/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/objects","fs","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/process","vs/base/common/map","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","util","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],p=0,k=K.length;p<k;p++)e[p]=Z[K[p]];return e};define(Z[84],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=p}),define(Z[62],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function k(m){const y=[];for(let b in m)p.call(m,b)&&y.push(m[b]);return y}e.values=k;function A(m,y){for(let b in m)if(p.call(m,b)&&y({key:b,value:m[b]},function(){delete m[b]})===!1)return}e.forEach=A;function P(m,y){const b=Object.create(null);for(const u of m){const S=y(u);let E=b[S];E||(E=b[S]=[]),E.push(u)}return b}e.groupBy=P;function U(m,y){const b=new Map;for(const u of m){const S=y(u);let E=b.get(S);E||(E=[],b.set(S,E)),E.push(u)}return b}e.groupByNumber=U;function T(m){const y=Object.create(null);return m&&m.forEach((b,u)=>{y[u]=b}),y}e.fromMap=T;function g(m,y){const b=[],u=[];for(let S of m)y.has(S)||b.push(S);for(let S of y)m.has(S)||u.push(S);return{removed:b,added:u}}e.diffSets=g;function v(m,y){const b=[],u=[];for(let[S,E]of m)y.has(S)||b.push(E);for(let[S,E]of y)m.has(S)||u.push(E);return{removed:b,added:u}}e.diffMaps=v;class O{constructor(){this.map=new Map}add(y,b){let u=this.map.get(y);u||(u=new Set,this.map.set(y,u)),u.add(b)}delete(y,b){const u=this.map.get(y);!u||(u.delete(b),u.size===0&&this.map.delete(y))}forEach(y,b){const u=this.map.get(y);!u||u.forEach(b)}}e.SetMap=O}),define(Z[85],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(U){return(T,g,v)=>{let O=null,m=null;if(typeof v.value=="function"?(O="value",m=v.value):typeof v.get=="function"&&(O="get",m=v.get),!m)throw new Error("not supported");v[O]=U(m,g)}}e.createDecorator=p;function k(U,T,g){let v=null,O=null;if(typeof g.value=="function"?(v="value",O=g.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(v="get",O=g.get),!O)throw new Error("not supported");const m=`$memoize$${T}`;g[v]=function(...y){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,y)}),this[m]}}e.memoize=k;function A(U,T,g){return p((v,O)=>{const m=`$debounce$${O}`,y=`$debounce$result$${O}`;return function(...b){this[y]||(this[y]=g?g():void 0),clearTimeout(this[m]),T&&(this[y]=T(this[y],...b),b=[this[y]]),this[m]=setTimeout(()=>{v.apply(this,b),this[y]=g?g():void 0},U)}})}e.debounce=A;function P(U,T,g){return p((v,O)=>{const m=`$throttle$timer$${O}`,y=`$throttle$result$${O}`,b=`$throttle$lastRun$${O}`,u=`$throttle$pending$${O}`;return function(...S){if(this[y]||(this[y]=g?g():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),T&&(this[y]=T(this[y],...S)),!this[u]){const E=this[b]+U;E<=Date.now()?(this[b]=Date.now(),v.apply(this,[this[y]]),this[y]=g?g():void 0):(this[u]=!0,this[m]=setTimeout(()=>{this[u]=!1,this[b]=Date.now(),v.apply(this,[this[y]]),this[y]=g?g():void 0},E-Date.now()))}}})}e.throttle=P}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function k(r){e.errorHandler.setUnexpectedErrorHandler(r)}e.setUnexpectedErrorHandler=k;function A(r){g(r)||e.errorHandler.onUnexpectedError(r)}e.onUnexpectedError=A;function P(r){g(r)||e.errorHandler.onUnexpectedExternalError(r)}e.onUnexpectedExternalError=P;function U(r){if(r instanceof Error){let{name:t,message:i}=r;const n=r.stacktrace||r.stack;return{$isError:!0,name:t,message:i,stack:n}}return r}e.transformErrorForSerialization=U;const T="Canceled";function g(r){return r instanceof Error&&r.name===T&&r.message===T}e.isPromiseCanceledError=g;class v extends Error{constructor(){super(T);this.name=this.message}}e.CancellationError=v;function O(){const r=new Error(T);return r.name=r.message,r}e.canceled=O;function m(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}e.illegalArgument=m;function y(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}e.illegalState=y;function b(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function u(r){const t=new Error(`${r} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function S(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}e.getErrorMessage=S;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class C extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=C;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function f(r){const t=r;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function s(r,t=Object.create(null)){const i=new Error(r);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=s}),define(Z[18],ee([0,1,11]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(q,H=0){return q[q.length-(1+H)]}e.tail=k;function A(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=A;function P(q,H,z=(D,L)=>D===L){if(q===H)return!0;if(!q||!H||q.length!==H.length)return!1;for(let D=0,L=q.length;D<L;D++)if(!z(q[D],H[D]))return!1;return!0}e.equals=P;function U(q,H,z){let D=0,L=q.length-1;for(;D<=L;){const F=(D+L)/2|0,N=z(q[F],H);if(N<0)D=F+1;else if(N>0)L=F-1;else return F}return-(D+1)}e.binarySearch=U;function T(q,H){let z=0,D=q.length;if(D===0)return 0;for(;z<D;){const L=Math.floor((z+D)/2);H(q[L])?D=L:z=L+1}return z}e.findFirstInSorted=T;function g(q,H,z){if(q=q|0,q>=H.length)throw new TypeError("invalid index");let D=H[Math.floor(H.length*Math.random())],L=[],F=[],N=[];for(let x of H){const G=z(x,D);G<0?L.push(x):G>0?F.push(x):N.push(x)}return q<L.length?g(q,L,z):q<L.length+N.length?N[0]:g(q-(L.length+N.length),F,z)}e.quickSelect=g;function v(q,H){const z=[];let D;for(const L of q.slice(0).sort(H))!D||H(D[0],L)!==0?(D=[L],z.push(D)):D.push(L);return z}e.groupBy=v;function O(q,H,z){const D=[];function L(x,G,J){if(!(G===0&&J.length===0)){const Q=D[D.length-1];Q&&Q.start+Q.deleteCount===x?(Q.deleteCount+=G,Q.toInsert.push(...J)):D.push({start:x,deleteCount:G,toInsert:J})}}let F=0,N=0;for(;;){if(F===q.length){L(F,0,H.slice(N));break}if(N===H.length){L(F,q.length-F,[]);break}const x=q[F],G=H[N],J=z(x,G);J===0?(F+=1,N+=1):J<0?(L(F,1,[]),F+=1):J>0&&(L(F,0,[G]),N+=1)}return D}e.sortedDiff=O;function m(q,H,z){const D=O(q,H,z),L=[],F=[];for(const N of D)L.push(...q.slice(N.start,N.start+N.deleteCount)),F.push(...N.toInsert);return{removed:L,added:F}}e.delta=m;function y(q,H,z){if(z===0)return[];const D=q.slice(0,z).sort(H);return u(q,H,D,z,q.length),D}e.top=y;function b(q,H,z,D,L){return z===0?Promise.resolve([]):new Promise((F,N)=>{(async()=>{const x=q.length,G=q.slice(0,z).sort(H);for(let J=z,Q=Math.min(z+D,x);J<x;J=Q,Q=Math.min(Q+D,x)){if(J>z&&await new Promise(ne=>setTimeout(ne)),L&&L.isCancellationRequested)throw(0,p.canceled)();u(q,H,G,J,Q)}return G})().then(F,N)})}e.topAsync=b;function u(q,H,z,D,L){for(const F=z.length;D<L;D++){const N=q[D];if(H(N,z[F-1])<0){z.pop();const x=T(z,G=>H(N,G)<0);z.splice(x,0,N)}}}function S(q){return q.filter(H=>!!H)}e.coalesce=S;function E(q){let H=0;for(let z=0;z<q.length;z++)q[z]&&(q[H]=q[z],H+=1);q.length=H}e.coalesceInPlace=E;function C(q,H,z){q.splice(z,0,q.splice(H,1)[0])}e.move=C;function I(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=I;function f(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=f;function s(q,H){if(!H)return q.filter((D,L)=>q.indexOf(D)===L);const z=Object.create(null);return q.filter(D=>{const L=H(D);return z[L]?!1:(z[L]=!0,!0)})}e.distinct=s;function r(q){const H=new Set;return q.filter(z=>H.has(z)?!1:(H.add(z),!0))}e.distinctES6=r;function t(q){const H=Object.create(null);return z=>{const D=q(z);return H[D]?!1:(H[D]=!0,!0)}}e.uniqueFilter=t;function i(q,H){for(let z=q.length-1;z>=0;z--){const D=q[z];if(H(D))return z}return-1}e.lastIndex=i;function n(q,H){return q.length>0?q[0]:H}e.firstOrDefault=n;function o(q,H,z=(D,L)=>D===L){let D=0;for(let L=0,F=Math.min(q.length,H.length);L<F&&z(q[L],H[L]);L++)D++;return D}e.commonPrefixLength=o;function a(q){return[].concat(...q)}e.flatten=a;function c(q,H){let z=typeof H=="number"?q:0;typeof H=="number"?z=q:(z=0,H=q);const D=[];if(z<=H)for(let L=z;L<H;L++)D.push(L);else for(let L=z;L>H;L--)D.push(L);return D}e.range=c;function l(q,H,z){return q.reduce((D,L)=>(D[H(L)]=z?z(L):L,D),Object.create(null))}e.index=l;function d(q,H){return q.push(H),()=>w(q,H)}e.insert=d;function w(q,H){const z=q.indexOf(H);if(z>-1)return q.splice(z,1),H}e.remove=w;function h(q,H,z){const D=q.slice(0,H),L=q.slice(H);return D.concat(z,L)}e.arrayInsert=h;function R(q,H){let z;if(typeof H=="number"){let D=H;z=()=>{const L=Math.sin(D++)*179426549;return L-Math.floor(L)}}else z=Math.random;for(let D=q.length-1;D>0;D-=1){const L=Math.floor(z()*(D+1)),F=q[D];q[D]=q[L],q[L]=F}}e.shuffle=R;function _(q,H){const z=q.indexOf(H);z>-1&&(q.splice(z,1),q.unshift(H))}e.pushToStart=_;function j(q,H){const z=q.indexOf(H);z>-1&&(q.splice(z,1),q.push(H))}e.pushToEnd=j;function B(q,H){return Array.isArray(q)?q.map(H):H(q)}e.mapArrayOrNot=B;function M(q){return Array.isArray(q)?q:[q]}e.asArray=M;function $(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=$;function V(q,H){for(const z of q){const D=H(z);if(D!==void 0)return D}}e.mapFind=V}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(k){const A=this;let P=!1,U;return function(){return P||(P=!0,U=k.apply(A,arguments)),U}}e.once=p}),define(Z[53],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(k){function A(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}k.is=A;const P=Object.freeze([]);function U(){return P}k.empty=U;function*T(r){yield r}k.single=T;function g(r){return r||P}k.from=g;function v(r){return!r||r[Symbol.iterator]().next().done===!0}k.isEmpty=v;function O(r){return r[Symbol.iterator]().next().value}k.first=O;function m(r,t){for(const i of r)if(t(i))return!0;return!1}k.some=m;function y(r,t){for(const i of r)if(t(i))return i}k.find=y;function*b(r,t){for(const i of r)t(i)&&(yield i)}k.filter=b;function*u(r,t){for(const i of r)yield t(i)}k.map=u;function*S(...r){for(const t of r)for(const i of t)yield i}k.concat=S;function*E(r){for(const t of r)for(const i of t)yield i}k.concatNested=E;function C(r,t,i){let n=i;for(const o of r)n=t(n,o);return n}k.reduce=C;function*I(r,t,i=r.length){for(t<0&&(t+=r.length),i<0?i+=r.length:i>r.length&&(i=r.length);t<i;t++)yield r[t]}k.slice=I;function f(r,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,r];const n=r[Symbol.iterator]();for(let o=0;o<t;o++){const a=n.next();if(a.done)return[i,k.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return n}}]}k.consume=f;function s(r,t,i=(n,o)=>n===o){const n=r[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const a=n.next(),c=o.next();if(a.done!==c.done)return!1;if(a.done)return!0;if(!i(a.value,c.value))return!1}}k.equals=s})(p=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function U(t,i=!1){let n=0,o=t.length,a="",c=0,l=16,d=0;function w($){let V=0,q=0;for(;V<$;){const H=t.charCodeAt(n);if(H>=48&&H<=57)q=q*16+H-48;else if(H>=65&&H<=70)q=q*16+H-65+10;else if(H>=97&&H<=102)q=q*16+H-97+10;else break;n++,V++}return V<$&&(q=-1),q}function h($){n=$,a="",c=0,l=16,d=0}function R(){const $=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&v(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&v(t.charCodeAt(n)))for(n++;n<t.length&&v(t.charCodeAt(n));)n++;else return d=3,t.substring($,n);let V=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&v(t.charCodeAt(n))){for(n++;n<t.length&&v(t.charCodeAt(n));)n++;V=n}else d=3;return t.substring($,V)}function _(){let $="",V=n;for(;;){if(n>=o){$+=t.substring(V,n),d=2;break}const q=t.charCodeAt(n);if(q===34){$+=t.substring(V,n),n++;break}if(q===92){if($+=t.substring(V,n),n++,n>=o){d=2;break}switch(t.charCodeAt(n++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const z=w(4);z>=0?$+=String.fromCharCode(z):d=4;break;default:d=5}V=n;continue}if(q>=0&&q<=31)if(g(q)){$+=t.substring(V,n),d=2;break}else d=6;n++}return $}function j(){if(a="",d=0,c=n,n>=o)return c=o,l=17;let $=t.charCodeAt(n);if(T($)){do n++,a+=String.fromCharCode($),$=t.charCodeAt(n);while(T($));return l=15}if(g($))return n++,a+=String.fromCharCode($),$===13&&t.charCodeAt(n)===10&&(n++,a+=`
`),l=14;switch($){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,a=_(),l=10;case 47:const V=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<o&&!g(t.charCodeAt(n));)n++;return a=t.substring(V,n),l=12}if(t.charCodeAt(n+1)===42){n+=2;const q=o-1;let H=!1;for(;n<q;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,H=!0;break}n++}return H||(n++,d=1),a=t.substring(V,n),l=13}return a+=String.fromCharCode($),n++,l=16;case 45:if(a+=String.fromCharCode($),n++,n===o||!v(t.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=R(),l=11;default:for(;n<o&&B($);)n++,$=t.charCodeAt(n);if(c!==n){switch(a=t.substring(c,n),a){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return a+=String.fromCharCode($),n++,l=16}}function B($){if(T($)||g($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let $;do $=j();while($>=12&&$<=15);return $}return{setPosition:h,getPosition:()=>n,scan:i?M:j,getToken:()=>l,getTokenValue:()=>a,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>d}}e.createScanner=U;function T(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function m(t,i){const n=[],o=new Object;let a;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function d(w,h,R,_){c.value=w,c.offset=h,c.length=R,c.type=_,c.colonOffset=void 0,a=c}try{f(t,{onObjectBegin:(w,h)=>{if(i<=w)throw o;a=void 0,l=i>w,n.push("")},onObjectProperty:(w,h,R)=>{if(i<h||(d(w,h,R,"property"),n[n.length-1]=w,i<=h+R))throw o},onObjectEnd:(w,h)=>{if(i<=w)throw o;a=void 0,n.pop()},onArrayBegin:(w,h)=>{if(i<=w)throw o;a=void 0,n.push(0)},onArrayEnd:(w,h)=>{if(i<=w)throw o;a=void 0,n.pop()},onLiteralValue:(w,h,R)=>{if(i<h||(d(w,h,R,r(w)),i<=h+R))throw o},onSeparator:(w,h,R)=>{if(i<=h)throw o;if(w===":"&&a&&a.type==="property")a.colonOffset=h,l=!1,a=void 0;else if(w===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(l=!0,n[n.length-1]=""),a=void 0}}})}catch(w){if(w!==o)throw w}return{path:n,previousNode:a,isAtPropertyKey:l,matches:w=>{let h=0;for(let R=0;h<w.length&&R<n.length;R++)if(w[h]===n[R]||w[h]==="*")h++;else if(w[h]!=="**")return!1;return h===w.length}}}e.getLocation=m;function y(t,i=[],n=P.DEFAULT){let o=null,a=[];const c=[];function l(w){Array.isArray(a)?a.push(w):o!==null&&(a[o]=w)}return f(t,{onObjectBegin:()=>{const w={};l(w),c.push(a),a=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const w=[];l(w),c.push(a),a=w,o=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:l,onError:(w,h,R)=>{i.push({error:w,offset:h,length:R})}},n),a[0]}e.parse=y;function b(t,i=[],n=P.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function c(w){return o.children.push(w),w}f(t,{onObjectBegin:w=>{o=c({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,h,R)=>{o=c({type:"property",offset:h,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:h,length:R,parent:o})},onObjectEnd:(w,h)=>{o.length=w+h-o.offset,o=o.parent,a(w+h)},onArrayBegin:(w,h)=>{o=c({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,h)=>{o.length=w+h-o.offset,o=o.parent,a(w+h)},onLiteralValue:(w,h,R)=>{c({type:r(w),offset:h,length:R,parent:o,value:w}),a(h+R)},onSeparator:(w,h,R)=>{o.type==="property"&&(w===":"?o.colonOffset=h:w===","&&a(h))},onError:(w,h,R)=>{i.push({error:w,offset:h,length:R})}},n);const d=o.children[0];return d&&delete d.parent,d}e.parseTree=b;function u(t,i){if(!!t){let n=t;for(let o of i)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===o){n=c.children[1],a=!0;break}if(!a)return}else{const a=o;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}}e.findNodeAtLocation=u;function S(t){if(!t.parent||!t.parent.children)return[];const i=S(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;i.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&i.push(n)}return i}e.getNodePath=S;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const i=Object.create(null);for(let n of t.children){const o=n.children[1];o&&(i[n.children[0].value]=E(o))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function C(t,i,n=!1){return i>=t.offset&&i<t.offset+t.length||n&&i===t.offset+t.length}e.contains=C;function I(t,i,n=!1){if(C(t,i,n)){const o=t.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=i;a++){const c=I(o[a],i,n);if(c)return c}return t}}e.findNodeAtOffset=I;function f(t,i,n=P.DEFAULT){const o=U(t,!1);function a(G){return G?()=>G(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(G){return G?J=>G(J,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=a(i.onObjectBegin),d=c(i.onObjectProperty),w=a(i.onObjectEnd),h=a(i.onArrayBegin),R=a(i.onArrayEnd),_=c(i.onLiteralValue),j=c(i.onSeparator),B=a(i.onComment),M=c(i.onError),$=n&&n.disallowComments,V=n&&n.allowTrailingComma;function q(){for(;;){const G=o.scan();switch(o.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(G){case 12:case 13:$?H(10):B();break;case 16:H(1);break;case 15:case 14:break;default:return G}}}function H(G,J=[],Q=[]){if(M(G),J.length+Q.length>0){let ne=o.getToken();for(;ne!==17;){if(J.indexOf(ne)!==-1){q();break}else if(Q.indexOf(ne)!==-1)break;ne=q()}}}function z(G){const J=o.getTokenValue();return G?_(J):d(J),q(),!0}function D(){switch(o.getToken()){case 11:let G=0;try{G=JSON.parse(o.getTokenValue()),typeof G!="number"&&(H(2),G=0)}catch(J){H(2)}_(G);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return q(),!0}function L(){return o.getToken()!==10?(H(3,[],[2,5]),!1):(z(!1),o.getToken()===6?(j(":"),q(),x()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function F(){l(),q();let G=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(G||H(4,[],[]),j(","),q(),o.getToken()===2&&V)break}else G&&H(6,[],[]);L()||H(4,[],[2,5]),G=!0}return w(),o.getToken()!==2?H(7,[2],[]):q(),!0}function N(){h(),q();let G=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(G||H(4,[],[]),j(","),q(),o.getToken()===4&&V)break}else G&&H(6,[],[]);x()||H(4,[],[4,5]),G=!0}return R(),o.getToken()!==4?H(8,[4],[]):q(),!0}function x(){switch(o.getToken()){case 3:return N();case 1:return F();case 10:return z(!0);default:return D()}}return q(),o.getToken()===17?n.allowEmptyContent?!0:(H(4,[],[]),!1):x()?(o.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=f;function s(t,i){let n=U(t),o=[],a,c=0,l;do switch(l=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:c!==l&&o.push(t.substring(c,l)),i!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,i)),c=n.getPosition();break}while(a!==17);return o.join("")}e.stripComments=s;function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=r}),define(Z[46],ee([0,1,32]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(g,v,O){let m,y,b,u,S;if(v){for(u=v.offset,S=u+v.length,b=u;b>0&&!T(g,b-1);)b--;let c=S;for(;c<g.length&&!T(g,c);)c++;y=g.substring(b,c),m=P(y,O)}else y=g,m=0,b=0,u=0,S=g.length;const E=U(O,g);let C=!1,I=0,f;O.insertSpaces?f=A(" ",O.tabSize||4):f="	";const s=(0,p.createScanner)(y,!1);let r=!1;function t(){return E+A(f,m+I)}function i(){let c=s.scan();for(C=!1;c===15||c===14;)C=C||c===14,c=s.scan();return r=c===16||s.getTokenError()!==0,c}const n=[];function o(c,l,d){!r&&l<S&&d>u&&g.substring(l,d)!==c&&n.push({offset:l,length:d-l,content:c})}let a=i();if(a!==17){const c=s.getTokenOffset()+b,l=A(f,m);o(l,b,c)}for(;a!==17;){let c=s.getTokenOffset()+s.getTokenLength()+b,l=i(),d="";for(;!C&&(l===12||l===13);){const h=s.getTokenOffset()+b;o(" ",c,h),c=s.getTokenOffset()+s.getTokenLength()+b,d=l===12?t():"",l=i()}if(l===2)a!==1&&(I--,d=t());else if(l===4)a!==3&&(I--,d=t());else{switch(a){case 3:case 1:I++,d=t();break;case 5:case 12:d=t();break;case 13:C?d=t():d=" ";break;case 6:d=" ";break;case 10:if(l===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?d=" ":l!==5&&l!==17&&(r=!0);break;case 16:r=!0;break}C&&(l===12||l===13)&&(d=t())}const w=s.getTokenOffset()+b;o(d,c,w),a=l}return n}e.format=k;function A(g,v){let O="";for(let m=0;m<v;m++)O+=g;return O}function P(g,v){let O=0,m=0;const y=v.tabSize||4;for(;O<g.length;){const b=g.charAt(O);if(b===" ")m++;else if(b==="	")m+=y;else break;O++}return Math.floor(m/y)}function U(g,v){for(let O=0;O<v.length;O++){const m=v.charAt(O);if(m==="\r")return O+1<v.length&&v.charAt(O+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=U;function T(g,v){return`\r
`.indexOf(g.charAt(v))!==-1}e.isEOL=T}),define(Z[41],ee([0,1,32,46]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(v,O,m){return P(v,O,void 0,m)}e.removeProperty=A;function P(v,O,m,y,b){const u=O.slice(),S=[],E=(0,p.parseTree)(v,S);let C,I;for(;u.length>0&&(I=u.pop(),C=(0,p.findNodeAtLocation)(E,u),C===void 0&&m!==void 0);)typeof I=="string"?m={[I]:m}:m=[m];if(C)if(C.type==="object"&&typeof I=="string"&&Array.isArray(C.children)){const f=(0,p.findNodeAtLocation)(C,[I]);if(f!==void 0)if(m===void 0){if(!f.parent)throw new Error("Malformed AST");const s=C.children.indexOf(f.parent);let r,t=f.parent.offset+f.parent.length;if(s>0){const i=C.children[s-1];r=i.offset+i.length}else r=C.offset+1,C.children.length>1&&(t=C.children[1].offset);return U(v,{offset:r,length:t-r,content:""},y)}else return U(v,{offset:f.offset,length:f.length,content:JSON.stringify(m)},y);else{if(m===void 0)return[];const s=`${JSON.stringify(I)}: ${JSON.stringify(m)}`,r=b?b(C.children.map(i=>i.children[0].value)):C.children.length;let t;if(r>0){const i=C.children[r-1];t={offset:i.offset+i.length,length:0,content:","+s}}else C.children.length===0?t={offset:C.offset+1,length:0,content:s}:t={offset:C.offset+1,length:0,content:s+","};return U(v,t,y)}}else if(C.type==="array"&&typeof I=="number"&&Array.isArray(C.children))if(m!==void 0){const f=`${JSON.stringify(m)}`;let s;if(C.children.length===0||I===0)s={offset:C.offset+1,length:0,content:C.children.length===0?f:f+","};else{const r=I===-1||I>C.children.length?C.children.length:I,t=C.children[r-1];s={offset:t.offset+t.length,length:0,content:","+f}}return U(v,s,y)}else{const f=I,s=C.children[f];let r;if(C.children.length===1)r={offset:C.offset+1,length:C.length-2,content:""};else if(C.children.length-1===f){const t=C.children[f-1],i=t.offset+t.length,n=C.offset+C.length;r={offset:i,length:n-2-i,content:""}}else r={offset:s.offset,length:C.children[f+1].offset-s.offset,content:""};return U(v,r,y)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${C.type}`);else{if(m===void 0)throw new Error("Can not delete in empty document");return U(v,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(m)},y)}}e.setProperty=P;function U(v,O,m){let y=T(v,O),b=O.offset,u=O.offset+O.content.length;if(O.length===0||O.content.length===0){for(;b>0&&!(0,k.isEOL)(y,b-1);)b--;for(;u<y.length&&!(0,k.isEOL)(y,u);)u++}const S=(0,k.format)(y,{offset:b,length:u-b},m);for(let C=S.length-1;C>=0;C--){const I=S[C];y=T(y,I),b=Math.min(b,I.offset),u=Math.max(u,I.offset+I.length),u+=I.content.length-I.length}const E=v.length-(y.length-u)-b;return[{offset:b,length:E,content:y.substring(b,u)}]}e.withFormatting=U;function T(v,O){return v.substring(0,O.offset)+O.content+v.substring(O.offset+O.length)}e.applyEdit=T;function g(v,O){let m=O.slice(0).sort((b,u)=>{const S=b.offset-u.offset;return S===0?b.length-u.length:S}),y=v.length;for(let b=m.length-1;b>=0;b--){let u=m[b];if(u.offset+u.length<=y)v=T(v,u);else throw new Error("Overlapping edit");y=u.offset}return v}e.applyEdits=g}),define(Z[2],ee([0,1,63,53]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let P=null;function U(f){P=f}if(e.setDisposableTracker=U,A){const f="__is_disposable_tracked__";P=new class{trackDisposable(s){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[f]||console.log(r)},3e3)}markTracked(s){if(s&&s!==S.None)try{s[f]=!0}catch(r){}}}}function T(f){!P||P.markTracked(f)}function g(f){return P&&P.trackDisposable(f),f}e.trackDisposable=g;class v extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=v;function O(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=O;function m(f){if(k.Iterable.is(f)){let s=[];for(const r of f)if(r){T(r);try{r.dispose()}catch(t){s.push(t)}}if(s.length===1)throw s[0];if(s.length>1)throw new v(s);return Array.isArray(f)?[]:f}else if(f)return T(f),f.dispose(),f}e.dispose=m;function y(...f){return f.forEach(T),b(()=>m(f))}e.combinedDisposable=y;function b(f){const s=g({dispose:()=>{T(s),f()}});return s}e.toDisposable=b;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(T(this),this._isDisposed=!0,this.clear())}clear(){try{m(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return T(s),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new u,g(this)}dispose(){T(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,g(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var r;this._isDisposed||s===this._value||((r=this._value)===null||r===void 0||r.dispose(),s&&T(s),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,T(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}e.MutableDisposable=E;class C{constructor(){this.references=new Map}acquire(s,...r){let t=this.references.get(s);t||(t={counter:0,object:this.createReferencedObject(s,...r)},this.references.set(s,t));const{object:i}=t,n=(0,p.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(s,t.object),this.references.delete(s))});return t.counter++,{object:i,dispose:n}}}e.ReferenceCollection=C;class I{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=I}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(P){this.element=P,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class k{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let P=this._first;for(;P!==p.Undefined;){const U=P.next;P.prev=p.Undefined,P.next=p.Undefined,P=U}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,U){const T=new p(P);if(this._first===p.Undefined)this._first=T,this._last=T;else if(U){const v=this._last;this._last=T,T.prev=v,v.next=T}else{const v=this._first;this._first=T,T.next=v,v.prev=T}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(T))}}shift(){if(this._first!==p.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==p.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==p.Undefined&&P.next!==p.Undefined){const U=P.prev;U.next=P.next,P.next.prev=U}else P.prev===p.Undefined&&P.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):P.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):P.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==p.Undefined;)yield P.element,P=P.next}}e.LinkedList=k});"use strict";(function(){function K(A){const P=[];typeof A=="number"&&P.push("code/timeOrigin",A);function U(g){P.push(g,Date.now())}function T(){const g=[];for(let v=0;v<P.length;v+=2)g.push({name:P[v],startTime:P[v+1]});return g}return{mark:U,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const U of performance.getEntriesByType("mark"))P.push({name:U.name,startTime:Math.round(A+U.startTime)});return P}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function p(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=p(k))})(),define(Z[7],ee([0,1]),function(K,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,P=!1,U=!1,T=!1,g=!1,v=!1,O=!1,m,y=k,b,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof e.globals.vscode!="undefined"?S=e.globals.vscode.process:typeof process!="undefined"&&(S=process);const E=typeof((p=S==null?void 0:S.versions)===null||p===void 0?void 0:p.electron)=="string"&&S.type==="renderer";if(e.isElectronSandboxed=E&&(S==null?void 0:S.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=S==null?void 0:S.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)u=navigator.userAgent,A=u.indexOf("Windows")>=0,P=u.indexOf("Macintosh")>=0,O=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=u.indexOf("Linux")>=0,v=!0,m=navigator.language,y=m;else if(typeof S=="object"){A=S.platform==="win32",P=S.platform==="darwin",U=S.platform==="linux",T=U&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,m=k,y=k;const o=S.env.VSCODE_NLS_CONFIG;if(o)try{const a=JSON.parse(o),c=a.availableLanguages["*"];m=a.locale,y=c||k,b=a._translationsConfigFile}catch(a){}g=!0}else console.error("Unable to resolve platform.");var C;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(C=e.Platform||(e.Platform={}));function I(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let f=0;P?f=1:A?f=3:U&&(f=2),e.isWindows=A,e.isMacintosh=P,e.isLinux=U,e.isLinuxSnap=T,e.isNative=g,e.isWeb=v,e.isIOS=O,e.platform=f,e.userAgent=u,e.language=y;var s;(function(o){function a(){return e.language}o.value=a;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=c;function l(){return e.language==="en"}o.isDefault=l})(s=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let w=0,h=c.length;w<h;w++){const R=c[w];if(R.id===d.data.vscodeSetImmediateId){c.splice(w,1),R.callback();return}}});let l=0;return d=>{const w=++l;c.push({id:w,callback:d}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof(S==null?void 0:S.nextTick)=="function")return S.nextTick.bind(S);const a=Promise.resolve();return c=>a.then(c)}();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||O?2:A?1:3;let t=!0,i=!1;function n(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=n}),define(Z[36],ee([0,1,7]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof p.globals.vscode!="undefined"){const A=p.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(P){return(0,p.setImmediate)(P)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(A){return(0,p.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(Z[8],ee([0,1,36]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,P=90,U=122,T=46,g=47,v=92,O=58,m=63;class y extends Error{constructor(s,r,t){let i;typeof r=="string"&&r.indexOf("not ")===0?(i="must not be",r=r.replace(/^not /,"")):i="must be";const n=s.indexOf(".")!==-1?"property":"argument";let o=`The "${s}" ${n} ${i} of type ${r}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function b(f,s){if(typeof f!="string")throw new y(s,"string",f)}function u(f){return f===g||f===v}function S(f){return f===g}function E(f){return f>=k&&f<=P||f>=A&&f<=U}function C(f,s,r,t){let i="",n=0,o=-1,a=0,c=0;for(let l=0;l<=f.length;++l){if(l<f.length)c=f.charCodeAt(l);else{if(t(c))break;c=g}if(t(c)){if(!(o===l-1||a===1))if(a===2){if(i.length<2||n!==2||i.charCodeAt(i.length-1)!==T||i.charCodeAt(i.length-2)!==T){if(i.length>2){const d=i.lastIndexOf(r);d===-1?(i="",n=0):(i=i.slice(0,d),n=i.length-1-i.lastIndexOf(r)),o=l,a=0;continue}else if(i.length!==0){i="",n=0,o=l,a=0;continue}}s&&(i+=i.length>0?`${r}..`:"..",n=2)}else i.length>0?i+=`${r}${f.slice(o+1,l)}`:i=f.slice(o+1,l),n=l-o-1;o=l,a=0}else c===T&&a!==-1?++a:a=-1}return i}function I(f,s){if(s===null||typeof s!="object")throw new y("pathObject","Object",s);const r=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${t}`:`${r}${f}${t}`:t}e.win32={resolve(...f){let s="",r="",t=!1;for(let i=f.length-1;i>=-1;i--){let n;if(i>=0){if(n=f[i],b(n,"path"),n.length===0)continue}else s.length===0?n=p.cwd():(n=p.env[`=${s}`]||p.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==s.toLowerCase()&&n.charCodeAt(2)===v)&&(n=`${s}\\`));const o=n.length;let a=0,c="",l=!1;const d=n.charCodeAt(0);if(o===1)u(d)&&(a=1,l=!0);else if(u(d))if(l=!0,u(n.charCodeAt(1))){let w=2,h=w;for(;w<o&&!u(n.charCodeAt(w));)w++;if(w<o&&w!==h){const R=n.slice(h,w);for(h=w;w<o&&u(n.charCodeAt(w));)w++;if(w<o&&w!==h){for(h=w;w<o&&!u(n.charCodeAt(w));)w++;(w===o||w!==h)&&(c=`\\\\${R}\\${n.slice(h,w)}`,a=w)}}}else a=1;else E(d)&&n.charCodeAt(1)===O&&(c=n.slice(0,2),a=2,o>2&&u(n.charCodeAt(2))&&(l=!0,a=3));if(c.length>0)if(s.length>0){if(c.toLowerCase()!==s.toLowerCase())continue}else s=c;if(t){if(s.length>0)break}else if(r=`${n.slice(a)}\\${r}`,t=l,l&&s.length>0)break}return r=C(r,!t,"\\",u),t?`${s}\\${r}`:`${s}${r}`||"."},normalize(f){b(f,"path");const s=f.length;if(s===0)return".";let r=0,t,i=!1;const n=f.charCodeAt(0);if(s===1)return S(n)?"\\":f;if(u(n))if(i=!0,u(f.charCodeAt(1))){let a=2,c=a;for(;a<s&&!u(f.charCodeAt(a));)a++;if(a<s&&a!==c){const l=f.slice(c,a);for(c=a;a<s&&u(f.charCodeAt(a));)a++;if(a<s&&a!==c){for(c=a;a<s&&!u(f.charCodeAt(a));)a++;if(a===s)return`\\\\${l}\\${f.slice(c)}\\`;a!==c&&(t=`\\\\${l}\\${f.slice(c,a)}`,r=a)}}}else r=1;else E(n)&&f.charCodeAt(1)===O&&(t=f.slice(0,2),r=2,s>2&&u(f.charCodeAt(2))&&(i=!0,r=3));let o=r<s?C(f.slice(r),!i,"\\",u):"";return o.length===0&&!i&&(o="."),o.length>0&&u(f.charCodeAt(s-1))&&(o+="\\"),t===void 0?i?`\\${o}`:o:i?`${t}\\${o}`:`${t}${o}`},isAbsolute(f){b(f,"path");const s=f.length;if(s===0)return!1;const r=f.charCodeAt(0);return u(r)||s>2&&E(r)&&f.charCodeAt(1)===O&&u(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let s,r;for(let n=0;n<f.length;++n){const o=f[n];b(o,"path"),o.length>0&&(s===void 0?s=r=o:s+=`\\${o}`)}if(s===void 0)return".";let t=!0,i=0;if(typeof r=="string"&&u(r.charCodeAt(0))){++i;const n=r.length;n>1&&u(r.charCodeAt(1))&&(++i,n>2&&(u(r.charCodeAt(2))?++i:t=!1))}if(t){for(;i<s.length&&u(s.charCodeAt(i));)i++;i>=2&&(s=`\\${s.slice(i)}`)}return e.win32.normalize(s)},relative(f,s){if(b(f,"from"),b(s,"to"),f===s)return"";const r=e.win32.resolve(f),t=e.win32.resolve(s);if(r===t||(f=r.toLowerCase(),s=t.toLowerCase(),f===s))return"";let i=0;for(;i<f.length&&f.charCodeAt(i)===v;)i++;let n=f.length;for(;n-1>i&&f.charCodeAt(n-1)===v;)n--;const o=n-i;let a=0;for(;a<s.length&&s.charCodeAt(a)===v;)a++;let c=s.length;for(;c-1>a&&s.charCodeAt(c-1)===v;)c--;const l=c-a,d=o<l?o:l;let w=-1,h=0;for(;h<d;h++){const _=f.charCodeAt(i+h);if(_!==s.charCodeAt(a+h))break;_===v&&(w=h)}if(h!==d){if(w===-1)return t}else{if(l>d){if(s.charCodeAt(a+h)===v)return t.slice(a+h+1);if(h===2)return t.slice(a+h)}o>d&&(f.charCodeAt(i+h)===v?w=h:h===2&&(w=3)),w===-1&&(w=0)}let R="";for(h=i+w+1;h<=n;++h)(h===n||f.charCodeAt(h)===v)&&(R+=R.length===0?"..":"\\..");return a+=w,R.length>0?`${R}${t.slice(a,c)}`:(t.charCodeAt(a)===v&&++a,t.slice(a,c))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const s=e.win32.resolve(f);if(s.length<=2)return f;if(s.charCodeAt(0)===v){if(s.charCodeAt(1)===v){const r=s.charCodeAt(2);if(r!==m&&r!==T)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(E(s.charCodeAt(0))&&s.charCodeAt(1)===O&&s.charCodeAt(2)===v)return`\\\\?\\${s}`;return f},dirname(f){b(f,"path");const s=f.length;if(s===0)return".";let r=-1,t=0;const i=f.charCodeAt(0);if(s===1)return u(i)?f:".";if(u(i)){if(r=t=1,u(f.charCodeAt(1))){let a=2,c=a;for(;a<s&&!u(f.charCodeAt(a));)a++;if(a<s&&a!==c){for(c=a;a<s&&u(f.charCodeAt(a));)a++;if(a<s&&a!==c){for(c=a;a<s&&!u(f.charCodeAt(a));)a++;if(a===s)return f;a!==c&&(r=t=a+1)}}}}else E(i)&&f.charCodeAt(1)===O&&(r=s>2&&u(f.charCodeAt(2))?3:2,t=r);let n=-1,o=!0;for(let a=s-1;a>=t;--a)if(u(f.charCodeAt(a))){if(!o){n=a;break}}else o=!1;if(n===-1){if(r===-1)return".";n=r}return f.slice(0,n)},basename(f,s){s!==void 0&&b(s,"ext"),b(f,"path");let r=0,t=-1,i=!0,n;if(f.length>=2&&E(f.charCodeAt(0))&&f.charCodeAt(1)===O&&(r=2),s!==void 0&&s.length>0&&s.length<=f.length){if(s===f)return"";let o=s.length-1,a=-1;for(n=f.length-1;n>=r;--n){const c=f.charCodeAt(n);if(u(c)){if(!i){r=n+1;break}}else a===-1&&(i=!1,a=n+1),o>=0&&(c===s.charCodeAt(o)?--o==-1&&(t=n):(o=-1,t=a))}return r===t?t=a:t===-1&&(t=f.length),f.slice(r,t)}for(n=f.length-1;n>=r;--n)if(u(f.charCodeAt(n))){if(!i){r=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":f.slice(r,t)},extname(f){b(f,"path");let s=0,r=-1,t=0,i=-1,n=!0,o=0;f.length>=2&&f.charCodeAt(1)===O&&E(f.charCodeAt(0))&&(s=t=2);for(let a=f.length-1;a>=s;--a){const c=f.charCodeAt(a);if(u(c)){if(!n){t=a+1;break}continue}i===-1&&(n=!1,i=a+1),c===T?r===-1?r=a:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||i===-1||o===0||o===1&&r===i-1&&r===t+1?"":f.slice(r,i)},format:I.bind(null,"\\"),parse(f){b(f,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return s;const r=f.length;let t=0,i=f.charCodeAt(0);if(r===1)return u(i)?(s.root=s.dir=f,s):(s.base=s.name=f,s);if(u(i)){if(t=1,u(f.charCodeAt(1))){let w=2,h=w;for(;w<r&&!u(f.charCodeAt(w));)w++;if(w<r&&w!==h){for(h=w;w<r&&u(f.charCodeAt(w));)w++;if(w<r&&w!==h){for(h=w;w<r&&!u(f.charCodeAt(w));)w++;w===r?t=w:w!==h&&(t=w+1)}}}}else if(E(i)&&f.charCodeAt(1)===O){if(r<=2)return s.root=s.dir=f,s;if(t=2,u(f.charCodeAt(2))){if(r===3)return s.root=s.dir=f,s;t=3}}t>0&&(s.root=f.slice(0,t));let n=-1,o=t,a=-1,c=!0,l=f.length-1,d=0;for(;l>=t;--l){if(i=f.charCodeAt(l),u(i)){if(!c){o=l+1;break}continue}a===-1&&(c=!1,a=l+1),i===T?n===-1?n=l:d!==1&&(d=1):n!==-1&&(d=-1)}return a!==-1&&(n===-1||d===0||d===1&&n===a-1&&n===o+1?s.base=s.name=f.slice(o,a):(s.name=f.slice(o,n),s.base=f.slice(o,a),s.ext=f.slice(n,a))),o>0&&o!==t?s.dir=f.slice(0,o-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let s="",r=!1;for(let t=f.length-1;t>=-1&&!r;t--){const i=t>=0?f[t]:p.cwd();b(i,"path"),i.length!==0&&(s=`${i}/${s}`,r=i.charCodeAt(0)===g)}return s=C(s,!r,"/",S),r?`/${s}`:s.length>0?s:"."},normalize(f){if(b(f,"path"),f.length===0)return".";const s=f.charCodeAt(0)===g,r=f.charCodeAt(f.length-1)===g;return f=C(f,!s,"/",S),f.length===0?s?"/":r?"./":".":(r&&(f+="/"),s?`/${f}`:f)},isAbsolute(f){return b(f,"path"),f.length>0&&f.charCodeAt(0)===g},join(...f){if(f.length===0)return".";let s;for(let r=0;r<f.length;++r){const t=f[r];b(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(f,s){if(b(f,"from"),b(s,"to"),f===s||(f=e.posix.resolve(f),s=e.posix.resolve(s),f===s))return"";const r=1,t=f.length,i=t-r,n=1,o=s.length-n,a=i<o?i:o;let c=-1,l=0;for(;l<a;l++){const w=f.charCodeAt(r+l);if(w!==s.charCodeAt(n+l))break;w===g&&(c=l)}if(l===a)if(o>a){if(s.charCodeAt(n+l)===g)return s.slice(n+l+1);if(l===0)return s.slice(n+l)}else i>a&&(f.charCodeAt(r+l)===g?c=l:l===0&&(c=0));let d="";for(l=r+c+1;l<=t;++l)(l===t||f.charCodeAt(l)===g)&&(d+=d.length===0?"..":"/..");return`${d}${s.slice(n+c)}`},toNamespacedPath(f){return f},dirname(f){if(b(f,"path"),f.length===0)return".";const s=f.charCodeAt(0)===g;let r=-1,t=!0;for(let i=f.length-1;i>=1;--i)if(f.charCodeAt(i)===g){if(!t){r=i;break}}else t=!1;return r===-1?s?"/":".":s&&r===1?"//":f.slice(0,r)},basename(f,s){s!==void 0&&b(s,"ext"),b(f,"path");let r=0,t=-1,i=!0,n;if(s!==void 0&&s.length>0&&s.length<=f.length){if(s===f)return"";let o=s.length-1,a=-1;for(n=f.length-1;n>=0;--n){const c=f.charCodeAt(n);if(c===g){if(!i){r=n+1;break}}else a===-1&&(i=!1,a=n+1),o>=0&&(c===s.charCodeAt(o)?--o==-1&&(t=n):(o=-1,t=a))}return r===t?t=a:t===-1&&(t=f.length),f.slice(r,t)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===g){if(!i){r=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":f.slice(r,t)},extname(f){b(f,"path");let s=-1,r=0,t=-1,i=!0,n=0;for(let o=f.length-1;o>=0;--o){const a=f.charCodeAt(o);if(a===g){if(!i){r=o+1;break}continue}t===-1&&(i=!1,t=o+1),a===T?s===-1?s=o:n!==1&&(n=1):s!==-1&&(n=-1)}return s===-1||t===-1||n===0||n===1&&s===t-1&&s===r+1?"":f.slice(s,t)},format:I.bind(null,"/"),parse(f){b(f,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return s;const r=f.charCodeAt(0)===g;let t;r?(s.root="/",t=1):t=0;let i=-1,n=0,o=-1,a=!0,c=f.length-1,l=0;for(;c>=t;--c){const d=f.charCodeAt(c);if(d===g){if(!a){n=c+1;break}continue}o===-1&&(a=!1,o=c+1),d===T?i===-1?i=c:l!==1&&(l=1):i!==-1&&(l=-1)}if(o!==-1){const d=n===0&&r?1:n;i===-1||l===0||l===1&&i===o-1&&i===n+1?s.base=s.name=f.slice(d,o):(s.name=f.slice(d,i),s.base=f.slice(d,o),s.ext=f.slice(i,o))}return n>0?s.dir=f.slice(0,n-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var p=e();for(var k in p)(typeof exports=="object"?exports:K)[k]=p[k]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function p(k){if(e[k])return e[k].exports;var A=e[k]={i:k,l:!1,exports:{}};return K[k].call(A.exports,A,A.exports,p),A.l=!0,A.exports}return p.m=K,p.c=e,p.d=function(k,A,P){p.o(k,A)||Object.defineProperty(k,A,{enumerable:!0,get:P})},p.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},p.t=function(k,A){if(1&A&&(k=p(k)),8&A||4&A&&typeof k=="object"&&k&&k.__esModule)return k;var P=Object.create(null);if(p.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:k}),2&A&&typeof k!="string")for(var U in k)p.d(P,U,function(T){return k[T]}.bind(null,U));return P},p.n=function(k){var A=k&&k.__esModule?function(){return k.default}:function(){return k};return p.d(A,"a",A),A},p.o=function(k,A){return Object.prototype.hasOwnProperty.call(k,A)},p.p="",p(p.s=0)}([function(K,e,p){(function(k){var A;e=K.exports=Q,A=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,U=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],g=e.src=[],v=0,O=v++;g[O]="0|[1-9]\\d*";var m=v++;g[m]="[0-9]+";var y=v++;g[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=v++;g[b]="("+g[O]+")\\.("+g[O]+")\\.("+g[O]+")";var u=v++;g[u]="("+g[m]+")\\.("+g[m]+")\\.("+g[m]+")";var S=v++;g[S]="(?:"+g[O]+"|"+g[y]+")";var E=v++;g[E]="(?:"+g[m]+"|"+g[y]+")";var C=v++;g[C]="(?:-("+g[S]+"(?:\\."+g[S]+")*))";var I=v++;g[I]="(?:-?("+g[E]+"(?:\\."+g[E]+")*))";var f=v++;g[f]="[0-9A-Za-z-]+";var s=v++;g[s]="(?:\\+("+g[f]+"(?:\\."+g[f]+")*))";var r=v++,t="v?"+g[b]+g[C]+"?"+g[s]+"?";g[r]="^"+t+"$";var i="[v=\\s]*"+g[u]+g[I]+"?"+g[s]+"?",n=v++;g[n]="^"+i+"$";var o=v++;g[o]="((?:<|>)?=?)";var a=v++;g[a]=g[m]+"|x|X|\\*";var c=v++;g[c]=g[O]+"|x|X|\\*";var l=v++;g[l]="[v=\\s]*("+g[c]+")(?:\\.("+g[c]+")(?:\\.("+g[c]+")(?:"+g[C]+")?"+g[s]+"?)?)?";var d=v++;g[d]="[v=\\s]*("+g[a]+")(?:\\.("+g[a]+")(?:\\.("+g[a]+")(?:"+g[I]+")?"+g[s]+"?)?)?";var w=v++;g[w]="^"+g[o]+"\\s*"+g[l]+"$";var h=v++;g[h]="^"+g[o]+"\\s*"+g[d]+"$";var R=v++;g[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=v++;g[_]="(?:~>?)";var j=v++;g[j]="(\\s*)"+g[_]+"\\s+",T[j]=new RegExp(g[j],"g");var B=v++;g[B]="^"+g[_]+g[l]+"$";var M=v++;g[M]="^"+g[_]+g[d]+"$";var $=v++;g[$]="(?:\\^)";var V=v++;g[V]="(\\s*)"+g[$]+"\\s+",T[V]=new RegExp(g[V],"g");var q=v++;g[q]="^"+g[$]+g[l]+"$";var H=v++;g[H]="^"+g[$]+g[d]+"$";var z=v++;g[z]="^"+g[o]+"\\s*("+i+")$|^$";var D=v++;g[D]="^"+g[o]+"\\s*("+t+")$|^$";var L=v++;g[L]="(\\s*)"+g[o]+"\\s*("+i+"|"+g[l]+")",T[L]=new RegExp(g[L],"g");var F=v++;g[F]="^\\s*("+g[l]+")\\s+-\\s+("+g[l]+")\\s*$";var N=v++;g[N]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var x=v++;g[x]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)A(G,g[G]),T[G]||(T[G]=new RegExp(g[G]));function J(X,re){if(X instanceof Q)return X;if(typeof X!="string"||X.length>P||!(re?T[n]:T[r]).test(X))return null;try{return new Q(X,re)}catch(se){return null}}function Q(X,re){if(X instanceof Q){if(X.loose===re)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Q))return new Q(X,re);A("SemVer",X,re),this.loose=re;var se=X.trim().match(re?T[n]:T[r]);if(!se)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>U||this.major<0)throw new TypeError("Invalid major version");if(this.minor>U||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>U||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var W=+me;if(W>=0&&W<U)return W}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=J,e.valid=function(X,re){var se=J(X,re);return se?se.version:null},e.clean=function(X,re){var se=J(X.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(X){return A("SemVer.compare",this.version,this.loose,X),X instanceof Q||(X=new Q(X,this.loose)),this.compareMain(X)||this.comparePre(X)},Q.prototype.compareMain=function(X){return X instanceof Q||(X=new Q(X,this.loose)),ie(this.major,X.major)||ie(this.minor,X.minor)||ie(this.patch,X.patch)},Q.prototype.comparePre=function(X){if(X instanceof Q||(X=new Q(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=X.prerelease[re];if(A("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ie(se,me)}while(++re)},Q.prototype.inc=function(X,re){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new Q(X,se).inc(re,me).version}catch(W){return null}},e.diff=function(X,re){if(Ee(X,re))return null;var se=J(X),me=J(re);if(se.prerelease.length||me.prerelease.length){for(var W in se)if((W==="major"||W==="minor"||W==="patch")&&se[W]!==me[W])return"pre"+W;return"prerelease"}for(var W in se)if((W==="major"||W==="minor"||W==="patch")&&se[W]!==me[W])return W},e.compareIdentifiers=ie;var ne=/^[0-9]+$/;function ie(X,re){var se=ne.test(X),me=ne.test(re);return se&&me&&(X=+X,re=+re),se&&!me?-1:me&&!se?1:X<re?-1:X>re?1:0}function ce(X,re,se){return new Q(X,se).compare(new Q(re,se))}function ue(X,re,se){return ce(X,re,se)>0}function ge(X,re,se){return ce(X,re,se)<0}function Ee(X,re,se){return ce(X,re,se)===0}function Ie(X,re,se){return ce(X,re,se)!==0}function Te(X,re,se){return ce(X,re,se)>=0}function Ae(X,re,se){return ce(X,re,se)<=0}function Ue(X,re,se,me){var W;switch(re){case"===":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),W=X===se;break;case"!==":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),W=X!==se;break;case"":case"=":case"==":W=Ee(X,se,me);break;case"!=":W=Ie(X,se,me);break;case">":W=ue(X,se,me);break;case">=":W=Te(X,se,me);break;case"<":W=ge(X,se,me);break;case"<=":W=Ae(X,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return W}function ke(X,re){if(X instanceof ke){if(X.loose===re)return X;X=X.value}if(!(this instanceof ke))return new ke(X,re);A("comparator",X,re),this.loose=re,this.parse(X),this.semver===Ne?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(X,re){return ie(re,X)},e.major=function(X,re){return new Q(X,re).major},e.minor=function(X,re){return new Q(X,re).minor},e.patch=function(X,re){return new Q(X,re).patch},e.compare=ce,e.compareLoose=function(X,re){return ce(X,re,!0)},e.rcompare=function(X,re,se){return ce(re,X,se)},e.sort=function(X,re){return X.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(X,re){return X.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=ue,e.lt=ge,e.eq=Ee,e.neq=Ie,e.gte=Te,e.lte=Ae,e.cmp=Ue,e.Comparator=ke;var Ne={};function De(X,re){if(X instanceof De)return X.loose===re?X:new De(X.raw,re);if(X instanceof ke)return new De(X.value,re);if(!(this instanceof De))return new De(X,re);if(this.loose=re,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Oe(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ge(X,re,se,me,W,te,oe,ae,le,fe,ve,Se,we){return((re=Oe(se)?"":Oe(me)?">="+se+".0.0":Oe(W)?">="+se+"."+me+".0":">="+re)+" "+(ae=Oe(le)?"":Oe(fe)?"<"+(+le+1)+".0.0":Oe(ve)?"<"+le+"."+(+fe+1)+".0":Se?"<="+le+"."+fe+"."+ve+"-"+Se:"<="+ae)).trim()}function Ke(X,re){for(var se=0;se<X.length;se++)if(!X[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<X.length;se++)if(A(X[se].semver),X[se].semver!==Ne&&X[se].semver.prerelease.length>0){var me=X[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function $e(X,re,se){try{re=new De(re,se)}catch(me){return!1}return re.test(X)}function ze(X,re,se,me){var W,te,oe,ae,le;switch(X=new Q(X,me),re=new De(re,me),se){case">":W=ue,te=Ae,oe=ge,ae=">",le=">=";break;case"<":W=ge,te=Te,oe=ue,ae="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(X,re,me))return!1;for(var fe=0;fe<re.set.length;++fe){var ve=re.set[fe],Se=null,we=null;if(ve.forEach(function(be){be.semver===Ne&&(be=new ke(">=0.0.0")),Se=Se||be,we=we||be,W(be.semver,Se.semver,me)?Se=be:oe(be.semver,we.semver,me)&&(we=be)}),Se.operator===ae||Se.operator===le||(!we.operator||we.operator===ae)&&te(X,we.semver)||we.operator===le&&oe(X,we.semver))return!1}return!0}ke.prototype.parse=function(X){var re=this.loose?T[z]:T[D],se=X.match(re);if(!se)throw new TypeError("Invalid comparator: "+X);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=Ne},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(X){return A("Comparator.test",X,this.loose),this.semver===Ne||(typeof X=="string"&&(X=new Q(X,this.loose)),Ue(X,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(X,re){if(!(X instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new De(X.value,re),$e(this.value,se,re);if(X.operator==="")return se=new De(this.value,re),$e(X.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),W=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),te=this.semver.version===X.semver.version,oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ae=Ue(this.semver,"<",X.semver,re)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),le=Ue(this.semver,">",X.semver,re)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return me||W||te&&oe||ae||le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(X){var re=this.loose;X=X.trim(),A("range",X,re);var se=re?T[N]:T[F];X=X.replace(se,Ge),A("hyphen replace",X),X=X.replace(T[L],"$1$2$3"),A("comparator trim",X,T[L]),X=(X=(X=X.replace(T[j],"$1~")).replace(T[V],"$1^")).split(/\s+/).join(" ");var me=re?T[z]:T[D],W=X.split(" ").map(function(te){return function(oe,ae){return A("comp",oe),oe=function(le,fe){return le.trim().split(/\s+/).map(function(ve){return function(Se,we){A("caret",Se,we);var be=we?T[H]:T[q];return Se.replace(be,function(Pe,ye,pe,Ce,Re){var de;return A("caret",Se,Pe,ye,pe,Ce,Re),Oe(ye)?de="":Oe(pe)?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":Oe(Ce)?de=ye==="0"?">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+".0 <"+(+ye+1)+".0.0":Re?(A("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),de=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+pe+"."+(+Ce+1):">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ce+Re+" <"+(+ye+1)+".0.0"):(A("no pr"),de=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ce+" <"+ye+"."+pe+"."+(+Ce+1):">="+ye+"."+pe+"."+Ce+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ce+" <"+(+ye+1)+".0.0"),A("caret return",de),de})}(ve,fe)}).join(" ")}(oe,ae),A("caret",oe),oe=function(le,fe){return le.trim().split(/\s+/).map(function(ve){return function(Se,we){var be=we?T[M]:T[B];return Se.replace(be,function(Pe,ye,pe,Ce,Re){var de;return A("tilde",Se,Pe,ye,pe,Ce,Re),Oe(ye)?de="":Oe(pe)?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":Oe(Ce)?de=">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":Re?(A("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),de=">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+(+pe+1)+".0"):de=">="+ye+"."+pe+"."+Ce+" <"+ye+"."+(+pe+1)+".0",A("tilde return",de),de})}(ve,fe)}).join(" ")}(oe,ae),A("tildes",oe),oe=function(le,fe){return A("replaceXRanges",le,fe),le.split(/\s+/).map(function(ve){return function(Se,we){Se=Se.trim();var be=we?T[h]:T[w];return Se.replace(be,function(Pe,ye,pe,Ce,Re,de){A("xRange",Se,Pe,ye,pe,Ce,Re,de);var Le=Oe(pe),_e=Le||Oe(Ce),Fe=_e||Oe(Re);return ye==="="&&Fe&&(ye=""),Le?Pe=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Fe?(_e&&(Ce=0),Fe&&(Re=0),ye===">"?(ye=">=",_e?(pe=+pe+1,Ce=0,Re=0):Fe&&(Ce=+Ce+1,Re=0)):ye==="<="&&(ye="<",_e?pe=+pe+1:Ce=+Ce+1),Pe=ye+pe+"."+Ce+"."+Re):_e?Pe=">="+pe+".0.0 <"+(+pe+1)+".0.0":Fe&&(Pe=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0"),A("xRange return",Pe),Pe})}(ve,fe)}).join(" ")}(oe,ae),A("xrange",oe),oe=function(le,fe){return A("replaceStars",le,fe),le.trim().replace(T[x],"")}(oe,ae),A("stars",oe),oe}(te,re)}).join(" ").split(/\s+/);return this.loose&&(W=W.filter(function(te){return!!te.match(me)})),W=W.map(function(te){return new ke(te,re)})},De.prototype.intersects=function(X,re){if(!(X instanceof De))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return X.set.some(function(W){return W.every(function(te){return me.intersects(te,re)})})})})},e.toComparators=function(X,re){return new De(X,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},De.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new Q(X,this.loose));for(var re=0;re<this.set.length;re++)if(Ke(this.set[re],X))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(X,re,se){var me=null,W=null;try{var te=new De(re,se)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(me&&W.compare(oe)!==-1||(W=new Q(me=oe,se)))}),me},e.minSatisfying=function(X,re,se){var me=null,W=null;try{var te=new De(re,se)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(me&&W.compare(oe)!==1||(W=new Q(me=oe,se)))}),me},e.validRange=function(X,re){try{return new De(X,re).range||"*"}catch(se){return null}},e.ltr=function(X,re,se){return ze(X,re,"<",se)},e.gtr=function(X,re,se){return ze(X,re,">",se)},e.outside=ze,e.prerelease=function(X,re){var se=J(X,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(X,re,se){return X=new De(X,se),re=new De(re,se),X.intersects(re)},e.coerce=function(X){if(X instanceof Q)return X;if(typeof X!="string")return null;var re=X.match(T[R]);return re==null?null:J((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,p(1))},function(K,e){var p,k,A=K.exports={};function P(){throw new Error("setTimeout has not been defined")}function U(){throw new Error("clearTimeout has not been defined")}function T(E){if(p===setTimeout)return setTimeout(E,0);if((p===P||!p)&&setTimeout)return p=setTimeout,setTimeout(E,0);try{return p(E,0)}catch(C){try{return p.call(null,E,0)}catch(I){return p.call(this,E,0)}}}(function(){try{p=typeof setTimeout=="function"?setTimeout:P}catch(E){p=P}try{k=typeof clearTimeout=="function"?clearTimeout:U}catch(E){k=U}})();var g,v=[],O=!1,m=-1;function y(){O&&g&&(O=!1,g.length?v=g.concat(v):m=-1,v.length&&b())}function b(){if(!O){var E=T(y);O=!0;for(var C=v.length;C;){for(g=v,v=[];++m<C;)g&&g[m].run();m=-1,C=v.length}g=null,O=!1,function(I){if(k===clearTimeout)return clearTimeout(I);if((k===U||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(I);try{k(I)}catch(f){try{return k.call(null,I)}catch(s){return k.call(this,I)}}}(E)}}function u(E,C){this.fun=E,this.array=C}function S(){}A.nextTick=function(E){var C=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)C[I-1]=arguments[I];v.push(new u(E,C)),v.length!==1||O||T(b)},u.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=S,A.addListener=S,A.once=S,A.off=S,A.removeListener=S,A.removeAllListeners=S,A.emit=S,A.prependListener=S,A.prependOnceListener=S,A.listeners=function(E){return[]},A.binding=function(E){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(E){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Z[86],ee([0,1,7]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=p.globals.performance&&typeof p.globals.performance.now=="function";class A{constructor(U){this._highResolution=k&&U,this._startTime=this._now(),this._stopTime=-1}static create(U=!0){return new A(U)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=A}),define(Z[3],ee([0,1,11,63,2,64,86]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var T;(function(C){C.None=()=>A.Disposable.None;function I(M){return($,V=null,q)=>{let H=!1,z;return z=M(D=>{if(!H)return z?z.dispose():H=!0,$.call(V,D)},null,q),H&&z.dispose(),z}}C.once=I;function f(M,$){return o((V,q=null,H)=>M(z=>V.call(q,$(z)),null,H))}C.map=f;function s(M,$){return o((V,q=null,H)=>M(z=>{$(z),V.call(q,z)},null,H))}C.forEach=s;function r(M,$){return o((V,q=null,H)=>M(z=>$(z)&&V.call(q,z),null,H))}C.filter=r;function t(M){return M}C.signal=t;function i(...M){return($,V=null,q)=>(0,A.combinedDisposable)(...M.map(H=>H(z=>$.call(V,z),null,q)))}C.any=i;function n(M,$,V){let q=V;return f(M,H=>(q=$(q,H),q))}C.reduce=n;function o(M){let $;const V=new y({onFirstListenerAdd(){$=M(V.fire,V)},onLastListenerRemove(){$.dispose()}});return V.event}C.snapshot=o;function a(M,$,V=100,q=!1,H){let z,D,L,F=0;const N=new y({leakWarningThreshold:H,onFirstListenerAdd(){z=M(x=>{F++,D=$(D,x),q&&!L&&(N.fire(D),D=void 0),clearTimeout(L),L=setTimeout(()=>{const G=D;D=void 0,L=void 0,(!q||F>1)&&N.fire(G),F=0},V)})},onLastListenerRemove(){z.dispose()}});return N.event}C.debounce=a;function c(M){const $=new Date().getTime();return f(I(M),V=>new Date().getTime()-$)}C.stopwatch=c;function l(M){let $=!0,V;return r(M,q=>{const H=$||q!==V;return $=!1,V=q,H})}C.latch=l;function d(M,$=!1,V=[]){let q=V.slice(),H=M(L=>{q?q.push(L):D.fire(L)});const z=()=>{q&&q.forEach(L=>D.fire(L)),q=null},D=new y({onFirstListenerAdd(){H||(H=M(L=>D.fire(L)))},onFirstListenerDidAdd(){q&&($?setTimeout(z):z())},onLastListenerRemove(){H&&H.dispose(),H=null}});return D.event}C.buffer=d;class w{constructor($){this.event=$}map($){return new w(f(this.event,$))}forEach($){return new w(s(this.event,$))}filter($){return new w(r(this.event,$))}reduce($,V){return new w(n(this.event,$,V))}latch(){return new w(l(this.event))}debounce($,V=100,q=!1,H){return new w(a(this.event,$,V,q,H))}on($,V,q){return this.event($,V,q)}once($,V,q){return I(this.event)($,V,q)}}function h(M){return new w(M)}C.chain=h;function R(M,$,V=q=>q){const q=(...L)=>D.fire(V(...L)),H=()=>M.on($,q),z=()=>M.removeListener($,q),D=new y({onFirstListenerAdd:H,onLastListenerRemove:z});return D.event}C.fromNodeEventEmitter=R;function _(M,$,V=q=>q){const q=(...L)=>D.fire(V(...L)),H=()=>M.addEventListener($,q),z=()=>M.removeEventListener($,q),D=new y({onFirstListenerAdd:H,onLastListenerRemove:z});return D.event}C.fromDOMEventEmitter=_;function j(M){const $=new y;let V=!1;return M.then(void 0,()=>null).then(()=>{V?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),V=!0,$.event}C.fromPromise=j;function B(M){return new Promise($=>I(M)($))}C.toPromise=B})(T=e.Event||(e.Event={}));class g{constructor(I){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${I}_${g._idPool++}`}start(I){this._stopWatch=new U.StopWatch(!0),this._listenerCount=I}stop(){if(this._stopWatch){const I=this._stopWatch.elapsed();this._elapsedOverall+=I,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${I.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}g._idPool=0;let v=-1;function O(C){const I=v;return v=C,{dispose(){v=I}}}e.setGlobalLeakWarningThreshold=O;class m{constructor(I,f=Math.random().toString(18).slice(2,5)){this.customThreshold=I,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(I){let f=v;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),!(f<=0||I<f)){this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let t,i=0;for(const[n,o]of this._stacks)(!t||i<o)&&(t=n,i=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(s)||0;this._stacks.set(s,t-1)}}}}class y{constructor(I){var f;this._disposed=!1,this._options=I,this._leakageMon=v>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((f=this._options)===null||f===void 0?void 0:f._profName)?new g(this._options._profName):void 0}get event(){return this._event||(this._event=(I,f,s)=>{var r;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(f?[I,f]:I);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,I,f);const n=(r=this._leakageMon)===null||r===void 0?void 0:r.check(this._listeners.size);let o;return o={dispose:()=>{n&&n(),o.dispose=y._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},s instanceof A.DisposableStore?s.add(o):Array.isArray(s)&&s.push(o),o}),this._event}fire(I){var f,s;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,I]);for((f=this._perfMon)===null||f===void 0||f.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,t]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,t):r[0].call(r[1],t)}catch(i){(0,p.onUnexpectedError)(i)}}(s=this._perfMon)===null||s===void 0||s.stop()}}dispose(){var I,f,s;(I=this._listeners)===null||I===void 0||I.clear(),(f=this._deliveryQueue)===null||f===void 0||f.clear(),(s=this._leakageMon)===null||s===void 0||s.dispose(),this._disposed=!0}}e.Emitter=y,y._noop=function(){};class b extends y{constructor(I){super(I);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=I==null?void 0:I.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const I=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(I))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(I){this._listeners&&(this._isPaused!==0?this._eventQueue.push(I):super.fire(I))}}e.PauseableEmitter=b;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(I){const f={event:I,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const s=()=>{this.hasListeners&&this.unhook(f);const r=this.events.indexOf(f);this.events.splice(r,1)};return(0,A.toDisposable)((0,k.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(I=>this.hook(I))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(I=>this.unhook(I))}hook(I){I.listener=I.event(f=>this.emitter.fire(f))}unhook(I){I.listener&&I.listener.dispose(),I.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=u;class S{constructor(){this.buffers=[]}wrapEvent(I){return(f,s,r)=>I(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>f.call(s,t)):f.call(s,t)},void 0,r)}bufferEvents(I){const f=[];this.buffers.push(f);const s=I();return this.buffers.pop(),f.forEach(r=>r()),s}}e.EventBufferer=S;class E{constructor(){this.listening=!1,this.inputEvent=T.None,this.inputEventListener=A.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(I){this.inputEvent=I,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=I(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(Z[30],ee([0,1,3]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(T,g){const v=setTimeout(T.bind(g),0);return{dispose(){clearTimeout(v)}}});var A;(function(T){function g(v){return v===T.None||v===T.Cancelled||v instanceof P?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}T.isCancellationToken=g,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class U{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=A.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=U}),define(Z[47],ee([0,1,11,2]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=A;function P(f){const s=f;return s?A(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=P;function U(f,s){return new T(f,s)}e.newWriteableStream=U;class T{constructor(s,r){this.reducer=s,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(r=>r(s))}emitError(s){this.listeners.error.length===0?(0,p.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(r=>r(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,r){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(s,r){if(!this.state.destroyed){let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(r);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(f,s){const r=[];let t;for(;(t=f.read())!==null;)r.push(t);return s(r)}e.consumeReadable=g;function v(f,s,r){const t=[];let i;for(;(i=f.read())!==null&&t.length<r;)t.push(i);return i===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}e.peekReadable=v;function O(f,s){return new Promise((r,t)=>{const i=[];m(f,{onData:n=>{s&&i.push(n)},onError:n=>{s?t(n):r(void 0)},onEnd:()=>{r(s?s(i):void 0)}})})}e.consumeStream=O;function m(f,s){f.on("error",r=>s.onError(r)),f.on("end",()=>s.onEnd()),f.on("data",r=>s.onData(r))}e.listenStream=m;function y(f,s){return new Promise((r,t)=>{const i=new k.DisposableStore,n=[],o=l=>{if(n.push(l),n.length>s)return i.dispose(),f.pause(),r({stream:f,buffer:n,ended:!1})},a=l=>t(l),c=()=>r({stream:f,buffer:n,ended:!0});i.add((0,k.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),i.add((0,k.toDisposable)(()=>f.removeListener("end",c))),f.on("end",c),i.add((0,k.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=y;function b(f,s){const r=U(s);return r.end(f),r}e.toStream=b;function u(){const f=U(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=u;function S(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=S;function E(f,s,r){const t=U(r);return m(f,{onData:i=>t.write(s.data(i)),onError:i=>t.error(s.error?s.error(i):i),onEnd:()=>t.end()}),t}e.transform=E;function C(f,s,r){let t=!1;return{read:()=>{const i=s.read();return t?i:(t=!0,i!==null?r([f,i]):f)}}}e.prefixedReadable=C;function I(f,s,r){let t=!1;const i=U(r);return m(s,{onData:n=>t?i.write(n):(t=!0,i.write(r([f,n]))),onError:n=>i.error(n),onEnd:()=>{t||(t=!0,i.write(f)),i.end()}}),i}e.prefixedStream=I}),define(Z[21],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function p(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=p;const k=/{(\d+)}/g;function A(W,...te){return te.length===0?W:W.replace(k,function(oe,ae){const le=parseInt(ae,10);return isNaN(le)||le<0||le>=te.length?oe:te[le]})}e.format=A;function P(W){return W.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=P;function U(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=U;function T(W,te){let oe=0;const ae=te.charCodeAt(0);for(let le=W.length-1;le>=0;le--)W.charCodeAt(le)===ae&&oe++;return oe}e.count=T;function g(W,te,oe="\u2026"){return W.length<=te?W:`${W.substr(0,te)}${oe}`}e.truncate=g;function v(W,te=" "){const oe=O(W,te);return m(oe,te)}e.trim=v;function O(W,te){if(!W||!te)return W;const oe=te.length;if(oe===0||W.length===0)return W;let ae=0;for(;W.indexOf(te,ae)===ae;)ae=ae+oe;return W.substring(ae)}e.ltrim=O;function m(W,te){if(!W||!te)return W;const oe=te.length,ae=W.length;if(oe===0||ae===0)return W;let le=ae,fe=-1;for(;fe=W.lastIndexOf(te,le-1),!(fe===-1||fe+oe!==le);){if(fe===0)return"";le=fe}return W.substring(0,le)}e.rtrim=m;function y(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function b(W){return W.replace(/\*/g,"")}e.stripWildcards=b;function u(W,te,oe={}){if(!W)throw new Error("Cannot create regex from empty string");te||(W=U(W)),oe.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(W,ae)}e.createRegExp=u;function S(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function E(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function C(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=C;function I(W){return W.split(/\r\n|\r|\n/)}e.splitLines=I;function f(W){for(let te=0,oe=W.length;te<oe;te++){const ae=W.charCodeAt(te);if(ae!==32&&ae!==9)return te}return-1}e.firstNonWhitespaceIndex=f;function s(W,te=0,oe=W.length){for(let ae=te;ae<oe;ae++){const le=W.charCodeAt(ae);if(le!==32&&le!==9)return W.substring(te,ae)}return W.substring(te,oe)}e.getLeadingWhitespace=s;function r(W,te=W.length-1){for(let oe=te;oe>=0;oe--){const ae=W.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=r;function t(W,te){return W<te?-1:W>te?1:0}e.compare=t;function i(W,te,oe=0,ae=W.length,le=0,fe=te.length){for(;oe<ae&&le<fe;oe++,le++){let we=W.charCodeAt(oe),be=te.charCodeAt(le);if(we<be)return-1;if(we>be)return 1}const ve=ae-oe,Se=fe-le;return ve<Se?-1:ve>Se?1:0}e.compareSubstring=i;function n(W,te){return o(W,te,0,W.length,0,te.length)}e.compareIgnoreCase=n;function o(W,te,oe=0,ae=W.length,le=0,fe=te.length){for(;oe<ae&&le<fe;oe++,le++){let we=W.charCodeAt(oe),be=te.charCodeAt(le);if(we!==be){const Pe=we-be;if(!(Pe===32&&c(be))&&!(Pe===-32&&c(we)))return a(we)&&a(be)?Pe:i(W.toLowerCase(),te.toLowerCase(),oe,ae,le,fe)}}const ve=ae-oe,Se=fe-le;return ve<Se?-1:ve>Se?1:0}e.compareSubstringIgnoreCase=o;function a(W){return W>=97&&W<=122}e.isLowerAsciiLetter=a;function c(W){return W>=65&&W<=90}e.isUpperAsciiLetter=c;function l(W){return a(W)||c(W)}function d(W,te){return W.length===te.length&&w(W,te)}e.equalsIgnoreCase=d;function w(W,te,oe=W.length){for(let ae=0;ae<oe;ae++){const le=W.charCodeAt(ae),fe=te.charCodeAt(ae);if(le!==fe){if(l(le)&&l(fe)){const ve=Math.abs(le-fe);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(fe).toLowerCase())return!1}}return!0}function h(W,te){const oe=te.length;return te.length>W.length?!1:w(W,te,oe)}e.startsWithIgnoreCase=h;function R(W,te){let oe,ae=Math.min(W.length,te.length);for(oe=0;oe<ae;oe++)if(W.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=R;function _(W,te){let oe,ae=Math.min(W.length,te.length);const le=W.length-1,fe=te.length-1;for(oe=0;oe<ae;oe++)if(W.charCodeAt(le-oe)!==te.charCodeAt(fe-oe))return oe;return ae}e.commonSuffixLength=_;function j(W){return 55296<=W&&W<=56319}e.isHighSurrogate=j;function B(W){return 56320<=W&&W<=57343}e.isLowSurrogate=B;function M(W,te){return(W-55296<<10)+(te-56320)+65536}e.computeCodePoint=M;function $(W,te,oe){const ae=W.charCodeAt(oe);if(j(ae)&&oe+1<te){const le=W.charCodeAt(oe+1);if(B(le))return M(ae,le)}return ae}e.getNextCodePoint=$;function V(W,te){const oe=W.charCodeAt(te-1);if(B(oe)&&te>1){const ae=W.charCodeAt(te-2);if(j(ae))return M(ae,oe)}return oe}function q(W,te){const oe=se.getInstance(),ae=te,le=W.length,fe=$(W,le,te);te+=fe>=65536?2:1;let ve=oe.getGraphemeBreakType(fe);for(;te<le;){const Se=$(W,le,te),we=oe.getGraphemeBreakType(Se);if(X(ve,we))break;te+=Se>=65536?2:1,ve=we}return te-ae}e.nextCharLength=q;function H(W,te){const oe=se.getInstance(),ae=te,le=V(W,te);te-=le>=65536?2:1;let fe=oe.getGraphemeBreakType(le);for(;te>0;){const ve=V(W,te),Se=oe.getGraphemeBreakType(ve);if(X(Se,fe))break;te-=ve>=65536?2:1,fe=Se}return ae-te}e.prevCharLength=H;function z(W,te){const oe=se.getInstance(),ae=W.length,le=te,fe=$(W,ae,te),ve=oe.getGraphemeBreakType(fe);te+=fe>=65536?2:1;let Se=ve;for(;te<ae;){const be=$(W,ae,te),Pe=oe.getGraphemeBreakType(be);if(X(Se,Pe))break;te+=be>=65536?2:1,Se=Pe}const we=te;for(te=le,Se=ve;te>0;){const be=V(W,te),Pe=oe.getGraphemeBreakType(be);if(X(Pe,Se))break;te-=be>=65536?2:1,Se=Pe}return[te,we]}function D(W,te){return te>0&&B(W.charCodeAt(te))?z(W,te-1):z(W,te)}e.getCharContainingOffset=D;function L(W){const te=W.length;let oe=0,ae=0;for(;ae<te;){const ve=$(W,te,ae);ae+=ve>=65536?2:1,ve<128?oe+=1:ve<2048?oe+=2:ve<65536?oe+=3:oe+=4}const le=new Uint8Array(oe);ae=0;let fe=0;for(;ae<te;){const ve=$(W,te,ae);ae+=ve>=65536?2:1,ve<128?le[fe++]=ve:ve<2048?(le[fe++]=192|(ve&1984)>>>6,le[fe++]=128|(ve&63)>>>0):ve<65536?(le[fe++]=224|(ve&61440)>>>12,le[fe++]=128|(ve&4032)>>>6,le[fe++]=128|(ve&63)>>>0):(le[fe++]=240|(ve&1835008)>>>18,le[fe++]=128|(ve&258048)>>>12,le[fe++]=128|(ve&4032)>>>6,le[fe++]=128|(ve&63)>>>0)}return le}e.encodeUTF8=L;function F(W){const te=W.byteLength,oe=[];let ae=0;for(;ae<te;){const le=W[ae];let fe;if(le>=240&&ae+3<te?fe=(W[ae++]&7)<<18>>>0|(W[ae++]&63)<<12>>>0|(W[ae++]&63)<<6>>>0|(W[ae++]&63)<<0>>>0:le>=224&&ae+2<te?fe=(W[ae++]&15)<<12>>>0|(W[ae++]&63)<<6>>>0|(W[ae++]&63)<<0>>>0:le>=192&&ae+1<te?fe=(W[ae++]&31)<<6>>>0|(W[ae++]&63)<<0>>>0:fe=W[ae++],fe>=0&&fe<=55295||fe>=57344&&fe<=65535)oe.push(String.fromCharCode(fe));else if(fe>=65536&&fe<=1114111){const ve=fe-65536,Se=55296+((ve&1047552)>>>10),we=56320+((ve&1023)>>>0);oe.push(String.fromCharCode(Se)),oe.push(String.fromCharCode(we))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function x(W){return N.test(W)}e.containsRTL=x;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function J(W){return G.test(W)}e.containsEmoji=J;const Q=/^[\t\n\r\x20-\x7E]*$/;function ne(W){return Q.test(W)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=ie;function ce(W){for(let te=0,oe=W.length;te<oe;te++)if(ue(W.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ce;function ue(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=ue;function ge(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=ge;function Ee(W,te){if(W.length<te)return W;const oe=/\b/g;let ae=0;for(;oe.test(W)&&!(W.length-oe.lastIndex<te);)ae=oe.lastIndex,oe.lastIndex+=1;return W.substring(ae).replace(/^\s/,"")}e.lcut=Ee;const Ie=/\x1B\x5B[12]?K/g,Te=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function Ue(W){return W&&(W=W.replace(Ie,""),W=W.replace(Te,""),W=W.replace(Ae,"")),W}e.removeAnsiEscapeCodes=Ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Ne(W){return ke(W)?W.substr(1):W}e.stripUTF8BOM=Ne;function De(W,te){if(!W||!te||W.length<te.length)return!1;const oe=te.length,ae=W.toLowerCase();let le=0,fe=-1;for(;le<oe;){const ve=ae.indexOf(te[le],fe+1);if(ve<0)return!1;fe=ve,le++}return!0}e.fuzzyContains=De;function Oe(W,te=!1){return W?(te&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Oe;function Ge(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=Ge;function Ke(W,te=1){if(te===0)return"";let oe=-1;do oe=W.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?W:(W[oe-1]==="\r"&&oe--,W.substr(0,oe))}e.getNLines=Ke;function $e(W){const te=90-65+1;return W=W%(2*te),W<te?String.fromCharCode(97+W):String.fromCharCode(65+W-te)}e.singleLetterHash=$e;function ze(W){return se.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ze;function X(W,te){return W===0?te!==5&&te!==7:W===2&&te===3?!1:W===4||W===2||W===3||te===4||te===2||te===3?!0:!(W===8&&(te===8||te===9||te===11||te===12)||(W===11||W===9)&&(te===9||te===10)||(W===12||W===10)&&te===10||te===5||te===13||te===7||W===1||W===13&&te===14||W===6&&te===6)}e.breakBetweenGraphemeBreakType=X;var re;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,ae=oe.length/3;let le=1;for(;le<=ae;)if(te<oe[3*le])le=2*le;else if(te>oe[3*le+1])le=2*le+1;else return oe[3*le+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Z[23],ee([0,1,21,47]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",U=typeof TextDecoder!="undefined";let T,g;class v{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return A?new v(Buffer.allocUnsafe(l)):new v(new Uint8Array(l))}static wrap(l){return A&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new v(l)}static fromString(l,d){return!((d==null?void 0:d.dontUseNodeBuffer)||!1)&&A?new v(Buffer.from(l)):P?(T||(T=new TextEncoder),new v(T.encode(l))):new v(p.encodeUTF8(l))}static concat(l,d){if(typeof d=="undefined"){d=0;for(let R=0,_=l.length;R<_;R++)d+=l[R].byteLength}const w=v.alloc(d);let h=0;for(let R=0,_=l.length;R<_;R++){const j=l[R];w.set(j,h),h+=j.byteLength}return w}toString(){return A?this.buffer.toString():U?(g||(g=new TextDecoder),g.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(l,d){return new v(this.buffer.subarray(l,d))}set(l,d){l instanceof v?this.buffer.set(l.buffer,d):this.buffer.set(l,d)}readUInt32BE(l){return y(this.buffer,l)}writeUInt32BE(l,d){b(this.buffer,l,d)}readUInt32LE(l){return u(this.buffer,l)}writeUInt32LE(l,d){S(this.buffer,l,d)}readUInt8(l){return E(this.buffer,l)}writeUInt8(l,d){C(this.buffer,l,d)}}e.VSBuffer=v;function O(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=O;function m(c,l,d){c[d+0]=l&255,l=l>>>8,c[d+1]=l&255}e.writeUInt16LE=m;function y(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=y;function b(c,l,d){c[d+3]=l,l=l>>>8,c[d+2]=l,l=l>>>8,c[d+1]=l,l=l>>>8,c[d]=l}e.writeUInt32BE=b;function u(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=u;function S(c,l,d){c[d+0]=l&255,l=l>>>8,c[d+1]=l&255,l=l>>>8,c[d+2]=l&255,l=l>>>8,c[d+3]=l&255}e.writeUInt32LE=S;function E(c,l){return c[l]}e.readUInt8=E;function C(c,l,d){c[d]=l}e.writeUInt8=C;function I(c){return k.consumeReadable(c,l=>v.concat(l))}e.readableToBuffer=I;function f(c){return k.toReadable(c)}e.bufferToReadable=f;function s(c){return k.consumeStream(c,l=>v.concat(l))}e.streamToBuffer=s;async function r(c){return c.ended?v.concat(c.buffer):v.concat([...c.buffer,await s(c.stream)])}e.bufferedStreamToBuffer=r;function t(c){return k.toStream(c,l=>v.concat(l))}e.bufferToStream=t;function i(c){return k.transform(c,{data:l=>typeof l=="string"?v.fromString(l):v.wrap(l)},l=>v.concat(l))}e.streamToBufferReadableStream=i;function n(c){return k.newWriteableStream(l=>v.concat(l),c)}e.newWriteableBufferStream=n;function o(c,l){return k.prefixedReadable(c,l,d=>v.concat(d))}e.prefixedBufferReadable=o;function a(c,l){return k.prefixedStream(c,l,d=>v.concat(d))}e.prefixedBufferStream=a}),define(Z[15],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(l){return Array.isArray(l)}e.isArray=p;function k(l){return typeof l=="string"}e.isString=k;function A(l){return Array.isArray(l)&&l.every(d=>k(d))}e.isStringArray=A;function P(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=P;function U(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=U;function T(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=T;function g(l){return l===!0||l===!1}e.isBoolean=g;function v(l){return typeof l=="undefined"}e.isUndefined=v;function O(l){return!m(l)}e.isDefined=O;function m(l){return v(l)||l===null}e.isUndefinedOrNull=m;function y(l,d){if(!l)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=y;function b(l){if(m(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=b;function u(...l){const d=[];for(let w=0;w<l.length;w++){const h=l[w];if(m(h))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);d.push(h)}return d}e.assertAllDefined=u;const S=Object.prototype.hasOwnProperty;function E(l){if(!P(l))return!1;for(let d in l)if(S.call(l,d))return!1;return!0}e.isEmptyObject=E;function C(l){return typeof l=="function"}e.isFunction=C;function I(...l){return l.length>0&&l.every(C)}e.areFunctions=I;function f(l,d){const w=Math.min(l.length,d.length);for(let h=0;h<w;h++)s(l[h],d[h])}e.validateConstraints=f;function s(l,d){if(k(d)){if(typeof l!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(C(d)){try{if(l instanceof d)return}catch(w){}if(!m(l)&&l.constructor===d||d.length===1&&d.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function r(l){let d=[],w=Object.getPrototypeOf(l);for(;Object.prototype!==w;)d=d.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return d}e.getAllPropertyNames=r;function t(l){const d=[];for(const w of r(l))typeof l[w]=="function"&&d.push(w);return d}e.getAllMethodNames=t;function i(l,d){const w=R=>function(){const _=Array.prototype.slice.call(arguments,0);return d(R,_)};let h={};for(const R of l)h[R]=w(R);return h}e.createProxyObject=i;function n(l){return l===null?void 0:l}e.withNullAsUndefined=n;function o(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=o;function a(l){return class{constructor(){return new Proxy({},{get(d,w){if(d[w])return d[w];throw new Error(`Not Implemented: ${l}->${String(w)}`)}})}}}e.NotImplementedProxy=a;function c(l){throw new Error("Unreachable")}e.assertNever=c}),define(Z[42],ee([0,1,7,21,8,15]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function U(i){return i===47||i===92}e.isPathSeparator=U;function T(i){return i.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=T;function g(i,n=A.posix.sep){if(!i)return"";const o=i.length,a=i.charCodeAt(0);if(U(a)){if(U(i.charCodeAt(1))&&!U(i.charCodeAt(2))){let l=3;const d=l;for(;l<o&&!U(i.charCodeAt(l));l++);if(d!==l&&!U(i.charCodeAt(l+1))){for(l+=1;l<o;l++)if(U(i.charCodeAt(l)))return i.slice(0,l+1).replace(/[\\/]/g,n)}}return n}else if(E(a)&&i.charCodeAt(1)===58)return U(i.charCodeAt(2))?i.slice(0,2)+n:i.slice(0,2);let c=i.indexOf("://");if(c!==-1){for(c+=3;c<o;c++)if(U(i.charCodeAt(c)))return i.slice(0,c+1)}return""}e.getRoot=g;function v(i){if(!p.isWindows||!i||i.length<5)return!1;let n=i.charCodeAt(0);if(n!==92||(n=i.charCodeAt(1),n!==92))return!1;let o=2;const a=o;for(;o<i.length&&(n=i.charCodeAt(o),n!==92);o++);return!(a===o||(n=i.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=v;const O=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(i,n=p.isWindows){const o=n?O:m;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||n&&y.test(i)||i==="."||i===".."||n&&i[i.length-1]==="."||n&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=b;function u(i,n,o){const a=i===n;return!o||a?a:!i||!n?!1:(0,k.equalsIgnoreCase)(i,n)}e.isEqual=u;function S(i,n,o,a=A.sep){if(i===n)return!0;if(!i||!n||n.length>i.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(i,n))return!1;if(n.length===i.length)return!0;let l=n.length;return n.charAt(n.length-1)===a&&l--,i.charAt(l)===a}return n.charAt(n.length-1)!==a&&(n+=a),i.indexOf(n)===0}e.isEqualOrParent=S;function E(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=E;function C(i,n){return p.isWindows&&i.endsWith(":")&&(i+=A.sep),(0,A.isAbsolute)(i)||(i=(0,A.join)(n,i)),i=(0,A.normalize)(i),p.isWindows?(i=(0,k.rtrim)(i,A.sep),i.endsWith(":")&&(i+=A.sep)):(i=(0,k.rtrim)(i,A.sep),i||(i=A.sep)),i}e.sanitizeFilePath=C;function I(i){const n=(0,A.normalize)(i);return p.isWindows?i.length>3?!1:f(n)&&(i.length===2||n.charCodeAt(2)===92):n===A.posix.sep}e.isRootOrDriveLetter=I;function f(i){return p.isWindows?E(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function s(i){return f(i)?i[0]:void 0}e.getDriveLetter=s;function r(i,n,o){return n.length>i.length?-1:i===n?0:(o&&(i=i.toLowerCase(),n=n.toLowerCase()),i.indexOf(n))}e.indexOfPath=r;function t(i){const n=i.split(":");let o,a,c;if(n.forEach(l=>{const d=Number(l);(0,P.isNumber)(d)?a===void 0?a=d:c===void 0&&(c=d):o=o?[o,l].join(":"):l}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:a!==void 0?a:void 0,column:c!==void 0?c:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Z[26],ee([0,1,15]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const E=Array.isArray(S)?[]:{};return Object.keys(S).forEach(C=>{S[C]&&typeof S[C]=="object"?E[C]=k(S[C]):E[C]=S[C]}),E}e.deepClone=k;function A(S){if(!S||typeof S!="object")return S;const E=[S];for(;E.length>0;){const C=E.shift();Object.freeze(C);for(const I in C)if(P.call(C,I)){const f=C[I];typeof f=="object"&&!Object.isFrozen(f)&&E.push(f)}}return S}e.deepFreeze=A;const P=Object.prototype.hasOwnProperty;function U(S,E){return T(S,E,new Set)}e.cloneAndChange=U;function T(S,E,C){if((0,p.isUndefinedOrNull)(S))return S;const I=E(S);if(typeof I!="undefined")return I;if((0,p.isArray)(S)){const f=[];for(const s of S)f.push(T(s,E,C));return f}if((0,p.isObject)(S)){if(C.has(S))throw new Error("Cannot clone recursive data-structure");C.add(S);const f={};for(let s in S)P.call(S,s)&&(f[s]=T(S[s],E,C));return C.delete(S),f}return S}function g(S,E,C=!0){return(0,p.isObject)(S)?((0,p.isObject)(E)&&Object.keys(E).forEach(I=>{I in S?C&&((0,p.isObject)(S[I])&&(0,p.isObject)(E[I])?g(S[I],E[I],C):S[I]=E[I]):S[I]=E[I]}),S):E}e.mixin=g;function v(S,E){if(S===E)return!0;if(S==null||E===null||E===void 0||typeof S!=typeof E||typeof S!="object"||Array.isArray(S)!==Array.isArray(E))return!1;let C,I;if(Array.isArray(S)){if(S.length!==E.length)return!1;for(C=0;C<S.length;C++)if(!v(S[C],E[C]))return!1}else{const f=[];for(I in S)f.push(I);f.sort();const s=[];for(I in E)s.push(I);if(s.sort(),!v(f,s))return!1;for(C=0;C<f.length;C++)if(!v(S[f[C]],E[f[C]]))return!1}return!0}e.equals=v;function O(S){const E=new Set;return JSON.stringify(S,(C,I)=>{if((0,p.isObject)(I)||Array.isArray(I)){if(E.has(I))return"[Circular]";E.add(I)}return I})}e.safeStringify=O;function m(S,E,C){const I=E(S);return typeof I=="undefined"?C:I}e.getOrDefault=m;function y(S,E){const C=Object.create(null);return!S||!E||Object.keys(E).forEach(f=>{const s=S[f],r=E[f];v(s,r)||(C[f]=r)}),C}e.distinct=y;function b(S,E){const C=E.toLowerCase(),I=Object.keys(S).find(f=>f.toLowerCase()===C);return I?S[I]:S[E]}e.getCaseInsensitive=b;function u(S,E){const C=Object.create(null);for(const I of Object.keys(S))E(I,S[I])&&(C[I]=S[I]);return C}e.filter=u}),define(Z[4],ee([0,1,7,8]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,P=/^\//,U=/^\/\//;function T(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!A.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!P.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(n,o){return!n&&!o?"file":n}function v(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==m&&(o=m+o):o=m;break}return o}const O="",m="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(o,a,c,l,d,w=!1){typeof o=="object"?(this.scheme=o.scheme||O,this.authority=o.authority||O,this.path=o.path||O,this.query=o.query||O,this.fragment=o.fragment||O):(this.scheme=g(o,w),this.authority=a||O,this.path=v(this.scheme,c||O),this.query=l||O,this.fragment=d||O,T(this,w))}static isUri(o){return o instanceof b?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return f(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:c,path:l,query:d,fragment:w}=o;return a===void 0?a=this.scheme:a===null&&(a=O),c===void 0?c=this.authority:c===null&&(c=O),l===void 0?l=this.path:l===null&&(l=O),d===void 0?d=this.query:d===null&&(d=O),w===void 0?w=this.fragment:w===null&&(w=O),a===this.scheme&&c===this.authority&&l===this.path&&d===this.query&&w===this.fragment?this:new S(a,c,l,d,w)}static parse(o,a=!1){const c=y.exec(o);return c?new S(c[2]||O,i(c[4]||O),i(c[5]||O),i(c[7]||O),i(c[9]||O),a):new S(O,O,O,O,O)}static file(o){let a=O;if(p.isWindows&&(o=o.replace(/\\/g,m)),o[0]===m&&o[1]===m){const c=o.indexOf(m,2);c===-1?(a=o.substring(2),o=m):(a=o.substring(2,c),o=o.substring(c)||m)}return new S("file",a,o,O,O)}static from(o){return new S(o.scheme,o.authority,o.path,o.query,o.fragment)}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return p.isWindows&&o.scheme==="file"?c=b.file(k.win32.join(f(o,!0),...a)).path:c=k.posix.join(o.path,...a),o.with({path:c})}toString(o=!1){return s(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof b)return o;{const a=new S(o);return a._formatted=o.external,a._fsPath=o._sep===u?o.fsPath:null,a}}else return o}}e.URI=b;const u=p.isWindows?1:void 0;class S extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(o=!1){return o?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=u),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function C(n,o){let a,c=-1;for(let l=0;l<n.length;l++){const d=n.charCodeAt(l);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||o&&d===47)c!==-1&&(a+=encodeURIComponent(n.substring(c,l)),c=-1),a!==void 0&&(a+=n.charAt(l));else{a===void 0&&(a=n.substr(0,l));const w=E[d];w!==void 0?(c!==-1&&(a+=encodeURIComponent(n.substring(c,l)),c=-1),a+=w):c===-1&&(c=l)}}return c!==-1&&(a+=encodeURIComponent(n.substring(c))),a!==void 0?a:n}function I(n){let o;for(let a=0;a<n.length;a++){const c=n.charCodeAt(a);c===35||c===63?(o===void 0&&(o=n.substr(0,a)),o+=E[c]):o!==void 0&&(o+=n[a])}return o!==void 0?o:n}function f(n,o){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,p.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=f;function s(n,o){const a=o?I:C;let c="",{scheme:l,authority:d,path:w,query:h,fragment:R}=n;if(l&&(c+=l,c+=":"),(d||l==="file")&&(c+=m,c+=m),d){let _=d.indexOf("@");if(_!==-1){const j=d.substr(0,_);d=d.substr(_+1),_=j.indexOf(":"),_===-1?c+=a(j,!1):(c+=a(j.substr(0,_),!1),c+=":",c+=a(j.substr(_+1),!1)),c+="@"}d=d.toLowerCase(),_=d.indexOf(":"),_===-1?c+=a(d,!1):(c+=a(d.substr(0,_),!1),c+=d.substr(_))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const _=w.charCodeAt(1);_>=65&&_<=90&&(w=`/${String.fromCharCode(_+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const _=w.charCodeAt(0);_>=65&&_<=90&&(w=`${String.fromCharCode(_+32)}:${w.substr(2)}`)}c+=a(w,!0)}return h&&(c+="?",c+=a(h,!1)),R&&(c+="#",c+=o?R:C(R,!1)),c}function r(n){try{return decodeURIComponent(n)}catch(o){return n.length>3?n.substr(0,3)+r(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(n){return n.match(t)?n.replace(t,o=>r(o)):n}}),define(Z[87],ee([0,1,4]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(v){const O=v;return O&&typeof O.type=="string"&&typeof O.severity=="string"}e.isRemoteConsoleLog=k;function A(v){const O=[];let m;try{const y=JSON.parse(v.arguments),b=y[y.length-1];b&&b.__$stack&&(y.pop(),m=b.__$stack),O.push(...y)}catch(y){O.push("Unable to log remote console arguments",v.arguments)}return{args:O,stack:m}}e.parse=A;function P(v){if(typeof v!="string")return P(A(v).stack);const O=v;if(O){const m=U(O),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(y&&y.length===4)return{uri:p.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=P;function U(v){if(!v)return v;const O=v.indexOf(`
`);return O===-1?v:v.substring(0,O)}function T(v,O){const{args:m,stack:y}=A(v),b=typeof m[0]=="string"&&m.length===1;let u=U(y);u&&(u=`(${u.trim()})`);let S=[];if(typeof m[0]=="string"?u&&b?S=[`%c[${O}] %c${m[0]} %c${u}`,g("blue"),g(""),g("grey")]:S=[`%c[${O}] %c${m[0]}`,g("blue"),g(""),...m.slice(1)]:S=[`%c[${O}]%`,g("blue"),...m],u&&!b&&S.push(u),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,S)}e.log=T;function g(v){return`color: ${v}`}});var lt=this&&this.__classPrivateFieldSet||function(K,e,p,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!A:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(K,p):A?A.value=p:e.set(K,p),p},je=this&&this.__classPrivateFieldGet||function(K,e,p,k){if(p==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!k:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?k:p==="a"?k.call(K):k?k.value:e.get(K)};define(Z[37],ee([0,1,4,21]),function(K,e,p,k){"use strict";var A,P,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(t,i,n){let o=t.get(i);return o===void 0&&(o=n,t.set(i,o)),o}e.getOrSet=T;function g(t){const i=[];return t.forEach((n,o)=>{i.push(`${o} => ${n}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=g;function v(t){const i=[];return t.forEach(n=>{i.push(n)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=v;class O{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return n-o}value(){return this._value[this._pos]}}e.StringIterator=O;class m{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=m;class y{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class u{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,k.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class S{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(i){this._iter=i}static forUris(i=()=>!1){return new E(new u(i))}static forPaths(){return new E(new y)}static forStrings(){return new E(new O)}static forConfigKeys(){return new E(new m)}clear(){this._root=void 0}set(i,n){const o=this._iter.reset(i);let a;for(this._root||(this._root=new S,this._root.segment=o.value()),a=this._root;;){const l=o.cmp(a.segment);if(l>0)a.left||(a.left=new S,a.left.segment=o.value()),a=a.left;else if(l<0)a.right||(a.right=new S,a.right.segment=o.value()),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new S,a.mid.segment=o.value()),a=a.mid;else break}const c=a.value;return a.value=n,a.key=i,c}get(i){var n;return(n=this._getNode(i))===null||n===void 0?void 0:n.value}_getNode(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const a=n.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(i){const n=this._getNode(i);return!((n==null?void 0:n.value)===void 0&&(n==null?void 0:n.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const o=this._iter.reset(i),a=[];let c=this._root;for(;c;){const l=o.cmp(c.segment);if(l>0)a.push([1,c]),c=c.left;else if(l<0)a.push([-1,c]),c=c.right;else if(o.hasNext())o.next(),a.push([0,c]),c=c.mid;else{for(n?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;a.length>0&&c.isEmpty();){let[d,w]=a.pop();switch(d){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}c=w}break}}}findSubstr(i){const n=this._iter.reset(i);let o=this._root,a;for(;o;){const c=n.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(n.hasNext())n.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const a=n.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[n,o]of this)i(o,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=E;class C{constructor(i,n){this[A]="ResourceMap",i instanceof C?(this.map=new Map(i.map),this.toKey=n!=null?n:C.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:C.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),n),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[o,a]of this.map)i(a,p.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield p.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[p.URI.parse(i[0]),i[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[p.URI.parse(i[0]),i[1]]}}e.ResourceMap=C,C.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class f{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,n=0){const o=this._map.get(i);if(!!o)return n!==0&&this.touch(o,n),o.value}set(i,n,o=0){let a=this._map.get(i);if(a)a.value=n,o!==0&&this.touch(a,o);else{switch(a={key:i,value:n,next:void 0,previous:void 0},o){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,n){const o=this._state;let a=this._head;for(;a;){if(n?i.bind(n)(a.value,a.key,this):i(a.value,a.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,n=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.key,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return a}values(){const i=this,n=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.value,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return a}entries(){const i=this,n=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:[o.key,o.value],done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return a}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let n=this._head,o=this.size;for(;n&&o>i;)this._map.delete(n.key),n=n.next,o--;this._head=n,this._size=o,n&&(n.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,o=i.previous;if(!n||!o)throw new Error("Invalid list");n.previous=o,o.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const o=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(o.previous=a,a.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const o=i.next,a=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=a,a.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,o)=>{i.push([o,n])}),i}fromJSON(i){this.clear();for(const[n,o]of i)this.set(n,o)}}e.LinkedMap=f;class s extends f{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class r{constructor(i){U.set(this,void 0),lt(this,U,i,"f")}get size(){return je(this,U,"f").size}forEach(i,n){je(this,U,"f").forEach(i,n)}get(i){return je(this,U,"f").get(i)}has(i){return je(this,U,"f").has(i)}entries(){return je(this,U,"f").entries()}keys(){return je(this,U,"f").keys()}values(){return je(this,U,"f").values()}[(U=new WeakMap,Symbol.iterator)](){return je(this,U,"f").entries()}}e.ReadonlyMapView=r}),define(Z[88],ee([0,1,23,21,4]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(v){return JSON.stringify(v,T)}e.stringify=P;function U(v){let O=JSON.parse(v);return O=g(O),O}e.parse=U;function T(v,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,k.regExpFlags)(O)}:O}function g(v,O=0){if(!v||O>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return A.URI.revive(v);case 2:return new RegExp(v.source,v.flags)}if(v instanceof p.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let m=0;m<v.length;++m)v[m]=g(v[m],O+1);else for(const m in v)Object.hasOwnProperty.call(v,m)&&(v[m]=g(v[m],O+1))}return v}e.revive=g}),define(Z[16],ee([0,1,4,7]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.userData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}set(g,v,O){this._hosts[g]=v,this._ports[g]=O}setConnectionToken(g,v){this._connectionTokens[g]=v}rewrite(g){if(this._delegate)return this._delegate(g);const v=g.authority;let O=this._hosts[v];O&&O.indexOf(":")!==-1&&(O=`[${O}]`);const m=this._ports[v],y=this._connectionTokens[v];let b=`path=${encodeURIComponent(g.path)}`;return typeof y=="string"&&(b+=`&tkn=${encodeURIComponent(y)}`),p.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${O}:${m}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new P;class U{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(g,v,O){const m=this.toUri(g,v);return m.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(m):k.isNative&&(O||k.isPreferringBrowserCodeLoad)&&m.scheme===A.file?m.with({scheme:A.vscodeFileResource,authority:m.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(g,v){const O=this.toUri(g,v);return O.scheme===A.vscodeFileResource?O.with({scheme:A.file,authority:O.authority!==this.FALLBACK_AUTHORITY?O.authority:null,query:null,fragment:null}):O}toUri(g,v){return p.URI.isUri(g)?g:p.URI.parse(v.toUrl(g))}}e.FileAccess=new U}),define(Z[65],ee([0,1,37]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const k=new p.LRUCache(1e4);function A(v){return g(v,"NFC",k)}e.normalizeNFC=A;const P=new p.LRUCache(1e4);function U(v){return g(v,"NFD",P)}e.normalizeNFD=U;const T=/[^\u0000-\u0080]/;function g(v,O,m){if(!e.canNormalize||!v)return v;const y=m.get(v);if(y)return y;let b;return T.test(v)?b=v.normalize(O):b=v,m.set(v,b),b}e.removeAccents=function(){if(e.canNormalize){const v=/[\u0300-\u036f]/g;return function(O){return U(O).replace(v,"")}}else return function(v){return v}}()}),define(Z[12],ee([0,1,42,8,4,21,16,7]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(b){return(0,A.uriToFsPath)(b,!0)}e.originalFSPath=g;class v{constructor(u){this._ignorePathCasing=u}compare(u,S,E=!1){return u===S?0:(0,P.compare)(this.getComparisonKey(u,E),this.getComparisonKey(S,E))}isEqual(u,S,E=!1){return u===S?!0:!u||!S?!1:this.getComparisonKey(u,E)===this.getComparisonKey(S,E)}getComparisonKey(u,S=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,S,E=!1){if(u.scheme===S.scheme){if(u.scheme===U.Schemas.file)return p.isEqualOrParent(g(u),g(S),this._ignorePathCasing(u))&&u.query===S.query&&(E||u.fragment===S.fragment);if((0,e.isEqualAuthority)(u.authority,S.authority))return p.isEqualOrParent(u.path,S.path,this._ignorePathCasing(u),"/")&&u.query===S.query&&(E||u.fragment===S.fragment)}return!1}joinPath(u,...S){return A.URI.joinPath(u,...S)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return k.posix.basename(u.path)}extname(u){return k.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let S;return u.scheme===U.Schemas.file?S=A.URI.file(k.dirname(g(u))).path:(S=k.posix.dirname(u.path),u.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),S="/")),u.with({path:S})}normalizePath(u){if(!u.path.length)return u;let S;return u.scheme===U.Schemas.file?S=A.URI.file(k.normalize(g(u))).path:S=k.posix.normalize(u.path),u.with({path:S})}relativePath(u,S){if(!(u.scheme!==S.scheme||!(0,e.isEqualAuthority)(u.authority,S.authority))){if(u.scheme===U.Schemas.file){const I=k.relative(g(u),g(S));return T.isWindows?p.toSlashes(I):I}let E=u.path||"/",C=S.path||"/";if(this._ignorePathCasing(u)){let I=0;for(const f=Math.min(E.length,C.length);I<f&&!(E.charCodeAt(I)!==C.charCodeAt(I)&&E.charAt(I).toLowerCase()!==C.charAt(I).toLowerCase());I++);E=C.substr(0,I)+E.substr(I)}return k.posix.relative(E,C)}}resolvePath(u,S){if(u.scheme===U.Schemas.file){const E=A.URI.file(k.resolve(g(u),S));return u.with({authority:E.authority,path:E.path})}return S.indexOf("/")===-1&&(S=p.toSlashes(S),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S)),u.with({path:k.posix.resolve(u.path,S)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,S){return u===S||(0,P.equalsIgnoreCase)(u,S)}hasTrailingPathSeparator(u,S=k.sep){if(u.scheme===U.Schemas.file){const E=g(u);return E.length>p.getRoot(E).length&&E[E.length-1]===S}else{const E=u.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,S=k.sep){return(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,S=k.sep){let E=!1;if(u.scheme===U.Schemas.file){const C=g(u);E=C!==void 0&&C.length===p.getRoot(C).length&&C[C.length-1]===S}else{S="/";const C=u.path;E=C.length===1&&C.charCodeAt(C.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path+"/"}):u}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(b=>b.scheme===U.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new v(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(b,u){const S=[];for(let E=0;E<b.length;E++){const C=u(b[E]);b.some((I,f)=>f===E?!1:(0,e.isEqualOrParent)(C,u(I)))||S.push(b[E])}return S}e.distinctParents=O;var m;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function u(S){const E=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(f=>{const[s,r]=f.split(":");s&&r&&E.set(s,r)});const I=S.path.substring(0,S.path.indexOf(";"));return I&&E.set(b.META_DATA_MIME,I),E}b.parseMetaData=u})(m=e.DataUri||(e.DataUri={}));function y(b,u,S){if(u){let E=b.path;return E&&E[0]!==k.posix.sep&&(E=k.posix.sep+E),b.with({scheme:S,authority:u,path:E})}return b.with({scheme:S})}e.toLocalResource=y}),define(Z[6],ee([0,1,30,11,3,2,64,12]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(z){return!!z&&typeof z.then=="function"}e.isThenable=g;function v(z){const D=new p.CancellationTokenSource,L=z(D.token),F=new Promise((N,x)=>{D.token.onCancellationRequested(()=>{x((0,k.canceled)())}),Promise.resolve(L).then(G=>{D.dispose(),N(G)},G=>{D.dispose(),x(G)})});return new class{cancel(){D.cancel()}then(N,x){return F.then(N,x)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=v;function O(z,D,L){return Promise.race([z,new Promise(F=>D.onCancellationRequested(()=>F(L)))])}e.raceCancellation=O;async function m(z){let D=-1;const L=z.map((N,x)=>N.then(G=>(D=x,G))),F=await Promise.race(L);return z.forEach((N,x)=>{x!==D&&N.cancel()}),F}e.raceCancellablePromises=m;function y(z,D,L){let F;const N=setTimeout(()=>{F==null||F(void 0),L==null||L()},D);return Promise.race([z.finally(()=>clearTimeout(N)),new Promise(x=>F=x)])}e.raceTimeout=y;function b(z){return new Promise((D,L)=>{const F=z();g(F)?F.then(D,L):D(F)})}e.asPromise=b;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const L=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(L,L).then(F)})}return new Promise((L,F)=>{this.queuedPromise.then(L,F)})}return this.activePromise=D(),new Promise((L,F)=>{this.activePromise.then(N=>{this.activePromise=null,L(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=u;class S{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=S;class E{constructor(){this.promiseMap=new Map}queue(D,L){var F;const x=((F=this.promiseMap.get(D))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(L).finally(()=>{this.promiseMap.get(D)===x&&this.promiseMap.delete(D)});return this.promiseMap.set(D,x),x}}e.SequencerByKey=E;class C{constructor(D){this.defaultDelay=D,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,L=this.defaultDelay){return this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},L),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=C;class I{constructor(D){this.delayer=new C(D),this.throttler=new u}trigger(D,L){return this.delayer.trigger(()=>this.throttler.queue(D),L)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class f{constructor(){this._isOpen=!1,this._promise=new Promise((D,L)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class s extends f{constructor(D){super();this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function r(z,D){return D?new Promise((L,F)=>{const N=setTimeout(L,z);D.onCancellationRequested(()=>{clearTimeout(N),F((0,k.canceled)())})}):v(L=>r(z,L))}e.timeout=r;function t(z,D=0){const L=setTimeout(z,D);return(0,P.toDisposable)(()=>clearTimeout(L))}e.disposableTimeout=t;function i(z){return z.then(void 0,D=>{})}e.ignoreErrors=i;function n(z){const D=[];let L=0;const F=z.length;function N(){return L<F?z[L++]():null}function x(G){G!=null&&D.push(G);const J=N();return J?J.then(x):Promise.resolve(D)}return Promise.resolve(null).then(x)}e.sequence=n;function o(z,D=F=>!!F,L=null){let F=0;const N=z.length,x=()=>{if(F>=N)return Promise.resolve(L);const G=z[F++];return Promise.resolve(G()).then(Q=>D(Q)?Promise.resolve(Q):x())};return x()}e.first=o;function a(z,D=F=>!!F,L=null){if(z.length===0)return Promise.resolve(L);let F=z.length;const N=()=>{var x,G;F=-1;for(const J of z)(G=(x=J).cancel)===null||G===void 0||G.call(x)};return new Promise((x,G)=>{for(const J of z)J.then(Q=>{--F>=0&&D(Q)?(N(),x(Q)):F===0&&x(L)}).catch(Q=>{--F>=0&&(N(),G(Q))})})}e.firstParallel=a;class c{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(D){return this._size++,new Promise((L,F)=>{this.outstandingPromises.push({factory:D,c:L,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const L=D.factory();L.then(D.c,D.e),L.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class l extends c{constructor(){super(1)}}e.Queue=l;class d{constructor(){this.queues=new Map}queueFor(D,L=T.extUri){const F=L.getComparisonKey(D);let N=this.queues.get(F);return N||(N=new l,A.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(F)}),this.queues.set(F,N)),N}dispose(){this.queues.forEach(D=>D.dispose()),this.queues.clear()}}e.ResourceQueue=d;class w{constructor(D,L){this._token=-1,typeof D=="function"&&typeof L=="number"&&this.setIfNotSet(D,L)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,L){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},L)}setIfNotSet(D,L){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},L))}}e.TimeoutTimer=w;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,L){this.cancel(),this._token=setInterval(()=>{D()},L)}}e.IntervalTimer=h;class R{constructor(D,L){this.timeoutToken=-1,this.runner=D,this.timeout=L,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class _ extends R{constructor(D,L){super(D,L);this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner&&this.runner(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=D=>{const L=setTimeout(()=>D(z));let F=!1;return{dispose(){F||(F=!0,clearTimeout(L))}}}}else e.runWhenIdle=(z,D)=>{const L=requestIdleCallback(z,typeof D=="number"?{timeout:D}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(L))}}}}();class j{constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(L){this._error=L}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function B(z,D,L){let F;for(let N=0;N<L;N++)try{return await z()}catch(x){F=x,await r(D)}throw F}e.retry=B;class M{hasPending(D){return this._pending?typeof D=="number"?this._pending.taskId===D:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var D;(D=this._pending)===null||D===void 0||D.cancel()}setPending(D,L,F){return this._pending={taskId:D,cancel:()=>F==null?void 0:F(),promise:L},L.then(()=>this.donePending(D),()=>this.donePending(D)),L}donePending(D){this._pending&&D===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const D=this._next;this._next=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this._next)this._next.run=D;else{let L,F;const N=new Promise((x,G)=>{L=x,F=G});this._next={run:D,promise:N,promiseResolve:L,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=M;class ${constructor(D){this.interval=D,this.lastIncrementTime=0,this.value=0}increment(){const D=Date.now();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((D,L)=>{this.completeCallback=D,this.errorCallback=L})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(D){return new Promise(L=>{this.completeCallback(D),this.resolved=!0,L()})}error(D){return new Promise(L=>{this.errorCallback(D),this.rejected=!0,L()})}cancel(){new Promise(D=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,D()})}}e.DeferredPromise=V;class q extends A.Emitter{async fireAsync(D,L,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,D]);for(;this._asyncDeliveryQueue.size>0&&!L.isCancellationRequested;){const[N,x]=this._asyncDeliveryQueue.shift(),G=[],J=Object.assign(Object.assign({},x),{waitUntil:Q=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");F&&(Q=F(Q,typeof N=="function"?N:N[0])),G.push(Q)}});try{typeof N=="function"?N.call(void 0,J):N[0].call(N[1],J)}catch(Q){(0,k.onUnexpectedError)(Q);continue}Object.freeze(G),await H.settled(G).catch(Q=>(0,k.onUnexpectedError)(Q))}}}}e.AsyncEmitter=q;var H;(function(z){async function D(x){return typeof Promise.allSettled=="function"?L(x):F(x)}z.allSettled=D;async function L(x){return Promise.allSettled(x)}async function F(x){return Promise.all(x.map(G=>G.then(J=>({status:"fulfilled",value:J}),J=>({status:"rejected",reason:J}))))}async function N(x){let G;const J=await Promise.all(x.map(Q=>Q.then(ne=>ne,ne=>{G||(G=ne)})));if(typeof G!="undefined")throw G;return J}z.settled=N})(H=e.Promises||(e.Promises={}))}),define(Z[89],ee([0,1,21,42,8,37,6]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T;const g="**",v="/",O="[/\\\\]",m="[^/\\\\]",y=/\//g;function b(L){switch(L){case 0:return"";case 1:return`${m}*?`;default:return`(?:${O}|${m}+${O}|${O}${m}+)*?`}}function u(L,F){if(!L)return[];const N=[];let x=!1,G=!1,J="";for(const Q of L){switch(Q){case F:if(!x&&!G){N.push(J),J="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":G=!0;break;case"]":G=!1;break}J+=Q}return J&&N.push(J),N}e.splitGlobAware=u;function S(L){if(!L)return"";let F="";const N=u(L,v);if(N.every(x=>x===g))F=".*";else{let x=!1;N.forEach((G,J)=>{if(G===g){x||(F+=b(2),x=!0);return}let Q=!1,ne="",ie=!1,ce="";for(const ue of G){if(ue!=="}"&&Q){ne+=ue;continue}if(ie&&(ue!=="]"||!ce)){let ge;ue==="-"?ge=ue:(ue==="^"||ue==="!")&&!ce?ge="^":ue===v?ge="":ge=p.escapeRegExpCharacters(ue),ce+=ge;continue}switch(ue){case"{":Q=!0;continue;case"[":ie=!0;continue;case"}":F+=`(?:${u(ne,",").map(Ie=>S(Ie)).join("|")})`,Q=!1,ne="";break;case"]":F+="["+ce+"]",ie=!1,ce="";break;case"?":F+=m;continue;case"*":F+=b(1);continue;default:F+=p.escapeRegExpCharacters(ue)}}J<N.length-1&&(N[J+1]!==g||J+2<N.length)&&(F+=O),x=!1})}return F}const E=/^\*\*\/\*\.[\w\.-]+$/,C=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),i=function(){return!1},n=function(){return null};function o(L,F){if(!L)return n;let N;typeof L!="string"?N=L.pattern:N=L,N=N.trim();const x=`${N}_${!!F.trimForExclusions}`;let G=t.get(x);if(G)return a(G,L);let J;if(E.test(N)){const Q=N.substr(4);G=function(ne,ie){return typeof ne=="string"&&ne.endsWith(Q)?N:null}}else(J=C.exec(c(N,F)))?G=l(J[1],N):(F.trimForExclusions?f:I).test(N)?G=d(N,F):(J=s.exec(c(N,F)))?G=w(J[1].substr(1),N,!0):(J=r.exec(c(N,F)))?G=w(J[1],N,!1):G=h(N);return t.set(x,G),a(G,L)}function a(L,F){return typeof F=="string"?L:function(N,x){return k.isEqualOrParent(N,F.base)?L(A.relative(F.base,N),x):null}}function c(L,F){return F.trimForExclusions&&L.endsWith("/**")?L.substr(0,L.length-2):L}function l(L,F){const N=`/${L}`,x=`\\${L}`,G=function(Q,ne){return typeof Q!="string"?null:ne?ne===L?F:null:Q===L||Q.endsWith(N)||Q.endsWith(x)?F:null},J=[L];return G.basenames=J,G.patterns=[F],G.allBasenames=J,G}function d(L,F){const N=D(L.slice(1,-1).split(",").map(ne=>o(ne,F)).filter(ne=>ne!==n),L),x=N.length;if(!x)return n;if(x===1)return N[0];const G=function(ne,ie){for(let ce=0,ue=N.length;ce<ue;ce++)if(N[ce](ne,ie))return L;return null},J=N.find(ne=>!!ne.allBasenames);J&&(G.allBasenames=J.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(G.allPaths=Q),G}function w(L,F,N){const x=A.sep===A.posix.sep,G=x?L:L.replace(y,A.sep),J=A.sep+G,Q=A.posix.sep+L,ne=N?function(ie,ce){return typeof ie=="string"&&(ie===G||ie.endsWith(J)||!x&&(ie===L||ie.endsWith(Q)))?F:null}:function(ie,ce){return typeof ie=="string"&&(ie===G||!x&&ie===L)?F:null};return ne.allPaths=[(N?"*/":"./")+L],ne}function h(L){try{const F=new RegExp(`^${S(L)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?L:null}}catch(F){return n}}function R(L,F,N){return!L||typeof F!="string"?!1:_(L)(F,void 0,N)}e.match=R;function _(L,F={}){if(!L)return i;if(typeof L=="string"||$(L)){const N=o(L,F);if(N===n)return i;const x=function(G,J){return!!N(G,J)};return N.allBasenames&&(x.allBasenames=N.allBasenames),N.allPaths&&(x.allPaths=N.allPaths),x}return H(L,F)}e.parse=_;function j(L){if(!!L){let F;return N=>(F||(F=(L()||Promise.resolve([])).then(x=>x?M(x):{})),F.then(x=>!!x[N]))}}e.hasSiblingPromiseFn=j;function B(L){if(!!L){let F;return N=>{if(!F){const x=L();F=x?M(x):{}}return!!F[N]}}}e.hasSiblingFn=B;function M(L){const F={};for(const N of L)F[N]=!0;return F}function $(L){const F=L;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=$;function V(L){return L.allBasenames||[]}e.getBasenameTerms=V;function q(L){return L.allPaths||[]}e.getPathTerms=q;function H(L,F){const N=D(Object.getOwnPropertyNames(L).map(ne=>z(ne,L[ne],F)).filter(ne=>ne!==n)),x=N.length;if(!x)return n;if(!N.some(ne=>!!ne.requiresSiblings)){if(x===1)return N[0];const ne=function(ue,ge){for(let Ee=0,Ie=N.length;Ee<Ie;Ee++){const Te=N[Ee](ue,ge);if(Te)return Te}return null},ie=N.find(ue=>!!ue.allBasenames);ie&&(ne.allBasenames=ie.allBasenames);const ce=N.reduce((ue,ge)=>ge.allPaths?ue.concat(ge.allPaths):ue,[]);return ce.length&&(ne.allPaths=ce),ne}const G=function(ne,ie,ce){let ue;for(let ge=0,Ee=N.length;ge<Ee;ge++){const Ie=N[ge];Ie.requiresSiblings&&ce&&(ie||(ie=A.basename(ne)),ue||(ue=ie.substr(0,ie.length-A.extname(ne).length)));const Te=Ie(ne,ie,ue,ce);if(Te)return Te}return null},J=N.find(ne=>!!ne.allBasenames);J&&(G.allBasenames=J.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(G.allPaths=Q),G}function z(L,F,N){if(F===!1)return n;const x=o(L,N);if(x===n)return n;if(typeof F=="boolean")return x;if(F){const G=F.when;if(typeof G=="string"){const J=(Q,ne,ie,ce)=>{if(!ce||!x(Q,ne))return null;const ue=G.replace("$(basename)",ie),ge=ce(ue);return(0,U.isThenable)(ge)?ge.then(Ee=>Ee?L:null):ge?L:null};return J.requiresSiblings=!0,J}}return x}function D(L,F){const N=L.filter(ne=>!!ne.basenames);if(N.length<2)return L;const x=N.reduce((ne,ie)=>{const ce=ie.basenames;return ce?ne.concat(ce):ne},[]);let G;if(F){G=[];for(let ne=0,ie=x.length;ne<ie;ne++)G.push(F)}else G=N.reduce((ne,ie)=>{const ce=ie.patterns;return ce?ne.concat(ce):ne},[]);const J=function(ne,ie){if(typeof ne!="string")return null;if(!ie){let ue;for(ue=ne.length;ue>0;ue--){const ge=ne.charCodeAt(ue-1);if(ge===47||ge===92)break}ie=ne.substr(ue)}const ce=x.indexOf(ie);return ce!==-1?G[ce]:null};J.basenames=x,J.patterns=G,J.allBasenames=x;const Q=L.filter(ne=>!ne.basenames);return Q.push(J),Q}}),define(Z[90],ee([0,1,4]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(O){return O.toJSON()}class A{constructor(m){this._uriTransformer=m}transformIncoming(m){const y=this._uriTransformer.transformIncoming(m);return y===m?m:k(p.URI.from(y))}transformOutgoing(m){const y=this._uriTransformer.transformOutgoing(m);return y===m?m:k(p.URI.from(y))}transformOutgoingURI(m){const y=this._uriTransformer.transformOutgoing(m);return y===m?m:p.URI.from(y)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function P(O,m,y){if(!O||y>200)return null;if(typeof O=="object"){if(O instanceof p.URI)return m.transformOutgoing(O);for(let b in O)if(Object.hasOwnProperty.call(O,b)){const u=P(O[b],m,y+1);u!==null&&(O[b]=u)}}return null}function U(O,m){const y=P(O,m,0);return y===null?O:y}e.transformOutgoingURIs=U;function T(O,m,y,b){if(!O||b>200)return null;if(typeof O=="object"){if(O.$mid===1)return y?p.URI.revive(m.transformIncoming(O)):m.transformIncoming(O);for(let u in O)if(Object.hasOwnProperty.call(O,u)){const S=T(O[u],m,y,b+1);S!==null&&(O[u]=S)}}return null}function g(O,m){const y=T(O,m,!1,0);return y===null?O:y}e.transformIncomingURIs=g;function v(O,m){const y=T(O,m,!0,0);return y===null?O:y}e.transformAndReviveIncomingURIs=v}),define(Z[31],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(g){return p.test(g)}e.isUUID=k;const A=new Uint8Array(16),P=[];for(let g=0;g<256;g++)P.push(g.toString(16).padStart(2,"0"));let U;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?U=crypto.getRandomValues.bind(crypto):U=function(g){for(let v=0;v<g.length;v++)g[v]=Math.floor(Math.random()*256);return g};function T(){U(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let g=0,v="";return v+=P[A[g++]],v+=P[A[g++]],v+=P[A[g++]],v+=P[A[g++]],v+="-",v+=P[A[g++]],v+=P[A[g++]],v+="-",v+=P[A[g++]],v+=P[A[g++]],v+="-",v+=P[A[g++]],v+=P[A[g++]],v+="-",v+=P[A[g++]],v+=P[A[g++]],v+=P[A[g++]],v+=P[A[g++]],v+=P[A[g++]],v+=P[A[g++]],v}e.generateUuid=T}),define(Z[66],ee([0,1,199]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(P="utf8"){this.stringDecoder=new p.StringDecoder(P),this.remaining=null}write(P){const U=[],T=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(T.length<1)return U;let g=0,v,O=g;for(;O<T.length;)if(v=T.charCodeAt(O),v===13||v===10){if(U.push(T.substring(g,O)),O++,O<T.length){const m=v;v=T.charCodeAt(O),(m===13&&v===10||m===10&&v===13)&&O++}g=O}else O++;return this.remaining=g<T.length?T.substr(g):null,U}end(){return this.remaining}}e.LineDecoder=k}),define(Z[91],ee([0,1,38]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(T){const g=T.replace(/\-/g,":").toLowerCase();return!k.has(g)}function P(){return new Promise(async(T,g)=>{const v=setTimeout(()=>g("Unable to retrieve mac address (timeout after 10s)"),1e4);try{T(await U())}catch(O){g(O)}finally{clearTimeout(v)}})}e.getMac=P;function U(){return new Promise((T,g)=>{try{const v=(0,p.networkInterfaces)();for(let O in v){const m=v[O];if(m){for(const{mac:y}of m)if(A(y))return T(y)}}g("Unable to retrieve mac address (unexpected format)")}catch(v){g(v)}})}}),define(Z[92],ee([0,1,11,31,38,37,91]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(O){return this._virtualMachineOUIs||(this._virtualMachineOUIs=P.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(O)}value(){if(this._value===void 0){let O=0,m=0;const y=(0,A.networkInterfaces)();for(let b in y){const u=y[b];if(u)for(const{mac:S,internal:E}of u)E||(m+=1,this._isVirtualMachineMacAdress(S.toUpperCase())&&(O+=1))}this._value=m>0?O/m:0}return this._value}};let T;async function g(){return T||(T=(async()=>await v()||k.generateUuid())()),T}e.getMachineId=g;async function v(){try{const O=await new Promise((y,b)=>{K(["crypto"],y,b)}),m=await(0,U.getMac)();return O.createHash("sha256").update(m,"utf8").digest("hex")}catch(O){p.onUnexpectedError(O);return}}}),define(Z[24],ee([0,1,27,38,8,6,7,42,31,65,12,4]),function(K,e,p,k,A,P,U,T,g,v,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var y;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function b(V,q=y.UNLINK){if((0,T.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return q===y.UNLINK?S(V):u(V)}e.rimraf=b;async function u(V){try{const q=(0,A.join)((0,k.tmpdir)(),(0,g.generateUuid)());try{await p.promises.rename(V,q)}catch(H){return S(V)}S(q).catch(H=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function S(V){return p.promises.rmdir(V,{recursive:!0,maxRetries:3})}function E(V){if((0,T.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(V,{recursive:!0})}e.rimrafSync=E;async function C(V,q){return s(await(q?I(V):p.promises.readdir(V)))}e.readdir=C;async function I(V){try{return await p.promises.readdir(V,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const q=[],H=await C(V);for(const z of H){let D=!1,L=!1,F=!1;try{const N=await p.promises.lstat((0,A.join)(V,z));D=N.isFile(),L=N.isDirectory(),F=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}q.push({name:z,isFile:()=>D,isDirectory:()=>L,isSymbolicLink:()=>F})}return q}function f(V){return s(p.readdirSync(V))}e.readdirSync=f;function s(V){return V.map(q=>typeof q=="string"?U.isMacintosh?(0,v.normalizeNFC)(q):q:(q.name=U.isMacintosh?(0,v.normalizeNFC)(q.name):q.name,q))}async function r(V){const q=await C(V),H=[];for(const z of q)await i.existsDirectory((0,A.join)(V,z))&&H.push(z);return H}e.readDirsInDir=r;function t(V,q=1e3){return new Promise(H=>{let z=!1;const D=setInterval(()=>{z||(z=!0,p.access(V,L=>{z=!1,L&&(clearInterval(D),H(void 0))}))},q)})}e.whenDeleted=t;var i;(function(V){async function q(D){let L;try{if(L=await p.promises.lstat(D),!L.isSymbolicLink())return{stat:L}}catch(F){}try{return{stat:await p.promises.stat(D),symbolicLink:(L==null?void 0:L.isSymbolicLink())?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(U.isWindows&&F.code==="EACCES")try{return{stat:await p.promises.stat(await p.promises.readlink(D)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw N}throw F}}V.stat=q;async function H(D){try{const{stat:L,symbolicLink:F}=await V.stat(D);return L.isFile()&&(F==null?void 0:F.dangling)!==!0}catch(L){}return!1}V.existsFile=H;async function z(D){try{const{stat:L,symbolicLink:F}=await V.stat(D);return L.isDirectory()&&(F==null?void 0:F.dangling)!==!0}catch(L){}return!1}V.existsDirectory=z})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new P.ResourceQueue;function o(V,q,H){return n.queueFor(m.URI.file(V),O.extUriBiasedIgnorePathCase).queue(()=>{const z=d(H);return new Promise((D,L)=>c(V,q,z,F=>F?L(F):D()))})}e.writeFile=o;let a=!0;function c(V,q,H,z){if(!a)return p.writeFile(V,q,{mode:H.mode,flag:H.flag},z);p.open(V,H.flag,H.mode,(D,L)=>{if(D)return z(D);p.writeFile(L,q,F=>{if(F)return p.close(L,()=>z(F));p.fdatasync(L,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),a=!1),p.close(L,x=>z(x))))})})}function l(V,q,H){const z=d(H);if(!a)return p.writeFileSync(V,q,{mode:z.mode,flag:z.flag});const D=p.openSync(V,z.flag,z.mode);try{p.writeFileSync(D,q);try{p.fdatasyncSync(D)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),a=!1}}finally{p.closeSync(D)}}e.writeFileSync=l;function d(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function w(V,q){if(V!==q){async function H(z){try{const D=await p.promises.lstat(z);if(D.isDirectory()||D.isSymbolicLink())return;const L=await p.promises.open(z,"a");try{await L.utimes(D.atime,new Date)}finally{await L.close()}}catch(D){}}try{await p.promises.rename(V,q),await H(q)}catch(z){if(V.toLowerCase()!==q.toLowerCase()&&z.code==="EXDEV"||V.endsWith("."))await h(V,q,{preserveSymlinks:!1}),await b(V,y.MOVE),await H(q);else throw z}}}e.move=w;async function h(V,q,H){return _(V,q,{root:{source:V,target:q},options:H,handledSourcePaths:new Set})}e.copy=h;const R=511;async function _(V,q,H){if(!H.handledSourcePaths.has(V)){H.handledSourcePaths.add(V);const{stat:z,symbolicLink:D}=await i.stat(V);if(D){if(H.options.preserveSymlinks)try{return await M(V,q,H)}catch(L){console.warn("[node.js fs] copy of symlink failed: ",L)}if(D.dangling)return}return z.isDirectory()?j(V,q,z.mode&R,H):B(V,q,z.mode&R)}}async function j(V,q,H,z){await p.promises.mkdir(q,{recursive:!0,mode:H});const D=await C(V);for(const L of D)await _((0,A.join)(V,L),(0,A.join)(q,L),z)}async function B(V,q,H){await p.promises.copyFile(V,q),await p.promises.chmod(q,H)}async function M(V,q,H){let z=await p.promises.readlink(V);(0,T.isEqualOrParent)(z,H.root.source,!U.isLinux)&&(z=(0,A.join)(H.root.target,z.substr(H.root.source.length+1))),await p.promises.symlink(z,q)}async function $(V){try{return await p.promises.access(V),!0}catch(q){return!1}}e.exists=$}),define(Z[93],ee([0,1,27,94,21,8,24]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(m){const y=(0,P.dirname)(m);if(m===y)return m;const b=((0,P.basename)(m)||m).toLowerCase();try{const S=(0,U.readdirSync)(y).filter(E=>E.toLowerCase()===b);if(S.length===1){const E=T(y);if(E)return(0,P.join)(E,S[0])}else if(S.length>1){const E=S.indexOf(b);if(E>=0){const C=T(y);if(C)return(0,P.join)(C,S[E])}}}catch(u){}return null}e.realcaseSync=T;async function g(m){try{return await(0,k.promisify)(p.realpath)(m)}catch(y){const b=O(m);return await p.promises.access(b,p.constants.R_OK),b}}e.realpath=g;function v(m){try{return p.realpathSync(m)}catch(y){const b=O(m);return p.accessSync(b,p.constants.R_OK),b}}e.realpathSync=v;function O(m){return(0,A.rtrim)((0,P.normalize)(m),P.sep)}}),define(Z[95],ee([0,1,48,16]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(U){return new Promise((T,g)=>{let v;const O=new Map;function m(u,S,E,C,I){const f=O.get(S);if(u===U||f){const s={name:y(E),cmd:E,pid:u,ppid:S,load:C,mem:I};O.set(u,s),u===U&&(v=s),f&&(f.children||(f.children=[]),f.children.push(s),f.children.length>1&&(f.children=f.children.sort((r,t)=>r.pid-t.pid)))}}function y(u){const S=/--disable-blink-features=Auxclick/,E=/\\watcher\\win32\\CodeHelper\.exe/,C=/--crashes-directory/,I=/\\pipe\\winpty-control/,f=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(E.exec(u))return"watcherService ";if(C.exec(u))return"electron-crash-reporter";if(I.exec(u))return"winpty-process";if(f.exec(u))return"console-window-host (Windows internal process)";let r=s.exec(u);if(r&&r.length===2)return r[1]==="renderer"?S.exec(u)?"shared-process":"window":r[1];const t=/[a-zA-Z-]+\.js/g;let i="";do r=t.exec(u),r&&(i+=r+" ");while(r);return i&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron_node ${i}`:u}if(process.platform==="win32"){const u=S=>S.indexOf("\\\\?\\")===0||S.indexOf("\\??\\")===0?S.substr(4):S.indexOf('"\\\\?\\')===0||S.indexOf('"\\??\\')===0?'"'+S.substr(5):S;new Promise((S,E)=>{K(["windows-process-tree"],S,E)}).then(S=>{S.getProcessList(U,E=>{S.getProcessCpuUsage(E,C=>{const I=new Map;C.forEach(f=>{const s=u(f.commandLine||"");I.set(f.pid,{name:y(s),cmd:s,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),v=I.get(U),v?(I.forEach(f=>{const s=I.get(f.ppid);s&&(s.children||(s.children=[]),s.children.push(f))}),I.forEach(f=>{f.children&&(f.children=f.children.sort((s,r)=>s.pid-r.pid))}),T(v)):g(new Error(`Root process ${U} not found`))})},S.ProcessDataFlag.CommandLine|S.ProcessDataFlag.Memory)})}else{function b(){let u=[v];const S=[];for(;u.length;){const C=u.shift();C&&(S.push(C.pid),C.children&&(u=u.concat(C.children)))}let E=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);E+=" "+S.join(" "),(0,p.exec)(E,{},(C,I,f)=>{if(C||f)g(C||new Error(f.toString()));else{const s=I.toString().split(`
`);for(let r=0;r<S.length;r++){const t=O.get(S[r]);t.load=parseFloat(s[r])}if(!v){g(new Error(`Root process ${U} not found`));return}T(v)}})}(0,p.exec)("which ps",{},(u,S,E)=>{if(u||E)if(process.platform!=="linux")g(u||new Error(E.toString()));else{const C=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,p.exec)(C,{},(I,f,s)=>{I||s?g(I||new Error(s.toString())):(P(f,m),b())})}else{const C=S.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${C} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,s,r)=>{f||r&&!r.includes("screen size is bogus")?g(f||new Error(r.toString())):(P(s,m),process.platform==="linux"?b():v?T(v):g(new Error(`Root process ${U} not found`)))})}})}})}e.listProcesses=A;function P(U,T){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=U.toString().split(`
`);for(const O of v){const m=g.exec(O.trim());m&&m.length===6&&T(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(Z[96],ee([0,1,8,27,7,65,2,24]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function g(m,y,b){return O({path:m,isDirectory:!1},y,b)}e.watchFile=g;function v(m,y,b){return O({path:m,isDirectory:!0},y,b)}e.watchFolder=v,e.CHANGE_BUFFER_DELAY=100;function O(m,y,b){const u=(0,p.basename)(m.path),S=new Map;let E=!1,C=[(0,U.toDisposable)(()=>{S.forEach(I=>(0,U.dispose)(I)),S.clear()})];try{const I=(0,k.watch)(m.path);C.push((0,U.toDisposable)(()=>{I.removeAllListeners(),I.close()}));const f=new Set;m.isDirectory&&(0,T.readdir)(m.path).then(s=>s.forEach(r=>f.add(r))),I.on("error",(s,r)=>{E||b(`Failed to watch ${m.path} for changes using fs.watch() (${s}, ${r})`)}),I.on("change",(s,r)=>{if(!E){let t="";if(r&&(t=r.toString(),A.isMacintosh&&(t=(0,P.normalizeNFC)(t))),!(!t||s!=="change"&&s!=="rename")){const i=m.isDirectory?(0,p.join)(m.path,t):m.path;if(m.isDirectory)if(s==="rename"){const n=S.get(i);n&&(0,U.dispose)(n);const o=setTimeout(async()=>{S.delete(i);const a=await(0,T.exists)(i);if(!E){let c;a?f.has(t)?c="changed":(c="added",f.add(t)):(f.delete(t),c="deleted"),y(c,i)}},e.CHANGE_BUFFER_DELAY);S.set(i,(0,U.toDisposable)(()=>clearTimeout(o)))}else{let n;f.has(t)?n="changed":(n="added",f.add(t)),y(n,i)}else if(s==="rename"||t!==u){const n=setTimeout(async()=>{const o=await(0,T.exists)(i);E||(o?(y("changed",i),C=[O(m,y,b)]):y("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,U.dispose)(C),C=[(0,U.toDisposable)(()=>clearTimeout(n))]}else y("changed",i)}}})}catch(I){(0,T.exists)(m.path).then(f=>{f&&!E&&b(`Failed to watch ${m.path} for changes using fs.watch() (${I.toString()})`)})}return(0,U.toDisposable)(()=>{E=!0,C=(0,U.dispose)(C)})}}),define(Z[34],ee([0,1,3,2,6,30,11,23,18,15,88,21]),function(K,e,p,k,A,P,U,T,g,v,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function b(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(u=e.ResponseType||(e.ResponseType={}));function S(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(E||(E={}));class C{constructor(D){this.buffer=D,this.pos=0}read(D){const L=this.buffer.slice(this.pos,this.pos+D);return this.pos+=L.byteLength,L}}class I{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var f;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(f||(f={}));function s(z){const D=T.VSBuffer.alloc(4);return D.writeUInt32BE(z,0),D}function r(z){return z.read(4).readUInt32BE(0)}function t(z){const D=T.VSBuffer.alloc(1);return D.writeUInt8(z,0),D}const i={Undefined:t(f.Undefined),String:t(f.String),Buffer:t(f.Buffer),VSBuffer:t(f.VSBuffer),Array:t(f.Array),Object:t(f.Object)},n=typeof Buffer!="undefined";function o(z,D){if(typeof D=="undefined")z.write(i.Undefined);else if(typeof D=="string"){const L=T.VSBuffer.fromString(D);z.write(i.String),z.write(s(L.byteLength)),z.write(L)}else if(n&&Buffer.isBuffer(D)){const L=T.VSBuffer.wrap(D);z.write(i.Buffer),z.write(s(L.byteLength)),z.write(L)}else if(D instanceof T.VSBuffer)z.write(i.VSBuffer),z.write(s(D.byteLength)),z.write(D);else if(Array.isArray(D)){z.write(i.Array),z.write(s(D.length));for(const L of D)o(z,L)}else{const L=T.VSBuffer.fromString(JSON.stringify(D));z.write(i.Object),z.write(s(L.byteLength)),z.write(L)}}function a(z){switch(z.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return z.read(r(z)).toString();case f.Buffer:return z.read(r(z)).buffer;case f.VSBuffer:return z.read(r(z));case f.Array:{const L=r(z),F=[];for(let N=0;N<L;N++)F.push(a(z));return F}case f.Object:return JSON.parse(z.read(r(z)).toString())}}class c{constructor(D,L,F=null,N=1e3){this.protocol=D,this.ctx=L,this.logger=F,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(x=>this.onRawMessage(x)),this.sendResponse({type:200})}registerChannel(D,L){this.channels.set(D,L),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const L=this.send([D.type]);this.logger&&this.logger.logOutgoing(L,0,1,S(D.type));return}case 201:case 202:case 204:case 203:{const L=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(L,D.id,1,S(D.type),D.data);return}}}send(D,L=void 0){const F=new I;return o(F,D),o(F,L),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(L){return 0}}onRawMessage(D){const L=new C(D),F=a(L),N=a(L),x=F[0];switch(x){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(x)}: ${F[2]}.${F[3]}`,N),this.onPromise({type:x,id:F[1],channelName:F[2],name:F[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(x)}: ${F[2]}.${F[3]}`,N),this.onEventListen({type:x,id:F[1],channelName:F[2],name:F[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(x)}`),this.disposeActiveRequest({type:x,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(x)}`),this.disposeActiveRequest({type:x,id:F[1]})}}onPromise(D){const L=this.channels.get(D.channelName);if(!L){this.collectPendingRequest(D);return}const F=new P.CancellationTokenSource;let N;try{N=L.call(this.ctx,D.name,D.arg,F.token)}catch(J){N=Promise.reject(J)}const x=D.id;N.then(J=>{this.sendResponse({id:x,data:J,type:201}),this.activeRequests.delete(D.id)},J=>{J instanceof Error?this.sendResponse({id:x,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:x,data:J,type:203}),this.activeRequests.delete(D.id)});const G=(0,k.toDisposable)(()=>F.cancel());this.activeRequests.set(D.id,G)}onEventListen(D){const L=this.channels.get(D.channelName);if(!L){this.collectPendingRequest(D);return}const F=D.id,x=L.listen(this.ctx,D.name,D.arg)(G=>this.sendResponse({id:F,data:G,type:204}));this.activeRequests.set(D.id,x)}disposeActiveRequest(D){const L=this.activeRequests.get(D.id);L&&(L.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let L=this.pendingRequests.get(D.channelName);L||(L=[],this.pendingRequests.set(D.channelName,L));const F=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);L.push({request:D,timeoutTimer:F})}flushPendingRequests(D){const L=this.pendingRequests.get(D);if(L){for(const F of L)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var l;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(D,L=null){this.protocol=D,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=L}getChannel(D){const L=this;return{call(F,N,x){return L.isDisposed?Promise.reject(U.canceled()):L.requestPromise(D,F,N,x)},listen(F,N){return L.isDisposed?Promise.reject(U.canceled()):L.requestEvent(D,F,N)}}}requestPromise(D,L,F,N=P.CancellationToken.None){const x=this.lastRequestId++,J={id:x,type:100,channelName:D,name:L,arg:F};if(N.isCancellationRequested)return Promise.reject(U.canceled());let Q;return new Promise((ie,ce)=>{if(N.isCancellationRequested)return ce(U.canceled());const ue=()=>{const Te=Ae=>{switch(Ae.type){case 201:this.handlers.delete(x),ie(Ae.data);break;case 202:this.handlers.delete(x);const Ue=new Error(Ae.data.message);Ue.stack=Ae.data.stack,Ue.name=Ae.data.name,ce(Ue);break;case 203:this.handlers.delete(x),ce(Ae.data);break}};this.handlers.set(x,Te),this.sendRequest(J)};let ge=null;this.state===E.Idle?ue():(ge=(0,A.createCancelablePromise)(Te=>this.whenInitialized()),ge.then(()=>{ge=null,ue()}));const Ee=()=>{ge?(ge.cancel(),ge=null):this.sendRequest({id:x,type:101}),ce(U.canceled())},Ie=N.onCancellationRequested(Ee);Q=(0,k.combinedDisposable)((0,k.toDisposable)(Ee),Ie),this.activeRequests.add(Q)}).finally(()=>{this.activeRequests.delete(Q)})}requestEvent(D,L,F){const N=this.lastRequestId++,G={id:N,type:102,channelName:D,name:L,arg:F};let J=null;const Q=new p.Emitter({onFirstListenerAdd:()=>{J=(0,A.createCancelablePromise)(ie=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(Q),this.sendRequest(G)})},onLastListenerRemove:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(Q),this.sendRequest({id:N,type:103}))}}),ne=ie=>Q.fire(ie.data);return this.handlers.set(N,ne),Q.event}sendRequest(D){switch(D.type){case 100:case 102:{const L=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(L,D.id,0,`${b(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const L=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(L,D.id,0,b(D.type));return}}}send(D,L=void 0){const F=new I;return o(F,D),o(F,L),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(L){return 0}}onBuffer(D){const L=new C(D),F=a(L),N=a(L),x=F[0];switch(x){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,S(x)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],0,S(x),N),this.onResponse({type:F[0],id:F[1],data:N})}}onResponse(D){if(D.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const L=this.handlers.get(D.id);L&&L(D)}whenInitialized(){return this.state===E.Idle?Promise.resolve():p.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelClient=d;class w{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:L,onDidClientDisconnect:F})=>{p.Event.once(L.onMessage)(x=>{const G=new C(x),J=a(G),Q=new c(L,J),ne=new d(L);this.channels.forEach((ce,ue)=>Q.registerChannel(ue,ce));const ie={channelServer:Q,channelClient:ne,ctx:J};this._connections.add(ie),this._onDidAddConnection.fire(ie),F(()=>{Q.dispose(),ne.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const D=[];return this._connections.forEach(L=>D.push(L)),D}getChannel(D,L){const F=this;return{call(N,x,G){let J;if((0,v.isFunction)(L)){let ne=(0,g.getRandomElement)(F.connections.filter(L));J=ne?Promise.resolve(ne):p.Event.toPromise(p.Event.filter(F.onDidAddConnection,L))}else J=L.routeCall(F,N,x);const Q=J.then(ne=>ne.channelClient.getChannel(D));return R(Q).call(N,x,G)},listen(N,x){if((0,v.isFunction)(L))return F.getMulticastEvent(D,L,N,x);const G=L.routeEvent(F,N,x).then(J=>J.channelClient.getChannel(D));return R(G).listen(N,x)}}}getMulticastEvent(D,L,F,N){const x=this;let G=new k.DisposableStore;const J=new p.Emitter({onFirstListenerAdd:()=>{G=new k.DisposableStore;const Q=new p.EventMultiplexer,ne=new Map,ie=ue=>{const Ee=ue.channelClient.getChannel(D).listen(F,N),Ie=Q.add(Ee);ne.set(ue,Ie)},ce=ue=>{const ge=ne.get(ue);!ge||(ge.dispose(),ne.delete(ue))};x.connections.filter(L).forEach(ie),p.Event.filter(x.onDidAddConnection,L)(ie,void 0,G),x.onDidRemoveConnection(ce,void 0,G),Q.event(J.fire,J,G),G.add(Q)},onLastListenerRemove:()=>{G.dispose()}});return J.event}registerChannel(D,L){this.channels.set(D,L),this._connections.forEach(F=>{F.channelServer.registerChannel(D,L)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class h{constructor(D,L,F=null){const N=new I;o(N,L),D.send(N.buffer),this.channelClient=new d(D,F),this.channelServer=new c(D,L,F)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,L){this.channelServer.registerChannel(D,L)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=h;function R(z){return{call(D,L,F){return z.then(N=>N.call(D,L,F))},listen(D,L){const F=new p.Relay;return z.then(N=>F.input=N.listen(D,L)),F.event}}}e.getDelayedChannel=R;function _(z){let D=!1;return{call(L,F,N){return D?z.call(L,F,N):(0,A.timeout)(0).then(()=>D=!0).then(()=>z.call(L,F,N))},listen(L,F){if(D)return z.listen(L,F);const N=new p.Relay;return(0,A.timeout)(0).then(()=>D=!0).then(()=>N.input=z.listen(L,F)),N.event}}}e.getNextTickChannel=_;class j{constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const L of D.connections)if(await Promise.resolve(this.fn(L.ctx)))return Promise.resolve(L);return await p.Event.toPromise(D.onDidAddConnection),await this.route(D)}}e.StaticRouter=j;var B;(function(z){function D(N,x){const G=N,J=x&&x.disableMarshalling,Q=new Map;for(const ne in G)F(ne)&&Q.set(ne,p.Event.buffer(G[ne],!0));return new class{listen(ne,ie){const ce=Q.get(ie);if(ce)return ce;throw new Error(`Event not found: ${ie}`)}call(ne,ie,ce){const ue=G[ie];if(typeof ue=="function"){if(!J&&Array.isArray(ce))for(let ge=0;ge<ce.length;ge++)ce[ge]=(0,O.revive)(ce[ge]);return ue.apply(G,ce)}throw new Error(`Method not found: ${ie}`)}}}z.fromService=D;function L(N,x){const G=x&&x.disableMarshalling;return new Proxy({},{get(J,Q){var ne;if(typeof Q=="string")return((ne=x==null?void 0:x.properties)===null||ne===void 0?void 0:ne.has(Q))?x.properties.get(Q):F(Q)?N.listen(Q):async function(...ie){let ce;x&&!(0,v.isUndefinedOrNull)(x.context)?ce=[x.context,...ie]:ce=ie;const ue=await N.call(Q,ce);return G?ue:(0,O.revive)(ue)};throw new Error(`Property not found: ${String(Q)}`)}})}z.toService=L;function F(N){return N[0]==="o"&&N[1]==="n"&&m.isUpperAsciiLetter(N.charCodeAt(2))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let D=z.toString();if(D!=="[object Object]")return D}return z}function V(z){return Array.isArray(z)?z.map($):$(z)}function q(z,D,L,F,N,x,G){G=V(G);const J=M[N],Q=J[F%J.length];let ne=[`%c[${z}]%c[${String(D).padStart(7," ")}]%c[len: ${String(L).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(x)?(ne=ne.concat(G),ne.push(")")):ne.push(G),console.log.apply(console,ne)}e.logWithColors=q;class H{constructor(D,L){this._outgoingPrefix=D,this._incomingPrefix=L,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,L,F,N,x){this._totalOutgoing+=D,q(this._outgoingPrefix,this._totalOutgoing,D,L,F,N,x)}logIncoming(D,L,F,N,x){this._totalIncoming+=D,q(this._incomingPrefix,this._totalIncoming,D,L,F,N,x)}}e.IPCLogger=H}),define(Z[97],ee([0,1,3,34,23]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class P{constructor(g){this.port=g,this.onMessage=p.Event.fromDOMEventEmitter(this.port,"message",v=>A.VSBuffer.wrap(v.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=P;class U extends k.IPCClient{constructor(g,v){const O=new P(g);super(O,v);this.protocol=O}dispose(){this.protocol.disconnect()}}e.Client=U}),define(Z[98],ee([0,1,99,3,34,97]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class U extends A.IPCServer{static getOnDidClientConnect(){const g=k.Event.fromNodeEventEmitter(p.ipcRenderer,"vscode:createMessageChannel",(v,O)=>O);return k.Event.map(g,v=>{const{port1:O,port2:m}=new MessageChannel,b={protocol:new P.Protocol(O),onDidClientDisconnect:k.Event.fromDOMEventEmitter(O,"close")};return p.ipcRenderer.postMessage("vscode:createMessageChannelResult",v,[m]),b})}constructor(){super(U.getOnDidClientConnect())}}e.Server=U}),define(Z[100],ee([0,1,11,23]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(T,g){T.proxyAuthorization&&(T.headers=Object.assign(Object.assign({},T.headers||{}),{"Proxy-Authorization":T.proxyAuthorization}));const v=new XMLHttpRequest;return new Promise((O,m)=>{v.open(T.type||"GET",T.url||"",!0,T.user,T.password),P(v,T),v.responseType="arraybuffer",v.onerror=y=>m(new Error(v.statusText&&"XHR failed: "+v.statusText||"XHR failed")),v.onload=y=>{O({res:{statusCode:v.status,headers:U(v)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(v.response)))})},v.ontimeout=y=>m(new Error(`XHR timeout: ${T.timeout}ms`)),T.timeout&&(v.timeout=T.timeout),v.send(T.data),g.onCancellationRequested(()=>{v.abort(),m((0,p.canceled)())})})}e.request=A;function P(T,g){if(g.headers){e:for(let v in g.headers){switch(v){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}T.setRequestHeader(v,g.headers[v])}}}function U(T){const g=Object.create(null);for(const v of T.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(v){const O=v.indexOf(":");g[v.substr(0,O).trim().toLowerCase()]=v.substr(O+1).trim()}return g}}),define(Z[67],ee([0,1,2,3,6,15]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var U;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(U=e.StorageHint||(e.StorageHint={}));var T;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(T||(T={}));class g extends p.Disposable{constructor(m,y=Object.create(null)){super();this.database=m,this.options=y,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=T.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){var y,b;(y=m.changed)===null||y===void 0||y.forEach((u,S)=>this.accept(S,u)),(b=m.deleted)===null||b===void 0||b.forEach(u=>this.accept(u,void 0))}accept(m,y){if(this.state!==T.Closed){let b=!1;(0,P.isUndefinedOrNull)(y)?b=this.cache.delete(m):this.cache.get(m)!==y&&(this.cache.set(m,y),b=!0),b&&this._onDidChangeStorage.fire(m)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===T.None&&(this.state=T.Initialized,this.options.hint!==U.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,y){const b=this.cache.get(m);return(0,P.isUndefinedOrNull)(b)?y:b}getBoolean(m,y){const b=this.get(m);return(0,P.isUndefinedOrNull)(b)?y:b==="true"}getNumber(m,y){const b=this.get(m);return(0,P.isUndefinedOrNull)(b)?y:parseInt(b,10)}async set(m,y){if(this.state!==T.Closed){if((0,P.isUndefinedOrNull)(y))return this.delete(m);const b=String(y);if(this.cache.get(m)!==b)return this.cache.set(m,b),this.pendingInserts.set(m,b),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(m){if(this.state!==T.Closed&&!!this.cache.delete(m))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=T.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{var y;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(y=this.whenFlushedCallbacks.pop())===null||y===void 0||y()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((y,b)=>this.items.set(b,y)),m.delete&&m.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=v}),define(Z[101],ee([13,14]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[54],ee([0,1,101]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,A=k*60,P=A*24,U=P*7,T=P*30,g=P*365;function v(m,y){typeof m!="number"&&(m=m.getTime());const b=Math.round((new Date().getTime()-m)/1e3);if(b<-30)return(0,p.localize)(0,null,v(new Date().getTime()+b*1e3,!1));if(b<30)return(0,p.localize)(1,null);let u;return b<k?(u=b,y?u===1?(0,p.localize)(2,null,u):(0,p.localize)(3,null,u):u===1?(0,p.localize)(4,null,u):(0,p.localize)(5,null,u)):b<A?(u=Math.floor(b/k),y?u===1?(0,p.localize)(6,null,u):(0,p.localize)(7,null,u):u===1?(0,p.localize)(8,null,u):(0,p.localize)(9,null,u)):b<P?(u=Math.floor(b/A),y?u===1?(0,p.localize)(10,null,u):(0,p.localize)(11,null,u):u===1?(0,p.localize)(12,null,u):(0,p.localize)(13,null,u)):b<U?(u=Math.floor(b/P),y?u===1?(0,p.localize)(14,null,u):(0,p.localize)(15,null,u):u===1?(0,p.localize)(16,null,u):(0,p.localize)(17,null,u)):b<T?(u=Math.floor(b/U),y?u===1?(0,p.localize)(18,null,u):(0,p.localize)(19,null,u):u===1?(0,p.localize)(20,null,u):(0,p.localize)(21,null,u)):b<g?(u=Math.floor(b/T),y?u===1?(0,p.localize)(22,null,u):(0,p.localize)(23,null,u):u===1?(0,p.localize)(24,null,u):(0,p.localize)(25,null,u)):(u=Math.floor(b/g),y?u===1?(0,p.localize)(26,null,u):(0,p.localize)(27,null,u):u===1?(0,p.localize)(28,null,u):(0,p.localize)(29,null,u))}e.fromNow=v;function O(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Z[102],ee([13,14]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,102,15,18]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(v,O){return O&&(v.stack||v.stacktrace)?p.localize(0,null,T(v),U(v.stack)||U(v.stacktrace)):T(v)}function U(v){return Array.isArray(v)?v.join(`
`):v}function T(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?p.localize(1,null,v.message):v.message||p.localize(2,null)}function g(v=null,O=!1){if(!v)return p.localize(3,null);if(Array.isArray(v)){const m=A.coalesce(v),y=g(m[0],O);return m.length>1?p.localize(4,null,y,m.length):y}if(k.isString(v))return v;if(v.detail){const m=v.detail;if(m.error)return P(m.error,O);if(m.exception)return P(m.exception,O)}return v.stack?P(v,O):v.message?v.message:p.localize(5,null)}e.toErrorMessage=g}),define(Z[103],ee([13,14]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[104],ee([0,1,8,27,24,48,103,36,15,26,42,7,66,16]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function u(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(r,t){if(m.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const n=P.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{n.once("error",a=>{o({success:!1,error:a})}),n.once("exit",(a,c)=>{o(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(m.isLinux||m.isMacintosh)try{const i=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(n=>{P.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,a,c)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function E(r=T.env){return r.comspec||"cmd.exe"}e.getWindowsShell=E;class C{constructor(t,i,n,o){if(i!==void 0&&n!==void 0&&o!==void 0)this.cmd=t,this.args=i,this.shell=n,this.options=o;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(T.env).forEach(c=>{a[c]=T.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(p.sep);return i!==-1&&(t=t.substring(i+1)),C.WellKnowCommands[t]?t:"other"}start(t){return m.isWindows&&(this.options&&this.options.cwd&&O.isUNC(this.options.cwd)||!this.options&&O.isUNC(T.cwd()))?Promise.reject(new Error(U.localize(0,null))):this.useExec().then(i=>{let n,o;const a=new Promise((c,l)=>{n=c,o=l});if(i){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=P.exec(c,this.options,(l,d,w)=>{this.childProcess=null;const h=l;h&&h.killed?o({killed:this.terminateRequested,stdout:d.toString(),stderr:w.toString()}):this.handleExec(n,t,l,d,w)})}else{let c=null;const l=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,n,t,o);const w={terminated:this.terminateRequested};g.isNumber(d)&&(w.cmdCode=d),n(w)};if(this.shell&&m.isWindows){const d=v.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let w=!1,h=!1;const R=[];let _=this.ensureQuotes(this.cmd);R.push(_.value),w=_.quoted,this.args&&this.args.forEach(B=>{_=this.ensureQuotes(B),R.push(_.value),h=h&&_.quoted});const j=["/s","/c"];w?h?j.push('"'+R.join(" ")+'"'):R.length>1?j.push('"'+R[0]+'" '+R.slice(1).join(" ")):j.push('"'+R[0]+'"'):j.push(R.join(" ")),c=P.spawn(E(),j,d)}else this.cmd&&(c=P.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(g.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",d=>{this.childProcess=null,o({terminated:this.terminateRequested,error:d})}),c.pid&&(this.childProcess.on("close",l),this.handleSpawn(c,n,t,o,!0)))}return a})}handleClose(t,i,n,o){}ensureQuotes(t){return C.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,S(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!m.isWindows)return t(!1);const i=P.spawn(E(),["/s","/c"]);i.on("error",n=>t(!0)),i.on("exit",n=>t(!1))})}}e.AbstractProcess=C,C.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},C.regexp=/^[^"].* .*[^"]/;class I extends C{constructor(t,i,n,o){super(t,i,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,n,o,a){[o,a].forEach((c,l)=>{const d=new y.LineDecoder;d.write(c).forEach(R=>{i({line:R,source:l===0?0:1})});const h=d.end();h&&i({line:h,source:l===0?0:1})}),t({terminated:this.terminateRequested,error:n})}handleSpawn(t,i,n,o,a){const c=new y.LineDecoder,l=new y.LineDecoder;t.stdout.on("data",d=>{c.write(d).forEach(h=>n({line:h,source:0}))}),t.stderr.on("data",d=>{l.write(d).forEach(h=>n({line:h,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=l}handleClose(t,i,n,o){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&n({line:c,source:1})}}e.LineProcess=I;function f(r){let t=[],i=!1;const n=function(o){if(i){t.push(o);return}(!r.send(o,c=>{if(c&&console.error(c),i=!1,t.length>0){const l=t.slice(0);t=[],l.forEach(d=>n(d))}})||m.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=f;var s;(function(r){async function t(i,n,o){if(p.isAbsolute(i))return i;if(n===void 0&&(n=T.cwd()),p.dirname(i)!=="."||(o===void 0&&g.isString(T.env.PATH)&&(o=T.env.PATH.split(p.delimiter)),o===void 0||o.length===0))return p.join(n,i);async function c(l){return await A.exists(l)?!(await k.promises.stat(l)).isDirectory():!1}for(let l of o){let d;if(p.isAbsolute(l)?d=p.join(l,i):d=p.join(n,l,i),await c(d))return d;let w=d+".com";if(await c(w)||(w=d+".exe",await c(w)))return w}return p.join(n,i)}r.findExecutable=t})(s=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,48,2,6,26,3,104,34,87,30,11,23,7]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends g.ChannelServer{constructor(C){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(f){}},onMessage:U.Event.fromNodeEventEmitter(process,"message",I=>y.VSBuffer.wrap(Buffer.from(I,"base64")))},C);process.once("disconnect",()=>this.dispose())}}e.Server=u;class S{constructor(C,I){this.modulePath=C,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new U.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new A.Delayer(f),this.child=null,this._client=null}getChannel(C){const I=this;return{call(f,s,r){return I.requestPromise(C,f,s,r)},listen(f,s){return I.requestEvent(C,f,s)}}}requestPromise(C,I,f,s=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(m.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(C),t=(0,A.createCancelablePromise)(o=>r.call(I,f,o)),i=s.onCancellationRequested(()=>t.cancel()),n=(0,k.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(C,I,f){if(!this.disposeDelayer)return U.Event.None;this.disposeDelayer.cancel();let s;const r=new U.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(C).listen(I,f)(r.fire,r),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const C=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env=Object.assign(Object.assign({},(0,P.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(I.env=Object.assign(Object.assign({},I.env),this.options.env)),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),b.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,C,I);const f=new U.Emitter;U.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,v.isRemoteConsoleLog)(a)){(0,v.log)(a,`IPC Library: ${this.options.serverName}`);return}f.fire(y.VSBuffer.wrap(Buffer.from(a,"base64")))});const r=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&r.send(a.buffer.toString("base64")),i=f.event,n={send:t,onMessage:i};this._client=new g.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,c)=>{process.removeListener("exit",o),this.activeRequests.forEach(l=>(0,k.dispose)(l)),this.activeRequests.clear(),a!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:c})})}return this._client}getCachedChannel(C){let I=this.channels.get(C);return I||(I=this.client.getChannel(C),this.channels.set(C,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(Z[105],ee([13,14]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[106],ee([13,14]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[107],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[108],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[109],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[110],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[111],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[112],ee([13,14]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[113],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[114],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[115],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[116],ee([13,14]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[117],ee([13,14]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[118],ee([13,14]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[119],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[120],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[121],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[122],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[123],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[124],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)});var he=this&&this.__decorate||function(K,e,p,k){var A=arguments.length,P=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,p):k,U;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(K,e,p,k);else for(var T=K.length-1;T>=0;T--)(U=K[T])&&(P=(A<3?U(P):A>3?U(e,p,P):U(e,p))||P);return A>3&&P&&Object.defineProperty(e,p,P),P};define(Z[125],ee([0,1,8,12,85,54,16,4,36]),function(K,e,p,k,A,P,U,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class v{constructor(u,S,E){this._args=u,this.paths=S,this.productService=E}get appRoot(){return(0,p.dirname)(U.FileAccess.asFileUri("",K).fsPath)}get userHome(){return T.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return T.URI.file((0,p.join)(this.userDataPath,"User"))}get tmpDir(){return T.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,p.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return T.URI.file((0,p.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(T.URI.file((0,p.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return T.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return T.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=g.env.VSCODE_PORTABLE;return u?T.URI.file((0,p.join)(u,"argv.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,k.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return T.URI.file((0,p.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,p.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,p.resolve)(u):(0,p.normalize)((0,p.join)(U.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,p.resolve)(u):(0,p.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,p.resolve)(u);const S=g.env.VSCODE_EXTENSIONS;if(S)return S;const E=g.env.VSCODE_PORTABLE;return E?(0,p.join)(E,"extensions"):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(S=>/^[^:/?#]+?:\/\//.test(S)?T.URI.parse(S):T.URI.file((0,p.normalize)(S)))}get extensionDevelopmentKind(){var u;return(u=this.args.extensionDevelopmentKind)===null||u===void 0?void 0:u.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?T.URI.parse(u):T.URI.file((0,p.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return O(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!g.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,k.joinPath)(T.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return T.URI.file((0,p.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}he([A.memoize],v.prototype,"appRoot",null),he([A.memoize],v.prototype,"userHome",null),he([A.memoize],v.prototype,"userDataPath",null),he([A.memoize],v.prototype,"appSettingsHome",null),he([A.memoize],v.prototype,"tmpDir",null),he([A.memoize],v.prototype,"userRoamingDataHome",null),he([A.memoize],v.prototype,"settingsResource",null),he([A.memoize],v.prototype,"userDataSyncHome",null),he([A.memoize],v.prototype,"userDataSyncLogResource",null),he([A.memoize],v.prototype,"sync",null),he([A.memoize],v.prototype,"machineSettingsResource",null),he([A.memoize],v.prototype,"globalStorageHome",null),he([A.memoize],v.prototype,"workspaceStorageHome",null),he([A.memoize],v.prototype,"keybindingsResource",null),he([A.memoize],v.prototype,"keyboardLayoutResource",null),he([A.memoize],v.prototype,"argvResource",null),he([A.memoize],v.prototype,"snippetsHome",null),he([A.memoize],v.prototype,"isExtensionDevelopment",null),he([A.memoize],v.prototype,"untitledWorkspacesHome",null),he([A.memoize],v.prototype,"installSourcePath",null),he([A.memoize],v.prototype,"builtinExtensionsPath",null),he([A.memoize],v.prototype,"extensionsPath",null),he([A.memoize],v.prototype,"extensionDevelopmentLocationURI",null),he([A.memoize],v.prototype,"extensionDevelopmentKind",null),he([A.memoize],v.prototype,"extensionTestsLocationURI",null),he([A.memoize],v.prototype,"debugExtensionHost",null),he([A.memoize],v.prototype,"serviceMachineIdResource",null),he([A.memoize],v.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=v;function O(b,u){return y(b["inspect-extensions"],b["inspect-brk-extensions"],5870,u,b.debugId)}e.parseExtensionHostPort=O;function m(b,u){return y(b["inspect-search"],b["inspect-brk-search"],5876,u)}e.parseSearchPort=m;function y(b,u,S,E,C){const f=Number(u||b)||(E?null:S),s=f?Boolean(!!u):!1;return{port:f,break:s,debugId:C}}}),function(){"use strict";function K(e,p,k,A){function P(T){const g=U(T),v=[g];return e.isAbsolute(g)||v.unshift(A),e.resolve(...v)}function U(T){const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");const v=T["user-data-dir"];if(v)return v;let O=process.env.VSCODE_APPDATA;if(!O)switch(process.platform){case"win32":if(O=process.env.APPDATA,!O){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");O=e.join(m,"AppData","Roaming")}break;case"darwin":O=e.join(p.homedir(),"Library","Application Support");break;case"linux":O=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(O,k)}return{getUserDataPath:P}}if(typeof define=="function")define(Z[126],ee([0,200,38,16,12,36]),function(e,p,k,A,P,U){const T=P.dirname(A.FileAccess.asFileUri("",e)),g=e.__$__nodeRequire(P.joinPath(T,"package.json").fsPath);return K(p,k,g.name,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),k=require("os");module.exports=K(p,k,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[127],ee([0,1,38,126,125]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class P extends A.AbstractNativeEnvironmentService{constructor(T,g){super(T,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,k.getUserDataPath)(T)},g)}}e.NativeEnvironmentService=P}),define(Z[128],ee([0,1,4]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const k=/^([^@:]+@)?([^:]+):/,A=/^([^@:]+@)?([^:]+):(.+)$/,P=/^([^@]+@)?([^:]+)(:\d+)?$/,U=/([^@:.]+\.[^@:.]+)(:\d+)?$/,T=/^\s*url\s*=\s*(.+\S)\s*$/mg,g=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function v(E){const C=E.match(U);return C?C[1]:null}function O(E){if(E.indexOf("://")===-1){const C=E.match(k);return C?v(C[2]):null}try{const C=p.URI.parse(E);if(C.authority)return v(C.authority)}catch(C){}return null}function m(E,C){const I=new Set;let f;for(;f=T.exec(E);){const r=O(f[1]);r&&I.add(r)}const s=new Set(C);return Array.from(I).map(r=>s.has(r)?r:r.replace(g,"a"))}e.getDomainsOfRemotes=m;function y(E){const C=E.match(P);return C?C[2]:null}function b(E,C,I){return E&&C?(I&&C.endsWith(".git")&&(C=C.substr(0,C.length-4)),C.indexOf("/")===0?`${E}${C}`:`${E}/${C}`):null}function u(E,C){if(E.indexOf("://")===-1){const I=E.match(A);if(I)return b(I[2],I[3],C)}try{const I=p.URI.parse(E);if(I.authority)return b(y(I.authority),I.path,C)}catch(I){}return null}function S(E,C=!1){const I=[];let f;for(;f=T.exec(E);){const s=u(f[1],C);s&&I.push(s)}return I}e.getRemotes=S}),define(Z[129],ee([0,1,3,4,90,26,2]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function T(u,S){return k.URI.revive(S?S.transformIncoming(u):u)}function g(u,S){return S?S.transformOutgoingURI(u):u}function v(u,S){S=S||A.DefaultURITransformer;const E=u.manifest,C=(0,A.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},u),{manifest:void 0}),S);return Object.assign(Object.assign({},C),{manifest:E})}function O(u,S){return S?(0,P.cloneAndChange)(u,E=>E instanceof k.URI?S.transformOutgoingURI(E):void 0):u}class m{constructor(S,E){this.service=S,this.getUriTransformer=E,this.onInstallExtension=p.Event.buffer(S.onInstallExtension,!0),this.onDidInstallExtension=p.Event.buffer(S.onDidInstallExtension,!0),this.onUninstallExtension=p.Event.buffer(S.onUninstallExtension,!0),this.onDidUninstallExtension=p.Event.buffer(S.onDidUninstallExtension,!0)}listen(S,E){const C=this.getUriTransformer(S);switch(E){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return p.Event.map(this.onDidInstallExtension,I=>Object.assign(Object.assign({},I),{local:I.local?O(I.local,C):I.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(S,E,C){const I=this.getUriTransformer(S);switch(E){case"zip":return this.service.zip(v(C[0],I)).then(f=>g(f,I));case"unzip":return this.service.unzip(T(C[0],I));case"install":return this.service.install(T(C[0],I));case"getManifest":return this.service.getManifest(T(C[0],I));case"canInstall":return this.service.canInstall(C[0]);case"installFromGallery":return this.service.installFromGallery(C[0],C[1]);case"uninstall":return this.service.uninstall(v(C[0],I),C[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(v(C[0],I));case"getInstalled":return this.service.getInstalled(C[0]).then(f=>f.map(s=>O(s,I)));case"updateMetadata":return this.service.updateMetadata(v(C[0],I),C[1]).then(f=>O(f,I));case"updateExtensionScope":return this.service.updateExtensionScope(v(C[0],I),C[1]).then(f=>O(f,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class y extends U.Disposable{constructor(S){super();this.channel=S,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new p.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(E=>this._onInstallExtension.fire(E))),this._register(this.channel.listen("onDidInstallExtension")(E=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},E),{local:E.local?v(E.local,null):E.local})))),this._register(this.channel.listen("onUninstallExtension")(E=>this._onUninstallExtension.fire(E))),this._register(this.channel.listen("onDidUninstallExtension")(E=>this._onDidUninstallExtension.fire(E)))}zip(S){return Promise.resolve(this.channel.call("zip",[S]).then(E=>k.URI.revive(E)))}unzip(S){return Promise.resolve(this.channel.call("unzip",[S]))}install(S){return Promise.resolve(this.channel.call("install",[S])).then(E=>v(E,null))}getManifest(S){return Promise.resolve(this.channel.call("getManifest",[S]))}async canInstall(S){return!0}installFromGallery(S,E){return Promise.resolve(this.channel.call("installFromGallery",[S,E])).then(C=>v(C,null))}uninstall(S,E){return Promise.resolve(this.channel.call("uninstall",[S,E]))}reinstallFromGallery(S){return Promise.resolve(this.channel.call("reinstallFromGallery",[S]))}getInstalled(S=null){return Promise.resolve(this.channel.call("getInstalled",[S])).then(E=>E.map(C=>v(C,null)))}updateMetadata(S,E){return Promise.resolve(this.channel.call("updateMetadata",[S,E])).then(C=>v(C,null))}updateExtensionScope(S,E){return Promise.resolve(this.channel.call("updateExtensionScope",[S,E])).then(C=>v(C,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=y;class b{constructor(S){this.service=S}listen(S,E){throw new Error("Invalid listen")}call(S,E,C){switch(E){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(C[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(Z[130],ee([0,1,26]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function A(P,U){const T=g=>{if(typeof g=="string"){const v=k.exec(g);if(!!v)return U[v[1]]||g}};return(0,p.cloneAndChange)(P,T)}e.localizeManifest=A}),define(Z[131],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class p{constructor(P){this.channel=P}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(P,U,T,g){return this.channel.call("promptImportantExtensionsInstallNotification",[P,U,T,g])}promptWorkspaceRecommendations(P){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=p;class k{constructor(P){this.service=P}listen(P,U){throw new Error(`Event not found: ${U}`)}call(P,U,T){switch(U){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(T[0],T[1],T[2],T[3])}throw new Error(`Call not found: ${U}`)}}e.ExtensionRecommendationNotificationServiceChannel=k}),define(Z[68],ee([0,1,112]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(m){return m=m.trim(),m==="*"||k.test(m)}e.isValidVersionStr=A;function P(m){if(!A(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=m.match(k);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=P;function U(m){if(!m)return null;let y=m.majorBase,b=m.majorMustEqual,u=m.minorBase,S=m.minorMustEqual,E=m.patchBase,C=m.patchMustEqual;return m.hasCaret&&(y===0||(S=!1),C=!1),{majorBase:y,majorMustEqual:b,minorBase:u,minorMustEqual:S,patchBase:E,patchMustEqual:C,isMinimum:m.hasGreaterEquals}}e.normalizeVersion=U;function T(m,y){let b;typeof m=="string"?b=U(P(m)):b=m;let u;if(typeof y=="string"?u=U(P(y)):u=y,!b||!u)return!1;let S=b.majorBase,E=b.minorBase,C=b.patchBase,I=u.majorBase,f=u.minorBase,s=u.patchBase,r=u.majorMustEqual,t=u.minorMustEqual,i=u.patchMustEqual;return u.isMinimum?S>I?!0:S<I?!1:E>f?!0:E<f?!1:C>=s:(S===1&&I===0&&(!r||!t||!i)&&(I=1,f=0,s=0,r=!0,t=!1,i=!1),S<I?!1:S>I?!r:E<f?!1:E>f?!t:C<s?!1:C>s?!i:!0)}e.isValidVersion=T;function g(m,y,b){return y.isBuiltin||typeof y.main=="undefined"?!0:O(m,y.engines.vscode,b)}e.isValidExtensionVersion=g;function v(m,y){return m==="*"||O(y,m)}e.isEngineValid=v;function O(m,y,b=[]){let u=U(P(y));if(!u)return b.push(p.localize(0,null,y)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return b.push(p.localize(1,null,y)),!1}else if(!u.majorMustEqual)return b.push(p.localize(2,null,y)),!1;return T(m,u)?!0:(b.push(p.localize(3,null,m,y)),!1)}e.isVersionValid=O}),define(Z[132],ee([0,1,34,49,2,16]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(g,v,O,m){super();this.folders=g,this.onDidFilesChange=v,this.onLogMessage=O,this.verboseLogging=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new k.Client(P.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(g.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.setFolders(this.folders)}setVerboseLogging(g){this.verboseLogging=g,!this.isDisposed&&this.service&&this.service.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${g}`})}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[133],ee([0,1,34,49,2,16]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(g,v,O,m,y={}){super();this.folders=g,this.onDidFilesChange=v,this.onLogMessage=O,this.verboseLogging=m,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new k.Client(P.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(g.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.service.setRoots(this.folders)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${g}`})}setVerboseLogging(g){this.verboseLogging=g,this.service&&this.service.setVerboseLogging(g)}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[134],ee([0,1,48,66,89,16]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class U{constructor(g,v,O,m,y){this.watchedFolder=g,this.eventCallback=O,this.logCallback=m,this.verboseLogging=y,this.restartCounter=0,Array.isArray(v)?this.ignored=v.map(b=>A.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${g}`),this.startWatcher()}startWatcher(){const g=[this.watchedFolder];this.verboseLogging&&g.push("-verbose"),this.handle=p.spawn(P.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,g);const v=new k.LineDecoder;this.handle.stdout.on("data",O=>{const m=[];v.write(O).forEach(y=>{const b=y.split("|");if(b.length===2){const u=Number(b[0]),S=b[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(E=>E(S))){this.verboseLogging&&this.log(S);return}m.push({type:U.changeTypeMap[u],path:S})}else this.log(b[1])}}),m.length>0&&this.eventCallback(m)}),this.handle.on("error",O=>this.onError(O)),this.handle.stderr.on("data",O=>this.onError(O)),this.handle.on("exit",(O,m)=>this.onExit(O,m))}onError(g){this.error("process error: "+g.toString())}onExit(g,v){this.handle&&(this.error(`terminated unexpectedly (code: ${g}, signal: ${v})`),this.restartCounter<=U.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(g){this.logCallback({type:"error",message:`[File Watcher (C#)] ${g}`})}log(g){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${g}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=U,U.MAX_RESTARTS=5,U.changeTypeMap=[0,1,2]}),define(Z[135],ee([0,1,134,8,21]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P{constructor(T,g,v,O){this.onDidFilesChange=g,this.onLogMessage=v,this.verboseLogging=O,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(k.posix.sep)&&(this.folder.path=(0,A.rtrim)(this.folder.path,k.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new p.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=P}),define(Z[50],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(P,U=[],T=!1){this.ctor=P,this.staticArguments=U,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=p;const k=(A,...P)=>new p(A,P);e.createSyncDescriptor=k}),define(Z[136],ee([0,1,50]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(U,T,g){T instanceof p.SyncDescriptor||(T=new p.SyncDescriptor(T,[],g)),k.push([U,T])}e.registerSingleton=A;function P(){return k}e.getSingletonServiceDescriptors=P}),define(Z[137],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=p;class k{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let U of this._nodes.values())U.outgoing.size===0&&P.push(U);return P}insertEdge(P,U){const T=this.lookupOrInsertNode(P),g=this.lookupOrInsertNode(U);T.outgoing.set(this._hashFn(U),g),g.incoming.set(this._hashFn(P),T)}removeNode(P){const U=this._hashFn(P);this._nodes.delete(U);for(let T of this._nodes.values())T.outgoing.delete(U),T.incoming.delete(U)}lookupOrInsertNode(P){const U=this._hashFn(P);let T=this._nodes.get(U);return T||(T=new p(P),this._nodes.set(U,T)),T}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[U,T]of this._nodes)P.push(`${U}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,U]of this._nodes){const T=new Set([P]),g=this._findCycle(U,T);if(g)return g}}_findCycle(P,U){for(let[T,g]of P.outgoing){if(U.has(T))return[...U,T].join(" -> ");U.add(T);const v=this._findCycle(g,U);if(v)return v;U.delete(T)}}}e.Graph=k}),define(Z[5],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function g(v){return v[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=g})(p=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(T,g,v,O){g[p.DI_TARGET]===g?g[p.DI_DEPENDENCIES].push({id:T,index:v,optional:O}):(g[p.DI_DEPENDENCIES]=[{id:T,index:v,optional:O}],g[p.DI_TARGET]=g)}function A(T){if(p.serviceIds.has(T))return p.serviceIds.get(T);const g=function(v,O,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(g,v,m,!1)};return g.toString=()=>T,p.serviceIds.set(T,g),g}e.createDecorator=A;function P(T){return T}e.refineServiceDecorator=P;function U(T){return function(g,v,O){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(T,g,O,!0)}}e.optional=U}),define(Z[138],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,p.createDecorator)("checksumService")}),define(Z[139],ee([0,1,21,5,7]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=A.userAgent||"";const U=new Map;U.set("false",!1),U.set("true",!0),U.set("isMac",A.isMacintosh),U.set("isLinux",A.isLinux),U.set("isWindows",A.isWindows),U.set("isWeb",A.isWeb),U.set("isMacNative",A.isMacintosh&&!A.isWeb),U.set("isEdge",P.indexOf("Edg/")>=0),U.set("isFirefox",P.indexOf("Firefox")>=0),U.set("isChrome",P.indexOf("Chrome")>=0),U.set("isSafari",P.indexOf("Safari")>=0),U.set("isIPad",P.indexOf("iPad")>=0);const T=Object.prototype.hasOwnProperty;var g;(function(w){w[w.False=0]="False",w[w.True=1]="True",w[w.Defined=2]="Defined",w[w.Not=3]="Not",w[w.Equals=4]="Equals",w[w.NotEquals=5]="NotEquals",w[w.And=6]="And",w[w.Regex=7]="Regex",w[w.NotRegex=8]="NotRegex",w[w.Or=9]="Or",w[w.In=10]="In",w[w.NotIn=11]="NotIn",w[w.Greater=12]="Greater",w[w.GreaterEquals=13]="GreaterEquals",w[w.Smaller=14]="Smaller",w[w.SmallerEquals=15]="SmallerEquals"})(g=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return m.INSTANCE}static true(){return y.INSTANCE}static has(h){return b.create(h)}static equals(h,R){return u.create(h,R)}static notEquals(h,R){return C.create(h,R)}static regex(h,R){return i.create(h,R)}static in(h,R){return S.create(h,R)}static not(h){return I.create(h)}static and(...h){return o.create(h)}static or(...h){return a.create(h)}static greater(h,R){return f.create(h,R)}static less(h,R){return r.create(h,R)}static deserialize(h,R=!1){if(!!h)return this._deserializeOrExpression(h,R)}static _deserializeOrExpression(h,R){let _=h.split("||");return a.create(_.map(j=>this._deserializeAndExpression(j,R)))}static _deserializeAndExpression(h,R){let _=h.split("&&");return o.create(_.map(j=>this._deserializeOne(j,R)))}static _deserializeOne(h,R){if(h=h.trim(),h.indexOf("!=")>=0){let _=h.split("!=");return C.create(_[0].trim(),this._deserializeValue(_[1],R))}if(h.indexOf("==")>=0){let _=h.split("==");return u.create(_[0].trim(),this._deserializeValue(_[1],R))}if(h.indexOf("=~")>=0){let _=h.split("=~");return i.create(_[0].trim(),this._deserializeRegexValue(_[1],R))}if(h.indexOf(" in ")>=0){let _=h.split(" in ");return S.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(h)){const _=h.split(">=");return s.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(h)){const _=h.split(">");return f.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(h)){const _=h.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(h)){const _=h.split("<");return r.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(h)?I.create(h.substr(1).trim()):b.create(h)}static _deserializeValue(h,R){if(h=h.trim(),h==="true")return!0;if(h==="false")return!1;let _=/^'([^']*)'$/.exec(h);return _?_[1].trim():h}static _deserializeRegexValue(h,R){if((0,p.isFalsyOrWhitespace)(h)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=h.indexOf("/"),j=h.lastIndexOf("/");if(_===j||_<0){if(R)throw new Error(`bad regexp-value '${h}', missing /-enclosure`);return console.warn(`bad regexp-value '${h}', missing /-enclosure`),null}let B=h.slice(_+1,j),M=h[j+1]==="i"?"i":"";try{return new RegExp(B,M)}catch($){if(R)throw new Error(`bad regexp-value '${h}', parse error: ${$}`);return console.warn(`bad regexp-value '${h}', parse error: ${$}`),null}}}e.ContextKeyExpr=v;function O(w,h){return w.cmp(h)}class m{constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class y{constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class b{constructor(h){this.key=h,this.type=2}static create(h){const R=U.get(h);return typeof R=="boolean"?R?y.INSTANCE:m.INSTANCE:new b(h)}cmp(h){return h.type!==this.type?this.type-h.type:l(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=b;class u{constructor(h,R){this.key=h,this.value=R,this.type=4}static create(h,R){if(typeof R=="boolean")return R?b.create(h):I.create(h);const _=U.get(h);return typeof _=="boolean"?R===(_?"true":"false")?y.INSTANCE:m.INSTANCE:new u(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return C.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class S{constructor(h,R){this.key=h,this.valueKey=R,this.type=10}static create(h,R){return new S(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}evaluate(h){const R=h.getValue(this.valueKey),_=h.getValue(this.key);return Array.isArray(R)?R.indexOf(_)>=0:typeof _=="string"&&typeof R=="object"&&R!==null?T.call(R,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=S;class E{constructor(h){this._actual=h,this.type=11}static create(h){return new E(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new E(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class C{constructor(h,R){this.key=h,this.value=R,this.type=5}static create(h,R){if(typeof R=="boolean")return R?I.create(h):b.create(h);const _=U.get(h);return typeof _=="boolean"?R===(_?"true":"false")?m.INSTANCE:y.INSTANCE:new C(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=C;class I{constructor(h){this.key=h,this.type=3}static create(h){const R=U.get(h);return typeof R=="boolean"?R?m.INSTANCE:y.INSTANCE:new I(h)}cmp(h){return h.type!==this.type?this.type-h.type:l(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return b.create(this.key)}}e.ContextKeyNotExpr=I;class f{constructor(h,R){this.key=h,this.value=R,this.type=12}static create(h,R){return new f(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class s{constructor(h,R){this.key=h,this.value=R,this.type=13}static create(h,R){return new s(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class r{constructor(h,R){this.key=h,this.value=R,this.type=14}static create(h,R){return new r(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=r;class t{constructor(h,R){this.key=h,this.value=R,this.type=15}static create(h,R){return new t(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(h,R){this.key=h,this.regexp=R,this.type=7}static create(h,R){return new i(h,R)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const R=this.regexp?this.regexp.source:"",_=h.regexp?h.regexp.source:"";return R<_?-1:R>_?1:0}equals(h){if(h.type===this.type){const R=this.regexp?this.regexp.source:"",_=h.regexp?h.regexp.source:"";return this.key===h.key&&R===_}return!1}evaluate(h){let R=h.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return n.create(this)}}e.ContextKeyRegexExpr=i;class n{constructor(h){this._actual=h,this.type=8}static create(h){return new n(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new n(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class o{constructor(h){this.expr=h,this.type=6}static create(h){return o._normalizeArr(h)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let R=0,_=this.expr.length;R<_;R++){const j=O(this.expr[R],h.expr[R]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let R=0,_=this.expr.length;R<_;R++)if(!this.expr[R].equals(h.expr[R]))return!1;return!0}return!1}evaluate(h){for(let R=0,_=this.expr.length;R<_;R++)if(!this.expr[R].evaluate(h))return!1;return!0}static _normalizeArr(h){const R=[];let _=!1;for(const j of h)if(!!j){if(j.type===1){_=!0;continue}if(j.type===0)return m.INSTANCE;if(j.type===6){R.push(...j.expr);continue}R.push(j)}if(R.length===0&&_)return y.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(O);R.length>1;){const j=R[R.length-1];if(j.type!==9)break;R.pop();const B=R.pop(),M=a.create(j.expr.map($=>o.create([$,B])));M&&(R.push(M),R.sort(O))}return R.length===1?R[0]:new o(R)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(let R of this.expr)h.push(...R.keys());return h}map(h){return new o(this.expr.map(R=>R.map(h)))}negate(){let h=[];for(let R of this.expr)h.push(R.negate());return a.create(h)}}e.ContextKeyAndExpr=o;class a{constructor(h){this.expr=h,this.type=9}static create(h){const R=a._normalizeArr(h);if(R.length!==0)return R.length===1?R[0]:new a(R)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let R=0,_=this.expr.length;R<_;R++){const j=O(this.expr[R],h.expr[R]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let R=0,_=this.expr.length;R<_;R++)if(!this.expr[R].equals(h.expr[R]))return!1;return!0}return!1}evaluate(h){for(let R=0,_=this.expr.length;R<_;R++)if(this.expr[R].evaluate(h))return!0;return!1}static _normalizeArr(h){let R=[],_=!1;if(h){for(let j=0,B=h.length;j<B;j++){const M=h[j];if(!!M){if(M.type===0){_=!0;continue}if(M.type===1)return[y.INSTANCE];if(M.type===9){R=R.concat(M.expr);continue}R.push(M)}}if(R.length===0&&_)return[m.INSTANCE];R.sort(O)}return R}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(let R of this.expr)h.push(...R.keys());return h}map(h){return new a(this.expr.map(R=>R.map(h)))}negate(){let h=[];for(let _ of this.expr)h.push(_.negate());const R=_=>_.type===9?_.expr:[_];for(;h.length>1;){const _=h.shift(),j=h.shift(),B=[];for(const M of R(_))for(const $ of R(j))B.push(v.and(M,$));h.unshift(v.or(...B))}return h[0]}}e.ContextKeyOrExpr=a;class c extends b{constructor(h,R,_){super(h);this._defaultValue=R,typeof _=="object"?c._info.push(Object.assign(Object.assign({},_),{key:h})):_!==!0&&c._info.push({key:h,description:_,type:R!=null?typeof R:void 0})}static all(){return c._info.values()}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return v.not(this.key)}isEqualTo(h){return v.equals(this.key,h)}notEqualsTo(h){return v.notEquals(this.key,h)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(w,h){return w<h?-1:w>h?1:0}function d(w,h,R,_){return w<R?-1:w>R?1:h<_?-1:h>_?1:0}}),define(Z[69],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function k(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=k}),define(Z[70],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,p.createDecorator)("downloadService")}),define(Z[9],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)});var Y=this&&this.__param||function(K,e){return function(p,k){e(p,k,K)}};define(Z[140],ee([0,1,9,8,24,11,2,6]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let g=class extends U.Disposable{constructor(O){super();this.environmentService=O,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let O=setTimeout(()=>{O=void 0;const m=(0,k.basename)(this.environmentService.logsPath),y=(0,k.dirname)(this.environmentService.logsPath);(0,A.readdir)(y).then(b=>{const S=b.filter(C=>/^\d{8}T\d{6}$/.test(C)).sort().filter((C,I)=>C!==m),E=S.slice(0,Math.max(0,S.length-9));return T.Promises.settled(E.map(C=>(0,A.rimraf)((0,k.join)(y,C))))}).then(null,P.onUnexpectedError)},10*1e3);this._register((0,U.toDisposable)(()=>{O&&(clearTimeout(O),O=void 0)}))}};g=he([Y(0,p.IEnvironmentService)],g),e.LogsDataCleaner=g}),define(Z[141],ee([0,1,27,9,8,24,11,2]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let g=class ct extends T.Disposable{constructor(O,m){super();this.backupWorkspacesPath=O,this.environmentService=m,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let O=setTimeout(()=>{O=void 0,(async()=>{try{const m=await p.promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(m).emptyWorkspaceInfos.map(E=>E.backupFolder),u=await(0,P.readdir)(this.environmentService.workspaceStorageHome.fsPath),S=[];u.forEach(E=>{E.length!==ct.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(E)===-1&&S.push((0,P.rimraf)((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,E)))}),await Promise.all(S)}catch(m){(0,U.onUnexpectedError)(m)}})()},30*1e3);this._register((0,T.toDisposable)(()=>{O&&(clearTimeout(O),O=void 0)}))}};g.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,g=he([Y(1,k.INativeEnvironmentService)],g),e.StorageDataCleaner=g}),define(Z[29],ee([0,1,107,5,16]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function P(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=P;var U;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=5]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(U=e.SortBy||(e.SortBy={}));var T;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(T=e.SortOrder||(e.SortOrder={}));var g;(function(m){m.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var v;(function(m){m[m.None=0]="None",m[m.Install=1]="Install",m[m.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class O extends Error{constructor(y,b){super(y);this.code=b}}e.ExtensionManagementError=O,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,p.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,p.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[142],ee([0,1,2,29]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let A=class extends p.Disposable{constructor(U){super();this.extensionManagementService=U,this._register(U),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};A=he([Y(0,k.IExtensionManagementService)],A),e.DeprecatedExtensionsCleaner=A}),define(Z[71],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var k;(function(U){U[U.FILE=1]="FILE",U[U.WORKSPACE=2]="WORKSPACE",U[U.EXE=3]="EXE"})(k=e.RecommendationSource||(e.RecommendationSource={}));function A(U){switch(U){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var P;(function(U){U.Ignored="ignored",U.Cancelled="cancelled",U.TooMany="toomany",U.IncompatibleWindow="incompatibleWindow",U.Accepted="reacted"})(P=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,p.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[72],ee([0,1,21,5]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class U{constructor(O){this.value=O,this._lower=O.toLowerCase()}static equals(O,m){if(typeof O=="undefined"||O===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof O=="string"||typeof m=="string"){let y=typeof O=="string"?O:O.value,b=typeof m=="string"?m:m.value;return p.equalsIgnoreCase(y,b)}return O._lower===m._lower}static toKey(O){return typeof O=="string"?O.toLowerCase():O._lower}}e.ExtensionIdentifier=U;function T(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function g(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=g,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,21,72]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(b,u){return b.uuid&&u.uuid?b.uuid===u.uuid:b.id===u.id?!0:(0,p.compareIgnoreCase)(b.id,u.id)===0}e.areSameExtensions=A;class P{constructor(u,S){this.version=S,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof P?A(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=P;function U(b,u){return`${b}.${u}`}e.getExtensionId=U;function T(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function g(b,u){return T(U(b,u))}e.getGalleryExtensionId=g;function v(b,u){const S=[],E=C=>{for(const I of S)if(I.some(f=>A(u(f),u(C))))return I;return null};for(const C of b){const I=E(C);I?I.push(C):S.push([C])}return S}e.groupByExtension=v;function O(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=O;function m(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function y(b){const u=new Set;for(const S of b)S.malicious&&u.add(S.id.id);return u}e.getMaliciousExtensionsSet=y}),define(Z[143],ee([0,1,2,8,72,24]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class U extends p.Disposable{constructor(g,v){super();this.environmentService=g,this.extensionsManifestCache=(0,k.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtension(O=>this.onDidInstallExtension(O))),this._register(v.onDidUninstallExtension(O=>this.onDidUnInstallExtension(O)))}onDidInstallExtension(g){g.error||this.invalidate()}onDidUnInstallExtension(g){g.error||this.invalidate()}invalidate(){P.rimraf(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=U}),define(Z[10],ee([0,1,114,8,4,5,21,15,37]),function(K,e,p,k,A,P,U,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function v(M){return M.create===!0}e.isFileOpenForWriteOptions=v;var O;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var m;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function b(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=b;function u(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function S(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=S;var E;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor($,V){super($);this.code=V}}e.FileSystemProviderError=C;function I(M,$){const V=new C(M.toString(),$);return s(V,$),V}e.createFileSystemProviderError=I;function f(M){return M||I((0,p.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=f;function s(M,$){return M.name=$?`${$} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=s;function r(M){if(!M)return E.Unknown;if(M instanceof C)return M.code;const $=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!$)return E.Unknown;switch($[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=r;function t(M){if(M instanceof l)return M.fileOperationResult;switch(r(M)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor($,V,q){this.resource=$,this.operation=V,this.target=q}isOperation($){return this.operation===$}}e.FileOperationEvent=n;var o;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class a{constructor($,V){this.ignorePathCasing=V,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const q of $)switch(q.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(q.resource,q);break}}contains($,...V){return this.doContains($,{includeChildren:!1},...V)}affects($,...V){return this.doContains($,{includeChildren:!0},...V)}doContains($,V,...q){var H,z,D,L,F,N;if(!$)return!1;const x=q.length>0;return!!((!x||q.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get($))||V.includeChildren&&((z=this.added)===null||z===void 0?void 0:z.findSuperstr($)))||(!x||q.includes(0))&&(((D=this.updated)===null||D===void 0?void 0:D.get($))||V.includeChildren&&((L=this.updated)===null||L===void 0?void 0:L.findSuperstr($)))||(!x||q.includes(2))&&(((F=this.deleted)===null||F===void 0?void 0:F.findSubstr($))||V.includeChildren&&((N=this.deleted)===null||N===void 0?void 0:N.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const V=[],q=$===1?this.added:$===0?this.updated:this.deleted;if(q)for(const[,H]of q)V.push(H);return V}filter($){return new a(this.changes.filter(V=>$(V)),this.ignorePathCasing)}}e.FileChangesEvent=a;function c(M,$,V){return!M||!$||M===$||$.length>M.length?!1:($.charAt($.length-1)!==k.sep&&($+=k.sep),V?(0,U.startsWithIgnoreCase)(M,$):M.indexOf($)===0)}e.isParent=c;class l extends Error{constructor($,V,q){super($);this.fileOperationResult=V,this.options=q}static isFileOperationError($){return $ instanceof Error&&!(0,T.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=l;var d;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var w;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(w=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function h(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=h;async function R(M,$){if(!$.canHandleResource(A.URI.from({scheme:M.scheme})))return new Promise(V=>{const q=$.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===M.scheme&&H.added&&(q.dispose(),V())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize($){return(0,T.isNumber)($)||($=0),$<_.KB?(0,p.localize)(1,null,$.toFixed(0)):$<_.MB?(0,p.localize)(2,null,($/_.KB).toFixed(2)):$<_.GB?(0,p.localize)(3,null,($/_.MB).toFixed(2)):$<_.TB?(0,p.localize)(4,null,($/_.GB).toFixed(2)):(0,p.localize)(5,null,($/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var j;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function B(M){return{maxFileSize:M===0?300*_.MB:16*_.GB,maxHeapSize:M===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=B}),define(Z[144],ee([0,1,145,47,10]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let P=class{constructor(T){this.fileService=T}checksum(T){return new Promise(async(g,v)=>{const O=(0,p.createHash)("md5"),m=(await this.fileService.readFileStream(T)).value;(0,k.listenStream)(m,{onData:y=>O.update(y.buffer),onError:y=>v(y),onEnd:()=>g(O.digest("base64").replace(/=+$/,""))})})}};P=he([Y(0,A.IFileService)],P),e.ChecksumService=P}),define(Z[73],ee([0,1,4,10,7]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function P(g){return g.map(v=>({type:v.type,resource:p.URI.file(v.path)}))}e.toFileChanges=P;function U(g){const v=new T;for(const O of g)v.processEvent(O);return v.normalize()}e.normalizeFileChanges=U;class T{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(v){const O=this.mapPathToChange.get(v.path);if(O){const m=O.type,y=v.type;m===1&&y===2?(this.mapPathToChange.delete(v.path),this.normalized.splice(this.normalized.indexOf(O),1)):m===2&&y===1?O.type=0:m===1&&y===0||(O.type=y)}else this.normalized.push(v),this.mapPathToChange.set(v.path,v)}normalize(){const v=[],O=[];return this.normalized.filter(m=>m.type!==2?(v.push(m),!1):!0).sort((m,y)=>m.path.length-y.path.length).filter(m=>O.some(y=>(0,k.isParent)(m.path,y,!A.isLinux))?!1:(O.push(m.path),!0)).concat(v)}}}),define(Z[146],ee([0,1,73,2,24,93,96,6,8]),function(K,e,p,k,A,P,U,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class v extends k.Disposable{constructor(m,y,b,u){super();this.path=m,this.onDidFilesChange=y,this.onLogMessage=b,this.verboseLogging=u,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(U.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(m){this.verboseLogging=m}async startWatching(){try{const{stat:m,symbolicLink:y}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(y)try{b=await(0,P.realpath)(b)}catch(u){if(this.onError(u),y.dangling)return}m.isDirectory()?this._register((0,U.watchFolder)(b,(u,S)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,g.join)(this.path,(0,g.basename)(S))})},u=>this.onError(u))):this._register((0,U.watchFile)(b,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(m){m.code!=="ENOENT"&&this.onError(m)}}onFileChange(m){this.fileChangesBuffer.push(m),this.verboseLogging&&this.onVerbose(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,p.normalizeFileChanges)(y);this.verboseLogging&&b.forEach(u=>{this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`)}),b.length>0&&this.onDidFilesChange(b)})}onError(m){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${m}`})}onVerbose(m){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=v}),define(Z[74],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...A){this._entries=new Map;for(let[P,U]of A)this.set(P,U)}set(A,P){const U=this._entries.get(A);return this._entries.set(A,P),U}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=p}),define(Z[147],ee([0,1,11,137,50,5,74,6]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const g=!1;class v extends Error{constructor(u){var S;super("cyclic dependency between services");this.message=(S=u.findCycleSlow())!==null&&S!==void 0?S:`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class O{constructor(u=new U.ServiceCollection,S=!1,E){this._activeInstantiations=new Set,this._services=u,this._strict=S,this._parent=E,this._services.set(P.IInstantiationService,this)}createChild(u){return new O(u,this._strict,this)}invokeFunction(u,...S){let E=y.traceInvocation(u),C=!1;try{return u({get:(f,s)=>{if(C)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(f,E);if(!r&&s!==P.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return r}},...S)}finally{C=!0,E.stop()}}createInstance(u,...S){let E,C;return u instanceof A.SyncDescriptor?(E=y.traceCreation(u.ctor),C=this._createInstance(u.ctor,u.staticArguments.concat(S),E)):(E=y.traceCreation(u),C=this._createInstance(u,S,E)),E.stop(),C}_createInstance(u,S=[],E){let C=P._util.getServiceDependencies(u).sort((s,r)=>s.index-r.index),I=[];for(const s of C){let r=this._getOrCreateServiceInstance(s.id,E);if(!r&&this._strict&&!s.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${s.id}.`);I.push(r)}let f=C.length>0?C[0].index:S.length;if(S.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${S.length} static arguments`);let s=f-S.length;s>0?S=S.concat(new Array(s)):S=S.slice(0,f)}return new u(...[...S,...I])}_setServiceInstance(u,S){if(this._services.get(u)instanceof A.SyncDescriptor)this._services.set(u,S);else if(this._parent)this._parent._setServiceInstance(u,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let S=this._services.get(u);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):S}_getOrCreateServiceInstance(u,S){let E=this._getServiceInstanceOrDescriptor(u);return E instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,E,S.branch(u,!0)):(S.branch(u,!1),E)}_safeCreateAndCacheServiceInstance(u,S,E){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,S,E)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,S,E){const C=new k.Graph(s=>s.id.toString());let I=0;const f=[{id:u,desc:S,_trace:E}];for(;f.length;){const s=f.pop();if(C.lookupOrInsertNode(s),I++>1e3)throw new v(C);for(let r of P._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(r.id);if(!t&&!r.optional&&console.warn(`[createInstance] ${u} depends on ${r.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const i={id:r.id,desc:t,_trace:s._trace.branch(r.id,!0)};C.insertEdge(s,i),f.push(i)}}}for(;;){const s=C.roots();if(s.length===0){if(!C.isEmpty())throw new v(C);break}for(const{data:r}of s){if(this._getServiceInstanceOrDescriptor(r.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}C.removeNode(r)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,S,E=[],C,I){if(this._services.get(u)instanceof A.SyncDescriptor)return this._createServiceInstance(S,E,C,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,S,E,C,I);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(u,S=[],E,C){if(E){const I=new T.IdleValue(()=>this._createInstance(u,S,C));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let r=I.value,t=r[s];return typeof t!="function"||(t=t.bind(r),f[s]=t),t},set(f,s,r){return I.value[s]=r,!0}})}else return this._createInstance(u,S,C)}}e.InstantiationService=O;var m;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(m||(m={}));class y{constructor(u,S){this.type=u,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return g?new y(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(u){return g?new y(0,u.name):y._None}branch(u,S){let E=new y(2,u.toString());return this._dep.push([u,S,E]),E}stop(){let u=Date.now()-this._start;y._totals+=u;let S=!1;function E(I,f){let s=[],r=new Array(I+1).join("	");for(const[t,i,n]of f._dep)if(i&&n){S=!0,s.push(`${r}CREATES -> ${t}`);let o=E(I+1,n);o&&s.push(o)}else s.push(`${r}uses -> ${t}`);return s.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(u>2||S)&&console.log(C.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class p{constructor(A,P){this.server=A,this.router=P}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,P){this.server.registerChannel(A,P)}}e.MessagePortMainProcessService=p}),define(Z[149],ee([0,1,34,50,136,5]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class U{constructor(b,u,S){const E=S.getChannel(b);return T(u)?new u.channelClientCtor(E):p.ProxyChannel.toService(E,u==null?void 0:u.proxyOptions)}}function T(y){const b=y;return!!(b==null?void 0:b.channelClientCtor)}e.IMainProcessService=(0,P.createDecorator)("mainProcessService");let g=class extends U{constructor(b,u,S){super(b,u,S)}};g=he([Y(2,e.IMainProcessService)],g);function v(y,b,u){(0,A.registerSingleton)(y,new k.SyncDescriptor(g,[b,u],u==null?void 0:u.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=v,e.ISharedProcessService=(0,P.createDecorator)("sharedProcessService");let O=class extends U{constructor(b,u,S){super(b,u,S)}};O=he([Y(2,e.ISharedProcessService)],O);function m(y,b,u){(0,A.registerSingleton)(y,new k.SyncDescriptor(O,[b,u],u==null?void 0:u.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=m}),define(Z[55],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,p.createDecorator)("localizationsService");function k(A){if(typeof A.languageId!="string"||!Array.isArray(A.translations)||A.translations.length===0)return!1;for(const P of A.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(A.languageName&&typeof A.languageName!="string"||A.localizedLanguageName&&typeof A.localizedLanguageName!="string")}e.isValidLocalization=k}),define(Z[150],ee([0,1,2,55]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends p.Disposable{constructor(U){super();this.localizationsService=U,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};A=he([Y(0,k.ILocalizationsService)],A),e.LocalizationsUpdater=A}),define(Z[17],ee([0,1,5,2,7,3,43]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function T(){return new Date().toISOString()}var g;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;class v extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class O extends v{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(g.Trace)&&this.log(g.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(g.Debug)&&this.log(g.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(g.Info)&&this.log(g.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(g.Warning)&&this.log(g.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(g.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(g.Error,this.format(n))}else this.log(g.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(g.Critical)&&this.log(g.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let n=0;n<t.length;n++){let o=t[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(a){}i+=(n>0?" ":"")+o}return i}}e.AbstractMessageLogger=O;class m extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...i){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,t,...i):console.log(`[main ${T()}]`,t,...i))}debug(t,...i){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,t,...i):console.log(`[main ${T()}]`,t,...i))}info(t,...i){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,t,...i):console.log(`[main ${T()}]`,t,...i))}warn(t,...i){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,t,...i):console.warn(`[main ${T()}]`,t,...i))}error(t,...i){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,t,...i):console.error(`[main ${T()}]`,t,...i))}critical(t,...i){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,t,...i):console.error(`[main ${T()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class y extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=y;class b extends v{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=g.Trace&&this.adapter.log(g.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=g.Debug&&this.adapter.log(g.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=g.Info&&this.adapter.log(g.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=g.Warning&&this.adapter.log(g.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=g.Error&&this.adapter.log(g.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=g.Critical&&this.adapter.log(g.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,U.toErrorMessage)(t,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class u extends v{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const n of this.logServices)n.trace(t,...i)}debug(t,...i){for(const n of this.logServices)n.debug(t,...i)}info(t,...i){for(const n of this.logServices)n.info(t,...i)}warn(t,...i){for(const n of this.logServices)n.warn(t,...i)}error(t,...i){for(const n of this.logServices)n.error(t,...i)}critical(t,...i){for(const n of this.logServices)n.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class S extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=S;class E extends k.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}createLogger(t,i){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,(i==null?void 0:i.always)?g.Trace:this.logLevel,i),this.loggers.set(t.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class C{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(t){}getLevel(){return g.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=C;function I(r){if(r.verbose)return g.Trace;if(typeof r.logLevel=="string"){const t=f(r.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function f(r){switch(r){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=f;function s(r){switch(r){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=s}),define(Z[151],ee([0,1,27,2,10,29,9,4,12,33,17,31,56,7,6,11]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let C=class extends k.Disposable{constructor(f,s,r,t){super();this.fileService=s,this.extensionGalleryService=r,this.logService=t,this.extensionsDownloadDir=T.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const r=this.getName(f),t=(0,g.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(t)){const i=(0,g.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,s);try{await this.rename(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(o){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return t}async delete(f){}async rename(f,s,r){try{await p.promises.rename(f.fsPath,s.fsPath)}catch(t){if(b.isWindows&&t&&t.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,r);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],r=[];for(const n of f.children){const o=this.parse(n.name);o&&r.push([o,n])}const t=(0,v.groupByExtension)(r,([n])=>n),i=[];for(const n of t)n.sort((o,a)=>y.rcompare(o[0].version,a[0].version)),s.push(...n.slice(1).map(o=>o[1].resource)),i.push(n[0][1]);i.sort((n,o)=>n.mtime-o.mtime),s.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await u.Promises.settled(s.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new v.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,m.generateUuid)()}parse(f){const s=E.exec(f);return s&&s[1]&&s[2]?new v.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};C=he([Y(0,U.INativeEnvironmentService),Y(1,A.IFileService),Y(2,P.IExtensionGalleryService),Y(3,O.ILogService)],C),e.ExtensionsDownloader=C}),define(Z[152],ee([0,1,2,17,48,43,8,6,3,16,24,9]),function(K,e,p,k,A,P,U,T,g,v,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends p.Disposable{constructor(u,S){super();this.environmentService=u,this.logService=S,this.processesLimiter=new T.Limiter(5)}async postUninstall(u){const S=this.parseScript(u,"uninstall");return S&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${E}`)))),(0,O.rimraf)(this.getExtensionStoragePath(u)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(u,S){const E=`vscode:${S}`;if(u.location.scheme===v.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[E]=="string"){const C=u.manifest.scripts[E].split(" ");return C.length<2||C[0]!=="node"||!C[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${E} should be a node script`),null):{script:(0,U.join)(u.location.fsPath,C[1]),args:C.slice(2)||[]}}return null}runLifecycleHook(u,S,E,C,I){return new Promise((f,s)=>{const r=this.start(u,S,E,I);let t;const i=n=>{t&&(clearTimeout(t),t=null),n?s(n):f(void 0)};r.on("error",n=>{i((0,P.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,o)=>{i(n?`post-${S} process exited with code ${n}`:void 0)}),C&&(t=setTimeout(()=>{t=null,r.kill(),s("timed out")},5e3))})}start(u,S,E,C){const I={silent:!0,execArgv:void 0},f=(0,A.fork)(u,[`--type=extension-post-${S}`,...E],I);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=g.Event.fromNodeEventEmitter(f.stdout,"data"),r=g.Event.fromNodeEventEmitter(f.stderr,"data");s(n=>this.logService.info(C.identifier.id,C.manifest.version,`post-${S}`,n)),r(n=>this.logService.error(C.identifier.id,C.manifest.version,`post-${S}`,n));const t=g.Event.any(g.Event.map(s,n=>({data:`%c${n}`,format:[""]})),g.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return g.Event.debounce(t,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(C.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,U.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};y=he([Y(0,m.IEnvironmentService),Y(1,k.ILogService)],y),e.ExtensionsLifecycle=y}),define(Z[153],ee([0,1,2,9,3,10,4,33,12,17]),function(K,e,p,k,A,P,U,T,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let O=class extends p.Disposable{constructor(y,b,u,S){super();this.extensionsManagementService=y,this.logService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(y.onInstallExtension(I=>this.onInstallExtension(I))),this._register(y.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(y.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const E=U.URI.file(u.extensionsPath),C=new g.ExtUri(I=>!b.hasCapability(I,1024));this._register(b.watch(E)),this._register(A.Event.filter(b.onDidFilesChange,I=>I.changes.some(f=>this.doesChangeAffects(f,E,C)))(()=>this.onDidChange()))}doesChangeAffects(y,b,u){return u.isEqual(u.dirname(y.resource),b)?u.isEqual(y.resource,u.joinPath(b,".obsolete"))?!0:!(y.type!==1&&y.type!==2||u.basename(y.resource).startsWith(".")):!1}onInstallExtension(y){this.addInstallingExtension(y.identifier)}onDidInstallExtension(y){this.removeInstallingExtension(y.identifier),y.error||this.addInstalledExtension(y.identifier)}onDidUninstallExtension(y){y.error||this.removeInstalledExtension(y.identifier)}addInstallingExtension(y){this.removeInstallingExtension(y),this.installingExtensions.push(y)}removeInstallingExtension(y){this.installingExtensions=this.installingExtensions.filter(b=>!(0,T.areSameExtensions)(b,y))}addInstalledExtension(y){this.installedExtensions&&(this.removeInstalledExtension(y),this.installedExtensions.push(y))}removeInstalledExtension(y){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,T.areSameExtensions)(b,y)))}async onDidChange(){if(this.installedExtensions){const y=await this.extensionsManagementService.getInstalled(1),b=y.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(E=>(0,T.areSameExtensions)(E,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),u=this.installedExtensions.filter(S=>this.installingExtensions.some(E=>(0,T.areSameExtensions)(E,S))?!1:y.every(E=>!(0,T.areSameExtensions)(E.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=y.map(S=>S.identifier),(b.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:u})}}};O=he([Y(1,P.IFileService),Y(2,k.INativeEnvironmentService),Y(3,v.ILogService)],O),e.ExtensionsWatcher=O}),define(Z[154],ee([0,1,24,27,145,29,2,9,6,33,17,55,18,3,16,8]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let E=class extends U.Disposable{constructor(f,s,r){super();this.extensionManagementService=f,this.logService=r,this._onDidLanguagesChange=this._register(new b.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new C(s,r)),this._register(f.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(f.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(f=>{const s=["en",...Object.keys(f)];return(0,y.distinct)(s)})}onDidInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",f.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(f){this.cache.getLanguagePacks().then(s=>{Object.keys(s).some(r=>s[r]&&s[r].extensions.some(t=>(0,v.areSameExtensions)(t.extensionIdentifier,f)))&&(this.logService.debug("Removing language packs from the extension",f.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[f,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(s);return!(0,y.equals)(Object.keys(f),Object.keys(r))}};E=he([Y(0,P.IExtensionManagementService),Y(1,T.INativeEnvironmentService),Y(2,O.ILogService)],E),e.LocalizationsService=E;let C=class extends U.Disposable{constructor(f,s){super();this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,S.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new g.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(s=>{Object.keys(s).forEach(r=>delete s[r]),this.createLanguagePacksFromExtensions(s,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...s){for(const r of s)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,r);Object.keys(f).forEach(r=>this.updateHash(f[r]))}createLanguagePacksFromExtension(f,s){const r=s.identifier,t=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of t)if(s.location.scheme===u.Schemas.file&&(0,m.isValidLocalization)(i)){let n=f[i.languageId];n||(n={hash:"",extensions:[],translations:{}},f[i.languageId]=n);let o=n.extensions.filter(a=>(0,v.areSameExtensions)(a.extensionIdentifier,r))[0];o?o.version=s.manifest.version:n.extensions.push({extensionIdentifier:r,version:s.manifest.version});for(const a of i.translations)n.translations[a.id]=(0,S.join)(s.location.fsPath,a.path)}}updateHash(f){if(f){const s=(0,A.createHash)("md5");for(const r of f.extensions)s.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);f.hash=s.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return k.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(t){return{}}}).then(r=>(s=f(r),r)).then(r=>{for(const i of Object.keys(r))r[i]||delete r[i];this.languagePacks=r,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,p.writeFile)(this.languagePacksFilePath,t)}).then(()=>s,r=>this.logService.error(r))})}};C=he([Y(0,T.INativeEnvironmentService),Y(1,O.ILogService)],C)}),define(Z[75],ee([0,1,17,3,4]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class P{constructor(y){this.service=y,this.onDidChangeLogLevel=k.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(y,b,u){switch(b){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=P;class U{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){U.setLevel(this.channel,y)}static setLevel(y,b){return y.call("setLevel",b)}}e.LogLevelChannelClient=U;class T{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,b){throw new Error(`Event not found: ${b}`)}async call(y,b,u){switch(b){case"createLogger":this.createLogger(A.URI.revive(u[0]),u[1]);return;case"log":return this.log(A.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${b}`)}createLogger(y,b){this.loggers.set(y.toString(),this.loggerService.createLogger(y,b))}consoleLog(y,b){let u=console.log;switch(y){case p.LogLevel.Error:u=console.error;break;case p.LogLevel.Warning:u=console.warn;break;case p.LogLevel.Info:u=console.info;break}u.call(console,...b)}log(y,b){const u=this.loggers.get(y.toString());if(!u)throw new Error("Create the logger before logging");for(const[S,E]of b)switch(S){case p.LogLevel.Trace:u.trace(E);break;case p.LogLevel.Debug:u.debug(E);break;case p.LogLevel.Info:u.info(E);break;case p.LogLevel.Warning:u.warn(E);break;case p.LogLevel.Error:u.error(E);break;case p.LogLevel.Critical:u.critical(E);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=T;class g extends p.AbstractLoggerService{constructor(y,b,u){super(y,b);this.channel=u}createConsoleMainLogger(){return new p.AdapterLogger({log:(y,b)=>{this.channel.call("consoleLog",[y,b])}})}doCreateLogger(y,b,u){return new v(this.channel,y,b,u)}}e.LoggerChannelClient=g;class v extends p.AbstractMessageLogger{constructor(y,b,u,S){super(S==null?void 0:S.always);this.channel=y,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[b,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,b){const u=[[y,b]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(y){this.channel.call("log",[this.file,y])}}class O extends p.LogService{constructor(y,b){super(b);this.parent=y,this._register(y.onDidChangeLogLevel(u=>b.setLevel(u)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=O}),define(Z[57],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,p.createDecorator)("nativeHostService")}),define(Z[51],ee([0,1,16,7,36,12]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;if(typeof k.globals.vscode!="undefined"){const T=k.globals.vscode.context.configuration();if(T)U=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(K==null?void 0:K.__$__nodeRequire)=="function"){const T=(0,P.dirname)(p.FileAccess.asFileUri("",K));U=K.__$__nodeRequire((0,P.joinPath)(T,"product.json").fsPath);const g=K.__$__nodeRequire((0,P.joinPath)(T,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(U,{nameShort:`${U.nameShort} Dev`,nameLong:`${U.nameLong} Dev`,dataFolderName:`${U.dataFolderName}-dev`}),Object.assign(U,{version:g.version})}else U={},Object.keys(U).length===0&&Object.assign(U,{version:"1.57.0-dev",nameShort:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=U}),define(Z[76],ee([0,1,115,23,10,11,51]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(m,y,b,u,S,E){let C;try{await g(m,y,b,u,S,E)}catch(I){C=I}finally{C&&S.errorTransformer&&(C=S.errorTransformer(C)),typeof C!="undefined"&&b.error(C),b.end()}}e.readFileIntoStream=T;async function g(m,y,b,u,S,E){v(E);const C=await m.open(y,{create:!1});try{v(E);let I=0,f=0,s=S&&typeof S.length=="number"?S.length:void 0,r=k.VSBuffer.alloc(Math.min(S.bufferSize,typeof s=="number"?s:S.bufferSize)),t=S&&typeof S.position=="number"?S.position:0,i=0;do f=await m.read(C,t,r.buffer,i,r.byteLength-i),t+=f,i+=f,I+=f,typeof s=="number"&&(s-=f),i===r.byteLength&&(await b.write(u(r)),r=k.VSBuffer.alloc(Math.min(S.bufferSize,typeof s=="number"?s:S.bufferSize)),i=0);while(f>0&&(typeof s!="number"||s>0)&&v(E)&&O(I,S));if(i>0){let n=i;typeof s=="number"&&(n=Math.min(i,s)),b.write(u(r.slice(0,n)))}}catch(I){throw(0,A.ensureFileSystemProviderError)(I)}finally{await m.close(C)}}function v(m){if(m.isCancellationRequested)throw(0,P.canceled)();return!0}function O(m,y){if(y==null?void 0:y.limits){if(typeof y.limits.memory=="number"&&m>y.limits.memory)throw(0,A.createFileSystemProviderError)((0,p.localize)(0,null,U.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&m>y.limits.size)throw(0,A.createFileSystemProviderError)((0,p.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[155],ee([0,1,113,156,2,10,3,12,37,18,17,23,47,6,30,16,76,53]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class extends A.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new U.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new U.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new U.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new U.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new U.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new U.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(s,r){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:r});const t=new A.DisposableStore;return t.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new P.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),t.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:s}))),typeof r.onDidErrorOccur=="function"&&t.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,A.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:r}),this.provider.delete(s),(0,A.dispose)(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){r.push(t)}}),!this.provider.has(s)&&await b.Promises.settled(r)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,r){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return C.Iterable.map(this.provider,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async withProvider(s){if(!(0,T.isAbsolutePath)(s))throw new P.FileOperationError((0,p.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const r=this.provider.get(s.scheme);if(!r){const t=new Error;throw t.name="ENOPRO",t.message=(0,p.localize)(1,null,s.toString()),t}return r}async withReadProvider(s){const r=await this.withProvider(s);if((0,P.hasOpenReadWriteCloseCapability)(r)||(0,P.hasReadWriteCapability)(r)||(0,P.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const r=await this.withProvider(s);if((0,P.hasOpenReadWriteCloseCapability)(r)||(0,P.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.doResolveFile(s,r)}catch(t){throw(0,P.toFileSystemProviderErrorCode)(t)===P.FileSystemProviderErrorCode.FileNotFound?new P.FileOperationError((0,p.localize)(2,null,this.resourceForError(s)),1):(0,P.ensureFileSystemProviderError)(t)}}async doResolveFile(s,r){const t=await this.withProvider(s),i=this.isPathCaseSensitive(t),n=r==null?void 0:r.resolveTo,o=r==null?void 0:r.resolveSingleChildDescendants,a=r==null?void 0:r.resolveMetadata,c=await t.stat(s);let l;return this.toFileStat(t,s,c,void 0,!!a,(d,w)=>(l||(l=g.TernarySearchTree.forUris(()=>!i),l.set(s,!0),(0,v.isNonEmptyArray)(n)&&n.forEach(h=>l.set(h,!0))),Boolean(l.findSuperstr(d.resource)||l.get(d.resource))?!0:d.isDirectory&&o?w===1:!1))}async toFileStat(s,r,t,i,n,o){const{providerExtUri:a}=this.getExtUri(s),c={resource:r,name:a.basename(r),isFile:(t.type&P.FileType.File)!=0,isDirectory:(t.type&P.FileType.Directory)!=0,isSymbolicLink:(t.type&P.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,P.etag)({mtime:t.mtime,size:t.size})};if(c.isDirectory&&o(c,i)){try{const l=await s.readdir(r),d=await b.Promises.settled(l.map(async([w,h])=>{try{const R=a.joinPath(r,w),_=n?await s.stat(R):{type:h};return await this.toFileStat(s,R,_,l.length,n,o)}catch(R){return this.logService.trace(R),null}}));c.children=(0,v.coalesce)(d)}catch(l){this.logService.trace(l),c.children=[]}return c}return c}async resolveAll(s){return b.Promises.settled(s.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const r=await this.withProvider(s);try{return!!await r.stat(s)}catch(t){return!1}}async canCreateFile(s,r){try{await this.doValidateCreateFile(s,r)}catch(t){return t}return!0}async doValidateCreateFile(s,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(s))throw new P.FileOperationError((0,p.localize)(3,null,this.resourceForError(s)),3,r)}async createFile(s,r=m.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const i=await this.writeFile(s,r);return this._onDidRunOperation.fire(new P.FileOperationEvent(s,0,i)),i}async writeFile(s,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,t)||await this.mkdirp(i,n.dirname(s));let a;if((0,P.hasReadWriteCapability)(i)&&!(r instanceof m.VSBuffer))if((0,y.isReadableStream)(r)){const c=await(0,y.peekStream)(r,3);c.ended?a=m.VSBuffer.concat(c.buffer):a=c}else a=(0,y.peekReadable)(r,c=>m.VSBuffer.concat(c),3);else a=r;!(0,P.hasOpenReadWriteCloseCapability)(i)||(0,P.hasReadWriteCapability)(i)&&a instanceof m.VSBuffer?await this.doWriteUnbuffered(i,s,t,a):await this.doWriteBuffered(i,s,t,a instanceof m.VSBuffer?(0,m.bufferToReadable)(a):a)}catch(o){throw new P.FileOperationError((0,p.localize)(4,null,this.resourceForError(s),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,r,t){if(!!(t==null?void 0:t.unlock)&&!(s.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(r)));let n;try{n=await s.stat(r)}catch(o){return}if((n.type&P.FileType.Directory)!=0)throw new P.FileOperationError((0,p.localize)(6,null,this.resourceForError(r)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==P.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,P.etag)({mtime:t.mtime,size:n.size}))throw new P.FileOperationError((0,p.localize)(7,null),3,t);return n}async readFile(s,r){const t=await this.withReadProvider(s);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(t,s,r):this.doReadFile(t,s,r)}async doReadFileAtomic(s,r,t){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(s,r,t);i(o)}catch(o){n(o)}})})}async doReadFile(s,r,t){const i=await this.doReadFileStream(s,r,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,m.streamToBuffer)(i.value)})}async readFileStream(s,r){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,r)}async doReadFileStream(s,r,t){const i=new u.CancellationTokenSource,n=this.validateReadFile(r,t).then(a=>a,a=>{throw i.cancel(),a});let o;try{t&&typeof t.etag=="string"&&t.etag!==P.ETAG_DISABLED&&await n,!((0,P.hasOpenReadWriteCloseCapability)(s)||(0,P.hasFileReadStreamCapability)(s))||(0,P.hasReadWriteCapability)(s)&&(t==null?void 0:t.preferUnbuffered)?o=this.readFileUnbuffered(s,r,t):(0,P.hasFileReadStreamCapability)(s)?o=this.readFileStreamed(s,r,i.token,t):o=this.readFileBuffered(s,r,i.token,t);const a=await n;return Object.assign(Object.assign({},a),{value:o})}catch(a){throw o&&await(0,y.consumeStream)(o),new P.FileOperationError((0,p.localize)(8,null,this.resourceForError(r),(0,P.ensureFileSystemProviderError)(a).toString()),(0,P.toFileOperationResult)(a),t)}}readFileStreamed(s,r,t,i=Object.create(null)){const n=s.readFileStream(r,i,t);return(0,y.transform)(n,{data:o=>o instanceof m.VSBuffer?o:m.VSBuffer.wrap(o),error:o=>new P.FileOperationError((0,p.localize)(9,null,this.resourceForError(r),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),i)},o=>m.VSBuffer.concat(o))}readFileBuffered(s,r,t,i=Object.create(null)){const n=(0,m.newWriteableBufferStream)();return(0,E.readFileIntoStream)(s,r,n,o=>o,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new P.FileOperationError((0,p.localize)(10,null,this.resourceForError(r),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),i)}),t),n}readFileUnbuffered(s,r,t){const i=(0,y.newWriteableStream)(n=>m.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(r);t&&typeof t.position=="number"&&(n=n.slice(t.position)),t&&typeof t.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(r,n.byteLength,t),i.end(m.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,r){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new P.FileOperationError((0,p.localize)(11,null,this.resourceForError(s)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==P.ETAG_DISABLED&&r.etag===t.etag)throw new P.FileOperationError((0,p.localize)(12,null),2,r);return this.validateReadFileLimits(s,t.size,r),t}validateReadFileLimits(s,r,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&r>t.limits.size&&(i=7),typeof i=="number")throw new P.FileOperationError((0,p.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,r,t){return this.doCanMoveCopy(s,r,"move",t)}async canCopy(s,r,t){return this.doCanMoveCopy(s,r,"copy",t)}async doCanMoveCopy(s,r,t,i){if(s.toString()!==r.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,s,o,r,t,i)}catch(n){return n}return!0}async move(s,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,s,n,r,"move",!!t),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(s,o==="move"?2:3,a)),a}async copy(s,r,t){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,s,n,r,"copy",!!t),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(s,o==="copy"?3:2,a)),a}async doMoveCopy(s,r,t,i,n,o){if(r.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(s,r,t,i,n,o);if(a&&!c&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),n==="copy"){if(s===t&&(0,P.hasFileFolderCopyCapability)(s))await s.copy(r,i,{overwrite:o});else{const l=await this.resolve(r);l.isDirectory?await this.doCopyFolder(s,l,t,i):await this.doCopyFile(s,r,t,i)}return n}else return s===t?(await s.rename(r,i,{overwrite:o}),n):(await this.doMoveCopy(s,r,t,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(s,r,t,i){if((0,P.hasOpenReadWriteCloseCapability)(s)&&(0,P.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,r,t,i);if((0,P.hasOpenReadWriteCloseCapability)(s)&&(0,P.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,r,t,i);if((0,P.hasReadWriteCapability)(s)&&(0,P.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,r,t,i);if((0,P.hasReadWriteCapability)(s)&&(0,P.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,r,t,i)}async doCopyFolder(s,r,t,i){await t.mkdir(i),Array.isArray(r.children)&&await b.Promises.settled(r.children.map(async n=>{const o=this.getExtUri(t).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),t,o):this.doCopyFile(s,n.resource,t,o)}))}async doValidateMoveCopy(s,r,t,i,n,o){let a=!1;if(s===t){const{providerExtUri:l,isPathCaseSensitive:d}=this.getExtUri(s);if(d||(a=l.isEqual(r,i)),a&&n==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!a&&l.isEqualOrParent(i,r))throw new Error((0,p.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!a){if(!o)throw new P.FileOperationError((0,p.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(s===t){const{providerExtUri:l}=this.getExtUri(s);if(l.isEqualOrParent(r,i))throw new Error((0,p.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(s){const r=this.isPathCaseSensitive(s);return{providerExtUri:r?T.extUri:T.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(r,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(s,0,t)),t}async mkdirp(s,r){const t=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(r,i.dirname(r));)try{if(((await s.stat(r)).type&P.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,P.toFileSystemProviderErrorCode)(n)!==P.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(i.basename(r)),r=i.dirname(r)}for(let n=t.length-1;n>=0;n--){r=i.joinPath(r,t[n]);try{await s.mkdir(r)}catch(o){if((0,P.toFileSystemProviderErrorCode)(o)!==P.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,r){try{await this.doValidateDelete(s,r)}catch(t){return t}return!0}async doValidateDelete(s,r){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!(r==null?void 0:r.useTrash)&&!(t.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(s)));const n=await this.exists(s);if(!n)throw new P.FileOperationError((0,p.localize)(20,null,this.resourceForError(s)),1);if(!!!(r==null?void 0:r.recursive)&&n){const a=await this.resolve(s);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(s)))}return t}async del(s,r){const t=await this.doValidateDelete(s,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await t.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new P.FileOperationEvent(s,1))}watch(s,r={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(s,r).then(n=>{t?(0,A.dispose)(n):i=()=>(0,A.dispose)(n)},n=>this.logService.error(n)),(0,A.toDisposable)(()=>i())}async doWatch(s,r){const t=await this.withProvider(s),i=this.toWatchKey(t,s,r),n=this.activeWatchers.get(i)||{count:0,disposable:t.watch(s,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,A.toDisposable)(()=>{n.count--,n.count===0&&((0,A.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(s,r,t){const{providerExtUri:i}=this.getExtUri(s);return[i.getComparisonKey(r),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,A.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,r,t,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{var n;const o=await s.open(r,{create:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,o,i):await this.doWriteReadableBufferedQueued(s,o,i)}catch(a){throw(0,P.ensureFileSystemProviderError)(a)}finally{await s.close(o)}})}async doWriteStreamBufferedQueued(s,r,t){let i=0,n;if((0,y.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=m.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,r,o,o.byteLength,i,0),i+=o.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(o,a)=>{(0,y.listenStream)(n,{onData:async c=>{n.pause();try{await this.doWriteBuffer(s,r,c,c.byteLength,i,0)}catch(l){return a(l)}i+=c.byteLength,setTimeout(()=>n.resume())},onError:c=>a(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,r,t){let i=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(s,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,r,t,i,n,o){let a=0;for(;a<i;)a+=await s.write(r,n+a,t.buffer,o+a,i-a)}async doWriteUnbuffered(s,r,t,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,r,t,i))}async doWriteUnbufferedQueued(s,r,t,i){var n;let o;i instanceof m.VSBuffer?o=i:(0,y.isReadableStream)(i)?o=await(0,m.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?o=await(0,m.bufferedStreamToBuffer)(i):o=(0,m.readableToBuffer)(i),await s.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,r,t,i))}async doPipeBufferedQueued(s,r,t,i){let n,o;try{n=await s.open(r,{create:!1}),o=await t.open(i,{create:!0,unlock:!1});const a=m.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,l=0,d=0;do d=await s.read(n,c,a.buffer,l,a.byteLength-l),await this.doWriteBuffer(t,o,a,d,c,l),c+=d,l+=d,l===a.byteLength&&(l=0);while(d>0)}catch(a){throw(0,P.ensureFileSystemProviderError)(a)}finally{await b.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,r,t,i))}async doPipeUnbufferedQueued(s,r,t,i){return t.writeFile(i,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,r,t,i))}async doPipeUnbufferedToBufferedQueued(s,r,t,i){const n=await t.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(r);await this.doWriteBuffer(t,n,m.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,P.ensureFileSystemProviderError)(o)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(s,r,t,i){const n=await(0,m.streamToBuffer)(this.readFileBuffered(s,r,u.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,n)}throwIfFileSystemIsReadonly(s,r){if(s.capabilities&2048)throw new P.FileOperationError((0,p.localize)(22,null,this.resourceForError(r)),6);return s}resourceForError(s){return s.scheme===S.Schemas.file?s.fsPath:s.toString(!0)}};I=he([Y(0,O.ILogService)],I),e.FileService=I}),define(Z[157],ee([0,1,27,94,2,10,3,7,24,8,12,42,6,17,116,73,133,135,132,146,47,76,18,23]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I,f,s,r,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class n extends A.Disposable{constructor(a,c){var l;super();this.logService=a,this.options=c,this.BUFFER_SIZE=((l=this.options)===null||l===void 0?void 0:l.bufferSize)||64*1024,this.onDidChangeCapabilities=U.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new U.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(a){try{const{stat:c,symbolicLink:l}=await g.SymlinkSupport.stat(this.toFilePath(a));return{type:this.toType(c,l),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size}}catch(c){throw this.toFileSystemProviderError(c)}}async readdir(a){try{const c=await(0,g.readdir)(this.toFilePath(a),{withFileTypes:!0}),l=[];return await Promise.all(c.map(async d=>{try{let w;d.isSymbolicLink()?w=(await this.stat((0,O.joinPath)(a,d.name))).type:w=this.toType(d),l.push([d.name,w])}catch(w){this.logService.trace(w)}})),l}catch(c){throw this.toFileSystemProviderError(c)}}toType(a,c){let l;return(c==null?void 0:c.dangling)?l=P.FileType.Unknown:a.isFile()?l=P.FileType.File:a.isDirectory()?l=P.FileType.Directory:l=P.FileType.Unknown,c&&(l|=P.FileType.SymbolicLink),l}async readFile(a){try{const c=this.toFilePath(a);return await p.promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}}readFileStream(a,c,l){const d=(0,s.newWriteableStream)(w=>i.VSBuffer.concat(w.map(h=>i.VSBuffer.wrap(h))).buffer);return(0,r.readFileIntoStream)(this,a,d,w=>w.buffer,Object.assign(Object.assign({},c),{bufferSize:this.BUFFER_SIZE}),l),d}async writeFile(a,c,l){let d;try{const w=this.toFilePath(a);if(!l.create||!l.overwrite){if(await(0,g.exists)(w)){if(!l.overwrite)throw(0,P.createFileSystemProviderError)((0,u.localize)(0,null),P.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,P.createFileSystemProviderError)((0,u.localize)(1,null),P.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(a,{create:!0,unlock:l.unlock}),await this.write(d,0,c,0,c.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(a,w)}finally{typeof d=="number"&&await this.close(d)}}async open(a,c){try{const l=this.toFilePath(a);if((0,P.isFileOpenForWriteOptions)(c)&&c.unlock)try{const{stat:h}=await g.SymlinkSupport.stat(l);h.mode&128||await p.promises.chmod(l,h.mode|128)}catch(h){this.logService.trace(h)}let d;if((0,P.isFileOpenForWriteOptions)(c)){if(T.isWindows)try{await p.promises.truncate(l,0),d="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}d||(d="w")}else d="r";const w=await(0,k.promisify)(p.open)(l,d);return this.mapHandleToPos.set(w,0),(0,P.isFileOpenForWriteOptions)(c)&&this.writeHandles.set(w,a),w}catch(l){throw(0,P.isFileOpenForWriteOptions)(c)?await this.toFileSystemProviderWriteError(a,l):this.toFileSystemProviderError(l)}}async close(a){try{if(this.mapHandleToPos.delete(a),this.writeHandles.delete(a)&&this.canFlush)try{await(0,k.promisify)(p.fdatasync)(a)}catch(c){this.canFlush=!1,this.logService.error(c)}return await(0,k.promisify)(p.close)(a)}catch(c){throw this.toFileSystemProviderError(c)}}async read(a,c,l,d,w){const h=this.normalizePos(a,c);let R=null;try{const _=await(0,k.promisify)(p.read)(a,l,d,w,h);return typeof _=="number"?R=_:R=_.bytesRead,R}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(a,h,R)}}normalizePos(a,c){return c===this.mapHandleToPos.get(a)?null:c}updatePos(a,c,l){const d=this.mapHandleToPos.get(a);typeof d=="number"&&(typeof c=="number"||(typeof l=="number"?this.mapHandleToPos.set(a,d+l):this.mapHandleToPos.delete(a)))}async write(a,c,l,d,w){return(0,y.retry)(()=>this.doWrite(a,c,l,d,w),100,3)}async doWrite(a,c,l,d,w){const h=this.normalizePos(a,c);let R=null;try{const _=await(0,k.promisify)(p.write)(a,l,d,w,h);return typeof _=="number"?R=_:R=_.bytesWritten,R}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(a),_)}finally{this.updatePos(a,h,R)}}async mkdir(a){try{await p.promises.mkdir(this.toFilePath(a))}catch(c){throw this.toFileSystemProviderError(c)}}async delete(a,c){try{const l=this.toFilePath(a);await this.doDelete(l,c)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(a,c){c.recursive?await(0,g.rimraf)(a,g.RimRafMode.MOVE):await p.promises.unlink(a)}async rename(a,c,l){const d=this.toFilePath(a),w=this.toFilePath(c);if(d!==w)try{await this.validateTargetDeleted(a,c,"move",l.overwrite),await(0,g.move)(d,w)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,u.localize)(2,null,(0,v.basename)(d),(0,v.basename)((0,v.dirname)(w)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(a,c,l){const d=this.toFilePath(a),w=this.toFilePath(c);if(d!==w)try{await this.validateTargetDeleted(a,c,"copy",l.overwrite),await(0,g.copy)(d,w,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,u.localize)(3,null,(0,v.basename)(d),(0,v.basename)((0,v.dirname)(w)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(a,c,l,d){const w=this.toFilePath(a),h=this.toFilePath(c);let R=!1;if(!!(this.capabilities&1024)||(R=(0,m.isEqual)(w,h,!0)),R&&l==="copy")throw(0,P.createFileSystemProviderError)((0,u.localize)(4,null),P.FileSystemProviderErrorCode.FileExists);if(!R&&await(0,g.exists)(h)){if(!d)throw(0,P.createFileSystemProviderError)((0,u.localize)(5,null),P.FileSystemProviderErrorCode.FileExists);await this.delete(c,{recursive:!0,useTrash:!1})}}watch(a,c){return c.recursive?this.watchRecursive(a,c.excludes):this.watchNonRecursive(a)}watchRecursive(a,c){const l={path:this.toFilePath(a),excludes:c},d=(0,t.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,A.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var a,c,l;if(this.recursiveWatcher instanceof I.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let d,w;((c=(a=this.options)===null||a===void 0?void 0:a.watcher)===null||c===void 0?void 0:c.usePolling)?(d=E.FileWatcher,w=(l=this.options)===null||l===void 0?void 0:l.watcher):this.recursiveFoldersToWatch.length===1?T.isWindows?d=C.FileWatcher:d=E.FileWatcher:d=I.FileWatcher,this.recursiveWatcher=new d(this.recursiveFoldersToWatch,h=>this._onDidChangeFile.fire((0,S.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===b.LogLevel.Trace,w),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(a){const c=new f.FileWatcher(this.toFilePath(a),d=>this._onDidChangeFile.fire((0,S.toFileChanges)(d)),d=>{d.type==="error"&&this._onDidWatchErrorOccur.fire(d.message),this.logService[d.type](d.message)},this.logService.getLevel()===b.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{c.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,A.combinedDisposable)(c,l)}toFilePath(a){return(0,v.normalize)(a.fsPath)}toFileSystemProviderError(a){if(a instanceof P.FileSystemProviderError)return a;let c;switch(a.code){case"ENOENT":c=P.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=P.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=P.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=P.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=P.FileSystemProviderErrorCode.NoPermissions;break;default:c=P.FileSystemProviderErrorCode.Unknown}return(0,P.createFileSystemProviderError)(a,c)}async toFileSystemProviderWriteError(a,c){let l=this.toFileSystemProviderError(c);if(a&&l.code===P.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await g.SymlinkSupport.stat(this.toFilePath(a));d.mode&128||(l=(0,P.createFileSystemProviderError)(c,P.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return l}dispose(){super.dispose(),(0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,A.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=n}),define(Z[28],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[158],ee([0,1,27,8,24,28,2,11,17,9]),function(K,e,p,k,A,P,U,T,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let O=class extends U.Disposable{constructor(y,b,u){super();this._environmentService=y,this._logService=b,this._productService=u,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let y=setTimeout(async()=>{y=void 0,this._logService.info("Starting to clean up unused language packs.");try{const b=Object.create(null),u=JSON.parse(await p.promises.readFile(k.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let I of Object.keys(u)){const f=u[I];b[`${f.hash}.${I}`]=!0}const S=k.join(this._environmentService.userDataPath,"clp");if(!await A.exists(S))return;for(let I of await A.readdir(S)){if(b[I]){this._logService.info(`Skipping directory ${I}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",I),await A.rimraf(k.join(S,I))}const C=Date.now();for(let I of Object.keys(b)){const f=k.join(S,I);for(let s of await A.readdir(f))if(s!=="tcf.json"){const r=k.join(f,s),t=await p.promises.stat(r);t.isDirectory()&&C-t.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",k.join(I,s)),await A.rimraf(r))}}}catch(b){(0,T.onUnexpectedError)(b)}},40*1e3);this._register((0,U.toDisposable)(()=>{y!==void 0&&clearTimeout(y)}))}};O=he([Y(0,v.INativeEnvironmentService),Y(1,g.ILogService),Y(2,P.IProductService)],O),e.LanguagePackCachedDataCleaner=O}),define(Z[159],ee([0,1,27,8,11,2,24,28]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let g=class{constructor(O,m){this.nodeCachedDataDir=O,this.productService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new P.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const O=(0,k.dirname)(this.nodeCachedDataDir),m=(0,k.basename)(this.nodeCachedDataDir);let y=setTimeout(()=>{y=void 0,(0,U.readdir)(O).then(b=>{const u=Date.now(),S=[];return b.forEach(E=>{if(E!==m){const C=(0,k.join)(O,E);S.push(p.promises.stat(C).then(I=>{if(I.isDirectory()&&u-I.mtime.getTime()>this._DataMaxAge)return(0,U.rimraf)(C)}))}}),Promise.all(S)}).then(void 0,A.onUnexpectedError)},30*1e3);this._disposables.add((0,P.toDisposable)(()=>{y&&(clearTimeout(y),y=void 0)}))}}};g=he([Y(1,T.IProductService)],g),e.NodeCachedDataCleaner=g}),define(Z[35],ee([0,1,15,84]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(U,T){k.ok(p.isString(U)),k.ok(p.isObject(T)),k.ok(!this.data.has(U),"There is already an extension with this id"),this.data.set(U,T)}knows(U){return this.data.has(U)}as(U){return this.data.get(U)||null}}e.Registry=new A}),define(Z[77],ee([0,1,35,3]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class P{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,v){this.schemasById[A(g)]=v,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const U=new P;p.Registry.add(e.Extensions.JSONContribution,U)}),define(Z[39],ee([0,1,106,3,35,15,77]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=A.Registry.as(U.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(C,I=!0){this.registerConfigurations([C],I)}registerConfigurations(C,I=!0){const f=[];C.forEach(s=>{f.push(...this.validateAndRegisterProperties(s,I,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(C){const I=[],f=s=>{if(s.properties)for(const r in s.properties)I.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,s.properties[r]);s.allOf&&s.allOf.forEach(r=>f(r))};for(const s of C){f(s);const r=this.configurationContributors.indexOf(s);r!==-1&&this.configurationContributors.splice(r,1)}g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}registerDefaultConfigurations(C){const I=[],f=[];for(const s of C)for(const r in s)if(I.push(r),e.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),s[r]);const t={type:"object",default:this.defaultValues[r],description:p.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId};f.push(m(r)),this.configurationProperties[r]=t,this.defaultLanguageConfigurationOverridesNode.properties[r]=t}else{this.defaultValues[r]=s[r];const t=this.configurationProperties[r];t&&(this.updatePropertyDefaultValue(r,t),this.updateSchema(r,t))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterDefaultConfigurations(C){const I=[];for(const f of C)for(const s in f)if(I.push(s),delete this.defaultValues[s],e.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const I of C)this.overrideIdentifiers.add(I);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(C,I=!0,f,s=3){var r;s=P.isUndefinedOrNull(C.scope)?s:C.scope;let t=[],i=C.properties;if(i)for(let o in i){if(I&&u(o)){delete i[o];continue}const a=i[o];if(this.updatePropertyDefaultValue(o,a),e.OVERRIDE_PROPERTY_PATTERN.test(o)?a.scope=void 0:(a.scope=P.isUndefinedOrNull(a.scope)?s:a.scope,a.restricted=P.isUndefinedOrNull(a.restricted)?!!((r=f==null?void 0:f.restrictedConfigurations)===null||r===void 0?void 0:r.includes(o)):a.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),t.push(o)}let n=C.allOf;if(n)for(let o of n)t.push(...this.validateAndRegisterProperties(o,I,f,s));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(C){const I=f=>{let s=f.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let r=f.allOf;r&&r.forEach(I)};I(C)}updateSchema(C,I){switch(e.allSettings.properties[C]=I,I.scope){case 1:e.applicationSettings.properties[C]=I;break;case 2:e.machineSettings.properties[C]=I;break;case 6:e.machineOverridableSettings.properties[C]=I;break;case 3:e.windowSettings.properties[C]=I;break;case 4:e.resourceSettings.properties[C]=I;break;case 5:e.resourceSettings.properties[C]=I,this.resourceLanguageSettingsSchema.properties[C]=I;break}}removeFromSchema(C,I){switch(delete e.allSettings.properties[C],I.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const I=`[${C}]`,f={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(I,f),e.allSettings.properties[I]=f,e.applicationSettings.properties[I]=f,e.machineSettings.properties[I]=f,e.machineOverridableSettings.properties[I]=f,e.windowSettings.properties[I]=f,e.resourceSettings.properties[I]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,I){let f=this.defaultValues[C];P.isUndefined(f)&&(f=I.default),P.isUndefined(f)&&(f=y(I.type)),I.default=f}}const O="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(O);function m(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=m;function y(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const b=new v;A.Registry.add(e.Extensions.Configuration,b);function u(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?p.localize(5,null,E):b.getConfigurationProperties()[E]!==void 0?p.localize(6,null,E):null:p.localize(4,null)}e.validateProperty=u;function S(){const E=[],C=b.getConfigurationProperties();for(const I of Object.keys(C))E.push([I,C[I].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=S}),define(Z[25],ee([0,1,26,15,4,35,5,39]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,U.createDecorator)("configurationService");function g(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationOverrides=g;var v;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(v=e.ConfigurationTarget||(e.ConfigurationTarget={}));function O(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=O;function m(i,n){const o=n?i?n.keys.filter(R=>i.keys.indexOf(R)===-1):[...n.keys]:[],a=i?n?i.keys.filter(R=>n.keys.indexOf(R)===-1):[...i.keys]:[],c=[];if(n&&i){for(const R of i.keys)if(n.keys.indexOf(R)!==-1){const _=C(i.contents,R),j=C(n.contents,R);p.equals(_,j)||c.push(R)}}const l=[],d=R=>{const _={};for(const j of R)for(const B of j.identifiers)_[r(B)]=j;return _},w=n?d(n.overrides):{},h=i?d(i.overrides):{};if(Object.keys(w).length)for(const R of o){const _=w[R];_&&l.push([(0,T.overrideIdentifierFromKey)(R),_.keys])}if(Object.keys(h).length)for(const R of a){const _=h[R];_&&l.push([(0,T.overrideIdentifierFromKey)(R),_.keys])}if(Object.keys(w).length&&Object.keys(h).length)for(const R of c){const _=h[R],j=w[R];if(_&&j){const B=m({contents:_.contents,keys:_.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});l.push([(0,T.overrideIdentifierFromKey)(R),[...B.added,...B.removed,...B.updated]])}}return{added:o,removed:a,updated:c,overrides:l}}e.compare=m;function y(i,n){const o=[];for(const a of Object.keys(i))if(T.OVERRIDE_PROPERTY_PATTERN.test(a)){const c={};for(const l in i[a])c[l]=i[a][l];o.push({identifiers:[(0,T.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(c),contents:b(c,n)})}return o}e.toOverrides=y;function b(i,n){const o=Object.create(null);for(let a in i)u(o,a,i[a],n);return o}e.toValuesTree=b;function u(i,n,o,a){const c=n.split("."),l=c.pop();let d=i;for(let w=0;w<c.length;w++){let h=c[w],R=d[h];switch(typeof R){case"undefined":R=d[h]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${c.slice(0,w+1).join(".")} is ${JSON.stringify(R)}`);return}d=R}if(typeof d=="object"&&d!==null)try{d[l]=o}catch(w){a(`Ignoring ${n} as ${c.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${n} as ${c.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=u;function S(i,n){const o=n.split(".");E(i,o)}e.removeFromValueTree=S;function E(i,n){const o=n.shift();if(n.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const a=i[o];typeof a=="object"&&!Array.isArray(a)&&(E(a,n),Object.keys(a).length===0&&delete i[o])}}function C(i,n,o){function a(d,w){let h=d;for(const R of w){if(typeof h!="object"||h===null)return;h=h[R]}return h}const c=n.split("."),l=a(i,c);return typeof l=="undefined"?o:l}e.getConfigurationValue=C;function I(i,n,o){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?k.isObject(i[a])&&k.isObject(n[a])?I(i[a],n[a],o):o&&(i[a]=n[a]):i[a]=n[a])})}e.merge=I;function f(){const i=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=f;function s(){const i=Object.create(null),n=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let o in n){let a=n[o].default;u(i,o,a,c=>console.error(`Conflict in default settings: ${c}`))}return i}e.getDefaultValues=s;function r(i){return`[${i}]`}e.keyFromOverrideIdentifier=r;function t(i,n,o){const a=i.inspect(n),c=i.inspect(o);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:a.defaultValue}e.getMigratedSettingValue=t}),define(Z[160],ee([0,1,32,37,18,15,26,4,39,25,35,2,3]),function(K,e,p,k,A,P,U,T,g,v,O,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},i=[],n=[]){this._contents=t,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,v.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const n=this.getContentsForOverrideIdentifer(i);return n?t?(0,v.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o],c=i[o];c&&(typeof a=="object"&&typeof c=="object"?(a=U.deepClone(a),this.mergeContents(a,c)):a=c),n[o]=a}return new b(n,this.keys,this.overrides)}merge(...t){const i=U.deepClone(this.contents),n=U.deepClone(this.overrides),o=[...this.keys];for(const a of t){this.mergeContents(i,a.contents);for(const c of a.overrides){const[l]=n.filter(d=>A.equals(d.identifiers,c.identifiers));l?this.mergeContents(l.contents,c.contents):n.push(U.deepClone(c))}for(const c of a.keys)o.indexOf(c)===-1&&o.push(c)}return new b(i,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const n of Object.keys(i)){if(n in t&&P.isObject(t[n])&&P.isObject(i[n])){this.mergeContents(t[n],i[n]);continue}t[n]=U.deepClone(i[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?U.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,v.addToValueTree)(this.contents,t,i,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,v.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let n=0;n<i;n++)t.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class u extends b{constructor(){const t=(0,v.getDefaultValues)(),i=(0,v.getConfigurationKeys)(),n=[];for(const o of Object.keys(t))g.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,g.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,v.toValuesTree)(t[o],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,i,n)}}e.DefaultConfigurationModel=u;class S{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!P.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:n,keys:o,overrides:a,restricted:c}=this.doParseRaw(t,i);this._configurationModel=new b(n,o,a),this._restrictedConfigurations=c||[]}doParseContent(t){let i={},n=null,o=[],a=[],c=[];function l(w){Array.isArray(o)?o.push(w):n&&(o[n]=w)}let d={onObjectBegin:()=>{let w={};l(w),a.push(o),o=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let w=[];l(w),a.push(o),o=w,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:l,onError:(w,h,R)=>{c.push({error:w,offset:h,length:R})}};if(t)try{p.visit(t,d),i=o[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return i}doParseRaw(t,i){const n=O.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,n,!0,i);t=o.raw;const a=(0,v.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),c=Object.keys(t),l=(0,v.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:a,keys:c,overrides:l,restricted:o.restricted}}filter(t,i,n,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const a={},c=[];for(let l in t)if(g.OVERRIDE_PROPERTY_PATTERN.test(l)&&n){const d=this.filter(t[l],i,!1,o);a[l]=d.raw,c.push(...d.restricted)}else{const d=i[l],w=d?typeof d.scope!="undefined"?d.scope:3:void 0;(d==null?void 0:d.restricted)&&c.push(l),(w===void 0||o.scopes===void 0||o.scopes.includes(w))&&(o.skipRestricted&&(d==null?void 0:d.restricted)||(a[l]=t[l]))}return{raw:a,restricted:c}}}e.ConfigurationModelParser=S;class E extends m.Disposable{constructor(t,i,n,o){super();this.userSettingsResource=t,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class C{constructor(t,i,n=new b,o=new b,a=new k.ResourceMap,c=new b,l=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=c,this._memoryConfigurationByResource=l,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(t)}updateValue(t,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new b,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,n){const o=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),c=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,l=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),h=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,j=i.overrideIdentifier?c.override(i.overrideIdentifier).getValue(t):c.getValue(t),B=o.getValue(t),M=A.distinct(A.flatten(o.overrides.map($=>$.identifiers))).filter($=>o.getOverrideValue(t,$)!==void 0);return{defaultValue:l,userValue:d,userLocalValue:w,userRemoteValue:h,workspaceValue:R,workspaceFolderValue:_,memoryValue:j,value:B,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:h!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:i.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:c.getValue(t),override:i.overrideIdentifier?c.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=i.filter(o=>g.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const a=(0,g.overrideIdentifierFromKey)(o),c=this._defaultConfiguration.getKeysForOverrideIdentifier(a),l=t.getKeysForOverrideIdentifier(a),d=[...l.filter(w=>c.indexOf(w)===-1),...c.filter(w=>l.indexOf(w)===-1),...c.filter(w=>!U.equals(this._defaultConfiguration.override(a).getValue(w),t.override(a).getValue(w)))];return[a,d]});return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:a}=(0,v.compare)(this.localUserConfiguration,t),c=[...i,...n,...o];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:a}=(0,v.compare)(this.remoteUserConfiguration,t);let c=[...i,...n,...o];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:o,overrides:a}=(0,v.compare)(this.workspaceConfiguration,t);let c=[...i,...n,...o];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:o,updated:a,removed:c,overrides:l}=(0,v.compare)(n,i);let d=[...o,...a,...c];return(d.length||!n)&&this.updateFolderConfiguration(t,i),{keys:d,overrides:l}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:o,removed:a,overrides:c}=(0,v.compare)(i,void 0);return{keys:[...n,...o,...a],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let n=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const a=this._memoryConfigurationByResource.get(t);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=n}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:n,overrides:o,keys:a}=this._folderConfigurations.get(i);return t.push([i,{contents:n,overrides:o,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((c,l)=>(c.set(T.URI.revive(l[0]),this.parseConfigurationModel(l[1])),c),new k.ResourceMap);return new C(i,n,new b,o,a,new b,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=C;function I(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(a=>t.add(a)),o.overrides.forEach(([a,c])=>{const l=(0,k.getOrSet)(i,a,new Set);c.forEach(d=>l.add(d))});const n=[];return i.forEach((o,a)=>n.push([a,[...o.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=I;class f{constructor(t,i,n,o){this.change=t,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(l=>a.add(l)),t.overrides.forEach(([,l])=>l.forEach(d=>a.add(d))),this.affectedKeys=[...a.values()];const c=new b;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,a=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!U.equals(o,a)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let n=(0,v.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(t=t[o],!t)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=f;class s extends f{constructor(t,i,n,o){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=s}),define(Z[161],ee([0,1,35,39,2,25,160,3,6,12]),function(K,e,p,k,A,P,U,T,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class O extends A.Disposable{constructor(y,b){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new U.UserSettings(this.settingsResource,void 0,v.extUriBiasedIgnorePathCase,b)),this.configuration=new U.Configuration(new U.DefaultConfigurationModel,new U.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new g.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(k.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new U.Configuration(new U.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,b){const u=typeof y=="string"?y:void 0,S=(0,P.isConfigurationOverrides)(y)?y:(0,P.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(u,S,void 0)}updateValue(y,b,u,S){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(u,b,1)}onDidDefaultConfigurationChange(y){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new U.DefaultConfigurationModel,y);this.trigger(u,b,6)}trigger(y,b,u){const S=new U.ConfigurationChangeEvent(y,{data:b},this.configuration);S.source=u,S.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=O}),define(Z[162],ee([0,1,25,17,100]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let P=class{constructor(T,g){this.configurationService=T,this.logService=g}request(T,g){return this.logService.trace("RequestService#request",T.url),T.proxyAuthorization||(T.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,A.request)(T,g)}async resolveProxy(T){}};P=he([Y(0,p.IConfigurationService),Y(1,k.ILogService)],P),e.RequestService=P}),define(Z[40],ee([0,1,117,5,39,35,23]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function T(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=T;function g(u){return u.res.statusCode===204}async function v(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);return g(u)?null:(await(0,U.streamToBuffer)(u.stream)).toString()}e.asText=v;async function O(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);if(g(u))return null;const E=(await(0,U.streamToBuffer)(u.stream)).toString();try{return JSON.parse(E)}catch(C){throw C.message+=`:
`+E,C}}e.asJson=O;function m(u){b(u)}e.updateProxyConfigurationsScope=m;let y;function b(u){const S=P.Registry.as(A.Extensions.Configuration);y&&S.deregisterConfigurations([y]),y={id:"http",order:15,title:(0,p.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,p.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,p.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,p.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,p.localize)(4,null),(0,p.localize)(5,null),(0,p.localize)(6,null),(0,p.localize)(7,null)],default:"override",description:(0,p.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,p.localize)(9,null),restricted:!0}}},S.registerConfiguration(y)}b(2)}),define(Z[163],ee([0,1,40,30,10,16]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let U=class{constructor(g,v){this.requestService=g,this.fileService=v}async download(g,v,O=k.CancellationToken.None){if(g.scheme===P.Schemas.file||g.scheme===P.Schemas.vscodeRemote){await this.fileService.copy(g,v);return}const m={type:"GET",url:g.toString()},y=await this.requestService.request(m,O);if(y.res.statusCode===200)await this.fileService.writeFile(v,y.stream);else{const b=await(0,p.asText)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${b}`)}}};U=he([Y(0,p.IRequestService),Y(1,A.IFileService)],U),e.DownloadService=U}),define(Z[164],ee([0,1,28,10,18,62,40,30,17,12,128,2]),function(K,e,p,k,A,P,U,T,g,v,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let y=class extends m.Disposable{constructor(u,S,E,C){super();this.fileService=u,this.productService=S,this.requestService=E,this.logService=C,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,P.forEach)(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const S=[];for(const[E,C]of this.allConfigBasedTips)try{const I=await this.fileService.readFile((0,v.joinPath)(u,E)),f=new Map;(0,P.forEach)(C.recommendations,({key:r,value:t})=>{if((0,A.isNonEmptyArray)(t.remotes))for(const i of t.remotes)f.set(i,{extensionId:r,extensionName:t.name,configName:C.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else S.push({extensionId:r,extensionName:t.name,configName:C.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=(0,O.getDomainsOfRemotes)(I.value.toString(),[...f.keys()]);for(const r of s){const t=f.get(r);t&&S.push(t)}}catch(I){}return S}async fetchWorkspacesTips(){var u,S;if(!((u=this.productService.extensionsGallery)===null||u===void 0?void 0:u.recommendationsUrl))return[];try{const E=await this.requestService.request({type:"GET",url:(S=this.productService.extensionsGallery)===null||S===void 0?void 0:S.recommendationsUrl},T.CancellationToken.None);if(E.res.statusCode!==200)return[];const C=await(0,U.asJson)(E);return C?C.workspaceRecommendations||[]:[]}catch(E){return this.logService.error(E),[]}}};y=he([Y(0,k.IFileService),Y(1,p.IProductService),Y(2,U.IRequestService),Y(3,g.ILogService)],y),e.ExtensionTipsService=y}),define(Z[44],ee([0,1,31,23]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(P,U,T){let g=T&&T.get("storage.serviceMachineId",0)||null;if(g)return g;try{const O=(await U.readFile(P.serviceMachineIdResource)).value.toString();g=(0,p.isUUID)(O)?O:null}catch(v){g=null}if(!g){g=(0,p.generateUuid)();try{await U.writeFile(P.serviceMachineIdResource,k.VSBuffer.fromString(g))}catch(v){}}return T&&T.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=A}),define(Z[19],ee([0,1,5,3,2,15,67,6]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";e.IStorageService=(0,p.createDecorator)("storageService");var v;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var O;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(O=e.StorageScope||(e.StorageScope={}));var m;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class y extends A.Disposable{constructor(E={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=E,this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(E,C){C===g?(E===0?this._globalKeyTargets=void 0:E===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:E})):this._onDidChangeValue.fire({scope:E,key:C,target:this.getKeyTargets(E)[C]})}emitWillSaveState(E){this._onWillSaveState.fire({reason:E})}get(E,C,I){var f;return(f=this.getStorage(C))===null||f===void 0?void 0:f.get(E,I)}getBoolean(E,C,I){var f;return(f=this.getStorage(C))===null||f===void 0?void 0:f.getBoolean(E,I)}getNumber(E,C,I){var f;return(f=this.getStorage(C))===null||f===void 0?void 0:f.getNumber(E,I)}store(E,C,I,f){if((0,P.isUndefinedOrNull)(C)){this.remove(E,I);return}this.withPausedEmitters(()=>{var s;this.updateKeyTarget(E,I,f),(s=this.getStorage(I))===null||s===void 0||s.set(E,C)})}remove(E,C){this.withPausedEmitters(()=>{var I;this.updateKeyTarget(E,C,void 0),(I=this.getStorage(C))===null||I===void 0||I.delete(E)})}withPausedEmitters(E){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{E()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(E,C){const I=[],f=this.getKeyTargets(E);for(const s of Object.keys(f))f[s]===C&&I.push(s);return I}updateKeyTarget(E,C,I){var f,s;const r=this.getKeyTargets(C);typeof I=="number"?r[E]!==I&&(r[E]=I,(f=this.getStorage(C))===null||f===void 0||f.set(g,JSON.stringify(r))):typeof r[E]=="number"&&(delete r[E],(s=this.getStorage(C))===null||s===void 0||s.set(g,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(E){return E===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(E){const C=this.get(g,E);if(C)try{return JSON.parse(C)}catch(I){}return Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(){var E,C,I,f;this._onWillSaveState.fire({reason:v.NONE}),await T.Promises.settled([(C=(E=this.getStorage(0))===null||E===void 0?void 0:E.whenFlushed())!==null&&C!==void 0?C:Promise.resolve(),(f=(I=this.getStorage(1))===null||I===void 0?void 0:I.whenFlushed())!==null&&f!==void 0?f:Promise.resolve()])}async logStorage(){var E,C,I,f,s,r;const t=(C=(E=this.getStorage(0))===null||E===void 0?void 0:E.items)!==null&&C!==void 0?C:new Map,i=(f=(I=this.getStorage(1))===null||I===void 0?void 0:I.items)!==null&&f!==void 0?f:new Map;return u(t,i,(s=this.getLogDetails(0))!==null&&s!==void 0?s:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends y{constructor(){super();this.globalStorage=new U.Storage(new U.InMemoryStorageDatabase),this.workspaceStorage=new U.Storage(new U.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(E=>this.emitDidChangeValue(1,E))),this._register(this.globalStorage.onDidChangeStorage(E=>this.emitDidChangeValue(0,E)))}getStorage(E){return E===0?this.globalStorage:this.workspaceStorage}getLogDetails(E){return E===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(E){}}e.InMemoryStorageService=b;async function u(S,E,C,I){const f=a=>{try{return JSON.parse(a)}catch(c){return a}},s=new Map,r=new Map;S.forEach((a,c)=>{s.set(c,a),r.set(c,f(a))});const t=new Map,i=new Map;E.forEach((a,c)=>{t.set(c,a),i.set(c,f(a))}),console.group(`Storage: Global (path: ${C})`);let n=[];s.forEach((a,c)=>{n.push({key:c,value:a})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${I})`);let o=[];t.forEach((a,c)=>{o.push({key:c,value:a})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=u}),define(Z[165],ee([0,1,3,2,29,33,19,15]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let g=class extends k.Disposable{constructor(m){super();this._onDidChangeEnablement=new p.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new v(m)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"})))}async enableExtension(m,y){return this._removeFromDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:y}),!0):!1}async disableExtension(m,y){return this._addToDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:y}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(m){let y=this.getDisabledExtensions();return y.every(b=>!(0,P.areSameExtensions)(b,m))?(y.push(m),this._setDisabledExtensions(y),!0):!1}_removeFromDisabledExtensions(m){let y=this.getDisabledExtensions();for(let b=0;b<y.length;b++){const u=y[b];if((0,P.areSameExtensions)(u,m))return y.splice(b,1),this._setDisabledExtensions(y),!0}return!1}_setDisabledExtensions(m){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,m)}_getExtensions(m){return this.storageManger.get(m,0)}_setExtensions(m,y){this.storageManger.set(m,y,0)}};g=he([Y(0,U.IStorageService)],g),e.GlobalExtensionEnablementService=g;class v extends k.Disposable{constructor(m){super();this.storageService=m,this.storage=Object.create(null),this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this._register(m.onDidChangeValue(y=>this.onDidStorageChange(y)))}get(m,y){let b;return y===0?((0,T.isUndefinedOrNull)(this.storage[m])&&(this.storage[m]=this._get(m,y)),b=this.storage[m]):b=this._get(m,y),JSON.parse(b)}set(m,y,b){let u=JSON.stringify(y.map(({id:E,uuid:C})=>({id:E,uuid:C})));this._get(m,b)!==u&&(b===0&&(y.length?this.storage[m]=u:delete this.storage[m]),this._set(m,y.length?u:void 0,b))}onDidStorageChange(m){if(m.scope===0&&!(0,T.isUndefinedOrNull)(this.storage[m.key])&&this._get(m.key,m.scope)!==this.storage[m.key]){const b=this.get(m.key,m.scope);delete this.storage[m.key];const u=this.get(m.key,m.scope),S=b.filter(C=>!u.some(I=>(0,P.areSameExtensions)(C,I))),E=u.filter(C=>!b.some(I=>(0,P.areSameExtensions)(I,C)));(S.length||E.length)&&this._onDidChange.fire([...S,...E])}}_get(m,y){return this.storageService.get(m,y,"[]")}_set(m,y,b){y?this.storageService.store(m,y,b,1):this.storageService.remove(m,b)}}e.StorageManager=v}),define(Z[166],ee([0,1,3,2]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class A extends k.Disposable{constructor(v,O){super();this.channel=v,this.workspace=O}async getItems(){const v={workspace:this.workspace},O=await this.channel.call("getItems",v);return new Map(O)}updateItems(v){const O={workspace:this.workspace};return v.insert&&(O.insert=Array.from(v.insert.entries())),v.delete&&(O.delete=Array.from(v.delete.values())),this.channel.call("updateItems",O)}}class P extends A{constructor(v){super(v,void 0);this._onDidChangeItemsExternal=this._register(new p.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(v=>this.onDidChangeGlobalStorage(v)))}onDidChangeGlobalStorage(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this._onDidChangeItemsExternal.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}async close(){this.dispose()}}class U extends A{constructor(v,O){super(v,O);this.onDidChangeItemsExternal=p.Event.None}async close(){const v={workspace:this.workspace};return this.channel.call("close",v)}}class T extends k.Disposable{constructor(v,O){super();this.channel=v,this.workspace=O,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new P(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new U(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=T}),define(Z[167],ee([0,1,2,19,67,6,156,166,12]),function(K,e,p,k,A,P,U,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class v extends k.AbstractStorageService{constructor(m,y,b){super();this.mainProcessService=y,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new p.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(m)}createGlobalStorage(){const m=new T.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),y=new A.Storage(m.globalStorage);return this._register(y.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),y}createWorkspaceStorage(m){const y=new T.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),m);if(y.workspaceStorage){const b=new A.Storage(y.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(u=>this.emitDidChangeValue(1,u)),this.workspaceStorageId=m==null?void 0:m.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var m,y;(0,U.mark)("code/willInitStorage");try{await P.Promises.settled([this.globalStorage.init(),(y=(m=this.workspaceStorage)===null||m===void 0?void 0:m.init())!==null&&y!==void 0?y:Promise.resolve()])}finally{(0,U.mark)("code/didInitStorage")}}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,g.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var m,y;this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await P.Promises.settled([this.globalStorage.close(),(y=(m=this.workspaceStorage)===null||m===void 0?void 0:m.close())!==null&&y!==void 0?y:Promise.resolve()])}async migrate(m){var y;const b=this.workspaceStorage,u=(y=b==null?void 0:b.items)!==null&&y!==void 0?y:new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(m),await this.workspaceStorage.init();for(const[S,E]of u)this.workspaceStorage.set(S,E)}}e.NativeStorageService=v}),define(Z[168],ee([0,1,7,36,31,4]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;function U(v){if(p.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function T(v,O,m,y,b,u,S,E,C,I){const f=Object.create(null);f["common.machineId"]=S,f.sessionID=(0,A.generateUuid)()+Date.now(),f.commitHash=b,f.version=u,f["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,p.PlatformToString)(p.platform),f["common.nodePlatform"]=k.platform,f["common.nodeArch"]=y,f["common.product"]=I||"desktop";const s=g(E||[]);s&&(f["common.msftInternal"]=s);let r=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),p.isLinuxSnap&&(f["common.snap"]="true");const i=U(m);i&&(f["common.platformDetail"]=i);try{const n=await v.readFile(P.URI.file(C));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}e.resolveCommonProperties=T;function g(v){const O=k.env.USERDNSDOMAIN;if(!O)return!1;const m=O.toLowerCase();return v.some(y=>m===y)}}),define(Z[22],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[169],ee([0,1,38,92,69,27,8,32,95,28,7,4,22,53,16,10,24]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function C(t,i){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],o=new Map,a=new Map,c=2e4;function l(h,R,_,j){const B=R.substring(h.length+1);return new Promise(async M=>{var $,V,q;let H;try{H=await(0,E.readdir)(R,{withFileTypes:!0})}catch(L){M();return}if(j.count>=c){j.count+=H.length,j.maxReached=!0,M();return}let z=H.length;if(z===0){M();return}let D=H;j.count+H.length>c&&(j.maxReached=!0,z=c-j.count,D=H.slice(0,z)),j.count+=H.length;for(const L of D)if(L.isDirectory()){if(_.includes(L.name)||await l(h,(0,U.join)(R,L.name),_,j),--z==0){M();return}}else{const F=L.name.lastIndexOf(".");if(F>=0){const N=L.name.substring(F+1);N&&o.set(N,(($=o.get(N))!==null&&$!==void 0?$:0)+1)}for(const N of n)((V=N.relativePathPattern)===null||V===void 0?void 0:V.test(B))!==!1&&N.filePattern.test(L.name)&&a.set(N.tag,((q=a.get(N.tag))!==null&&q!==void 0?q:0)+1);if(--z==0){M();return}}})}const d={count:0,maxReached:!1};await l(t,t,i,d);const w=await s(t);return{configFiles:I(a),fileTypes:I(o),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:w}}e.collectWorkspaceStats=C;function I(t){return[...b.Iterable.map(t.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function f(){const t={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/S.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/S.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(k.virtualMachineHint.value()*100)}%`},i=p.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=f;function s(t){let i=new Map,n=(0,U.join)(t,".vscode","launch.json");return new Promise((o,a)=>{(0,P.exists)(n,c=>{if(c)(0,P.readFile)(n,(l,d)=>{if(l)return o([]);const w=[],h=(0,T.parse)(d.toString(),w);if(w.length)return console.log(`Unable to parse ${n}`),o([]);if((0,T.getNodeType)(h)==="object"&&h.configurations)for(const R of h.configurations){const _=R.type;_&&(i.has(_)?i.set(_,i.get(_)+1):i.set(_,1))}return o(I(i))});else return o([])})})}e.collectLaunchConfigs=s;let r=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const o=p.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(p.totalmem()/S.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/S.ByteSize.GB).toFixed(2)}GB free)`),O.isWindows||n.push(`Load (avg):       ${p.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(k.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,g.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[a,c]=o,l=this.formatProcessList(i,a);return n.forEach(d=>{if((0,A.isRemoteDiagnosticError)(d))l+=`
${d.errorMessage}`,c+=`
${d.errorMessage}`;else if(l+=`

Remote: ${d.hostName}`,d.processes&&(l+=`
${this.formatProcessList(i,d.processes)}`),d.workspaceMetadata){c+=`
|  Remote: ${d.hostName}`;for(const w of Object.keys(d.workspaceMetadata)){const h=d.workspaceMetadata[w];let R=`${h.fileCount} files`;h.maxFilesReached&&(R=`more than ${R}`),c+=`|    Folder (${w}): ${R}`,c+=this.formatWorkspaceStats(h)}}}),{processInfo:l,workspaceInfo:c}})}async getSystemInfo(i,n){const{memory:o,vmHint:a,os:c,cpus:l}=f(),d={os:c,memory:o,cpus:l,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return O.isWindows||(d.load=`${p.loadavg().map(w=>Math.round(w)).join(", ")}`),O.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(i,n){const o=[];return(0,g.listProcesses)(i.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,a)),i.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(c=>{if((0,A.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.formatMachineInfo(c.machineInfo)),c.processes&&o.push(this.formatProcessList(i,c.processes)),c.workspaceMetadata)for(const l of Object.keys(c.workspaceMetadata)){const d=c.workspaceMetadata[l];let w=`${d.fileCount} files`;d.maxFilesReached&&(w=`more than ${w}`),o.push(`Folder (${l}): ${w}`),o.push(this.formatWorkspaceStats(d))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let a=0;const c=(h,R)=>{const _=` ${h}(${R})`;a+_.length>o?(n.push(l),l="|                 ",a=l.length):a+=_.length,l+=_};let l="|      File types:";const d=10;let w=i.fileTypes.length>d?d:i.fileTypes.length;for(let h=0;h<w;h++){const R=i.fileTypes[h];c(R.name,R.count)}if(n.push(l),i.configFiles.length>=0&&(l="|      Conf files:",a=0,i.configFiles.forEach(h=>{c(h.name,h.count)}),n.push(l)),i.launchConfigFiles.length>0){let h="|      Launch Configs:";i.launchConfigFiles.forEach(R=>{h+=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`}),n.push(h)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const l=m.URI.revive(c);if(l.scheme===u.Schemas.file){const d=l.fsPath;o.push(C(d,["node_modules",".git"]).then(w=>{let h=`${w.fileCount} files`;w.maxFilesReached&&(h=`more than ${h}`),n.push(`|    Folder (${(0,U.basename)(d)}): ${h}`),n.push(this.formatWorkspaceStats(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${d} (${w.toString()})`)}))}else n.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(c=>o.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,a,n,0),a.join(`
`)}formatProcessItem(i,n,o,a,c){const l=c===0;let d;l?d=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(d=`${d} (${n.get(a.pid)})`));const w=process.platform==="win32"?a.mem:p.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(w/S.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(a.children)&&a.children.forEach(h=>this.formatProcessItem(i,n,o,h,c+1))}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=m.URI.revive(n);if(o.scheme===u.Schemas.file){const a=o.fsPath;try{const c=await C(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),c.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),c.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),c.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})})}catch(c){}}}}};r=he([Y(0,y.ITelemetryService),Y(1,v.IProductService)],r),e.DiagnosticsService=r}),define(Z[170],ee([0,1,11,29,33,26,22,40,68,9,30,17,10,4,28,19,44,5,12]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var f;(function(D){D[D.None=0]="None",D[D.IncludeVersions=1]="IncludeVersions",D[D.IncludeFiles=2]="IncludeFiles",D[D.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",D[D.IncludeSharedAccounts=8]="IncludeSharedAccounts",D[D.IncludeVersionProperties=16]="IncludeVersionProperties",D[D.ExcludeNonValidated=32]="ExcludeNonValidated",D[D.IncludeInstallationTargets=64]="IncludeInstallationTargets",D[D.IncludeAssetUri=128]="IncludeAssetUri",D[D.IncludeStatistics=256]="IncludeStatistics",D[D.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",D[D.Unpublished=4096]="Unpublished"})(f||(f={}));function s(...D){return String(D.reduce((L,F)=>L|F,0))}var r;(function(D){D[D.Tag=1]="Tag",D[D.ExtensionId=4]="ExtensionId",D[D.Category=5]="Category",D[D.ExtensionName=7]="ExtensionName",D[D.Target=8]="Target",D[D.Featured=9]="Featured",D[D.SearchText=10]="SearchText",D[D.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:f.None,criteria:[],assetTypes:[]};class a{constructor(L=o){this.state=L}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(L,F=this.state.pageSize){return new a(Object.assign(Object.assign({},this.state),{pageNumber:L,pageSize:F}))}withFilter(L,...F){const N=[...this.state.criteria,...F.length?F.map(x=>({filterType:L,value:x})):[{filterType:L}]];return new a(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(L){return new a(Object.assign(Object.assign({},this.state),{sortBy:L}))}withSortOrder(L){return new a(Object.assign(Object.assign({},this.state),{sortOrder:L}))}withFlags(...L){return new a(Object.assign(Object.assign({},this.state),{flags:L.reduce((F,N)=>F|N,0)}))}withAssetTypes(...L){return new a(Object.assign(Object.assign({},this.state),{assetTypes:L}))}get raw(){const{criteria:L,pageNumber:F,pageSize:N,sortBy:x,sortOrder:G,flags:J,assetTypes:Q}=this.state;return{filters:[{criteria:L,pageNumber:F,pageSize:N,sortBy:x,sortOrder:G}],assetTypes:Q,flags:J}}get searchText(){const L=this.state.criteria.filter(F=>F.filterType===r.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(L=>String(L.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(D,L){const F=(D||[]).filter(N=>N.statisticName===L)[0];return F?F.value:0}function l(D){const L="Microsoft.VisualStudio.Code.Translation.";return D.files.filter(N=>N.assetType.indexOf(L)===0).reduce((N,x)=>{const G=R(D,x.assetType);return G&&N.push([x.assetType.substring(L.length),G]),N},[])}function d(D){if(D.properties){const L=D.properties.filter(x=>x.key===t.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=L.filter(x=>F.test(x.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return R(D,t.Repository)}function w(D){return{uri:`${D.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${D.fallbackAssetUri}/${t.VSIX}`}}function h(D){const L=R(D,t.Icon);if(L)return L;const F=k.DefaultIconPath;return{uri:F,fallbackUri:F}}function R(D,L){return D.files.filter(N=>N.assetType===L)[0]?{uri:`${D.assetUri}/${L}`,fallbackUri:`${D.fallbackAssetUri}/${L}`}:null}function _(D,L){const F=D.properties?D.properties.filter(x=>x.key===L):[],N=F.length>0&&F[0].value;return N?N.split(",").map(x=>(0,A.adoptToGalleryExtensionId)(x)):[]}function j(D){const L=D.properties?D.properties.filter(F=>F.key===i.Engine):[];return L.length>0&&L[0].value||""}function B(D){const L=D.properties?D.properties.filter(N=>N.key===i.LocalizedLanguages):[],F=L.length>0&&L[0].value||"";return F?F.split(","):[]}function M(D){return D.indexOf("preview")!==-1}function $(D){const L=D.properties?D.properties.find(F=>F.key===i.WebExtension):void 0;return!!L&&L.value==="true"}function V(D){return D.files.some(L=>L.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,I.joinPath)(b.URI.parse(D.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function q(D,L,F,N,x){const G={manifest:R(L,t.Manifest),readme:R(L,t.Details),changelog:R(L,t.Changelog),license:R(L,t.License),repository:d(L),download:w(L),icon:h(L),coreTranslations:l(L)};return{identifier:{id:(0,A.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},name:D.extensionName,version:L.version,date:L.lastUpdated,displayName:D.displayName,publisherId:D.publisher.publisherId,publisher:D.publisher.publisherName,publisherDisplayName:D.publisher.displayName,description:D.shortDescription||"",installCount:c(D.statistics,"install"),rating:c(D.statistics,"averagerating"),ratingCount:c(D.statistics,"ratingcount"),assetUri:b.URI.parse(L.assetUri),webResource:V(L),assetTypes:L.files.map(({assetType:J})=>J),assets:G,properties:{dependencies:_(L,i.Dependency),extensionPack:_(L,i.ExtensionPack),engine:j(L),localizedLanguages:B(L),webExtension:$(L)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+F,querySource:x},preview:M(D.flags)}}let H=class{constructor(L,F,N,x,G,J,Q){this.requestService=L,this.logService=F,this.environmentService=N,this.telemetryService=x,this.fileService=G,this.productService=J;const ne=J.extensionsGallery;this.extensionsGalleryUrl=ne&&ne.serviceUrl,this.extensionsControlUrl=ne&&ne.controlUrl,this.commonHeadersPromise=z(J.version,this.environmentService,this.fileService,Q)}api(L=""){return`${this.extensionsGalleryUrl}${L}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(L,F){const N=[];let{total:x,firstPage:G,getPage:J}=await this.query({names:L,pageSize:L.length},F);N.push(...G);for(let Q=1;N.length<x&&(G=await J(Q,F),G.length);Q++)N.push(...G);return N}async getCompatibleExtension(L,F){const N=await this.getCompatibleExtensionByEngine(L,F);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(L,F){const N=(0,k.isIExtensionIdentifier)(L)?null:L;if(N&&N.properties.engine&&(0,g.isEngineValid)(N.properties.engine,this.productService.version))return N;const{id:x,uuid:G}=N?N.identifier:L;let J=new a().withFlags(f.IncludeAssetUri,f.IncludeStatistics,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");G?J=J.withFilter(r.ExtensionId,G):J=J.withFilter(r.ExtensionName,x);const{galleryExtensions:Q}=await this.queryGallery(J,O.CancellationToken.None),[ne]=Q;if(!ne||!ne.versions.length)return null;if(F){const ce=ne.versions.filter(ue=>ue.version===F)[0];if(ce){const ue=q(ne,ce,0,J);if(ue.properties.engine&&(0,g.isEngineValid)(ue.properties.engine,this.productService.version))return ue}return null}const ie=await this.getLastValidExtensionVersion(ne,ne.versions);return ie?q(ne,ie,0,J):null}async query(L,F){const N=O.CancellationToken.isCancellationToken(L)?{}:L,x=O.CancellationToken.isCancellationToken(L)?L:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let G=N.text||"";const J=(0,P.getOrDefault)(N,ge=>ge.pageSize,50);let Q=new a().withFlags(f.IncludeLatestVersionOnly,f.IncludeAssetUri,f.IncludeStatistics,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,J).withFilter(r.Target,"Microsoft.VisualStudio.Code");G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ie)=>(Q=Q.withFilter(r.Category,Ie||Ee),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ie)=>(Q=Q.withFilter(r.Tag,Ie||Ee),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(r.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),Q=Q.withFilter(r.SearchText,G)),Q=Q.withSortBy(0)):N.ids?Q=Q.withFilter(r.ExtensionId,...N.ids):N.names?Q=Q.withFilter(r.ExtensionName,...N.names):Q=Q.withSortBy(4),typeof N.sortBy=="number"&&(Q=Q.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(Q=Q.withSortOrder(N.sortOrder));const{galleryExtensions:ne,total:ie}=await this.queryGallery(Q,x),ce=ne.map((ge,Ee)=>q(ge,ge.versions[0],Ee,Q,N.source)),ue=async(ge,Ee)=>{if(Ee.isCancellationRequested)throw(0,p.canceled)();const Ie=Q.withPage(ge+1),{galleryExtensions:Te}=await this.queryGallery(Ie,Ee);return Te.map((Ae,Ue)=>q(Ae,Ae.versions[0],Ue,Ie,N.source))};return{firstPage:ce,total:ie,pageSize:Q.pageSize,getPage:ue}}async queryGallery(L,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,f.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(f.Unpublished));const N=await this.commonHeadersPromise,x=JSON.stringify(L.raw),G=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)}),J=new Date().getTime();let Q,ne,ie=0;try{if(Q=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:x,headers:G},F),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:ie};const ce=await(0,T.asJson)(Q);if(ce){const ue=ce.results[0],ge=ue.extensions,Ee=ue.resultMetadata&&ue.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ie=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ie}}return{galleryExtensions:[],total:ie}}catch(ce){throw ne=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},L.telemetryData),{requestBodySize:String(x.length),duration:new Date().getTime()-J,success:!!Q&&(0,T.isSuccess)(Q),responseBodySize:Q==null?void 0:Q.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:ne?(0,p.isPromiseCanceledError)(ne)?"canceled":(0,p.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ie)}))}}async reportStatistic(L,F,N,x){if(!!this.isEnabled()){const G=await this.commonHeadersPromise,J=Object.assign(Object.assign({},G),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${L}/extensions/${F}/${N}/stats?statType=${x}`),headers:J},O.CancellationToken.None)}catch(Q){}}}async download(L,F,N){this.logService.trace("ExtensionGalleryService#download",L.identifier.id);const x=(0,A.getGalleryExtensionTelemetryData)(L),G=new Date().getTime(),J=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},x),{duration:ce})),Q=N===1?"install":N===2?"update":"",ne=Q?{uri:`${L.assets.download.uri}&${Q}=true`,fallbackUri:`${L.assets.download.fallbackUri}?${Q}=true`}:L.assets.download,ie=await this.getAsset(ne);await this.fileService.writeFile(F,ie.stream),J(new Date().getTime()-G)}async getReadme(L,F){if(L.assets.readme){const N=await this.getAsset(L.assets.readme,{},F);return await(0,T.asText)(N)||""}return""}async getManifest(L,F){if(L.assets.manifest){const N=await this.getAsset(L.assets.manifest,{},F),x=await(0,T.asText)(N);return x?JSON.parse(x):null}return null}async getCoreTranslation(L,F){const N=L.assets.coreTranslations.filter(x=>x[0]===F.toUpperCase())[0];if(N){const x=await this.getAsset(N[1]),G=await(0,T.asText)(x);return G?JSON.parse(G):null}return null}async getChangelog(L,F){if(L.assets.changelog){const N=await this.getAsset(L.assets.changelog,{},F);return await(0,T.asText)(N)||""}return""}async getAllVersions(L,F){let N=new a().withFlags(f.IncludeVersions,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");L.identifier.uuid?N=N.withFilter(r.ExtensionId,L.identifier.uuid):N=N.withFilter(r.ExtensionName,L.identifier.id);const x=[],{galleryExtensions:G}=await this.queryGallery(N,O.CancellationToken.None);return G.length&&(F?await Promise.all(G[0].versions.map(async J=>{let Q;try{Q=await this.getEngine(J)}catch(ne){}Q&&(0,g.isEngineValid)(Q,this.productService.version)&&x.push({version:J.version,date:J.lastUpdated})})):x.push(...G[0].versions.map(J=>({version:J.version,date:J.lastUpdated})))),x}async getAsset(L,F={},N=O.CancellationToken.None){const x=await this.commonHeadersPromise,G={type:"GET"},J=Object.assign(Object.assign({},x),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),G),{headers:J});const Q=L.uri,ne=L.fallbackUri,ie=Object.assign(Object.assign({},F),{url:Q});try{const ce=await this.requestService.request(ie,N);if(ce.res.statusCode===200)return ce;const ue=await(0,T.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${ue}`)}catch(ce){if((0,p.isPromiseCanceledError)(ce))throw ce;const ue=(0,p.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:ue});const ge=Object.assign(Object.assign({},F),{url:ne});return this.requestService.request(ge,N)}}async getLastValidExtensionVersion(L,F){const N=this.getLastValidExtensionVersionFromProperties(L,F);return N||this.getLastValidExtensionVersionRecursively(L,F)}getLastValidExtensionVersionFromProperties(L,F){for(const N of F){const x=j(N);if(!x)return null;if((0,g.isEngineValid)(x,this.productService.version))return N}return null}async getEngine(L){const F=j(L);if(F)return F;const N=R(L,t.Manifest);if(!N)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},G=await this.getAsset(N,{headers:x}),J=await(0,T.asJson)(G);if(J)return J.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(L,F){if(!F.length)return null;const N=F[0],x=await this.getEngine(N);return(0,g.isEngineValid)(x,this.productService.version)?(N.properties=N.properties||[],N.properties.push({key:i.Engine,value:x}),N):this.getLastValidExtensionVersionRecursively(L,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const L=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,T.asJson)(L),N=new Map;if(F)for(const x of F.malicious){const G=N.get(x)||{id:{id:x},malicious:!0,slow:!1};G.malicious=!0,N.set(x,G)}return[...N.values()]}};H=he([Y(0,T.IRequestService),Y(1,m.ILogService),Y(2,v.IEnvironmentService),Y(3,U.ITelemetryService),Y(4,y.IFileService),Y(5,u.IProductService),Y(6,(0,C.optional)(S.IStorageService))],H),e.ExtensionGalleryService=H;async function z(D,L,F,N){const x={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D}`},G=await(0,E.getServiceMachineId)(L,F,N);return x["X-Market-User-Id"]=G,x}e.resolveMarketplaceHeaders=z}),define(Z[171],ee([0,1,4,8,28,9,36,10,7,18,29,62,40,17,164,6,22,71,108,19,3,57]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let n=class extends u.ExtensionTipsService{constructor(a,c,l,d,w,h,R,_,j,B){super(R,_,j,B);this.environmentService=a,this.telemetryService=c,this.extensionManagementService=l,this.storageService=d,this.nativeHostService=w,this.extensionRecommendationNotificationService=h,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,m.forEach)(_.exeBasedExtensionTips,({key:M,value:$})=>{const V=[],q=[],H=[];(0,m.forEach)($.recommendations,({key:z,value:D})=>{D.important?$.important?V.push({extensionId:z,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):q.push({extensionId:z,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):H.push({extensionId:z,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:V}),q.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:q}),H.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H})}),(0,S.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,l)}groupImportantTipsByExe(a,c){const l=new Map;a.forEach(_=>l.set(_.extensionId.toLowerCase(),_));const{installed:d,uninstalled:w}=this.groupByInstalled([...l.keys()],c);for(const _ of d){const j=l.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,k.basename)(j.windowsPath)})}for(const _ of w){const j=l.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,k.basename)(j.windowsPath)})}const h=this.getPromptedExecutableTips(),R=new Map;for(const _ of w){const j=l.get(_);if(j&&(!h[j.exeName]||!h[j.exeName].includes(j.extensionId))){let B=R.get(j.exeName);B||(B=[],R.set(j.exeName,B)),B.push(j)}}return R}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[a,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const d=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register((0,S.disposableTimeout)(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const a=this.getLastPromptedMediumExeTime(),c=Date.now()-a,l=7*24*60*60*1e3;if(c<l){const h=this._register((0,S.disposableTimeout)(()=>{h.dispose(),this.promptMediumImportanceExeBasedTip()},l-c));return}const[d,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(h=>{switch(h){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(w[0].exeName,w);const R=this._register((0,S.disposableTimeout)(()=>{R.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const j=this._register((0,S.disposableTimeout)(()=>{j.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(a){const c=a.map(({extensionId:d})=>d.toLowerCase()),l=(0,I.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,l,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(i,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(i,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(a,c){const l=this.getPromptedExecutableTips();l[a]=c.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(a,c){const l=[],d=[],w=c.reduce((h,R)=>(h.add(R.identifier.id.toLowerCase()),h),new Set);return a.forEach(h=>{w.has(h.toLowerCase())?l.push(h):d.push(h)}),{installed:l,uninstalled:d}}async getValidExecutableBasedExtensionTips(a){const c=[],l=new Map;for(const d of a.keys()){const w=a.get(d);if(!(!w||!(0,v.isNonEmptyArray)(w.recommendations))){const h=[];g.isWindows?w.windowsPath&&h.push(w.windowsPath.replace("%USERPROFILE%",U.env.USERPROFILE).replace("%ProgramFiles(x86)%",U.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",U.env.ProgramFiles).replace("%APPDATA%",U.env.APPDATA).replace("%WINDIR%",U.env.WINDIR)):(h.push((0,k.join)("/usr/local/bin",d)),h.push((0,k.join)("/usr/bin",d)),h.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const R of h){let _=l.get(R);if(_===void 0&&(_=await this.fileService.exists(p.URI.file(R)),l.set(R,_)),_)for(const{extensionId:j,extensionName:B,isExtensionPack:M}of w.recommendations)c.push({extensionId:j,extensionName:B,isExtensionPack:M,exeName:d,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}}return c}};n=he([Y(0,P.INativeEnvironmentService),Y(1,E.ITelemetryService),Y(2,O.IExtensionManagementService),Y(3,f.IStorageService),Y(4,r.INativeHostService),Y(5,C.IExtensionRecommendationNotificationService),Y(6,T.IFileService),Y(7,A.IProductService),Y(8,y.IRequestService),Y(9,b.ILogService)],n),e.ExtensionTipsService=n}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(P){this.appender=P}listen(P,U){throw new Error(`Event not found: ${U}`)}call(P,U,{eventName:T,data:g}){return this.appender.log(T,g),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class k{constructor(P){this.channel=P}log(P,U){return this.channel.call("log",{eventName:P,data:U}).then(void 0,T=>`Failed to log telemetry: ${console.warn(T)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=k}),define(Z[79],ee([0,1,51,118,21,5,25,39,2,26,35]),function(K,e,p,k,A,P,U,T,g,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(u,S){this._configurationService=S,this._experimentProperties={},this._disposables=new g.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(E),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(E=>{const C=/^[a-f0-9]+$/i.test(E["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!C})}))}setExperimentProperty(u,S){this._experimentProperties[u]=S}setEnabled(u){this._enabled=u}_updateUserOptIn(){var u;const S=(u=this._configurationService)===null||u===void 0?void 0:u.getValue(y);this._userOptIn=S?S.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let S=u.sessionID,E=u["common.instanceId"],C=u["common.machineId"],I=u["common.firstSessionDate"],f=u["common.msftInternal"];return{sessionId:S,instanceId:E,machineId:C,firstSessionDate:I,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(u,S,E){return this.isOptedIn?this._commonProperties.then(C=>{S=(0,v.mixin)(S,C),S=(0,v.mixin)(S,this._experimentProperties),S=(0,v.cloneAndChange)(S,I=>{if(typeof I=="string")return this._cleanupInfo(I,E)}),this._appender.log(u,S)},C=>{console.error(C)}):Promise.resolve(void 0)}publicLog2(u,S,E){return this.publicLog(u,S,E)}publicLogError(u,S){return this.sendErrorTelemetry?this.publicLog(u,S,!0):Promise.resolve(void 0)}publicLogError2(u,S){return this.publicLogError(u,S)}_cleanupInfo(u,S){let E=u;if(S){const C=[];for(let r of this._cleanupPatterns)for(;;){const t=r.exec(u);if(!t)break;C.push([t.index,r.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(E="";;){const r=f.exec(u);if(!r)break;!I.test(r[0])&&C.every(([t,i])=>r.index<t||r.index>=i)&&(E+=u.substring(s,r.index)+"<REDACTED: user-file-path>",s=f.lastIndex)}s<u.length&&(E+=u.substr(s))}for(let C of this._cleanupPatterns)E=E.replace(C,"");return E}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=he([Y(1,(0,P.optional)(U.IConfigurationService))],m),e.TelemetryService=m;const y="telemetry";O.Registry.as(T.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:(0,k.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,k.localize)(2,null,p.default.privacyStatementUrl):(0,k.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[58],ee([0,1,25,26,15,6]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(u,S){return Promise.resolve(void 0)}publicLog2(u,S){return this.publicLog(u,S)}publicLogError(u,S){return Promise.resolve(void 0)}publicLogError2(u,S){return this.publicLogError(u,S)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class U{async publicLog(S,E,C){}async publicLogError(S,E,C){}}e.NullEndpointTelemetryService=U;function T(...u){return{log:(S,E)=>u.forEach(C=>C.log(S,E)),flush:()=>P.Promises.settled(u.map(S=>S.flush()))}}e.combinedAppender=T,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(u,S){return S.onDidChangeConfiguration(E=>{E.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(E.source),configurationKeys:y(E.sourceConfig)})})}e.configurationTelemetry=g;function v(u){const S=Object.create(null),E=Object.create(null),C=Object.create(null);m(u,C);for(let I in C){I=I.length>150?I.substr(I.length-149):I;const f=C[I];typeof f=="number"?E[I]=f:typeof f=="boolean"?E[I]=f?1:0:typeof f=="string"?S[I]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(S[I]=f)}return{properties:S,measurements:E}}e.validateTelemetryData=v;function O(u){if(!u)return"none";let S="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(C=>{u.indexOf(`${C}+`)===0&&(S=C)}),S}e.cleanRemoteAuthority=O;function m(u,S,E=0,C){if(!!u)for(let I of Object.getOwnPropertyNames(u)){const f=u[I],s=C?C+I:I;Array.isArray(f)?S[s]=(0,k.safeStringify)(f):f instanceof Date?S[s]=f.toISOString():(0,A.isObject)(f)?E<2?m(f,S,E+1,s+"."):S[s]=(0,k.safeStringify)(f):S[s]=f}}function y(u){if(!u)return[];const S=[];return b(S,"",u),S}function b(u,S,E){E&&typeof E=="object"&&!Array.isArray(E)?Object.keys(E).forEach(C=>b(u,S?`${S}.${C}`:C,E[C])):u.push(S)}}),define(Z[172],ee([0,1,2,9,17,58]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let U=class extends p.Disposable{constructor(g,v){super();this.logger=this._register(g.createLogger(v.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(g,v){this.logger.trace(`telemetry/${g}`,(0,P.validateTelemetryData)(v))}};U=he([Y(0,A.ILoggerService),Y(1,k.IEnvironmentService)],U),e.TelemetryLogAppender=U}),define(Z[173],ee([0,1,11,26,58]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function P(T){const g=await new Promise((O,m)=>{K(["applicationinsights"],O,m)});let v;return g.defaultClient?(v=new g.TelemetryClient(T),v.channel.setUseDiskRetryCaching(!0)):(g.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),v=g.defaultClient),T.indexOf("AIF-")===0&&(v.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),v}class U{constructor(g,v,O){this._eventPrefix=g,this._defaultData=v,this._defaultData||(this._defaultData=Object.create(null)),typeof O=="function"?this._aiClient=O():this._aiClient=O,this._asyncAIClient=null}_withAIClient(g){if(!!this._aiClient){if(typeof this._aiClient!="string"){g(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient)),this._asyncAIClient.then(v=>{g(v)},v=>{(0,p.onUnexpectedError)(v),console.error(v)})}}log(g,v){!this._aiClient||(v=(0,k.mixin)(v,this._defaultData),v=(0,A.validateTelemetryData)(v),this._withAIClient(O=>O.trackEvent({name:this._eventPrefix+"/"+g,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(g=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,g(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=U}),define(Z[174],ee([0,1,49,78,16,79,25,22]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(O,m){this.configurationService=O,this.telemetryService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(O){if(!this.customTelemetryServices.has(O.id)){const{machineId:m,sessionId:y}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=m,b["common.vscodesessionid"]=y;const u=[O.id,JSON.stringify(b),O.aiKey],E=new p.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:u,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),C=new k.TelemetryAppenderClient(E);this.customTelemetryServices.set(O.id,new P.TelemetryService({appender:C,sendErrorTelemetry:O.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(O.id)}async publicLog(O,m,y){await(await this.getCustomTelemetryService(O)).publicLog(m,y)}async publicLogError(O,m,y){await(await this.getCustomTelemetryService(O)).publicLogError(m,y)}};g=he([Y(0,U.IConfigurationService),Y(1,T.ITelemetryService)],g),e.CustomEndpointTelemetryService=g}),define(Z[80],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var k;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(A=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,p.createDecorator)("localTerminalService"),e.IPtyService=(0,p.createDecorator)("ptyService");var P;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(P=e.HeartbeatConstants||(e.HeartbeatConstants={}));var U;(function(g){g[g.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",g[g.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(U=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var T;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(T=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(Z[175],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,p.createDecorator)("localPtyService")}),define(Z[176],ee([0,1,2,17,80,49,16,34,3,75,22]),function(K,e,p,k,A,P,U,T,g,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let y=0,b=class extends p.Disposable{constructor(S,E){super();this._logService=S,this._telemetryService=E,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new g.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new g.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new g.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new g.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new g.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new g.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new g.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new g.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new g.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new g.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new g.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new g.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new g.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,p.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const S=new P.Client(U.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:y,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),T.ProxyChannel.toService(S.getChannel(A.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(S.onDidProcessExit(f=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(f.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}, giving up`))}));const C=S.getChannel(A.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(C,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(C,this._logService.getLevel())}));const I=T.ProxyChannel.toService(S.getChannel(A.TerminalIpcChannels.PtyHost));return this._register(I.onProcessData(f=>this._onProcessData.fire(f))),this._register(I.onProcessExit(f=>this._onProcessExit.fire(f))),this._register(I.onProcessReady(f=>this._onProcessReady.fire(f))),this._register(I.onProcessTitleChanged(f=>this._onProcessTitleChanged.fire(f))),this._register(I.onProcessShellTypeChanged(f=>this._onProcessShellTypeChanged.fire(f))),this._register(I.onProcessOverrideDimensions(f=>this._onProcessOverrideDimensions.fire(f))),this._register(I.onProcessResolvedShellLaunchConfig(f=>this._onProcessResolvedShellLaunchConfig.fire(f))),this._register(I.onProcessReplay(f=>this._onProcessReplay.fire(f))),this._register(I.onProcessOrphanQuestion(f=>this._onProcessOrphanQuestion.fire(f))),[S,I]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(S,E,C,I,f,s,r,t,i,n){const o=setTimeout(()=>this._handleUnresponsiveCreateProcess(),A.HeartbeatConstants.CreateProcessTimeout),a=await this._proxy.createProcess(S,E,C,I,f,s,r,t,i,n);return clearTimeout(o),y=Math.max(y,a),a}updateTitle(S,E){return this._proxy.updateTitle(S,E)}updateIcon(S,E){return this._proxy.updateIcon(S,E)}attachToProcess(S){return this._proxy.attachToProcess(S)}detachFromProcess(S){return this._proxy.detachFromProcess(S)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(S){return this._proxy.start(S)}shutdown(S,E){return this._proxy.shutdown(S,E)}input(S,E){return this._proxy.input(S,E)}processBinary(S,E){return this._proxy.processBinary(S,E)}resize(S,E,C){return this._proxy.resize(S,E,C)}acknowledgeDataEvent(S,E){return this._proxy.acknowledgeDataEvent(S,E)}getInitialCwd(S){return this._proxy.getInitialCwd(S)}getCwd(S){return this._proxy.getCwd(S)}getLatency(S){return this._proxy.getLatency(S)}orphanQuestionReply(S){return this._proxy.orphanQuestionReply(S)}getDefaultSystemShell(S){return this._proxy.getDefaultSystemShell(S)}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(S){return this._proxy.getWslPath(S)}setTerminalLayoutInfo(S){return this._proxy.setTerminalLayoutInfo(S)}async getTerminalLayoutInfo(S){return await this._proxy.getTerminalLayoutInfo(S)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier+A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${A.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};b=he([Y(0,k.ILogService),Y(1,O.ITelemetryService)],b),e.PtyHostService=b}),define(Z[52],ee([0,1,41]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function k(U,T,g,v){const O=(0,p.setProperty)(U,T,g,v)[0];return O&&(U=U.substring(0,O.offset)+O.content+U.substring(O.offset+O.length)),U}e.edit=k;function A(U,T,g){let v=g;for(;v>=0;){if(U.charAt(v)===T.charAt(T.length-1)&&T.length===1)return v+1;if(v--,T.length===2&&v>=0&&U.charAt(v)===T.charAt(0))return v+2}return 0}e.getLineStartOffset=A;function P(U,T,g){let v=g;for(;v>=0;)if(U.charAt(v)===T.charAt(T.length-1)&&T.length===1||(v++,T.length===2&&v>=0&&U.charAt(v)===T.charAt(1)))return v;return U.length-1}e.getLineEndOffset=P}),define(Z[177],ee([0,1,26,56]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(m,y,b,u,S){var E,C;const I=[],f=[],s=[];if(!y){const j=m.filter(({identifier:B})=>S.every(M=>M.toLowerCase()!==B.id.toLowerCase()));return{added:I,removed:f,updated:s,remote:j.length>0?j:null}}m=m.map(v),y=y.map(v),b=b?b.map(v):null;const r=new Map,t=j=>{j.uuid&&r.set(j.id.toLowerCase(),j.uuid)};m.forEach(({identifier:j})=>t(j)),y.forEach(({identifier:j})=>t(j)),b&&b.forEach(({identifier:j})=>t(j));const i=j=>{const B=j.identifier.uuid||r.get(j.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${j.identifier.id.toLowerCase()}`},n=(j,B)=>(j.set(i(B),B),j),o=m.reduce(n,new Map),a=y.reduce(n,new Map),c=y.reduce((j,B)=>{const M=i(B);B=(0,p.deepClone)(B);const $=o.get(M);return $&&($.installed&&(B.installed=!0),B.version||(B.version=$.version)),n(j,B)},new Map),l=b?b.reduce(n,new Map):null,d=u.reduce(n,new Map),w=S.reduce((j,B)=>{const M=r.get(B.toLowerCase());return j.add(M?`uuid:${M}`:`id:${B.toLowerCase()}`)},new Set),h=P(o,a,w);if(h.added.size>0||h.removed.size>0||h.updated.size>0){const j=P(l,o,w),B=P(l,a,w),M=($,V)=>{const q=o.get($);if(q){const H=a.get($);return Object.assign(Object.assign({},V?H:q),{version:(H.version&&k.gt(H.version,q.version),q.version),state:U(q,H,l==null?void 0:l.get($))})}};for(const $ of B.removed.values()){const V=o.get($);V&&f.push(V.identifier)}for(const $ of B.added.values())if(j.added.has($)){if(h.updated.has($)){const V=M($,!0);V&&(s.push(O(V,$)),c.set($,V))}}else{const V=a.get($);V.installed&&I.push(O(V,$))}for(const $ of B.updated.values()){const V=M($,!0);V&&(s.push(O(V,$)),c.set($,V))}for(const $ of j.added.values())B.added.has($)||c.set($,o.get($));for(const $ of j.updated.values())if(!B.removed.has($)&&!B.updated.has($)){const V=M($,!1);V&&(((E=c.get($))===null||E===void 0?void 0:E.installed)&&(V.installed=!0),c.set($,V))}for(const $ of j.removed.values())!d.has($)&&!B.updated.has($)&&((C=l==null?void 0:l.get($))===null||C===void 0?void 0:C.installed)&&c.delete($)}const R=[],_=P(a,c,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&c.forEach((j,B)=>R.push(O(j,B))),{added:I,removed:f,updated:s,remote:R.length?R:null}}e.merge=A;function P(m,y,b,{checkInstalledProperty:u,checkVersionProperty:S}={checkInstalledProperty:!1,checkVersionProperty:!1}){const E=m?[...m.keys()].filter(r=>!b.has(r)):[],C=[...y.keys()].filter(r=>!b.has(r)),I=C.filter(r=>E.indexOf(r)===-1).reduce((r,t)=>(r.add(t),r),new Set),f=E.filter(r=>C.indexOf(r)===-1).reduce((r,t)=>(r.add(t),r),new Set),s=new Set;for(const r of E)if(!f.has(r)){const t=m.get(r),i=y.get(r);(!i||t.disabled!==i.disabled||!g(t.state,i.state)||S&&t.version!==i.version||u&&t.installed!==i.installed)&&s.add(r)}return{added:I,removed:f,updated:s}}function U(m,y,b){const u=m.state,S=y.state,E=b==null?void 0:b.state;if(!y.version||u&&k.gt(m.version,y.version))return u;if(S&&k.gt(y.version,m.version)||!u)return S;if(!S)return u;const C=(0,p.deepClone)(u),I=E?T(E,S):{added:Object.keys(S).reduce((s,r)=>(s.add(r),s),new Set),removed:new Set,updated:new Set},f=E?T(E,u):{added:Object.keys(u).reduce((s,r)=>(s.add(r),s),new Set),removed:new Set,updated:new Set};for(const s of[...I.added.values(),...I.updated.values()])C[s]=S[s];for(const s of I.removed.values())f.updated.has(s)||delete C[s];return C}function T(m,y){const b=Object.keys(m),u=Object.keys(y),S=u.filter(I=>b.indexOf(I)===-1).reduce((I,f)=>(I.add(f),I),new Set),E=b.filter(I=>u.indexOf(I)===-1).reduce((I,f)=>(I.add(f),I),new Set),C=new Set;for(const I of b)if(!E.has(I)){const f=m[I],s=y[I];(0,p.equals)(f,s)||C.add(I)}return{added:S,removed:E,updated:C}}function g(m={},y={}){const{added:b,removed:u,updated:S}=T(m,y);return b.size===0&&u.size===0&&S.size===0}function v(m){return Object.assign(Object.assign({},m),{disabled:!!m.disabled,installed:!!m.installed})}function O(m,y){const b={identifier:{id:m.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0}};return m.version&&(b.version=m.version),m.disabled&&(b.disabled=!0),m.installed&&(b.installed=!0),m.state&&(b.state=m.state),b}}),define(Z[81],ee([0,1,18,3,2,33,5,28,19]),function(K,e,p,k,A,P,U,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,U.createDecorator)("IExtensionsStorageSyncService");const v=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let O=class Qe extends A.Disposable{constructor(y,b){super();this.storageService=y,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new k.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(y){return`extensionKeys/${(0,P.adoptToGalleryExtensionId)(y.id)}@${y.version}`}static fromKey(y){const b=v.exec(y);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const y=this.storageService.keys(0,1);for(const b of y){const u=Qe.fromKey(b);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(y){if(y.scope===0){if(this.extensionsWithKeysForSync.has(y.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=Qe.fromKey(y.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(y,b){this.storageService.store(Qe.toKey(y),JSON.stringify(b),0,1)}getKeysForSync(y){var b;const u=(b=this.productService.extensionSyncedKeys)===null||b===void 0?void 0:b[y.id.toLowerCase()],S=this.storageService.get(Qe.toKey(y),0),E=S?JSON.parse(S):void 0;return E&&u?(0,p.distinct)([...E,...u]):E||u}};O=he([Y(0,g.IStorageService),Y(1,T.IProductService)],O),e.ExtensionsStorageSyncService=O}),define(Z[82],ee([0,1,18,25,5]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let P=class{constructor(T){this.configurationService=T}hasToNeverSyncExtension(T){return this.getConfiguredIgnoredExtensions().includes(T.toLowerCase())}hasToAlwaysSyncExtension(T){return this.getConfiguredIgnoredExtensions().includes(`-${T.toLowerCase()}`)}updateIgnoredExtensions(T,g){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(O=>O.toLowerCase());return v=v.filter(O=>O!==T&&O!==`-${T}`),g&&v.push(T.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}updateSynchronizedExtensions(T,g){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(O=>O.toLowerCase());return v=v.filter(O=>O!==T&&O!==`-${T}`),g&&v.push(`-${T.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}getIgnoredExtensions(T){const g=T.filter(y=>y.isMachineScoped).map(y=>y.identifier.id.toLowerCase()),v=this.getConfiguredIgnoredExtensions().map(y=>y.toLowerCase()),O=[],m=[];if(Array.isArray(v))for(const y of v)y.startsWith("-")?m.push(y.substring(1)):O.push(y);return(0,p.distinct)([...g,...O].filter(y=>m.indexOf(y)===-1))}getConfiguredIgnoredExtensions(){let T=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return T!==void 0||(T=this.configurationService.inspect("sync.ignoredExtensions").userValue,T!==void 0)?T:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(g=>g.toLowerCase())}};P=he([Y(0,k.IConfigurationService)],P),e.IgnoredExtensionsManagementService=P}),define(Z[178],ee([0,1,26,32,18,139,52]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function T(s){return(0,k.parse)(s)||[]}e.parseKeybindings=T;async function g(s,r,t,i,n){const o=T(s),a=T(r),c=t?T(t):null,l=[...o,...a,...c||[]].map(q=>q.key),d=await n.resolveUserBindings(l);let w=O(o,a,c,d);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:r,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const h=y(o),R=y(a),_=c?y(c):null,j=u(h,R,d),B=_?u(_,h,d):{added:[...h.keys()].reduce((q,H)=>(q.add(H),q),new Set),removed:new Set,updated:new Set},M=_?u(_,R,d):{added:[...R.keys()].reduce((q,H)=>(q.add(H),q),new Set),removed:new Set,updated:new Set},$=v(j,B,M);let V=s;for(const q of $.removed.values())$.conflicts.has(q)||(V=I(V,q,i));for(const q of $.added.values())if(!$.conflicts.has(q)){const H=R.get(q);if(H.some(z=>z.command!==`-${q}`&&w.conflicts.has(d[z.key]))){$.conflicts.add(q);continue}V=C(V,H,i)}for(const q of $.updated.values())if(!$.conflicts.has(q)){const H=R.get(q);if(H.some(z=>z.command!==`-${q}`&&w.conflicts.has(d[z.key]))){$.conflicts.add(q);continue}V=f(V,q,H,i)}return{mergeContent:V,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=g;function v(s,r,t){const i=new Set,n=new Set,o=new Set,a=new Set;for(const c of r.removed.values())t.updated.has(c)&&a.add(c);for(const c of t.removed.values())a.has(c)||(r.updated.has(c)?a.add(c):n.add(c));for(const c of r.added.values())a.has(c)||t.added.has(c)&&s.updated.has(c)&&a.add(c);for(const c of t.added.values())a.has(c)||(r.added.has(c)?s.updated.has(c)&&a.add(c):i.add(c));for(const c of r.updated.values())a.has(c)||t.updated.has(c)&&s.updated.has(c)&&a.add(c);for(const c of t.updated.values())a.has(c)||(r.updated.has(c)?s.updated.has(c)&&a.add(c):o.add(c));return{added:i,removed:n,updated:o,conflicts:a}}function O(s,r,t,i){const n=new Set,o=m(s,i),a=m(r,i),c=t?m(t,i):null,l=b(o,a);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=c?b(c,o):{added:[...o.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=c?b(c,a):{added:[...a.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:h,removed:R,updated:_,conflicts:j}=v(l,d,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:h,removed:R,updated:_,conflicts:j}}function m(s,r){const t=new Map;for(const i of s){const n=r[i.key];let o=t.get(n);o||(o=[],t.set(n,o)),o.push(i)}return t}function y(s){const r=new Map;for(const t of s){const i=t.command[0]==="-"?t.command.substring(1):t.command;let n=r.get(i);n||(n=[],r.set(i,n)),n.push(t)}return r}function b(s,r){const t=[...s.keys()],i=[...r.keys()],n=i.filter(c=>t.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),o=t.filter(c=>i.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),a=new Set;for(const c of t)if(!o.has(c)){const l=s.get(c).map(w=>Object.assign(Object.assign({},w),{key:c})),d=r.get(c).map(w=>Object.assign(Object.assign({},w),{key:c}));(0,A.equals)(l,d,(w,h)=>E(w,h))||a.add(c)}return{added:n,removed:o,updated:a}}function u(s,r,t){const i=[...s.keys()],n=[...r.keys()],o=n.filter(l=>i.indexOf(l)===-1).reduce((l,d)=>(l.add(d),l),new Set),a=i.filter(l=>n.indexOf(l)===-1).reduce((l,d)=>(l.add(d),l),new Set),c=new Set;for(const l of i)if(!a.has(l)){const d=s.get(l).map(h=>Object.assign(Object.assign({},h),{key:t[h.key]})),w=r.get(l).map(h=>Object.assign(Object.assign({},h),{key:t[h.key]}));S(d,w)||c.add(l)}return{added:o,removed:a,updated:c}}function S(s,r){return!(!(0,A.equals)(s.filter(({command:t})=>t[0]!=="-"),r.filter(({command:t})=>t[0]!=="-"),(t,i)=>E(t,i))||!(0,A.equals)(s.filter(({command:t})=>t[0]==="-"),r.filter(({command:t})=>t[0]==="-"),(t,i)=>E(t,i)))}function E(s,r){if(s.command!==r.command||s.key!==r.key)return!1;const t=P.ContextKeyExpr.deserialize(s.when),i=P.ContextKeyExpr.deserialize(r.when);return!(t&&!i||!t&&i||t&&i&&!t.equals(i)||!p.equals(s.args,r.args))}function C(s,r,t){for(const i of r)s=U.edit(s,[-1],i,t);return s}function I(s,r,t){const i=T(s);for(let n=i.length-1;n>=0;n--)(i[n].command===r||i[n].command===`-${r}`)&&(s=U.edit(s,[n],void 0,t));return s}function f(s,r,t,i){const n=T(s),o=n.findIndex(a=>a.command===r||a.command===`-${r}`);for(let a=n.length-1;a>=0;a--)(n[a].command===r||n[a].command===`-${r}`)&&(s=U.edit(s,[a],void 0,i));for(let a=t.length-1;a>=0;a--)s=U.edit(s,[o],t[a],i);return s}}),define(Z[179],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function p(P,U,T){const g={},v={},O=new Set;if(!U)return{local:{added:g,updated:v,removed:[...O.values()]},remote:{added:P,updated:{},removed:[]},conflicts:[]};const m=k(P,U);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{local:{added:g,updated:v,removed:[...O.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const y=k(T,P),b=k(T,U),u={},S={},E=new Set,C=new Set;for(const I of y.removed.values())b.updated.has(I)?g[I]=U[I]:E.add(I);for(const I of b.removed.values())C.has(I)||(y.updated.has(I)?C.add(I):O.add(I));for(const I of y.updated.values())C.has(I)||(b.updated.has(I)?m.updated.has(I)&&C.add(I):S[I]=P[I]);for(const I of b.updated.values())C.has(I)||(y.updated.has(I)?m.updated.has(I)&&C.add(I):P[I]!==void 0&&(v[I]=U[I]));for(const I of y.added.values())C.has(I)||(b.added.has(I)?m.updated.has(I)&&C.add(I):u[I]=P[I]);for(const I of b.added.values())C.has(I)||(y.added.has(I)?m.updated.has(I)&&C.add(I):g[I]=U[I]);return{local:{added:g,removed:[...O.values()],updated:v},remote:{added:u,removed:[...E.values()],updated:S},conflicts:[...C.values()]}}e.merge=p;function k(P,U){const T=P?Object.keys(P):[],g=U?Object.keys(U):[],v=g.filter(y=>T.indexOf(y)===-1).reduce((y,b)=>(y.add(b),y),new Set),O=T.filter(y=>g.indexOf(y)===-1).reduce((y,b)=>(y.add(b),y),new Set),m=new Set;for(const y of T)if(!O.has(y)){const b=P[y],u=U[y];b!==u&&m.add(y)}return{added:v,removed:O,updated:m}}function A(P,U){const{added:T,removed:g,updated:v}=k(P,U);return T.size===0&&g.size===0&&v.size===0}e.areSame=A}),define(Z[20],ee([0,1,5,29,35,39,123,77,12,18,15]),function(K,e,p,k,A,P,U,T,g,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function m(){const a=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(a).filter(c=>!!a[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=m;function y(){const a=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(a).filter(w=>!!a[w].ignoreSync),l=Object.keys(a).filter(w=>a[w].scope===2||a[w].scope===6),d=m();return(0,v.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...l,...d])}e.getDefaultIgnoredSettings=y;function b(){const a="vscode://schemas/ignoredSettings",c=A.Registry.as(P.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,U.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,U.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,U.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,U.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,U.localize)(4,null),default:[],scope:1,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=A.Registry.as(T.Extensions.JSONContribution),d=()=>{const w=m(),h=y().filter(B=>B!==e.CONFIGURATION_SYNC_STORE_KEY),R=Object.keys(P.allSettings.properties).filter(B=>h.indexOf(B)===-1),_=h.filter(B=>w.indexOf(B)===-1),j={items:{type:"string",enum:[...R,..._.map(B=>`-${B}`)]}};l.registerSchema(a,j)};return c.onDidUpdateConfiguration(()=>d())}e.registerConfiguration=b;function u(a){return a&&(0,O.isObject)(a)&&(0,O.isString)(a.id)&&(0,O.isArray)(a.scopes)}e.isAuthenticationProvider=u;var S;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Extensions="extensions",a.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,p.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,p.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,p.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function E(a){const c={};return c[e.HEADER_EXECUTION_ID]=a,c}e.createSyncHeaders=E;var C;(function(a){a.Unauthorized="Unauthorized",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.NoRef="NoRef",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.UnresolvedConflicts="UnresolvedConflicts",a.Unknown="Unknown"})(C=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class I extends Error{constructor(c,l,d,w){super(c);this.code=l,this.resource=d,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=I;class f extends I{constructor(c,l,d,w){super(c,d,void 0,w);this.url=l}}e.UserDataSyncStoreError=f;class s extends I{constructor(c,l){super(c,l)}}e.UserDataAutoSyncError=s,function(a){function c(l){if(l instanceof a)return l;const d=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(d&&d[1]){const w=d[2]==="unknown"?void 0:d[2],h=d[3]==="unknown"?void 0:d[3];return new a(l.message,d[1],w,h)}return new a(l.message,C.Unknown)}a.toUserDataSyncError=c}(I=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var t;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var i;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(a){return`sync.enable.${a}`}e.getEnablementKey=n,e.IUserDataSyncResourceEnablementService=(0,p.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,p.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,p.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,p.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,p.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,p.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(a,c){if(a.scheme!==e.USER_DATA_SYNC_SCHEME)return a=a.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>(0,g.isEqualOrParent)(a,(0,g.joinPath)(c.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(Z[45],ee([0,1,2,10,23,4,20,9,12,6,3,22,32,119,25,15,21,18,44,19,30]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=r;function t(c,l,d){return d.joinPath(l.userDataSyncHome,c,`lastSync${c}.json`)}let i=class extends p.Disposable{constructor(l,d,w,h,R,_,j,B,M,$){super();this.resource=l,this.fileService=d,this.environmentService=w,this.userDataSyncStoreService=R,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=j,this.telemetryService=B,this.logService=M,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new O.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new O.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new v.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new O.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(w.userDataSyncHome,1024)?g.extUri:g.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(w.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,U.PREVIEW_DIR_NAME),this.lastSyncResource=t(l,w,this.extUri),this.currentMachineIdPromise=(0,I.getServiceMachineId)(w,d,h)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,s.CancellationToken.None)).resourcePreviews.some(({remoteChange:w})=>w!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const d=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),d==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,d={}){await this._sync(l,!0,d)}async preview(l,d={}){return this._sync(l,!1,d)}async apply(l,d={}){try{this.syncHeaders=Object.assign({},d);const w=await this.doApply(l);return this.setStatus(w),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,d,w){try{if(this.syncHeaders=Object.assign({},w),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let h="idle";try{const R=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(l,R);return h=await this.performSync(_,R,d),h==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):h==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(h)}}finally{this.syncHeaders={}}}async replace(l){const d=await this.resolveContent(l);if(!d)return!1;const w=this.parseSyncData(d);if(!w)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const h=await this.getLastSyncUserData(),R=await this.getLatestRemoteUserData(null,h),_=await this.generateSyncPreview({ref:R.ref,syncData:w},h,s.CancellationToken.None),j=[];for(const B of _){const M=await this.getAcceptResult(B,B.remoteResource,void 0,s.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(B,B.previewResource,B.remoteContent,s.CancellationToken.None);j.push([B,Object.assign(Object.assign({},M),{remoteChange:$!==0?$:2})])}await this.applyResult(R,h,j,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(l,d){if(d){const w=l&&l.latest?l.latest[this.resource]:void 0;if(d.ref===w||w===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(l,d,w){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new U.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,l.syncData.version),U.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(l,d,w)}catch(h){if(h instanceof U.UserDataSyncError)switch(h.code){case U.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,d,w);case U.UserDataSyncErrorCode.Conflict:case U.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(l,d,w)}throw h}}async doSync(l,d,w){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,v.createCancelablePromise)(R=>this.doGenerateSyncResourcePreview(l,d,w,R)));const h=await this.syncPreviewPromise;return this.updateConflicts(h.resourcePreviews),h.resourcePreviews.some(({mergeState:R})=>R==="conflict")?"hasConflicts":w?await this.doApply(!1):"syncing"}catch(h){throw this.syncPreviewPromise=null,h}}async merge(l){return await this.updateSyncResourcePreview(l,async d=>{const w=await this.getMergeResult(d,s.CancellationToken.None);await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString((w==null?void 0:w.content)||""));const h=w&&!w.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,s.CancellationToken.None):void 0;return d.acceptResult=h,d.mergeState=w.hasConflicts?"conflict":h?"accepted":"preview",d.localChange=h?h.localChange:w.localChange,d.remoteChange=h?h.remoteChange:w.remoteChange,d}),this.syncPreviewPromise}async accept(l,d){return await this.updateSyncResourcePreview(l,async w=>{const h=await this.getAcceptResult(w,l,d,s.CancellationToken.None);return w.acceptResult=h,w.mergeState="accepted",w.localChange=h.localChange,w.remoteChange=h.remoteChange,w}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async d=>{const w=await this.getMergeResult(d,s.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString(w.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=w.localChange,d.remoteChange=w.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(l,d){if(!!this.syncPreviewPromise){let w=await this.syncPreviewPromise;const h=w.resourcePreviews.findIndex(({localResource:R,remoteResource:_,previewResource:j})=>this.extUri.isEqual(R,l)||this.extUri.isEqual(_,l)||this.extUri.isEqual(j,l));h!==-1&&(this.syncPreviewPromise=(0,v.createCancelablePromise)(async R=>{const _=[...w.resourcePreviews];return _[h]=await d(_[h]),Object.assign(Object.assign({},w),{resourcePreviews:_})}),w=await this.syncPreviewPromise,this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:R})=>R==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(l){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:w})=>w==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:w})=>w!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(w=>[w,w.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const d=l.filter(({mergeState:w})=>w==="conflict");(0,C.equals)(this._conflicts,d,(w,h)=>this.extUri.isEqual(w.previewResource,h.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:d,ref:w})=>({created:d,uri:this.toRemoteBackupResource(w)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:d,ref:w})=>({created:d,uri:this.toLocalBackupResource(w)}))}toRemoteBackupResource(l){return P.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return P.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const d=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(d))){const{content:w}=await this.getUserData(d);if(w){const h=this.parseSyncData(w);return h==null?void 0:h.machineId}}}async resolveContent(l){const d=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(d))){const{content:w}=await this.getUserData(d);return w}return this.extUri.isEqual(l,this.toLocalBackupResource(d))?this.userDataSyncBackupStoreService.resolveContent(this.resource,d):null}async resolvePreviewContent(l){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const w of d.resourcePreviews){if(this.extUri.isEqual(w.acceptedResource,l))return w.acceptResult?w.acceptResult.content:null;if(this.extUri.isEqual(w.remoteResource,l))return w.remoteContent;if(this.extUri.isEqual(w.localResource,l))return w.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,d,w,h){var R;const _=await this.currentMachineIdPromise,j=!!((R=l.syncData)===null||R===void 0?void 0:R.machineId)&&l.syncData.machineId===_,B=d===null&&j&&!this.hasSyncResourceStateVersionChanged?l:d,M=await this.generateSyncPreview(l,B,h),$=[];for(const V of M){const q=V.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(V.localChange===0&&V.remoteChange===0)$.push(Object.assign(Object.assign({},V),{acceptedResource:q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const H=w?await this.getMergeResult(V,h):void 0;if(h.isCancellationRequested)break;await this.fileService.writeFile(V.previewResource,A.VSBuffer.fromString((H==null?void 0:H.content)||""));const z=H&&!H.hasConflicts?await this.getAcceptResult(V,V.previewResource,void 0,h):void 0;$.push(Object.assign(Object.assign({},V),{acceptResult:z,mergeState:(H==null?void 0:H.hasConflicts)?"conflict":z?"accepted":"preview",localChange:z?z.localChange:H?H.localChange:V.localChange,remoteChange:z?z.remoteChange:H?H.remoteChange:V.remoteChange}))}}return{remoteUserData:l,lastSyncUserData:d,resourcePreviews:$,isLastSyncFromCurrentMachine:j}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(l.value.toString()),w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=d.version&&w&&d.version!==w,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${w}.`),await this.resetLocal(),null;const h=d;if(h.content===null)return{ref:d.ref,syncData:null};const R=JSON.parse(h.content);if(r(R))return Object.assign(Object.assign({},d),{syncData:R,content:void 0})}catch(l){l instanceof k.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,d={}){if(d.ref||d.content||d.version)throw new Error("Cannot have core properties as additional");const w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),h=Object.assign({ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:w},d);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(h)))}async getRemoteUserData(l){const{ref:d,content:w}=await this.getUserData(l);let h=null;return w!==null&&(h=this.parseSyncData(w)),{ref:d,syncData:h}}parseSyncData(l){try{const d=JSON.parse(l);if(r(d))return d}catch(d){this.logService.error(d)}throw new U.UserDataSyncError((0,b.localize)(1,null),U.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(l){if((0,S.isString)(l)){const d=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:d}}else{const d=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,d,this.syncHeaders)}}async updateRemoteUserData(l,d){const w=await this.currentMachineIdPromise,h={version:this.version,machineId:w,content:l};return d=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(h),d,this.syncHeaders),{ref:d,syncData:h}}async backupLocal(l){const d={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};i=he([Y(1,k.IFileService),Y(2,T.IEnvironmentService),Y(3,f.IStorageService),Y(4,U.IUserDataSyncStoreService),Y(5,U.IUserDataSyncBackupStoreService),Y(6,U.IUserDataSyncResourceEnablementService),Y(7,m.ITelemetryService),Y(8,U.IUserDataSyncLogService),Y(9,u.IConfigurationService)],i),e.AbstractSynchroniser=i;let n=class extends i{constructor(l,d,w,h,R,_,j,B,M,$,V){super(d,w,h,R,_,j,B,M,$,V);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(q=>this.onFileChanges(q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,d,w){try{d?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(l),w?void 0:d):await this.fileService.createFile(this.file,A.VSBuffer.fromString(l),{overwrite:w})}catch(h){throw h instanceof k.FileOperationError&&h.fileOperationResult===1||h instanceof k.FileOperationError&&h.fileOperationResult===3?new U.UserDataSyncError(h.message,U.UserDataSyncErrorCode.LocalPreconditionFailed):h}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};n=he([Y(2,k.IFileService),Y(3,T.IEnvironmentService),Y(4,f.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,m.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,u.IConfigurationService)],n),e.AbstractFileSynchroniser=n;let o=class extends n{constructor(l,d,w,h,R,_,j,B,M,$,V,q){super(l,d,w,h,R,_,j,B,M,$,q);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(l){const d=[];return(0,y.parse)(l,d,{allowEmptyContent:!0,allowTrailingComma:!0}),d.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=he([Y(2,k.IFileService),Y(3,T.IEnvironmentService),Y(4,f.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,m.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,U.IUserDataSyncUtilService),Y(11,u.IConfigurationService)],o),e.AbstractJsonFileSynchroniser=o;let a=class{constructor(l,d,w,h){this.resource=l,this.environmentService=d,this.logService=w,this.fileService=h,this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?g.extUri:g.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,d,g.extUri)}async initialize({ref:l,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const w=this.parseSyncData(d);if(!!w){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:w})}catch(R){this.logService.error(R)}}}parseSyncData(l){try{const d=JSON.parse(l);if(r(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,d={}){const w=Object.assign({ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null},d);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(w)))}};a=he([Y(1,T.IEnvironmentService),Y(2,U.IUserDataSyncLogService),Y(3,k.IFileService)],a),e.AbstractInitializer=a}),define(Z[180],ee([0,1,20,3,9,29,33,10,25,177,45,22,4,46,41,21,19,82,11,81,6]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function r(a,c){const l=JSON.parse(a.content);if(a.version===1||a.version===2){const d=(await c.getInstalled(0)).filter(w=>w.isBuiltin);for(const w of l)a.version===1&&(w.enabled===!1&&(w.disabled=!0),delete w.enabled),a.version===2&&d.every(h=>!(0,U.areSameExtensions)(h.identifier,w.identifier))&&(w.installed=!0)}return l}function t(a,c,l){const d=l.get((0,U.getExtensionId)(a,c),0)||"{}";return JSON.parse(d)}e.getExtensionStorageState=t;function i(a,c,l,d){d.store((0,U.getExtensionId)(a,c),JSON.stringify(l),0,1)}e.storeExtensionStorageState=i;let n=class st extends O.AbstractSynchroniser{constructor(c,l,d,w,h,R,_,j,B,M,$,V,q,H){super("extensions",l,c,d,w,h,V,q,B,$);this.storageService=d,this.extensionManagementService=R,this.extensionEnablementService=_,this.ignoredExtensionsManagementService=j,this.extensionGalleryService=M,this.extensionsStorageSyncService=H,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtension,z=>!!z.gallery),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,z=>!z.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,l){const d=c.syncData?await r(c.syncData,this.extensionManagementService):null,w=(l==null?void 0:l.skippedExtensions)||[],h=(l==null?void 0:l.syncData)?await r(l.syncData,this.extensionManagementService):null,R=await this.extensionManagementService.getInstalled(),_=this.getLocalExtensions(R),j=this.ignoredExtensionsManagementService.getIgnoredExtensions(R);d?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:B,removed:M,updated:$,remote:V}=(0,v.merge)(_,d,h,w,j),q={added:B,removed:M,updated:$,remote:V,content:this.getPreviewContent(_,B,$,M),localChange:B.length>0||M.length>0||$.length>0?2:0,remoteChange:V!==null?2:0};return[{skippedExtensions:w,localResource:this.localResource,localContent:this.format(_),localExtensions:_,remoteResource:this.remoteResource,remoteContent:d?this.format(d):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,l,d,w){const h=[...l,...d],R=new Set,_=j=>{R.add(j.id.toLowerCase()),j.uuid&&R.add(j.uuid)};h.forEach(({identifier:j})=>_(j)),w.forEach(_);for(const j of c)R.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&R.has(j.identifier.uuid)||h.push(j);return this.format(h)}async getMergeResult(c,l){return Object.assign(Object.assign({},c.previewResult),{hasConflicts:!1})}async getAcceptResult(c,l,d,w){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(l,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(c){const l=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),w=(0,v.merge)(c.localExtensions,null,null,c.skippedExtensions,d),{added:h,removed:R,updated:_,remote:j}=w;return{content:c.localContent,added:h,removed:R,updated:_,remote:j,localChange:h.length>0||R.length>0||_.length>0?2:0,remoteChange:j!==null?2:0}}async acceptRemote(c){const l=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),w=c.remoteContent?JSON.parse(c.remoteContent):null;if(w!==null){const h=(0,v.merge)(c.localExtensions,w,c.localExtensions,[],d),{added:R,removed:_,updated:j,remote:B}=h;return{content:c.remoteContent,added:R,removed:_,updated:j,remote:B,localChange:R.length>0||_.length>0||j.length>0?2:0,remoteChange:B!==null?2:0}}else return{content:c.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(c,l,d,w){let{skippedExtensions:h,localExtensions:R}=d[0][0],{added:_,removed:j,updated:B,remote:M,localChange:$,remoteChange:V}=d[0][1];if($===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(R)),h=await this.updateLocalExtensions(_,j,B,h)),M){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const q=JSON.stringify(M);c=await this.updateRemoteUserData(q,w?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(l==null?void 0:l.ref)!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:h}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:st.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,st.EXTENSIONS_DATA_URI)){const d=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),h=this.getLocalExtensions(d).filter(R=>!w.some(_=>(0,U.areSameExtensions)({id:_},R.identifier)));return this.format(h)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let l=await super.resolveContent(c);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(c)),l){const d=this.parseSyncData(l);if(d)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(d))}}return null}format(c){c.sort((w,h)=>!w.identifier.uuid&&h.identifier.uuid?-1:w.identifier.uuid&&!h.identifier.uuid?1:(0,S.compare)(w.identifier.id,h.identifier.id));const l=JSON.stringify(c),d=(0,b.format)(l,void 0,{});return(0,u.applyEdits)(l,d)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(d=>d.installed||d.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,l,d,w){const h=[],R=[],_=await this.extensionManagementService.getInstalled();if(l.length){const B=_.filter(({identifier:M,isBuiltin:$})=>!$&&l.some(V=>(0,U.areSameExtensions)(M,V)));await s.Promises.settled(B.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),h.push(M.identifier)}))}(c.length||d.length)&&await s.Promises.settled([...c,...d].map(async B=>{const M=_.find(V=>(0,U.areSameExtensions)(V.identifier,B.identifier));if(M&&M.isBuiltin){B.state&&M.manifest.version===B.version&&this.updateExtensionState(B.state,M.manifest.publisher,M.manifest.name,M.manifest.version),B.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,B.identifier.id),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,B.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,B.identifier.id),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,B.identifier.id)),h.push(B.identifier);return}const $=await this.extensionGalleryService.getCompatibleExtension(B.identifier);if(B.state&&(M?M.manifest.version===B.version:!!$)){const V=M?M.manifest.publisher:$.publisher,q=M?M.manifest.name:$.name;this.updateExtensionState(B.state,V,q,M==null?void 0:M.manifest.version)}if($)try{B.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,B.identifier.id,$.version),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,B.identifier.id,$.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,B.identifier.id,$.version),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,B.identifier.id,$.version)),M||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,B.identifier.id,$.version),await this.extensionManagementService.installFromGallery($,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,B.identifier.id,$.version),h.push($.identifier))}catch(V){R.push(B),this.logService.error(V),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,$.displayName||$.identifier.id)}else R.push(B)}));const j=[];for(const B of w)h.some(M=>(0,U.areSameExtensions)(M,B.identifier))||j.push(B);for(const B of R)j.some(M=>(0,U.areSameExtensions)(M.identifier,B.identifier))||j.push(B);return j}updateExtensionState(c,l,d,w){const h=t(l,d,this.storageService),R=w?this.extensionsStorageSyncService.getKeysForSync({id:(0,U.getGalleryExtensionId)(l,d),version:w}):void 0;R?R.forEach(_=>{h[_]=c[_]}):Object.keys(c).forEach(_=>h[_]=c[_]),i(l,d,h,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const l=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:d,isBuiltin:w,manifest:h})=>{const R={identifier:d,version:h.version};l.some(_=>(0,U.areSameExtensions)(_,d))&&(R.disabled=!0),w||(R.installed=!0);try{const _=this.extensionsStorageSyncService.getKeysForSync({id:d.id,version:h.version});if(_){const j=t(h.publisher,h.name,this.storageService);R.state=Object.keys(j).reduce((B,M)=>(_.includes(M)&&(B[M]=j[M]),B),{})}}catch(_){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,I.getErrorMessage)(_))}return R})}};n.EXTENSIONS_DATA_URI=y.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=he([Y(0,A.IEnvironmentService),Y(1,T.IFileService),Y(2,E.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncBackupStoreService),Y(5,P.IExtensionManagementService),Y(6,P.IGlobalExtensionEnablementService),Y(7,C.IIgnoredExtensionsManagementService),Y(8,p.IUserDataSyncLogService),Y(9,P.IExtensionGalleryService),Y(10,g.IConfigurationService),Y(11,p.IUserDataSyncResourceEnablementService),Y(12,m.ITelemetryService),Y(13,f.IExtensionsStorageSyncService)],n),e.ExtensionsSynchroniser=n;let o=class extends O.AbstractInitializer{constructor(c,l,d,w,h){super("extensions",w,h,d);this.extensionManagementService=c,this.ignoredExtensionsManagementService=l}async parseExtensions(c){return c.syncData?await r(c.syncData,this.extensionManagementService):null}generatePreview(c,l){const d=[],w=[],h=[];for(const R of c)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(R.identifier.id)){const _=l.find(j=>(0,U.areSameExtensions)(j.identifier,R.identifier));_?(d.push(_),R.disabled&&h.push(R.identifier)):R.installed&&(w.push(R.identifier),R.disabled&&h.push(R.identifier))}return{installedExtensions:d,newExtensions:w,disabledExtensions:h,remoteExtensions:c}}};o=he([Y(0,P.IExtensionManagementService),Y(1,C.IIgnoredExtensionsManagementService),Y(2,T.IFileService),Y(3,A.IEnvironmentService),Y(4,p.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(Z[181],ee([0,1,26,20]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(T,g,v,O,m){if(!g)return{remote:Object.keys(T).length>0?T:null,local:{added:{},removed:[],updated:{}}};const y=P(T,g);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=v?P(v,g):{added:Object.keys(g).reduce((I,f)=>(I.add(f),I),new Set),removed:new Set,updated:new Set},u=v?P(v,T):{added:Object.keys(T).reduce((I,f)=>(I.add(f),I),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},E=p.deepClone(g),C=!v;for(const I of u.added.values())I!==k.SYNC_SERVICE_URL_TYPE&&C&&b.added.has(I)||(E[I]=T[I]);for(const I of u.updated.values())E[I]=T[I];for(const I of u.removed.values())O.unregistered.includes(I)||delete E[I];for(const I of b.added.values()){const f=g[I];if(O.machine.includes(I)){m.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(!(v&&u.added.has(I))){const s=T[I];s&&s.value===f.value||I===k.SYNC_SERVICE_URL_TYPE&&C&&u.added.has(I)||(s?S.updated[I]=f:S.added[I]=f)}}for(const I of b.updated.values()){const f=g[I];if(O.machine.includes(I)){m.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(!(u.updated.has(I)||u.removed.has(I))){const s=T[I];s&&s.value===f.value||(S.updated[I]=f)}}for(const I of b.removed.values()){if(O.machine.includes(I)){m.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}u.updated.has(I)||u.removed.has(I)||S.removed.push(I)}return{local:S,remote:U(E,g)?null:E}}e.merge=A;function P(T,g){const v=Object.keys(T),O=Object.keys(g),m=O.filter(u=>v.indexOf(u)===-1).reduce((u,S)=>(u.add(S),u),new Set),y=v.filter(u=>O.indexOf(u)===-1).reduce((u,S)=>(u.add(S),u),new Set),b=new Set;for(const u of v)if(!y.has(u)){const S=T[u],E=g[u];p.equals(S,E)||b.add(u)}return{added:m,removed:y,updated:b}}function U(T,g){const{added:v,removed:O,updated:m}=P(T,g);return v.size===0&&O.size===0&&m.size===0}}),define(Z[182],ee([0,1,20,23,3,9,10,52,181,32,45,22,25,4,46,41,19,7,44,31,17]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",t=["locale"];function i(l){const d=l.storage?Object.keys(l.storage).sort():[],w={};d.forEach(_=>w[_]=l.storage[_]),l.storage=w;const h=JSON.stringify(l),R=(0,u.format)(h,void 0,{});return(0,S.applyEdits)(h,R)}const n=1;let o=class ot extends O.AbstractSynchroniser{constructor(d,w,h,R,_,j,B,M,$){super("globalState",d,_,$,w,h,j,B,R,M);this.storageService=$,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(d.onDidFilesChange,V=>V.contains(this.environmentService.argvResource)),A.Event.filter($.onDidChangeValue,V=>V.scope===0&&V.target!==void 0?V.target===0:$.keys(0,0).includes(V.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,w,h){const R=d.syncData?JSON.parse(d.syncData.content):null,_=w&&w.syncData?JSON.parse(w.syncData.content):null,j=await this.getLocalGlobalState();R?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=this.getStorageKeys(_),{local:M,remote:$}=(0,g.merge)(j.storage,R?R.storage:null,_?_.storage:null,B,this.logService),V={content:null,local:M,remote:$,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:$!==null?2:0};return[{localResource:this.localResource,localContent:i(j),localUserData:j,remoteResource:this.remoteResource,remoteContent:R?i(R):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource,storageKeys:B}]}async getMergeResult(d,w){return Object.assign(Object.assign({},d.previewResult),{hasConflicts:!1})}async getAcceptResult(d,w,h,R){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(w,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const w=JSON.parse(d.remoteContent),{local:h,remote:R}=(0,g.merge)(d.localUserData.storage,w.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:h,remote:R,localChange:Object.keys(h.added).length>0||Object.keys(h.updated).length>0||h.removed.length>0?2:0,remoteChange:R!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,w,h,R){let{localUserData:_}=h[0][0],{local:j,remote:B,localChange:M,remoteChange:$}=h[0][1];if(M===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(j),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),$!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const V=JSON.stringify({storage:B});d=await this.updateRemoteUserData(V,R?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(w==null?void 0:w.ref)!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ot.GLOBAL_STATE_DATA_URI)){const h=await this.getLocalGlobalState();return i(h)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let w=await super.resolveContent(d);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(d)),w){const h=this.parseSyncData(w);if(h)switch(this.extUri.basename(d)){case"globalState.json":return i(JSON.parse(h.content))}}return null}async hasLocalData(){var d;try{const{storage:w}=await this.getLocalGlobalState();if(Object.keys(w).length>1||((d=w[`${r}.locale`])===null||d===void 0?void 0:d.value)!=="en")return!0}catch(w){}return!1}async getLocalGlobalState(){const d={},w=await this.getLocalArgvContent(),h=(0,v.parse)(w);for(const R of t)h[R]!==void 0&&(d[`${r}${R}`]={version:1,value:h[R]});for(const R of this.storageService.keys(0,0)){const _=this.storageService.get(R,0);_&&(d[R]={version:1,value:_})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:w,updated:h}){const R={},_={},j=(M,$)=>{for(const V of M){if(V.startsWith(r)){R[V.substring(r.length)]=$?$[V].value:void 0;continue}if($){const q=$[V];q.value!==String(this.storageService.get(V,0))&&(_[V]=q.value)}else this.storageService.get(V,0)!==void 0&&(_[V]=void 0)}};if(j(Object.keys(d),d),j(Object.keys(h),h),j(w),Object.keys(R).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(R),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(_))this.storageService.store(M,_[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(d){const w=await this.getLocalArgvContent();let h=w;for(const R of Object.keys(d))h=(0,T.edit)(h,[R],d[R],{});w!==h&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(h)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const w=this.storageService.keys(0,0),h=this.storageService.keys(0,1),R=[...w,...h],_=(d==null?void 0:d.storage)?Object.keys(d.storage).filter(j=>!j.startsWith(r)&&!R.includes(j)&&this.storageService.get(j,0)!==void 0):[];if(!C.isWeb){const j=[...p.ALL_SYNC_RESOURCES.map(B=>(0,p.getEnablementKey)(B)),p.SYNC_SERVICE_URL_TYPE];_.push(...j),h.push(...j)}return{user:w,machine:h,unregistered:_}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([Y(0,U.IFileService),Y(1,p.IUserDataSyncStoreService),Y(2,p.IUserDataSyncBackupStoreService),Y(3,p.IUserDataSyncLogService),Y(4,P.IEnvironmentService),Y(5,p.IUserDataSyncResourceEnablementService),Y(6,m.ITelemetryService),Y(7,y.IConfigurationService),Y(8,E.IStorageService)],o),e.GlobalStateSynchroniser=o;let a=class extends O.AbstractInitializer{constructor(d,w,h,R){super("globalState",h,R,w);this.storageService=d}async doInitialize(d){const w=d.syncData?JSON.parse(d.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const h={},R={};for(const _ of Object.keys(w.storage))_.startsWith(r)?h[_.substring(r.length)]=w.storage[_].value:this.storageService.get(_,0)===void 0&&(R[_]=w.storage[_].value);if(Object.keys(h).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(j){}for(const j of Object.keys(h))_=(0,T.edit)(_,[j],h[j],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_))}if(Object.keys(R).length)for(const _ of Object.keys(R))this.storageService.store(_,R[_],0,0)}};a=he([Y(0,E.IStorageService),Y(1,U.IFileService),Y(2,P.IEnvironmentService),Y(3,p.IUserDataSyncLogService)],a),e.GlobalStateInitializer=a;let c=class{constructor(d,w,h,R,_){this.userDataSyncStoreClient=d,this.storageService=w,this.environmentService=h,this.fileService=R,this.logService=_}getSyncStoreType(d){var w;const h=this.parseGlobalState(d);return(w=h==null?void 0:h.storage[p.SYNC_SERVICE_URL_TYPE])===null||w===void 0?void 0:w.value}async sync(d){const w=(0,p.createSyncHeaders)((0,f.generateUuid)());try{return await this.doSync(d,w)}catch(h){if(h instanceof p.UserDataSyncError)switch(h.code){case p.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,w)}throw h}}async doSync(d,w){const h=await this.userDataSyncStoreClient.read("globalState",null,w),R=this.parseGlobalState(h)||{storage:{}};R.storage[p.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const _=await(0,I.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),j={version:n,machineId:_,content:i(R)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(j),h.ref,w)}parseGlobalState({content:d}){if(!d)return null;const w=JSON.parse(d);if((0,O.isSyncData)(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};c=he([Y(1,E.IStorageService),Y(2,P.IEnvironmentService),Y(3,U.IFileService),Y(4,s.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(Z[183],ee([0,1,10,20,178,32,120,9,25,7,15,18,45,22,19,23,3]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function C(s,r){const t=JSON.parse(s);if(!r)return(0,O.isUndefined)(t.all)?null:t.all;switch(v.OS){case 2:return(0,O.isUndefined)(t.mac)?null:t.mac;case 3:return(0,O.isUndefined)(t.linux)?null:t.linux;case 1:return(0,O.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=C;let I=class extends y.AbstractJsonFileSynchroniser{constructor(r,t,i,n,o,a,c,l,d,w){super(c.keybindingsResource,"keybindings",a,c,l,r,t,o,w,i,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(E.Event.filter(n.onDidChangeConfiguration,h=>h.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,t,i){const n=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null,o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,a=await this.getLocalFileContent(),c=await this.getFormattingOptions();let l=null,d=!1,w=!1,h=!1;if(n){let _=a?a.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new k.UserDataSyncError((0,U.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==_||o!==n){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const j=await(0,A.merge)(_,n,o,c,this.userDataSyncUtilService);j.hasChanges&&(l=j.mergeContent,h=j.hasConflicts,d=h||j.mergeContent!==_,w=h||j.mergeContent!==n)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),l=a.value.toString(),w=!0);const R={content:l,localChange:d?a?2:1:0,remoteChange:w?2:0,hasConflicts:h};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:R.localChange,remoteResource:this.remoteResource,remoteContent:n,remoteChange:R.remoteChange,previewResource:this.previewResource,previewResult:R,acceptedResource:this.acceptedResource}]}async getMergeResult(r,t){return r.previewResult}async getAcceptResult(r,t,i,n){if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,n){var o;const{fileContent:a}=i[0][0];let{content:c,localChange:l,remoteChange:d}=i[0][1];if(l===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new k.UserDataSyncError((0,U.localize)(1,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(c||"[]",a,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),d!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const w=this.toSyncContent(c||"[]",(o=r.syncData)===null||o===void 0?void 0:o.content);r=await this.updateRemoteUserData(w,n?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(t==null?void 0:t.ref)!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=(0,P.parse)(r.value.toString());if((0,m.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(i.content)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(r.syncData.content)}getKeybindingsContentFromSyncContent(r){try{return C(r,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,v.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){let r=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return r!==void 0||(r=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,r!==void 0)?r:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=he([Y(0,k.IUserDataSyncStoreService),Y(1,k.IUserDataSyncBackupStoreService),Y(2,k.IUserDataSyncLogService),Y(3,g.IConfigurationService),Y(4,k.IUserDataSyncResourceEnablementService),Y(5,p.IFileService),Y(6,T.IEnvironmentService),Y(7,u.IStorageService),Y(8,k.IUserDataSyncUtilService),Y(9,b.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let f=class extends y.AbstractInitializer{constructor(r,t,i){super("keybindings",t,i,r)}async doInitialize(r){const t=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,S.VSBuffer.fromString(t)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,P.parse)(r.value.toString());return!(0,m.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return C(r,!0)}catch(t){return this.logService.error(t),null}}};f=he([Y(0,p.IFileService),Y(1,T.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],f),e.KeybindingsInitializer=f}),define(Z[184],ee([0,1,26,32,41,46,52,20,18]),function(K,e,p,k,A,P,U,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function v(c,l,d){let w=[];d?w=m(d):w=O(l);const h=[],R=[...(0,T.getDisallowedIgnoredSettings)()];if(Array.isArray(w))for(const _ of w)_.startsWith("-")?R.push(_.substring(1)):h.push(_);return(0,g.distinct)([...c,...h].filter(_=>R.indexOf(_)===-1))}e.getIgnoredSettings=v;function O(c){let l=c.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=c.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:c.getValue("settingsSync.ignoredSettings")||[]}function m(c){const l=(0,k.parse)(c);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function y(c,l,d,w){if(d.length){const h=a(l),R=(0,k.parse)(l),_=(0,k.parse)(c),j=[];for(const B of d){const M=R[B],$=_[B];M===void 0?c=U.edit(c,[B],void 0,w):$!==void 0?c=U.edit(c,[B],M,w):j.push(r(B,h))}j.sort((B,M)=>B.startOffset-M.startOffset),j.forEach(B=>c=C(B.setting.key,l,c,w))}return c}e.updateIgnoredSettings=y;function b(c,l,d,w,h,R){const _=y(c,l,w,R),j=d!==_,B=d!==l;if(!j&&!B)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!B)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(B&&!j)return{conflictsSettings:[],localContent:y(l,c,w,R),remoteContent:null,hasConflicts:!1};if(d===null&&S(c)){const ie=u(c,l,w)?null:y(l,c,w,R);return{conflictsSettings:[],localContent:ie,remoteContent:null,hasConflicts:!1}}let M=c,$=l;const V=(0,k.parse)(c),q=(0,k.parse)(l),H=d?(0,k.parse)(d):null,z=w.reduce((ie,ce)=>(ie.add(ce),ie),new Set),D=E(V,q,z),L=E(H,V,z),F=E(H,q,z),N=new Map,x=new Set,G=ie=>{x.add(ie);const ce=h.filter(({key:ue})=>ue===ie)[0];ce?(M=U.edit(M,[ie],ce.value,R),$=U.edit($,[ie],ce.value,R)):N.set(ie,{key:ie,localValue:V[ie],remoteValue:q[ie]})};for(const ie of L.removed.values())F.updated.has(ie)?G(ie):$=U.edit($,[ie],void 0,R);for(const ie of F.removed.values())x.has(ie)||(L.updated.has(ie)?G(ie):M=U.edit(M,[ie],void 0,R));for(const ie of L.updated.values())x.has(ie)||(F.updated.has(ie)?D.updated.has(ie)&&G(ie):$=U.edit($,[ie],V[ie],R));for(const ie of F.updated.values())x.has(ie)||(L.updated.has(ie)?D.updated.has(ie)&&G(ie):M=U.edit(M,[ie],q[ie],R));for(const ie of L.added.values())x.has(ie)||(F.added.has(ie)?D.updated.has(ie)&&G(ie):$=C(ie,M,$,R));for(const ie of F.added.values())x.has(ie)||(L.added.has(ie)?D.updated.has(ie)&&G(ie):M=C(ie,$,M,R));const J=N.size>0||!u(M,$,w),Q=J||!u(M,c,[]),ne=J||!u($,l,[]);return{localContent:Q?M:null,remoteContent:ne?$:null,conflictsSettings:[...N.values()],hasConflicts:J}}e.merge=b;function u(c,l,d){if(c===l)return!0;const w=(0,k.parse)(c),h=(0,k.parse)(l),R=d.reduce((B,M)=>(B.add(M),B),new Set),_=a(c).filter(B=>!(B.setting&&R.has(B.setting.key))),j=a(l).filter(B=>!(B.setting&&R.has(B.setting.key)));if(_.length!==j.length)return!1;for(let B=0;B<_.length;B++){const M=_[B],$=j[B];if(M.setting&&$.setting){if(M.setting.key!==$.setting.key||!p.equals(w[M.setting.key],h[M.setting.key]))return!1}else if(!M.setting&&!$.setting){if(M.value!==$.value)return!1}else return!1}return!0}e.areSame=u;function S(c){return c?a(c).length===0:!0}e.isEmpty=S;function E(c,l,d){const w=c?Object.keys(c).filter(B=>!d.has(B)):[],h=Object.keys(l).filter(B=>!d.has(B)),R=h.filter(B=>w.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),_=w.filter(B=>h.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),j=new Set;if(c){for(const B of w)if(!_.has(B)){const M=c[B],$=l[B];p.equals(M,$)||j.add(B)}}return{added:R,removed:_,updated:j}}function C(c,l,d,w){const h=(0,k.parse)(l),R=a(l),_=a(d),j=I(c,R,_);return f(d,c,h[c],j,_,w)}e.addSetting=C;function I(c,l,d){const w=l.findIndex(R=>{var _;return((_=R.setting)===null||_===void 0?void 0:_.key)===c}),h=l[w-1];if(h){if(h.setting){const _=r(h.setting.key,d);if(_)return{index:d.indexOf(_),insertAfter:!0}}else{const _=t(w,l);if(_){const j=r(_.setting.key,d);if(j){const B=i(d.indexOf(j),d),M=n(l,_,l[w]);if(B){const $=n(d,j,B),V=o(M,$);return V?{index:d.indexOf(V),insertAfter:!0}:{index:d.indexOf(B),insertAfter:!1}}else{const $=n(d,j,d[d.length-1]),V=o(M,$);return V?{index:d.indexOf(V),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const R=l[w+1];if(R)if(R.setting){const _=r(R.setting.key,d);if(_)return{index:d.indexOf(_),insertAfter:!1}}else{const _=i(w,l);if(_){const j=r(_.setting.key,d);if(j){const B=t(d.indexOf(j),d),M=n(l,l[w],_);if(B){const $=n(d,B,j),V=o(M.reverse(),$.reverse());return V?{index:d.indexOf(V),insertAfter:!1}:{index:d.indexOf(B),insertAfter:!0}}else{const $=n(d,d[0],j),V=o(M.reverse(),$.reverse());return V?{index:d.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function f(c,l,d,w,h,R){let _;return w.index===-1?_=(0,A.setProperty)(c,[l],d,R):_=s(c,l,d,w,h,R).map(j=>(0,A.withFormatting)(c,j,R)[0]),(0,A.applyEdits)(c,_)}function s(c,l,d,w,h,R){var _;const j=`${JSON.stringify(l)}: ${JSON.stringify(d)}`,B=(0,P.getEOL)(R,c),M=h[w.index];if(w.insertAfter){const $=[];if(M.setting)$.push({offset:M.endOffset,length:0,content:","+j});else{const V=i(w.index,h),q=t(w.index,h),H=(_=q==null?void 0:q.setting)===null||_===void 0?void 0:_.commaOffset;q&&H===void 0&&$.push({offset:q.endOffset,length:0,content:","});const z=H!==void 0&&H>M.endOffset;$.push({offset:z?H+1:M.endOffset,length:0,content:V?B+j+",":B+j})}return $}else{if(M.setting)return[{offset:M.startOffset,length:0,content:j+","}];const $=(h[w.index-1]&&!h[w.index-1].setting?B:"")+j+(i(w.index,h)?",":"")+B;return[{offset:M.startOffset,length:0,content:$}]}}function r(c,l){return l.filter(d=>{var w;return((w=d.setting)===null||w===void 0?void 0:w.key)===c})[0]}function t(c,l){for(let d=c-1;d>=0;d--)if(l[d].setting)return l[d]}function i(c,l){for(let d=c+1;d<l.length;d++)if(l[d].setting)return l[d]}function n(c,l,d){const w=c.indexOf(l),h=c.indexOf(d);return c.filter((R,_)=>w<_&&_<h)}function o(c,l){if(c.length&&l.length){let d=0;for(;d<l.length&&d<c.length;d++)if(c[d].value!==l[d].value)return l[d-1];return l[d-1]}}function a(c){const l=[];let d=-1,w,h;const R={onObjectBegin:_=>{d++},onObjectProperty:(_,j,B)=>{d===0&&(w=j,h=_)},onObjectEnd:(_,j)=>{d--,d===0&&l.push({startOffset:w,endOffset:_+j,value:c.substring(w,_+j),setting:{key:h,commaOffset:void 0}})},onArrayBegin:(_,j)=>{d++},onArrayEnd:(_,j)=>{d--,d===0&&l.push({startOffset:w,endOffset:_+j,value:c.substring(w,_+j),setting:{key:h,commaOffset:void 0}})},onLiteralValue:(_,j,B)=>{d===0&&l.push({startOffset:w,endOffset:j+B,value:c.substring(w,j+B),setting:{key:h,commaOffset:void 0}})},onSeparator:(_,j,B)=>{if(d===0&&_===","){let M=l.length-1;for(;M>=0&&!l[M].setting;M--);const $=l[M];$&&l.splice(M,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:j}})}},onComment:(_,j)=>{d===0&&l.push({startOffset:_,endOffset:_+j,value:c.substring(_,_+j)})}};return(0,k.visit)(c,R),l}}),define(Z[185],ee([0,1,10,20,23,121,3,9,25,184,52,45,22,29,19,41]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function E(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function C(r){const t=JSON.parse(r);return E(t)?t:{settings:r}}e.parseSettingsSyncContent=C;let I=class extends m.AbstractJsonFileSynchroniser{constructor(t,i,n,o,a,c,l,d,w,h,R){super(i.settingsResource,"settings",t,i,n,o,a,w,h,c,l,d);this.extensionManagementService=R,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,i,n){const o=await this.getLocalFileContent(),a=await this.getFormattingOptions(),c=this.getSettingsSyncContent(t),l=i?this.getSettingsSyncContent(i):null,d=await this.getIgnoredSettings();let w=null,h=!1,R=!1,_=!1;if(c){let B=o?o.value.toString().trim():"{}";B=B||"{}",this.validateContent(B),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,v.merge)(B,c.settings,l?l.settings:null,d,[],a);w=M.localContent||M.remoteContent,h=M.localContent!==null,R=M.remoteContent!==null,_=M.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),w=o.value.toString(),R=!0);const j={content:w,localChange:h?2:0,remoteChange:R?2:0,hasConflicts:_};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async getMergeResult(t,i){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,v.updateIgnoredSettings)(t.previewResult.content,"{}",o,n):null})}async getAcceptResult(t,i,n,o){const a=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:t.fileContent?(0,v.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",c,a):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:t.remoteContent!==null?(0,v.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,a):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,v.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",c,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(t,i,n,o){const{fileContent:a}=n[0][0];let{content:c,localChange:l,remoteChange:d}=n[0][1];if(l===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),a&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(a.value.toString()))),await this.updateLocalFileContent(c,a,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const w=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t),R=await this.getIgnoredSettings(c);c=(0,v.updateIgnoredSettings)(c,h?h.settings:"{}",R,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(i==null?void 0:i.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const i=await this.getFormattingOptions(),n=(0,O.edit)(t.value.toString(),[k.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,v.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:i}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let i=await super.resolveContent(t);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(t)),i){const n=this.parseSyncData(i);if(n){const o=this.parseSettingsSyncContent(n.content);if(o)switch(this.extUri.basename(t)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(t){let i=await super.resolvePreviewContent(t);if(i){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();i=(0,v.updateIgnoredSettings)(i,"{}",o,n)}return i}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return C(t)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtension,o=>!!o.gallery),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(i,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new k.UserDataSyncError((0,P.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const i=JSON.parse(t.value.toString());if(!s(i))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(i.content);if(!n||!n.settings)return;let o=n.settings;const a=await this.getFormattingOptions();for(const c in i)if(["version","content","machineId"].indexOf(c)===-1&&i[c]!==void 0){const l=(0,S.setProperty)(o,[c],i[c],a);l.length&&(o=(0,S.applyEdits)(o,l))}await this.fileService.writeFile(this.file,A.VSBuffer.fromString(o))}catch(t){}}};I=he([Y(0,p.IFileService),Y(1,T.IEnvironmentService),Y(2,u.IStorageService),Y(3,k.IUserDataSyncStoreService),Y(4,k.IUserDataSyncBackupStoreService),Y(5,k.IUserDataSyncLogService),Y(6,k.IUserDataSyncUtilService),Y(7,g.IConfigurationService),Y(8,k.IUserDataSyncResourceEnablementService),Y(9,y.ITelemetryService),Y(10,b.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let f=class extends m.AbstractInitializer{constructor(t,i,n){super("settings",i,n,t)}async doInitialize(t){const i=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,A.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return C(t)}catch(i){this.logService.error(i)}return null}};f=he([Y(0,p.IFileService),Y(1,T.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],f),e.SettingsInitializer=f;function s(r){return!!(r&&r.version!==void 0&&typeof r.version=="number"&&r.content!==void 0&&typeof r.content=="string"&&r.machineId!==void 0&&typeof r.machineId=="string")}}),define(Z[186],ee([0,1,20,9,10,25,45,22,23,179,19,26,3]),function(K,e,p,k,A,P,U,T,g,v,O,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends U.AbstractSynchroniser{constructor(E,C,I,f,s,r,t,i,n){super("snippets",C,E,I,f,s,i,n,r,t);this.version=1,this.snippetsFolder=E.snippetsHome,this._register(this.fileService.watch(E.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(y.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(E,C,I){const f=await this.getSnippetsFileContents(),s=this.toSnippetsContents(f),r=E.syncData?this.parseSnippets(E.syncData):null,t=C&&C.syncData?this.parseSnippets(C.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,v.merge)(s,r,t);return this.getResourcePreviews(i,f,r||{})}async getMergeResult(E,C){return E.previewResult}async getAcceptResult(E,C,I,f){if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:E.fileContent?E.fileContent.value.toString():null,localChange:0,remoteChange:E.fileContent?E.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:E.remoteContent,localChange:E.remoteContent!==null?E.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder))return I===void 0?{content:E.previewResult.content,localChange:E.previewResult.localChange,remoteChange:E.previewResult.remoteChange}:{content:I,localChange:I===null?E.fileContent!==null?3:0:2,remoteChange:I===null?E.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${C.toString()}`)}async applyResult(E,C,I,f){const s=I.map(([r,t])=>Object.assign(Object.assign({},r),{acceptResult:t}));s.every(({localChange:r,remoteChange:t})=>r===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,f)),s.some(({remoteChange:r})=>r!==0)&&(E=await this.updateRemoteSnippets(s,E,f)),(C==null?void 0:C.ref)!==E.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(E),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of s)try{await this.fileService.del(r)}catch(t){}}getResourcePreviews(E,C,I){const f=new Map;for(const s of Object.keys(E.local.added)){const r={content:E.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};f.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(E.local.updated)){const r={content:E.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of E.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(E.remote.added)){const r={content:E.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(E.remote.updated)){const r={content:E.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of E.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of E.conflicts){const r={content:C[s]?C[s].value.toString():null,hasConflicts:!0,localChange:C[s]?2:1,remoteChange:I[s]?2:1};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s]||null,localContent:C[s]?C[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(C))if(!f.has(s)){const r={content:C[s]?C[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s]||null,localContent:C[s]?C[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...f.values()]}async getAssociatedResources({uri:E}){let C=await super.resolveContent(E);if(C){const I=this.parseSyncData(C);if(I){const f=this.parseSnippets(I),s=[];for(const r of Object.keys(f)){const t=this.extUri.joinPath(E,r),i=this.extUri.joinPath(this.snippetsFolder,r),n=await this.fileService.exists(i);s.push({resource:t,comparableResource:n?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(E){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(E);let C=await super.resolveContent(E);if(C)return C;if(C=await super.resolveContent(this.extUri.dirname(E)),C){const I=this.parseSyncData(C);if(I)return this.parseSnippets(I)[this.extUri.basename(E)]||null}return null}async hasLocalData(){try{const E=await this.getSnippetsFileContents();if(Object.keys(E).length)return!0}catch(E){}return!1}async updateLocalBackup(E){const C={};for(const I of E)I.fileContent&&(C[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(C)))}async updateLocalSnippets(E,C){for(const{fileContent:I,acceptResult:f,localResource:s,remoteResource:r,localChange:t}of E)if(t!==0){const i=r?this.extUri.basename(r):this.extUri.basename(s),n=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,g.VSBuffer.fromString(f.content),{overwrite:C}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,g.VSBuffer.fromString(f.content),C?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(E,C,I){const f=C.syncData?this.parseSnippets(C.syncData):{},s=(0,m.deepClone)(f);for(const{acceptResult:r,localResource:t,remoteResource:i,remoteChange:n}of E)if(n!==0){const o=t?this.extUri.basename(t):this.extUri.basename(i);n===3?delete s[o]:s[o]=r.content}return(0,v.areSame)(f,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),C=await this.updateRemoteUserData(JSON.stringify(s),I?null:C.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),C}parseSnippets(E){return JSON.parse(E.content)}toSnippetsContents(E){const C={};for(const I of Object.keys(E))C[I]=E[I].value.toString();return C}async getSnippetsFileContents(){const E={};let C;try{C=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof A.FileOperationError&&I.fileOperationResult===1)return E;throw I}for(const I of C.children||[]){const f=I.resource,s=this.extUri.extname(f);if(s===".json"||s===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,f),t=await this.fileService.readFile(f);E[r]=t}}return E}};b=he([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,O.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncBackupStoreService),Y(5,p.IUserDataSyncLogService),Y(6,P.IConfigurationService),Y(7,p.IUserDataSyncResourceEnablementService),Y(8,T.ITelemetryService)],b),e.SnippetsSynchroniser=b;let u=class extends U.AbstractInitializer{constructor(E,C,I){super("snippets",C,I,E)}async doInitialize(E){const C=E.syncData?JSON.parse(E.syncData.content):null;if(!C){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const f of Object.keys(C)){const s=C[f];if(s){const r=this.extUri.joinPath(this.environmentService.snippetsHome,f);await this.fileService.createFile(r,g.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(E)}async isEmpty(){var E;try{return!((E=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||E===void 0?void 0:E.length)}catch(C){return C.fileOperationResult===1}}};u=he([Y(0,A.IFileService),Y(1,k.IEnvironmentService),Y(2,p.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(Z[59],ee([0,1,5,3,2,20]),function(K,e,p,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,p.createDecorator)("IUserDataSyncAccountService");let U=class extends A.Disposable{constructor(g){super();this.userDataSyncStoreService=g,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(g.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(g.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(g){(g&&this._account?g.token!==this._account.token||g.authenticationProviderId!==this._account.authenticationProviderId:g!==this._account)&&(this._account=g,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(g))}};U=he([Y(0,P.IUserDataSyncStoreService)],U),e.UserDataSyncAccountService=U}),define(Z[187],ee([0,1,2,20,12,25,10,9,54,23,6]),function(K,e,p,k,A,P,U,T,g,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends p.Disposable{constructor(b,u,S,E){super();this.environmentService=b,this.fileService=u,this.configurationService=S,this.logService=E,k.ALL_SYNC_RESOURCES.forEach(C=>this.cleanUpBackup(C))}async getAllRefs(b){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),S=await this.fileService.resolve(u);return S.children?S.children.filter(C=>C.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(C.name)).sort().reverse().map(C=>({ref:C.name,created:this.getCreationTime(C)})):[]}async resolveContent(b,u){if(!u){const S=await this.getAllRefs(b);S.length&&(u=S[S.length-1].ref)}if(u){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,b,u);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(b,u){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),E=(0,A.joinPath)(S,`${(0,g.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(E,v.VSBuffer.fromString(u))}catch(C){this.logService.error(C)}try{this.cleanUpBackup(b)}catch(C){}}async cleanUpBackup(b){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(u))return}catch(E){return}const S=await this.fileService.resolve(u);if(S.children){const E=S.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),C=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=E.filter(s=>Date.now()-this.getCreationTime(s)>C);const f=E.length-I.length;f<10&&(I=I.slice(10-f)),await O.Promises.settled(I.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};m=he([Y(0,T.IEnvironmentService),Y(1,U.IFileService),Y(2,P.IConfigurationService),Y(3,k.IUserDataSyncLogService)],m),e.UserDataSyncBackupStoreService=m}),define(Z[188],ee([0,1,4,2]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(y){this.service=y}listen(y,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(y,b,u){switch(b){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class P{constructor(y){this.service=y}listen(y,b){throw new Error(`Event not found: ${b}`)}call(y,b,u){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(p.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=P;class U{constructor(y){this.channel=y}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(y){return this.channel.call("resolveUserKeybindings",[y])}async resolveFormattingOptions(y){return this.channel.call("resolveFormattingOptions",[y])}}e.UserDataSyncUtilServiceClient=U;class T{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(y,b,u){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=T;class g{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(y,b,u){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=g;class v{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(y,b,u){switch(b){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=v;class O extends k.Disposable{constructor(y){super();this.channel=y,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(y){return this.channel.call("switch",[y])}async getPreviousUserDataSyncStore(){const y=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(y)}revive(y){return{url:p.URI.revive(y.url),type:y.type,defaultUrl:p.URI.revive(y.defaultUrl),insidersUrl:p.URI.revive(y.insidersUrl),stableUrl:p.URI.revive(y.stableUrl),canSwitch:y.canSwitch,authenticationProviders:y.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=O}),define(Z[189],ee([0,1,17,9]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends p.AbstractLogger{constructor(U,T){super();this.logger=this._register(U.createLogger(T.userDataSyncLogResource,{name:"settingssync"}))}trace(U,...T){this.logger.trace(U,...T)}debug(U,...T){this.logger.debug(U,...T)}info(U,...T){this.logger.info(U,...T)}warn(U,...T){this.logger.warn(U,...T)}error(U,...T){this.logger.error(U,...T)}critical(U,...T){this.logger.critical(U,...T)}flush(){this.logger.flush()}};A=he([Y(0,p.ILoggerService),Y(1,k.IEnvironmentService)],A),e.UserDataSyncLogService=A}),define(Z[60],ee([0,1,5,2,44,9,10,19,20,124,28,7,21,3]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,p.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let S=class He extends k.Disposable{constructor(C,I,f,s,r,t){super();this.storageService=f,this.userDataSyncStoreService=s,this.logService=r,this.productService=t,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,A.getServiceMachineId)(C,I,f)}async getMachines(C){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(C)).machines.map(s=>Object.assign(Object.assign({},s),{isCurrent:s.id===I}))}async addCurrentMachine(C){const I=await this.currentMachineIdPromise,f=await this.readMachinesData(C);f.machines.some(({id:s})=>s===I)||(f.machines.push({id:I,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(C){const I=await this.currentMachineIdPromise,f=await this.readMachinesData(C),s=f.machines.filter(({id:r})=>r!==I);s.length!==f.machines.length&&(f.machines=s,await this.writeMachinesData(f))}async renameMachine(C,I,f){const s=await this.currentMachineIdPromise,r=await this.readMachinesData(f),t=r.machines.find(({id:i})=>i===C);t&&(t.name=I,await this.writeMachinesData(r),r.machines.some(({id:i})=>i===s)&&this.storageService.store(u,I,0,1))}async setEnablement(C,I){const f=await this.readMachinesData(),s=f.machines.find(({id:r})=>r===C);s&&(s.disabled=I?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(C){const I=this.storageService.get(u,0);if(I)return I;const f=`${this.productService.nameLong} (${(0,m.PlatformToString)(m.isWeb?0:m.platform)})`,s=new RegExp(`${(0,y.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let r=0;for(const t of C){const i=s.exec(t.name),n=i?parseInt(i[1]):0;r=n>r?n:r}return`${f} #${r+1}`}async readMachinesData(C){this.userData=await this.readUserData(C);const I=this.parse(this.userData);if(I.version!==He.VERSION)throw new Error((0,v.localize)(0,null,this.productService.nameLong));return I}async writeMachinesData(C){var I;const f=JSON.stringify(C),s=await this.userDataSyncStoreService.write(He.RESOURCE,f,((I=this.userData)===null||I===void 0?void 0:I.ref)||null);this.userData={ref:s,content:f},this._onDidChange.fire()}async readUserData(C){if(this.userData){const I=C&&C.latest?C.latest[He.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(He.RESOURCE,this.userData)}parse(C){if(C.content!==null)try{return JSON.parse(C.content)}catch(I){this.logService.error(I)}return{version:He.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=he([Y(0,P.IEnvironmentService),Y(1,U.IFileService),Y(2,T.IStorageService),Y(3,g.IUserDataSyncStoreService),Y(4,g.IUserDataSyncLogService),Y(5,O.IProductService)],S),e.UserDataSyncMachinesService=S}),define(Z[83],ee([0,1,6,3,2,20,59,22,11,19,9,60,122,54,4,12,7,28]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const I="sync.enable",f="sync.disableMachineEventually",s="sync.sessionId",r="sync.storeUrl",t="sync.productQuality";let i=class extends A.Disposable{constructor(c,l,d){super();this.storageService=c,this.environmentService=l,this.userDataSyncStoreManagementService=d,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(c.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(c){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!!c)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(c){c&&!this.canToggleEnablement()||this.storageService.store(I,c,0,1)}onDidStorageChange(c){if(c.scope===0&&I===c.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=he([Y(0,v.IStorageService),Y(1,O.IEnvironmentService),Y(2,P.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let n=class extends A.Disposable{constructor(c,l,d,w,h,R,_,j,B,M,$){var V;super();this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=d,this.userDataSyncResourceEnablementService=w,this.userDataSyncService=h,this.logService=R,this.userDataSyncAccountService=_,this.telemetryService=j,this.userDataSyncMachinesService=B,this.storageService=M,this.autoSync=this._register(new A.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=$,this.syncTriggerDelayer=this._register(new p.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(V=l.userDataSyncStore)===null||V===void 0?void 0:V.url,this.previousProductQuality=this.productQuality,this.productQuality=c.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(l.onDidChangeUserDataSyncStore(()=>{var q,H;(0,S.isEqual)(this.syncUrl,(q=l.userDataSyncStore)===null||q===void 0?void 0:q.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(H=l.userDataSyncStore)===null||H===void 0?void 0:H.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(d.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(h.onDidChangeLocal,(q,H)=>q?[...q,H]:[H],1e3)(q=>this.triggerSync(q,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,q])=>q)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const c=this.storageService.get(r,0);return c?u.URI.parse(c):void 0}set syncUrl(c){c?this.storageService.store(r,c.toString(),0,1):this.storageService.remove(r,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(c){c?this.storageService.store(t,c,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:c,message:l}=this.isAutoSyncEnabled();c?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(d=>this.onDidFinishSync(d))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(l&&this.logService.info(l),this.autoSync.clear()):l&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(l))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,b.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(c,l,d){try{this.userDataSyncAccountService.account&&!d&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),c?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(w){if(l)this.logService.error(w),this.updateEnablement(!1);else throw w}}updateEnablement(c){this.userDataAutoSyncEnablementService.isEnabled()!==c&&(this.telemetryService.publicLog2(I,{enabled:c}),this.userDataAutoSyncEnablementService.setEnablement(c),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(c){if(!c){this.successiveFailures=0;return}const l=P.UserDataSyncError.toUserDataSyncError(c);l instanceof P.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:l.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),l.code===P.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):l.code===P.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):l.code===P.UserDataSyncErrorCode.LocalTooManyRequests||l.code===P.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):l.code===P.UserDataSyncErrorCode.UpgradeRequired||l.code===P.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):l.code===P.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with newer version than of client. Requires client upgrade.`)):l.code===P.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with older version than of client. Requires server reset.`)):l.code===P.UserDataSyncErrorCode.ServiceChanged||l.code===P.UserDataSyncErrorCode.DefaultServiceChanged?E.isWeb&&l.code===P.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(l),this.successiveFailures++),this._onError.fire(l)}async disableMachineEventually(){this.storageService.store(f,!0,0,1),await(0,p.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(f,0,!1)}stopDisableMachineEventually(){this.storageService.remove(f,0)}async triggerSync(c,l,d){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(l&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...c),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",d)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};n=he([Y(0,C.IProductService),Y(1,P.IUserDataSyncStoreManagementService),Y(2,P.IUserDataSyncStoreService),Y(3,P.IUserDataSyncResourceEnablementService),Y(4,P.IUserDataSyncService),Y(5,P.IUserDataSyncLogService),Y(6,U.IUserDataSyncAccountService),Y(7,T.ITelemetryService),Y(8,m.IUserDataSyncMachinesService),Y(9,v.IStorageService),Y(10,P.IUserDataAutoSyncEnablementService)],n),e.UserDataAutoSyncService=n;class o extends A.Disposable{constructor(c,l,d,w,h,R,_,j){super();this.lastSyncUrl=c,this.interval=l,this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=w,this.userDataSyncService=h,this.userDataSyncMachinesService=R,this.logService=_,this.storageService=j,this.intervalHandler=this._register(new A.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,A.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,p.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(c,l){const d=(0,p.createCancelablePromise)(async w=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,g.isPromiseCanceledError)(h))return}return this.doSync(c,l,w)});return this.syncPromise=d,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var c;return this.lastSyncUrl!==void 0&&!(0,S.isEqual)(this.lastSyncUrl,(c=this.userDataSyncStoreManagementService.userDataSyncStore)===null||c===void 0?void 0:c.url)}async hasDefaultServiceChanged(){const c=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),l=this.userDataSyncStoreManagementService.userDataSyncStore;return!!l&&!!c&&(!(0,S.isEqual)(l.defaultUrl,c.defaultUrl)||!(0,S.isEqual)(l.insidersUrl,c.insidersUrl)||!(0,S.isEqual)(l.stableUrl,c.stableUrl))}async doSync(c,l,d){this.logService.info(`Auto Sync: Triggered by ${c}`),this._onDidStartSync.fire();let w;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(l),d.isCancellationRequested)return;let h=this.syncTask.manifest;if(h===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new P.UserDataAutoSyncError((0,y.localize)(0,null),P.UserDataSyncErrorCode.DefaultServiceChanged):new P.UserDataAutoSyncError((0,y.localize)(1,null),P.UserDataSyncErrorCode.ServiceChanged):new P.UserDataAutoSyncError((0,y.localize)(2,null),P.UserDataSyncErrorCode.TurnedOff);const R=this.storageService.get(s,0);if(R&&h&&R!==h.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new P.UserDataAutoSyncError((0,y.localize)(3,null),P.UserDataSyncErrorCode.DefaultServiceChanged):new P.UserDataAutoSyncError((0,y.localize)(4,null),P.UserDataSyncErrorCode.ServiceChanged):new P.UserDataAutoSyncError((0,y.localize)(5,null),P.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(h||void 0);if(d.isCancellationRequested)return;const j=_.find(B=>B.isCurrent);if(j==null?void 0:j.disabled)throw new P.UserDataAutoSyncError((0,y.localize)(6,null),P.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),h===null&&(h=await this.userDataSyncStoreService.manifest()),h&&h.session!==R&&this.storageService.store(s,h.session,0,1),d.isCancellationRequested)return;j||await this.userDataSyncMachinesService.addCurrentMachine(h||void 0)}catch(h){this.logService.error(h),w=h}this._onDidFinishSync.fire(w)}register(c){return super._register(c)}}o.INTERVAL_SYNCING="Interval"}),define(Z[190],ee([0,1,20,2,3,19,22,7]),function(K,e,p,k,A,P,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let g=class extends k.Disposable{constructor(O,m){super();this.storageService=O,this.telemetryService=m,this._onDidChangeResourceEnablement=new A.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(O.onDidChangeValue(y=>this.onDidStorageChange(y)))}isResourceEnabled(O){return this.storageService.getBoolean((0,p.getEnablementKey)(O),0,!0)}setResourceEnablement(O,m){if(this.isResourceEnabled(O)!==m){const y=(0,p.getEnablementKey)(O);this.telemetryService.publicLog2(y,{enabled:m}),this.storeResourceEnablement(y,m)}}getResourceSyncStateVersion(O){}storeResourceEnablement(O,m){this.storageService.store(O,m,0,T.isWeb?0:1)}onDidStorageChange(O){if(O.scope===0){const m=p.ALL_SYNC_RESOURCES.filter(y=>(0,p.getEnablementKey)(y)===O.key)[0];if(m){this._onDidChangeResourceEnablement.fire([m,this.isResourceEnabled(m)]);return}}}};g=he([Y(0,P.IStorageService),Y(1,U.ITelemetryService)],g),e.UserDataSyncResourceEnablementService=g}),define(Z[191],ee([0,1,20,2,5,3,180,183,182,43,22,18,19,185,12,186,31,6,11]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const f="sync.lastSyncTime";let s=class extends k.Disposable{constructor(n,o,a,c,l,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=o,this.instantiationService=a,this.logService=c,this.telemetryService=l,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new P.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new P.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new P.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new P.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new P.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new P.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(T.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(S.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(g.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(U.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(P.Event.any(...this.synchronisers.map(w=>P.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(P.Event.any(...this.synchronisers.map(w=>P.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(f,0,void 0),this.onDidChangeLocal=P.Event.any(...this.synchronisers.map(w=>P.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n){await this.checkEnablement();const o=(0,E.generateUuid)();let a;try{const w=(0,p.createSyncHeaders)(o);n&&(w["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(w)}catch(w){const h=p.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(h,o),h}let c=!1;const l=this;let d;return{manifest:a,run(){if(c)throw new Error("Can run a task only once");return d=(0,C.createCancelablePromise)(w=>l.sync(a,o,w)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,E.generateUuid)(),o=(0,p.createSyncHeaders)(n);let a;try{a=await this.userDataSyncStoreService.manifest(o)}catch(c){const l=p.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(l,n),l}return new r(n,a,o,this.synchronisers,this.logService)}async sync(n,o,a){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!a.isCancellationRequested){const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=(0,p.createSyncHeaders)(o);for(const d of this.synchronisers){if(a.isCancellationRequested)return;try{await d.sync(n,l)}catch(w){if(w instanceof p.UserDataSyncError)switch(w.code){case p.UserDataSyncErrorCode.TooLarge:throw new p.UserDataSyncError(w.message,w.code,d.resource);case p.UserDataSyncErrorCode.TooManyRequests:case p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case p.UserDataSyncErrorCode.LocalTooManyRequests:case p.UserDataSyncErrorCode.Gone:case p.UserDataSyncErrorCode.UpgradeRequired:case p.UserDataSyncErrorCode.IncompatibleRemoteContent:case p.UserDataSyncErrorCode.IncompatibleLocalContent:throw w}const h=p.UserDataSyncError.toUserDataSyncError(w);this.reportUserDataSyncError(h,o),this.logService.error(w),this.logService.error(`${d.resource}: ${(0,v.toErrorMessage)(w)}`),this._syncErrors.push([d.resource,h])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(l){const d=p.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(d,o),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(o){this.logService.error(o)}}async replace(n){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(n))return}async accept(n,o,a,c){await this.checkEnablement();const l=this.getSynchroniser(n);await l.accept(o,a),c&&await l.apply(!1,(0,p.createSyncHeaders)((0,E.generateUuid)()))}async resolveContent(n){for(const o of this.synchronisers){const a=await o.resolveContent(n);if(a)return a}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,o){return this.getSynchroniser(n).getAssociatedResources(o)}getMachineId(n,o){return this.getSynchroniser(n).getMachineId(o)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of n)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(f,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(o){this.logService.error(`${n.resource}: ${(0,v.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const o=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,m.equals)(this._conflicts,n,([o,a],[c,l])=>o===o&&(0,m.equals)(a,l,(d,w)=>(0,u.isEqual)(d.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(f,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,o){this.telemetryService.publicLog2("sync/error",{code:n.code,url:n instanceof p.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(o=>o.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=he([Y(0,p.IUserDataSyncStoreService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,A.IInstantiationService),Y(3,p.IUserDataSyncLogService),Y(4,O.ITelemetryService),Y(5,y.IStorageService)],s),e.UserDataSyncService=s;class r extends k.Disposable{constructor(n,o,a,c,l){super();this.id=n,this.manifest=o,this.syncHeaders=a,this.synchronisers=c,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new P.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,C.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,o){try{return await this.performAction(n,a=>a.accept(n,o))}catch(a){throw this.logService.error(a),a}}async merge(n){try{return n?await this.performAction(n,o=>o.merge(n)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(n){try{return await this.performAction(n,o=>o.discard(n))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,o]of this.previews)for(const a of o.resourcePreviews)a.mergeState==="conflict"&&n.push(a.previewResource);for(const o of n)await this.discard(o);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[o,a]of this.previews){this.synchronizingResources.push([o,a.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(d=>d.resource===o);for(const d of a.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await c.merge(d.previewResource);const l=await c.apply(!1,this.syncHeaders);l&&n.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,o]of this.previews){this.synchronizingResources.push([n,o.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(c=>c.resource===n);for(const c of o.resourcePreviews)await a.accept(c.remoteResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,o]of this.previews){this.synchronizingResources.push([n,o.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(c=>c.resource===n);for(const c of o.resourcePreviews)await a.accept(c.localResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(o){(0,I.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(n,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const a=this.previews.findIndex(([,j])=>j.resourcePreviews.some(({localResource:B,previewResource:M,remoteResource:$})=>(0,u.isEqual)(n,B)||(0,u.isEqual)(n,M)||(0,u.isEqual)(n,$)));if(a===-1)return this.previews;const[c,l]=this.previews[a],d=l.resourcePreviews.find(({localResource:j,remoteResource:B,previewResource:M})=>(0,u.isEqual)(j,n)||(0,u.isEqual)(B,n)||(0,u.isEqual)(M,n));if(!d)return this.previews;let w=this.synchronizingResources.find(j=>j[0]===c);w||(w=[c,[]],this.synchronizingResources.push(w)),w[1].some(j=>(0,u.isEqual)(j,d.localResource))||(w[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const h=this.synchronisers.find(j=>j.resource===this.previews[a][0]),R=await o(h);R?this.previews.splice(a,1,this.toSyncResourcePreview(h.resource,R)):this.previews.splice(a,1);const _=this.synchronizingResources.findIndex(j=>j[0]===c);return this.synchronizingResources[_][1].splice(w[1].findIndex(j=>(0,u.isEqual)(j,d.localResource)),1),w[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[o,a]of this.previews){this.synchronizingResources.push([o,a.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(d=>d.resource===o);let l=a;for(const d of a.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(l=await c.merge(d.previewResource));l&&n.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const o=[];for(const a of this.synchronisers){if(n.isCancellationRequested)return[];const c=await a.preview(this.manifest,this.syncHeaders);c&&o.push(this.toSyncResourcePreview(a.resource,c))}return o}toSyncResourcePreview(n,o){return[n,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(Z[192],ee([0,1,3,20,4,2,15]),function(K,e,p,k,A,P,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class T{constructor(m,y){this.service=m,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new p.Emitter}listen(m,y){switch(y){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${y}`)}async call(m,y,b){try{return await this._call(m,y,b)}catch(u){throw this.logService.error(u),u}}async _call(m,y,b){switch(y){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],A.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:A.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:A.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(y.startsWith("manualSync/")){const u=y.substring("manualSync/".length),S=b[0],E=this.getManualSyncTask(S);switch(b=b.slice(1),u){case"preview":return E.preview();case"accept":return E.accept(A.URI.revive(b[0]),b[1]);case"merge":return E.merge(A.URI.revive(b[0]));case"discard":return E.discard(A.URI.revive(b[0]));case"discardConflicts":return E.discardConflicts();case"apply":return E.apply();case"pull":return E.pull();case"push":return E.push();case"stop":return E.stop();case"_getStatus":return E.status;case"dispose":return this.disposeManualSyncTask(E)}}throw new Error("Invalid call")}getManualSyncTask(m){const y=this.manualSyncTasks.get(this.createKey(m));if(!y)throw new Error(`Manual sync taks not found: ${m}`);return y.manualSyncTask}async createManualSyncTask(){const m=new P.DisposableStore,y=m.add(await this.service.createManualSyncTask());return m.add(y.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:y.id,data:b}))),this.manualSyncTasks.set(this.createKey(y.id),{manualSyncTask:y,disposables:m}),{id:y.id,manifest:y.manifest,status:y.status}}disposeManualSyncTask(m){var y;m.dispose();const b=this.createKey(m.id);(y=this.manualSyncTasks.get(b))===null||y===void 0||y.disposables.dispose(),this.manualSyncTasks.delete(b)}createKey(m){return`manualSyncTask-${m}`}}e.UserDataSyncChannel=T;class g extends P.Disposable{constructor(m){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new p.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new p.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new p.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new p.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,b,u){return m.call(y,b,u).then(null,S=>{throw k.UserDataSyncError.toUserDataSyncError(S)})},listen(y,b){return m.listen(y,b)}},this.channel.call("_getInitialData").then(([y,b,u])=>{this.updateStatus(y),this.updateConflicts(b),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(([b,u])=>[b,k.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:m,manifest:y,status:b}=await this.channel.call("createManualSyncTask"),u=this,S=new v(m,y,b,{async call(E,C,I){return u.channel.call(`manualSync/${E}`,[m,...(0,U.isArray)(C)?C:[C]],I)},listen(E,C){return p.Event.map(p.Event.filter(u.channel.listen(`manualSync/${E}`,C),I=>!S.isDiposed()&&I.manualSyncTaskId===m),I=>I.data)}});return S}replace(m){return this.channel.call("replace",[m])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(m,y,b,u){return this.channel.call("accept",[m,y,b,u])}resolveContent(m){return this.channel.call("resolveContent",[m])}async getLocalSyncResourceHandles(m){return(await this.channel.call("getLocalSyncResourceHandles",[m])).map(({created:b,uri:u})=>({created:b,uri:A.URI.revive(u)}))}async getRemoteSyncResourceHandles(m){return(await this.channel.call("getRemoteSyncResourceHandles",[m])).map(({created:b,uri:u})=>({created:b,uri:A.URI.revive(u)}))}async getAssociatedResources(m,y){return(await this.channel.call("getAssociatedResources",[m,y])).map(({resource:u,comparableResource:S})=>({resource:A.URI.revive(u),comparableResource:A.URI.revive(S)}))}async getMachineId(m,y){return this.channel.call("getMachineId",[m,y])}async updateStatus(m){this._status=m,this._onDidChangeStatus.fire(m)}async updateConflicts(m){this._conflicts=m.map(([y,b])=>[y,b.map(u=>Object.assign(Object.assign({},u),{localResource:A.URI.revive(u.localResource),remoteResource:A.URI.revive(u.remoteResource),previewResource:A.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(m){this._lastSyncTime!==m&&(this._lastSyncTime=m,this._onDidChangeLastSyncTime.fire(m))}}e.UserDataSyncChannelClient=g;class v extends P.Disposable{constructor(m,y,b,u){super();this.id=m,this.manifest=y,this._disposed=!1,this._status=b;const S=this;this.channel={async call(E,C,I){try{const f=await u.call(E,C,I);return S.isDiposed()||(S._status=await u.call("_getStatus")),f}catch(f){throw k.UserDataSyncError.toUserDataSyncError(f)}},listen(E,C){return u.listen(E,C)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const m=await this.channel.call("preview");return this.deserializePreviews(m)}async accept(m,y){const b=await this.channel.call("accept",[m,y]);return this.deserializePreviews(b)}async merge(m){const y=await this.channel.call("merge",[m]);return this.deserializePreviews(y)}async discard(m){const y=await this.channel.call("discard",[m]);return this.deserializePreviews(y)}async discardConflicts(){const m=await this.channel.call("discardConflicts");return this.deserializePreviews(m)}async apply(){const m=await this.channel.call("apply");return this.deserializePreviews(m)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(m){return m.map(([y,b])=>[y,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(u=>Object.assign(Object.assign({},u),{localResource:A.URI.revive(u.localResource),remoteResource:A.URI.revive(u.remoteResource),previewResource:A.URI.revive(u.previewResource),acceptedResource:A.URI.revive(u.acceptedResource)}))}])}}}),define(Z[193],ee([0,1,2,20,40,12,30,25,28,44,9,10,19,31,7,3,6,15,4,11]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const s="sync.previous.store",r="sync.donot-make-requests-until",t="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let a=class extends p.Disposable{constructor(R,_,j){super();this.productService=R,this.configurationService=_,this.storageService=j,this._onDidChangeUserDataSyncStore=this._register(new S.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(S.Event.filter(j.onDidChangeValue,B=>{var M;return B.key===k.SYNC_SERVICE_URL_TYPE&&B.scope===0&&this.userDataSyncStoreType!==((M=this.userDataSyncStore)===null||M===void 0?void 0:M.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(k.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(R){this.storageService.store(k.SYNC_SERVICE_URL_TYPE,R,0,u.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[k.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(k.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(R,_){R=u.isWeb&&(R==null?void 0:R.web)?Object.assign(Object.assign({},R),R.web):R;const j=Object.assign(Object.assign({},R||{}),_||{});if(j&&(0,C.isString)(j.url)&&(0,C.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(B=>(0,C.isArray)(j.authenticationProviders[B].scopes))){const B=j,M=!!B.canSwitch&&!(_==null?void 0:_.url),$=B.url===B.insidersUrl?"insiders":"stable",V=(M?this.userDataSyncStoreType:void 0)||$,q=(_==null?void 0:_.url)||(V==="insiders"?B.insidersUrl:V==="stable"?B.stableUrl:B.url);return{url:I.URI.parse(q),type:V,defaultType:$,defaultUrl:I.URI.parse(B.url),stableUrl:I.URI.parse(B.stableUrl),insidersUrl:I.URI.parse(B.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(B.authenticationProviders).reduce((H,z)=>(H.push({id:z,scopes:B.authenticationProviders[z].scopes}),H),[])}}}};a=he([Y(0,g.IProductService),Y(1,T.IConfigurationService),Y(2,y.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let c=class extends a{constructor(R,_,j){super(R,_,j);const B=this.storageService.get(s,0);B&&(this.previousConfigurationSyncStore=JSON.parse(B));const M=this.productService[k.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(s,JSON.stringify(M),0,1):this.storageService.remove(s,0)}async switch(R){R!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=R,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=he([Y(0,g.IProductService),Y(1,T.IConfigurationService),Y(2,y.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let l=class extends p.Disposable{constructor(R,_,j,B,M,$,V){super();this.requestService=j,this.logService=B,this.storageService=V,this._onTokenFailed=this._register(new S.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new S.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new S.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(R),this.commonHeadersPromise=(0,v.getServiceMachineId)(M,$,V).then(q=>{const H={"X-Client-Name":`${_.applicationName}${u.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":q};return _.commit&&(H["X-Client-Commit"]=_.commit),H}),this.session=new w(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,p.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(R,_){this.authToken={token:R,type:_}}updateUserDataSyncStoreUrl(R){this.userDataSyncStoreUrl=R?(0,P.joinPath)(R,"v1"):void 0}initDonotMakeRequestsUntil(){const R=this.storageService.getNumber(r,0);R&&Date.now()<R&&this.setDonotMakeRequestsUntil(new Date(R))}setDonotMakeRequestsUntil(R){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(R==null?void 0:R.getTime())&&(this._donotMakeRequestsUntil=R,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,E.createCancelablePromise)(j=>(0,E.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),j).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,j=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(R){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",R),j={},B=await this.request(_.toString(),{type:"GET",headers:j},[],U.CancellationToken.None);return(await(0,A.asJson)(B)||[]).map(({url:$,created:V})=>({ref:(0,P.relativePath)(_,_.with({path:$})),created:V*1e3}))}async resolveContent(R,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",R,_).toString(),B={};B["Cache-Control"]="no-cache";const M=await this.request(j,{type:"GET",headers:B},[],U.CancellationToken.None);return await(0,A.asText)(M)}async delete(R){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",R).toString(),j={};await this.request(_,{type:"DELETE",headers:j},[],U.CancellationToken.None)}async read(R,_,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",R,"latest").toString();j=Object.assign({},j),j["Cache-Control"]="no-cache",_&&(j["If-None-Match"]=_.ref);const M=await this.request(B,{type:"GET",headers:j},[304],U.CancellationToken.None);if(M.res.statusCode===304)return _;const $=M.res.headers.etag;if(!$)throw new k.UserDataSyncStoreError("Server did not return the ref",B,k.UserDataSyncErrorCode.NoRef,M.res.headers[k.HEADER_OPERATION_ID]);const V=await(0,A.asText)(M);return{ref:$,content:V}}async write(R,_,j,B={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",R).toString();B=Object.assign({},B),B["Content-Type"]="text/plain",j&&(B["If-Match"]=j);const $=await this.request(M,{type:"POST",data:_,headers:B},[],U.CancellationToken.None),V=$.res.headers.etag;if(!V)throw new k.UserDataSyncStoreError("Server did not return the ref",M,k.UserDataSyncErrorCode.NoRef,$.res.headers[k.HEADER_OPERATION_ID]);return V}async manifest(R={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,P.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();R=Object.assign({},R),R["Content-Type"]="application/json";const j=await this.request(_,{type:"GET",headers:R},[],U.CancellationToken.None),B=await(0,A.asJson)(j),M=this.storageService.get(t,0);return M&&B&&M!==B.session&&this.clearSession(),B===null&&M&&this.clearSession(),B&&this.storageService.store(t,B.session,0,1),B}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(R,{type:"DELETE",headers:_},[],U.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(i,0)}async request(R,_,j,B){if(!this.authToken)throw new k.UserDataSyncStoreError("No Auth Token Available",R,k.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new k.UserDataSyncStoreError(`${_.type} request '${R}' failed because of too many requests (429).`,R,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),M),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:R,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let $;try{$=await this.session.request(R,_,B)}catch(z){if(!(z instanceof k.UserDataSyncStoreError)){const D=(0,f.isPromiseCanceledError)(z)?k.UserDataSyncErrorCode.RequestCanceled:(0,f.getErrorMessage)(z).startsWith("XHR timeout")?k.UserDataSyncErrorCode.RequestTimeout:k.UserDataSyncErrorCode.RequestFailed;z=new k.UserDataSyncStoreError(`Connection refused for the request '${R}'.`,R,D,void 0)}throw this.logService.info("Request failed",R),z}const V=$.res.headers[k.HEADER_OPERATION_ID],q={url:R,status:$.res.statusCode,"execution-id":_.headers[k.HEADER_EXECUTION_ID],"operation-id":V},H=(0,A.isSuccess)($)||$.res.statusCode&&j.indexOf($.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new k.UserDataSyncStoreError(`Request '${R}' failed because of Unauthorized (401).`,R,k.UserDataSyncErrorCode.Unauthorized,V);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new k.UserDataSyncStoreError(`${_.type} request '${R}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,R,k.UserDataSyncErrorCode.Conflict,V);if($.res.statusCode===410)throw new k.UserDataSyncStoreError(`${_.type} request '${R}' failed because the requested resource is not longer available (410).`,R,k.UserDataSyncErrorCode.Gone,V);if($.res.statusCode===412)throw new k.UserDataSyncStoreError(`${_.type} request '${R}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,R,k.UserDataSyncErrorCode.PreconditionFailed,V);if($.res.statusCode===413)throw new k.UserDataSyncStoreError(`${_.type} request '${R}' failed because of too large payload (413).`,R,k.UserDataSyncErrorCode.TooLarge,V);if($.res.statusCode===426)throw new k.UserDataSyncStoreError(`${_.type} request '${R}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,R,k.UserDataSyncErrorCode.UpgradeRequired,V);if($.res.statusCode===429){const z=$.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new k.UserDataSyncStoreError(`${_.type} request '${R}' failed because of too many requests (429).`,R,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,V)):new k.UserDataSyncStoreError(`${_.type} request '${R}' failed because of too many requests (429).`,R,k.UserDataSyncErrorCode.TooManyRequests,V)}if(!H)throw new k.UserDataSyncStoreError("Server returned "+$.res.statusCode,R,k.UserDataSyncErrorCode.Unknown,V);return $}addSessionHeaders(R){let _=this.storageService.get(i,0);_===void 0&&(_=(0,b.generateUuid)(),this.storageService.store(i,_,0,1)),R["X-Machine-Session-Id"]=_;const j=this.storageService.get(t,0);j!==void 0&&(R["X-User-Session-Id"]=j)}};l=he([Y(1,g.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,O.IEnvironmentService),Y(5,m.IFileService),Y(6,y.IStorageService)],l),e.UserDataSyncStoreClient=l;let d=class extends l{constructor(R,_,j,B,M,$,V){var q;super((q=R.userDataSyncStore)===null||q===void 0?void 0:q.url,_,j,B,M,$,V);this._register(R.onDidChangeUserDataSyncStore(()=>{var H;return this.updateUserDataSyncStoreUrl((H=R.userDataSyncStore)===null||H===void 0?void 0:H.url)}))}};d=he([Y(0,k.IUserDataSyncStoreManagementService),Y(1,g.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,O.IEnvironmentService),Y(5,m.IFileService),Y(6,y.IStorageService)],d),e.UserDataSyncStoreService=d;class w{constructor(R,_,j,B){this.limit=R,this.interval=_,this.requestService=j,this.logService=B,this.requests=[],this.startTime=void 0}request(R,_,j){if(this.isExpired()&&this.reset(),_.url=R,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new k.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,R,k.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(R),this.requestService.request(_,j)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=w}),define(Z[194],ee([0,1,20,3,57,83,59,22,19,60,28]),function(K,e,p,k,A,P,U,T,g,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let m=class extends P.UserDataAutoSyncService{constructor(b,u,S,E,C,I,f,s,r,t,i,n){super(b,u,S,E,C,f,s,r,t,i,n);this._register(k.Event.debounce(k.Event.any(k.Event.map(I.onDidFocusWindow,()=>"windowFocus"),k.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(o,a)=>o?[...o,a]:[a],1e3)(o=>this.triggerSync(o,!0,!1)))}};m=he([Y(0,O.IProductService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncResourceEnablementService),Y(4,p.IUserDataSyncService),Y(5,A.INativeHostService),Y(6,p.IUserDataSyncLogService),Y(7,U.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,v.IUserDataSyncMachinesService),Y(10,g.IStorageService),Y(11,p.IUserDataAutoSyncEnablementService)],m),e.UserDataAutoSyncService=m}),define(Z[195],ee([0,1,3,2,6]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class P extends k.Disposable{constructor({onDidOpenWindow:T,onDidFocusWindow:g,getActiveWindowId:v}){super();this.disposables=this._register(new k.DisposableStore),p.Event.latch(p.Event.any(T,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,A.createCancelablePromise)(()=>v()),(async()=>{try{const m=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:m}catch(m){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(T){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=T}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=P}),define(Z[61],ee([0,1,105,8,27,6,24,201,202,15]),function(K,e,p,k,A,P,U,T,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class O extends Error{constructor(t,i){let n=i.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=i}}e.ExtractError=O;function m(r){const t=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>t&i).reduce((i,n)=>i+n,t&61440)}function y(r){if(r instanceof O)return r;let t;return/end of central directory record signature not found/.test(r.message)&&(t="CorruptZip"),new O(t,r)}function b(r,t,i,n,o,a){const c=k.dirname(t),l=k.join(n,c);if(!l.startsWith(n))return Promise.reject(new Error(p.localize(0,null,t)));const d=k.join(n,t);let w;return a.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(A.promises.mkdir(l,{recursive:!0})).then(()=>new Promise((h,R)=>{if(!a.isCancellationRequested)try{w=(0,A.createWriteStream)(d,{mode:i}),w.once("close",()=>h()),w.once("error",R),r.once("error",R),r.pipe(w)}catch(_){R(_)}}))}function u(r,t,i,n){let o=(0,P.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{o.cancel(),r.close()}),new Promise((c,l)=>{const d=new P.Sequencer,w=h=>{h.isCancellationRequested||(a++,r.readEntry())};r.once("error",l),r.once("close",()=>o.then(()=>{n.isCancellationRequested||r.entryCount===a?c():l(new O("Incomplete",new Error(p.localize(1,null,a,r.entryCount))))},l)),r.readEntry(),r.on("entry",h=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(h.fileName)){w(n);return}const R=h.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(R)){const B=k.join(t,R);o=(0,P.createCancelablePromise)(M=>A.promises.mkdir(B,{recursive:!0}).then(()=>w(M)).then(void 0,l));return}const _=E(r,h),j=m(h);o=(0,P.createCancelablePromise)(B=>d.queue(()=>_.then(M=>b(M,R,j,t,i,B).then(()=>w(B)))).then(null,l))}})})}function S(r,t=!1){return new Promise((i,n)=>{(0,T.open)(r,t?{lazyEntries:!0}:void 0,(o,a)=>{o?n(y(o)):i((0,v.assertIsDefined)(a))})})}function E(r,t){return new Promise((i,n)=>{r.openReadStream(t,(o,a)=>{o?n(y(o)):i((0,v.assertIsDefined)(a))})})}function C(r,t){return new Promise((i,n)=>{const o=new g.ZipFile;t.forEach(c=>{c.contents?o.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&o.addFile(c.localPath,c.path)}),o.end();const a=(0,A.createWriteStream)(r);o.outputStream.pipe(a),o.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(r))})}e.zip=C;function I(r,t,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=S(r,!0);return i.overwrite&&(a=a.then(c=>(0,U.rimraf)(t).then(()=>c))),a.then(c=>u(c,t,{sourcePathRegex:o},n))}e.extract=I;function f(r,t){return S(r).then(i=>new Promise((n,o)=>{i.on("entry",a=>{a.fileName===t&&E(i,a).then(c=>n(c),c=>o(c))}),i.once("close",()=>o(new Error(p.localize(2,null,t))))}))}function s(r,t){return f(r,t).then(i=>new Promise((n,o)=>{const a=[];i.once("error",o),i.on("data",c=>a.push(c)),i.on("end",()=>n(Buffer.concat(a)))}))}e.buffer=s}),define(Z[196],ee([0,1,61,110]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(P){return(0,p.buffer)(P,"extension/package.json").then(U=>{try{return JSON.parse(U.toString("utf8"))}catch(T){throw new Error((0,k.localize)(0,null))}})}e.getManifest=A}),define(Z[197],ee([0,1,27,56,2,24,8,17,29,33,6,4,9,130,111,28,61,7,18,16,10,12,31,11]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I,f,s,r,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const n="scanningSystem",o="scanningUser",a="extracting",c="deleting",l="renaming";let d=class extends A.Disposable{constructor(h,R,_,j,B){super();this.beforeRemovingExtension=h,this.fileService=R,this.logService=_,this.environmentService=j,this.productService=B,this._devSystemExtensionsPath=null,this.systemExtensionsPath=j.builtinExtensionsPath,this.extensionsPath=j.extensionsPath,this.uninstalledPath=U.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new O.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(h){const R=[];(h===null||h===0)&&R.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(_).message,n)))),(h===null||h===1)&&R.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(_).message,o))));try{const _=await Promise.all(R);return(0,I.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(h){this.logService.trace("Started scanning user extensions");let[R,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(j=>!R[new v.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]),h&&(_=(0,v.groupByExtension)(_,B=>B.identifier).map(B=>B.sort((M,$)=>k.rcompare(M.manifest.version,$.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(h,R,_){const j=h.key(),B=U.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),M=U.join(this.extensionsPath,j);try{await P.rimraf(M)}catch(V){try{await P.rimraf(M)}catch(q){}throw new g.ExtensionManagementError((0,u.localize)(0,null,M,h.id),c)}await this.extractAtLocation(h,R,B,_);let $=await this.scanExtension(m.URI.file(B),1);if(!$)throw new Error((0,u.localize)(1,null,B));await this.storeMetadata($,{installedTimestamp:Date.now()});try{await this.rename(h,B,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(V){try{await P.rimraf(B)}catch(q){}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",h.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(V)}. Deleted from extracted location`,B),V}try{$=await this.scanExtension(m.URI.file(M),1)}catch(V){}if($)return $;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(h,R){return this.setMetadata(h,R),await this.storeMetadata(h,Object.assign(Object.assign({},R),{installedTimestamp:h.installedTimestamp})),h}async storeMetadata(h,R){R.isMachineScoped=R.isMachineScoped||void 0,R.isBuiltin=R.isBuiltin||void 0,R.installedTimestamp=R.installedTimestamp||void 0;const _=U.join(h.location.fsPath,"package.json"),j=await p.promises.readFile(_,"utf8"),{manifest:B}=await this.parseManifest(j);return B.__metadata=R,await P.writeFile(_,JSON.stringify(B,null,"	")),h}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...h){const R=h.map(_=>new v.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{R.forEach(j=>_[j.key()]=!0)})}async setInstalled(h){await this.withUninstalledExtensions(j=>delete j[h.key()]);const _=(await this.scanExtensions(1)).find(j=>new v.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).equals(h))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(h){return this.uninstalledFileLimiter.queue(async()=>{let R;try{R=await p.promises.readFile(this.uninstalledPath,"utf8")}catch(j){if(j.code!=="ENOENT")throw j}let _={};if(R)try{_=JSON.parse(R)}catch(j){}return h&&(h(_),Object.keys(_).length?await P.writeFile(this.uninstalledPath,JSON.stringify(_)):await P.rimraf(this.uninstalledPath)),_})}async removeExtension(h,R){this.logService.trace(`Deleting ${R} extension from disk`,h.identifier.id,h.location.fsPath),await P.rimraf(h.location.fsPath),this.logService.info("Deleted from disk",h.identifier.id,h.location.fsPath)}async removeUninstalledExtension(h){await this.removeExtension(h,"uninstalled"),await this.withUninstalledExtensions(R=>delete R[new v.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()])}async extractAtLocation(h,R,_,j){this.logService.trace(`Started extracting the extension from ${R} to ${_}`);try{await P.rimraf(_)}catch(B){throw new g.ExtensionManagementError(this.joinErrors(B).message,c)}try{await(0,E.extract)(R,_,{sourcePath:"extension",overwrite:!0},j),this.logService.info(`Extracted extension to ${_}:`,h.id)}catch(B){try{await P.rimraf(_)}catch(M){}throw new g.ExtensionManagementError(B.message,B instanceof E.ExtractError&&B.type?B.type:a)}}async rename(h,R,_,j){try{await p.promises.rename(R,_)}catch(B){if(C.isWindows&&B&&B.code==="EPERM"&&Date.now()<j)return this.logService.info(`Failed renaming ${R} to ${_} with 'EPERM' error. Trying again...`,h.id),this.rename(h,R,_,j);throw new g.ExtensionManagementError(B.message||(0,u.localize)(3,null,R,_),B.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const h=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return h;const R=this.scanDevSystemExtensions(),[_,j]=await Promise.all([h,R]);return[..._,...j]}async scanExtensionsInDir(h,R){const _=new O.Limiter(10),j=await this.fileService.resolve(m.URI.file(h));return j.children?(await Promise.all(j.children.filter(M=>M.isDirectory).map(M=>_.queue(async()=>R===1&&(0,r.basename)(M.resource).indexOf(".")===0?null:this.scanExtension(M.resource,R))))).filter(M=>M&&M.identifier):[]}async scanExtension(h,R){var _,j;try{const B=await this.fileService.resolve(h);if(B.children){const{manifest:M,metadata:$}=await this.readManifest(h.fsPath),V=(_=B.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D)))===null||_===void 0?void 0:_.resource,q=(j=B.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D)))===null||j===void 0?void 0:j.resource,H={id:(0,v.getGalleryExtensionId)(M.publisher,M.name)},z={type:R,identifier:H,manifest:M,location:h,readmeUrl:V,changelogUrl:q,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:R===0};return $&&(this.setMetadata(z,$),z.installedTimestamp=$.installedTimestamp),z}}catch(B){R!==0&&this.logService.trace(B)}return null}async scanDefaultSystemExtensions(){const h=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",h.length),h}async scanDevSystemExtensions(){const h=this.getDevSystemExtensionsList();if(h.length){const R=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",R.length),R.filter(_=>h.some(j=>(0,v.areSameExtensions)(_.identifier,{id:j})))}else return[]}setMetadata(h,R){h.publisherDisplayName=R.publisherDisplayName||null,h.publisherId=R.publisherId||null,h.identifier.uuid=R.id,h.isMachineScoped=!!R.isMachineScoped,h.isBuiltin=h.type===0||!!R.isBuiltin}async removeUninstalledExtensions(){const h=await this.getUninstalledExtensions(),R=await this.scanAllUserExtensions(),_=new Set;for(const M of R)h[new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]||_.add(M.identifier.id.toLowerCase());const j=(0,v.groupByExtension)(R,M=>M.identifier);await O.Promises.settled(j.map(async M=>{const $=M.sort((V,q)=>k.rcompare(V.manifest.version,q.manifest.version))[0];_.has($.identifier.id.toLowerCase())||await this.beforeRemovingExtension($)}));const B=R.filter(M=>h[new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]);await O.Promises.settled(B.map(M=>this.removeUninstalledExtension(M)))}async removeOutdatedExtensions(){const h=await this.scanAllUserExtensions(),R=[],_=(0,v.groupByExtension)(h,j=>j.identifier);R.push(...(0,I.flatten)(_.map(j=>j.sort((B,M)=>k.rcompare(B.manifest.version,M.manifest.version)).slice(1)))),await O.Promises.settled(R.map(j=>this.removeExtension(j,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(h=>h.name)}joinErrors(h){const R=Array.isArray(h)?h:[h];return R.length===1?R[0]instanceof Error?R[0]:new Error(R[0]):R.reduce((_,j)=>new Error(`${_.message}${_.message?",":""}${j instanceof Error?j.message:j}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=U.normalize(U.join(f.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(h){const R=[p.promises.readFile(U.join(h,"package.json"),"utf8").then(M=>this.parseManifest(M)),p.promises.readFile(U.join(h,"package.nls.json"),"utf8").then(void 0,M=>M.code!=="ENOENT"?Promise.reject(M):"{}").then(M=>JSON.parse(M))],[{manifest:_,metadata:j},B]=await Promise.all(R);return{manifest:(0,b.localizeManifest)(_,B),metadata:j}}parseManifest(h){return new Promise((R,_)=>{try{const j=JSON.parse(h),B=j.__metadata||null;R({manifest:j,metadata:B})}catch(j){_(new Error((0,u.localize)(4,null)))}})}};d=he([Y(1,s.IFileService),Y(2,T.ILogService),Y(3,y.INativeEnvironmentService),Y(4,S.IProductService)],d),e.ExtensionsScanner=d}),define(Z[198],ee([0,1,27,109,8,24,2,18,61,29,33,9,6,3,56,4,51,7,17,143,43,22,68,12,31,70,5,16,30,196,151,197,152,153,10]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I,f,s,r,t,i,n,o,a,c,l,d,w,h,R,_,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const B="unsetUninstalled",M="downloading",$="validating",V="local",q="unknown";let H=class extends U.Disposable{constructor(D,L,F,N,x,G,J){super();this.environmentService=D,this.galleryService=L,this.logService=F,this.downloadService=N,this.telemetryService=x,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new b.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new b.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new b.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new b.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(G.createInstance(R.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(h.ExtensionsScanner,ie=>Q.postUninstall(ie))),this.manifestCache=this._register(new f.ExtensionsManifestCache(D,this)),this.extensionsDownloader=this._register(G.createInstance(w.ExtensionsDownloader));const ne=this._register(new _.ExtensionsWatcher(this,J,D,F));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:ie,removed:ce})=>{ie.forEach(ue=>this._onDidInstallExtension.fire({identifier:ue.identifier,operation:0,local:ue})),ce.forEach(ue=>this._onDidUninstallExtension.fire({identifier:ue}))})),this._register((0,U.toDisposable)(()=>{this.installingExtensions.forEach(ie=>ie.cancel()),this.uninstallingExtensions.forEach(ie=>ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(D){this.logService.trace("ExtensionManagementService#zip",D.identifier.id);const L=await this.collectFiles(D),F=await(0,g.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,L);return S.URI.file(F)}async unzip(D){return this.logService.trace("ExtensionManagementService#unzip",D.toString()),(await this.install(D)).identifier}async getManifest(D){const L=await this.downloadVsix(D),F=A.resolve(L.fsPath);return(0,d.getManifest)(F)}async collectFiles(D){const L=async N=>{let x=await P.readdir(N);x=x.map(Q=>A.join(N,Q));const G=await Promise.all(x.map(Q=>p.promises.stat(Q)));let J=Promise.resolve([]);return G.forEach((Q,ne)=>{const ie=x[ne];Q.isFile()&&(J=J.then(ce=>[...ce,ie])),Q.isDirectory()&&(J=J.then(ce=>L(ie).then(ue=>[...ce,...ue])))}),J};return(await L(D.location.fsPath)).map(N=>({path:`extension/${A.relative(D.location.fsPath,N)}`,localPath:N}))}async install(D,L={}){return this.logService.trace("ExtensionManagementService#install",D.toString()),(0,y.createCancelablePromise)(async F=>{const N=await this.downloadVsix(D),x=A.resolve(N.fsPath),G=await(0,d.getManifest)(x),J={id:(0,O.getGalleryExtensionId)(G.publisher,G.name)};let Q=1;if(G.engines&&G.engines.vscode&&!(0,t.isEngineValid)(G.engines.vscode,E.default.version))throw new Error(k.localize(0,null,J.id,E.default.version));const ne=new O.ExtensionIdentifierWithVersion(J,G.version),ce=(await this.getInstalled(1)).find(ge=>(0,O.areSameExtensions)(J,ge.identifier));if(ce)if(L.isMachineScoped=L.isMachineScoped||ce.isMachineScoped,L.isBuiltin=L.isBuiltin||ce.isBuiltin,Q=2,ne.equals(new O.ExtensionIdentifierWithVersion(ce.identifier,ce.manifest.version)))try{await this.extensionsScanner.removeExtension(ce,"existing")}catch(ge){throw new Error(k.localize(1,null,G.displayName||G.name))}else u.gt(ce.manifest.version,G.version)&&await this.uninstallExtension(ce);else{const ge=await this.unsetUninstalledAndGetLocal(ne);if(ge)try{await this.extensionsScanner.removeExtension(ge,"existing")}catch(Ee){throw new Error(k.localize(2,null,G.displayName||G.name))}}this.logService.info("Installing the extension:",J.id),this._onInstallExtension.fire({identifier:J,zipPath:x});let ue;try{ue=await this.getGalleryMetadata((0,O.getGalleryExtensionId)(G.publisher,G.name))}catch(ge){}try{const ge=await this.installFromZipPath(ne,x,Object.assign(Object.assign({},ue||{}),L),L,Q,F);return this.logService.info("Successfully installed the extension:",J.id),ge}catch(ge){throw this.logService.error("Failed to install the extension:",J.id,ge.message),ge}})}async downloadVsix(D){if(D.scheme===c.Schemas.file)return D;if(!this.downloadService)throw new Error("Download service is not available");const L=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(D,L),L}async installFromZipPath(D,L,F,N,x,G){try{const J=await this.installExtension({zipPath:L,identifierWithVersion:D,metadata:F},G);try{await this.installDependenciesAndPackExtensions(J,void 0,N)}catch(Q){(0,T.isNonEmptyArray)(J.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",J.identifier.id,Q.message),(0,T.isNonEmptyArray)(J.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",J.identifier.id,Q.message)}return this._onDidInstallExtension.fire({identifier:D,zipPath:L,local:J,operation:x}),J}catch(J){throw this._onDidInstallExtension.fire({identifier:D,zipPath:L,operation:x,error:J}),J}}async canInstall(D){return!0}async installFromGallery(D,L={}){if(!this.galleryService.isEnabled())throw new Error(k.localize(3,null));try{D=await this.checkAndGetCompatibleVersion(D)}catch(x){const G=x&&x.code?x.code:q;throw this.logService.error("Failed to install extension:",D.identifier.id,x?x.message:G),this.reportTelemetry(this.getTelemetryEvent(1),(0,O.getGalleryExtensionTelemetryData)(D),void 0,x),x instanceof Error&&(x.name=G),x}const F=new O.ExtensionIdentifierWithVersion(D.identifier,D.version).key();let N=this.installingExtensions.get(F);return N||(N=(0,y.createCancelablePromise)(x=>this.doInstallFromGallery(D,L,x)),this.installingExtensions.set(F,N),N.finally(()=>this.installingExtensions.delete(F))),N}async doInstallFromGallery(D,L,F){const N=new Date().getTime();let x=1;this.logService.info("Installing extension:",D.identifier.id),this._onInstallExtension.fire({identifier:D.identifier,gallery:D});try{const J=(await this.getInstalled(1)).find(ie=>(0,O.areSameExtensions)(ie.identifier,D.identifier));J&&(x=2);const Q=await this.downloadInstallableExtension(D,x);Q.metadata.isMachineScoped=L.isMachineScoped||(J==null?void 0:J.isMachineScoped),Q.metadata.isBuiltin=L.isBuiltin||(J==null?void 0:J.isBuiltin);const ne=await this.installExtension(Q,F);try{await this.extensionsDownloader.delete(S.URI.file(Q.zipPath))}catch(ie){}if(!L.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(ne,J,L)}catch(ie){try{await this.uninstall(ne)}catch(ce){}throw ie}return J&&u.neq(J.manifest.version,D.version)&&await this.extensionsScanner.setUninstalled(J),this.logService.info("Extensions installed successfully:",D.identifier.id),this._onDidInstallExtension.fire({identifier:D.identifier,gallery:D,local:ne,operation:x}),this.reportTelemetry(this.getTelemetryEvent(x),(0,O.getGalleryExtensionTelemetryData)(D),new Date().getTime()-N,void 0),ne}catch(G){const J=G&&G.code?G.code:q;throw this.logService.error("Failed to install extension:",D.identifier.id,G?G.message:J),this._onDidInstallExtension.fire({identifier:D.identifier,gallery:D,operation:x,error:J}),this.reportTelemetry(this.getTelemetryEvent(x),(0,O.getGalleryExtensionTelemetryData)(D),new Date().getTime()-N,G),G instanceof Error&&(G.name=J),G}}async checkAndGetCompatibleVersion(D){if(await this.isMalicious(D))throw new v.ExtensionManagementError(k.localize(4,null),v.INSTALL_ERROR_MALICIOUS);const L=await this.galleryService.getCompatibleExtension(D);if(!L)throw new v.ExtensionManagementError(k.localize(5,null,D.identifier.id,E.default.version),v.INSTALL_ERROR_INCOMPATIBLE);return L}async reinstallFromGallery(D){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",D.identifier.id),!this.galleryService.isEnabled())throw new Error(k.localize(6,null));const L=await this.findGalleryExtension(D);if(!L)throw new Error(k.localize(7,null));await this.extensionsScanner.setUninstalled(D);try{await this.extensionsScanner.removeUninstalledExtension(D)}catch(F){throw new Error(k.localize(8,null,(0,s.toErrorMessage)(F)))}await this.installFromGallery(L)}getTelemetryEvent(D){return D===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(D){const L=await this.getExtensionsReport();return(0,O.getMaliciousExtensionsSet)(L).has(D.identifier.id)}async downloadInstallableExtension(D,L){const F={id:D.identifier.uuid,publisherId:D.publisherId,publisherDisplayName:D.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",D.identifier.id),N=(await this.extensionsDownloader.downloadExtension(D,L)).fsPath,this.logService.info("Downloaded extension:",D.identifier.id,N)}catch(x){throw new v.ExtensionManagementError(this.joinErrors(x).message,M)}try{const x=await(0,d.getManifest)(N);return{zipPath:N,identifierWithVersion:new O.ExtensionIdentifierWithVersion(D.identifier,x.version),metadata:F}}catch(x){throw new v.ExtensionManagementError(this.joinErrors(x).message,$)}}async installExtension(D,L){try{const F=await this.unsetUninstalledAndGetLocal(D.identifierWithVersion);if(F)return D.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,D.metadata):F}catch(F){throw C.isMacintosh?new v.ExtensionManagementError(k.localize(9,null),B):new v.ExtensionManagementError(k.localize(10,null),B)}return this.extractAndInstall(D,L)}async unsetUninstalledAndGetLocal(D){if(!await this.isUninstalled(D))return null;this.logService.trace("Removing the extension from uninstalled list:",D.id);const F=await this.extensionsScanner.setInstalled(D);return this.logService.info("Removed the extension from uninstalled list:",D.id),F}async extractAndInstall({zipPath:D,identifierWithVersion:L,metadata:F},N){let x=await this.extensionsScanner.extractUserExtension(L,D,N);return this.logService.info("Installation completed.",L.id),F&&(x=await this.extensionsScanner.saveMetadataForLocalExtension(x,F)),x}async installDependenciesAndPackExtensions(D,L,F){if(!!this.galleryService.isEnabled()){const N=D.manifest.extensionDependencies||[];if(D.manifest.extensionPack)for(const x of D.manifest.extensionPack)L&&L.manifest.extensionPack&&L.manifest.extensionPack.some(G=>(0,O.areSameExtensions)({id:G},{id:x}))||N.every(G=>!(0,O.areSameExtensions)({id:G},{id:x}))&&N.push(x);if(N.length){const x=await this.getInstalled(),G=N.filter(J=>x.every(({identifier:Q})=>!(0,O.areSameExtensions)(Q,{id:J})));if(G.length){const Q=(await this.galleryService.query({names:G,pageSize:N.length},l.CancellationToken.None)).firstPage;try{await y.Promises.settled(Q.map(ne=>this.installFromGallery(ne,F)))}catch(ne){try{await this.rollback(Q)}catch(ie){}throw ne}}}}}async rollback(D){const F=(await this.getInstalled(1)).filter(N=>D.some(x=>new O.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new O.ExtensionIdentifierWithVersion(x.identifier,x.version))));await y.Promises.settled(F.map(N=>this.uninstall(N)))}async uninstall(D,L={}){this.logService.trace("ExtensionManagementService#uninstall",D.identifier.id);const F=await this.getInstalled(1),N=F.find(x=>(0,O.areSameExtensions)(x.identifier,D.identifier));if(!N)throw new Error(k.localize(11,null,D.manifest.displayName||D.manifest.name));try{await this.checkForDependenciesAndUninstall(N,F,L)}catch(x){throw this.joinErrors(x)}}async updateMetadata(D,L){return this.logService.trace("ExtensionManagementService#updateMetadata",D.identifier.id),D=await this.extensionsScanner.saveMetadataForLocalExtension(D,Object.assign(Object.assign({},D.manifest.__metadata||{}),L)),this.manifestCache.invalidate(),D}async updateExtensionScope(D,L){return this.logService.trace("ExtensionManagementService#updateExtensionScope",D.identifier.id),D=await this.extensionsScanner.saveMetadataForLocalExtension(D,Object.assign(Object.assign({},D.manifest.__metadata||{}),{isMachineScoped:L})),this.manifestCache.invalidate(),D}async getGalleryMetadata(D){const L=await this.findGalleryExtensionByName(D);return L?{id:L.identifier.uuid,publisherDisplayName:L.publisherDisplayName,publisherId:L.publisherId}:void 0}async findGalleryExtension(D){if(D.identifier.uuid){const L=await this.findGalleryExtensionById(D.identifier.uuid);return L||this.findGalleryExtensionByName(D.identifier.id)}return this.findGalleryExtensionByName(D.identifier.id)}async findGalleryExtensionById(D){return(await this.galleryService.query({ids:[D],pageSize:1},l.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(D){return(await this.galleryService.query({names:[D],pageSize:1},l.CancellationToken.None)).firstPage[0]}joinErrors(D){const L=Array.isArray(D)?D:[D];return L.length===1?L[0]instanceof Error?L[0]:new Error(L[0]):L.reduce((F,N)=>new Error(`${F.message}${F.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(D,L,F){try{await this.preUninstallExtension(D);const N=F.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(D,L);await this.uninstallExtensions(D,N,L,F)}catch(N){throw await this.postUninstallExtension(D,new v.ExtensionManagementError(N instanceof Error?N.message:N,V)),N}await this.postUninstallExtension(D)}async uninstallExtensions(D,L,F,N){const x=[D,...L];if(!N.donotCheckDependents)for(const G of x)this.checkForDependents(G,x,F,D);await y.Promises.settled([this.uninstallExtension(D),...L.map(G=>this.doUninstall(G))])}checkForDependents(D,L,F,N){const x=this.getDependents(D,F);if(x.length){const G=x.filter(J=>L.indexOf(J)===-1);if(G.length)throw new Error(this.getDependentsErrorMessage(D,G,N))}}getDependentsErrorMessage(D,L,F){return F===D?L.length===1?k.localize(12,null,F.manifest.displayName||F.manifest.name,L[0].manifest.displayName||L[0].manifest.name):L.length===2?k.localize(13,null,F.manifest.displayName||F.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name):k.localize(14,null,F.manifest.displayName||F.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name):L.length===1?k.localize(15,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,L[0].manifest.displayName||L[0].manifest.name):L.length===2?k.localize(16,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name):k.localize(17,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name)}getAllPackExtensionsToUninstall(D,L,F=[]){if(F.indexOf(D)!==-1)return[];F.push(D);const N=D.manifest.extensionPack?D.manifest.extensionPack:[];if(N.length){const x=L.filter(J=>!J.isBuiltin&&N.some(Q=>(0,O.areSameExtensions)({id:Q},J.identifier))),G=[];for(const J of x)G.push(...this.getAllPackExtensionsToUninstall(J,L,F));return[...x,...G]}return[]}getDependents(D,L){return L.filter(F=>F.manifest.extensionDependencies&&F.manifest.extensionDependencies.some(N=>(0,O.areSameExtensions)({id:N},D.identifier)))}async doUninstall(D){try{await this.preUninstallExtension(D),await this.uninstallExtension(D)}catch(L){throw await this.postUninstallExtension(D,new v.ExtensionManagementError(L instanceof Error?L.message:L,V)),L}await this.postUninstallExtension(D)}async preUninstallExtension(D){if(!await P.exists(D.location.fsPath))throw new Error(k.localize(18,null));this.logService.info("Uninstalling extension:",D.identifier.id),this._onUninstallExtension.fire(D.identifier)}async uninstallExtension(D){let L=this.uninstallingExtensions.get(D.identifier.id);return L||(L=(0,y.createCancelablePromise)(async()=>{const F=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...F.filter(N=>(0,O.areSameExtensions)(N.identifier,D.identifier)))}),this.uninstallingExtensions.set(D.identifier.id,L),L.finally(()=>this.uninstallingExtensions.delete(D.identifier.id))),L}async postUninstallExtension(D,L){if(L)this.logService.error("Failed to uninstall extension:",D.identifier.id,L.message);else if(this.logService.info("Successfully uninstalled extension:",D.identifier.id),D.identifier.uuid)try{await this.galleryService.reportStatistic(D.manifest.publisher,D.manifest.name,D.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",(0,O.getLocalExtensionTelemetryData)(D),void 0,L);const F=L?L instanceof v.ExtensionManagementError?L.code:q:void 0;this._onDidUninstallExtension.fire({identifier:D.identifier,error:F})}getInstalled(D=null){return this.extensionsScanner.scanExtensions(D)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(D){return(await this.filterUninstalled(D)).length===1}async filterUninstalled(...D){const L=[],F=await this.extensionsScanner.getUninstalledExtensions();for(const N of D)F[N.key()]&&L.push(N.key());return L}getExtensionsReport(){const D=new Date().getTime();return(!this.reportedExtensions||D-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=D),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const D=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${D.length} reported extensions from service`),D}catch(D){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(D,L,F,N){const x=N?N instanceof v.ExtensionManagementError?N.code:q:void 0;this.telemetryService.publicLogError(D,Object.assign(Object.assign({},L),{success:!N,duration:F,errorcode:x}))}};H=he([Y(0,m.INativeEnvironmentService),Y(1,v.IExtensionGalleryService),Y(2,I.ILogService),Y(3,(0,a.optional)(o.IDownloadService)),Y(4,r.ITelemetryService),Y(5,a.IInstantiationService),Y(6,j.IFileService)],H),e.ExtensionManagementService=H}),define(Z[203],ee([0,1,27,38,204,99,51,98,34,74,50,147,9,127,129,29,198,170,25,161,40,162,22,58,168,78,79,173,17,75,154,55,2,163,70,159,158,141,140,149,148,169,69,155,10,157,16,28,20,191,193,188,57,189,194,167,19,165,190,59,187,171,60,71,131,195,172,83,82,81,5,150,142,11,43,80,176,175,192,138,144,174,4,12]),function(K,e,p,k,A,P,U,T,g,v,O,m,y,b,u,S,E,C,I,f,s,r,t,i,n,o,a,c,l,d,w,h,R,_,j,B,M,$,V,q,H,z,D,L,F,N,x,G,J,Q,ne,ie,ce,ue,ge,Ee,Ie,Te,Ae,Ue,ke,Ne,De,Oe,Ge,Ke,$e,ze,X,re,se,me,W,te,oe,ae,le,fe,ve,Se,we,be,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends R.Disposable{constructor(de){super();this.configuration=de,this.server=this._register(new T.Server),(0,A.gracefulify)(p),this.registerListeners()}registerListeners(){const de=()=>this.dispose();process.once("exit",de),P.ipcRenderer.once("vscode:electron-main->shared-process=exit",de)}async open(){const de=await this.initServices();(0,J.registerConfiguration)(),de.invokeFunction(Le=>{const _e=Le.get(l.ILogService);_e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Le),this.registerErrorHandler(_e)}),this._register((0,R.combinedDisposable)(de.createInstance(B.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),de.createInstance(M.LanguagePackCachedDataCleaner),de.createInstance($.StorageDataCleaner,this.configuration.backupWorkspacesPath),de.createInstance(V.LogsDataCleaner),de.createInstance(me.LocalizationsUpdater),de.createInstance(W.DeprecatedExtensionsCleaner)))}async initServices(){const de=new v.ServiceCollection,Le=Object.assign({_serviceBrand:void 0},U.default);de.set(G.IProductService,Le);const _e=new g.StaticRouter(qe=>qe==="main"),Fe=new H.MessagePortMainProcessService(this.server,_e);de.set(q.IMainProcessService,Fe);const Me=new b.NativeEnvironmentService(this.configuration.args,Le);de.set(y.INativeEnvironmentService,Me);const Ze=new d.LogLevelChannelClient(this.server.getChannel("logLevel",_e)),Ye=new d.LoggerChannelClient(this.configuration.logLevel,Ze.onDidChangeLogLevel,Fe.getChannel("logger"));de.set(l.ILoggerService,Ye);const tt=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Ye.createLogger((0,ye.joinPath)(Pe.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Be=this._register(new d.FollowerLogService(Ze,tt));de.set(l.ILogService,Be);const We=this._register(new L.FileService(Be));de.set(F.IFileService,We);const it=this._register(new N.DiskFileSystemProvider(Be));We.registerProvider(x.Schemas.file,it);const Ve=this._register(new f.ConfigurationService(Me.settingsResource,We));de.set(I.IConfigurationService,Ve),await Ve.initialize();const Je=new Ee.NativeStorageService(void 0,Fe,Me);de.set(Ie.IStorageService,Je),await Je.initialize(),this._register((0,R.toDisposable)(()=>Je.flush())),de.set(s.IRequestService,new O.SyncDescriptor(r.RequestService)),de.set(Se.IChecksumService,new O.SyncDescriptor(we.ChecksumService));const et=g.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});de.set(ce.INativeHostService,et),de.set(j.IDownloadService,new O.SyncDescriptor(_.DownloadService));const nt=this._register(new Ke.ActiveWindowManager(et)),ut=new g.StaticRouter(qe=>nt.getActiveClientId().then(rt=>qe===rt));de.set(Oe.IExtensionRecommendationNotificationService,new Ge.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));let Xe,xe;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Le.enableTelemetry){xe=new $e.TelemetryLogAppender(Ye,Me);const{appRoot:qe,extensionsPath:rt,isBuilt:dt,installSourcePath:ft}=Me;if(Le.aiConfig&&Le.aiConfig.asimovKey&&dt){const at=new c.AppInsightsAppender("monacoworkbench",null,Le.aiConfig.asimovKey);this._register((0,R.toDisposable)(()=>at.flush())),xe=(0,i.combinedAppender)(at,xe)}Xe=new a.TelemetryService({appender:xe,commonProperties:(0,n.resolveCommonProperties)(We,(0,k.release)(),(0,k.hostname)(),process.arch,Le.commit,Le.version,this.configuration.machineId,Le.msftInternalDomains,ft),sendErrorTelemetry:!0,piiPaths:[qe,rt]},Ve)}else Xe=i.NullTelemetryService,xe=i.NullAppender;this.server.registerChannel("telemetryAppender",new o.TelemetryAppenderChannel(xe)),de.set(t.ITelemetryService,Xe);const ht=new be.CustomEndpointTelemetryService(Ve,Xe);return de.set(t.ICustomEndpointTelemetryService,ht),de.set(S.IExtensionManagementService,new O.SyncDescriptor(E.ExtensionManagementService)),de.set(S.IExtensionGalleryService,new O.SyncDescriptor(C.ExtensionGalleryService)),de.set(S.IExtensionTipsService,new O.SyncDescriptor(Ne.ExtensionTipsService)),de.set(h.ILocalizationsService,new O.SyncDescriptor(w.LocalizationsService)),de.set(D.IDiagnosticsService,new O.SyncDescriptor(z.DiagnosticsService)),de.set(Ue.IUserDataSyncAccountService,new O.SyncDescriptor(Ue.UserDataSyncAccountService)),de.set(J.IUserDataSyncLogService,new O.SyncDescriptor(ue.UserDataSyncLogService)),de.set(J.IUserDataSyncUtilService,new ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",qe=>qe.ctx!=="main"))),de.set(S.IGlobalExtensionEnablementService,new O.SyncDescriptor(Te.GlobalExtensionEnablementService)),de.set(X.IIgnoredExtensionsManagementService,new O.SyncDescriptor(X.IgnoredExtensionsManagementService)),de.set(re.IExtensionsStorageSyncService,new O.SyncDescriptor(re.ExtensionsStorageSyncService)),de.set(J.IUserDataSyncStoreManagementService,new O.SyncDescriptor(ne.UserDataSyncStoreManagementService)),de.set(J.IUserDataSyncStoreService,new O.SyncDescriptor(ne.UserDataSyncStoreService)),de.set(De.IUserDataSyncMachinesService,new O.SyncDescriptor(De.UserDataSyncMachinesService)),de.set(J.IUserDataSyncBackupStoreService,new O.SyncDescriptor(ke.UserDataSyncBackupStoreService)),de.set(J.IUserDataAutoSyncEnablementService,new O.SyncDescriptor(ze.UserDataAutoSyncEnablementService)),de.set(J.IUserDataSyncResourceEnablementService,new O.SyncDescriptor(Ae.UserDataSyncResourceEnablementService)),de.set(J.IUserDataSyncService,new O.SyncDescriptor(Q.UserDataSyncService)),de.set(fe.ILocalPtyService,this._register(new le.PtyHostService(Be,Xe))),new m.InstantiationService(de)}initChannels(de){const Le=new u.ExtensionManagementChannel(de.get(S.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Le);const _e=g.ProxyChannel.fromService(de.get(h.ILocalizationsService));this.server.registerChannel("localizations",_e);const Fe=g.ProxyChannel.fromService(de.get(D.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new u.ExtensionTipsChannel(de.get(S.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const Ze=g.ProxyChannel.fromService(de.get(Se.IChecksumService));this.server.registerChannel("checksum",Ze);const Ye=new ie.UserDataSyncMachinesServiceChannel(de.get(De.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ye);const tt=g.ProxyChannel.fromService(de.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",tt);const Be=new ie.UserDataSyncAccountServiceChannel(de.get(Ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const We=new ie.UserDataSyncStoreManagementServiceChannel(de.get(J.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",We);const it=new ve.UserDataSyncChannel(de.get(J.IUserDataSyncService),de.get(l.ILogService));this.server.registerChannel("userDataSync",it);const Ve=this._register(de.get(se.IInstantiationService).createInstance(ge.UserDataAutoSyncService)),Je=new ie.UserDataAutoSyncChannel(Ve);this.server.registerChannel("userDataAutoSync",Je);const et=de.get(fe.ILocalPtyService),nt=g.ProxyChannel.fromService(et);this.server.registerChannel(ae.TerminalIpcChannels.LocalPty,nt)}registerErrorHandler(de){window.addEventListener("unhandledrejection",Le=>{(0,te.onUnexpectedError)(Le.reason),Le.preventDefault()}),(0,te.setUnexpectedErrorHandler)(Le=>{const _e=(0,oe.toErrorMessage)(Le,!0);!_e||de.error(`[uncaught exception in sharedProcess]: ${_e}`)})}}async function Ce(Re){const de=new pe(Re);P.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await de.open(),P.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6bee0f2f3fea9df1ad45344f09b2a139c93b384f/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
