/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/resources","fs","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","util","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function($){for(var t=[],p=0,T=$.length;p<T;p++)t[p]=Q[$[p]];return t};define(Q[56],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function p(T,I){if(!T)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}t.ok=p}),define(Q[57],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function p(F){return(L,f,u)=>{let R=null,v=null;if(typeof u.value=="function"?(R="value",v=u.value):typeof u.get=="function"&&(R="get",v=u.get),!v)throw new Error("not supported");u[R]=F(v,f)}}t.createDecorator=p;function T(F,L,f){let u=null,R=null;if(typeof f.value=="function"?(u="value",R=f.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(u="get",R=f.get),!R)throw new Error("not supported");const v=`$memoize$${L}`;f[u]=function(...y){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,y)}),this[v]}}t.memoize=T;function I(F,L,f){return p((u,R)=>{const v=`$debounce$${R}`,y=`$debounce$result$${R}`;return function(...D){this[y]||(this[y]=f?f():void 0),clearTimeout(this[v]),L&&(this[y]=L(this[y],...D),D=[this[y]]),this[v]=setTimeout(()=>{u.apply(this,D),this[y]=f?f():void 0},F)}})}t.debounce=I;function w(F,L,f){return p((u,R)=>{const v=`$throttle$timer$${R}`,y=`$throttle$result$${R}`,D=`$throttle$lastRun$${R}`,h=`$throttle$pending$${R}`;return function(...d){if(this[y]||(this[y]=f?f():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),L&&(this[y]=L(this[y],...d)),!this[h]){const b=this[D]+F;b<=Date.now()?(this[D]=Date.now(),u.apply(this,[this[y]]),this[y]=f?f():void 0):(this[h]=!0,this[v]=setTimeout(()=>{this[h]=!1,this[D]=Date.now(),u.apply(this,[this[y]]),this[y]=f?f():void 0},b-Date.now()))}}})}t.throttle=w}),define(Q[23],Z([0,1,12]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function T(W,G=0){return W[W.length-(1+G)]}t.tail=T;function I(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}t.tail2=I;function w(W,G,V=(a,l)=>a===l){if(W===G)return!0;if(!W||!G||W.length!==G.length)return!1;for(let a=0,l=W.length;a<l;a++)if(!V(W[a],G[a]))return!1;return!0}t.equals=w;function F(W,G,V){let a=0,l=W.length-1;for(;a<=l;){const P=(a+l)/2|0,S=V(W[P],G);if(S<0)a=P+1;else if(S>0)l=P-1;else return P}return-(a+1)}t.binarySearch=F;function L(W,G){let V=0,a=W.length;if(a===0)return 0;for(;V<a;){const l=Math.floor((V+a)/2);G(W[l])?a=l:V=l+1}return V}t.findFirstInSorted=L;function f(W,G,V){if(W=W|0,W>=G.length)throw new TypeError("invalid index");let a=G[Math.floor(G.length*Math.random())],l=[],P=[],S=[];for(let A of G){const j=V(A,a);j<0?l.push(A):j>0?P.push(A):S.push(A)}return W<l.length?f(W,l,V):W<l.length+S.length?S[0]:f(W-(l.length+S.length),P,V)}t.quickSelect=f;function u(W,G){const V=[];let a;for(const l of W.slice(0).sort(G))!a||G(a[0],l)!==0?(a=[l],V.push(a)):a.push(l);return V}t.groupBy=u;function R(W,G,V){const a=[];function l(A,j,B){if(!(j===0&&B.length===0)){const _=a[a.length-1];_&&_.start+_.deleteCount===A?(_.deleteCount+=j,_.toInsert.push(...B)):a.push({start:A,deleteCount:j,toInsert:B})}}let P=0,S=0;for(;;){if(P===W.length){l(P,0,G.slice(S));break}if(S===G.length){l(P,W.length-P,[]);break}const A=W[P],j=G[S],B=V(A,j);B===0?(P+=1,S+=1):B<0?(l(P,1,[]),P+=1):B>0&&(l(P,0,[j]),S+=1)}return a}t.sortedDiff=R;function v(W,G,V){const a=R(W,G,V),l=[],P=[];for(const S of a)l.push(...W.slice(S.start,S.start+S.deleteCount)),P.push(...S.toInsert);return{removed:l,added:P}}t.delta=v;function y(W,G,V){if(V===0)return[];const a=W.slice(0,V).sort(G);return h(W,G,a,V,W.length),a}t.top=y;function D(W,G,V,a,l){return V===0?Promise.resolve([]):new Promise((P,S)=>{(async()=>{const A=W.length,j=W.slice(0,V).sort(G);for(let B=V,_=Math.min(V+a,A);B<A;B=_,_=Math.min(_+a,A)){if(B>V&&await new Promise(q=>setTimeout(q)),l&&l.isCancellationRequested)throw(0,p.canceled)();h(W,G,j,B,_)}return j})().then(P,S)})}t.topAsync=D;function h(W,G,V,a,l){for(const P=V.length;a<l;a++){const S=W[a];if(G(S,V[P-1])<0){V.pop();const A=L(V,j=>G(S,j)<0);V.splice(A,0,S)}}}function d(W){return W.filter(G=>!!G)}t.coalesce=d;function b(W){let G=0;for(let V=0;V<W.length;V++)W[V]&&(W[G]=W[V],G+=1);W.length=G}t.coalesceInPlace=b;function O(W,G,V){W.splice(V,0,W.splice(G,1)[0])}t.move=O;function C(W){return!Array.isArray(W)||W.length===0}t.isFalsyOrEmpty=C;function m(W){return Array.isArray(W)&&W.length>0}t.isNonEmptyArray=m;function s(W,G){if(!G)return W.filter((a,l)=>W.indexOf(a)===l);const V=Object.create(null);return W.filter(a=>{const l=G(a);return V[l]?!1:(V[l]=!0,!0)})}t.distinct=s;function r(W){const G=new Set;return W.filter(V=>G.has(V)?!1:(G.add(V),!0))}t.distinctES6=r;function e(W){const G=Object.create(null);return V=>{const a=W(V);return G[a]?!1:(G[a]=!0,!0)}}t.uniqueFilter=e;function i(W,G){for(let V=W.length-1;V>=0;V--){const a=W[V];if(G(a))return V}return-1}t.lastIndex=i;function n(W,G){return W.length>0?W[0]:G}t.firstOrDefault=n;function o(W,G,V=(a,l)=>a===l){let a=0;for(let l=0,P=Math.min(W.length,G.length);l<P&&V(W[l],G[l]);l++)a++;return a}t.commonPrefixLength=o;function c(W){return[].concat(...W)}t.flatten=c;function g(W,G){let V=typeof G=="number"?W:0;typeof G=="number"?V=W:(V=0,G=W);const a=[];if(V<=G)for(let l=V;l<G;l++)a.push(l);else for(let l=V;l>G;l--)a.push(l);return a}t.range=g;function E(W,G,V){return W.reduce((a,l)=>(a[G(l)]=V?V(l):l,a),Object.create(null))}t.index=E;function M(W,G){return W.push(G),()=>N(W,G)}t.insert=M;function N(W,G){const V=W.indexOf(G);if(V>-1)return W.splice(V,1),G}t.remove=N;function k(W,G,V){const a=W.slice(0,G),l=W.slice(G);return a.concat(V,l)}t.arrayInsert=k;function U(W,G){let V;if(typeof G=="number"){let a=G;V=()=>{const l=Math.sin(a++)*179426549;return l-Math.floor(l)}}else V=Math.random;for(let a=W.length-1;a>0;a-=1){const l=Math.floor(V()*(a+1)),P=W[a];W[a]=W[l],W[l]=P}}t.shuffle=U;function x(W,G){const V=W.indexOf(G);V>-1&&(W.splice(V,1),W.unshift(G))}t.pushToStart=x;function X(W,G){const V=W.indexOf(G);V>-1&&(W.splice(V,1),W.push(G))}t.pushToEnd=X;function ie(W,G){return Array.isArray(W)?W.map(G):G(W)}t.mapArrayOrNot=ie;function ee(W){return Array.isArray(W)?W:[W]}t.asArray=ee;function te(W){return W[Math.floor(Math.random()*W.length)]}t.getRandomElement=te;function ae(W,G){for(const V of W){const a=G(V);if(a!==void 0)return a}}t.mapFind=ae}),define(Q[58],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var p;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(p=t.ScanError||(t.ScanError={}));var T;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(T=t.SyntaxKind||(t.SyntaxKind={}));var I;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(I=t.ParseErrorCode||(t.ParseErrorCode={}));var w;(function(e){e.DEFAULT={allowTrailingComma:!0}})(w=t.ParseOptions||(t.ParseOptions={}));function F(e,i=!1){let n=0,o=e.length,c="",g=0,E=16,M=0;function N(te){let ae=0,W=0;for(;ae<te;){const G=e.charCodeAt(n);if(G>=48&&G<=57)W=W*16+G-48;else if(G>=65&&G<=70)W=W*16+G-65+10;else if(G>=97&&G<=102)W=W*16+G-97+10;else break;n++,ae++}return ae<te&&(W=-1),W}function k(te){n=te,c="",g=0,E=16,M=0}function U(){const te=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&u(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&u(e.charCodeAt(n)))for(n++;n<e.length&&u(e.charCodeAt(n));)n++;else return M=3,e.substring(te,n);let ae=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&u(e.charCodeAt(n))){for(n++;n<e.length&&u(e.charCodeAt(n));)n++;ae=n}else M=3;return e.substring(te,ae)}function x(){let te="",ae=n;for(;;){if(n>=o){te+=e.substring(ae,n),M=2;break}const W=e.charCodeAt(n);if(W===34){te+=e.substring(ae,n),n++;break}if(W===92){if(te+=e.substring(ae,n),n++,n>=o){M=2;break}switch(e.charCodeAt(n++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const V=N(4);V>=0?te+=String.fromCharCode(V):M=4;break;default:M=5}ae=n;continue}if(W>=0&&W<=31)if(f(W)){te+=e.substring(ae,n),M=2;break}else M=6;n++}return te}function X(){if(c="",M=0,g=n,n>=o)return g=o,E=17;let te=e.charCodeAt(n);if(L(te)){do n++,c+=String.fromCharCode(te),te=e.charCodeAt(n);while(L(te));return E=15}if(f(te))return n++,c+=String.fromCharCode(te),te===13&&e.charCodeAt(n)===10&&(n++,c+=`
`),E=14;switch(te){case 123:return n++,E=1;case 125:return n++,E=2;case 91:return n++,E=3;case 93:return n++,E=4;case 58:return n++,E=6;case 44:return n++,E=5;case 34:return n++,c=x(),E=10;case 47:const ae=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<o&&!f(e.charCodeAt(n));)n++;return c=e.substring(ae,n),E=12}if(e.charCodeAt(n+1)===42){n+=2;const W=o-1;let G=!1;for(;n<W;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,M=1),c=e.substring(ae,n),E=13}return c+=String.fromCharCode(te),n++,E=16;case 45:if(c+=String.fromCharCode(te),n++,n===o||!u(e.charCodeAt(n)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=U(),E=11;default:for(;n<o&&ie(te);)n++,te=e.charCodeAt(n);if(g!==n){switch(c=e.substring(g,n),c){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return c+=String.fromCharCode(te),n++,E=16}}function ie(te){if(L(te)||f(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let te;do te=X();while(te>=12&&te<=15);return te}return{setPosition:k,getPosition:()=>n,scan:i?ee:X,getToken:()=>E,getTokenValue:()=>c,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>M}}t.createScanner=F;function L(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function f(e){return e===10||e===13||e===8232||e===8233}function u(e){return e>=48&&e<=57}var R;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(R||(R={}));function v(e,i){const n=[],o=new Object;let c;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function M(N,k,U,x){g.value=N,g.offset=k,g.length=U,g.type=x,g.colonOffset=void 0,c=g}try{m(e,{onObjectBegin:(N,k)=>{if(i<=N)throw o;c=void 0,E=i>N,n.push("")},onObjectProperty:(N,k,U)=>{if(i<k||(M(N,k,U,"property"),n[n.length-1]=N,i<=k+U))throw o},onObjectEnd:(N,k)=>{if(i<=N)throw o;c=void 0,n.pop()},onArrayBegin:(N,k)=>{if(i<=N)throw o;c=void 0,n.push(0)},onArrayEnd:(N,k)=>{if(i<=N)throw o;c=void 0,n.pop()},onLiteralValue:(N,k,U)=>{if(i<k||(M(N,k,U,r(N)),i<=k+U))throw o},onSeparator:(N,k,U)=>{if(i<=k)throw o;if(N===":"&&c&&c.type==="property")c.colonOffset=k,E=!1,c=void 0;else if(N===","){const x=n[n.length-1];typeof x=="number"?n[n.length-1]=x+1:(E=!0,n[n.length-1]=""),c=void 0}}})}catch(N){if(N!==o)throw N}return{path:n,previousNode:c,isAtPropertyKey:E,matches:N=>{let k=0;for(let U=0;k<N.length&&U<n.length;U++)if(N[k]===n[U]||N[k]==="*")k++;else if(N[k]!=="**")return!1;return k===N.length}}}t.getLocation=v;function y(e,i=[],n=w.DEFAULT){let o=null,c=[];const g=[];function E(N){Array.isArray(c)?c.push(N):o!==null&&(c[o]=N)}return m(e,{onObjectBegin:()=>{const N={};E(N),g.push(c),c=N,o=null},onObjectProperty:N=>{o=N},onObjectEnd:()=>{c=g.pop()},onArrayBegin:()=>{const N=[];E(N),g.push(c),c=N,o=null},onArrayEnd:()=>{c=g.pop()},onLiteralValue:E,onError:(N,k,U)=>{i.push({error:N,offset:k,length:U})}},n),c[0]}t.parse=y;function D(e,i=[],n=w.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(N){o.type==="property"&&(o.length=N-o.offset,o=o.parent)}function g(N){return o.children.push(N),N}m(e,{onObjectBegin:N=>{o=g({type:"object",offset:N,length:-1,parent:o,children:[]})},onObjectProperty:(N,k,U)=>{o=g({type:"property",offset:k,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:N,offset:k,length:U,parent:o})},onObjectEnd:(N,k)=>{o.length=N+k-o.offset,o=o.parent,c(N+k)},onArrayBegin:(N,k)=>{o=g({type:"array",offset:N,length:-1,parent:o,children:[]})},onArrayEnd:(N,k)=>{o.length=N+k-o.offset,o=o.parent,c(N+k)},onLiteralValue:(N,k,U)=>{g({type:r(N),offset:k,length:U,parent:o,value:N}),c(k+U)},onSeparator:(N,k,U)=>{o.type==="property"&&(N===":"?o.colonOffset=k:N===","&&c(k))},onError:(N,k,U)=>{i.push({error:N,offset:k,length:U})}},n);const M=o.children[0];return M&&delete M.parent,M}t.parseTree=D;function h(e,i){if(!!e){let n=e;for(let o of i)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let c=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===o){n=g.children[1],c=!0;break}if(!c)return}else{const c=o;if(n.type!=="array"||c<0||!Array.isArray(n.children)||c>=n.children.length)return;n=n.children[c]}return n}}t.findNodeAtLocation=h;function d(e){if(!e.parent||!e.parent.children)return[];const i=d(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=d;function b(e){switch(e.type){case"array":return e.children.map(b);case"object":const i=Object.create(null);for(let n of e.children){const o=n.children[1];o&&(i[n.children[0].value]=b(o))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=b;function O(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=O;function C(e,i,n=!1){if(O(e,i,n)){const o=e.children;if(Array.isArray(o))for(let c=0;c<o.length&&o[c].offset<=i;c++){const g=C(o[c],i,n);if(g)return g}return e}}t.findNodeAtOffset=C;function m(e,i,n=w.DEFAULT){const o=F(e,!1);function c(j){return j?()=>j(o.getTokenOffset(),o.getTokenLength()):()=>!0}function g(j){return j?B=>j(B,o.getTokenOffset(),o.getTokenLength()):()=>!0}const E=c(i.onObjectBegin),M=g(i.onObjectProperty),N=c(i.onObjectEnd),k=c(i.onArrayBegin),U=c(i.onArrayEnd),x=g(i.onLiteralValue),X=g(i.onSeparator),ie=c(i.onComment),ee=g(i.onError),te=n&&n.disallowComments,ae=n&&n.allowTrailingComma;function W(){for(;;){const j=o.scan();switch(o.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:te||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(j){case 12:case 13:te?G(10):ie();break;case 16:G(1);break;case 15:case 14:break;default:return j}}}function G(j,B=[],_=[]){if(ee(j),B.length+_.length>0){let q=o.getToken();for(;q!==17;){if(B.indexOf(q)!==-1){W();break}else if(_.indexOf(q)!==-1)break;q=W()}}}function V(j){const B=o.getTokenValue();return j?x(B):M(B),W(),!0}function a(){switch(o.getToken()){case 11:let j=0;try{j=JSON.parse(o.getTokenValue()),typeof j!="number"&&(G(2),j=0)}catch(B){G(2)}x(j);break;case 7:x(null);break;case 8:x(!0);break;case 9:x(!1);break;default:return!1}return W(),!0}function l(){return o.getToken()!==10?(G(3,[],[2,5]),!1):(V(!1),o.getToken()===6?(X(":"),W(),A()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function P(){E(),W();let j=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(j||G(4,[],[]),X(","),W(),o.getToken()===2&&ae)break}else j&&G(6,[],[]);l()||G(4,[],[2,5]),j=!0}return N(),o.getToken()!==2?G(7,[2],[]):W(),!0}function S(){k(),W();let j=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(j||G(4,[],[]),X(","),W(),o.getToken()===4&&ae)break}else j&&G(6,[],[]);A()||G(4,[],[4,5]),j=!0}return U(),o.getToken()!==4?G(8,[4],[]):W(),!0}function A(){switch(o.getToken()){case 3:return S();case 1:return P();case 10:return V(!0);default:return a()}}return W(),o.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):A()?(o.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=m;function s(e,i){let n=F(e),o=[],c,g=0,E;do switch(E=n.getPosition(),c=n.scan(),c){case 12:case 13:case 17:g!==E&&o.push(e.substring(g,E)),i!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,i)),g=n.getPosition();break}while(c!==17);return o.join("")}t.stripComments=s;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r});"use strict";(function(){function $(I){const w=[];typeof I=="number"&&w.push("code/timeOrigin",I);function F(f){w.push(f,Date.now())}function L(){const f=[];for(let u=0;u<w.length;u+=2)f.push({name:w[u],startTime:w[u+1]});return f}return{mark:F,getMarks:L}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const w=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const F of performance.getEntriesByType("mark"))w.push({name:F.name,startTime:Math.round(I+F.startTime)});return w}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function p(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=t()),I.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=p(T))})(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var p=t();for(var T in p)(typeof exports=="object"?exports:$)[T]=p[T]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function p(T){if(t[T])return t[T].exports;var I=t[T]={i:T,l:!1,exports:{}};return $[T].call(I.exports,I,I.exports,p),I.l=!0,I.exports}return p.m=$,p.c=t,p.d=function(T,I,w){p.o(T,I)||Object.defineProperty(T,I,{enumerable:!0,get:w})},p.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},p.t=function(T,I){if(1&I&&(T=p(T)),8&I||4&I&&typeof T=="object"&&T&&T.__esModule)return T;var w=Object.create(null);if(p.r(w),Object.defineProperty(w,"default",{enumerable:!0,value:T}),2&I&&typeof T!="string")for(var F in T)p.d(w,F,function(L){return T[L]}.bind(null,F));return w},p.n=function(T){var I=T&&T.__esModule?function(){return T.default}:function(){return T};return p.d(I,"a",I),I},p.o=function(T,I){return Object.prototype.hasOwnProperty.call(T,I)},p.p="",p(p.s=0)}([function($,t,p){(function(T){var I;t=$.exports=_,I=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var w=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,L=t.re=[],f=t.src=[],u=0,R=u++;f[R]="0|[1-9]\\d*";var v=u++;f[v]="[0-9]+";var y=u++;f[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=u++;f[D]="("+f[R]+")\\.("+f[R]+")\\.("+f[R]+")";var h=u++;f[h]="("+f[v]+")\\.("+f[v]+")\\.("+f[v]+")";var d=u++;f[d]="(?:"+f[R]+"|"+f[y]+")";var b=u++;f[b]="(?:"+f[v]+"|"+f[y]+")";var O=u++;f[O]="(?:-("+f[d]+"(?:\\."+f[d]+")*))";var C=u++;f[C]="(?:-?("+f[b]+"(?:\\."+f[b]+")*))";var m=u++;f[m]="[0-9A-Za-z-]+";var s=u++;f[s]="(?:\\+("+f[m]+"(?:\\."+f[m]+")*))";var r=u++,e="v?"+f[D]+f[O]+"?"+f[s]+"?";f[r]="^"+e+"$";var i="[v=\\s]*"+f[h]+f[C]+"?"+f[s]+"?",n=u++;f[n]="^"+i+"$";var o=u++;f[o]="((?:<|>)?=?)";var c=u++;f[c]=f[v]+"|x|X|\\*";var g=u++;f[g]=f[R]+"|x|X|\\*";var E=u++;f[E]="[v=\\s]*("+f[g]+")(?:\\.("+f[g]+")(?:\\.("+f[g]+")(?:"+f[O]+")?"+f[s]+"?)?)?";var M=u++;f[M]="[v=\\s]*("+f[c]+")(?:\\.("+f[c]+")(?:\\.("+f[c]+")(?:"+f[C]+")?"+f[s]+"?)?)?";var N=u++;f[N]="^"+f[o]+"\\s*"+f[E]+"$";var k=u++;f[k]="^"+f[o]+"\\s*"+f[M]+"$";var U=u++;f[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var x=u++;f[x]="(?:~>?)";var X=u++;f[X]="(\\s*)"+f[x]+"\\s+",L[X]=new RegExp(f[X],"g");var ie=u++;f[ie]="^"+f[x]+f[E]+"$";var ee=u++;f[ee]="^"+f[x]+f[M]+"$";var te=u++;f[te]="(?:\\^)";var ae=u++;f[ae]="(\\s*)"+f[te]+"\\s+",L[ae]=new RegExp(f[ae],"g");var W=u++;f[W]="^"+f[te]+f[E]+"$";var G=u++;f[G]="^"+f[te]+f[M]+"$";var V=u++;f[V]="^"+f[o]+"\\s*("+i+")$|^$";var a=u++;f[a]="^"+f[o]+"\\s*("+e+")$|^$";var l=u++;f[l]="(\\s*)"+f[o]+"\\s*("+i+"|"+f[E]+")",L[l]=new RegExp(f[l],"g");var P=u++;f[P]="^\\s*("+f[E]+")\\s+-\\s+("+f[E]+")\\s*$";var S=u++;f[S]="^\\s*("+f[M]+")\\s+-\\s+("+f[M]+")\\s*$";var A=u++;f[A]="(<|>)?=?\\s*\\*";for(var j=0;j<35;j++)I(j,f[j]),L[j]||(L[j]=new RegExp(f[j]));function B(z,H){if(z instanceof _)return z;if(typeof z!="string"||z.length>w||!(H?L[n]:L[r]).test(z))return null;try{return new _(z,H)}catch(K){return null}}function _(z,H){if(z instanceof _){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>w)throw new TypeError("version is longer than "+w+" characters");if(!(this instanceof _))return new _(z,H);I("SemVer",z,H),this.loose=H;var K=z.trim().match(H?L[n]:L[r]);if(!K)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var oe=+se;if(oe>=0&&oe<F)return oe}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=B,t.valid=function(z,H){var K=B(z,H);return K?K.version:null},t.clean=function(z,H){var K=B(z.trim().replace(/^[=v]+/,""),H);return K?K.version:null},t.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(z){return I("SemVer.compare",this.version,this.loose,z),z instanceof _||(z=new _(z,this.loose)),this.compareMain(z)||this.comparePre(z)},_.prototype.compareMain=function(z){return z instanceof _||(z=new _(z,this.loose)),J(this.major,z.major)||J(this.minor,z.minor)||J(this.patch,z.patch)},_.prototype.comparePre=function(z){if(z instanceof _||(z=new _(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],se=z.prerelease[H];if(I("prerelease compare",H,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return J(K,se)}while(++H)},_.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,H,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new _(z,K).inc(H,se).version}catch(oe){return null}},t.diff=function(z,H){if(he(z,H))return null;var K=B(z),se=B(H);if(K.prerelease.length||se.prerelease.length){for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return"pre"+oe;return"prerelease"}for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return oe},t.compareIdentifiers=J;var q=/^[0-9]+$/;function J(z,H){var K=q.test(z),se=q.test(H);return K&&se&&(z=+z,H=+H),K&&!se?-1:se&&!K?1:z<H?-1:z>H?1:0}function Y(z,H,K){return new _(z,K).compare(new _(H,K))}function ne(z,H,K){return Y(z,H,K)>0}function re(z,H,K){return Y(z,H,K)<0}function he(z,H,K){return Y(z,H,K)===0}function me(z,H,K){return Y(z,H,K)!==0}function De(z,H,K){return Y(z,H,K)>=0}function Oe(z,H,K){return Y(z,H,K)<=0}function Fe(z,H,K,se){var oe;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),oe=z===K;break;case"!==":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),oe=z!==K;break;case"":case"=":case"==":oe=he(z,K,se);break;case"!=":oe=me(z,K,se);break;case">":oe=ne(z,K,se);break;case">=":oe=De(z,K,se);break;case"<":oe=re(z,K,se);break;case"<=":oe=Oe(z,K,se);break;default:throw new TypeError("Invalid operator: "+H)}return oe}function be(z,H){if(z instanceof be){if(z.loose===H)return z;z=z.value}if(!(this instanceof be))return new be(z,H);I("comparator",z,H),this.loose=H,this.parse(z),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}t.rcompareIdentifiers=function(z,H){return J(H,z)},t.major=function(z,H){return new _(z,H).major},t.minor=function(z,H){return new _(z,H).minor},t.patch=function(z,H){return new _(z,H).patch},t.compare=Y,t.compareLoose=function(z,H){return Y(z,H,!0)},t.rcompare=function(z,H,K){return Y(H,z,K)},t.sort=function(z,H){return z.sort(function(K,se){return t.compare(K,se,H)})},t.rsort=function(z,H){return z.sort(function(K,se){return t.rcompare(K,se,H)})},t.gt=ne,t.lt=re,t.eq=he,t.neq=me,t.gte=De,t.lte=Oe,t.cmp=Fe,t.Comparator=be;var Me={};function pe(z,H){if(z instanceof pe)return z.loose===H?z:new pe(z.raw,H);if(z instanceof be)return new pe(z.value,H);if(!(this instanceof pe))return new pe(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Re(z){return!z||z.toLowerCase()==="x"||z==="*"}function We(z,H,K,se,oe,Se,de,Ce,Ee,Le,ke,we,Ie){return((H=Re(K)?"":Re(se)?">="+K+".0.0":Re(oe)?">="+K+"."+se+".0":">="+H)+" "+(Ce=Re(Ee)?"":Re(Le)?"<"+(+Ee+1)+".0.0":Re(ke)?"<"+Ee+"."+(+Le+1)+".0":we?"<="+Ee+"."+Le+"."+ke+"-"+we:"<="+Ce)).trim()}function xe(z,H){for(var K=0;K<z.length;K++)if(!z[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<z.length;K++)if(I(z[K].semver),z[K].semver!==Me&&z[K].semver.prerelease.length>0){var se=z[K].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function Ue(z,H,K){try{H=new pe(H,K)}catch(se){return!1}return H.test(z)}function ze(z,H,K,se){var oe,Se,de,Ce,Ee;switch(z=new _(z,se),H=new pe(H,se),K){case">":oe=ne,Se=Oe,de=re,Ce=">",Ee=">=";break;case"<":oe=re,Se=De,de=ne,Ce="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,H,se))return!1;for(var Le=0;Le<H.set.length;++Le){var ke=H.set[Le],we=null,Ie=null;if(ke.forEach(function(Te){Te.semver===Me&&(Te=new be(">=0.0.0")),we=we||Te,Ie=Ie||Te,oe(Te.semver,we.semver,se)?we=Te:de(Te.semver,Ie.semver,se)&&(Ie=Te)}),we.operator===Ce||we.operator===Ee||(!Ie.operator||Ie.operator===Ce)&&Se(z,Ie.semver)||Ie.operator===Ee&&de(z,Ie.semver))return!1}return!0}be.prototype.parse=function(z){var H=this.loose?L[V]:L[a],K=z.match(H);if(!K)throw new TypeError("Invalid comparator: "+z);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new _(K[2],this.loose):this.semver=Me},be.prototype.toString=function(){return this.value},be.prototype.test=function(z){return I("Comparator.test",z,this.loose),this.semver===Me||(typeof z=="string"&&(z=new _(z,this.loose)),Fe(z,this.operator,this.semver,this.loose))},be.prototype.intersects=function(z,H){if(!(z instanceof be))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new pe(z.value,H),Ue(this.value,K,H);if(z.operator==="")return K=new pe(this.value,H),Ue(z.semver,K,H);var se=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Se=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ce=Fe(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ee=Fe(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return se||oe||Se&&de||Ce||Ee},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),I("range",z,H);var K=H?L[S]:L[P];z=z.replace(K,We),I("hyphen replace",z),z=z.replace(L[l],"$1$2$3"),I("comparator trim",z,L[l]),z=(z=(z=z.replace(L[X],"$1~")).replace(L[ae],"$1^")).split(/\s+/).join(" ");var se=H?L[V]:L[a],oe=z.split(" ").map(function(Se){return function(de,Ce){return I("comp",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Ie){I("caret",we,Ie);var Te=Ie?L[G]:L[W];return we.replace(Te,function(Ae,le,fe,ge,ve){var Pe;return I("caret",we,Ae,le,fe,ge,ve),Re(le)?Pe="":Re(fe)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Pe=le==="0"?">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+".0 <"+(+le+1)+".0.0":ve?(I("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),Pe=le==="0"?fe==="0"?">="+le+"."+fe+"."+ge+ve+" <"+le+"."+fe+"."+(+ge+1):">="+le+"."+fe+"."+ge+ve+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+ge+ve+" <"+(+le+1)+".0.0"):(I("no pr"),Pe=le==="0"?fe==="0"?">="+le+"."+fe+"."+ge+" <"+le+"."+fe+"."+(+ge+1):">="+le+"."+fe+"."+ge+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+ge+" <"+(+le+1)+".0.0"),I("caret return",Pe),Pe})}(ke,Le)}).join(" ")}(de,Ce),I("caret",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Ie){var Te=Ie?L[ee]:L[ie];return we.replace(Te,function(Ae,le,fe,ge,ve){var Pe;return I("tilde",we,Ae,le,fe,ge,ve),Re(le)?Pe="":Re(fe)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Pe=">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":ve?(I("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),Pe=">="+le+"."+fe+"."+ge+ve+" <"+le+"."+(+fe+1)+".0"):Pe=">="+le+"."+fe+"."+ge+" <"+le+"."+(+fe+1)+".0",I("tilde return",Pe),Pe})}(ke,Le)}).join(" ")}(de,Ce),I("tildes",de),de=function(Ee,Le){return I("replaceXRanges",Ee,Le),Ee.split(/\s+/).map(function(ke){return function(we,Ie){we=we.trim();var Te=Ie?L[k]:L[N];return we.replace(Te,function(Ae,le,fe,ge,ve,Pe){I("xRange",we,Ae,le,fe,ge,ve,Pe);var _e=Re(fe),Ne=_e||Re(ge),je=Ne||Re(ve);return le==="="&&je&&(le=""),_e?Ae=le===">"||le==="<"?"<0.0.0":"*":le&&je?(Ne&&(ge=0),je&&(ve=0),le===">"?(le=">=",Ne?(fe=+fe+1,ge=0,ve=0):je&&(ge=+ge+1,ve=0)):le==="<="&&(le="<",Ne?fe=+fe+1:ge=+ge+1),Ae=le+fe+"."+ge+"."+ve):Ne?Ae=">="+fe+".0.0 <"+(+fe+1)+".0.0":je&&(Ae=">="+fe+"."+ge+".0 <"+fe+"."+(+ge+1)+".0"),I("xRange return",Ae),Ae})}(ke,Le)}).join(" ")}(de,Ce),I("xrange",de),de=function(Ee,Le){return I("replaceStars",Ee,Le),Ee.trim().replace(L[A],"")}(de,Ce),I("stars",de),de}(Se,H)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(Se){return!!Se.match(se)})),oe=oe.map(function(Se){return new be(Se,H)})},pe.prototype.intersects=function(z,H){if(!(z instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return z.set.some(function(oe){return oe.every(function(Se){return se.intersects(Se,H)})})})})},t.toComparators=function(z,H){return new pe(z,H).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new _(z,this.loose));for(var H=0;H<this.set.length;H++)if(xe(this.set[H],z))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(z,H,K){var se=null,oe=null;try{var Se=new pe(H,K)}catch(de){return null}return z.forEach(function(de){Se.test(de)&&(se&&oe.compare(de)!==-1||(oe=new _(se=de,K)))}),se},t.minSatisfying=function(z,H,K){var se=null,oe=null;try{var Se=new pe(H,K)}catch(de){return null}return z.forEach(function(de){Se.test(de)&&(se&&oe.compare(de)!==1||(oe=new _(se=de,K)))}),se},t.validRange=function(z,H){try{return new pe(z,H).range||"*"}catch(K){return null}},t.ltr=function(z,H,K){return ze(z,H,"<",K)},t.gtr=function(z,H,K){return ze(z,H,">",K)},t.outside=ze,t.prerelease=function(z,H){var K=B(z,H);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(z,H,K){return z=new pe(z,K),H=new pe(H,K),z.intersects(H)},t.coerce=function(z){if(z instanceof _)return z;if(typeof z!="string")return null;var H=z.match(L[U]);return H==null?null:B((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,p(1))},function($,t){var p,T,I=$.exports={};function w(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function L(b){if(p===setTimeout)return setTimeout(b,0);if((p===w||!p)&&setTimeout)return p=setTimeout,setTimeout(b,0);try{return p(b,0)}catch(O){try{return p.call(null,b,0)}catch(C){return p.call(this,b,0)}}}(function(){try{p=typeof setTimeout=="function"?setTimeout:w}catch(b){p=w}try{T=typeof clearTimeout=="function"?clearTimeout:F}catch(b){T=F}})();var f,u=[],R=!1,v=-1;function y(){R&&f&&(R=!1,f.length?u=f.concat(u):v=-1,u.length&&D())}function D(){if(!R){var b=L(y);R=!0;for(var O=u.length;O;){for(f=u,u=[];++v<O;)f&&f[v].run();v=-1,O=u.length}f=null,R=!1,function(C){if(T===clearTimeout)return clearTimeout(C);if((T===F||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(C);try{T(C)}catch(m){try{return T.call(null,C)}catch(s){return T.call(this,C)}}}(b)}}function h(b,O){this.fun=b,this.array=O}function d(){}I.nextTick=function(b){var O=new Array(arguments.length-1);if(arguments.length>1)for(var C=1;C<arguments.length;C++)O[C-1]=arguments[C];u.push(new h(b,O)),u.length!==1||R||L(D)},h.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=d,I.addListener=d,I.once=d,I.off=d,I.removeListener=d,I.removeAllListeners=d,I.emit=d,I.prependListener=d,I.prependOnceListener=d,I.listeners=function(b){return[]},I.binding=function(b){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(b){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Q[35],Z([0,1,12,2]),function($,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function I(m){const s=m;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}t.isReadableStream=I;function w(m){const s=m;return s?I(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=w;function F(m,s){return new L(m,s)}t.newWriteableStream=F;class L{constructor(s,r){this.reducer=s,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(r=>r(s))}emitError(s){this.listeners.error.length===0?(0,p.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(r=>r(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,r){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(s,r){if(!this.state.destroyed){let e;switch(s){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(r);i>=0&&e.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(m,s){const r=[];let e;for(;(e=m.read())!==null;)r.push(e);return s(r)}t.consumeReadable=f;function u(m,s,r){const e=[];let i;for(;(i=m.read())!==null&&e.length<r;)e.push(i);return i===null&&e.length>0?s(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return m.read()}}}t.peekReadable=u;function R(m,s){return new Promise((r,e)=>{const i=[];v(m,{onData:n=>{s&&i.push(n)},onError:n=>{s?e(n):r(void 0)},onEnd:()=>{r(s?s(i):void 0)}})})}t.consumeStream=R;function v(m,s){m.on("error",r=>s.onError(r)),m.on("end",()=>s.onEnd()),m.on("data",r=>s.onData(r))}t.listenStream=v;function y(m,s){return new Promise((r,e)=>{const i=new T.DisposableStore,n=[],o=E=>{if(n.push(E),n.length>s)return i.dispose(),m.pause(),r({stream:m,buffer:n,ended:!1})},c=E=>e(E),g=()=>r({stream:m,buffer:n,ended:!0});i.add((0,T.toDisposable)(()=>m.removeListener("error",c))),m.on("error",c),i.add((0,T.toDisposable)(()=>m.removeListener("end",g))),m.on("end",g),i.add((0,T.toDisposable)(()=>m.removeListener("data",o))),m.on("data",o)})}t.peekStream=y;function D(m,s){const r=F(s);return r.end(m),r}t.toStream=D;function h(){const m=F(()=>{throw new Error("not supported")});return m.end(),m}t.emptyStream=h;function d(m){let s=!1;return{read:()=>s?null:(s=!0,m)}}t.toReadable=d;function b(m,s,r){const e=F(r);return v(m,{onData:i=>e.write(s.data(i)),onError:i=>e.error(s.error?s.error(i):i),onEnd:()=>e.end()}),e}t.transform=b;function O(m,s,r){let e=!1;return{read:()=>{const i=s.read();return e?i:(e=!0,i!==null?r([m,i]):m)}}}t.prefixedReadable=O;function C(m,s,r){let e=!1;const i=F(r);return v(s,{onData:n=>e?i.write(n):(e=!0,i.write(r([m,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(m)),i.end()}}),i}t.prefixedStream=C}),define(Q[16],Z([0,1,20,35]),function($,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined",w=typeof TextEncoder!="undefined",F=typeof TextDecoder!="undefined";let L,f;class u{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return I?new u(Buffer.allocUnsafe(E)):new u(new Uint8Array(E))}static wrap(E){return I&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new u(E)}static fromString(E,M){return!((M==null?void 0:M.dontUseNodeBuffer)||!1)&&I?new u(Buffer.from(E)):w?(L||(L=new TextEncoder),new u(L.encode(E))):new u(p.encodeUTF8(E))}static concat(E,M){if(typeof M=="undefined"){M=0;for(let U=0,x=E.length;U<x;U++)M+=E[U].byteLength}const N=u.alloc(M);let k=0;for(let U=0,x=E.length;U<x;U++){const X=E[U];N.set(X,k),k+=X.byteLength}return N}toString(){return I?this.buffer.toString():F?(f||(f=new TextDecoder),f.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(E,M){return new u(this.buffer.subarray(E,M))}set(E,M){E instanceof u?this.buffer.set(E.buffer,M):this.buffer.set(E,M)}readUInt32BE(E){return y(this.buffer,E)}writeUInt32BE(E,M){D(this.buffer,E,M)}readUInt32LE(E){return h(this.buffer,E)}writeUInt32LE(E,M){d(this.buffer,E,M)}readUInt8(E){return b(this.buffer,E)}writeUInt8(E,M){O(this.buffer,E,M)}}t.VSBuffer=u;function R(g,E){return g[E+0]<<0>>>0|g[E+1]<<8>>>0}t.readUInt16LE=R;function v(g,E,M){g[M+0]=E&255,E=E>>>8,g[M+1]=E&255}t.writeUInt16LE=v;function y(g,E){return g[E]*2**24+g[E+1]*2**16+g[E+2]*2**8+g[E+3]}t.readUInt32BE=y;function D(g,E,M){g[M+3]=E,E=E>>>8,g[M+2]=E,E=E>>>8,g[M+1]=E,E=E>>>8,g[M]=E}t.writeUInt32BE=D;function h(g,E){return g[E+0]<<0>>>0|g[E+1]<<8>>>0|g[E+2]<<16>>>0|g[E+3]<<24>>>0}t.readUInt32LE=h;function d(g,E,M){g[M+0]=E&255,E=E>>>8,g[M+1]=E&255,E=E>>>8,g[M+2]=E&255,E=E>>>8,g[M+3]=E&255}t.writeUInt32LE=d;function b(g,E){return g[E]}t.readUInt8=b;function O(g,E,M){g[M]=E}t.writeUInt8=O;function C(g){return T.consumeReadable(g,E=>u.concat(E))}t.readableToBuffer=C;function m(g){return T.toReadable(g)}t.bufferToReadable=m;function s(g){return T.consumeStream(g,E=>u.concat(E))}t.streamToBuffer=s;async function r(g){return g.ended?u.concat(g.buffer):u.concat([...g.buffer,await s(g.stream)])}t.bufferedStreamToBuffer=r;function e(g){return T.toStream(g,E=>u.concat(E))}t.bufferToStream=e;function i(g){return T.transform(g,{data:E=>typeof E=="string"?u.fromString(E):u.wrap(E)},E=>u.concat(E))}t.streamToBufferReadableStream=i;function n(g){return T.newWriteableStream(E=>u.concat(E),g)}t.newWriteableBufferStream=n;function o(g,E){return T.prefixedReadable(g,E,M=>u.concat(M))}t.prefixedBufferReadable=o;function c(g,E){return T.prefixedStream(g,E,M=>u.concat(M))}t.prefixedBufferStream=c}),define(Q[21],Z([0,1,11]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function T(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const b=Array.isArray(d)?[]:{};return Object.keys(d).forEach(O=>{d[O]&&typeof d[O]=="object"?b[O]=T(d[O]):b[O]=d[O]}),b}t.deepClone=T;function I(d){if(!d||typeof d!="object")return d;const b=[d];for(;b.length>0;){const O=b.shift();Object.freeze(O);for(const C in O)if(w.call(O,C)){const m=O[C];typeof m=="object"&&!Object.isFrozen(m)&&b.push(m)}}return d}t.deepFreeze=I;const w=Object.prototype.hasOwnProperty;function F(d,b){return L(d,b,new Set)}t.cloneAndChange=F;function L(d,b,O){if((0,p.isUndefinedOrNull)(d))return d;const C=b(d);if(typeof C!="undefined")return C;if((0,p.isArray)(d)){const m=[];for(const s of d)m.push(L(s,b,O));return m}if((0,p.isObject)(d)){if(O.has(d))throw new Error("Cannot clone recursive data-structure");O.add(d);const m={};for(let s in d)w.call(d,s)&&(m[s]=L(d[s],b,O));return O.delete(d),m}return d}function f(d,b,O=!0){return(0,p.isObject)(d)?((0,p.isObject)(b)&&Object.keys(b).forEach(C=>{C in d?O&&((0,p.isObject)(d[C])&&(0,p.isObject)(b[C])?f(d[C],b[C],O):d[C]=b[C]):d[C]=b[C]}),d):b}t.mixin=f;function u(d,b){if(d===b)return!0;if(d==null||b===null||b===void 0||typeof d!=typeof b||typeof d!="object"||Array.isArray(d)!==Array.isArray(b))return!1;let O,C;if(Array.isArray(d)){if(d.length!==b.length)return!1;for(O=0;O<d.length;O++)if(!u(d[O],b[O]))return!1}else{const m=[];for(C in d)m.push(C);m.sort();const s=[];for(C in b)s.push(C);if(s.sort(),!u(m,s))return!1;for(O=0;O<m.length;O++)if(!u(d[m[O]],b[m[O]]))return!1}return!0}t.equals=u;function R(d){const b=new Set;return JSON.stringify(d,(O,C)=>{if((0,p.isObject)(C)||Array.isArray(C)){if(b.has(C))return"[Circular]";b.add(C)}return C})}t.safeStringify=R;function v(d,b,O){const C=b(d);return typeof C=="undefined"?O:C}t.getOrDefault=v;function y(d,b){const O=Object.create(null);return!d||!b||Object.keys(b).forEach(m=>{const s=d[m],r=b[m];u(s,r)||(O[m]=r)}),O}t.distinct=y;function D(d,b){const O=b.toLowerCase(),C=Object.keys(d).find(m=>m.toLowerCase()===O);return C?d[C]:d[b]}t.getCaseInsensitive=D;function h(d,b){const O=Object.create(null);for(const C of Object.keys(d))b(C,d[C])&&(O[C]=d[C]);return O}t.filter=h}),define(Q[59],Z([0,1,7]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function T(u){const R=u;return R&&typeof R.type=="string"&&typeof R.severity=="string"}t.isRemoteConsoleLog=T;function I(u){const R=[];let v;try{const y=JSON.parse(u.arguments),D=y[y.length-1];D&&D.__$stack&&(y.pop(),v=D.__$stack),R.push(...y)}catch(y){R.push("Unable to log remote console arguments",u.arguments)}return{args:R,stack:v}}t.parse=I;function w(u){if(typeof u!="string")return w(I(u).stack);const R=u;if(R){const v=F(R),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(y&&y.length===4)return{uri:p.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}t.getFirstFrame=w;function F(u){if(!u)return u;const R=u.indexOf(`
`);return R===-1?u:u.substring(0,R)}function L(u,R){const{args:v,stack:y}=I(u),D=typeof v[0]=="string"&&v.length===1;let h=F(y);h&&(h=`(${h.trim()})`);let d=[];if(typeof v[0]=="string"?h&&D?d=[`%c[${R}] %c${v[0]} %c${h}`,f("blue"),f(""),f("grey")]:d=[`%c[${R}] %c${v[0]}`,f("blue"),f(""),...v.slice(1)]:d=[`%c[${R}]%`,f("blue"),...v],h&&!D&&d.push(h),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,d)}t.log=L;function f(u){return`color: ${u}`}}),define(Q[60],Z([0,1,16,20,7]),function($,t,p,T,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function w(u){return JSON.stringify(u,L)}t.stringify=w;function F(u){let R=JSON.parse(u);return R=f(R),R}t.parse=F;function L(u,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,T.regExpFlags)(R)}:R}function f(u,R=0){if(!u||R>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return I.URI.revive(u);case 2:return new RegExp(u.source,u.flags)}if(u instanceof p.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let v=0;v<u.length;++v)u[v]=f(u[v],R+1);else for(const v in u)Object.hasOwnProperty.call(u,v)&&(u[v]=f(u[v],R+1))}return u}t.revive=f}),define(Q[61],Z([0,1,20,36,3,44,4]),function($,t,p,T,I,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function L(){return Object.create(null)}t.getEmptyExpression=L;const f="**",u="/",R="[/\\\\]",v="[^/\\\\]",y=/\//g;function D(l){switch(l){case 0:return"";case 1:return`${v}*?`;default:return`(?:${R}|${v}+${R}|${R}${v}+)*?`}}function h(l,P){if(!l)return[];const S=[];let A=!1,j=!1,B="";for(const _ of l){switch(_){case P:if(!A&&!j){S.push(B),B="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":j=!0;break;case"]":j=!1;break}B+=_}return B&&S.push(B),S}t.splitGlobAware=h;function d(l){if(!l)return"";let P="";const S=h(l,u);if(S.every(A=>A===f))P=".*";else{let A=!1;S.forEach((j,B)=>{if(j===f){A||(P+=D(2),A=!0);return}let _=!1,q="",J=!1,Y="";for(const ne of j){if(ne!=="}"&&_){q+=ne;continue}if(J&&(ne!=="]"||!Y)){let re;ne==="-"?re=ne:(ne==="^"||ne==="!")&&!Y?re="^":ne===u?re="":re=p.escapeRegExpCharacters(ne),Y+=re;continue}switch(ne){case"{":_=!0;continue;case"[":J=!0;continue;case"}":P+=`(?:${h(q,",").map(me=>d(me)).join("|")})`,_=!1,q="";break;case"]":P+="["+Y+"]",J=!1,Y="";break;case"?":P+=v;continue;case"*":P+=D(1);continue;default:P+=p.escapeRegExpCharacters(ne)}}B<S.length-1&&(S[B+1]!==f||B+2<S.length)&&(P+=R),A=!1})}return P}const b=/^\*\*\/\*\.[\w\.-]+$/,O=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new w.LRUCache(1e4),i=function(){return!1},n=function(){return null};function o(l,P){if(!l)return n;let S;typeof l!="string"?S=l.pattern:S=l,S=S.trim();const A=`${S}_${!!P.trimForExclusions}`;let j=e.get(A);if(j)return c(j,l);let B;if(b.test(S)){const _=S.substr(4);j=function(q,J){return typeof q=="string"&&q.endsWith(_)?S:null}}else(B=O.exec(g(S,P)))?j=E(B[1],S):(P.trimForExclusions?m:C).test(S)?j=M(S,P):(B=s.exec(g(S,P)))?j=N(B[1].substr(1),S,!0):(B=r.exec(g(S,P)))?j=N(B[1],S,!1):j=k(S);return e.set(A,j),c(j,l)}function c(l,P){return typeof P=="string"?l:function(S,A){return T.isEqualOrParent(S,P.base)?l(I.relative(P.base,S),A):null}}function g(l,P){return P.trimForExclusions&&l.endsWith("/**")?l.substr(0,l.length-2):l}function E(l,P){const S=`/${l}`,A=`\\${l}`,j=function(_,q){return typeof _!="string"?null:q?q===l?P:null:_===l||_.endsWith(S)||_.endsWith(A)?P:null},B=[l];return j.basenames=B,j.patterns=[P],j.allBasenames=B,j}function M(l,P){const S=a(l.slice(1,-1).split(",").map(q=>o(q,P)).filter(q=>q!==n),l),A=S.length;if(!A)return n;if(A===1)return S[0];const j=function(q,J){for(let Y=0,ne=S.length;Y<ne;Y++)if(S[Y](q,J))return l;return null},B=S.find(q=>!!q.allBasenames);B&&(j.allBasenames=B.allBasenames);const _=S.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return _.length&&(j.allPaths=_),j}function N(l,P,S){const A=I.sep===I.posix.sep,j=A?l:l.replace(y,I.sep),B=I.sep+j,_=I.posix.sep+l,q=S?function(J,Y){return typeof J=="string"&&(J===j||J.endsWith(B)||!A&&(J===l||J.endsWith(_)))?P:null}:function(J,Y){return typeof J=="string"&&(J===j||!A&&J===l)?P:null};return q.allPaths=[(S?"*/":"./")+l],q}function k(l){try{const P=new RegExp(`^${d(l)}$`);return function(S){return P.lastIndex=0,typeof S=="string"&&P.test(S)?l:null}}catch(P){return n}}function U(l,P,S){return!l||typeof P!="string"?!1:x(l)(P,void 0,S)}t.match=U;function x(l,P={}){if(!l)return i;if(typeof l=="string"||te(l)){const S=o(l,P);if(S===n)return i;const A=function(j,B){return!!S(j,B)};return S.allBasenames&&(A.allBasenames=S.allBasenames),S.allPaths&&(A.allPaths=S.allPaths),A}return G(l,P)}t.parse=x;function X(l){if(!!l){let P;return S=>(P||(P=(l()||Promise.resolve([])).then(A=>A?ee(A):{})),P.then(A=>!!A[S]))}}t.hasSiblingPromiseFn=X;function ie(l){if(!!l){let P;return S=>{if(!P){const A=l();P=A?ee(A):{}}return!!P[S]}}}t.hasSiblingFn=ie;function ee(l){const P={};for(const S of l)P[S]=!0;return P}function te(l){const P=l;return P&&typeof P.base=="string"&&typeof P.pattern=="string"}t.isRelativePattern=te;function ae(l){return l.allBasenames||[]}t.getBasenameTerms=ae;function W(l){return l.allPaths||[]}t.getPathTerms=W;function G(l,P){const S=a(Object.getOwnPropertyNames(l).map(q=>V(q,l[q],P)).filter(q=>q!==n)),A=S.length;if(!A)return n;if(!S.some(q=>!!q.requiresSiblings)){if(A===1)return S[0];const q=function(ne,re){for(let he=0,me=S.length;he<me;he++){const De=S[he](ne,re);if(De)return De}return null},J=S.find(ne=>!!ne.allBasenames);J&&(q.allBasenames=J.allBasenames);const Y=S.reduce((ne,re)=>re.allPaths?ne.concat(re.allPaths):ne,[]);return Y.length&&(q.allPaths=Y),q}const j=function(q,J,Y){let ne;for(let re=0,he=S.length;re<he;re++){const me=S[re];me.requiresSiblings&&Y&&(J||(J=I.basename(q)),ne||(ne=J.substr(0,J.length-I.extname(q).length)));const De=me(q,J,ne,Y);if(De)return De}return null},B=S.find(q=>!!q.allBasenames);B&&(j.allBasenames=B.allBasenames);const _=S.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return _.length&&(j.allPaths=_),j}function V(l,P,S){if(P===!1)return n;const A=o(l,S);if(A===n)return n;if(typeof P=="boolean")return A;if(P){const j=P.when;if(typeof j=="string"){const B=(_,q,J,Y)=>{if(!Y||!A(_,q))return null;const ne=j.replace("$(basename)",J),re=Y(ne);return(0,F.isThenable)(re)?re.then(he=>he?l:null):re?l:null};return B.requiresSiblings=!0,B}}return A}function a(l,P){const S=l.filter(q=>!!q.basenames);if(S.length<2)return l;const A=S.reduce((q,J)=>{const Y=J.basenames;return Y?q.concat(Y):q},[]);let j;if(P){j=[];for(let q=0,J=A.length;q<J;q++)j.push(P)}else j=S.reduce((q,J)=>{const Y=J.patterns;return Y?q.concat(Y):q},[]);const B=function(q,J){if(typeof q!="string")return null;if(!J){let ne;for(ne=q.length;ne>0;ne--){const re=q.charCodeAt(ne-1);if(re===47||re===92)break}J=q.substr(ne)}const Y=A.indexOf(J);return Y!==-1?j[Y]:null};B.basenames=A,B.patterns=j,B.allBasenames=A;const _=l.filter(q=>!q.basenames);return _.push(B),_}}),define(Q[62],Z([0,1,7,3,20,8,13,17,36]),function($,t,p,T,I,w,F,L,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function u(o,c,g){if(typeof o=="string"&&(o=p.URI.file(o)),g){const M=g.getWorkspaceFolder(o);if(M){const N=g.getWorkspace().folders.length>1;let k;if((0,L.isEqual)(M.uri,o)?k="":k=(0,L.relativePath)(M.uri,o),N){const U=M.name?M.name:(0,L.basename)(M.uri);k=k?U+" \u2022 "+k:U}return k}}if(o.scheme!==w.Schemas.file&&o.scheme!==w.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(o.fsPath))return(0,T.normalize)(v(o.fsPath));let E=(0,T.normalize)(o.fsPath);return!F.isWindows&&(c==null?void 0:c.userHome)&&(E=D(E,c.userHome.fsPath)),E}t.getPathLabel=u;function R(o){if(!!o){typeof o=="string"&&(o=p.URI.file(o));const c=(0,L.basename)(o)||(o.scheme===w.Schemas.file?o.fsPath:o.path);return F.isWindows&&(0,f.isRootOrDriveLetter)(c)?v(c):c}}t.getBaseLabel=R;function v(o){return(0,f.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}t.normalizeDriveLetter=v;let y=Object.create(null);function D(o,c){if(F.isWindows||!o||!c)return o;let g=y.original===c?y.normalized:void 0;return g||(g=`${(0,I.rtrim)(c,T.posix.sep)}${T.posix.sep}`,y={original:c,normalized:g}),(F.isLinux?o.startsWith(g):(0,I.startsWithIgnoreCase)(o,g))&&(o=`~/${o.substr(g.length)}`),o}t.tildify=D;function h(o,c){return o.replace(/^~($|\/|\\)/,`${c}$1`)}t.untildify=h;const d="\u2026",b="\\\\",O="~";function C(o,c=T.sep){const g=new Array(o.length);let E=!1;for(let M=0;M<o.length;M++){let N=o[M];if(N===""){g[M]=`.${c}`;continue}if(!N){g[M]=N;continue}E=!0;let k="";N.indexOf(b)===0?(k=N.substr(0,N.indexOf(b)+b.length),N=N.substr(N.indexOf(b)+b.length)):N.indexOf(c)===0?(k=N.substr(0,N.indexOf(c)+c.length),N=N.substr(N.indexOf(c)+c.length)):N.indexOf(O)===0&&(k=N.substr(0,N.indexOf(O)+O.length),N=N.substr(N.indexOf(O)+O.length));const U=N.split(c);for(let x=1;E&&x<=U.length;x++)for(let X=U.length-x;E&&X>=0;X--){E=!1;let ie=U.slice(X,X+x).join(c);for(let ee=0;!E&&ee<o.length;ee++)if(ee!==M&&o[ee]&&o[ee].indexOf(ie)>-1){const te=X+x===U.length,ae=X>0&&o[ee].indexOf(c)>-1?c+ie:ie,W=o[ee].endsWith(ae);E=!te||W}if(!E){let ee="";(U[0].endsWith(":")||k!=="")&&(X===1&&(X=0,x++,ie=U[0]+c+ie),X>0&&(ee=U[0]+c),ee=k+ee),X>0&&(ee=ee+d+c),ee=ee+ie,X+x<U.length&&(ee=ee+c+d),g[M]=ee}}E&&(g[M]=N)}return g}t.shorten=C;var m;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function s(o,c=Object.create(null)){const g=[];let E=!1,M="";for(const N of o)if(N==="$"||E&&N==="{")M&&g.push({value:M,type:m.TEXT}),M="",E=!0;else if(N==="}"&&E){const k=c[M];if(typeof k=="string")k.length&&g.push({value:k,type:m.VARIABLE});else if(k){const U=g[g.length-1];(!U||U.type!==m.SEPARATOR)&&g.push({value:k.label,type:m.SEPARATOR})}M="",E=!1}else M+=N;return M&&!E&&g.push({value:M,type:m.TEXT}),g.filter((N,k)=>{if(N.type===m.SEPARATOR){const U=g[k-1],x=g[k+1];return[U,x].every(X=>X&&(X.type===m.VARIABLE||X.type===m.TEXT)&&X.value.length>0)}return!0}).map(N=>N.value).join("")}t.template=s;function r(o,c){return F.isMacintosh||c?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):o.replace(/&&|&/g,g=>g==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(o,c){return F.isMacintosh||c?o.replace(/\(&&\w\)|&&/g,""):F.isWindows?o.replace(/&&|&/g,g=>g==="&"?"&&":"&"):o.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(o){return o.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(o){const c=o.indexOf("/")!==-1?T.posix:T.win32,g=c.basename(o),E=c.dirname(o);return g.length?{name:g,parentPath:E}:{name:E,parentPath:""}}t.splitName=n}),define(Q[45],Z([0,1,125]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class T{constructor(w="utf8"){this.stringDecoder=new p.StringDecoder(w),this.remaining=null}write(w){const F=[],L=this.remaining?this.remaining+this.stringDecoder.write(w):this.stringDecoder.write(w);if(L.length<1)return F;let f=0,u,R=f;for(;R<L.length;)if(u=L.charCodeAt(R),u===13||u===10){if(F.push(L.substring(f,R)),R++,R<L.length){const v=u;u=L.charCodeAt(R),(v===13&&u===10||v===10&&u===13)&&R++}f=R}else R++;return this.remaining=f<L.length?L.substr(f):null,F}end(){return this.remaining}}t.LineDecoder=T}),define(Q[63],Z([0,1,18,64,20,3,14]),function($,t,p,T,I,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function L(v){const y=(0,w.dirname)(v);if(v===y)return v;const D=((0,w.basename)(v)||v).toLowerCase();try{const d=(0,F.readdirSync)(y).filter(b=>b.toLowerCase()===D);if(d.length===1){const b=L(y);if(b)return(0,w.join)(b,d[0])}else if(d.length>1){const b=d.indexOf(D);if(b>=0){const O=L(y);if(O)return(0,w.join)(O,d[b])}}}catch(h){}return null}t.realcaseSync=L;async function f(v){try{return await(0,T.promisify)(p.realpath)(v)}catch(y){const D=R(v);return await p.promises.access(D,p.constants.R_OK),D}}t.realpath=f;function u(v){try{return p.realpathSync(v)}catch(y){const D=R(v);return p.accessSync(D,p.constants.R_OK),D}}t.realpathSync=u;function R(v){return(0,I.rtrim)((0,w.normalize)(v),w.sep)}});var ye=this&&this.__await||function($){return this instanceof ye?(this.v=$,this):new ye($)},Ve=this&&this.__asyncGenerator||function($,t,p){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var T=p.apply($,t||[]),I,w=[];return I={},F("next"),F("throw"),F("return"),I[Symbol.asyncIterator]=function(){return this},I;function F(y){T[y]&&(I[y]=function(D){return new Promise(function(h,d){w.push([y,D,h,d])>1||L(y,D)})})}function L(y,D){try{f(T[y](D))}catch(h){v(w[0][3],h)}}function f(y){y.value instanceof ye?Promise.resolve(y.value.v).then(u,R):v(w[0][2],y)}function u(y){L("next",y)}function R(y){L("throw",y)}function v(y,D){y(D),w.shift(),w.length&&L(w[0][0],w[0][1])}},Be=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=$[Symbol.asyncIterator],p;return t?t.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),p={},T("next"),T("throw"),T("return"),p[Symbol.asyncIterator]=function(){return this},p);function T(w){p[w]=$[w]&&function(F){return new Promise(function(L,f){F=$[w](F),I(L,f,F.done,F.value)})}}function I(w,F,L,f){Promise.resolve(f).then(function(u){w({value:u,done:L})},F)}};define(Q[65],Z([0,1,14,32,3]),function($,t,p,T,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const w=/^\d+$/,F=/^Microsoft.PowerShell_.*/,L=/^Microsoft.PowerShellPreview_.*/;var f;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(f||(f={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class v{constructor(r,e,i){this.exePath=r,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:s=!1}={}){return s?u===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function D({useAlternateBitness:s=!1,findPreview:r=!1}={}){const e=y({useAlternateBitness:s});if(!e)return null;const i=I.join(e,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(i))return null;let n=-1,o=null;for(const E of await p.readdir(i)){let M=-1;if(r){const k=E.indexOf("-");if(k<0)continue;const U=E.substring(0,k);if(!w.test(U)||E.substring(k+1)!=="preview")continue;M=parseInt(U,10)}else{if(!w.test(E))continue;M=parseInt(E,10)}if(!(M<=n)){const N=I.join(i,E,"pwsh.exe");!await p.SymlinkSupport.existsFile(N)||(o=N,n=M)}}if(!o)return null;const c=e.includes("x86")?" (x86)":"",g=r?" Preview":"";return new v(o,`PowerShell${g}${c}`,!0)}async function h({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const r=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=s?{pwshMsixDirRegex:L,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:F,pwshMsixName:"PowerShell (Store)"};for(const n of await p.readdir(r))if(e.test(n)){const o=I.join(r,n,"pwsh.exe");return new v(o,i)}return null}function d(){const s=I.join(T.homedir(),".dotnet","tools","pwsh.exe");return new v(s,".NET Core PowerShell Global Tool")}function b(){const s=I.join(process.env.windir,u===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(s,"Windows PowerShell",!0)}function O(){return Ve(this,arguments,function*(){let r=yield ye(D());r&&(yield yield ye(r)),r=yield ye(D({useAlternateBitness:!0})),r&&(yield yield ye(r)),r=yield ye(h()),r&&(yield yield ye(r)),r=d(),r&&(yield yield ye(r)),r=yield ye(D({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(h({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(D({useAlternateBitness:!0,findPreview:!0})),r&&(yield yield ye(r)),r=b(),r&&(yield yield ye(r))})}function C(){return Ve(this,arguments,function*(){var r,e;try{for(var i=Be(O()),n;n=yield ye(i.next()),!n.done;){const o=n.value;(yield ye(o.exists()))&&(yield yield ye(o))}}catch(o){r={error:o}}finally{try{n&&!n.done&&(e=i.return)&&(yield ye(e.call(i)))}finally{if(r)throw r.error}}})}t.enumeratePowerShellInstallations=C;async function m(){var s,r;try{for(var e=Be(C()),i;i=await e.next(),!i.done;)return i.value}catch(n){s={error:n}}finally{try{i&&!i.done&&(r=e.return)&&await r.call(e)}finally{if(s)throw s.error}}return null}t.getFirstAvailablePowerShellInstallation=m}),define(Q[66],Z([0,1,3,18,13,126,2,14]),function($,t,p,T,I,w,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function f(v,y,D){return R({path:v,isDirectory:!1},y,D)}t.watchFile=f;function u(v,y,D){return R({path:v,isDirectory:!0},y,D)}t.watchFolder=u,t.CHANGE_BUFFER_DELAY=100;function R(v,y,D){const h=(0,p.basename)(v.path),d=new Map;let b=!1,O=[(0,F.toDisposable)(()=>{d.forEach(C=>(0,F.dispose)(C)),d.clear()})];try{const C=(0,T.watch)(v.path);O.push((0,F.toDisposable)(()=>{C.removeAllListeners(),C.close()}));const m=new Set;v.isDirectory&&(0,L.readdir)(v.path).then(s=>s.forEach(r=>m.add(r))),C.on("error",(s,r)=>{b||D(`Failed to watch ${v.path} for changes using fs.watch() (${s}, ${r})`)}),C.on("change",(s,r)=>{if(!b){let e="";if(r&&(e=r.toString(),I.isMacintosh&&(e=(0,w.normalizeNFC)(e))),!(!e||s!=="change"&&s!=="rename")){const i=v.isDirectory?(0,p.join)(v.path,e):v.path;if(v.isDirectory)if(s==="rename"){const n=d.get(i);n&&(0,F.dispose)(n);const o=setTimeout(async()=>{d.delete(i);const c=await(0,L.exists)(i);if(!b){let g;c?m.has(e)?g="changed":(g="added",m.add(e)):(m.delete(e),g="deleted"),y(g,i)}},t.CHANGE_BUFFER_DELAY);d.set(i,(0,F.toDisposable)(()=>clearTimeout(o)))}else{let n;m.has(e)?n="changed":(n="added",m.add(e)),y(n,i)}else if(s==="rename"||e!==h){const n=setTimeout(async()=>{const o=await(0,L.exists)(i);b||(o?(y("changed",i),O=[R(v,y,D)]):y("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,F.dispose)(O),O=[(0,F.toDisposable)(()=>clearTimeout(n))]}else y("changed",i)}}})}catch(C){(0,L.exists)(v.path).then(m=>{m&&!b&&D(`Failed to watch ${v.path} for changes using fs.watch() (${C.toString()})`)})}return(0,F.toDisposable)(()=>{b=!0,O=(0,F.dispose)(O)})}}),define(Q[37],Z([0,1,9,2,4,28,12,16,23,11,60,20]),function($,t,p,T,I,w,F,L,f,u,R,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var y;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(y=t.RequestType||(t.RequestType={}));function D(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(h=t.ResponseType||(t.ResponseType={}));function d(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(b||(b={}));class O{constructor(a){this.buffer=a,this.pos=0}read(a){const l=this.buffer.slice(this.pos,this.pos+a);return this.pos+=l.byteLength,l}}class C{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(a){this.buffers.push(a)}}var m;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(m||(m={}));function s(V){const a=L.VSBuffer.alloc(4);return a.writeUInt32BE(V,0),a}function r(V){return V.read(4).readUInt32BE(0)}function e(V){const a=L.VSBuffer.alloc(1);return a.writeUInt8(V,0),a}const i={Undefined:e(m.Undefined),String:e(m.String),Buffer:e(m.Buffer),VSBuffer:e(m.VSBuffer),Array:e(m.Array),Object:e(m.Object)},n=typeof Buffer!="undefined";function o(V,a){if(typeof a=="undefined")V.write(i.Undefined);else if(typeof a=="string"){const l=L.VSBuffer.fromString(a);V.write(i.String),V.write(s(l.byteLength)),V.write(l)}else if(n&&Buffer.isBuffer(a)){const l=L.VSBuffer.wrap(a);V.write(i.Buffer),V.write(s(l.byteLength)),V.write(l)}else if(a instanceof L.VSBuffer)V.write(i.VSBuffer),V.write(s(a.byteLength)),V.write(a);else if(Array.isArray(a)){V.write(i.Array),V.write(s(a.length));for(const l of a)o(V,l)}else{const l=L.VSBuffer.fromString(JSON.stringify(a));V.write(i.Object),V.write(s(l.byteLength)),V.write(l)}}function c(V){switch(V.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return V.read(r(V)).toString();case m.Buffer:return V.read(r(V)).buffer;case m.VSBuffer:return V.read(r(V));case m.Array:{const l=r(V),P=[];for(let S=0;S<l;S++)P.push(c(V));return P}case m.Object:return JSON.parse(V.read(r(V)).toString())}}class g{constructor(a,l,P=null,S=1e3){this.protocol=a,this.ctx=l,this.logger=P,this.timeoutDelay=S,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(a,l){this.channels.set(a,l),setTimeout(()=>this.flushPendingRequests(a),0)}sendResponse(a){switch(a.type){case 200:{const l=this.send([a.type]);this.logger&&this.logger.logOutgoing(l,0,1,d(a.type));return}case 201:case 202:case 204:case 203:{const l=this.send([a.type,a.id],a.data);this.logger&&this.logger.logOutgoing(l,a.id,1,d(a.type),a.data);return}}}send(a,l=void 0){const P=new C;return o(P,a),o(P,l),this.sendBuffer(P.buffer)}sendBuffer(a){try{return this.protocol.send(a),a.byteLength}catch(l){return 0}}onRawMessage(a){const l=new O(a),P=c(l),S=c(l),A=P[0];switch(A){case 100:return this.logger&&this.logger.logIncoming(a.byteLength,P[1],1,`${D(A)}: ${P[2]}.${P[3]}`,S),this.onPromise({type:A,id:P[1],channelName:P[2],name:P[3],arg:S});case 102:return this.logger&&this.logger.logIncoming(a.byteLength,P[1],1,`${D(A)}: ${P[2]}.${P[3]}`,S),this.onEventListen({type:A,id:P[1],channelName:P[2],name:P[3],arg:S});case 101:return this.logger&&this.logger.logIncoming(a.byteLength,P[1],1,`${D(A)}`),this.disposeActiveRequest({type:A,id:P[1]});case 103:return this.logger&&this.logger.logIncoming(a.byteLength,P[1],1,`${D(A)}`),this.disposeActiveRequest({type:A,id:P[1]})}}onPromise(a){const l=this.channels.get(a.channelName);if(!l){this.collectPendingRequest(a);return}const P=new w.CancellationTokenSource;let S;try{S=l.call(this.ctx,a.name,a.arg,P.token)}catch(B){S=Promise.reject(B)}const A=a.id;S.then(B=>{this.sendResponse({id:A,data:B,type:201}),this.activeRequests.delete(a.id)},B=>{B instanceof Error?this.sendResponse({id:A,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:A,data:B,type:203}),this.activeRequests.delete(a.id)});const j=(0,T.toDisposable)(()=>P.cancel());this.activeRequests.set(a.id,j)}onEventListen(a){const l=this.channels.get(a.channelName);if(!l){this.collectPendingRequest(a);return}const P=a.id,A=l.listen(this.ctx,a.name,a.arg)(j=>this.sendResponse({id:P,data:j,type:204}));this.activeRequests.set(a.id,A)}disposeActiveRequest(a){const l=this.activeRequests.get(a.id);l&&(l.dispose(),this.activeRequests.delete(a.id))}collectPendingRequest(a){let l=this.pendingRequests.get(a.channelName);l||(l=[],this.pendingRequests.set(a.channelName,l));const P=setTimeout(()=>{console.error(`Unknown channel: ${a.channelName}`),a.type===100&&this.sendResponse({id:a.id,data:{name:"Unknown channel",message:`Channel name '${a.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);l.push({request:a,timeoutTimer:P})}flushPendingRequests(a){const l=this.pendingRequests.get(a);if(l){for(const P of l)switch(clearTimeout(P.timeoutTimer),P.request.type){case 100:this.onPromise(P.request);break;case 102:this.onEventListen(P.request);break}this.pendingRequests.delete(a)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(a=>a.dispose()),this.activeRequests.clear()}}t.ChannelServer=g;var E;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(E=t.RequestInitiator||(t.RequestInitiator={}));class M{constructor(a,l=null){this.protocol=a,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(P=>this.onBuffer(P)),this.logger=l}getChannel(a){const l=this;return{call(P,S,A){return l.isDisposed?Promise.reject(F.canceled()):l.requestPromise(a,P,S,A)},listen(P,S){return l.isDisposed?Promise.reject(F.canceled()):l.requestEvent(a,P,S)}}}requestPromise(a,l,P,S=w.CancellationToken.None){const A=this.lastRequestId++,B={id:A,type:100,channelName:a,name:l,arg:P};if(S.isCancellationRequested)return Promise.reject(F.canceled());let _;return new Promise((J,Y)=>{if(S.isCancellationRequested)return Y(F.canceled());const ne=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(A),J(Oe.data);break;case 202:this.handlers.delete(A);const Fe=new Error(Oe.data.message);Fe.stack=Oe.data.stack,Fe.name=Oe.data.name,Y(Fe);break;case 203:this.handlers.delete(A),Y(Oe.data);break}};this.handlers.set(A,De),this.sendRequest(B)};let re=null;this.state===b.Idle?ne():(re=(0,I.createCancelablePromise)(De=>this.whenInitialized()),re.then(()=>{re=null,ne()}));const he=()=>{re?(re.cancel(),re=null):this.sendRequest({id:A,type:101}),Y(F.canceled())},me=S.onCancellationRequested(he);_=(0,T.combinedDisposable)((0,T.toDisposable)(he),me),this.activeRequests.add(_)}).finally(()=>{this.activeRequests.delete(_)})}requestEvent(a,l,P){const S=this.lastRequestId++,j={id:S,type:102,channelName:a,name:l,arg:P};let B=null;const _=new p.Emitter({onFirstListenerAdd:()=>{B=(0,I.createCancelablePromise)(J=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add(_),this.sendRequest(j)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete(_),this.sendRequest({id:S,type:103}))}}),q=J=>_.fire(J.data);return this.handlers.set(S,q),_.event}sendRequest(a){switch(a.type){case 100:case 102:{const l=this.send([a.type,a.id,a.channelName,a.name],a.arg);this.logger&&this.logger.logOutgoing(l,a.id,0,`${D(a.type)}: ${a.channelName}.${a.name}`,a.arg);return}case 101:case 103:{const l=this.send([a.type,a.id]);this.logger&&this.logger.logOutgoing(l,a.id,0,D(a.type));return}}}send(a,l=void 0){const P=new C;return o(P,a),o(P,l),this.sendBuffer(P.buffer)}sendBuffer(a){try{return this.protocol.send(a),a.byteLength}catch(l){return 0}}onBuffer(a){const l=new O(a),P=c(l),S=c(l),A=P[0];switch(A){case 200:return this.logger&&this.logger.logIncoming(a.byteLength,0,0,d(A)),this.onResponse({type:P[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(a.byteLength,P[1],0,d(A),S),this.onResponse({type:P[0],id:P[1],data:S})}}onResponse(a){if(a.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const l=this.handlers.get(a.id);l&&l(a)}whenInitialized(){return this.state===b.Idle?Promise.resolve():p.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(a=>a.dispose()),this.activeRequests.clear()}}t.ChannelClient=M;class N{constructor(a){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,a(({protocol:l,onDidClientDisconnect:P})=>{p.Event.once(l.onMessage)(A=>{const j=new O(A),B=c(j),_=new g(l,B),q=new M(l);this.channels.forEach((Y,ne)=>_.registerChannel(ne,Y));const J={channelServer:_,channelClient:q,ctx:B};this._connections.add(J),this._onDidAddConnection.fire(J),P(()=>{_.dispose(),q.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const a=[];return this._connections.forEach(l=>a.push(l)),a}getChannel(a,l){const P=this;return{call(S,A,j){let B;if((0,u.isFunction)(l)){let q=(0,f.getRandomElement)(P.connections.filter(l));B=q?Promise.resolve(q):p.Event.toPromise(p.Event.filter(P.onDidAddConnection,l))}else B=l.routeCall(P,S,A);const _=B.then(q=>q.channelClient.getChannel(a));return U(_).call(S,A,j)},listen(S,A){if((0,u.isFunction)(l))return P.getMulticastEvent(a,l,S,A);const j=l.routeEvent(P,S,A).then(B=>B.channelClient.getChannel(a));return U(j).listen(S,A)}}}getMulticastEvent(a,l,P,S){const A=this;let j=new T.DisposableStore;const B=new p.Emitter({onFirstListenerAdd:()=>{j=new T.DisposableStore;const _=new p.EventMultiplexer,q=new Map,J=ne=>{const he=ne.channelClient.getChannel(a).listen(P,S),me=_.add(he);q.set(ne,me)},Y=ne=>{const re=q.get(ne);!re||(re.dispose(),q.delete(ne))};A.connections.filter(l).forEach(J),p.Event.filter(A.onDidAddConnection,l)(J,void 0,j),A.onDidRemoveConnection(Y,void 0,j),_.event(B.fire,B,j),j.add(_)},onLastListenerRemove:()=>{j.dispose()}});return B.event}registerChannel(a,l){this.channels.set(a,l),this._connections.forEach(P=>{P.channelServer.registerChannel(a,l)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=N;class k{constructor(a,l,P=null){const S=new C;o(S,l),a.send(S.buffer),this.channelClient=new M(a,P),this.channelServer=new g(a,l,P)}getChannel(a){return this.channelClient.getChannel(a)}registerChannel(a,l){this.channelServer.registerChannel(a,l)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=k;function U(V){return{call(a,l,P){return V.then(S=>S.call(a,l,P))},listen(a,l){const P=new p.Relay;return V.then(S=>P.input=S.listen(a,l)),P.event}}}t.getDelayedChannel=U;function x(V){let a=!1;return{call(l,P,S){return a?V.call(l,P,S):(0,I.timeout)(0).then(()=>a=!0).then(()=>V.call(l,P,S))},listen(l,P){if(a)return V.listen(l,P);const S=new p.Relay;return(0,I.timeout)(0).then(()=>a=!0).then(()=>S.input=V.listen(l,P)),S.event}}}t.getNextTickChannel=x;class X{constructor(a){this.fn=a}routeCall(a){return this.route(a)}routeEvent(a){return this.route(a)}async route(a){for(const l of a.connections)if(await Promise.resolve(this.fn(l.ctx)))return Promise.resolve(l);return await p.Event.toPromise(a.onDidAddConnection),await this.route(a)}}t.StaticRouter=X;var ie;(function(V){function a(S,A){const j=S,B=A&&A.disableMarshalling,_=new Map;for(const q in j)P(q)&&_.set(q,p.Event.buffer(j[q],!0));return new class{listen(q,J){const Y=_.get(J);if(Y)return Y;throw new Error(`Event not found: ${J}`)}call(q,J,Y){const ne=j[J];if(typeof ne=="function"){if(!B&&Array.isArray(Y))for(let re=0;re<Y.length;re++)Y[re]=(0,R.revive)(Y[re]);return ne.apply(j,Y)}throw new Error(`Method not found: ${J}`)}}}V.fromService=a;function l(S,A){const j=A&&A.disableMarshalling;return new Proxy({},{get(B,_){var q;if(typeof _=="string")return((q=A==null?void 0:A.properties)===null||q===void 0?void 0:q.has(_))?A.properties.get(_):P(_)?S.listen(_):async function(...J){let Y;A&&!(0,u.isUndefinedOrNull)(A.context)?Y=[A.context,...J]:Y=J;const ne=await S.call(_,Y);return j?ne:(0,R.revive)(ne)};throw new Error(`Property not found: ${String(_)}`)}})}V.toService=l;function P(S){return S[0]==="o"&&S[1]==="n"&&v.isUpperAsciiLetter(S.charCodeAt(2))}})(ie=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let a=V.toString();if(a!=="[object Object]")return a}return V}function ae(V){return Array.isArray(V)?V.map(te):te(V)}function W(V,a,l,P,S,A,j){j=ae(j);const B=ee[S],_=B[P%B.length];let q=[`%c[${V}]%c[${String(a).padStart(7," ")}]%c[len: ${String(l).padStart(5," ")}]%c${String(P).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(A)?(q=q.concat(j),q.push(")")):q.push(j),console.log.apply(console,q)}t.logWithColors=W;class G{constructor(a,l){this._outgoingPrefix=a,this._incomingPrefix=l,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(a,l,P,S,A){this._totalOutgoing+=a,W(this._outgoingPrefix,this._totalOutgoing,a,l,P,S,A)}logIncoming(a,l,P,S,A){this._totalIncoming+=a,W(this._incomingPrefix,this._totalIncoming,a,l,P,S,A)}}t.IPCLogger=G}),define(Q[67],Z([0,1,2,9,4,11]),function($,t,p,T,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var F;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(F=t.StorageHint||(t.StorageHint={}));var L;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(L||(L={}));class f extends p.Disposable{constructor(v,y=Object.create(null)){super();this.database=v,this.options=y,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){var y,D;(y=v.changed)===null||y===void 0||y.forEach((h,d)=>this.accept(d,h)),(D=v.deleted)===null||D===void 0||D.forEach(h=>this.accept(h,void 0))}accept(v,y){if(this.state!==L.Closed){let D=!1;(0,w.isUndefinedOrNull)(y)?D=this.cache.delete(v):this.cache.get(v)!==y&&(this.cache.set(v,y),D=!0),D&&this._onDidChangeStorage.fire(v)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==F.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,y){const D=this.cache.get(v);return(0,w.isUndefinedOrNull)(D)?y:D}getBoolean(v,y){const D=this.get(v);return(0,w.isUndefinedOrNull)(D)?y:D==="true"}getNumber(v,y){const D=this.get(v);return(0,w.isUndefinedOrNull)(D)?y:parseInt(D,10)}async set(v,y){if(this.state!==L.Closed){if((0,w.isUndefinedOrNull)(y))return this.delete(v);const D=String(y);if(this.cache.get(v)!==D)return this.cache.set(v,D),this.pendingInserts.set(v,D),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(v){if(this.state!==L.Closed&&!!this.cache.delete(v))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(v){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{var y;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(y=this.whenFlushedCallbacks.pop())===null||y===void 0||y()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class u{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((y,D)=>this.items.set(D,y)),v.delete&&v.delete.forEach(y=>this.items.delete(y))}async close(){}}t.InMemoryStorageDatabase=u}),define(Q[68],Z([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(Q[69],Z([0,1,68]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const T=60,I=T*60,w=I*24,F=w*7,L=w*30,f=w*365;function u(v,y){typeof v!="number"&&(v=v.getTime());const D=Math.round((new Date().getTime()-v)/1e3);if(D<-30)return(0,p.localize)(0,null,u(new Date().getTime()+D*1e3,!1));if(D<30)return(0,p.localize)(1,null);let h;return D<T?(h=D,y?h===1?(0,p.localize)(2,null,h):(0,p.localize)(3,null,h):h===1?(0,p.localize)(4,null,h):(0,p.localize)(5,null,h)):D<I?(h=Math.floor(D/T),y?h===1?(0,p.localize)(6,null,h):(0,p.localize)(7,null,h):h===1?(0,p.localize)(8,null,h):(0,p.localize)(9,null,h)):D<w?(h=Math.floor(D/I),y?h===1?(0,p.localize)(10,null,h):(0,p.localize)(11,null,h):h===1?(0,p.localize)(12,null,h):(0,p.localize)(13,null,h)):D<F?(h=Math.floor(D/w),y?h===1?(0,p.localize)(14,null,h):(0,p.localize)(15,null,h):h===1?(0,p.localize)(16,null,h):(0,p.localize)(17,null,h)):D<L?(h=Math.floor(D/F),y?h===1?(0,p.localize)(18,null,h):(0,p.localize)(19,null,h):h===1?(0,p.localize)(20,null,h):(0,p.localize)(21,null,h)):D<f?(h=Math.floor(D/L),y?h===1?(0,p.localize)(22,null,h):(0,p.localize)(23,null,h):h===1?(0,p.localize)(24,null,h):(0,p.localize)(25,null,h)):(h=Math.floor(D/f),y?h===1?(0,p.localize)(26,null,h):(0,p.localize)(27,null,h):h===1?(0,p.localize)(28,null,h):(0,p.localize)(29,null,h))}t.fromNow=u;function R(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=R}),define(Q[70],Z([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Q[29],Z([0,1,70,11,23]),function($,t,p,T,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function w(u,R){return R&&(u.stack||u.stacktrace)?p.localize(0,null,L(u),F(u.stack)||F(u.stacktrace)):L(u)}function F(u){return Array.isArray(u)?u.join(`
`):u}function L(u){return typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?p.localize(1,null,u.message):u.message||p.localize(2,null)}function f(u=null,R=!1){if(!u)return p.localize(3,null);if(Array.isArray(u)){const v=I.coalesce(u),y=f(v[0],R);return v.length>1?p.localize(4,null,y,v.length):y}if(T.isString(u))return u;if(u.detail){const v=u.detail;if(v.error)return w(v.error,R);if(v.exception)return w(v.exception,R)}return u.stack?w(u,R):u.message?u.message:p.localize(5,null)}t.toErrorMessage=f}),define(Q[71],Z([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(Q[46],Z([0,1,3,18,14,33,71,34,11,21,36,13,45,8]),function($,t,p,T,I,w,F,L,f,u,R,v,y,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(r,e){if(v.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};e&&(i.cwd=e);const n=w.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{n.once("error",c=>{o({success:!1,error:c})}),n.once("exit",(c,g)=>{o(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?h(i.status):1})}else if(v.isLinux||v.isMacintosh)try{const i=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(n=>{w.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,c,g)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function b(r=L.env){return r.comspec||"cmd.exe"}t.getWindowsShell=b;class O{constructor(e,i,n,o){if(i!==void 0&&n!==void 0&&o!==void 0)this.cmd=e,this.args=i,this.shell=n,this.options=o;else{const c=e;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(L.env).forEach(g=>{c[g]=L.env[g]}),Object.keys(this.options.env).forEach(g=>{c[g]=this.options.env[g]}),this.options.env=c}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const i=e.lastIndexOf(p.sep);return i!==-1&&(e=e.substring(i+1)),O.WellKnowCommands[e]?e:"other"}start(e){return v.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(L.cwd()))?Promise.reject(new Error(F.localize(0,null))):this.useExec().then(i=>{let n,o;const c=new Promise((g,E)=>{n=g,o=E});if(i){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=w.exec(g,this.options,(E,M,N)=>{this.childProcess=null;const k=E;k&&k.killed?o({killed:this.terminateRequested,stdout:M.toString(),stderr:N.toString()}):this.handleExec(n,e,E,M,N)})}else{let g=null;const E=M=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(M,n,e,o);const N={terminated:this.terminateRequested};f.isNumber(M)&&(N.cmdCode=M),n(N)};if(this.shell&&v.isWindows){const M=u.deepClone(this.options);M.windowsVerbatimArguments=!0,M.detached=!1;let N=!1,k=!1;const U=[];let x=this.ensureQuotes(this.cmd);U.push(x.value),N=x.quoted,this.args&&this.args.forEach(ie=>{x=this.ensureQuotes(ie),U.push(x.value),k=k&&x.quoted});const X=["/s","/c"];N?k?X.push('"'+U.join(" ")+'"'):U.length>1?X.push('"'+U[0]+'" '+U.slice(1).join(" ")):X.push('"'+U[0]+'"'):X.push(U.join(" ")),g=w.spawn(b(),X,M)}else this.cmd&&(g=w.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(f.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",M=>{this.childProcess=null,o({terminated:this.terminateRequested,error:M})}),g.pid&&(this.childProcess.on("close",E),this.handleSpawn(g,n,e,o,!0)))}return c})}handleClose(e,i,n,o){}ensureQuotes(e){return O.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,d(e,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!v.isWindows)return e(!1);const i=w.spawn(b(),["/s","/c"]);i.on("error",n=>e(!0)),i.on("exit",n=>e(!1))})}}t.AbstractProcess=O,O.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},O.regexp=/^[^"].* .*[^"]/;class C extends O{constructor(e,i,n,o){super(e,i,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,i,n,o,c){[o,c].forEach((g,E)=>{const M=new y.LineDecoder;M.write(g).forEach(U=>{i({line:U,source:E===0?0:1})});const k=M.end();k&&i({line:k,source:E===0?0:1})}),e({terminated:this.terminateRequested,error:n})}handleSpawn(e,i,n,o,c){const g=new y.LineDecoder,E=new y.LineDecoder;e.stdout.on("data",M=>{g.write(M).forEach(k=>n({line:k,source:0}))}),e.stderr.on("data",M=>{E.write(M).forEach(k=>n({line:k,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=E}handleClose(e,i,n,o){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&n({line:c,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&n({line:g,source:1})}}t.LineProcess=C;function m(r){let e=[],i=!1;const n=function(o){if(i){e.push(o);return}(!r.send(o,g=>{if(g&&console.error(g),i=!1,e.length>0){const E=e.slice(0);e=[],E.forEach(M=>n(M))}})||v.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=m;var s;(function(r){async function e(i,n,o){if(p.isAbsolute(i))return i;if(n===void 0&&(n=L.cwd()),p.dirname(i)!=="."||(o===void 0&&f.isString(L.env.PATH)&&(o=L.env.PATH.split(p.delimiter)),o===void 0||o.length===0))return p.join(n,i);async function g(E){return await I.exists(E)?!(await T.promises.stat(E)).isDirectory():!1}for(let E of o){let M;if(p.isAbsolute(E)?M=p.join(E,i):M=p.join(n,E,i),await g(M))return M;let N=M+".com";if(await g(N)||(N=M+".exe",await g(N)))return N}return p.join(n,i)}r.findExecutable=e})(s=t.win32||(t.win32={}))}),define(Q[72],Z([0,1,32,13,65,46]),function($,t,p,T,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function F(D,h){return D===1?T.isWindows?v():w.getWindowsShell(h):u(D,h)}t.getSystemShell=F;function L(D,h){return D===1?T.isWindows?y(h):w.getWindowsShell(h):u(D,h)}t.getSystemShellSync=L;let f=null;function u(D,h){if(T.isLinux&&D===2||T.isMacintosh&&D===3)return"/bin/bash";if(!f){let d;if(T.isWindows)d="/bin/bash";else{if(d=h.SHELL,!d)try{d=(0,p.userInfo)().shell}catch(b){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}f=d}return f}let R=null;async function v(){return R||(R=(await(0,I.getFirstAvailablePowerShellInstallation)()).exePath),R}function y(D){if(R)return R;const h=T.isWindows&&parseFloat((0,p.release)())>=10,d=D.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${D.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?b:w.getWindowsShell(D)}}),define(Q[47],Z([0,1,33,2,4,21,9,46,37,59,28,12,16,13]),function($,t,p,T,I,w,F,L,f,u,R,v,y,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class h extends f.ChannelServer{constructor(O){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch(m){}},onMessage:F.Event.fromNodeEventEmitter(process,"message",C=>y.VSBuffer.wrap(Buffer.from(C,"base64")))},O);process.once("disconnect",()=>this.dispose())}}t.Server=h;class d{constructor(O,C){this.modulePath=O,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new F.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new I.Delayer(m),this.child=null,this._client=null}getChannel(O){const C=this;return{call(m,s,r){return C.requestPromise(O,m,s,r)},listen(m,s){return C.requestEvent(O,m,s)}}}requestPromise(O,C,m,s=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(O),e=(0,I.createCancelablePromise)(o=>r.call(C,m,o)),i=s.onCancellationRequested(()=>e.cancel()),n=(0,T.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(O,C,m){if(!this.disposeDelayer)return F.Event.None;this.disposeDelayer.cancel();let s;const r=new F.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(O).listen(C,m)(r.fire,r),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const O=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env=Object.assign(Object.assign({},(0,w.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(C.env=Object.assign(Object.assign({},C.env),this.options.env)),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),D.isMacintosh&&C.env&&delete C.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,O,C);const m=new F.Emitter;F.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,u.isRemoteConsoleLog)(c)){(0,u.log)(c,`IPC Library: ${this.options.serverName}`);return}m.fire(y.VSBuffer.wrap(Buffer.from(c,"base64")))});const r=this.options.useQueue?(0,L.createQueuedSender)(this.child):this.child,e=c=>this.child&&this.child.connected&&r.send(c.buffer.toString("base64")),i=m.event,n={send:e,onMessage:i};this._client=new f.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,g)=>{process.removeListener("exit",o),this.activeRequests.forEach(E=>(0,T.dispose)(E)),this.activeRequests.clear(),c!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:g})})}return this._client}getCachedChannel(O){let C=this.channels.get(O);return C||(C=this.client.getChannel(O),this.channels.set(O,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=d}),define(Q[73],Z([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(Q[74],Z([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[75],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[76],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[77],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[78],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[79],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[80],Z([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[81],Z([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Q[82],Z([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Q[83],Z([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[84],Z([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Q[85],Z([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)});var ce=this&&this.__decorate||function($,t,p,T){var I=arguments.length,w=I<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,p):T,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate($,t,p,T);else for(var L=$.length-1;L>=0;L--)(F=$[L])&&(w=(I<3?F(w):I>3?F(t,p,w):F(t,p))||w);return I>3&&w&&Object.defineProperty(t,p,w),w};define(Q[86],Z([0,1,3,17,57,69,8,7,34]),function($,t,p,T,I,w,F,L,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class u{constructor(h,d,b){this._args=h,this.paths=d,this.productService=b}get appRoot(){return(0,p.dirname)(F.FileAccess.asFileUri("",$).fsPath)}get userHome(){return L.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return L.URI.file((0,p.join)(this.userDataPath,"User"))}get tmpDir(){return L.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,p.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return L.URI.file((0,p.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(L.URI.file((0,p.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return L.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return L.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=f.env.VSCODE_PORTABLE;return h?L.URI.file((0,p.join)(h,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return L.URI.file((0,p.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,p.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,p.resolve)(h):(0,p.normalize)((0,p.join)(F.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,p.resolve)(h):(0,p.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,p.resolve)(h);const d=f.env.VSCODE_EXTENSIONS;if(d)return d;const b=f.env.VSCODE_PORTABLE;return b?(0,p.join)(b,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(d=>/^[^:/?#]+?:\/\//.test(d)?L.URI.parse(d):L.URI.file((0,p.normalize)(d)))}get extensionDevelopmentKind(){var h;return(h=this.args.extensionDevelopmentKind)===null||h===void 0?void 0:h.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?L.URI.parse(h):L.URI.file((0,p.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!f.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(L.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return L.URI.file((0,p.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([I.memoize],u.prototype,"appRoot",null),ce([I.memoize],u.prototype,"userHome",null),ce([I.memoize],u.prototype,"userDataPath",null),ce([I.memoize],u.prototype,"appSettingsHome",null),ce([I.memoize],u.prototype,"tmpDir",null),ce([I.memoize],u.prototype,"userRoamingDataHome",null),ce([I.memoize],u.prototype,"settingsResource",null),ce([I.memoize],u.prototype,"userDataSyncHome",null),ce([I.memoize],u.prototype,"userDataSyncLogResource",null),ce([I.memoize],u.prototype,"sync",null),ce([I.memoize],u.prototype,"machineSettingsResource",null),ce([I.memoize],u.prototype,"globalStorageHome",null),ce([I.memoize],u.prototype,"workspaceStorageHome",null),ce([I.memoize],u.prototype,"keybindingsResource",null),ce([I.memoize],u.prototype,"keyboardLayoutResource",null),ce([I.memoize],u.prototype,"argvResource",null),ce([I.memoize],u.prototype,"snippetsHome",null),ce([I.memoize],u.prototype,"isExtensionDevelopment",null),ce([I.memoize],u.prototype,"untitledWorkspacesHome",null),ce([I.memoize],u.prototype,"installSourcePath",null),ce([I.memoize],u.prototype,"builtinExtensionsPath",null),ce([I.memoize],u.prototype,"extensionsPath",null),ce([I.memoize],u.prototype,"extensionDevelopmentLocationURI",null),ce([I.memoize],u.prototype,"extensionDevelopmentKind",null),ce([I.memoize],u.prototype,"extensionTestsLocationURI",null),ce([I.memoize],u.prototype,"debugExtensionHost",null),ce([I.memoize],u.prototype,"serviceMachineIdResource",null),ce([I.memoize],u.prototype,"telemetryLogResource",null),t.AbstractNativeEnvironmentService=u;function R(D,h){return y(D["inspect-extensions"],D["inspect-brk-extensions"],5870,h,D.debugId)}t.parseExtensionHostPort=R;function v(D,h){return y(D["inspect-search"],D["inspect-brk-search"],5876,h)}t.parseSearchPort=v;function y(D,h,d,b,O){const m=Number(h||D)||(b?null:d),s=m?Boolean(!!h):!1;return{port:m,break:s,debugId:O}}}),function(){"use strict";function $(t,p,T,I){function w(L){const f=F(L),u=[f];return t.isAbsolute(f)||u.unshift(I),t.resolve(...u)}function F(L){const f=process.env.VSCODE_PORTABLE;if(f)return t.join(f,"user-data");const u=L["user-data-dir"];if(u)return u;let R=process.env.VSCODE_APPDATA;if(!R)switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=t.join(v,"AppData","Roaming")}break;case"darwin":R=t.join(p.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||t.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(R,T)}return{getUserDataPath:w}}if(typeof define=="function")define(Q[87],Z([0,88,32,8,17,34]),function(t,p,T,I,w,F){const L=w.dirname(I.FileAccess.asFileUri("",t)),f=t.__$__nodeRequire(w.joinPath(L,"package.json").fsPath);return $(p,T,f.name,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),p=require("path"),T=require("os");module.exports=$(p,T,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[89],Z([0,1,32,87,86]),function($,t,p,T,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class w extends I.AbstractNativeEnvironmentService{constructor(L,f){super(L,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,T.getUserDataPath)(L)},f)}}t.NativeEnvironmentService=w}),define(Q[90],Z([0,1,21]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function I(w,F){const L=f=>{if(typeof f=="string"){const u=T.exec(f);if(!!u)return F[u[1]]||f}};return(0,p.cloneAndChange)(w,L)}t.localizeManifest=I}),define(Q[48],Z([0,1,80]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function I(v){return v=v.trim(),v==="*"||T.test(v)}t.isValidVersionStr=I;function w(v){if(!I(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=v.match(T);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}t.parseVersion=w;function F(v){if(!v)return null;let y=v.majorBase,D=v.majorMustEqual,h=v.minorBase,d=v.minorMustEqual,b=v.patchBase,O=v.patchMustEqual;return v.hasCaret&&(y===0||(d=!1),O=!1),{majorBase:y,majorMustEqual:D,minorBase:h,minorMustEqual:d,patchBase:b,patchMustEqual:O,isMinimum:v.hasGreaterEquals}}t.normalizeVersion=F;function L(v,y){let D;typeof v=="string"?D=F(w(v)):D=v;let h;if(typeof y=="string"?h=F(w(y)):h=y,!D||!h)return!1;let d=D.majorBase,b=D.minorBase,O=D.patchBase,C=h.majorBase,m=h.minorBase,s=h.patchBase,r=h.majorMustEqual,e=h.minorMustEqual,i=h.patchMustEqual;return h.isMinimum?d>C?!0:d<C?!1:b>m?!0:b<m?!1:O>=s:(d===1&&C===0&&(!r||!e||!i)&&(C=1,m=0,s=0,r=!0,e=!1,i=!1),d<C?!1:d>C?!r:b<m?!1:b>m?!e:O<s?!1:O>s?!i:!0)}t.isValidVersion=L;function f(v,y,D){return y.isBuiltin||typeof y.main=="undefined"?!0:R(v,y.engines.vscode,D)}t.isValidExtensionVersion=f;function u(v,y){return v==="*"||R(y,v)}t.isEngineValid=u;function R(v,y,D=[]){let h=F(w(y));if(!h)return D.push(p.localize(0,null,y)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return D.push(p.localize(1,null,y)),!1}else if(!h.majorMustEqual)return D.push(p.localize(2,null,y)),!1;return L(v,h)?!0:(D.push(p.localize(3,null,v,y)),!1)}t.isVersionValid=R}),define(Q[91],Z([0,1,37,47,2,8]),function($,t,p,T,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends I.Disposable{constructor(f,u,R,v){super();this.folders=f,this.onDidFilesChange=u,this.onLogMessage=R,this.verboseLogging=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new T.Client(w.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(u=>!this.isDisposed&&this.onDidFilesChange(u))),this._register(this.service.onDidLogMessage(u=>this.onLogMessage(u))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Q[92],Z([0,1,37,47,2,8]),function($,t,p,T,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends I.Disposable{constructor(f,u,R,v,y={}){super();this.folders=f,this.onDidFilesChange=u,this.onLogMessage=R,this.verboseLogging=v,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new T.Client(w.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(f.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(u=>!this.isDisposed&&this.onDidFilesChange(u))),this._register(this.service.onDidLogMessage(u=>this.onLogMessage(u))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Q[93],Z([0,1,33,45,61,8]),function($,t,p,T,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class F{constructor(f,u,R,v,y){this.watchedFolder=f,this.eventCallback=R,this.logCallback=v,this.verboseLogging=y,this.restartCounter=0,Array.isArray(u)?this.ignored=u.map(D=>I.parse(D)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=p.spawn(w.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,f);const u=new T.LineDecoder;this.handle.stdout.on("data",R=>{const v=[];u.write(R).forEach(y=>{const D=y.split("|");if(D.length===2){const h=Number(D[0]),d=D[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(b=>b(d))){this.verboseLogging&&this.log(d);return}v.push({type:F.changeTypeMap[h],path:d})}else this.log(D[1])}}),v.length>0&&this.eventCallback(v)}),this.handle.on("error",R=>this.onError(R)),this.handle.stderr.on("data",R=>this.onError(R)),this.handle.on("exit",(R,v)=>this.onExit(R,v))}onError(f){this.error("process error: "+f.toString())}onExit(f,u){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${u})`),this.restartCounter<=F.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=F,F.MAX_RESTARTS=5,F.changeTypeMap=[0,1,2]}),define(Q[94],Z([0,1,93,3,20]),function($,t,p,T,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class w{constructor(L,f,u,R){this.onDidFilesChange=f,this.onLogMessage=u,this.verboseLogging=R,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,I.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new p.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=w}),define(Q[49],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class p{constructor(w,F=[],L=!1){this.ctor=w,this.staticArguments=F,this.supportsDelayedInstantiation=L}}t.SyncDescriptor=p;const T=(I,...w)=>new p(I,w);t.createSyncDescriptor=T}),define(Q[95],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class p{constructor(w){this.incoming=new Map,this.outgoing=new Map,this.data=w}}t.Node=p;class T{constructor(w){this._hashFn=w,this._nodes=new Map}roots(){const w=[];for(let F of this._nodes.values())F.outgoing.size===0&&w.push(F);return w}insertEdge(w,F){const L=this.lookupOrInsertNode(w),f=this.lookupOrInsertNode(F);L.outgoing.set(this._hashFn(F),f),f.incoming.set(this._hashFn(w),L)}removeNode(w){const F=this._hashFn(w);this._nodes.delete(F);for(let L of this._nodes.values())L.outgoing.delete(F),L.incoming.delete(F)}lookupOrInsertNode(w){const F=this._hashFn(w);let L=this._nodes.get(F);return L||(L=new p(w),this._nodes.set(F,L)),L}lookup(w){return this._nodes.get(this._hashFn(w))}isEmpty(){return this._nodes.size===0}toString(){let w=[];for(let[F,L]of this._nodes)w.push(`${F}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return w.join(`
`)}findCycleSlow(){for(let[w,F]of this._nodes){const L=new Set([w]),f=this._findCycle(F,L);if(f)return f}}_findCycle(w,F){for(let[L,f]of w.outgoing){if(F.has(L))return[...F,L].join(" -> ");F.add(L);const u=this._findCycle(f,F);if(u)return u;F.delete(L)}}}t.Graph=T}),define(Q[96],Z([0,1,10]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,p.createDecorator)("downloadService")}),define(Q[22],Z([0,1,10]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,p.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,p.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[24],Z([0,1,75,10,8]),function($,t,p,T,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function w(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}t.isIExtensionIdentifier=w;var F;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=5]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(F=t.SortBy||(t.SortBy={}));var L;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(L=t.SortOrder||(t.SortOrder={}));var f;(function(v){v.Uninstall="uninstall"})(f=t.StatisticType||(t.StatisticType={}));var u;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(u=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(y,D){super(y);this.code=D}}t.ExtensionManagementError=R,t.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=I.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,p.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,p.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(Q[38],Z([0,1,20,10]),function($,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}t.isIExtensionIdentifier=I,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(w=t.ExtensionType||(t.ExtensionType={}));class F{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,v){if(typeof R=="undefined"||R===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof R=="string"||typeof v=="string"){let y=typeof R=="string"?R:R.value,D=typeof v=="string"?v:v.value;return p.equalsIgnoreCase(y,D)}return R._lower===v._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}t.ExtensionIdentifier=F;function L(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}t.isLanguagePackExtension=L;function f(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=f,t.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[25],Z([0,1,20,38]),function($,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function I(D,h){return D.uuid&&h.uuid?D.uuid===h.uuid:D.id===h.id?!0:(0,p.compareIgnoreCase)(D.id,h.id)===0}t.areSameExtensions=I;class w{constructor(h,d){this.version=d,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof w?I(this,h)&&this.version===h.version:!1}}t.ExtensionIdentifierWithVersion=w;function F(D,h){return`${D}.${h}`}t.getExtensionId=F;function L(D){return D.toLocaleLowerCase()}t.adoptToGalleryExtensionId=L;function f(D,h){return L(F(D,h))}t.getGalleryExtensionId=f;function u(D,h){const d=[],b=O=>{for(const C of d)if(C.some(m=>I(h(m),h(O))))return C;return null};for(const O of D){const C=b(O);C?C.push(O):d.push([O])}return d}t.groupByExtension=u;function R(D){return{id:D.identifier.id,name:D.manifest.name,galleryId:null,publisherId:D.publisherId,publisherName:D.manifest.publisher,publisherDisplayName:D.publisherDisplayName,dependencies:D.manifest.extensionDependencies&&D.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=R;function v(D){return Object.assign({id:D.identifier.id,name:D.name,galleryId:D.identifier.uuid,publisherId:D.publisherId,publisherName:D.publisher,publisherDisplayName:D.publisherDisplayName,dependencies:!!(D.properties.dependencies&&D.properties.dependencies.length>0)},D.telemetryData)}t.getGalleryExtensionTelemetryData=v,t.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function y(D){const h=new Set;for(const d of D)d.malicious&&h.add(d.id.id);return h}t.getMaliciousExtensionsSet=y});var ue=this&&this.__param||function($,t){return function(p,T){t(p,T,$)}};define(Q[97],Z([0,1,76,12,7,39,24,25,38,62,28,8]),function($,t,p,T,I,w,F,L,f,u,R,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const y=C=>(0,p.localize)(0,null,C),D=(0,p.localize)(1,null,"ms-dotnettools.csharp");function h(C,m){return m?`${C.publisher}.${C.name}@${C.version}`:`${C.publisher}.${C.name}`}const d=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function b(C){const m=d.exec(C);return m&&m[1]?[(0,L.adoptToGalleryExtensionId)(m[1]),m[2]]:[(0,L.adoptToGalleryExtensionId)(C),void 0]}t.getIdAndVersion=b;let O=class{constructor(m,s){this.extensionManagementService=m,this.extensionGalleryService=s}get location(){}async listExtensions(m,s,r=console){let e=await this.extensionManagementService.getInstalled(1);const i=f.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(s&&s!==""){if(i.indexOf(s.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(o=>o.manifest.categories?o.manifest.categories.map(g=>g.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){r.log("Possible Categories: "),i.forEach(o=>{r.log(o)});return}this.location&&r.log((0,p.localize)(2,null,this.location)),e=e.sort((o,c)=>o.identifier.id.localeCompare(c.identifier.id));let n;for(let o of e)n!==o.identifier.id&&(n=o.identifier.id,r.log(h(o.manifest,m)))}async installExtensions(m,s,r,e,i=console){const n=[],o=[];m.length&&i.log(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const c=await this.extensionManagementService.getInstalled(1),g=(N,k)=>{const U=c.find(x=>(0,L.areSameExtensions)(x.identifier,{id:N}));if(U){if(!k&&!e)return i.log((0,p.localize)(5,null,N,U.manifest.version,N)),!1;if(k&&U.manifest.version===k)return i.log((0,p.localize)(6,null,`${N}@${k}`)),!1}return!0},E=[],M=[];for(const N of m)if(N instanceof I.URI)E.push(N);else{const[k,U]=b(N);g(k,U)&&M.push({id:k,version:U,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const N of s){const[k,U]=b(N);g(k,U)&&M.push({id:k,version:U,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(E.length&&await Promise.all(E.map(async N=>{try{const k=await this.installVSIX(N,{isBuiltin:!1,isMachineScoped:r},e,i);k&&o.push(k)}catch(k){i.error(k.message||k.stack||k),n.push(N.toString())}})),M.length){const N=await this.getGalleryExtensions(M);await Promise.all(M.map(async k=>{const U=N.get(k.id.toLowerCase());if(U)try{const x=await this.installFromGallery(k,U,c,e,i);x&&o.push(x)}catch(x){i.error(x.message||x.stack||x),n.push(k.id)}else i.error(`${y(k.version?`${k.id}@${k.version}`:k.id)}
${D}`),n.push(k.id)}))}if(n.length)throw new Error((0,p.localize)(7,null,n.join(", ")))}async installVSIX(m,s,r,e){const i=await this.extensionManagementService.getManifest(m);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,e))try{return await this.extensionManagementService.install(m,s),e.log((0,p.localize)(8,null,(0,u.getBaseLabel)(m))),i}catch(o){if((0,T.isPromiseCanceledError)(o))return e.log((0,p.localize)(9,null,(0,u.getBaseLabel)(m))),null;throw o}return null}async getGalleryExtensions(m){const s=m.filter(({version:i})=>i===void 0).map(({id:i})=>i),r=m.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(s,R.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(r.map(async({id:i,version:n})=>{const o=await this.extensionGalleryService.getCompatibleExtension({id:i},n);o&&e.set(o.identifier.id.toLowerCase(),o)}))]),e}async installFromGallery({id:m,version:s,installOptions:r},e,i,n,o){const c=await this.extensionGalleryService.getManifest(e,R.CancellationToken.None);if(c&&!this.validateExtensionKind(c,o))return null;const g=i.find(E=>(0,L.areSameExtensions)(E.identifier,e.identifier));if(g){if(e.version===g.manifest.version)return o.log((0,p.localize)(10,null,s?`${m}@${s}`:m)),null;o.log((0,p.localize)(11,null,m,e.version))}try{return r.isBuiltin?o.log((0,p.localize)(12,null,m,e.version)):o.log((0,p.localize)(13,null,m,e.version)),await this.extensionManagementService.installFromGallery(e,r),o.log((0,p.localize)(14,null,m,e.version)),c}catch(E){if((0,T.isPromiseCanceledError)(E))return o.log((0,p.localize)(15,null,m)),null;throw E}}validateExtensionKind(m,s){return!0}async validateVSIX(m,s,r){const e={id:(0,L.getGalleryExtensionId)(m.publisher,m.name)},n=(await this.extensionManagementService.getInstalled(1)).find(o=>(0,L.areSameExtensions)(e,o.identifier)&&(0,w.gt)(o.manifest.version,m.version));return n&&!s?(r.log((0,p.localize)(16,null,n.identifier.id,n.manifest.version,m.version)),!1):this.validateExtensionKind(m,r)}async uninstallExtensions(m,s,r=console){const e=async n=>{if(n instanceof I.URI){const o=await this.extensionManagementService.getManifest(n);return h(o)}return n},i=[];for(const n of m){const o=await e(n),g=(await this.extensionManagementService.getInstalled()).filter(E=>(0,L.areSameExtensions)(E.identifier,{id:o}));if(!g.length)throw new Error(`${this.notInstalled(o)}
${D}`);if(g.some(E=>E.type===0)){r.log((0,p.localize)(17,null,o));return}if(!s&&g.some(E=>E.isBuiltin)){r.log((0,p.localize)(18,null,o));return}r.log((0,p.localize)(19,null,o));for(const E of g)await this.extensionManagementService.uninstall(E),i.push(E);this.location?r.log((0,p.localize)(20,null,o,this.location)):r.log((0,p.localize)(21,null,o))}}async locateExtension(m,s=console){const r=await this.extensionManagementService.getInstalled();m.forEach(e=>{r.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===v.Schemas.file){s.log(i.location.fsPath);return}})})}notInstalled(m){return this.location?(0,p.localize)(22,null,m,this.location):(0,p.localize)(23,null,m)}};O=ce([ue(0,F.IExtensionManagementService),ue(1,F.IExtensionGalleryService)],O),t.ExtensionManagementCLIService=O}),define(Q[98],Z([0,1,2,3,38,14]),function($,t,p,T,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class F extends p.Disposable{constructor(f,u){super();this.environmentService=f,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(u.onDidInstallExtension(R=>this.onDidInstallExtension(R))),this._register(u.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtension(f){f.error||this.invalidate()}onDidUnInstallExtension(f){f.error||this.invalidate()}invalidate(){w.rimraf(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=F}),define(Q[99],Z([0,1,88,33,30,13,127,29,72]),function($,t,p,T,I,w,F,L,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function u(y,D,h){return D["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,F.isLaunchedFromCli)(h)&&!D["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,F.isLaunchedFromCli)(h)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),R||(R=v(y)),R)}t.resolveShellEnv=u;let R;async function v(y){const D=new Promise(async(h,d)=>{const b=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",b);const O=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",O);const C=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),m=new RegExp(C+"(.*)"+C),s=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});y.trace("getUnixShellEnvironment#env",s);const r=await(0,f.getSystemShell)(w.OS,s);y.trace("getUnixShellEnvironment#shell",r);const e=p.basename(r);let i,n;/^pwsh(-preview)?$/.test(e)?(i=`& '${process.execPath}' -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,n=["-Login","-Command"]):(i=`'${process.execPath}' -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,n=["-ilc"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(n),i);const o=(0,T.spawn)(r,[...n,i],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});o.on("error",E=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(E)),h({})});const c=[];o.stdout.on("data",E=>c.push(E));const g=[];o.stderr.on("data",E=>g.push(E)),o.on("close",(E,M)=>{const N=Buffer.concat(c).toString("utf8");y.trace("getUnixShellEnvironment#raw",N);const k=Buffer.concat(g).toString("utf8");if(k.trim()&&y.trace("getUnixShellEnvironment#stderr",k),E||M)return d(new Error(`Failed to get environment (code ${E}, signal ${M})`));const U=m.exec(N),x=U?U[1]:"{}";try{const X=JSON.parse(x);b?X.ELECTRON_RUN_AS_NODE=b:delete X.ELECTRON_RUN_AS_NODE,O?X.ELECTRON_NO_ATTACH_CONSOLE=O:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",X),h(X)}catch(X){y.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(X)),d(X)}})});try{return await D}catch(h){return y.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(h)),{}}}}),define(Q[50],Z([0,1,7,19,13]),function($,t,p,T,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function w(f){return f.map(u=>({type:u.type,resource:p.URI.file(u.path)}))}t.toFileChanges=w;function F(f){const u=new L;for(const R of f)u.processEvent(R);return u.normalize()}t.normalizeFileChanges=F;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(u){const R=this.mapPathToChange.get(u.path);if(R){const v=R.type,y=u.type;v===1&&y===2?(this.mapPathToChange.delete(u.path),this.normalized.splice(this.normalized.indexOf(R),1)):v===2&&y===1?R.type=0:v===1&&y===0||(R.type=y)}else this.normalized.push(u),this.mapPathToChange.set(u.path,u)}normalize(){const u=[],R=[];return this.normalized.filter(v=>v.type!==2?(u.push(v),!1):!0).sort((v,y)=>v.path.length-y.path.length).filter(v=>R.some(y=>(0,T.isParent)(v.path,y,!I.isLinux))?!1:(R.push(v.path),!0)).concat(u)}}}),define(Q[100],Z([0,1,50,2,14,63,66,4,3]),function($,t,p,T,I,w,F,L,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class u extends T.Disposable{constructor(v,y,D,h){super();this.path=v,this.onDidFilesChange=y,this.onLogMessage=D,this.verboseLogging=h,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(F.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(v){this.verboseLogging=v}async startWatching(){try{const{stat:v,symbolicLink:y}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let D=this.path;if(y)try{D=await(0,w.realpath)(D)}catch(h){if(this.onError(h),y.dangling)return}v.isDirectory()?this._register((0,F.watchFolder)(D,(h,d)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,f.join)(this.path,(0,f.basename)(d))})},h=>this.onError(h))):this._register((0,F.watchFile)(D,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(v){v.code!=="ENOENT"&&this.onError(v)}}onFileChange(v){this.fileChangesBuffer.push(v),this.verboseLogging&&this.onVerbose(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const D=(0,p.normalizeFileChanges)(y);this.verboseLogging&&D.forEach(h=>{this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`)}),D.length>0&&this.onDidFilesChange(D)})}onError(v){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${v}`})}onVerbose(v){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=u}),define(Q[51],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class p{constructor(...I){this._entries=new Map;for(let[w,F]of I)this.set(w,F)}set(I,w){const F=this._entries.get(I);return this._entries.set(I,w),F}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}t.ServiceCollection=p}),define(Q[101],Z([0,1,12,95,49,10,51,4]),function($,t,p,T,I,w,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const f=!1;class u extends Error{constructor(h){var d;super("cyclic dependency between services");this.message=(d=h.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class R{constructor(h=new F.ServiceCollection,d=!1,b){this._activeInstantiations=new Set,this._services=h,this._strict=d,this._parent=b,this._services.set(w.IInstantiationService,this)}createChild(h){return new R(h,this._strict,this)}invokeFunction(h,...d){let b=y.traceInvocation(h),O=!1;try{return h({get:(m,s)=>{if(O)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(m,b);if(!r&&s!==w.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return r}},...d)}finally{O=!0,b.stop()}}createInstance(h,...d){let b,O;return h instanceof I.SyncDescriptor?(b=y.traceCreation(h.ctor),O=this._createInstance(h.ctor,h.staticArguments.concat(d),b)):(b=y.traceCreation(h),O=this._createInstance(h,d,b)),b.stop(),O}_createInstance(h,d=[],b){let O=w._util.getServiceDependencies(h).sort((s,r)=>s.index-r.index),C=[];for(const s of O){let r=this._getOrCreateServiceInstance(s.id,b);if(!r&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);C.push(r)}let m=O.length>0?O[0].index:d.length;if(d.length!==m){console.warn(`[createInstance] First service dependency of ${h.name} at position ${m+1} conflicts with ${d.length} static arguments`);let s=m-d.length;s>0?d=d.concat(new Array(s)):d=d.slice(0,m)}return new h(...[...d,...C])}_setServiceInstance(h,d){if(this._services.get(h)instanceof I.SyncDescriptor)this._services.set(h,d);else if(this._parent)this._parent._setServiceInstance(h,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let d=this._services.get(h);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):d}_getOrCreateServiceInstance(h,d){let b=this._getServiceInstanceOrDescriptor(h);return b instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,b,d.branch(h,!0)):(d.branch(h,!1),b)}_safeCreateAndCacheServiceInstance(h,d,b){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,d,b)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,d,b){const O=new T.Graph(s=>s.id.toString());let C=0;const m=[{id:h,desc:d,_trace:b}];for(;m.length;){const s=m.pop();if(O.lookupOrInsertNode(s),C++>1e3)throw new u(O);for(let r of w._util.getServiceDependencies(s.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${h} depends on ${r.id} which is NOT registered.`),e instanceof I.SyncDescriptor){const i={id:r.id,desc:e,_trace:s._trace.branch(r.id,!0)};O.insertEdge(s,i),m.push(i)}}}for(;;){const s=O.roots();if(s.length===0){if(!O.isEmpty())throw new u(O);break}for(const{data:r}of s){if(this._getServiceInstanceOrDescriptor(r.id)instanceof I.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}O.removeNode(r)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,d,b=[],O,C){if(this._services.get(h)instanceof I.SyncDescriptor)return this._createServiceInstance(d,b,O,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,d,b,O,C);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(h,d=[],b,O){if(b){const C=new L.IdleValue(()=>this._createInstance(h,d,O));return new Proxy(Object.create(null),{get(m,s){if(s in m)return m[s];let r=C.value,e=r[s];return typeof e!="function"||(e=e.bind(r),m[s]=e),e},set(m,s,r){return C.value[s]=r,!0}})}else return this._createInstance(h,d,O)}}t.InstantiationService=R;var v;(function(D){D[D.Creation=0]="Creation",D[D.Invocation=1]="Invocation",D[D.Branch=2]="Branch"})(v||(v={}));class y{constructor(h,d){this.type=h,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return f?new y(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(h){return f?new y(0,h.name):y._None}branch(h,d){let b=new y(2,h.toString());return this._dep.push([h,d,b]),b}stop(){let h=Date.now()-this._start;y._totals+=h;let d=!1;function b(C,m){let s=[],r=new Array(C+1).join("	");for(const[e,i,n]of m._dep)if(i&&n){d=!0,s.push(`${r}CREATES -> ${e}`);let o=b(C+1,n);o&&s.push(o)}else s.push(`${r}uses -> ${e}`);return s.join(`
`)}let O=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(h>2||d)&&console.log(O.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Q[52],Z([0,1,10]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,p.createDecorator)("localizationsService");function T(I){if(typeof I.languageId!="string"||!Array.isArray(I.translations)||I.translations.length===0)return!1;for(const w of I.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(I.languageName&&typeof I.languageName!="string"||I.localizedLanguageName&&typeof I.localizedLanguageName!="string")}t.isValidLocalization=T}),define(Q[15],Z([0,1,10,2,13,9,29]),function($,t,p,T,I,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,p.createDecorator)("logService"),t.ILoggerService=(0,p.createDecorator)("loggerService");function L(){return new Date().toISOString()}var f;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(f=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=f.Info;class u extends T.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new w.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=u;class R extends u{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(f.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(f.Error,this.format(n))}else this.log(f.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let o=e[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(c){}i+=(n>0?" ":"")+o}return i}}t.AbstractMessageLogger=R;class v extends u{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...i){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}debug(e,...i){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}info(e,...i){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}warn(e,...i){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,e,...i):console.warn(`[main ${L()}]`,e,...i))}error(e,...i){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}critical(e,...i){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=v;class y extends u{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=y;class D extends u{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,F.toErrorMessage)(e,this.getLevel()<=f.Trace)}dispose(){}flush(){}}t.AdapterLogger=D;class h extends u{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=h;class d extends T.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=d;class b extends T.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,(i==null?void 0:i.always)?f.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=b;class O{constructor(){this.onDidChangeLogLevel=new w.Emitter().event}setLevel(e){}getLevel(){return f.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=O;function C(r){if(r.verbose)return f.Trace;if(typeof r.logLevel=="string"){const e=m(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=C;function m(r){switch(r){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}t.parseLogLevel=m;function s(r){switch(r){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}t.LogLevelToString=s}),define(Q[102],Z([0,1,18,2,19,24,22,7,17,25,15,30,39,13,4,12]),function($,t,p,T,I,w,F,L,f,u,R,v,y,D,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let O=class extends T.Disposable{constructor(m,s,r,e){super();this.fileService=s,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=L.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,s){await this.cleanUpPromise;const r=this.getName(m),e=(0,f.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const i=(0,f.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(m,i,s);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(o){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,d.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(m){}async rename(m,s,r){try{await p.promises.rename(m.fsPath,s.fsPath)}catch(e){if(D.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${m} to ${s} with 'EPERM' error. Trying again...`),this.rename(m,s,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const s=[],r=[];for(const n of m.children){const o=this.parse(n.name);o&&r.push([o,n])}const e=(0,u.groupByExtension)(r,([n])=>n),i=[];for(const n of e)n.sort((o,c)=>y.rcompare(o[0].version,c[0].version)),s.push(...n.slice(1).map(o=>o[1].resource)),i.push(n[0][1]);i.sort((n,o)=>n.mtime-o.mtime),s.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await h.Promises.settled(s.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?new u.ExtensionIdentifierWithVersion(m.identifier,m.version).key().toLowerCase():(0,v.generateUuid)()}parse(m){const s=b.exec(m);return s&&s[1]&&s[2]?new u.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};O=ce([ue(0,F.INativeEnvironmentService),ue(1,I.IFileService),ue(2,w.IExtensionGalleryService),ue(3,R.ILogService)],O),t.ExtensionsDownloader=O}),define(Q[103],Z([0,1,2,15,33,29,3,4,9,8,14,22]),function($,t,p,T,I,w,F,L,f,u,R,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let y=class extends p.Disposable{constructor(h,d){super();this.environmentService=h,this.logService=d,this.processesLimiter=new L.Limiter(5)}async postUninstall(h){const d=this.parseScript(h,"uninstall");return d&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${b}`)))),(0,R.rimraf)(this.getExtensionStoragePath(h)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(h,d){const b=`vscode:${d}`;if(h.location.scheme===u.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[b]=="string"){const O=h.manifest.scripts[b].split(" ");return O.length<2||O[0]!=="node"||!O[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${b} should be a node script`),null):{script:(0,F.join)(h.location.fsPath,O[1]),args:O.slice(2)||[]}}return null}runLifecycleHook(h,d,b,O,C){return new Promise((m,s)=>{const r=this.start(h,d,b,C);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?s(n):m(void 0)};r.on("error",n=>{i((0,w.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,o)=>{i(n?`post-${d} process exited with code ${n}`:void 0)}),O&&(e=setTimeout(()=>{e=null,r.kill(),s("timed out")},5e3))})}start(h,d,b,O){const C={silent:!0,execArgv:void 0},m=(0,I.fork)(h,[`--type=extension-post-${d}`,...b],C);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const s=f.Event.fromNodeEventEmitter(m.stdout,"data"),r=f.Event.fromNodeEventEmitter(m.stderr,"data");s(n=>this.logService.info(O.identifier.id,O.manifest.version,`post-${d}`,n)),r(n=>this.logService.error(O.identifier.id,O.manifest.version,`post-${d}`,n));const e=f.Event.any(f.Event.map(s,n=>({data:`%c${n}`,format:[""]})),f.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return f.Event.debounce(e,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(O.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),m}getExtensionStoragePath(h){return(0,F.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};y=ce([ue(0,v.IEnvironmentService),ue(1,T.ILogService)],y),t.ExtensionsLifecycle=y}),define(Q[104],Z([0,1,2,22,9,19,7,25,17,15]),function($,t,p,T,I,w,F,L,f,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let R=class extends p.Disposable{constructor(y,D,h,d){super();this.extensionsManagementService=y,this.logService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new I.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(C=>{this.installedExtensions=C.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(y.onInstallExtension(C=>this.onInstallExtension(C))),this._register(y.onDidInstallExtension(C=>this.onDidInstallExtension(C))),this._register(y.onDidUninstallExtension(C=>this.onDidUninstallExtension(C)));const b=F.URI.file(h.extensionsPath),O=new f.ExtUri(C=>!D.hasCapability(C,1024));this._register(D.watch(b)),this._register(I.Event.filter(D.onDidFilesChange,C=>C.changes.some(m=>this.doesChangeAffects(m,b,O)))(()=>this.onDidChange()))}doesChangeAffects(y,D,h){return h.isEqual(h.dirname(y.resource),D)?h.isEqual(y.resource,h.joinPath(D,".obsolete"))?!0:!(y.type!==1&&y.type!==2||h.basename(y.resource).startsWith(".")):!1}onInstallExtension(y){this.addInstallingExtension(y.identifier)}onDidInstallExtension(y){this.removeInstallingExtension(y.identifier),y.error||this.addInstalledExtension(y.identifier)}onDidUninstallExtension(y){y.error||this.removeInstalledExtension(y.identifier)}addInstallingExtension(y){this.removeInstallingExtension(y),this.installingExtensions.push(y)}removeInstallingExtension(y){this.installingExtensions=this.installingExtensions.filter(D=>!(0,L.areSameExtensions)(D,y))}addInstalledExtension(y){this.installedExtensions&&(this.removeInstalledExtension(y),this.installedExtensions.push(y))}removeInstalledExtension(y){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(D=>!(0,L.areSameExtensions)(D,y)))}async onDidChange(){if(this.installedExtensions){const y=await this.extensionsManagementService.getInstalled(1),D=y.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(b=>(0,L.areSameExtensions)(b,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),h=this.installedExtensions.filter(d=>this.installingExtensions.some(b=>(0,L.areSameExtensions)(b,d))?!1:y.every(b=>!(0,L.areSameExtensions)(b.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=y.map(d=>d.identifier),(D.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:D,removed:h})}}};R=ce([ue(1,w.IFileService),ue(2,T.INativeEnvironmentService),ue(3,u.ILogService)],R),t.ExtensionsWatcher=R}),define(Q[105],Z([0,1,14,18,128,24,2,22,4,25,15,52,23,9,8,3]),function($,t,p,T,I,w,F,L,f,u,R,v,y,D,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let b=class extends F.Disposable{constructor(m,s,r){super();this.extensionManagementService=m,this.logService=r,this._onDidLanguagesChange=this._register(new D.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new O(s,r)),this._register(m.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(m.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(m=>{const s=["en",...Object.keys(m)];return(0,y.distinct)(s)})}onDidInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",m.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(m){this.cache.getLanguagePacks().then(s=>{Object.keys(s).some(r=>s[r]&&s[r].extensions.some(e=>(0,u.areSameExtensions)(e.extensionIdentifier,m)))&&(this.logService.debug("Removing language packs from the extension",m.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[m,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(s);return!(0,y.equals)(Object.keys(m),Object.keys(r))}};b=ce([ue(0,w.IExtensionManagementService),ue(1,L.INativeEnvironmentService),ue(2,R.ILogService)],b),t.LocalizationsService=b;let O=class extends F.Disposable{constructor(m,s){super();this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,d.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new f.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(s=>{Object.keys(s).forEach(r=>delete s[r]),this.createLanguagePacksFromExtensions(s,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...s){for(const r of s)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,r);Object.keys(m).forEach(r=>this.updateHash(m[r]))}createLanguagePacksFromExtension(m,s){const r=s.identifier,e=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of e)if(s.location.scheme===h.Schemas.file&&(0,v.isValidLocalization)(i)){let n=m[i.languageId];n||(n={hash:"",extensions:[],translations:{}},m[i.languageId]=n);let o=n.extensions.filter(c=>(0,u.areSameExtensions)(c.extensionIdentifier,r))[0];o?o.version=s.manifest.version:n.extensions.push({extensionIdentifier:r,version:s.manifest.version});for(const c of i.translations)n.translations[c.id]=(0,d.join)(s.location.fsPath,c.path)}}updateHash(m){if(m){const s=(0,I.createHash)("md5");for(const r of m.extensions)s.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);m.hash=s.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return T.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(e){return{}}}).then(r=>(s=m(r),r)).then(r=>{for(const i of Object.keys(r))r[i]||delete r[i];this.languagePacks=r,this.initializedCache=!0;const e=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",e),(0,p.writeFile)(this.languagePacksFilePath,e)}).then(()=>s,r=>this.logService.error(r))})}};O=ce([ue(0,L.INativeEnvironmentService),ue(1,R.ILogService)],O)}),define(Q[106],Z([0,1,15,19]),function($,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function I(f,u,R,v){try{const y=await new Promise((D,h)=>{$(["spdlog"],D,h)});return y.setAsyncMode(8192,500),y.createRotatingLoggerAsync(f,u,R,v)}catch(y){console.error(y)}return null}function w(f,u,R,v){return $.__$__nodeRequire("spdlog").createRotatingLogger(f,u,R,v)}t.createRotatingLogger=w;function F(f,u,R){switch(u){case p.LogLevel.Trace:f.trace(R);break;case p.LogLevel.Debug:f.debug(R);break;case p.LogLevel.Info:f.info(R);break;case p.LogLevel.Warning:f.warn(R);break;case p.LogLevel.Error:f.error(R);break;case p.LogLevel.Critical:f.critical(R);break;default:throw new Error("Invalid log level")}}class L extends p.AbstractMessageLogger{constructor(u,R,v,y){super();this.name=u,this.filepath=R,this.rotating=v,this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(D=>{this._logger&&this._logger.setLevel(D)}))}_createSpdLogLogger(){const u=this.rotating?6:1,R=30/u*T.ByteSize.MB;return I(this.name,this.filepath,R,u).then(v=>{if(v){this._logger=v,this._logger.setLevel(this.getLevel());for(const{level:y,message:D}of this.buffer)F(this._logger,y,D);this.buffer=[]}})}log(u,R){this._logger?F(this._logger,u,R):this.getLevel()<=u&&this.buffer.push({level:u,message:R})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Q[53],Z([0,1,82,16,19,12,40]),function($,t,p,T,I,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(v,y,D,h,d,b){let O;try{await f(v,y,D,h,d,b)}catch(C){O=C}finally{O&&d.errorTransformer&&(O=d.errorTransformer(O)),typeof O!="undefined"&&D.error(O),D.end()}}t.readFileIntoStream=L;async function f(v,y,D,h,d,b){u(b);const O=await v.open(y,{create:!1});try{u(b);let C=0,m=0,s=d&&typeof d.length=="number"?d.length:void 0,r=T.VSBuffer.alloc(Math.min(d.bufferSize,typeof s=="number"?s:d.bufferSize)),e=d&&typeof d.position=="number"?d.position:0,i=0;do m=await v.read(O,e,r.buffer,i,r.byteLength-i),e+=m,i+=m,C+=m,typeof s=="number"&&(s-=m),i===r.byteLength&&(await D.write(h(r)),r=T.VSBuffer.alloc(Math.min(d.bufferSize,typeof s=="number"?s:d.bufferSize)),i=0);while(m>0&&(typeof s!="number"||s>0)&&u(b)&&R(C,d));if(i>0){let n=i;typeof s=="number"&&(n=Math.min(i,s)),D.write(h(r.slice(0,n)))}}catch(C){throw(0,I.ensureFileSystemProviderError)(C)}finally{await v.close(O)}}function u(v){if(v.isCancellationRequested)throw(0,w.canceled)();return!0}function R(v,y){if(y==null?void 0:y.limits){if(typeof y.limits.memory=="number"&&v>y.limits.memory)throw(0,I.createFileSystemProviderError)((0,p.localize)(0,null,F.default.nameShort),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&v>y.limits.size)throw(0,I.createFileSystemProviderError)((0,p.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[107],Z([0,1,81,129,2,19,9,17,44,23,15,16,35,4,28,8,53,130]),function($,t,p,T,I,w,F,L,f,u,R,v,y,D,h,d,b,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let C=class extends I.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new F.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new F.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new F.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new F.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new F.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new F.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(s,r){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,T.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:r});const e=new I.DisposableStore;return e.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new w.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:s}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,I.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:r}),this.provider.delete(s),(0,I.dispose)(e)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(e){r.push(e)}}),!this.provider.has(s)&&await D.Promises.settled(r)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,r){const e=this.provider.get(s.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return O.Iterable.map(this.provider,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async withProvider(s){if(!(0,L.isAbsolutePath)(s))throw new w.FileOperationError((0,p.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const r=this.provider.get(s.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=(0,p.localize)(1,null,s.toString()),e}return r}async withReadProvider(s){const r=await this.withProvider(s);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r)||(0,w.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const r=await this.withProvider(s);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.doResolveFile(s,r)}catch(e){throw(0,w.toFileSystemProviderErrorCode)(e)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,p.localize)(2,null,this.resourceForError(s)),1):(0,w.ensureFileSystemProviderError)(e)}}async doResolveFile(s,r){const e=await this.withProvider(s),i=this.isPathCaseSensitive(e),n=r==null?void 0:r.resolveTo,o=r==null?void 0:r.resolveSingleChildDescendants,c=r==null?void 0:r.resolveMetadata,g=await e.stat(s);let E;return this.toFileStat(e,s,g,void 0,!!c,(M,N)=>(E||(E=f.TernarySearchTree.forUris(()=>!i),E.set(s,!0),(0,u.isNonEmptyArray)(n)&&n.forEach(k=>E.set(k,!0))),Boolean(E.findSuperstr(M.resource)||E.get(M.resource))?!0:M.isDirectory&&o?N===1:!1))}async toFileStat(s,r,e,i,n,o){const{providerExtUri:c}=this.getExtUri(s),g={resource:r,name:c.basename(r),isFile:(e.type&w.FileType.File)!=0,isDirectory:(e.type&w.FileType.Directory)!=0,isSymbolicLink:(e.type&w.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,etag:(0,w.etag)({mtime:e.mtime,size:e.size})};if(g.isDirectory&&o(g,i)){try{const E=await s.readdir(r),M=await D.Promises.settled(E.map(async([N,k])=>{try{const U=c.joinPath(r,N),x=n?await s.stat(U):{type:k};return await this.toFileStat(s,U,x,E.length,n,o)}catch(U){return this.logService.trace(U),null}}));g.children=(0,u.coalesce)(M)}catch(E){this.logService.trace(E),g.children=[]}return g}return g}async resolveAll(s){return D.Promises.settled(s.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(s){const r=await this.withProvider(s);try{return!!await r.stat(s)}catch(e){return!1}}async canCreateFile(s,r){try{await this.doValidateCreateFile(s,r)}catch(e){return e}return!0}async doValidateCreateFile(s,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(s))throw new w.FileOperationError((0,p.localize)(3,null,this.resourceForError(s)),3,r)}async createFile(s,r=v.VSBuffer.fromString(""),e){await this.doValidateCreateFile(s,e);const i=await this.writeFile(s,r);return this._onDidRunOperation.fire(new w.FileOperationEvent(s,0,i)),i}async writeFile(s,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,e)||await this.mkdirp(i,n.dirname(s));let c;if((0,w.hasReadWriteCapability)(i)&&!(r instanceof v.VSBuffer))if((0,y.isReadableStream)(r)){const g=await(0,y.peekStream)(r,3);g.ended?c=v.VSBuffer.concat(g.buffer):c=g}else c=(0,y.peekReadable)(r,g=>v.VSBuffer.concat(g),3);else c=r;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&c instanceof v.VSBuffer?await this.doWriteUnbuffered(i,s,e,c):await this.doWriteBuffered(i,s,e,c instanceof v.VSBuffer?(0,v.bufferToReadable)(c):c)}catch(o){throw new w.FileOperationError((0,p.localize)(4,null,this.resourceForError(s),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),e)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,r,e){if(!!(e==null?void 0:e.unlock)&&!(s.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(r)));let n;try{n=await s.stat(r)}catch(o){return}if((n.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,p.localize)(6,null,this.resourceForError(r)),0,e);if(e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==w.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,w.etag)({mtime:e.mtime,size:n.size}))throw new w.FileOperationError((0,p.localize)(7,null),3,e);return n}async readFile(s,r){const e=await this.withReadProvider(s);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(e,s,r):this.doReadFile(e,s,r)}async doReadFileAtomic(s,r,e){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(s,r,e);i(o)}catch(o){n(o)}})})}async doReadFile(s,r,e){const i=await this.doReadFileStream(s,r,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,v.streamToBuffer)(i.value)})}async readFileStream(s,r){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,r)}async doReadFileStream(s,r,e){const i=new h.CancellationTokenSource,n=this.validateReadFile(r,e).then(c=>c,c=>{throw i.cancel(),c});let o;try{e&&typeof e.etag=="string"&&e.etag!==w.ETAG_DISABLED&&await n,!((0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasFileReadStreamCapability)(s))||(0,w.hasReadWriteCapability)(s)&&(e==null?void 0:e.preferUnbuffered)?o=this.readFileUnbuffered(s,r,e):(0,w.hasFileReadStreamCapability)(s)?o=this.readFileStreamed(s,r,i.token,e):o=this.readFileBuffered(s,r,i.token,e);const c=await n;return Object.assign(Object.assign({},c),{value:o})}catch(c){throw o&&await(0,y.consumeStream)(o),new w.FileOperationError((0,p.localize)(8,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(c).toString()),(0,w.toFileOperationResult)(c),e)}}readFileStreamed(s,r,e,i=Object.create(null)){const n=s.readFileStream(r,i,e);return(0,y.transform)(n,{data:o=>o instanceof v.VSBuffer?o:v.VSBuffer.wrap(o),error:o=>new w.FileOperationError((0,p.localize)(9,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),i)},o=>v.VSBuffer.concat(o))}readFileBuffered(s,r,e,i=Object.create(null)){const n=(0,v.newWriteableBufferStream)();return(0,b.readFileIntoStream)(s,r,n,o=>o,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new w.FileOperationError((0,p.localize)(10,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),i)}),e),n}readFileUnbuffered(s,r,e){const i=(0,y.newWriteableStream)(n=>v.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(r);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(r,n.byteLength,e),i.end(v.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,r){const e=await this.resolve(s,{resolveMetadata:!0});if(e.isDirectory)throw new w.FileOperationError((0,p.localize)(11,null,this.resourceForError(s)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==w.ETAG_DISABLED&&r.etag===e.etag)throw new w.FileOperationError((0,p.localize)(12,null),2,r);return this.validateReadFileLimits(s,e.size,r),e}validateReadFileLimits(s,r,e){if(e==null?void 0:e.limits){let i;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&r>e.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,p.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,r,e){return this.doCanMoveCopy(s,r,"move",e)}async canCopy(s,r,e){return this.doCanMoveCopy(s,r,"copy",e)}async doCanMoveCopy(s,r,e,i){if(s.toString()!==r.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,s,o,r,e,i)}catch(n){return n}return!0}async move(s,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,s,n,r,"move",!!e),c=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,o==="move"?2:3,c)),c}async copy(s,r,e){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,s,n,r,"copy",!!e),c=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,o==="copy"?3:2,c)),c}async doMoveCopy(s,r,e,i,n,o){if(r.toString()===i.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(s,r,e,i,n,o);if(c&&!g&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(s===e&&(0,w.hasFileFolderCopyCapability)(s))await s.copy(r,i,{overwrite:o});else{const E=await this.resolve(r);E.isDirectory?await this.doCopyFolder(s,E,e,i):await this.doCopyFile(s,r,e,i)}return n}else return s===e?(await s.rename(r,i,{overwrite:o}),n):(await this.doMoveCopy(s,r,e,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(s,r,e,i){if((0,w.hasOpenReadWriteCloseCapability)(s)&&(0,w.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(s,r,e,i);if((0,w.hasOpenReadWriteCloseCapability)(s)&&(0,w.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(s,r,e,i);if((0,w.hasReadWriteCapability)(s)&&(0,w.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(s,r,e,i);if((0,w.hasReadWriteCapability)(s)&&(0,w.hasReadWriteCapability)(e))return this.doPipeUnbuffered(s,r,e,i)}async doCopyFolder(s,r,e,i){await e.mkdir(i),Array.isArray(r.children)&&await D.Promises.settled(r.children.map(async n=>{const o=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),e,o):this.doCopyFile(s,n.resource,e,o)}))}async doValidateMoveCopy(s,r,e,i,n,o){let c=!1;if(s===e){const{providerExtUri:E,isPathCaseSensitive:M}=this.getExtUri(s);if(M||(c=E.isEqual(r,i)),c&&n==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!c&&E.isEqualOrParent(i,r))throw new Error((0,p.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const g=await this.exists(i);if(g&&!c){if(!o)throw new w.FileOperationError((0,p.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(s===e){const{providerExtUri:E}=this.getExtUri(s);if(E.isEqualOrParent(r,i))throw new Error((0,p.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:g,isSameResourceWithDifferentPathCase:c}}getExtUri(s){const r=this.isPathCaseSensitive(s);return{providerExtUri:r?L.extUri:L.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(r,s);const e=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,0,e)),e}async mkdirp(s,r){const e=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(r,i.dirname(r));)try{if(((await s.stat(r)).type&w.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,w.toFileSystemProviderErrorCode)(n)!==w.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(r)),r=i.dirname(r)}for(let n=e.length-1;n>=0;n--){r=i.joinPath(r,e[n]);try{await s.mkdir(r)}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,r){try{await this.doValidateDelete(s,r)}catch(e){return e}return!0}async doValidateDelete(s,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!(r==null?void 0:r.useTrash)&&!(e.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(s)));const n=await this.exists(s);if(!n)throw new w.FileOperationError((0,p.localize)(20,null,this.resourceForError(s)),1);if(!!!(r==null?void 0:r.recursive)&&n){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(s)))}return e}async del(s,r){const e=await this.doValidateDelete(s,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await e.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new w.FileOperationEvent(s,1))}watch(s,r={recursive:!1,excludes:[]}){let e=!1,i=()=>{e=!0};return this.doWatch(s,r).then(n=>{e?(0,I.dispose)(n):i=()=>(0,I.dispose)(n)},n=>this.logService.error(n)),(0,I.toDisposable)(()=>i())}async doWatch(s,r){const e=await this.withProvider(s),i=this.toWatchKey(e,s,r),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(s,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,I.toDisposable)(()=>{n.count--,n.count===0&&((0,I.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(s,r,e){const{providerExtUri:i}=this.getExtUri(s);return[i.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,I.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{var n;const o=await s.open(r,{create:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,o,i):await this.doWriteReadableBufferedQueued(s,o,i)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await s.close(o)}})}async doWriteStreamBufferedQueued(s,r,e){let i=0,n;if((0,y.isReadableBufferedStream)(e)){if(e.buffer.length>0){const o=v.VSBuffer.concat(e.buffer);await this.doWriteBuffer(s,r,o,o.byteLength,i,0),i+=o.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(o,c)=>{(0,y.listenStream)(n,{onData:async g=>{n.pause();try{await this.doWriteBuffer(s,r,g,g.byteLength,i,0)}catch(E){return c(E)}i+=g.byteLength,setTimeout(()=>n.resume())},onError:g=>c(g),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,r,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(s,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,r,e,i,n,o){let c=0;for(;c<i;)c+=await s.write(r,n+c,e.buffer,o+c,i-c)}async doWriteUnbuffered(s,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,r,e,i))}async doWriteUnbufferedQueued(s,r,e,i){var n;let o;i instanceof v.VSBuffer?o=i:(0,y.isReadableStream)(i)?o=await(0,v.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?o=await(0,v.bufferedStreamToBuffer)(i):o=(0,v.readableToBuffer)(i),await s.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,r,e,i))}async doPipeBufferedQueued(s,r,e,i){let n,o;try{n=await s.open(r,{create:!1}),o=await e.open(i,{create:!0,unlock:!1});const c=v.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,E=0,M=0;do M=await s.read(n,g,c.buffer,E,c.byteLength-E),await this.doWriteBuffer(e,o,c,M,g,E),g+=M,E+=M,E===c.byteLength&&(E=0);while(M>0)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await D.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?e.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,r,e,i))}async doPipeUnbufferedQueued(s,r,e,i){return e.writeFile(i,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,r,e,i))}async doPipeUnbufferedToBufferedQueued(s,r,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(r);await this.doWriteBuffer(e,n,v.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(s,r,e,i){const n=await(0,v.streamToBuffer)(this.readFileBuffered(s,r,h.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(s,r){if(s.capabilities&2048)throw new w.FileOperationError((0,p.localize)(22,null,this.resourceForError(r)),6);return s}resourceForError(s){return s.scheme===d.Schemas.file?s.fsPath:s.toString(!0)}};C=ce([ue(0,R.ILogService)],C),t.FileService=C}),define(Q[108],Z([0,1,18,64,2,19,9,13,14,3,17,36,4,15,83,50,92,94,91,100,35,53,23,16]),function($,t,p,T,I,w,F,L,f,u,R,v,y,D,h,d,b,O,C,m,s,r,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class n extends I.Disposable{constructor(c,g){var E;super();this.logService=c,this.options=g,this.BUFFER_SIZE=((E=this.options)===null||E===void 0?void 0:E.bufferSize)||64*1024,this.onDidChangeCapabilities=F.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new F.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new F.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(c){try{const{stat:g,symbolicLink:E}=await f.SymlinkSupport.stat(this.toFilePath(c));return{type:this.toType(g,E),ctime:g.birthtime.getTime(),mtime:g.mtime.getTime(),size:g.size}}catch(g){throw this.toFileSystemProviderError(g)}}async readdir(c){try{const g=await(0,f.readdir)(this.toFilePath(c),{withFileTypes:!0}),E=[];return await Promise.all(g.map(async M=>{try{let N;M.isSymbolicLink()?N=(await this.stat((0,R.joinPath)(c,M.name))).type:N=this.toType(M),E.push([M.name,N])}catch(N){this.logService.trace(N)}})),E}catch(g){throw this.toFileSystemProviderError(g)}}toType(c,g){let E;return(g==null?void 0:g.dangling)?E=w.FileType.Unknown:c.isFile()?E=w.FileType.File:c.isDirectory()?E=w.FileType.Directory:E=w.FileType.Unknown,g&&(E|=w.FileType.SymbolicLink),E}async readFile(c){try{const g=this.toFilePath(c);return await p.promises.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}}readFileStream(c,g,E){const M=(0,s.newWriteableStream)(N=>i.VSBuffer.concat(N.map(k=>i.VSBuffer.wrap(k))).buffer);return(0,r.readFileIntoStream)(this,c,M,N=>N.buffer,Object.assign(Object.assign({},g),{bufferSize:this.BUFFER_SIZE}),E),M}async writeFile(c,g,E){let M;try{const N=this.toFilePath(c);if(!E.create||!E.overwrite){if(await(0,f.exists)(N)){if(!E.overwrite)throw(0,w.createFileSystemProviderError)((0,h.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!E.create)throw(0,w.createFileSystemProviderError)((0,h.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}M=await this.open(c,{create:!0,unlock:E.unlock}),await this.write(M,0,g,0,g.byteLength)}catch(N){throw await this.toFileSystemProviderWriteError(c,N)}finally{typeof M=="number"&&await this.close(M)}}async open(c,g){try{const E=this.toFilePath(c);if((0,w.isFileOpenForWriteOptions)(g)&&g.unlock)try{const{stat:k}=await f.SymlinkSupport.stat(E);k.mode&128||await p.promises.chmod(E,k.mode|128)}catch(k){this.logService.trace(k)}let M;if((0,w.isFileOpenForWriteOptions)(g)){if(L.isWindows)try{await p.promises.truncate(E,0),M="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}M||(M="w")}else M="r";const N=await(0,T.promisify)(p.open)(E,M);return this.mapHandleToPos.set(N,0),(0,w.isFileOpenForWriteOptions)(g)&&this.writeHandles.set(N,c),N}catch(E){throw(0,w.isFileOpenForWriteOptions)(g)?await this.toFileSystemProviderWriteError(c,E):this.toFileSystemProviderError(E)}}async close(c){try{if(this.mapHandleToPos.delete(c),this.writeHandles.delete(c)&&this.canFlush)try{await(0,T.promisify)(p.fdatasync)(c)}catch(g){this.canFlush=!1,this.logService.error(g)}return await(0,T.promisify)(p.close)(c)}catch(g){throw this.toFileSystemProviderError(g)}}async read(c,g,E,M,N){const k=this.normalizePos(c,g);let U=null;try{const x=await(0,T.promisify)(p.read)(c,E,M,N,k);return typeof x=="number"?U=x:U=x.bytesRead,U}catch(x){throw this.toFileSystemProviderError(x)}finally{this.updatePos(c,k,U)}}normalizePos(c,g){return g===this.mapHandleToPos.get(c)?null:g}updatePos(c,g,E){const M=this.mapHandleToPos.get(c);typeof M=="number"&&(typeof g=="number"||(typeof E=="number"?this.mapHandleToPos.set(c,M+E):this.mapHandleToPos.delete(c)))}async write(c,g,E,M,N){return(0,y.retry)(()=>this.doWrite(c,g,E,M,N),100,3)}async doWrite(c,g,E,M,N){const k=this.normalizePos(c,g);let U=null;try{const x=await(0,T.promisify)(p.write)(c,E,M,N,k);return typeof x=="number"?U=x:U=x.bytesWritten,U}catch(x){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(c),x)}finally{this.updatePos(c,k,U)}}async mkdir(c){try{await p.promises.mkdir(this.toFilePath(c))}catch(g){throw this.toFileSystemProviderError(g)}}async delete(c,g){try{const E=this.toFilePath(c);await this.doDelete(E,g)}catch(E){throw this.toFileSystemProviderError(E)}}async doDelete(c,g){g.recursive?await(0,f.rimraf)(c,f.RimRafMode.MOVE):await p.promises.unlink(c)}async rename(c,g,E){const M=this.toFilePath(c),N=this.toFilePath(g);if(M!==N)try{await this.validateTargetDeleted(c,g,"move",E.overwrite),await(0,f.move)(M,N)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,h.localize)(2,null,(0,u.basename)(M),(0,u.basename)((0,u.dirname)(N)),k.toString()))),this.toFileSystemProviderError(k)}}async copy(c,g,E){const M=this.toFilePath(c),N=this.toFilePath(g);if(M!==N)try{await this.validateTargetDeleted(c,g,"copy",E.overwrite),await(0,f.copy)(M,N,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,h.localize)(3,null,(0,u.basename)(M),(0,u.basename)((0,u.dirname)(N)),k.toString()))),this.toFileSystemProviderError(k)}}async validateTargetDeleted(c,g,E,M){const N=this.toFilePath(c),k=this.toFilePath(g);let U=!1;if(!!(this.capabilities&1024)||(U=(0,v.isEqual)(N,k,!0)),U&&E==="copy")throw(0,w.createFileSystemProviderError)((0,h.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!U&&await(0,f.exists)(k)){if(!M)throw(0,w.createFileSystemProviderError)((0,h.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(g,{recursive:!0,useTrash:!1})}}watch(c,g){return g.recursive?this.watchRecursive(c,g.excludes):this.watchNonRecursive(c)}watchRecursive(c,g){const E={path:this.toFilePath(c),excludes:g},M=(0,e.insert)(this.recursiveFoldersToWatch,E);return this.refreshRecursiveWatchers(),(0,I.toDisposable)(()=>{M(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var c,g,E;if(this.recursiveWatcher instanceof C.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,I.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let M,N;((g=(c=this.options)===null||c===void 0?void 0:c.watcher)===null||g===void 0?void 0:g.usePolling)?(M=b.FileWatcher,N=(E=this.options)===null||E===void 0?void 0:E.watcher):this.recursiveFoldersToWatch.length===1?L.isWindows?M=O.FileWatcher:M=b.FileWatcher:M=C.FileWatcher,this.recursiveWatcher=new M(this.recursiveFoldersToWatch,k=>this._onDidChangeFile.fire((0,d.toFileChanges)(k)),k=>{k.type==="error"&&this._onDidWatchErrorOccur.fire(k.message),this.logService[k.type](k.message)},this.logService.getLevel()===D.LogLevel.Trace,N),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)}))}}watchNonRecursive(c){const g=new m.FileWatcher(this.toFilePath(c),M=>this._onDidChangeFile.fire((0,d.toFileChanges)(M)),M=>{M.type==="error"&&this._onDidWatchErrorOccur.fire(M.message),this.logService[M.type](M.message)},this.logService.getLevel()===D.LogLevel.Trace),E=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)});return(0,I.combinedDisposable)(g,E)}toFilePath(c){return(0,u.normalize)(c.fsPath)}toFileSystemProviderError(c){if(c instanceof w.FileSystemProviderError)return c;let g;switch(c.code){case"ENOENT":g=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":g=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":g=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":g=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":g=w.FileSystemProviderErrorCode.NoPermissions;break;default:g=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(c,g)}async toFileSystemProviderWriteError(c,g){let E=this.toFileSystemProviderError(g);if(c&&E.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:M}=await f.SymlinkSupport.stat(this.toFilePath(c));M.mode&128||(E=(0,w.createFileSystemProviderError)(g,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(M){this.logService.trace(M)}return E}dispose(){super.dispose(),(0,I.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,I.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=n}),define(Q[41],Z([0,1,10]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,p.createDecorator)("productService")}),define(Q[26],Z([0,1,11,56]),function($,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class I{constructor(){this.data=new Map}add(F,L){T.ok(p.isString(F)),T.ok(p.isObject(L)),T.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,L)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}t.Registry=new I}),define(Q[109],Z([0,1,26,9]),function($,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function I(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class w{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,u){this.schemasById[I(f)]=u,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new w;p.Registry.add(t.Extensions.JSONContribution,F)}),define(Q[31],Z([0,1,74,9,26,11,109]),function($,t,p,T,I,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var L;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=I.Registry.as(F.Extensions.JSONContribution);class u{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(O,C=!0){this.registerConfigurations([O],C)}registerConfigurations(O,C=!0){const m=[];O.forEach(s=>{m.push(...this.validateAndRegisterProperties(s,C,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(O){const C=[],m=s=>{if(s.properties)for(const r in s.properties)C.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,s.properties[r]);s.allOf&&s.allOf.forEach(r=>m(r))};for(const s of O){m(s);const r=this.configurationContributors.indexOf(s);r!==-1&&this.configurationContributors.splice(r,1)}f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}registerDefaultConfigurations(O){const C=[],m=[];for(const s of O)for(const r in s)if(C.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),s[r]);const e={type:"object",default:this.defaultValues[r],description:p.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};m.push(v(r)),this.configurationProperties[r]=e,this.defaultLanguageConfigurationOverridesNode.properties[r]=e}else{this.defaultValues[r]=s[r];const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}deregisterDefaultConfigurations(O){const C=[];for(const m of O)for(const s in m)if(C.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}notifyConfigurationSchemaUpdated(...O){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(O){for(const C of O)this.overrideIdentifiers.add(C);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(O,C=!0,m,s=3){var r;s=w.isUndefinedOrNull(O.scope)?s:O.scope;let e=[],i=O.properties;if(i)for(let o in i){if(C&&h(o)){delete i[o];continue}const c=i[o];if(this.updatePropertyDefaultValue(o,c),t.OVERRIDE_PROPERTY_PATTERN.test(o)?c.scope=void 0:(c.scope=w.isUndefinedOrNull(c.scope)?s:c.scope,c.restricted=w.isUndefinedOrNull(c.restricted)?!!((r=m==null?void 0:m.restrictedConfigurations)===null||r===void 0?void 0:r.includes(o)):c.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),e.push(o)}let n=O.allOf;if(n)for(let o of n)e.push(...this.validateAndRegisterProperties(o,C,m,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(O){const C=m=>{let s=m.properties;if(s)for(const e in s)this.updateSchema(e,s[e]);let r=m.allOf;r&&r.forEach(C)};C(O)}updateSchema(O,C){switch(t.allSettings.properties[O]=C,C.scope){case 1:t.applicationSettings.properties[O]=C;break;case 2:t.machineSettings.properties[O]=C;break;case 6:t.machineOverridableSettings.properties[O]=C;break;case 3:t.windowSettings.properties[O]=C;break;case 4:t.resourceSettings.properties[O]=C;break;case 5:t.resourceSettings.properties[O]=C,this.resourceLanguageSettingsSchema.properties[O]=C;break}}removeFromSchema(O,C){switch(delete t.allSettings.properties[O],C.scope){case 1:delete t.applicationSettings.properties[O];break;case 2:delete t.machineSettings.properties[O];break;case 6:delete t.machineOverridableSettings.properties[O];break;case 3:delete t.windowSettings.properties[O];break;case 4:case 5:delete t.resourceSettings.properties[O];break}}updateOverridePropertyPatternKey(){for(const O of this.overrideIdentifiers.values()){const C=`[${O}]`,m={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(C,m),t.allSettings.properties[C]=m,t.applicationSettings.properties[C]=m,t.machineSettings.properties[C]=m,t.machineOverridableSettings.properties[C]=m,t.windowSettings.properties[C]=m,t.resourceSettings.properties[C]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(O,C){let m=this.defaultValues[O];w.isUndefined(m)&&(m=C.default),w.isUndefined(m)&&(m=y(C.type)),C.default=m}}const R="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function v(b){return b.substring(1,b.length-1)}t.overrideIdentifierFromKey=v;function y(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=y;const D=new u;I.Registry.add(t.Extensions.Configuration,D);function h(b){return b.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(b)?p.localize(5,null,b):D.getConfigurationProperties()[b]!==void 0?p.localize(6,null,b):null:p.localize(4,null)}t.validateProperty=h;function d(){const b=[],O=D.getConfigurationProperties();for(const C of Object.keys(O))b.push([C,O[C].scope]);return b.push(["launch",4]),b.push(["task",4]),b}t.getScopes=d}),define(Q[27],Z([0,1,21,11,7,26,10,31]),function($,t,p,T,I,w,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,F.createDecorator)("configurationService");function f(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof I.URI)}t.isConfigurationOverrides=f;var u;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(u=t.ConfigurationTarget||(t.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=R;function v(i,n){const o=n?i?n.keys.filter(U=>i.keys.indexOf(U)===-1):[...n.keys]:[],c=i?n?i.keys.filter(U=>n.keys.indexOf(U)===-1):[...i.keys]:[],g=[];if(n&&i){for(const U of i.keys)if(n.keys.indexOf(U)!==-1){const x=O(i.contents,U),X=O(n.contents,U);p.equals(x,X)||g.push(U)}}const E=[],M=U=>{const x={};for(const X of U)for(const ie of X.identifiers)x[r(ie)]=X;return x},N=n?M(n.overrides):{},k=i?M(i.overrides):{};if(Object.keys(N).length)for(const U of o){const x=N[U];x&&E.push([(0,L.overrideIdentifierFromKey)(U),x.keys])}if(Object.keys(k).length)for(const U of c){const x=k[U];x&&E.push([(0,L.overrideIdentifierFromKey)(U),x.keys])}if(Object.keys(N).length&&Object.keys(k).length)for(const U of g){const x=k[U],X=N[U];if(x&&X){const ie=v({contents:x.contents,keys:x.keys,overrides:[]},{contents:X.contents,keys:X.keys,overrides:[]});E.push([(0,L.overrideIdentifierFromKey)(U),[...ie.added,...ie.removed,...ie.updated]])}}return{added:o,removed:c,updated:g,overrides:E}}t.compare=v;function y(i,n){const o=[];for(const c of Object.keys(i))if(L.OVERRIDE_PROPERTY_PATTERN.test(c)){const g={};for(const E in i[c])g[E]=i[c][E];o.push({identifiers:[(0,L.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(g),contents:D(g,n)})}return o}t.toOverrides=y;function D(i,n){const o=Object.create(null);for(let c in i)h(o,c,i[c],n);return o}t.toValuesTree=D;function h(i,n,o,c){const g=n.split("."),E=g.pop();let M=i;for(let N=0;N<g.length;N++){let k=g[N],U=M[k];switch(typeof U){case"undefined":U=M[k]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${g.slice(0,N+1).join(".")} is ${JSON.stringify(U)}`);return}M=U}if(typeof M=="object"&&M!==null)try{M[E]=o}catch(N){c(`Ignoring ${n} as ${g.join(".")} is ${JSON.stringify(M)}`)}else c(`Ignoring ${n} as ${g.join(".")} is ${JSON.stringify(M)}`)}t.addToValueTree=h;function d(i,n){const o=n.split(".");b(i,o)}t.removeFromValueTree=d;function b(i,n){const o=n.shift();if(n.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const c=i[o];typeof c=="object"&&!Array.isArray(c)&&(b(c,n),Object.keys(c).length===0&&delete i[o])}}function O(i,n,o){function c(M,N){let k=M;for(const U of N){if(typeof k!="object"||k===null)return;k=k[U]}return k}const g=n.split("."),E=c(i,g);return typeof E=="undefined"?o:E}t.getConfigurationValue=O;function C(i,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in i?T.isObject(i[c])&&T.isObject(n[c])?C(i[c],n[c],o):o&&(i[c]=n[c]):i[c]=n[c])})}t.merge=C;function m(){const i=w.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=m;function s(){const i=Object.create(null),n=w.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let o in n){let c=n[o].default;h(i,o,c,g=>console.error(`Conflict in default settings: ${g}`))}return i}t.getDefaultValues=s;function r(i){return`[${i}]`}t.keyFromOverrideIdentifier=r;function e(i,n,o){const c=i.inspect(n),g=i.inspect(o);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:c.defaultValue}t.getMigratedSettingValue=e}),define(Q[110],Z([0,1,58,44,23,11,21,7,31,27,26,2,9]),function($,t,p,T,I,w,F,L,f,u,R,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class D{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,u.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,u.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o],g=i[o];g&&(typeof c=="object"&&typeof g=="object"?(c=F.deepClone(c),this.mergeContents(c,g)):c=g),n[o]=c}return new D(n,this.keys,this.overrides)}merge(...e){const i=F.deepClone(this.contents),n=F.deepClone(this.overrides),o=[...this.keys];for(const c of e){this.mergeContents(i,c.contents);for(const g of c.overrides){const[E]=n.filter(M=>I.equals(M.identifiers,g.identifiers));E?this.mergeContents(E.contents,g.contents):n.push(F.deepClone(g))}for(const g of c.keys)o.indexOf(g)===-1&&o.push(g)}return new D(i,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&w.isObject(e[n])&&w.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=F.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?F.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,u.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,u.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=D;class h extends D{constructor(){const e=(0,u.getDefaultValues)(),i=(0,u.getConfigurationKeys)(),n=[];for(const o of Object.keys(e))f.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,f.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(e[o]),contents:(0,u.toValuesTree)(e[o],c=>console.error(`Conflict in default settings file: ${c}`))});super(e,i,n)}}t.DefaultConfigurationModel=h;class d{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new D}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!w.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:o,overrides:c,restricted:g}=this.doParseRaw(e,i);this._configurationModel=new D(n,o,c),this._restrictedConfigurations=g||[]}doParseContent(e){let i={},n=null,o=[],c=[],g=[];function E(N){Array.isArray(o)?o.push(N):n&&(o[n]=N)}let M={onObjectBegin:()=>{let N={};E(N),c.push(o),o=N,n=null},onObjectProperty:N=>{n=N},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let N=[];E(N),c.push(o),o=N,n=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:E,onError:(N,k,U)=>{g.push({error:N,offset:k,length:U})}};if(e)try{p.visit(e,M),i=o[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return i}doParseRaw(e,i){const n=R.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),o=this.filter(e,n,!0,i);e=o.raw;const c=(0,u.toValuesTree)(e,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),g=Object.keys(e),E=(0,u.toOverrides)(e,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:c,keys:g,overrides:E,restricted:o.restricted}}filter(e,i,n,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:e,restricted:[]};const c={},g=[];for(let E in e)if(f.OVERRIDE_PROPERTY_PATTERN.test(E)&&n){const M=this.filter(e[E],i,!1,o);c[E]=M.raw,g.push(...M.restricted)}else{const M=i[E],N=M?typeof M.scope!="undefined"?M.scope:3:void 0;(M==null?void 0:M.restricted)&&g.push(E),(N===void 0||o.scopes===void 0||o.scopes.includes(N))&&(o.skipRestricted&&(M==null?void 0:M.restricted)||(c[E]=e[E]))}return{raw:c,restricted:g}}}t.ConfigurationModelParser=d;class b extends v.Disposable{constructor(e,i,n,o){super();this.userSettingsResource=e,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new D}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=b;class O{constructor(e,i,n=new D,o=new D,c=new T.ResourceMap,g=new D,E=new T.ResourceMap,M=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=g,this._memoryConfigurationByResource=E,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new D,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(e):o.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const o=this.getConsolidateConfigurationModel(i,n),c=this.getFolderConfigurationModelForResource(i.resource,n),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),M=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),U=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,x=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(e):c.freeze().getValue(e):void 0,X=i.overrideIdentifier?g.override(i.overrideIdentifier).getValue(e):g.getValue(e),ie=o.getValue(e),ee=I.distinct(I.flatten(o.overrides.map(te=>te.identifiers))).filter(te=>o.getOverrideValue(e,te)!==void 0);return{defaultValue:E,userValue:M,userLocalValue:N,userRemoteValue:k,workspaceValue:U,workspaceFolderValue:x,memoryValue:X,value:ie,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:c==null?void 0:c.freeze().getValue(e),override:i.overrideIdentifier?c==null?void 0:c.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:g.getValue(e),override:i.overrideIdentifier?g.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(o=>f.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const c=(0,f.overrideIdentifierFromKey)(o),g=this._defaultConfiguration.getKeysForOverrideIdentifier(c),E=e.getKeysForOverrideIdentifier(c),M=[...E.filter(N=>g.indexOf(N)===-1),...g.filter(N=>E.indexOf(N)===-1),...g.filter(N=>!F.equals(this._defaultConfiguration.override(c).getValue(N),e.override(c).getValue(N)))];return[c,M]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:c}=(0,u.compare)(this.localUserConfiguration,e),g=[...i,...n,...o];return g.length&&this.updateLocalUserConfiguration(e),{keys:g,overrides:c}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:c}=(0,u.compare)(this.remoteUserConfiguration,e);let g=[...i,...n,...o];return g.length&&this.updateRemoteUserConfiguration(e),{keys:g,overrides:c}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:o,overrides:c}=(0,u.compare)(this.workspaceConfiguration,e);let g=[...i,...n,...o];return g.length&&this.updateWorkspaceConfiguration(e),{keys:g,overrides:c}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:o,updated:c,removed:g,overrides:E}=(0,u.compare)(n,i);let M=[...o,...c,...g];return(M.length||!n)&&this.updateFolderConfiguration(e,i),{keys:M,overrides:E}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:o,removed:c,overrides:g}=(0,u.compare)(i,void 0);return{keys:[...n,...o,...c],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const o=i.getFolder(e);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const c=this._memoryConfigurationByResource.get(e);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(e);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:o,keys:c}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:o,keys:c}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(o=>i.add(o))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),o=this.parseConfigurationModel(e.workspace),c=e.folders.reduce((g,E)=>(g.set(L.URI.revive(E[0]),this.parseConfigurationModel(E[1])),g),new T.ResourceMap);return new O(i,n,new D,o,c,new D,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new D(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=O;function C(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const o of r)o.keys.forEach(c=>e.add(c)),o.overrides.forEach(([c,g])=>{const E=(0,T.getOrSet)(i,c,new Set);g.forEach(M=>E.add(M))});const n=[];return i.forEach((o,c)=>n.push([c,[...o.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=C;class m{constructor(e,i,n,o){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;e.keys.forEach(E=>c.add(E)),e.overrides.forEach(([,E])=>E.forEach(M=>c.add(M))),this.affectedKeys=[...c.values()];const g=new D;this.affectedKeys.forEach(E=>g.setValue(E,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=O.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(e,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,c=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!F.equals(o,c)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,u.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(e=e[o],!e)return!1;n=n[o]}return!0}}t.ConfigurationChangeEvent=m;class s extends m{constructor(e,i,n,o){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=s}),define(Q[111],Z([0,1,26,31,2,27,110,9,4,17]),function($,t,p,T,I,w,F,L,f,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class R extends I.Disposable{constructor(y,D){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new F.UserSettings(this.settingsResource,void 0,u.extUriBiasedIgnorePathCase,D)),this.configuration=new F.Configuration(new F.DefaultConfigurationModel,new F.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new f.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(T.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new F.Configuration(new F.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,D){const h=typeof y=="string"?y:void 0,d=(0,w.isConfigurationOverrides)(y)?y:(0,w.isConfigurationOverrides)(D)?D:{};return this.configuration.getValue(h,d,void 0)}updateValue(y,D,h,d){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const D=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(h,D,1)}onDidDefaultConfigurationChange(y){const D=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new F.DefaultConfigurationModel,y);this.trigger(h,D,6)}trigger(y,D,h){const d=new F.ConfigurationChangeEvent(y,{data:D},this.configuration);d.source=h,d.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=R}),define(Q[54],Z([0,1,84,10,31,26,16]),function($,t,p,T,I,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,T.createDecorator)("requestService");function L(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}t.isSuccess=L;function f(h){return h.res.statusCode===204}async function u(h){if(!L(h))throw new Error("Server returned "+h.res.statusCode);return f(h)?null:(await(0,F.streamToBuffer)(h.stream)).toString()}t.asText=u;async function R(h){if(!L(h))throw new Error("Server returned "+h.res.statusCode);if(f(h))return null;const b=(await(0,F.streamToBuffer)(h.stream)).toString();try{return JSON.parse(b)}catch(O){throw O.message+=`:
`+b,O}}t.asJson=R;function v(h){D(h)}t.updateProxyConfigurationsScope=v;let y;function D(h){const d=w.Registry.as(I.Extensions.Configuration);y&&d.deregisterConfigurations([y]),y={id:"http",order:15,title:(0,p.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,p.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,p.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,p.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,p.localize)(4,null),(0,p.localize)(5,null),(0,p.localize)(6,null),(0,p.localize)(7,null)],default:"override",description:(0,p.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,p.localize)(9,null),restricted:!0}}},d.registerConfiguration(y)}D(2)}),define(Q[112],Z([0,1,113,11]),function($,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function I(F,L){return F.protocol==="http:"?L.HTTP_PROXY||L.http_proxy||null:F.protocol==="https:"&&(L.HTTPS_PROXY||L.https_proxy||L.HTTP_PROXY||L.http_proxy)||null}async function w(F,L,f={}){const u=(0,p.parse)(F),R=f.proxyUrl||I(u,L);if(!R)return null;const v=(0,p.parse)(R);if(!/^https?:$/.test(v.protocol||""))return null;const y={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,T.isBoolean)(f.strictSSL)?f.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((D,h)=>{$(["http-proxy-agent"],D,h)}))(y):new(await new Promise((D,h)=>{$(["https-proxy-agent"],D,h)}))(y)}t.getProxyAgent=w}),define(Q[114],Z([0,1,30,16]),function($,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function I(w,F,L){let f=L&&L.get("storage.serviceMachineId",0)||null;if(f)return f;try{const R=(await F.readFile(w.serviceMachineIdResource)).value.toString();f=(0,p.isUUID)(R)?R:null}catch(u){f=null}if(!f){f=(0,p.generateUuid)();try{await F.writeFile(w.serviceMachineIdResource,T.VSBuffer.fromString(f))}catch(u){}}return L&&L.store("storage.serviceMachineId",f,0,1),f}t.getServiceMachineId=I}),define(Q[115],Z([0,1,10,9,2,11,67,4]),function($,t,p,T,I,w,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";t.IStorageService=(0,p.createDecorator)("storageService");var u;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(u=t.WillSaveStateReason||(t.WillSaveStateReason={}));var R;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(R=t.StorageScope||(t.StorageScope={}));var v;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(v=t.StorageTarget||(t.StorageTarget={}));class y extends I.Disposable{constructor(b={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,I.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,O){O===f?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:O,target:this.getKeyTargets(b)[O]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,O,C){var m;return(m=this.getStorage(O))===null||m===void 0?void 0:m.get(b,C)}getBoolean(b,O,C){var m;return(m=this.getStorage(O))===null||m===void 0?void 0:m.getBoolean(b,C)}getNumber(b,O,C){var m;return(m=this.getStorage(O))===null||m===void 0?void 0:m.getNumber(b,C)}store(b,O,C,m){if((0,w.isUndefinedOrNull)(O)){this.remove(b,C);return}this.withPausedEmitters(()=>{var s;this.updateKeyTarget(b,C,m),(s=this.getStorage(C))===null||s===void 0||s.set(b,O)})}remove(b,O){this.withPausedEmitters(()=>{var C;this.updateKeyTarget(b,O,void 0),(C=this.getStorage(O))===null||C===void 0||C.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,O){const C=[],m=this.getKeyTargets(b);for(const s of Object.keys(m))m[s]===O&&C.push(s);return C}updateKeyTarget(b,O,C){var m,s;const r=this.getKeyTargets(O);typeof C=="number"?r[b]!==C&&(r[b]=C,(m=this.getStorage(O))===null||m===void 0||m.set(f,JSON.stringify(r))):typeof r[b]=="number"&&(delete r[b],(s=this.getStorage(O))===null||s===void 0||s.set(f,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const O=this.get(f,b);if(O)try{return JSON.parse(O)}catch(C){}return Object.create(null)}isNew(b){return this.getBoolean(t.IS_NEW_KEY,b)===!0}async flush(){var b,O,C,m;this._onWillSaveState.fire({reason:u.NONE}),await L.Promises.settled([(O=(b=this.getStorage(0))===null||b===void 0?void 0:b.whenFlushed())!==null&&O!==void 0?O:Promise.resolve(),(m=(C=this.getStorage(1))===null||C===void 0?void 0:C.whenFlushed())!==null&&m!==void 0?m:Promise.resolve()])}async logStorage(){var b,O,C,m,s,r;const e=(O=(b=this.getStorage(0))===null||b===void 0?void 0:b.items)!==null&&O!==void 0?O:new Map,i=(m=(C=this.getStorage(1))===null||C===void 0?void 0:C.items)!==null&&m!==void 0?m:new Map;return h(e,i,(s=this.getLogDetails(0))!==null&&s!==void 0?s:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}t.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class D extends y{constructor(){super();this.globalStorage=new F.Storage(new F.InMemoryStorageDatabase),this.workspaceStorage=new F.Storage(new F.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}t.InMemoryStorageService=D;async function h(d,b,O,C){const m=c=>{try{return JSON.parse(c)}catch(g){return c}},s=new Map,r=new Map;d.forEach((c,g)=>{s.set(g,c),r.set(g,m(c))});const e=new Map,i=new Map;b.forEach((c,g)=>{e.set(g,c),i.set(g,m(c))}),console.group(`Storage: Global (path: ${O})`);let n=[];s.forEach((c,g)=>{n.push({key:g,value:c})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${C})`);let o=[];e.forEach((c,g)=>{o.push({key:g,value:c})}),console.table(o),console.groupEnd(),console.log(i)}t.logStorage=h}),define(Q[116],Z([0,1,13,34,30,7]),function($,t,p,T,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0;function F(u){if(p.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}async function L(u,R,v,y,D,h,d,b,O,C){const m=Object.create(null);m["common.machineId"]=d,m.sessionID=(0,I.generateUuid)()+Date.now(),m.commitHash=D,m.version=h,m["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,p.PlatformToString)(p.platform),m["common.nodePlatform"]=T.platform,m["common.nodeArch"]=y,m["common.product"]=C||"desktop";const s=f(b||[]);s&&(m["common.msftInternal"]=s);let r=0;const e=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),p.isLinuxSnap&&(m["common.snap"]="true");const i=F(v);i&&(m["common.platformDetail"]=i);try{const n=await u.readFile(w.URI.file(O));m["common.source"]=n.value.toString().slice(0,30)}catch(n){}return m}t.resolveCommonProperties=L;function f(u){const R=T.env.USERDNSDOMAIN;if(!R)return!1;const v=R.toLowerCase();return u.some(y=>v===y)}}),define(Q[42],Z([0,1,10]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,p.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[117],Z([0,1,12,24,25,21,42,54,48,22,28,15,19,7,41,115,114,10,17]),function($,t,p,T,I,w,F,L,f,u,R,v,y,D,h,d,b,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var m;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished"})(m||(m={}));function s(...a){return String(a.reduce((l,P)=>l|P,0))}var r;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:m.None,criteria:[],assetTypes:[]};class c{constructor(l=o){this.state=l}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(l,P=this.state.pageSize){return new c(Object.assign(Object.assign({},this.state),{pageNumber:l,pageSize:P}))}withFilter(l,...P){const S=[...this.state.criteria,...P.length?P.map(A=>({filterType:l,value:A})):[{filterType:l}]];return new c(Object.assign(Object.assign({},this.state),{criteria:S}))}withSortBy(l){return new c(Object.assign(Object.assign({},this.state),{sortBy:l}))}withSortOrder(l){return new c(Object.assign(Object.assign({},this.state),{sortOrder:l}))}withFlags(...l){return new c(Object.assign(Object.assign({},this.state),{flags:l.reduce((P,S)=>P|S,0)}))}withAssetTypes(...l){return new c(Object.assign(Object.assign({},this.state),{assetTypes:l}))}get raw(){const{criteria:l,pageNumber:P,pageSize:S,sortBy:A,sortOrder:j,flags:B,assetTypes:_}=this.state;return{filters:[{criteria:l,pageNumber:P,pageSize:S,sortBy:A,sortOrder:j}],assetTypes:_,flags:B}}get searchText(){const l=this.state.criteria.filter(P=>P.filterType===r.SearchText)[0];return l&&l.value?l.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(l=>String(l.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(a,l){const P=(a||[]).filter(S=>S.statisticName===l)[0];return P?P.value:0}function E(a){const l="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(S=>S.assetType.indexOf(l)===0).reduce((S,A)=>{const j=U(a,A.assetType);return j&&S.push([A.assetType.substring(l.length),j]),S},[])}function M(a){if(a.properties){const l=a.properties.filter(A=>A.key===e.Repository),P=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),S=l.filter(A=>P.test(A.value))[0];return S?{uri:S.value,fallbackUri:S.value}:null}return U(a,e.Repository)}function N(a){return{uri:`${a.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${a.fallbackAssetUri}/${e.VSIX}`}}function k(a){const l=U(a,e.Icon);if(l)return l;const P=T.DefaultIconPath;return{uri:P,fallbackUri:P}}function U(a,l){return a.files.filter(S=>S.assetType===l)[0]?{uri:`${a.assetUri}/${l}`,fallbackUri:`${a.fallbackAssetUri}/${l}`}:null}function x(a,l){const P=a.properties?a.properties.filter(A=>A.key===l):[],S=P.length>0&&P[0].value;return S?S.split(",").map(A=>(0,I.adoptToGalleryExtensionId)(A)):[]}function X(a){const l=a.properties?a.properties.filter(P=>P.key===i.Engine):[];return l.length>0&&l[0].value||""}function ie(a){const l=a.properties?a.properties.filter(S=>S.key===i.LocalizedLanguages):[],P=l.length>0&&l[0].value||"";return P?P.split(","):[]}function ee(a){return a.indexOf("preview")!==-1}function te(a){const l=a.properties?a.properties.find(P=>P.key===i.WebExtension):void 0;return!!l&&l.value==="true"}function ae(a){return a.files.some(l=>l.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,C.joinPath)(D.URI.parse(a.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function W(a,l,P,S,A){const j={manifest:U(l,e.Manifest),readme:U(l,e.Details),changelog:U(l,e.Changelog),license:U(l,e.License),repository:M(l),download:N(l),icon:k(l),coreTranslations:E(l)};return{identifier:{id:(0,I.getGalleryExtensionId)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:l.version,date:l.lastUpdated,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,description:a.shortDescription||"",installCount:g(a.statistics,"install"),rating:g(a.statistics,"averagerating"),ratingCount:g(a.statistics,"ratingcount"),assetUri:D.URI.parse(l.assetUri),webResource:ae(l),assetTypes:l.files.map(({assetType:B})=>B),assets:j,properties:{dependencies:x(l,i.Dependency),extensionPack:x(l,i.ExtensionPack),engine:X(l),localizedLanguages:ie(l),webExtension:te(l)},telemetryData:{index:(S.pageNumber-1)*S.pageSize+P,querySource:A},preview:ee(a.flags)}}let G=class{constructor(l,P,S,A,j,B,_){this.requestService=l,this.logService=P,this.environmentService=S,this.telemetryService=A,this.fileService=j,this.productService=B;const q=B.extensionsGallery;this.extensionsGalleryUrl=q&&q.serviceUrl,this.extensionsControlUrl=q&&q.controlUrl,this.commonHeadersPromise=V(B.version,this.environmentService,this.fileService,_)}api(l=""){return`${this.extensionsGalleryUrl}${l}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(l,P){const S=[];let{total:A,firstPage:j,getPage:B}=await this.query({names:l,pageSize:l.length},P);S.push(...j);for(let _=1;S.length<A&&(j=await B(_,P),j.length);_++)S.push(...j);return S}async getCompatibleExtension(l,P){const S=await this.getCompatibleExtensionByEngine(l,P);return(S==null?void 0:S.properties.webExtension)?S.webResource?S:null:S}async getCompatibleExtensionByEngine(l,P){const S=(0,T.isIExtensionIdentifier)(l)?null:l;if(S&&S.properties.engine&&(0,f.isEngineValid)(S.properties.engine,this.productService.version))return S;const{id:A,uuid:j}=S?S.identifier:l;let B=new c().withFlags(m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");j?B=B.withFilter(r.ExtensionId,j):B=B.withFilter(r.ExtensionName,A);const{galleryExtensions:_}=await this.queryGallery(B,R.CancellationToken.None),[q]=_;if(!q||!q.versions.length)return null;if(P){const Y=q.versions.filter(ne=>ne.version===P)[0];if(Y){const ne=W(q,Y,0,B);if(ne.properties.engine&&(0,f.isEngineValid)(ne.properties.engine,this.productService.version))return ne}return null}const J=await this.getLastValidExtensionVersion(q,q.versions);return J?W(q,J,0,B):null}async query(l,P){const S=R.CancellationToken.isCancellationToken(l)?{}:l,A=R.CancellationToken.isCancellationToken(l)?l:P;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=S.text||"";const B=(0,w.getOrDefault)(S,re=>re.pageSize,50);let _=new c().withFlags(m.IncludeLatestVersionOnly,m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,B).withFilter(r.Target,"Microsoft.VisualStudio.Code");j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,me)=>(_=_.withFilter(r.Category,me||he),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,me)=>(_=_.withFilter(r.Tag,me||he),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(r.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),_=_.withFilter(r.SearchText,j)),_=_.withSortBy(0)):S.ids?_=_.withFilter(r.ExtensionId,...S.ids):S.names?_=_.withFilter(r.ExtensionName,...S.names):_=_.withSortBy(4),typeof S.sortBy=="number"&&(_=_.withSortBy(S.sortBy)),typeof S.sortOrder=="number"&&(_=_.withSortOrder(S.sortOrder));const{galleryExtensions:q,total:J}=await this.queryGallery(_,A),Y=q.map((re,he)=>W(re,re.versions[0],he,_,S.source)),ne=async(re,he)=>{if(he.isCancellationRequested)throw(0,p.canceled)();const me=_.withPage(re+1),{galleryExtensions:De}=await this.queryGallery(me,he);return De.map((Oe,Fe)=>W(Oe,Oe.versions[0],Fe,me,S.source))};return{firstPage:Y,total:J,pageSize:_.pageSize,getPage:ne}}async queryGallery(l,P){if(!this.isEnabled())throw new Error("No extension gallery service configured.");l=l.withFlags(l.flags,m.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(m.Unpublished));const S=await this.commonHeadersPromise,A=JSON.stringify(l.raw),j=Object.assign(Object.assign({},S),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(A.length)}),B=new Date().getTime();let _,q,J=0;try{if(_=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:A,headers:j},P),_.res.statusCode&&_.res.statusCode>=400&&_.res.statusCode<500)return{galleryExtensions:[],total:J};const Y=await(0,L.asJson)(_);if(Y){const ne=Y.results[0],re=ne.extensions,he=ne.resultMetadata&&ne.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return J=he&&he.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:J}}return{galleryExtensions:[],total:J}}catch(Y){throw q=Y,Y}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},l.telemetryData),{requestBodySize:String(A.length),duration:new Date().getTime()-B,success:!!_&&(0,L.isSuccess)(_),responseBodySize:_==null?void 0:_.res.headers["Content-Length"],statusCode:_?String(_.res.statusCode):void 0,errorCode:q?(0,p.isPromiseCanceledError)(q)?"canceled":(0,p.getErrorMessage)(q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(J)}))}}async reportStatistic(l,P,S,A){if(!!this.isEnabled()){const j=await this.commonHeadersPromise,B=Object.assign(Object.assign({},j),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${l}/extensions/${P}/${S}/stats?statType=${A}`),headers:B},R.CancellationToken.None)}catch(_){}}}async download(l,P,S){this.logService.trace("ExtensionGalleryService#download",l.identifier.id);const A=(0,I.getGalleryExtensionTelemetryData)(l),j=new Date().getTime(),B=Y=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},A),{duration:Y})),_=S===1?"install":S===2?"update":"",q=_?{uri:`${l.assets.download.uri}&${_}=true`,fallbackUri:`${l.assets.download.fallbackUri}?${_}=true`}:l.assets.download,J=await this.getAsset(q);await this.fileService.writeFile(P,J.stream),B(new Date().getTime()-j)}async getReadme(l,P){if(l.assets.readme){const S=await this.getAsset(l.assets.readme,{},P);return await(0,L.asText)(S)||""}return""}async getManifest(l,P){if(l.assets.manifest){const S=await this.getAsset(l.assets.manifest,{},P),A=await(0,L.asText)(S);return A?JSON.parse(A):null}return null}async getCoreTranslation(l,P){const S=l.assets.coreTranslations.filter(A=>A[0]===P.toUpperCase())[0];if(S){const A=await this.getAsset(S[1]),j=await(0,L.asText)(A);return j?JSON.parse(j):null}return null}async getChangelog(l,P){if(l.assets.changelog){const S=await this.getAsset(l.assets.changelog,{},P);return await(0,L.asText)(S)||""}return""}async getAllVersions(l,P){let S=new c().withFlags(m.IncludeVersions,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");l.identifier.uuid?S=S.withFilter(r.ExtensionId,l.identifier.uuid):S=S.withFilter(r.ExtensionName,l.identifier.id);const A=[],{galleryExtensions:j}=await this.queryGallery(S,R.CancellationToken.None);return j.length&&(P?await Promise.all(j[0].versions.map(async B=>{let _;try{_=await this.getEngine(B)}catch(q){}_&&(0,f.isEngineValid)(_,this.productService.version)&&A.push({version:B.version,date:B.lastUpdated})})):A.push(...j[0].versions.map(B=>({version:B.version,date:B.lastUpdated})))),A}async getAsset(l,P={},S=R.CancellationToken.None){const A=await this.commonHeadersPromise,j={type:"GET"},B=Object.assign(Object.assign({},A),P.headers||{});P=Object.assign(Object.assign(Object.assign({},P),j),{headers:B});const _=l.uri,q=l.fallbackUri,J=Object.assign(Object.assign({},P),{url:_});try{const Y=await this.requestService.request(J,S);if(Y.res.statusCode===200)return Y;const ne=await(0,L.asText)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${ne}`)}catch(Y){if((0,p.isPromiseCanceledError)(Y))throw Y;const ne=(0,p.getErrorMessage)(Y);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:_,message:ne});const re=Object.assign(Object.assign({},P),{url:q});return this.requestService.request(re,S)}}async getLastValidExtensionVersion(l,P){const S=this.getLastValidExtensionVersionFromProperties(l,P);return S||this.getLastValidExtensionVersionRecursively(l,P)}getLastValidExtensionVersionFromProperties(l,P){for(const S of P){const A=X(S);if(!A)return null;if((0,f.isEngineValid)(A,this.productService.version))return S}return null}async getEngine(l){const P=X(l);if(P)return P;const S=U(l,e.Manifest);if(!S)throw new Error("Manifest was not found");const A={"Accept-Encoding":"gzip"},j=await this.getAsset(S,{headers:A}),B=await(0,L.asJson)(j);if(B)return B.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(l,P){if(!P.length)return null;const S=P[0],A=await this.getEngine(S);return(0,f.isEngineValid)(A,this.productService.version)?(S.properties=S.properties||[],S.properties.push({key:i.Engine,value:A}),S):this.getLastValidExtensionVersionRecursively(l,P.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const l=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(l.res.statusCode!==200)throw new Error("Could not get extensions report.");const P=await(0,L.asJson)(l),S=new Map;if(P)for(const A of P.malicious){const j=S.get(A)||{id:{id:A},malicious:!0,slow:!1};j.malicious=!0,S.set(A,j)}return[...S.values()]}};G=ce([ue(0,L.IRequestService),ue(1,v.ILogService),ue(2,u.IEnvironmentService),ue(3,F.ITelemetryService),ue(4,y.IFileService),ue(5,h.IProductService),ue(6,(0,O.optional)(d.IStorageService))],G),t.ExtensionGalleryService=G;async function V(a,l,P,S){const A={"X-Market-Client-Id":`VSCode ${a}`,"User-Agent":`VSCode ${a}`},j=await(0,b.getServiceMachineId)(l,P,S);return A["X-Market-User-Id"]=j,A}t.resolveMarketplaceHeaders=V}),define(Q[118],Z([0,1,40,85,20,10,27,31,2,21,26]),function($,t,p,T,I,w,F,L,f,u,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let v=class{constructor(h,d){this._configurationService=d,this._experimentProperties={},this._disposables=new f.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,I.escapeRegExpCharacters)(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const O=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!O})}))}setExperimentProperty(h,d){this._experimentProperties[h]=d}setEnabled(h){this._enabled=h}_updateUserOptIn(){var h;const d=(h=this._configurationService)===null||h===void 0?void 0:h.getValue(y);this._userOptIn=d?d.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let d=h.sessionID,b=h["common.instanceId"],O=h["common.machineId"],C=h["common.firstSessionDate"],m=h["common.msftInternal"];return{sessionId:d,instanceId:b,machineId:O,firstSessionDate:C,msftInternal:m}}dispose(){this._disposables.dispose()}publicLog(h,d,b){return this.isOptedIn?this._commonProperties.then(O=>{d=(0,u.mixin)(d,O),d=(0,u.mixin)(d,this._experimentProperties),d=(0,u.cloneAndChange)(d,C=>{if(typeof C=="string")return this._cleanupInfo(C,b)}),this._appender.log(h,d)},O=>{console.error(O)}):Promise.resolve(void 0)}publicLog2(h,d,b){return this.publicLog(h,d,b)}publicLogError(h,d){return this.sendErrorTelemetry?this.publicLog(h,d,!0):Promise.resolve(void 0)}publicLogError2(h,d){return this.publicLogError(h,d)}_cleanupInfo(h,d){let b=h;if(d){const O=[];for(let r of this._cleanupPatterns)for(;;){const e=r.exec(h);if(!e)break;O.push([e.index,r.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(b="";;){const r=m.exec(h);if(!r)break;!C.test(r[0])&&O.every(([e,i])=>r.index<e||r.index>=i)&&(b+=h.substring(s,r.index)+"<REDACTED: user-file-path>",s=m.lastIndex)}s<h.length&&(b+=h.substr(s))}for(let O of this._cleanupPatterns)b=b.replace(O,"");return b}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=ce([ue(1,(0,w.optional)(F.IConfigurationService))],v),t.TelemetryService=v;const y="telemetry";R.Registry.as(L.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:(0,T.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,T.localize)(2,null,p.default.privacyStatementUrl):(0,T.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Q[55],Z([0,1,27,21,11,4]),function($,t,p,T,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,d){return Promise.resolve(void 0)}publicLog2(h,d){return this.publicLog(h,d)}publicLogError(h,d){return Promise.resolve(void 0)}publicLogError2(h,d){return this.publicLogError(h,d)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class F{async publicLog(d,b,O){}async publicLogError(d,b,O){}}t.NullEndpointTelemetryService=F;function L(...h){return{log:(d,b)=>h.forEach(O=>O.log(d,b)),flush:()=>w.Promises.settled(h.map(d=>d.flush()))}}t.combinedAppender=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(h,d){return d.onDidChangeConfiguration(b=>{b.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(b.source),configurationKeys:y(b.sourceConfig)})})}t.configurationTelemetry=f;function u(h){const d=Object.create(null),b=Object.create(null),O=Object.create(null);v(h,O);for(let C in O){C=C.length>150?C.substr(C.length-149):C;const m=O[C];typeof m=="number"?b[C]=m:typeof m=="boolean"?b[C]=m?1:0:typeof m=="string"?d[C]=m.substring(0,1023):typeof m!="undefined"&&m!==null&&(d[C]=m)}return{properties:d,measurements:b}}t.validateTelemetryData=u;function R(h){if(!h)return"none";let d="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(O=>{h.indexOf(`${O}+`)===0&&(d=O)}),d}t.cleanRemoteAuthority=R;function v(h,d,b=0,O){if(!!h)for(let C of Object.getOwnPropertyNames(h)){const m=h[C],s=O?O+C:C;Array.isArray(m)?d[s]=(0,T.safeStringify)(m):m instanceof Date?d[s]=m.toISOString():(0,I.isObject)(m)?b<2?v(m,d,b+1,s+"."):d[s]=(0,T.safeStringify)(m):d[s]=m}}function y(h){if(!h)return[];const d=[];return D(d,"",h),d}function D(h,d,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(O=>D(h,d?`${d}.${O}`:O,b[O])):h.push(d)}}),define(Q[119],Z([0,1,12,21,55]),function($,t,p,T,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function w(L){const f=await new Promise((R,v)=>{$(["applicationinsights"],R,v)});let u;return f.defaultClient?(u=new f.TelemetryClient(L),u.channel.setUseDiskRetryCaching(!0)):(f.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),u=f.defaultClient),L.indexOf("AIF-")===0&&(u.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),u}class F{constructor(f,u,R){this._eventPrefix=f,this._defaultData=u,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(f){if(!!this._aiClient){if(typeof this._aiClient!="string"){f(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=w(this._aiClient)),this._asyncAIClient.then(u=>{f(u)},u=>{(0,p.onUnexpectedError)(u),console.error(u)})}}log(f,u){!this._aiClient||(u=(0,T.mixin)(u,this._defaultData),u=(0,I.validateTelemetryData)(u),this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+f,properties:u.properties,measurements:u.measurements})))}flush(){return this._aiClient?new Promise(f=>{this._withAIClient(u=>{u.flush({callback:()=>{this._aiClient=void 0,f(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=F}),define(Q[120],Z([0,1,14,18,3]),function($,t,p,T,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function w(F,L){const f=Object.create(null),u=(v,y)=>{const D=JSON.parse(v);f[y]=D};if(L){const v=(0,p.readdirSync)(L).filter(D=>{try{return(0,T.statSync)((0,I.join)(L,D)).isDirectory()}catch(h){return!1}}),y=[];v.forEach(D=>{(0,p.readdirSync)((0,I.join)(L,D)).filter(d=>d==="telemetry.json").length===1&&y.push(D)}),y.forEach(D=>{const h=(0,T.readFileSync)((0,I.join)(L,D,"telemetry.json")).toString();u(h,D)})}let R=(0,T.readFileSync)((0,I.join)(F,"telemetry-core.json")).toString();return u(R,"vscode-core"),R=(0,T.readFileSync)((0,I.join)(F,"telemetry-extensions.json")).toString(),u(R,"vscode-extensions"),JSON.stringify(f,null,4)}t.buildTelemetryMessage=w}),define(Q[43],Z([0,1,73,3,18,4,14,131,132,11]),function($,t,p,T,I,w,F,L,f,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class R extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=R;function v(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function y(r){if(r instanceof R)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new R(e,r)}function D(r,e,i,n,o,c){const g=T.dirname(e),E=T.join(n,g);if(!E.startsWith(n))return Promise.reject(new Error(p.localize(0,null,e)));const M=T.join(n,e);let N;return c.onCancellationRequested(()=>{N&&N.destroy()}),Promise.resolve(I.promises.mkdir(E,{recursive:!0})).then(()=>new Promise((k,U)=>{if(!c.isCancellationRequested)try{N=(0,I.createWriteStream)(M,{mode:i}),N.once("close",()=>k()),N.once("error",U),r.once("error",U),r.pipe(N)}catch(x){U(x)}}))}function h(r,e,i,n){let o=(0,w.createCancelablePromise)(()=>Promise.resolve()),c=0;return n.onCancellationRequested(()=>{o.cancel(),r.close()}),new Promise((g,E)=>{const M=new w.Sequencer,N=k=>{k.isCancellationRequested||(c++,r.readEntry())};r.once("error",E),r.once("close",()=>o.then(()=>{n.isCancellationRequested||r.entryCount===c?g():E(new R("Incomplete",new Error(p.localize(1,null,c,r.entryCount))))},E)),r.readEntry(),r.on("entry",k=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(k.fileName)){N(n);return}const U=k.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(U)){const ie=T.join(e,U);o=(0,w.createCancelablePromise)(ee=>I.promises.mkdir(ie,{recursive:!0}).then(()=>N(ee)).then(void 0,E));return}const x=b(r,k),X=v(k);o=(0,w.createCancelablePromise)(ie=>M.queue(()=>x.then(ee=>D(ee,U,X,e,i,ie).then(()=>N(ie)))).then(null,E))}})})}function d(r,e=!1){return new Promise((i,n)=>{(0,L.open)(r,e?{lazyEntries:!0}:void 0,(o,c)=>{o?n(y(o)):i((0,u.assertIsDefined)(c))})})}function b(r,e){return new Promise((i,n)=>{r.openReadStream(e,(o,c)=>{o?n(y(o)):i((0,u.assertIsDefined)(c))})})}function O(r,e){return new Promise((i,n)=>{const o=new f.ZipFile;e.forEach(g=>{g.contents?o.addBuffer(typeof g.contents=="string"?Buffer.from(g.contents,"utf8"):g.contents,g.path):g.localPath&&o.addFile(g.localPath,g.path)}),o.end();const c=(0,I.createWriteStream)(r);o.outputStream.pipe(c),o.outputStream.once("error",n),c.once("error",n),c.once("finish",()=>i(r))})}t.zip=O;function C(r,e,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let c=d(r,!0);return i.overwrite&&(c=c.then(g=>(0,F.rimraf)(e).then(()=>g))),c.then(g=>h(g,e,{sourcePathRegex:o},n))}t.extract=C;function m(r,e){return d(r).then(i=>new Promise((n,o)=>{i.on("entry",c=>{c.fileName===e&&b(i,c).then(g=>n(g),g=>o(g))}),i.once("close",()=>o(new Error(p.localize(2,null,e))))}))}function s(r,e){return m(r,e).then(i=>new Promise((n,o)=>{const c=[];i.once("error",o),i.on("data",g=>c.push(g)),i.on("end",()=>n(Buffer.concat(c)))}))}t.buffer=s}),define(Q[121],Z([0,1,43,78]),function($,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function I(w){return(0,p.buffer)(w,"extension/package.json").then(F=>{try{return JSON.parse(F.toString("utf8"))}catch(L){throw new Error((0,T.localize)(0,null))}})}t.getManifest=I}),define(Q[122],Z([0,1,18,39,2,14,3,15,24,25,4,7,22,90,79,41,43,13,23,8,19,17,30,12]),function($,t,p,T,I,w,F,L,f,u,R,v,y,D,h,d,b,O,C,m,s,r,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const n="scanningSystem",o="scanningUser",c="extracting",g="deleting",E="renaming";let M=class extends I.Disposable{constructor(k,U,x,X,ie){super();this.beforeRemovingExtension=k,this.fileService=U,this.logService=x,this.environmentService=X,this.productService=ie,this._devSystemExtensionsPath=null,this.systemExtensionsPath=X.builtinExtensionsPath,this.extensionsPath=X.extensionsPath,this.uninstalledPath=F.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(k){const U=[];(k===null||k===0)&&U.push(this.scanSystemExtensions().then(null,x=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(x).message,n)))),(k===null||k===1)&&U.push(this.scanUserExtensions(!0).then(null,x=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(x).message,o))));try{const x=await Promise.all(U);return(0,C.flatten)(x)}catch(x){throw this.joinErrors(x)}}async scanUserExtensions(k){this.logService.trace("Started scanning user extensions");let[U,x]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return x=x.filter(X=>!U[new u.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).key()]),k&&(x=(0,u.groupByExtension)(x,ie=>ie.identifier).map(ie=>ie.sort((ee,te)=>T.rcompare(ee.manifest.version,te.manifest.version))[0])),this.logService.trace("Scanned user extensions:",x.length),x}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(k,U,x){const X=k.key(),ie=F.join(this.extensionsPath,`.${(0,e.generateUuid)()}`),ee=F.join(this.extensionsPath,X);try{await w.rimraf(ee)}catch(ae){try{await w.rimraf(ee)}catch(W){}throw new f.ExtensionManagementError((0,h.localize)(0,null,ee,k.id),g)}await this.extractAtLocation(k,U,ie,x);let te=await this.scanExtension(v.URI.file(ie),1);if(!te)throw new Error((0,h.localize)(1,null,ie));await this.storeMetadata(te,{installedTimestamp:Date.now()});try{await this.rename(k,ie,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(ae){try{await w.rimraf(ie)}catch(W){}if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",k.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(ae)}. Deleted from extracted location`,ie),ae}try{te=await this.scanExtension(v.URI.file(ee),1)}catch(ae){}if(te)return te;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(k,U){return this.setMetadata(k,U),await this.storeMetadata(k,Object.assign(Object.assign({},U),{installedTimestamp:k.installedTimestamp})),k}async storeMetadata(k,U){U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.installedTimestamp=U.installedTimestamp||void 0;const x=F.join(k.location.fsPath,"package.json"),X=await p.promises.readFile(x,"utf8"),{manifest:ie}=await this.parseManifest(X);return ie.__metadata=U,await w.writeFile(x,JSON.stringify(ie,null,"	")),k}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...k){const U=k.map(x=>new u.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version));await this.withUninstalledExtensions(x=>{U.forEach(X=>x[X.key()]=!0)})}async setInstalled(k){await this.withUninstalledExtensions(X=>delete X[k.key()]);const x=(await this.scanExtensions(1)).find(X=>new u.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).equals(k))||null;return x?(await this.storeMetadata(x,{installedTimestamp:Date.now()}),this.scanExtension(x.location,1)):null}async withUninstalledExtensions(k){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await p.promises.readFile(this.uninstalledPath,"utf8")}catch(X){if(X.code!=="ENOENT")throw X}let x={};if(U)try{x=JSON.parse(U)}catch(X){}return k&&(k(x),Object.keys(x).length?await w.writeFile(this.uninstalledPath,JSON.stringify(x)):await w.rimraf(this.uninstalledPath)),x})}async removeExtension(k,U){this.logService.trace(`Deleting ${U} extension from disk`,k.identifier.id,k.location.fsPath),await w.rimraf(k.location.fsPath),this.logService.info("Deleted from disk",k.identifier.id,k.location.fsPath)}async removeUninstalledExtension(k){await this.removeExtension(k,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[new u.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version).key()])}async extractAtLocation(k,U,x,X){this.logService.trace(`Started extracting the extension from ${U} to ${x}`);try{await w.rimraf(x)}catch(ie){throw new f.ExtensionManagementError(this.joinErrors(ie).message,g)}try{await(0,b.extract)(U,x,{sourcePath:"extension",overwrite:!0},X),this.logService.info(`Extracted extension to ${x}:`,k.id)}catch(ie){try{await w.rimraf(x)}catch(ee){}throw new f.ExtensionManagementError(ie.message,ie instanceof b.ExtractError&&ie.type?ie.type:c)}}async rename(k,U,x,X){try{await p.promises.rename(U,x)}catch(ie){if(O.isWindows&&ie&&ie.code==="EPERM"&&Date.now()<X)return this.logService.info(`Failed renaming ${U} to ${x} with 'EPERM' error. Trying again...`,k.id),this.rename(k,U,x,X);throw new f.ExtensionManagementError(ie.message||(0,h.localize)(3,null,U,x),ie.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const k=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return k;const U=this.scanDevSystemExtensions(),[x,X]=await Promise.all([k,U]);return[...x,...X]}async scanExtensionsInDir(k,U){const x=new R.Limiter(10),X=await this.fileService.resolve(v.URI.file(k));return X.children?(await Promise.all(X.children.filter(ee=>ee.isDirectory).map(ee=>x.queue(async()=>U===1&&(0,r.basename)(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,U))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(k,U){var x,X;try{const ie=await this.fileService.resolve(k);if(ie.children){const{manifest:ee,metadata:te}=await this.readManifest(k.fsPath),ae=(x=ie.children.find(({name:a})=>/^readme(\.txt|\.md|)$/i.test(a)))===null||x===void 0?void 0:x.resource,W=(X=ie.children.find(({name:a})=>/^changelog(\.txt|\.md|)$/i.test(a)))===null||X===void 0?void 0:X.resource,G={id:(0,u.getGalleryExtensionId)(ee.publisher,ee.name)},V={type:U,identifier:G,manifest:ee,location:k,readmeUrl:ae,changelogUrl:W,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:U===0};return te&&(this.setMetadata(V,te),V.installedTimestamp=te.installedTimestamp),V}}catch(ie){U!==0&&this.logService.trace(ie)}return null}async scanDefaultSystemExtensions(){const k=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",k.length),k}async scanDevSystemExtensions(){const k=this.getDevSystemExtensionsList();if(k.length){const U=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",U.length),U.filter(x=>k.some(X=>(0,u.areSameExtensions)(x.identifier,{id:X})))}else return[]}setMetadata(k,U){k.publisherDisplayName=U.publisherDisplayName||null,k.publisherId=U.publisherId||null,k.identifier.uuid=U.id,k.isMachineScoped=!!U.isMachineScoped,k.isBuiltin=k.type===0||!!U.isBuiltin}async removeUninstalledExtensions(){const k=await this.getUninstalledExtensions(),U=await this.scanAllUserExtensions(),x=new Set;for(const ee of U)k[new u.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||x.add(ee.identifier.id.toLowerCase());const X=(0,u.groupByExtension)(U,ee=>ee.identifier);await R.Promises.settled(X.map(async ee=>{const te=ee.sort((ae,W)=>T.rcompare(ae.manifest.version,W.manifest.version))[0];x.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(te)}));const ie=U.filter(ee=>k[new u.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await R.Promises.settled(ie.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const k=await this.scanAllUserExtensions(),U=[],x=(0,u.groupByExtension)(k,X=>X.identifier);U.push(...(0,C.flatten)(x.map(X=>X.sort((ie,ee)=>T.rcompare(ie.manifest.version,ee.manifest.version)).slice(1)))),await R.Promises.settled(U.map(X=>this.removeExtension(X,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(k=>k.name)}joinErrors(k){const U=Array.isArray(k)?k:[k];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((x,X)=>new Error(`${x.message}${x.message?",":""}${X instanceof Error?X.message:X}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=F.normalize(F.join(m.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(k){const U=[p.promises.readFile(F.join(k,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),p.promises.readFile(F.join(k,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:x,metadata:X},ie]=await Promise.all(U);return{manifest:(0,D.localizeManifest)(x,ie),metadata:X}}parseManifest(k){return new Promise((U,x)=>{try{const X=JSON.parse(k),ie=X.__metadata||null;U({manifest:X,metadata:ie})}catch(X){x(new Error((0,h.localize)(4,null)))}})}};M=ce([ue(1,s.IFileService),ue(2,L.ILogService),ue(3,y.INativeEnvironmentService),ue(4,d.IProductService)],M),t.ExtensionsScanner=M}),define(Q[123],Z([0,1,18,77,3,14,2,23,43,24,25,22,4,9,39,7,40,13,15,98,29,42,48,17,30,96,10,8,28,121,102,122,103,104,19]),function($,t,p,T,I,w,F,L,f,u,R,v,y,D,h,d,b,O,C,m,s,r,e,i,n,o,c,g,E,M,N,k,U,x,X){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const ie="unsetUninstalled",ee="downloading",te="validating",ae="local",W="unknown";let G=class extends F.Disposable{constructor(a,l,P,S,A,j,B){super();this.environmentService=a,this.galleryService=l,this.logService=P,this.downloadService=S,this.telemetryService=A,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new D.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const _=this._register(j.createInstance(U.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(k.ExtensionsScanner,J=>_.postUninstall(J))),this.manifestCache=this._register(new m.ExtensionsManifestCache(a,this)),this.extensionsDownloader=this._register(j.createInstance(N.ExtensionsDownloader));const q=this._register(new x.ExtensionsWatcher(this,B,a,P));this._register(q.onDidChangeExtensionsByAnotherSource(({added:J,removed:Y})=>{J.forEach(ne=>this._onDidInstallExtension.fire({identifier:ne.identifier,operation:0,local:ne})),Y.forEach(ne=>this._onDidUninstallExtension.fire({identifier:ne}))})),this._register((0,F.toDisposable)(()=>{this.installingExtensions.forEach(J=>J.cancel()),this.uninstallingExtensions.forEach(J=>J.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(a){this.logService.trace("ExtensionManagementService#zip",a.identifier.id);const l=await this.collectFiles(a),P=await(0,f.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,l);return d.URI.file(P)}async unzip(a){return this.logService.trace("ExtensionManagementService#unzip",a.toString()),(await this.install(a)).identifier}async getManifest(a){const l=await this.downloadVsix(a),P=I.resolve(l.fsPath);return(0,M.getManifest)(P)}async collectFiles(a){const l=async S=>{let A=await w.readdir(S);A=A.map(_=>I.join(S,_));const j=await Promise.all(A.map(_=>p.promises.stat(_)));let B=Promise.resolve([]);return j.forEach((_,q)=>{const J=A[q];_.isFile()&&(B=B.then(Y=>[...Y,J])),_.isDirectory()&&(B=B.then(Y=>l(J).then(ne=>[...Y,...ne])))}),B};return(await l(a.location.fsPath)).map(S=>({path:`extension/${I.relative(a.location.fsPath,S)}`,localPath:S}))}async install(a,l={}){return this.logService.trace("ExtensionManagementService#install",a.toString()),(0,y.createCancelablePromise)(async P=>{const S=await this.downloadVsix(a),A=I.resolve(S.fsPath),j=await(0,M.getManifest)(A),B={id:(0,R.getGalleryExtensionId)(j.publisher,j.name)};let _=1;if(j.engines&&j.engines.vscode&&!(0,e.isEngineValid)(j.engines.vscode,b.default.version))throw new Error(T.localize(0,null,B.id,b.default.version));const q=new R.ExtensionIdentifierWithVersion(B,j.version),Y=(await this.getInstalled(1)).find(re=>(0,R.areSameExtensions)(B,re.identifier));if(Y)if(l.isMachineScoped=l.isMachineScoped||Y.isMachineScoped,l.isBuiltin=l.isBuiltin||Y.isBuiltin,_=2,q.equals(new R.ExtensionIdentifierWithVersion(Y.identifier,Y.manifest.version)))try{await this.extensionsScanner.removeExtension(Y,"existing")}catch(re){throw new Error(T.localize(1,null,j.displayName||j.name))}else h.gt(Y.manifest.version,j.version)&&await this.uninstallExtension(Y);else{const re=await this.unsetUninstalledAndGetLocal(q);if(re)try{await this.extensionsScanner.removeExtension(re,"existing")}catch(he){throw new Error(T.localize(2,null,j.displayName||j.name))}}this.logService.info("Installing the extension:",B.id),this._onInstallExtension.fire({identifier:B,zipPath:A});let ne;try{ne=await this.getGalleryMetadata((0,R.getGalleryExtensionId)(j.publisher,j.name))}catch(re){}try{const re=await this.installFromZipPath(q,A,Object.assign(Object.assign({},ne||{}),l),l,_,P);return this.logService.info("Successfully installed the extension:",B.id),re}catch(re){throw this.logService.error("Failed to install the extension:",B.id,re.message),re}})}async downloadVsix(a){if(a.scheme===g.Schemas.file)return a;if(!this.downloadService)throw new Error("Download service is not available");const l=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(a,l),l}async installFromZipPath(a,l,P,S,A,j){try{const B=await this.installExtension({zipPath:l,identifierWithVersion:a,metadata:P},j);try{await this.installDependenciesAndPackExtensions(B,void 0,S)}catch(_){(0,L.isNonEmptyArray)(B.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",B.identifier.id,_.message),(0,L.isNonEmptyArray)(B.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",B.identifier.id,_.message)}return this._onDidInstallExtension.fire({identifier:a,zipPath:l,local:B,operation:A}),B}catch(B){throw this._onDidInstallExtension.fire({identifier:a,zipPath:l,operation:A,error:B}),B}}async canInstall(a){return!0}async installFromGallery(a,l={}){if(!this.galleryService.isEnabled())throw new Error(T.localize(3,null));try{a=await this.checkAndGetCompatibleVersion(a)}catch(A){const j=A&&A.code?A.code:W;throw this.logService.error("Failed to install extension:",a.identifier.id,A?A.message:j),this.reportTelemetry(this.getTelemetryEvent(1),(0,R.getGalleryExtensionTelemetryData)(a),void 0,A),A instanceof Error&&(A.name=j),A}const P=new R.ExtensionIdentifierWithVersion(a.identifier,a.version).key();let S=this.installingExtensions.get(P);return S||(S=(0,y.createCancelablePromise)(A=>this.doInstallFromGallery(a,l,A)),this.installingExtensions.set(P,S),S.finally(()=>this.installingExtensions.delete(P))),S}async doInstallFromGallery(a,l,P){const S=new Date().getTime();let A=1;this.logService.info("Installing extension:",a.identifier.id),this._onInstallExtension.fire({identifier:a.identifier,gallery:a});try{const B=(await this.getInstalled(1)).find(J=>(0,R.areSameExtensions)(J.identifier,a.identifier));B&&(A=2);const _=await this.downloadInstallableExtension(a,A);_.metadata.isMachineScoped=l.isMachineScoped||(B==null?void 0:B.isMachineScoped),_.metadata.isBuiltin=l.isBuiltin||(B==null?void 0:B.isBuiltin);const q=await this.installExtension(_,P);try{await this.extensionsDownloader.delete(d.URI.file(_.zipPath))}catch(J){}if(!l.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(q,B,l)}catch(J){try{await this.uninstall(q)}catch(Y){}throw J}return B&&h.neq(B.manifest.version,a.version)&&await this.extensionsScanner.setUninstalled(B),this.logService.info("Extensions installed successfully:",a.identifier.id),this._onDidInstallExtension.fire({identifier:a.identifier,gallery:a,local:q,operation:A}),this.reportTelemetry(this.getTelemetryEvent(A),(0,R.getGalleryExtensionTelemetryData)(a),new Date().getTime()-S,void 0),q}catch(j){const B=j&&j.code?j.code:W;throw this.logService.error("Failed to install extension:",a.identifier.id,j?j.message:B),this._onDidInstallExtension.fire({identifier:a.identifier,gallery:a,operation:A,error:B}),this.reportTelemetry(this.getTelemetryEvent(A),(0,R.getGalleryExtensionTelemetryData)(a),new Date().getTime()-S,j),j instanceof Error&&(j.name=B),j}}async checkAndGetCompatibleVersion(a){if(await this.isMalicious(a))throw new u.ExtensionManagementError(T.localize(4,null),u.INSTALL_ERROR_MALICIOUS);const l=await this.galleryService.getCompatibleExtension(a);if(!l)throw new u.ExtensionManagementError(T.localize(5,null,a.identifier.id,b.default.version),u.INSTALL_ERROR_INCOMPATIBLE);return l}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(6,null));const l=await this.findGalleryExtension(a);if(!l)throw new Error(T.localize(7,null));await this.extensionsScanner.setUninstalled(a);try{await this.extensionsScanner.removeUninstalledExtension(a)}catch(P){throw new Error(T.localize(8,null,(0,s.toErrorMessage)(P)))}await this.installFromGallery(l)}getTelemetryEvent(a){return a===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(a){const l=await this.getExtensionsReport();return(0,R.getMaliciousExtensionsSet)(l).has(a.identifier.id)}async downloadInstallableExtension(a,l){const P={id:a.identifier.uuid,publisherId:a.publisherId,publisherDisplayName:a.publisherDisplayName};let S;try{this.logService.trace("Started downloading extension:",a.identifier.id),S=(await this.extensionsDownloader.downloadExtension(a,l)).fsPath,this.logService.info("Downloaded extension:",a.identifier.id,S)}catch(A){throw new u.ExtensionManagementError(this.joinErrors(A).message,ee)}try{const A=await(0,M.getManifest)(S);return{zipPath:S,identifierWithVersion:new R.ExtensionIdentifierWithVersion(a.identifier,A.version),metadata:P}}catch(A){throw new u.ExtensionManagementError(this.joinErrors(A).message,te)}}async installExtension(a,l){try{const P=await this.unsetUninstalledAndGetLocal(a.identifierWithVersion);if(P)return a.metadata?this.extensionsScanner.saveMetadataForLocalExtension(P,a.metadata):P}catch(P){throw O.isMacintosh?new u.ExtensionManagementError(T.localize(9,null),ie):new u.ExtensionManagementError(T.localize(10,null),ie)}return this.extractAndInstall(a,l)}async unsetUninstalledAndGetLocal(a){if(!await this.isUninstalled(a))return null;this.logService.trace("Removing the extension from uninstalled list:",a.id);const P=await this.extensionsScanner.setInstalled(a);return this.logService.info("Removed the extension from uninstalled list:",a.id),P}async extractAndInstall({zipPath:a,identifierWithVersion:l,metadata:P},S){let A=await this.extensionsScanner.extractUserExtension(l,a,S);return this.logService.info("Installation completed.",l.id),P&&(A=await this.extensionsScanner.saveMetadataForLocalExtension(A,P)),A}async installDependenciesAndPackExtensions(a,l,P){if(!!this.galleryService.isEnabled()){const S=a.manifest.extensionDependencies||[];if(a.manifest.extensionPack)for(const A of a.manifest.extensionPack)l&&l.manifest.extensionPack&&l.manifest.extensionPack.some(j=>(0,R.areSameExtensions)({id:j},{id:A}))||S.every(j=>!(0,R.areSameExtensions)({id:j},{id:A}))&&S.push(A);if(S.length){const A=await this.getInstalled(),j=S.filter(B=>A.every(({identifier:_})=>!(0,R.areSameExtensions)(_,{id:B})));if(j.length){const _=(await this.galleryService.query({names:j,pageSize:S.length},E.CancellationToken.None)).firstPage;try{await y.Promises.settled(_.map(q=>this.installFromGallery(q,P)))}catch(q){try{await this.rollback(_)}catch(J){}throw q}}}}}async rollback(a){const P=(await this.getInstalled(1)).filter(S=>a.some(A=>new R.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).equals(new R.ExtensionIdentifierWithVersion(A.identifier,A.version))));await y.Promises.settled(P.map(S=>this.uninstall(S)))}async uninstall(a,l={}){this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id);const P=await this.getInstalled(1),S=P.find(A=>(0,R.areSameExtensions)(A.identifier,a.identifier));if(!S)throw new Error(T.localize(11,null,a.manifest.displayName||a.manifest.name));try{await this.checkForDependenciesAndUninstall(S,P,l)}catch(A){throw this.joinErrors(A)}}async updateMetadata(a,l){return this.logService.trace("ExtensionManagementService#updateMetadata",a.identifier.id),a=await this.extensionsScanner.saveMetadataForLocalExtension(a,Object.assign(Object.assign({},a.manifest.__metadata||{}),l)),this.manifestCache.invalidate(),a}async updateExtensionScope(a,l){return this.logService.trace("ExtensionManagementService#updateExtensionScope",a.identifier.id),a=await this.extensionsScanner.saveMetadataForLocalExtension(a,Object.assign(Object.assign({},a.manifest.__metadata||{}),{isMachineScoped:l})),this.manifestCache.invalidate(),a}async getGalleryMetadata(a){const l=await this.findGalleryExtensionByName(a);return l?{id:l.identifier.uuid,publisherDisplayName:l.publisherDisplayName,publisherId:l.publisherId}:void 0}async findGalleryExtension(a){if(a.identifier.uuid){const l=await this.findGalleryExtensionById(a.identifier.uuid);return l||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},E.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},E.CancellationToken.None)).firstPage[0]}joinErrors(a){const l=Array.isArray(a)?a:[a];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((P,S)=>new Error(`${P.message}${P.message?",":""}${S instanceof Error?S.message:S}`),new Error(""))}async checkForDependenciesAndUninstall(a,l,P){try{await this.preUninstallExtension(a);const S=P.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(a,l);await this.uninstallExtensions(a,S,l,P)}catch(S){throw await this.postUninstallExtension(a,new u.ExtensionManagementError(S instanceof Error?S.message:S,ae)),S}await this.postUninstallExtension(a)}async uninstallExtensions(a,l,P,S){const A=[a,...l];if(!S.donotCheckDependents)for(const j of A)this.checkForDependents(j,A,P,a);await y.Promises.settled([this.uninstallExtension(a),...l.map(j=>this.doUninstall(j))])}checkForDependents(a,l,P,S){const A=this.getDependents(a,P);if(A.length){const j=A.filter(B=>l.indexOf(B)===-1);if(j.length)throw new Error(this.getDependentsErrorMessage(a,j,S))}}getDependentsErrorMessage(a,l,P){return P===a?l.length===1?T.localize(12,null,P.manifest.displayName||P.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?T.localize(13,null,P.manifest.displayName||P.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):T.localize(14,null,P.manifest.displayName||P.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):l.length===1?T.localize(15,null,P.manifest.displayName||P.manifest.name,a.manifest.displayName||a.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?T.localize(16,null,P.manifest.displayName||P.manifest.name,a.manifest.displayName||a.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):T.localize(17,null,P.manifest.displayName||P.manifest.name,a.manifest.displayName||a.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name)}getAllPackExtensionsToUninstall(a,l,P=[]){if(P.indexOf(a)!==-1)return[];P.push(a);const S=a.manifest.extensionPack?a.manifest.extensionPack:[];if(S.length){const A=l.filter(B=>!B.isBuiltin&&S.some(_=>(0,R.areSameExtensions)({id:_},B.identifier))),j=[];for(const B of A)j.push(...this.getAllPackExtensionsToUninstall(B,l,P));return[...A,...j]}return[]}getDependents(a,l){return l.filter(P=>P.manifest.extensionDependencies&&P.manifest.extensionDependencies.some(S=>(0,R.areSameExtensions)({id:S},a.identifier)))}async doUninstall(a){try{await this.preUninstallExtension(a),await this.uninstallExtension(a)}catch(l){throw await this.postUninstallExtension(a,new u.ExtensionManagementError(l instanceof Error?l.message:l,ae)),l}await this.postUninstallExtension(a)}async preUninstallExtension(a){if(!await w.exists(a.location.fsPath))throw new Error(T.localize(18,null));this.logService.info("Uninstalling extension:",a.identifier.id),this._onUninstallExtension.fire(a.identifier)}async uninstallExtension(a){let l=this.uninstallingExtensions.get(a.identifier.id);return l||(l=(0,y.createCancelablePromise)(async()=>{const P=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...P.filter(S=>(0,R.areSameExtensions)(S.identifier,a.identifier)))}),this.uninstallingExtensions.set(a.identifier.id,l),l.finally(()=>this.uninstallingExtensions.delete(a.identifier.id))),l}async postUninstallExtension(a,l){if(l)this.logService.error("Failed to uninstall extension:",a.identifier.id,l.message);else if(this.logService.info("Successfully uninstalled extension:",a.identifier.id),a.identifier.uuid)try{await this.galleryService.reportStatistic(a.manifest.publisher,a.manifest.name,a.manifest.version,"uninstall")}catch(S){}this.reportTelemetry("extensionGallery:uninstall",(0,R.getLocalExtensionTelemetryData)(a),void 0,l);const P=l?l instanceof u.ExtensionManagementError?l.code:W:void 0;this._onDidUninstallExtension.fire({identifier:a.identifier,error:P})}getInstalled(a=null){return this.extensionsScanner.scanExtensions(a)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(a){return(await this.filterUninstalled(a)).length===1}async filterUninstalled(...a){const l=[],P=await this.extensionsScanner.getUninstalledExtensions();for(const S of a)P[S.key()]&&l.push(S.key());return l}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(a,l,P,S){const A=S?S instanceof u.ExtensionManagementError?S.code:W:void 0;this.telemetryService.publicLogError(a,Object.assign(Object.assign({},l),{success:!S,duration:P,errorcode:A}))}};G=ce([ue(0,v.INativeEnvironmentService),ue(1,u.IExtensionGalleryService),ue(2,C.ILogService),ue(3,(0,c.optional)(o.IDownloadService)),ue(4,r.ITelemetryService),ue(5,c.IInstantiationService),ue(6,X.IFileService)],G),t.ExtensionManagementService=G}),define(Q[124],Z([0,1,133,113,2,11,12,112,27,15,16,22,99]),function($,t,p,T,I,w,F,L,f,u,R,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let D=class extends I.Disposable{constructor(d,b,O){super();this.environmentService=b,this.logService=O,this.configure(d.getValue()),this._register(d.onDidChangeConfiguration(()=>this.configure(d.getValue()),this))}configure(d){this.proxyUrl=d.http&&d.http.proxy,this.strictSSL=!!(d.http&&d.http.proxyStrictSSL),this.authorization=d.http&&d.http.proxyAuthorization}async request(d,b){this.logService.trace("RequestService#request",d.url);const{proxyUrl:O,strictSSL:C}=this,m=Object.assign(Object.assign({},process.env),await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),s=d.agent?d.agent:await(0,L.getProxyAgent)(d.url||"",m,{proxyUrl:O,strictSSL:C});return d.agent=s,d.strictSSL=C,this.authorization&&(d.headers=Object.assign(Object.assign({},d.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(d,b)}async getNodeRequest(d){return((0,T.parse)(d.url).protocol==="https:"?await new Promise((C,m)=>{$(["https"],C,m)}):await new Promise((C,m)=>{$(["http"],C,m)})).request}_request(d,b){return new Promise(async(O,C)=>{let m;const s=(0,T.parse)(d.url),r=d.getRawRequest?d.getRawRequest(d):await this.getNodeRequest(d),e={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,w.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(e.auth=d.user+":"+d.password),m=r(e,i=>{const n=(0,w.isNumber)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},d),{url:i.headers.location,followRedirects:n-1}),b).then(O,C);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,p.createGunzip)())),O({res:i,stream:(0,R.streamToBufferReadableStream)(o)})}}),m.on("error",C),d.timeout&&m.setTimeout(d.timeout),d.data&&typeof d.data=="string"&&m.write(d.data),m.end(),b.onCancellationRequested(()=>{m.abort(),C((0,F.canceled)())})})}async resolveProxy(d){}};D=ce([ue(0,f.IConfigurationService),ue(1,v.INativeEnvironmentService),ue(2,u.ILogService)],D),t.RequestService=D}),define(Q[134],Z([0,1,32,18,135,3,4,40,51,49,101,22,89,24,123,117,42,55,118,116,54,124,27,111,119,15,8,106,120,107,19,108,2,41,97,7,105,52,12,29,16,34]),function($,t,p,T,I,w,F,L,f,u,R,v,y,D,h,d,b,O,C,m,s,r,e,i,n,o,c,g,E,M,N,k,U,x,X,ie,ee,te,ae,W,G,V){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class a extends U.Disposable{constructor(S){super();this.argv=S,(0,I.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[S,A]=await this.initServices();return S.invokeFunction(async j=>{const B=j.get(o.ILogService),_=j.get(N.IFileService),q=j.get(v.INativeEnvironmentService),J=j.get(D.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun(q,J,_),(0,F.raceTimeout)((0,O.combinedAppender)(...A).flush(),1e3)})}async initServices(){const S=new f.ServiceCollection,A=Object.assign({_serviceBrand:void 0},L.default);S.set(x.IProductService,A);const j=new y.NativeEnvironmentService(this.argv,A);S.set(v.INativeEnvironmentService,j),await Promise.all([j.appSettingsHome.fsPath,j.extensionsPath].map(he=>he?T.promises.mkdir(he,{recursive:!0}):void 0));const B=(0,o.getLogLevel)(j),_=[];_.push(new g.SpdLogLogger("cli",(0,w.join)(j.logsPath,"cli.log"),!0,B)),B===o.LogLevel.Trace&&_.push(new o.ConsoleLogger(B));const q=this._register(new o.MultiplexLogService(_));S.set(o.ILogService,q);const J=this._register(new M.FileService(q));S.set(N.IFileService,J);const Y=this._register(new k.DiskFileSystemProvider(q));J.registerProvider(c.Schemas.file,Y);const ne=this._register(new i.ConfigurationService(j.settingsResource,J));S.set(e.IConfigurationService,ne),await ne.initialize(),S.set(s.IRequestService,new u.SyncDescriptor(r.RequestService)),S.set(D.IExtensionManagementService,new u.SyncDescriptor(h.ExtensionManagementService)),S.set(D.IExtensionGalleryService,new u.SyncDescriptor(d.ExtensionGalleryService)),S.set(D.IExtensionManagementCLIService,new u.SyncDescriptor(X.ExtensionManagementCLIService)),S.set(te.ILocalizationsService,new u.SyncDescriptor(ee.LocalizationsService));const re=[];if(j.isBuilt&&!j.isExtensionDevelopment&&!j.disableTelemetry&&A.enableTelemetry){A.aiConfig&&A.aiConfig.asimovKey&&re.push(new n.AppInsightsAppender("monacoworkbench",null,A.aiConfig.asimovKey));const{appRoot:he,extensionsPath:me,installSourcePath:De}=j,Oe={appender:(0,O.combinedAppender)(...re),sendErrorTelemetry:!1,commonProperties:(async()=>{let Fe;try{const be=await T.promises.readFile((0,w.join)(j.userDataPath,"storage.json"));Fe=JSON.parse(be.toString())[b.machineIdKey]}catch(be){be.code!=="ENOENT"&&q.error(be)}return(0,m.resolveCommonProperties)(J,(0,p.release)(),(0,p.hostname)(),process.arch,A.commit,A.version,Fe,A.msftInternalDomains,De)})(),piiPaths:[he,me]};S.set(b.ITelemetryService,new u.SyncDescriptor(C.TelemetryService,[Oe]))}else S.set(b.ITelemetryService,O.NullTelemetryService);return[new R.InstantiationService(S),re]}registerErrorHandler(S){(0,ae.setUnexpectedErrorHandler)(A=>{const j=(0,W.toErrorMessage)(A,!0);!j||S.error(`[uncaught exception in CLI]: ${j}`)})}async doRun(S,A,j){if(this.argv["install-source"])return this.setInstallSource(S,j,this.argv["install-source"]);if(this.argv["list-extensions"])return A.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return A.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return A.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return A.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,E.buildTelemetryMessage)(S.appRoot,S.extensionsPath))}asExtensionIdOrVSIX(S){return S.map(A=>/\.vsix$/i.test(A)?ie.URI.file((0,w.isAbsolute)(A)?A:(0,w.join)((0,V.cwd)(),A)):A)}async setInstallSource(S,A,j){await A.writeFile(ie.URI.file(S.installSourcePath),G.VSBuffer.fromString(j.slice(0,30)))}}async function l(P){const S=new a(P);try{await S.run()}finally{S.dispose()}}t.main=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6bee0f2f3fea9df1ad45344f09b2a139c93b384f/core/vs/code/node/cliProcessMain.js.map
