/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/platform","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/extpath","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/processes","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(G){for(var e=[],b=0,I=G.length;b<I;b++)e[b]=ge[G[b]];return e};define(ge[52],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(I,T){if(!I)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=b}),define(ge[53],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function I(C){const f=[];for(let g in C)b.call(C,g)&&f.push(C[g]);return f}e.values=I;function T(C,f){for(let g in C)if(b.call(C,g)&&f({key:g,value:C[g]},function(){delete C[g]})===!1)return}e.forEach=T;function A(C,f){const g=Object.create(null);for(const a of C){const d=f(a);let E=g[d];E||(E=g[d]=[]),E.push(a)}return g}e.groupBy=A;function y(C,f){const g=new Map;for(const a of C){const d=f(a);let E=g.get(d);E||(E=[],g.set(d,E)),E.push(a)}return g}e.groupByNumber=y;function P(C){const f=Object.create(null);return C&&C.forEach((g,a)=>{f[a]=g}),f}e.fromMap=P;function D(C,f){const g=[],a=[];for(let d of C)f.has(d)||g.push(d);for(let d of f)C.has(d)||a.push(d);return{removed:g,added:a}}e.diffSets=D;function k(C,f){const g=[],a=[];for(let[d,E]of C)f.has(d)||g.push(E);for(let[d,E]of f)C.has(d)||a.push(E);return{removed:g,added:a}}e.diffMaps=k;class r{constructor(){this.map=new Map}add(f,g){let a=this.map.get(f);a||(a=new Set,this.map.set(f,a)),a.add(g)}delete(f,g){const a=this.map.get(f);!a||(a.delete(g),a.size===0&&this.map.delete(f))}forEach(f,g){const a=this.map.get(f);!a||a.forEach(g)}}e.SetMap=r}),define(ge[70],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function b(y){return(P,D,k)=>{let r=null,C=null;if(typeof k.value=="function"?(r="value",C=k.value):typeof k.get=="function"&&(r="get",C=k.get),!C)throw new Error("not supported");k[r]=y(C,D)}}e.createDecorator=b;function I(y,P,D){let k=null,r=null;if(typeof D.value=="function"?(k="value",r=D.value,r.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(k="get",r=D.get),!r)throw new Error("not supported");const C=`$memoize$${P}`;D[k]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:r.apply(this,f)}),this[C]}}e.memoize=I;function T(y,P,D){return b((k,r)=>{const C=`$debounce$${r}`,f=`$debounce$result$${r}`;return function(...g){this[f]||(this[f]=D?D():void 0),clearTimeout(this[C]),P&&(this[f]=P(this[f],...g),g=[this[f]]),this[C]=setTimeout(()=>{k.apply(this,g),this[f]=D?D():void 0},y)}})}e.debounce=T;function A(y,P,D){return b((k,r)=>{const C=`$throttle$timer$${r}`,f=`$throttle$result$${r}`,g=`$throttle$lastRun$${r}`,a=`$throttle$pending$${r}`;return function(...d){if(this[f]||(this[f]=D?D():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...d)),!this[a]){const E=this[g]+y;E<=Date.now()?(this[g]=Date.now(),k.apply(this,[this[f]]),this[f]=D?D():void 0):(this[a]=!0,this[C]=setTimeout(()=>{this[a]=!1,this[g]=Date.now(),k.apply(this,[this[f]]),this[f]=D?D():void 0},E-Date.now()))}}})}e.throttle=A}),define(ge[16],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function I(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=I;function T(v){D(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=T;function A(v){D(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=A;function y(v){if(v instanceof Error){let{name:t,message:n}=v;const o=v.stacktrace||v.stack;return{$isError:!0,name:t,message:n,stack:o}}return v}e.transformErrorForSerialization=y;const P="Canceled";function D(v){return v instanceof Error&&v.name===P&&v.message===P}e.isPromiseCanceledError=D;class k extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=k;function r(){const v=new Error(P);return v.name=v.message,v}e.canceled=r;function C(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=C;function f(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=f;function g(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function a(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function d(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=d;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function m(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=m;function l(v,t=Object.create(null)){const n=new Error(v);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=l}),define(ge[17],pe([0,1,16]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(U,M=0){return U[U.length-(1+M)]}e.tail=I;function T(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=T;function A(U,M,F=(L,N)=>L===N){if(U===M)return!0;if(!U||!M||U.length!==M.length)return!1;for(let L=0,N=U.length;L<N;L++)if(!F(U[L],M[L]))return!1;return!0}e.equals=A;function y(U,M,F){let L=0,N=U.length-1;for(;L<=N;){const $=(L+N)/2|0,q=F(U[$],M);if(q<0)L=$+1;else if(q>0)N=$-1;else return $}return-(L+1)}e.binarySearch=y;function P(U,M){let F=0,L=U.length;if(L===0)return 0;for(;F<L;){const N=Math.floor((F+L)/2);M(U[N])?L=N:F=N+1}return F}e.findFirstInSorted=P;function D(U,M,F){if(U=U|0,U>=M.length)throw new TypeError("invalid index");let L=M[Math.floor(M.length*Math.random())],N=[],$=[],q=[];for(let Q of M){const de=F(Q,L);de<0?N.push(Q):de>0?$.push(Q):q.push(Q)}return U<N.length?D(U,N,F):U<N.length+q.length?q[0]:D(U-(N.length+q.length),$,F)}e.quickSelect=D;function k(U,M){const F=[];let L;for(const N of U.slice(0).sort(M))!L||M(L[0],N)!==0?(L=[N],F.push(L)):L.push(N);return F}e.groupBy=k;function r(U,M,F){const L=[];function N(Q,de,be){if(!(de===0&&be.length===0)){const Ae=L[L.length-1];Ae&&Ae.start+Ae.deleteCount===Q?(Ae.deleteCount+=de,Ae.toInsert.push(...be)):L.push({start:Q,deleteCount:de,toInsert:be})}}let $=0,q=0;for(;;){if($===U.length){N($,0,M.slice(q));break}if(q===M.length){N($,U.length-$,[]);break}const Q=U[$],de=M[q],be=F(Q,de);be===0?($+=1,q+=1):be<0?(N($,1,[]),$+=1):be>0&&(N($,0,[de]),q+=1)}return L}e.sortedDiff=r;function C(U,M,F){const L=r(U,M,F),N=[],$=[];for(const q of L)N.push(...U.slice(q.start,q.start+q.deleteCount)),$.push(...q.toInsert);return{removed:N,added:$}}e.delta=C;function f(U,M,F){if(F===0)return[];const L=U.slice(0,F).sort(M);return a(U,M,L,F,U.length),L}e.top=f;function g(U,M,F,L,N){return F===0?Promise.resolve([]):new Promise(($,q)=>{(async()=>{const Q=U.length,de=U.slice(0,F).sort(M);for(let be=F,Ae=Math.min(F+L,Q);be<Q;be=Ae,Ae=Math.min(Ae+L,Q)){if(be>F&&await new Promise(Ce=>setTimeout(Ce)),N&&N.isCancellationRequested)throw(0,b.canceled)();a(U,M,de,be,Ae)}return de})().then($,q)})}e.topAsync=g;function a(U,M,F,L,N){for(const $=F.length;L<N;L++){const q=U[L];if(M(q,F[$-1])<0){F.pop();const Q=P(F,de=>M(q,de)<0);F.splice(Q,0,q)}}}function d(U){return U.filter(M=>!!M)}e.coalesce=d;function E(U){let M=0;for(let F=0;F<U.length;F++)U[F]&&(U[M]=U[F],M+=1);U.length=M}e.coalesceInPlace=E;function w(U,M,F){U.splice(F,0,U.splice(M,1)[0])}e.move=w;function S(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=S;function m(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=m;function l(U,M){if(!M)return U.filter((L,N)=>U.indexOf(L)===N);const F=Object.create(null);return U.filter(L=>{const N=M(L);return F[N]?!1:(F[N]=!0,!0)})}e.distinct=l;function v(U){const M=new Set;return U.filter(F=>M.has(F)?!1:(M.add(F),!0))}e.distinctES6=v;function t(U){const M=Object.create(null);return F=>{const L=U(F);return M[L]?!1:(M[L]=!0,!0)}}e.uniqueFilter=t;function n(U,M){for(let F=U.length-1;F>=0;F--){const L=U[F];if(M(L))return F}return-1}e.lastIndex=n;function o(U,M){return U.length>0?U[0]:M}e.firstOrDefault=o;function i(U,M,F=(L,N)=>L===N){let L=0;for(let N=0,$=Math.min(U.length,M.length);N<$&&F(U[N],M[N]);N++)L++;return L}e.commonPrefixLength=i;function s(U){return[].concat(...U)}e.flatten=s;function c(U,M){let F=typeof M=="number"?U:0;typeof M=="number"?F=U:(F=0,M=U);const L=[];if(F<=M)for(let N=F;N<M;N++)L.push(N);else for(let N=F;N>M;N--)L.push(N);return L}e.range=c;function h(U,M,F){return U.reduce((L,N)=>(L[M(N)]=F?F(N):N,L),Object.create(null))}e.index=h;function _(U,M){return U.push(M),()=>u(U,M)}e.insert=_;function u(U,M){const F=U.indexOf(M);if(F>-1)return U.splice(F,1),M}e.remove=u;function p(U,M,F){const L=U.slice(0,M),N=U.slice(M);return L.concat(F,N)}e.arrayInsert=p;function R(U,M){let F;if(typeof M=="number"){let L=M;F=()=>{const N=Math.sin(L++)*179426549;return N-Math.floor(N)}}else F=Math.random;for(let L=U.length-1;L>0;L-=1){const N=Math.floor(F()*(L+1)),$=U[L];U[L]=U[N],U[N]=$}}e.shuffle=R;function O(U,M){const F=U.indexOf(M);F>-1&&(U.splice(F,1),U.unshift(M))}e.pushToStart=O;function V(U,M){const F=U.indexOf(M);F>-1&&(U.splice(F,1),U.push(M))}e.pushToEnd=V;function re(U,M){return Array.isArray(U)?U.map(M):M(U)}e.mapArrayOrNot=re;function j(U){return Array.isArray(U)?U:[U]}e.asArray=j;function x(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=x;function W(U,M){for(const F of U){const L=M(F);if(L!==void 0)return L}}e.mapFind=W}),define(ge[71],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(I){const T=this;let A=!1,y;return function(){return A||(A=!0,y=I.apply(T,arguments)),y}}e.once=b}),define(ge[72],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(ge[54],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(I){function T(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}I.is=T;const A=Object.freeze([]);function y(){return A}I.empty=y;function*P(v){yield v}I.single=P;function D(v){return v||A}I.from=D;function k(v){return!v||v[Symbol.iterator]().next().done===!0}I.isEmpty=k;function r(v){return v[Symbol.iterator]().next().value}I.first=r;function C(v,t){for(const n of v)if(t(n))return!0;return!1}I.some=C;function f(v,t){for(const n of v)if(t(n))return n}I.find=f;function*g(v,t){for(const n of v)t(n)&&(yield n)}I.filter=g;function*a(v,t){for(const n of v)yield t(n)}I.map=a;function*d(...v){for(const t of v)for(const n of t)yield n}I.concat=d;function*E(v){for(const t of v)for(const n of t)yield n}I.concatNested=E;function w(v,t,n){let o=n;for(const i of v)o=t(o,i);return o}I.reduce=w;function*S(v,t,n=v.length){for(t<0&&(t+=v.length),n<0?n+=v.length:n>v.length&&(n=v.length);t<n;t++)yield v[t]}I.slice=S;function m(v,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,v];const o=v[Symbol.iterator]();for(let i=0;i<t;i++){const s=o.next();if(s.done)return[n,I.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return o}}]}I.consume=m;function l(v,t,n=(o,i)=>o===i){const o=v[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const s=o.next(),c=i.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!n(s.value,c.value))return!1}}I.equals=l})(b=e.Iterable||(e.Iterable={}))}),define(ge[55],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let o=0,i=t.length,s="",c=0,h=16,_=0;function u(x){let W=0,U=0;for(;W<x;){const M=t.charCodeAt(o);if(M>=48&&M<=57)U=U*16+M-48;else if(M>=65&&M<=70)U=U*16+M-65+10;else if(M>=97&&M<=102)U=U*16+M-97+10;else break;o++,W++}return W<x&&(U=-1),U}function p(x){o=x,s="",c=0,h=16,_=0}function R(){const x=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&k(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&k(t.charCodeAt(o)))for(o++;o<t.length&&k(t.charCodeAt(o));)o++;else return _=3,t.substring(x,o);let W=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&k(t.charCodeAt(o))){for(o++;o<t.length&&k(t.charCodeAt(o));)o++;W=o}else _=3;return t.substring(x,W)}function O(){let x="",W=o;for(;;){if(o>=i){x+=t.substring(W,o),_=2;break}const U=t.charCodeAt(o);if(U===34){x+=t.substring(W,o),o++;break}if(U===92){if(x+=t.substring(W,o),o++,o>=i){_=2;break}switch(t.charCodeAt(o++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const F=u(4);F>=0?x+=String.fromCharCode(F):_=4;break;default:_=5}W=o;continue}if(U>=0&&U<=31)if(D(U)){x+=t.substring(W,o),_=2;break}else _=6;o++}return x}function V(){if(s="",_=0,c=o,o>=i)return c=i,h=17;let x=t.charCodeAt(o);if(P(x)){do o++,s+=String.fromCharCode(x),x=t.charCodeAt(o);while(P(x));return h=15}if(D(x))return o++,s+=String.fromCharCode(x),x===13&&t.charCodeAt(o)===10&&(o++,s+=`
`),h=14;switch(x){case 123:return o++,h=1;case 125:return o++,h=2;case 91:return o++,h=3;case 93:return o++,h=4;case 58:return o++,h=6;case 44:return o++,h=5;case 34:return o++,s=O(),h=10;case 47:const W=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<i&&!D(t.charCodeAt(o));)o++;return s=t.substring(W,o),h=12}if(t.charCodeAt(o+1)===42){o+=2;const U=i-1;let M=!1;for(;o<U;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,M=!0;break}o++}return M||(o++,_=1),s=t.substring(W,o),h=13}return s+=String.fromCharCode(x),o++,h=16;case 45:if(s+=String.fromCharCode(x),o++,o===i||!k(t.charCodeAt(o)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=R(),h=11;default:for(;o<i&&re(x);)o++,x=t.charCodeAt(o);if(c!==o){switch(s=t.substring(c,o),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode(x),o++,h=16}}function re(x){if(P(x)||D(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let x;do x=V();while(x>=12&&x<=15);return x}return{setPosition:p,getPosition:()=>o,scan:n?j:V,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>o-c,getTokenError:()=>_}}e.createScanner=y;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function C(t,n){const o=[],i=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function _(u,p,R,O){c.value=u,c.offset=p,c.length=R,c.type=O,c.colonOffset=void 0,s=c}try{m(t,{onObjectBegin:(u,p)=>{if(n<=u)throw i;s=void 0,h=n>u,o.push("")},onObjectProperty:(u,p,R)=>{if(n<p||(_(u,p,R,"property"),o[o.length-1]=u,n<=p+R))throw i},onObjectEnd:(u,p)=>{if(n<=u)throw i;s=void 0,o.pop()},onArrayBegin:(u,p)=>{if(n<=u)throw i;s=void 0,o.push(0)},onArrayEnd:(u,p)=>{if(n<=u)throw i;s=void 0,o.pop()},onLiteralValue:(u,p,R)=>{if(n<p||(_(u,p,R,v(u)),n<=p+R))throw i},onSeparator:(u,p,R)=>{if(n<=p)throw i;if(u===":"&&s&&s.type==="property")s.colonOffset=p,h=!1,s=void 0;else if(u===","){const O=o[o.length-1];typeof O=="number"?o[o.length-1]=O+1:(h=!0,o[o.length-1]=""),s=void 0}}})}catch(u){if(u!==i)throw u}return{path:o,previousNode:s,isAtPropertyKey:h,matches:u=>{let p=0;for(let R=0;p<u.length&&R<o.length;R++)if(u[p]===o[R]||u[p]==="*")p++;else if(u[p]!=="**")return!1;return p===u.length}}}e.getLocation=C;function f(t,n=[],o=A.DEFAULT){let i=null,s=[];const c=[];function h(u){Array.isArray(s)?s.push(u):i!==null&&(s[i]=u)}return m(t,{onObjectBegin:()=>{const u={};h(u),c.push(s),s=u,i=null},onObjectProperty:u=>{i=u},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const u=[];h(u),c.push(s),s=u,i=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:h,onError:(u,p,R)=>{n.push({error:u,offset:p,length:R})}},o),s[0]}e.parse=f;function g(t,n=[],o=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(u){i.type==="property"&&(i.length=u-i.offset,i=i.parent)}function c(u){return i.children.push(u),u}m(t,{onObjectBegin:u=>{i=c({type:"object",offset:u,length:-1,parent:i,children:[]})},onObjectProperty:(u,p,R)=>{i=c({type:"property",offset:p,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:u,offset:p,length:R,parent:i})},onObjectEnd:(u,p)=>{i.length=u+p-i.offset,i=i.parent,s(u+p)},onArrayBegin:(u,p)=>{i=c({type:"array",offset:u,length:-1,parent:i,children:[]})},onArrayEnd:(u,p)=>{i.length=u+p-i.offset,i=i.parent,s(u+p)},onLiteralValue:(u,p,R)=>{c({type:v(u),offset:p,length:R,parent:i,value:u}),s(p+R)},onSeparator:(u,p,R)=>{i.type==="property"&&(u===":"?i.colonOffset=p:u===","&&s(p))},onError:(u,p,R)=>{n.push({error:u,offset:p,length:R})}},o);const _=i.children[0];return _&&delete _.parent,_}e.parseTree=g;function a(t,n){if(!!t){let o=t;for(let i of n)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const c of o.children)if(Array.isArray(c.children)&&c.children[0].value===i){o=c.children[1],s=!0;break}if(!s)return}else{const s=i;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}}e.findNodeAtLocation=a;function d(t){if(!t.parent||!t.parent.children)return[];const n=d(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;n.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&n.push(o)}return n}e.getNodePath=d;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let o of t.children){const i=o.children[1];i&&(n[o.children[0].value]=E(i))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function w(t,n,o=!1){return n>=t.offset&&n<t.offset+t.length||o&&n===t.offset+t.length}e.contains=w;function S(t,n,o=!1){if(w(t,n,o)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=n;s++){const c=S(i[s],n,o);if(c)return c}return t}}e.findNodeAtOffset=S;function m(t,n,o=A.DEFAULT){const i=y(t,!1);function s(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(de){return de?be=>de(be,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=s(n.onObjectBegin),_=c(n.onObjectProperty),u=s(n.onObjectEnd),p=s(n.onArrayBegin),R=s(n.onArrayEnd),O=c(n.onLiteralValue),V=c(n.onSeparator),re=s(n.onComment),j=c(n.onError),x=o&&o.disallowComments,W=o&&o.allowTrailingComma;function U(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:x||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(de){case 12:case 13:x?M(10):re();break;case 16:M(1);break;case 15:case 14:break;default:return de}}}function M(de,be=[],Ae=[]){if(j(de),be.length+Ae.length>0){let Ce=i.getToken();for(;Ce!==17;){if(be.indexOf(Ce)!==-1){U();break}else if(Ae.indexOf(Ce)!==-1)break;Ce=U()}}}function F(de){const be=i.getTokenValue();return de?O(be):_(be),U(),!0}function L(){switch(i.getToken()){case 11:let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(M(2),de=0)}catch(be){M(2)}O(de);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return U(),!0}function N(){return i.getToken()!==10?(M(3,[],[2,5]),!1):(F(!1),i.getToken()===6?(V(":"),U(),Q()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function $(){h(),U();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||M(4,[],[]),V(","),U(),i.getToken()===2&&W)break}else de&&M(6,[],[]);N()||M(4,[],[2,5]),de=!0}return u(),i.getToken()!==2?M(7,[2],[]):U(),!0}function q(){p(),U();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||M(4,[],[]),V(","),U(),i.getToken()===4&&W)break}else de&&M(6,[],[]);Q()||M(4,[],[4,5]),de=!0}return R(),i.getToken()!==4?M(8,[4],[]):U(),!0}function Q(){switch(i.getToken()){case 3:return q();case 1:return $();case 10:return F(!0);default:return L()}}return U(),i.getToken()===17?o.allowEmptyContent?!0:(M(4,[],[]),!1):Q()?(i.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=m;function l(t,n){let o=y(t),i=[],s,c=0,h;do switch(h=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:c!==h&&i.push(t.substring(c,h)),n!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),c=o.getPosition();break}while(s!==17);return i.join("")}e.stripComments=l;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(ge[133],pe([0,1,55]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(D,k,r){let C,f,g,a,d;if(k){for(a=k.offset,d=a+k.length,g=a;g>0&&!P(D,g-1);)g--;let c=d;for(;c<D.length&&!P(D,c);)c++;f=D.substring(g,c),C=A(f,r)}else f=D,C=0,g=0,a=0,d=D.length;const E=y(r,D);let w=!1,S=0,m;r.insertSpaces?m=T(" ",r.tabSize||4):m="	";const l=(0,b.createScanner)(f,!1);let v=!1;function t(){return E+T(m,C+S)}function n(){let c=l.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=l.scan();return v=c===16||l.getTokenError()!==0,c}const o=[];function i(c,h,_){!v&&h<d&&_>a&&D.substring(h,_)!==c&&o.push({offset:h,length:_-h,content:c})}let s=n();if(s!==17){const c=l.getTokenOffset()+g,h=T(m,C);i(h,g,c)}for(;s!==17;){let c=l.getTokenOffset()+l.getTokenLength()+g,h=n(),_="";for(;!w&&(h===12||h===13);){const p=l.getTokenOffset()+g;i(" ",c,p),c=l.getTokenOffset()+l.getTokenLength()+g,_=h===12?t():"",h=n()}if(h===2)s!==1&&(S--,_=t());else if(h===4)s!==3&&(S--,_=t());else{switch(s){case 3:case 1:S++,_=t();break;case 5:case 12:_=t();break;case 13:w?_=t():_=" ";break;case 6:_=" ";break;case 10:if(h===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?_=" ":h!==5&&h!==17&&(v=!0);break;case 16:v=!0;break}w&&(h===12||h===13)&&(_=t())}const u=l.getTokenOffset()+g;i(_,c,u),s=h}return o}e.format=I;function T(D,k){let r="";for(let C=0;C<k;C++)r+=D;return r}function A(D,k){let r=0,C=0;const f=k.tabSize||4;for(;r<D.length;){const g=D.charAt(r);if(g===" ")C++;else if(g==="	")C+=f;else break;r++}return Math.floor(C/f)}function y(D,k){for(let r=0;r<k.length;r++){const C=k.charAt(r);if(C==="\r")return r+1<k.length&&k.charAt(r+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function P(D,k){return`\r
`.indexOf(D.charAt(k))!==-1}e.isEOL=P}),define(ge[134],pe([0,1,55,133]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(k,r,C){return A(k,r,void 0,C)}e.removeProperty=T;function A(k,r,C,f,g){const a=r.slice(),d=[],E=(0,b.parseTree)(k,d);let w,S;for(;a.length>0&&(S=a.pop(),w=(0,b.findNodeAtLocation)(E,a),w===void 0&&C!==void 0);)typeof S=="string"?C={[S]:C}:C=[C];if(w)if(w.type==="object"&&typeof S=="string"&&Array.isArray(w.children)){const m=(0,b.findNodeAtLocation)(w,[S]);if(m!==void 0)if(C===void 0){if(!m.parent)throw new Error("Malformed AST");const l=w.children.indexOf(m.parent);let v,t=m.parent.offset+m.parent.length;if(l>0){const n=w.children[l-1];v=n.offset+n.length}else v=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return y(k,{offset:v,length:t-v,content:""},f)}else return y(k,{offset:m.offset,length:m.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const l=`${JSON.stringify(S)}: ${JSON.stringify(C)}`,v=g?g(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(v>0){const n=w.children[v-1];t={offset:n.offset+n.length,length:0,content:","+l}}else w.children.length===0?t={offset:w.offset+1,length:0,content:l}:t={offset:w.offset+1,length:0,content:l+","};return y(k,t,f)}}else if(w.type==="array"&&typeof S=="number"&&Array.isArray(w.children))if(C!==void 0){const m=`${JSON.stringify(C)}`;let l;if(w.children.length===0||S===0)l={offset:w.offset+1,length:0,content:w.children.length===0?m:m+","};else{const v=S===-1||S>w.children.length?w.children.length:S,t=w.children[v-1];l={offset:t.offset+t.length,length:0,content:","+m}}return y(k,l,f)}else{const m=S,l=w.children[m];let v;if(w.children.length===1)v={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===m){const t=w.children[m-1],n=t.offset+t.length,o=w.offset+w.length;v={offset:n,length:o-2-n,content:""}}else v={offset:l.offset,length:w.children[m+1].offset-l.offset,content:""};return y(k,v,f)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${w.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(C)},f)}}e.setProperty=A;function y(k,r,C){let f=P(k,r),g=r.offset,a=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;g>0&&!(0,I.isEOL)(f,g-1);)g--;for(;a<f.length&&!(0,I.isEOL)(f,a);)a++}const d=(0,I.format)(f,{offset:g,length:a-g},C);for(let w=d.length-1;w>=0;w--){const S=d[w];f=P(f,S),g=Math.min(g,S.offset),a=Math.max(a,S.offset+S.length),a+=S.content.length-S.length}const E=k.length-(f.length-a)-g;return[{offset:g,length:E,content:f.substring(g,a)}]}e.withFormatting=y;function P(k,r){return k.substring(0,r.offset)+r.content+k.substring(r.offset+r.length)}e.applyEdit=P;function D(k,r){let C=r.slice(0).sort((g,a)=>{const d=g.offset-a.offset;return d===0?g.length-a.length:d}),f=k.length;for(let g=C.length-1;g>=0;g--){let a=C[g];if(a.offset+a.length<=f)k=P(k,a);else throw new Error("Overlapping edit");f=a.offset}return k}e.applyEdits=D}),define(ge[135],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new b(()=>T(this.getValue()))}}e.Lazy=b}),define(ge[6],pe([0,1,71,54]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let A=null;function y(m){A=m}if(e.setDisposableTracker=y,T){const m="__is_disposable_tracked__";A=new class{trackDisposable(l){const v=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[m]||console.log(v)},3e3)}markTracked(l){if(l&&l!==d.None)try{l[m]=!0}catch(v){}}}}function P(m){!A||A.markTracked(m)}function D(m){return A&&A.trackDisposable(m),m}e.trackDisposable=D;class k extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=k;function r(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=r;function C(m){if(I.Iterable.is(m)){let l=[];for(const v of m)if(v){P(v);try{v.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new k(l);return Array.isArray(m)?[]:m}else if(m)return P(m),m.dispose(),m}e.dispose=C;function f(...m){return m.forEach(P),g(()=>C(m))}e.combinedDisposable=f;function g(m){const l=D({dispose:()=>{P(l),m()}});return l}e.toDisposable=g;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return P(l),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new a,D(this)}dispose(){P(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var v;this._isDisposed||l===this._value||((v=this._value)===null||v===void 0||v.dispose(),l&&P(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,P(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=E;class w{constructor(){this.references=new Map}acquire(l,...v){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...v)},this.references.set(l,t));const{object:n}=t,o=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:n,dispose:o}}}e.ReferenceCollection=w;class S{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=S}),define(ge[56],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(A){this.element=A,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class I{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let A=this._first;for(;A!==b.Undefined;){const y=A.next;A.prev=b.Undefined,A.next=b.Undefined,A=y}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,y){const P=new b(A);if(this._first===b.Undefined)this._first=P,this._last=P;else if(y){const k=this._last;this._last=P,P.prev=k,k.next=P}else{const k=this._first;this._first=P,P.next=k,k.prev=P}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(P))}}shift(){if(this._first!==b.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==b.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==b.Undefined&&A.next!==b.Undefined){const y=A.prev;y.next=A.next,A.next.prev=y}else A.prev===b.Undefined&&A.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):A.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):A.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==b.Undefined;)yield A.element,A=A.next}}e.LinkedList=I}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(K,se){for(var he=0;he<se.length;he++){var J=se[he];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(K,J.key,J)}}function e(K,se,he){return se&&G(K.prototype,se),he&&G(K,he),K}function b(K,se){if(!!K){if(typeof K=="string")return I(K,se);var he=Object.prototype.toString.call(K).slice(8,-1);if(he==="Object"&&K.constructor&&(he=K.constructor.name),he==="Map"||he==="Set")return Array.from(K);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return I(K,se)}}function I(K,se){(se==null||se>K.length)&&(se=K.length);for(var he=0,J=new Array(se);he<se;he++)J[he]=K[he];return J}function T(K,se){var he;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(he=b(K))||se&&K&&typeof K.length=="number"){he&&(K=he);var J=0;return function(){return J>=K.length?{done:!0}:{done:!1,value:K[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=K[Symbol.iterator](),he.next.bind(he)}function A(K){var se={exports:{}};return K(se,se.exports),se.exports}var y=A(function(K){function se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(J){K.exports.defaults=J}K.exports={defaults:se(),getDefaults:se,changeDefaults:he}}),P=/[&<>"']/,D=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,r=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(se){return C[se]};function g(K,se){if(se){if(P.test(K))return K.replace(D,f)}else if(k.test(K))return K.replace(r,f);return K}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(K){return K.replace(a,function(se,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var E=/(^|[^\[])\^/g;function w(K,se){K=K.source||K,se=se||"";var he={replace:function(te,ce){return ce=ce.source||ce,ce=ce.replace(E,"$1"),K=K.replace(te,ce),he},getRegex:function(){return new RegExp(K,se)}};return he}var S=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(K,se,he){if(K){var J;try{J=decodeURIComponent(d(he)).replace(S,"").toLowerCase()}catch(te){return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}se&&!m.test(he)&&(he=i(se,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(te){return null}return he}var v={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(K,se){v[" "+K]||(t.test(K)?v[" "+K]=K+"/":v[" "+K]=_(K,"/",!0)),K=v[" "+K];var he=K.indexOf(":")===-1;return se.substring(0,2)==="//"?he?se:K.replace(n,"$1")+se:se.charAt(0)==="/"?he?se:K.replace(o,"$1")+se:K+se}var s={exec:function(){}};function c(K){for(var se=1,he,J;se<arguments.length;se++){he=arguments[se];for(J in he)Object.prototype.hasOwnProperty.call(he,J)&&(K[J]=he[J])}return K}function h(K,se){var he=K.replace(/\|/g,function(ce,ve,ye){for(var je=!1,He=ve;--He>=0&&ye[He]==="\\";)je=!je;return je?"|":" |"}),J=he.split(/ \|/),te=0;if(J.length>se)J.splice(se);else for(;J.length<se;)J.push("");for(;te<J.length;te++)J[te]=J[te].trim().replace(/\\\|/g,"|");return J}function _(K,se,he){var J=K.length;if(J===0)return"";for(var te=0;te<J;){var ce=K.charAt(J-te-1);if(ce===se&&!he)te++;else if(ce!==se&&he)te++;else break}return K.substr(0,J-te)}function u(K,se){if(K.indexOf(se[1])===-1)return-1;for(var he=K.length,J=0,te=0;te<he;te++)if(K[te]==="\\")te++;else if(K[te]===se[0])J++;else if(K[te]===se[1]&&(J--,J<0))return te;return-1}function p(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(K,se){if(se<1)return"";for(var he="";se>1;)se&1&&(he+=K),se>>=1,K+=K;return he+K}var O={escape:g,unescape:d,edit:w,cleanUrl:l,resolveUrl:i,noopTest:s,merge:c,splitCells:h,rtrim:_,findClosingBracket:u,checkSanitizeDeprecation:p,repeatString:R},V=y.defaults,re=O.rtrim,j=O.splitCells,x=O.escape,W=O.findClosingBracket;function U(K,se,he){var J=se.href,te=se.title?x(se.title):null,ce=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:he,href:J,title:te,text:ce}:{type:"image",raw:he,href:J,title:te,text:x(ce)}}function M(K,se){var he=K.match(/^(\s+)(?:```)/);if(he===null)return se;var J=he[1];return se.split(`
`).map(function(te){var ce=te.match(/^\s+/);if(ce===null)return te;var ve=ce[0];return ve.length>=J.length?te.slice(J.length):te}).join(`
`)}var F=function(){function K(he){this.options=he||V}var se=K.prototype;return se.space=function(J){var te=this.rules.block.newline.exec(J);if(te)return te[0].length>1?{type:"space",raw:te[0]}:{raw:`
`}},se.code=function(J){var te=this.rules.block.code.exec(J);if(te){var ce=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:re(ce,`
`)}}},se.fences=function(J){var te=this.rules.block.fences.exec(J);if(te){var ce=te[0],ve=M(ce,te[3]||"");return{type:"code",raw:ce,lang:te[2]?te[2].trim():te[2],text:ve}}},se.heading=function(J){var te=this.rules.block.heading.exec(J);if(te){var ce=te[2].trim();if(/#$/.test(ce)){var ve=re(ce,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(ce=ve.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:ce}}},se.nptable=function(J){var te=this.rules.block.nptable.exec(J);if(te){var ce={type:"table",header:j(te[1].replace(/^ *| *\| *$/g,"")),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:te[3]?te[3].replace(/\n$/,"").split(`
`):[],raw:te[0]};if(ce.header.length===ce.align.length){var ve=ce.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(ce.align[ye])?ce.align[ye]="right":/^ *:-+: *$/.test(ce.align[ye])?ce.align[ye]="center":/^ *:-+ *$/.test(ce.align[ye])?ce.align[ye]="left":ce.align[ye]=null;for(ve=ce.cells.length,ye=0;ye<ve;ye++)ce.cells[ye]=j(ce.cells[ye],ce.header.length);return ce}}},se.hr=function(J){var te=this.rules.block.hr.exec(J);if(te)return{type:"hr",raw:te[0]}},se.blockquote=function(J){var te=this.rules.block.blockquote.exec(J);if(te){var ce=te[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:te[0],text:ce}}},se.list=function(J){var te=this.rules.block.list.exec(J);if(te){var ce=te[0],ve=te[2],ye=ve.length>1,je={type:"list",raw:ce,ordered:ye,start:ye?+ve.slice(0,-1):"",loose:!1,items:[]},He=te[0].match(this.rules.block.item),We=!1,Ge,nt,dt,it,Ye,mt,wt,Ee,fe=He.length;dt=this.rules.block.listItemStart.exec(He[0]);for(var le=0;le<fe;le++){if(Ge=He[le],ce=Ge,le!==fe-1){if(it=this.rules.block.listItemStart.exec(He[le+1]),this.options.pedantic?it[1].length>dt[1].length:it[1].length>dt[0].length||it[1].length>3){He.splice(le,2,He[le]+`
`+He[le+1]),le--,fe--;continue}else(!this.options.pedantic||this.options.smartLists?it[2][it[2].length-1]!==ve[ve.length-1]:ye===(it[2].length===1))&&(Ye=He.slice(le+1).join(`
`),je.raw=je.raw.substring(0,je.raw.length-Ye.length),le=fe-1);dt=it}nt=Ge.length,Ge=Ge.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ge.indexOf(`
 `)&&(nt-=Ge.length,Ge=this.options.pedantic?Ge.replace(/^ {1,4}/gm,""):Ge.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),mt=We||/\n\n(?!\s*$)/.test(Ge),le!==fe-1&&(We=Ge.charAt(Ge.length-1)===`
`,mt||(mt=We)),mt&&(je.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test(Ge),Ee=void 0,wt&&(Ee=Ge[1]!==" ",Ge=Ge.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:ce,task:wt,checked:Ee,loose:mt,text:Ge})}return je}},se.html=function(J){var te=this.rules.block.html.exec(J);if(te)return{type:this.options.sanitize?"paragraph":"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):x(te[0]):te[0]}},se.def=function(J){var te=this.rules.block.def.exec(J);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var ce=te[1].toLowerCase().replace(/\s+/g," ");return{tag:ce,raw:te[0],href:te[2],title:te[3]}}},se.table=function(J){var te=this.rules.block.table.exec(J);if(te){var ce={type:"table",header:j(te[1].replace(/^ *| *\| *$/g,"")),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:te[3]?te[3].replace(/\n$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=te[0];var ve=ce.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(ce.align[ye])?ce.align[ye]="right":/^ *:-+: *$/.test(ce.align[ye])?ce.align[ye]="center":/^ *:-+ *$/.test(ce.align[ye])?ce.align[ye]="left":ce.align[ye]=null;for(ve=ce.cells.length,ye=0;ye<ve;ye++)ce.cells[ye]=j(ce.cells[ye].replace(/^ *\| *| *\| *$/g,""),ce.header.length);return ce}}},se.lheading=function(J){var te=this.rules.block.lheading.exec(J);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1]}},se.paragraph=function(J){var te=this.rules.block.paragraph.exec(J);if(te)return{type:"paragraph",raw:te[0],text:te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1]}},se.text=function(J){var te=this.rules.block.text.exec(J);if(te)return{type:"text",raw:te[0],text:te[0]}},se.escape=function(J){var te=this.rules.inline.escape.exec(J);if(te)return{type:"escape",raw:te[0],text:x(te[1])}},se.tag=function(J,te,ce){var ve=this.rules.inline.tag.exec(J);if(ve)return!te&&/^<a /i.test(ve[0])?te=!0:te&&/^<\/a>/i.test(ve[0])&&(te=!1),!ce&&/^<(pre|code|kbd|script)(\s|>)/i.test(ve[0])?ce=!0:ce&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ve[0])&&(ce=!1),{type:this.options.sanitize?"text":"html",raw:ve[0],inLink:te,inRawBlock:ce,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):x(ve[0]):ve[0]}},se.link=function(J){var te=this.rules.inline.link.exec(J);if(te){var ce=te[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var ve=re(ce.slice(0,-1),"\\");if((ce.length-ve.length)%2==0)return}else{var ye=W(te[2],"()");if(ye>-1){var je=te[0].indexOf("!")===0?5:4,He=je+te[1].length+ye;te[2]=te[2].substring(0,ye),te[0]=te[0].substring(0,He).trim(),te[3]=""}}var We=te[2],Ge="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);nt&&(We=nt[1],Ge=nt[3])}else Ge=te[3]?te[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(ce)?We=We.slice(1):We=We.slice(1,-1)),U(te,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:Ge&&Ge.replace(this.rules.inline._escapes,"$1")},te[0])}},se.reflink=function(J,te){var ce;if((ce=this.rules.inline.reflink.exec(J))||(ce=this.rules.inline.nolink.exec(J))){var ve=(ce[2]||ce[1]).replace(/\s+/g," ");if(ve=te[ve.toLowerCase()],!ve||!ve.href){var ye=ce[0].charAt(0);return{type:"text",raw:ye,text:ye}}return U(ce,ve,ce[0])}},se.emStrong=function(J,te,ce){ce===void 0&&(ce="");var ve=this.rules.inline.emStrong.lDelim.exec(J);if(!!ve&&!(ve[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=ve[1]||ve[2]||"";if(!ye||ye&&(ce===""||this.rules.inline.punctuation.exec(ce))){var je=ve[0].length-1,He,We,Ge=je,nt=0,dt=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(dt.lastIndex=0,te=te.slice(-1*J.length+je);(ve=dt.exec(te))!=null;)if(He=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!He){if(We=He.length,ve[3]||ve[4]){Ge+=We;continue}else if((ve[5]||ve[6])&&je%3&&!((je+We)%3)){nt+=We;continue}if(Ge-=We,!(Ge>0)){if(Ge+nt-We<=0&&!te.slice(dt.lastIndex).match(dt)&&(We=Math.min(We,We+Ge+nt)),Math.min(je,We)%2)return{type:"em",raw:J.slice(0,je+ve.index+We+1),text:J.slice(1,je+ve.index+We)};if(Math.min(je,We)%2==0)return{type:"strong",raw:J.slice(0,je+ve.index+We+1),text:J.slice(2,je+ve.index+We-1)}}}}}},se.codespan=function(J){var te=this.rules.inline.code.exec(J);if(te){var ce=te[2].replace(/\n/g," "),ve=/[^ ]/.test(ce),ye=/^ /.test(ce)&&/ $/.test(ce);return ve&&ye&&(ce=ce.substring(1,ce.length-1)),ce=x(ce,!0),{type:"codespan",raw:te[0],text:ce}}},se.br=function(J){var te=this.rules.inline.br.exec(J);if(te)return{type:"br",raw:te[0]}},se.del=function(J){var te=this.rules.inline.del.exec(J);if(te)return{type:"del",raw:te[0],text:te[2]}},se.autolink=function(J,te){var ce=this.rules.inline.autolink.exec(J);if(ce){var ve,ye;return ce[2]==="@"?(ve=x(this.options.mangle?te(ce[1]):ce[1]),ye="mailto:"+ve):(ve=x(ce[1]),ye=ve),{type:"link",raw:ce[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},se.url=function(J,te){var ce;if(ce=this.rules.inline.url.exec(J)){var ve,ye;if(ce[2]==="@")ve=x(this.options.mangle?te(ce[0]):ce[0]),ye="mailto:"+ve;else{var je;do je=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(je!==ce[0]);ve=x(ce[0]),ce[1]==="www."?ye="http://"+ve:ye=ve}return{type:"link",raw:ce[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},se.inlineText=function(J,te,ce){var ve=this.rules.inline.text.exec(J);if(ve){var ye;return te?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):x(ve[0]):ve[0]:ye=x(this.options.smartypants?ce(ve[0]):ve[0]),{type:"text",raw:ve[0],text:ye}}},K}(),L=O.noopTest,N=O.edit,$=O.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:L,table:L,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=N(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=N(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=N(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=N(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=N(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=N(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=N(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=$({},q),q.gfm=$({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=N(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=N(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=$({},q.normal,{html:N(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:L,paragraph:N(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:L,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:L,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=N(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=N(q._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=N(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=N(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=N(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=N(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=N(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=N(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=N(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=N(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=$({},Q),Q.pedantic=$({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:N(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:N(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=$({},Q.normal,{escape:N(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=N(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=$({},Q.gfm,{br:N(Q.br).replace("{2,}","*").getRegex(),text:N(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:q,inline:Q},be=y.defaults,Ae=de.block,Ce=de.inline,Le=O.repeatString;function H(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(K){var se="",he,J,te=K.length;for(he=0;he<te;he++)J=K.charCodeAt(he),Math.random()>.5&&(J="x"+J.toString(16)),se+="&#"+J+";";return se}var ee=function(){function K(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||be,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var J={block:Ae.normal,inline:Ce.normal};this.options.pedantic?(J.block=Ae.pedantic,J.inline=Ce.pedantic):this.options.gfm&&(J.block=Ae.gfm,this.options.breaks?J.inline=Ce.breaks:J.inline=Ce.gfm),this.tokenizer.rules=J}K.lex=function(J,te){var ce=new K(te);return ce.lex(J)},K.lexInline=function(J,te){var ce=new K(te);return ce.inlineTokens(J)};var se=K.prototype;return se.lex=function(J){return J=J.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(J,this.tokens,!0),this.inline(this.tokens),this.tokens},se.blockTokens=function(J,te,ce){te===void 0&&(te=[]),ce===void 0&&(ce=!0),this.options.pedantic&&(J=J.replace(/^ +$/gm,""));for(var ve,ye,je,He;J;){if(ve=this.tokenizer.space(J)){J=J.substring(ve.raw.length),ve.type&&te.push(ve);continue}if(ve=this.tokenizer.code(J)){J=J.substring(ve.raw.length),He=te[te.length-1],He&&He.type==="paragraph"?(He.raw+=`
`+ve.raw,He.text+=`
`+ve.text):te.push(ve);continue}if(ve=this.tokenizer.fences(J)){J=J.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.heading(J)){J=J.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.nptable(J)){J=J.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.hr(J)){J=J.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.blockquote(J)){J=J.substring(ve.raw.length),ve.tokens=this.blockTokens(ve.text,[],ce),te.push(ve);continue}if(ve=this.tokenizer.list(J)){for(J=J.substring(ve.raw.length),je=ve.items.length,ye=0;ye<je;ye++)ve.items[ye].tokens=this.blockTokens(ve.items[ye].text,[],!1);te.push(ve);continue}if(ve=this.tokenizer.html(J)){J=J.substring(ve.raw.length),te.push(ve);continue}if(ce&&(ve=this.tokenizer.def(J))){J=J.substring(ve.raw.length),this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(J)){J=J.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.lheading(J)){J=J.substring(ve.raw.length),te.push(ve);continue}if(ce&&(ve=this.tokenizer.paragraph(J))){J=J.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.text(J)){J=J.substring(ve.raw.length),He=te[te.length-1],He&&He.type==="text"?(He.raw+=`
`+ve.raw,He.text+=`
`+ve.text):te.push(ve);continue}if(J){var We="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return te},se.inline=function(J){var te,ce,ve,ye,je,He,We=J.length;for(te=0;te<We;te++)switch(He=J[te],He.type){case"paragraph":case"text":case"heading":{He.tokens=[],this.inlineTokens(He.text,He.tokens);break}case"table":{for(He.tokens={header:[],cells:[]},ye=He.header.length,ce=0;ce<ye;ce++)He.tokens.header[ce]=[],this.inlineTokens(He.header[ce],He.tokens.header[ce]);for(ye=He.cells.length,ce=0;ce<ye;ce++)for(je=He.cells[ce],He.tokens.cells[ce]=[],ve=0;ve<je.length;ve++)He.tokens.cells[ce][ve]=[],this.inlineTokens(je[ve],He.tokens.cells[ce][ve]);break}case"blockquote":{this.inline(He.tokens);break}case"list":{for(ye=He.items.length,ce=0;ce<ye;ce++)this.inline(He.items[ce].tokens);break}}return J},se.inlineTokens=function(J,te,ce,ve){te===void 0&&(te=[]),ce===void 0&&(ce=!1),ve===void 0&&(ve=!1);var ye,je,He=J,We,Ge,nt;if(this.tokens.links){var dt=Object.keys(this.tokens.links);if(dt.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)dt.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,We.index)+"["+Le("a",We[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,We.index)+"["+Le("a",We[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,We.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;){if(Ge||(nt=""),Ge=!1,ye=this.tokenizer.escape(J)){J=J.substring(ye.raw.length),te.push(ye);continue}if(ye=this.tokenizer.tag(J,ce,ve)){J=J.substring(ye.raw.length),ce=ye.inLink,ve=ye.inRawBlock;var it=te[te.length-1];it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):te.push(ye);continue}if(ye=this.tokenizer.link(J)){J=J.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,ve)),te.push(ye);continue}if(ye=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(ye.raw.length);var Ye=te[te.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,ve),te.push(ye)):Ye&&ye.type==="text"&&Ye.type==="text"?(Ye.raw+=ye.raw,Ye.text+=ye.text):te.push(ye);continue}if(ye=this.tokenizer.emStrong(J,He,nt)){J=J.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ce,ve),te.push(ye);continue}if(ye=this.tokenizer.codespan(J)){J=J.substring(ye.raw.length),te.push(ye);continue}if(ye=this.tokenizer.br(J)){J=J.substring(ye.raw.length),te.push(ye);continue}if(ye=this.tokenizer.del(J)){J=J.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ce,ve),te.push(ye);continue}if(ye=this.tokenizer.autolink(J,Y)){J=J.substring(ye.raw.length),te.push(ye);continue}if(!ce&&(ye=this.tokenizer.url(J,Y))){J=J.substring(ye.raw.length),te.push(ye);continue}if(ye=this.tokenizer.inlineText(J,ve,H)){J=J.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Ge=!0,je=te[te.length-1],je&&je.type==="text"?(je.raw+=ye.raw,je.text+=ye.text):te.push(ye);continue}if(J){var mt="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return te},e(K,null,[{key:"rules",get:function(){return{block:Ae,inline:Ce}}}]),K}(),ae=y.defaults,me=O.cleanUrl,De=O.escape,Oe=function(){function K(he){this.options=he||ae}var se=K.prototype;return se.code=function(J,te,ce){var ve=(te||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(J,ve);ye!=null&&ye!==J&&(ce=!0,J=ye)}return J=J.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+De(ve,!0)+'">'+(ce?J:De(J,!0))+`</code></pre>
`:"<pre><code>"+(ce?J:De(J,!0))+`</code></pre>
`},se.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},se.html=function(J){return J},se.heading=function(J,te,ce,ve){return this.options.headerIds?"<h"+te+' id="'+this.options.headerPrefix+ve.slug(ce)+'">'+J+"</h"+te+`>
`:"<h"+te+">"+J+"</h"+te+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(J,te,ce){var ve=te?"ol":"ul",ye=te&&ce!==1?' start="'+ce+'"':"";return"<"+ve+ye+`>
`+J+"</"+ve+`>
`},se.listitem=function(J){return"<li>"+J+`</li>
`},se.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(J){return"<p>"+J+`</p>
`},se.table=function(J,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+te+`</table>
`},se.tablerow=function(J){return`<tr>
`+J+`</tr>
`},se.tablecell=function(J,te){var ce=te.header?"th":"td",ve=te.align?"<"+ce+' align="'+te.align+'">':"<"+ce+">";return ve+J+"</"+ce+`>
`},se.strong=function(J){return"<strong>"+J+"</strong>"},se.em=function(J){return"<em>"+J+"</em>"},se.codespan=function(J){return"<code>"+J+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(J){return"<del>"+J+"</del>"},se.link=function(J,te,ce){if(J=me(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var ve='<a href="'+De(J)+'"';return te&&(ve+=' title="'+te+'"'),ve+=">"+ce+"</a>",ve},se.image=function(J,te,ce){if(J=me(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var ve='<img src="'+J+'" alt="'+ce+'"';return te&&(ve+=' title="'+te+'"'),ve+=this.options.xhtml?"/>":">",ve},se.text=function(J){return J},K}(),we=function(){function K(){}var se=K.prototype;return se.strong=function(J){return J},se.em=function(J){return J},se.codespan=function(J){return J},se.del=function(J){return J},se.html=function(J){return J},se.text=function(J){return J},se.link=function(J,te,ce){return""+ce},se.image=function(J,te,ce){return""+ce},se.br=function(){return""},K}(),Pe=function(){function K(){this.seen={}}var se=K.prototype;return se.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(J,te){var ce=J,ve=0;if(this.seen.hasOwnProperty(ce)){ve=this.seen[J];do ve++,ce=J+"-"+ve;while(this.seen.hasOwnProperty(ce))}return te||(this.seen[J]=ve,this.seen[ce]=0),ce},se.slug=function(J,te){te===void 0&&(te={});var ce=this.serialize(J);return this.getNextSafeSlug(ce,te.dryrun)},K}(),Re=y.defaults,Be=O.unescape,Se=function(){function K(he){this.options=he||Re,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new Pe}K.parse=function(J,te){var ce=new K(te);return ce.parse(J)},K.parseInline=function(J,te){var ce=new K(te);return ce.parseInline(J)};var se=K.prototype;return se.parse=function(J,te){te===void 0&&(te=!0);var ce="",ve,ye,je,He,We,Ge,nt,dt,it,Ye,mt,wt,Ee,fe,le,Z,Fe,Te,Qe=J.length;for(ve=0;ve<Qe;ve++)switch(Ye=J[ve],Ye.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,Be(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(dt="",nt="",He=Ye.header.length,ye=0;ye<He;ye++)nt+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[ye]),{header:!0,align:Ye.align[ye]});for(dt+=this.renderer.tablerow(nt),it="",He=Ye.cells.length,ye=0;ye<He;ye++){for(Ge=Ye.tokens.cells[ye],nt="",We=Ge.length,je=0;je<We;je++)nt+=this.renderer.tablecell(this.parseInline(Ge[je]),{header:!1,align:Ye.align[je]});it+=this.renderer.tablerow(nt)}ce+=this.renderer.table(dt,it);continue}case"blockquote":{it=this.parse(Ye.tokens),ce+=this.renderer.blockquote(it);continue}case"list":{for(mt=Ye.ordered,wt=Ye.start,Ee=Ye.loose,He=Ye.items.length,it="",ye=0;ye<He;ye++)le=Ye.items[ye],Z=le.checked,Fe=le.task,fe="",le.task&&(Te=this.renderer.checkbox(Z),Ee?le.tokens.length>0&&le.tokens[0].type==="text"?(le.tokens[0].text=Te+" "+le.tokens[0].text,le.tokens[0].tokens&&le.tokens[0].tokens.length>0&&le.tokens[0].tokens[0].type==="text"&&(le.tokens[0].tokens[0].text=Te+" "+le.tokens[0].tokens[0].text)):le.tokens.unshift({type:"text",text:Te}):fe+=Te),fe+=this.parse(le.tokens,Ee),it+=this.renderer.listitem(fe,Fe,Z);ce+=this.renderer.list(it,mt,wt);continue}case"html":{ce+=this.renderer.html(Ye.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(it=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;ve+1<Qe&&J[ve+1].type==="text";)Ye=J[++ve],it+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);ce+=te?this.renderer.paragraph(it):it;continue}default:{var Ze='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return ce},se.parseInline=function(J,te){te=te||this.renderer;var ce="",ve,ye,je=J.length;for(ve=0;ve<je;ve++)switch(ye=J[ve],ye.type){case"escape":{ce+=te.text(ye.text);break}case"html":{ce+=te.html(ye.text);break}case"link":{ce+=te.link(ye.href,ye.title,this.parseInline(ye.tokens,te));break}case"image":{ce+=te.image(ye.href,ye.title,ye.text);break}case"strong":{ce+=te.strong(this.parseInline(ye.tokens,te));break}case"em":{ce+=te.em(this.parseInline(ye.tokens,te));break}case"codespan":{ce+=te.codespan(ye.text);break}case"br":{ce+=te.br();break}case"del":{ce+=te.del(this.parseInline(ye.tokens,te));break}case"text":{ce+=te.text(ye.text);break}default:{var He='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}return ce},K}(),qe=O.merge,X=O.checkSanitizeDeprecation,ie=O.escape,_e=y.getDefaults,Ne=y.changeDefaults,ze=y.defaults;function $e(K,se,he){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof se=="function"&&(he=se,se=null),se=qe({},$e.defaults,se||{}),X(se),he){var J=se.highlight,te;try{te=ee.lex(K,se)}catch(je){return he(je)}var ce=function(He){var We;if(!He)try{We=Se.parse(te,se)}catch(Ge){He=Ge}return se.highlight=J,He?he(He):he(null,We)};if(!J||J.length<3||(delete se.highlight,!te.length))return ce();var ve=0;$e.walkTokens(te,function(je){je.type==="code"&&(ve++,setTimeout(function(){J(je.text,je.lang,function(He,We){if(He)return ce(He);We!=null&&We!==je.text&&(je.text=We,je.escaped=!0),ve--,ve===0&&ce()})},0))}),ve===0&&ce();return}try{var ye=ee.lex(K,se);return se.walkTokens&&$e.walkTokens(ye,se.walkTokens),Se.parse(ye,se)}catch(je){if(je.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(je.message+"",!0)+"</pre>";throw je}}$e.options=$e.setOptions=function(K){return qe($e.defaults,K),Ne($e.defaults),$e},$e.getDefaults=_e,$e.defaults=ze,$e.use=function(K){var se=qe({},K);if(K.renderer&&function(){var J=$e.defaults.renderer||new Oe,te=function(ye){var je=J[ye];J[ye]=function(){for(var He=arguments.length,We=new Array(He),Ge=0;Ge<He;Ge++)We[Ge]=arguments[Ge];var nt=K.renderer[ye].apply(J,We);return nt===!1&&(nt=je.apply(J,We)),nt}};for(var ce in K.renderer)te(ce);se.renderer=J}(),K.tokenizer&&function(){var J=$e.defaults.tokenizer||new F,te=function(ye){var je=J[ye];J[ye]=function(){for(var He=arguments.length,We=new Array(He),Ge=0;Ge<He;Ge++)We[Ge]=arguments[Ge];var nt=K.tokenizer[ye].apply(J,We);return nt===!1&&(nt=je.apply(J,We)),nt}};for(var ce in K.tokenizer)te(ce);se.tokenizer=J}(),K.walkTokens){var he=$e.defaults.walkTokens;se.walkTokens=function(J){K.walkTokens(J),he&&he(J)}}$e.setOptions(se)},$e.walkTokens=function(K,se){for(var he=T(K),J;!(J=he()).done;){var te=J.value;switch(se(te),te.type){case"table":{for(var ce=T(te.tokens.header),ve;!(ve=ce()).done;){var ye=ve.value;$e.walkTokens(ye,se)}for(var je=T(te.tokens.cells),He;!(He=je()).done;)for(var We=He.value,Ge=T(We),nt;!(nt=Ge()).done;){var dt=nt.value;$e.walkTokens(dt,se)}break}case"list":{$e.walkTokens(te.items,se);break}default:te.tokens&&$e.walkTokens(te.tokens,se)}}},$e.parseInline=function(K,se){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");se=qe({},$e.defaults,se||{}),X(se);try{var he=ee.lexInline(K,se);return se.walkTokens&&$e.walkTokens(he,se.walkTokens),Se.parseInline(he,se)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(J.message+"",!0)+"</pre>";throw J}},$e.Parser=Se,$e.parser=Se.parse,$e.Renderer=Oe,$e.TextRenderer=we,$e.Lexer=ee,$e.lexer=ee.lex,$e.Tokenizer=F,$e.Slugger=Pe,$e.parse=$e;var Je=$e;return Je}),define(ge[73],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(y,P,D){return Math.min(Math.max(y,P),D)}e.clamp=b;function I(y,P){return(P+y%P)%P}e.rot=I;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class A{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function G(T){const A=[];typeof T=="number"&&A.push("code/timeOrigin",T);function y(D){A.push(D,Date.now())}function P(){const D=[];for(let k=0;k<A.length;k+=2)D.push({name:A[k],startTime:A[k+1]});return D}return{mark:y,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const y of performance.getEntriesByType("mark"))A.push({name:y.name,startTime:Math.round(T+y.startTime)});return A}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function b(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=b(I))})(),define(ge[10],pe([0,1]),function(G,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let T=!1,A=!1,y=!1,P=!1,D=!1,k=!1,r=!1,C,f=I,g,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const E=typeof((b=d==null?void 0:d.versions)===null||b===void 0?void 0:b.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=E&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)a=navigator.userAgent,T=a.indexOf("Windows")>=0,A=a.indexOf("Macintosh")>=0,r=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=a.indexOf("Linux")>=0,k=!0,C=navigator.language,f=C;else if(typeof d=="object"){T=d.platform==="win32",A=d.platform==="darwin",y=d.platform==="linux",P=y&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,C=I,f=I;const i=d.env.VSCODE_NLS_CONFIG;if(i)try{const s=JSON.parse(i),c=s.availableLanguages["*"];C=s.locale,f=c||I,g=s._translationsConfigFile}catch(s){}D=!0}else console.error("Unable to resolve platform.");var w;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function S(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let m=0;A?m=1:T?m=3:y&&(m=2),e.isWindows=T,e.isMacintosh=A,e.isLinux=y,e.isLinuxSnap=P,e.isNative=D,e.isWeb=k,e.isIOS=r,e.platform=m,e.userAgent=a,e.language=f;var l;(function(i){function s(){return e.language}i.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=c;function h(){return e.language==="en"}i.isDefault=h})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let u=0,p=c.length;u<p;u++){const R=c[u];if(R.id===_.data.vscodeSetImmediateId){c.splice(u,1),R.callback();return}}});let h=0;return _=>{const u=++h;c.push({id:u,callback:_}),e.globals.postMessage({vscodeSetImmediateId:u},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const s=Promise.resolve();return c=>s.then(c)}();var v;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(v=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||r?2:T?1:3;let t=!0,n=!1;function o(){if(!n){n=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,t=new Uint16Array(i.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(ge[36],pe([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof b.globals.vscode!="undefined"){const T=b.globals.vscode.process;I={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(A){return(0,b.setImmediate)(A)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}}:I={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(T){return(0,b.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(ge[8],pe([0,1,36]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,T=97,A=90,y=122,P=46,D=47,k=92,r=58,C=63;class f extends Error{constructor(l,v,t){let n;typeof v=="string"&&v.indexOf("not ")===0?(n="must not be",v=v.replace(/^not /,"")):n="must be";const o=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${o} ${n} of type ${v}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function g(m,l){if(typeof m!="string")throw new f(l,"string",m)}function a(m){return m===D||m===k}function d(m){return m===D}function E(m){return m>=I&&m<=A||m>=T&&m<=y}function w(m,l,v,t){let n="",o=0,i=-1,s=0,c=0;for(let h=0;h<=m.length;++h){if(h<m.length)c=m.charCodeAt(h);else{if(t(c))break;c=D}if(t(c)){if(!(i===h-1||s===1))if(s===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const _=n.lastIndexOf(v);_===-1?(n="",o=0):(n=n.slice(0,_),o=n.length-1-n.lastIndexOf(v)),i=h,s=0;continue}else if(n.length!==0){n="",o=0,i=h,s=0;continue}}l&&(n+=n.length>0?`${v}..`:"..",o=2)}else n.length>0?n+=`${v}${m.slice(i+1,h)}`:n=m.slice(i+1,h),o=h-i-1;i=h,s=0}else c===P&&s!==-1?++s:s=-1}return n}function S(m,l){if(l===null||typeof l!="object")throw new f("pathObject","Object",l);const v=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return v?v===l.root?`${v}${t}`:`${v}${m}${t}`:t}e.win32={resolve(...m){let l="",v="",t=!1;for(let n=m.length-1;n>=-1;n--){let o;if(n>=0){if(o=m[n],g(o,"path"),o.length===0)continue}else l.length===0?o=b.cwd():(o=b.env[`=${l}`]||b.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===k)&&(o=`${l}\\`));const i=o.length;let s=0,c="",h=!1;const _=o.charCodeAt(0);if(i===1)a(_)&&(s=1,h=!0);else if(a(_))if(h=!0,a(o.charCodeAt(1))){let u=2,p=u;for(;u<i&&!a(o.charCodeAt(u));)u++;if(u<i&&u!==p){const R=o.slice(p,u);for(p=u;u<i&&a(o.charCodeAt(u));)u++;if(u<i&&u!==p){for(p=u;u<i&&!a(o.charCodeAt(u));)u++;(u===i||u!==p)&&(c=`\\\\${R}\\${o.slice(p,u)}`,s=u)}}}else s=1;else E(_)&&o.charCodeAt(1)===r&&(c=o.slice(0,2),s=2,i>2&&a(o.charCodeAt(2))&&(h=!0,s=3));if(c.length>0)if(l.length>0){if(c.toLowerCase()!==l.toLowerCase())continue}else l=c;if(t){if(l.length>0)break}else if(v=`${o.slice(s)}\\${v}`,t=h,h&&l.length>0)break}return v=w(v,!t,"\\",a),t?`${l}\\${v}`:`${l}${v}`||"."},normalize(m){g(m,"path");const l=m.length;if(l===0)return".";let v=0,t,n=!1;const o=m.charCodeAt(0);if(l===1)return d(o)?"\\":m;if(a(o))if(n=!0,a(m.charCodeAt(1))){let s=2,c=s;for(;s<l&&!a(m.charCodeAt(s));)s++;if(s<l&&s!==c){const h=m.slice(c,s);for(c=s;s<l&&a(m.charCodeAt(s));)s++;if(s<l&&s!==c){for(c=s;s<l&&!a(m.charCodeAt(s));)s++;if(s===l)return`\\\\${h}\\${m.slice(c)}\\`;s!==c&&(t=`\\\\${h}\\${m.slice(c,s)}`,v=s)}}}else v=1;else E(o)&&m.charCodeAt(1)===r&&(t=m.slice(0,2),v=2,l>2&&a(m.charCodeAt(2))&&(n=!0,v=3));let i=v<l?w(m.slice(v),!n,"\\",a):"";return i.length===0&&!n&&(i="."),i.length>0&&a(m.charCodeAt(l-1))&&(i+="\\"),t===void 0?n?`\\${i}`:i:n?`${t}\\${i}`:`${t}${i}`},isAbsolute(m){g(m,"path");const l=m.length;if(l===0)return!1;const v=m.charCodeAt(0);return a(v)||l>2&&E(v)&&m.charCodeAt(1)===r&&a(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let l,v;for(let o=0;o<m.length;++o){const i=m[o];g(i,"path"),i.length>0&&(l===void 0?l=v=i:l+=`\\${i}`)}if(l===void 0)return".";let t=!0,n=0;if(typeof v=="string"&&a(v.charCodeAt(0))){++n;const o=v.length;o>1&&a(v.charCodeAt(1))&&(++n,o>2&&(a(v.charCodeAt(2))?++n:t=!1))}if(t){for(;n<l.length&&a(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(m,l){if(g(m,"from"),g(l,"to"),m===l)return"";const v=e.win32.resolve(m),t=e.win32.resolve(l);if(v===t||(m=v.toLowerCase(),l=t.toLowerCase(),m===l))return"";let n=0;for(;n<m.length&&m.charCodeAt(n)===k;)n++;let o=m.length;for(;o-1>n&&m.charCodeAt(o-1)===k;)o--;const i=o-n;let s=0;for(;s<l.length&&l.charCodeAt(s)===k;)s++;let c=l.length;for(;c-1>s&&l.charCodeAt(c-1)===k;)c--;const h=c-s,_=i<h?i:h;let u=-1,p=0;for(;p<_;p++){const O=m.charCodeAt(n+p);if(O!==l.charCodeAt(s+p))break;O===k&&(u=p)}if(p!==_){if(u===-1)return t}else{if(h>_){if(l.charCodeAt(s+p)===k)return t.slice(s+p+1);if(p===2)return t.slice(s+p)}i>_&&(m.charCodeAt(n+p)===k?u=p:p===2&&(u=3)),u===-1&&(u=0)}let R="";for(p=n+u+1;p<=o;++p)(p===o||m.charCodeAt(p)===k)&&(R+=R.length===0?"..":"\\..");return s+=u,R.length>0?`${R}${t.slice(s,c)}`:(t.charCodeAt(s)===k&&++s,t.slice(s,c))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const l=e.win32.resolve(m);if(l.length<=2)return m;if(l.charCodeAt(0)===k){if(l.charCodeAt(1)===k){const v=l.charCodeAt(2);if(v!==C&&v!==P)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(E(l.charCodeAt(0))&&l.charCodeAt(1)===r&&l.charCodeAt(2)===k)return`\\\\?\\${l}`;return m},dirname(m){g(m,"path");const l=m.length;if(l===0)return".";let v=-1,t=0;const n=m.charCodeAt(0);if(l===1)return a(n)?m:".";if(a(n)){if(v=t=1,a(m.charCodeAt(1))){let s=2,c=s;for(;s<l&&!a(m.charCodeAt(s));)s++;if(s<l&&s!==c){for(c=s;s<l&&a(m.charCodeAt(s));)s++;if(s<l&&s!==c){for(c=s;s<l&&!a(m.charCodeAt(s));)s++;if(s===l)return m;s!==c&&(v=t=s+1)}}}}else E(n)&&m.charCodeAt(1)===r&&(v=l>2&&a(m.charCodeAt(2))?3:2,t=v);let o=-1,i=!0;for(let s=l-1;s>=t;--s)if(a(m.charCodeAt(s))){if(!i){o=s;break}}else i=!1;if(o===-1){if(v===-1)return".";o=v}return m.slice(0,o)},basename(m,l){l!==void 0&&g(l,"ext"),g(m,"path");let v=0,t=-1,n=!0,o;if(m.length>=2&&E(m.charCodeAt(0))&&m.charCodeAt(1)===r&&(v=2),l!==void 0&&l.length>0&&l.length<=m.length){if(l===m)return"";let i=l.length-1,s=-1;for(o=m.length-1;o>=v;--o){const c=m.charCodeAt(o);if(a(c)){if(!n){v=o+1;break}}else s===-1&&(n=!1,s=o+1),i>=0&&(c===l.charCodeAt(i)?--i==-1&&(t=o):(i=-1,t=s))}return v===t?t=s:t===-1&&(t=m.length),m.slice(v,t)}for(o=m.length-1;o>=v;--o)if(a(m.charCodeAt(o))){if(!n){v=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":m.slice(v,t)},extname(m){g(m,"path");let l=0,v=-1,t=0,n=-1,o=!0,i=0;m.length>=2&&m.charCodeAt(1)===r&&E(m.charCodeAt(0))&&(l=t=2);for(let s=m.length-1;s>=l;--s){const c=m.charCodeAt(s);if(a(c)){if(!o){t=s+1;break}continue}n===-1&&(o=!1,n=s+1),c===P?v===-1?v=s:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||n===-1||i===0||i===1&&v===n-1&&v===t+1?"":m.slice(v,n)},format:S.bind(null,"\\"),parse(m){g(m,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return l;const v=m.length;let t=0,n=m.charCodeAt(0);if(v===1)return a(n)?(l.root=l.dir=m,l):(l.base=l.name=m,l);if(a(n)){if(t=1,a(m.charCodeAt(1))){let u=2,p=u;for(;u<v&&!a(m.charCodeAt(u));)u++;if(u<v&&u!==p){for(p=u;u<v&&a(m.charCodeAt(u));)u++;if(u<v&&u!==p){for(p=u;u<v&&!a(m.charCodeAt(u));)u++;u===v?t=u:u!==p&&(t=u+1)}}}}else if(E(n)&&m.charCodeAt(1)===r){if(v<=2)return l.root=l.dir=m,l;if(t=2,a(m.charCodeAt(2))){if(v===3)return l.root=l.dir=m,l;t=3}}t>0&&(l.root=m.slice(0,t));let o=-1,i=t,s=-1,c=!0,h=m.length-1,_=0;for(;h>=t;--h){if(n=m.charCodeAt(h),a(n)){if(!c){i=h+1;break}continue}s===-1&&(c=!1,s=h+1),n===P?o===-1?o=h:_!==1&&(_=1):o!==-1&&(_=-1)}return s!==-1&&(o===-1||_===0||_===1&&o===s-1&&o===i+1?l.base=l.name=m.slice(i,s):(l.name=m.slice(i,o),l.base=m.slice(i,s),l.ext=m.slice(o,s))),i>0&&i!==t?l.dir=m.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let l="",v=!1;for(let t=m.length-1;t>=-1&&!v;t--){const n=t>=0?m[t]:b.cwd();g(n,"path"),n.length!==0&&(l=`${n}/${l}`,v=n.charCodeAt(0)===D)}return l=w(l,!v,"/",d),v?`/${l}`:l.length>0?l:"."},normalize(m){if(g(m,"path"),m.length===0)return".";const l=m.charCodeAt(0)===D,v=m.charCodeAt(m.length-1)===D;return m=w(m,!l,"/",d),m.length===0?l?"/":v?"./":".":(v&&(m+="/"),l?`/${m}`:m)},isAbsolute(m){return g(m,"path"),m.length>0&&m.charCodeAt(0)===D},join(...m){if(m.length===0)return".";let l;for(let v=0;v<m.length;++v){const t=m[v];g(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(m,l){if(g(m,"from"),g(l,"to"),m===l||(m=e.posix.resolve(m),l=e.posix.resolve(l),m===l))return"";const v=1,t=m.length,n=t-v,o=1,i=l.length-o,s=n<i?n:i;let c=-1,h=0;for(;h<s;h++){const u=m.charCodeAt(v+h);if(u!==l.charCodeAt(o+h))break;u===D&&(c=h)}if(h===s)if(i>s){if(l.charCodeAt(o+h)===D)return l.slice(o+h+1);if(h===0)return l.slice(o+h)}else n>s&&(m.charCodeAt(v+h)===D?c=h:h===0&&(c=0));let _="";for(h=v+c+1;h<=t;++h)(h===t||m.charCodeAt(h)===D)&&(_+=_.length===0?"..":"/..");return`${_}${l.slice(o+c)}`},toNamespacedPath(m){return m},dirname(m){if(g(m,"path"),m.length===0)return".";const l=m.charCodeAt(0)===D;let v=-1,t=!0;for(let n=m.length-1;n>=1;--n)if(m.charCodeAt(n)===D){if(!t){v=n;break}}else t=!1;return v===-1?l?"/":".":l&&v===1?"//":m.slice(0,v)},basename(m,l){l!==void 0&&g(l,"ext"),g(m,"path");let v=0,t=-1,n=!0,o;if(l!==void 0&&l.length>0&&l.length<=m.length){if(l===m)return"";let i=l.length-1,s=-1;for(o=m.length-1;o>=0;--o){const c=m.charCodeAt(o);if(c===D){if(!n){v=o+1;break}}else s===-1&&(n=!1,s=o+1),i>=0&&(c===l.charCodeAt(i)?--i==-1&&(t=o):(i=-1,t=s))}return v===t?t=s:t===-1&&(t=m.length),m.slice(v,t)}for(o=m.length-1;o>=0;--o)if(m.charCodeAt(o)===D){if(!n){v=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":m.slice(v,t)},extname(m){g(m,"path");let l=-1,v=0,t=-1,n=!0,o=0;for(let i=m.length-1;i>=0;--i){const s=m.charCodeAt(i);if(s===D){if(!n){v=i+1;break}continue}t===-1&&(n=!1,t=i+1),s===P?l===-1?l=i:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||t===-1||o===0||o===1&&l===t-1&&l===v+1?"":m.slice(l,t)},format:S.bind(null,"/"),parse(m){g(m,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return l;const v=m.charCodeAt(0)===D;let t;v?(l.root="/",t=1):t=0;let n=-1,o=0,i=-1,s=!0,c=m.length-1,h=0;for(;c>=t;--c){const _=m.charCodeAt(c);if(_===D){if(!s){o=c+1;break}continue}i===-1&&(s=!1,i=c+1),_===P?n===-1?n=c:h!==1&&(h=1):n!==-1&&(h=-1)}if(i!==-1){const _=o===0&&v?1:o;n===-1||h===0||h===1&&n===i-1&&n===o+1?l.base=l.name=m.slice(_,i):(l.name=m.slice(_,n),l.base=m.slice(_,i),l.ext=m.slice(n,i))}return o>0?l.dir=m.slice(0,o-1):v&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[95],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var b;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(b=e.Source||(e.Source={}));var I;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(A,...y){const P=y.reduce((r,C)=>(r[C]=!0,r),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(r=>!P[r]).forEach(r=>{for(let C=0;C<D.length;C++)if(r.search(D[C])!==-1){delete A[r];break}})}e.sanitizeProcessEnvironment=T}),define(ge[47],pe([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=b.globals.performance&&typeof b.globals.performance.now=="function";class T{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new T(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ge[3],pe([0,1,16,71,6,56,47]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(w){w.None=()=>T.Disposable.None;function S(j){return(x,W=null,U)=>{let M=!1,F;return F=j(L=>{if(!M)return F?F.dispose():M=!0,x.call(W,L)},null,U),M&&F.dispose(),F}}w.once=S;function m(j,x){return i((W,U=null,M)=>j(F=>W.call(U,x(F)),null,M))}w.map=m;function l(j,x){return i((W,U=null,M)=>j(F=>{x(F),W.call(U,F)},null,M))}w.forEach=l;function v(j,x){return i((W,U=null,M)=>j(F=>x(F)&&W.call(U,F),null,M))}w.filter=v;function t(j){return j}w.signal=t;function n(...j){return(x,W=null,U)=>(0,T.combinedDisposable)(...j.map(M=>M(F=>x.call(W,F),null,U)))}w.any=n;function o(j,x,W){let U=W;return m(j,M=>(U=x(U,M),U))}w.reduce=o;function i(j){let x;const W=new f({onFirstListenerAdd(){x=j(W.fire,W)},onLastListenerRemove(){x.dispose()}});return W.event}w.snapshot=i;function s(j,x,W=100,U=!1,M){let F,L,N,$=0;const q=new f({leakWarningThreshold:M,onFirstListenerAdd(){F=j(Q=>{$++,L=x(L,Q),U&&!N&&(q.fire(L),L=void 0),clearTimeout(N),N=setTimeout(()=>{const de=L;L=void 0,N=void 0,(!U||$>1)&&q.fire(de),$=0},W)})},onLastListenerRemove(){F.dispose()}});return q.event}w.debounce=s;function c(j){const x=new Date().getTime();return m(S(j),W=>new Date().getTime()-x)}w.stopwatch=c;function h(j){let x=!0,W;return v(j,U=>{const M=x||U!==W;return x=!1,W=U,M})}w.latch=h;function _(j,x=!1,W=[]){let U=W.slice(),M=j(N=>{U?U.push(N):L.fire(N)});const F=()=>{U&&U.forEach(N=>L.fire(N)),U=null},L=new f({onFirstListenerAdd(){M||(M=j(N=>L.fire(N)))},onFirstListenerDidAdd(){U&&(x?setTimeout(F):F())},onLastListenerRemove(){M&&M.dispose(),M=null}});return L.event}w.buffer=_;class u{constructor(x){this.event=x}map(x){return new u(m(this.event,x))}forEach(x){return new u(l(this.event,x))}filter(x){return new u(v(this.event,x))}reduce(x,W){return new u(o(this.event,x,W))}latch(){return new u(h(this.event))}debounce(x,W=100,U=!1,M){return new u(s(this.event,x,W,U,M))}on(x,W,U){return this.event(x,W,U)}once(x,W,U){return S(this.event)(x,W,U)}}function p(j){return new u(j)}w.chain=p;function R(j,x,W=U=>U){const U=(...N)=>L.fire(W(...N)),M=()=>j.on(x,U),F=()=>j.removeListener(x,U),L=new f({onFirstListenerAdd:M,onLastListenerRemove:F});return L.event}w.fromNodeEventEmitter=R;function O(j,x,W=U=>U){const U=(...N)=>L.fire(W(...N)),M=()=>j.addEventListener(x,U),F=()=>j.removeEventListener(x,U),L=new f({onFirstListenerAdd:M,onLastListenerRemove:F});return L.event}w.fromDOMEventEmitter=O;function V(j){const x=new f;let W=!1;return j.then(void 0,()=>null).then(()=>{W?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),W=!0,x.event}w.fromPromise=V;function re(j){return new Promise(x=>S(j)(x))}w.toPromise=re})(P=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let k=-1;function r(w){const S=k;return k=w,{dispose(){k=S}}}e.setGlobalLeakWarningThreshold=r;class C{constructor(S,m=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let m=k;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),!(m<=0||S<m)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),v=this._stacks.get(l)||0;if(this._stacks.set(l,v+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let t,n=0;for(const[o,i]of this._stacks)(!t||n<i)&&(t=o,n=i);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class f{constructor(S){var m;this._disposed=!1,this._options=S,this._leakageMon=k>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((m=this._options)===null||m===void 0?void 0:m._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,m,l)=>{var v;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(m?[S,m]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,m);const o=(v=this._leakageMon)===null||v===void 0?void 0:v.check(this._listeners.size);let i;return i={dispose:()=>{o&&o(),i.dispose=f._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof T.DisposableStore?l.add(i):Array.isArray(l)&&l.push(i),i}),this._event}fire(S){var m,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,S]);for((m=this._perfMon)===null||m===void 0||m.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(n){(0,b.onUnexpectedError)(n)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var S,m,l;(S=this._listeners)===null||S===void 0||S.clear(),(m=this._deliveryQueue)===null||m===void 0||m.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=f,f._noop=function(){};class g extends f{constructor(S){super(S);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=g;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const m={event:S,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const l=()=>{this.hasListeners&&this.unhook(m);const v=this.events.indexOf(m);this.events.splice(v,1)};return(0,T.toDisposable)((0,I.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(m=>this.emitter.fire(m))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class d{constructor(){this.buffers=[]}wrapEvent(S){return(m,l,v)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>m.call(l,t)):m.call(l,t)},void 0,v)}bufferEvents(S){const m=[];this.buffers.push(m);const l=S();return this.buffers.pop(),m.forEach(v=>v()),l}}e.EventBufferer=d;class E{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=T.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(ge[21],pe([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(P,D){const k=setTimeout(P.bind(D),0);return{dispose(){clearTimeout(k)}}});var T;(function(P){function D(k){return k===P.None||k===P.Cancelled||k instanceof A?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}P.isCancellationToken=D,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(T=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=T.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=y}),define(ge[43],pe([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(C){const f=this._icons.get(C.id);f?C.description?f.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new I;e.iconRegistry=T;function A(r,C){return new P(r,C)}e.registerCodicon=A;function y(r){return r?r.replace(/\$\((.*?)\)/g,(C,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=y;class P{constructor(C,f,g){this.id=C,this.definition=f,this.description=g,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function D(r,C){const f=["codicon","codicon-"+r];return C&&f.push("codicon-modifier-"+C),f}e.getClassNamesArray=D;var k;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function f(d){if(d instanceof P)return["codicon","codicon-"+d.id];const E=C.exec(d.id);if(!E)return f(P.error);let[,w,S]=E;const m=["codicon","codicon-"+w];return S&&m.push("codicon-modifier-"+S.substr(1)),m}r.asClassNameArray=f;function g(d){return f(d).join(" ")}r.asClassName=g;function a(d){return"."+f(d).join(".")}r.asCSSSelector=a})(k=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(ge[96],pe([0,1,16,6]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(m){const l=m;return l?[l.on,l.pause,l.resume,l.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=T;function A(m){const l=m;return l?T(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=A;function y(m,l){return new P(m,l)}e.newWriteableStream=y;class P{constructor(l,v){this.reducer=l,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(v=>v(l))}emitError(l){this.listeners.error.length===0?(0,b.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(v=>v(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,v){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(l,v){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(v);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(m,l){const v=[];let t;for(;(t=m.read())!==null;)v.push(t);return l(v)}e.consumeReadable=D;function k(m,l,v){const t=[];let n;for(;(n=m.read())!==null&&t.length<v;)t.push(n);return n===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const o=n;return n=void 0,o}return m.read()}}}e.peekReadable=k;function r(m,l){return new Promise((v,t)=>{const n=[];C(m,{onData:o=>{l&&n.push(o)},onError:o=>{l?t(o):v(void 0)},onEnd:()=>{v(l?l(n):void 0)}})})}e.consumeStream=r;function C(m,l){m.on("error",v=>l.onError(v)),m.on("end",()=>l.onEnd()),m.on("data",v=>l.onData(v))}e.listenStream=C;function f(m,l){return new Promise((v,t)=>{const n=new I.DisposableStore,o=[],i=h=>{if(o.push(h),o.length>l)return n.dispose(),m.pause(),v({stream:m,buffer:o,ended:!1})},s=h=>t(h),c=()=>v({stream:m,buffer:o,ended:!0});n.add((0,I.toDisposable)(()=>m.removeListener("error",s))),m.on("error",s),n.add((0,I.toDisposable)(()=>m.removeListener("end",c))),m.on("end",c),n.add((0,I.toDisposable)(()=>m.removeListener("data",i))),m.on("data",i)})}e.peekStream=f;function g(m,l){const v=y(l);return v.end(m),v}e.toStream=g;function a(){const m=y(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=a;function d(m){let l=!1;return{read:()=>l?null:(l=!0,m)}}e.toReadable=d;function E(m,l,v){const t=y(v);return C(m,{onData:n=>t.write(l.data(n)),onError:n=>t.error(l.error?l.error(n):n),onEnd:()=>t.end()}),t}e.transform=E;function w(m,l,v){let t=!1;return{read:()=>{const n=l.read();return t?n:(t=!0,n!==null?v([m,n]):m)}}}e.prefixedReadable=w;function S(m,l,v){let t=!1;const n=y(v);return C(l,{onData:o=>t?n.write(o):(t=!0,n.write(v([m,o]))),onError:o=>n.error(o),onEnd:()=>{t||(t=!0,n.write(m)),n.end()}}),n}e.prefixedStream=S}),define(ge[9],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=b;const I=/{(\d+)}/g;function T(K,...se){return se.length===0?K:K.replace(I,function(he,J){const te=parseInt(J,10);return isNaN(te)||te<0||te>=se.length?he:se[te]})}e.format=T;function A(K){return K.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=A;function y(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function P(K,se){let he=0;const J=se.charCodeAt(0);for(let te=K.length-1;te>=0;te--)K.charCodeAt(te)===J&&he++;return he}e.count=P;function D(K,se,he="\u2026"){return K.length<=se?K:`${K.substr(0,se)}${he}`}e.truncate=D;function k(K,se=" "){const he=r(K,se);return C(he,se)}e.trim=k;function r(K,se){if(!K||!se)return K;const he=se.length;if(he===0||K.length===0)return K;let J=0;for(;K.indexOf(se,J)===J;)J=J+he;return K.substring(J)}e.ltrim=r;function C(K,se){if(!K||!se)return K;const he=se.length,J=K.length;if(he===0||J===0)return K;let te=J,ce=-1;for(;ce=K.lastIndexOf(se,te-1),!(ce===-1||ce+he!==te);){if(ce===0)return"";te=ce}return K.substring(0,te)}e.rtrim=C;function f(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function g(K){return K.replace(/\*/g,"")}e.stripWildcards=g;function a(K,se,he={}){if(!K)throw new Error("Cannot create regex from empty string");se||(K=y(K)),he.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let J="";return he.global&&(J+="g"),he.matchCase||(J+="i"),he.multiline&&(J+="m"),he.unicode&&(J+="u"),new RegExp(K,J)}e.createRegExp=a;function d(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function E(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function w(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=w;function S(K){return K.split(/\r\n|\r|\n/)}e.splitLines=S;function m(K){for(let se=0,he=K.length;se<he;se++){const J=K.charCodeAt(se);if(J!==32&&J!==9)return se}return-1}e.firstNonWhitespaceIndex=m;function l(K,se=0,he=K.length){for(let J=se;J<he;J++){const te=K.charCodeAt(J);if(te!==32&&te!==9)return K.substring(se,J)}return K.substring(se,he)}e.getLeadingWhitespace=l;function v(K,se=K.length-1){for(let he=se;he>=0;he--){const J=K.charCodeAt(he);if(J!==32&&J!==9)return he}return-1}e.lastNonWhitespaceIndex=v;function t(K,se){return K<se?-1:K>se?1:0}e.compare=t;function n(K,se,he=0,J=K.length,te=0,ce=se.length){for(;he<J&&te<ce;he++,te++){let je=K.charCodeAt(he),He=se.charCodeAt(te);if(je<He)return-1;if(je>He)return 1}const ve=J-he,ye=ce-te;return ve<ye?-1:ve>ye?1:0}e.compareSubstring=n;function o(K,se){return i(K,se,0,K.length,0,se.length)}e.compareIgnoreCase=o;function i(K,se,he=0,J=K.length,te=0,ce=se.length){for(;he<J&&te<ce;he++,te++){let je=K.charCodeAt(he),He=se.charCodeAt(te);if(je!==He){const We=je-He;if(!(We===32&&c(He))&&!(We===-32&&c(je)))return s(je)&&s(He)?We:n(K.toLowerCase(),se.toLowerCase(),he,J,te,ce)}}const ve=J-he,ye=ce-te;return ve<ye?-1:ve>ye?1:0}e.compareSubstringIgnoreCase=i;function s(K){return K>=97&&K<=122}e.isLowerAsciiLetter=s;function c(K){return K>=65&&K<=90}e.isUpperAsciiLetter=c;function h(K){return s(K)||c(K)}function _(K,se){return K.length===se.length&&u(K,se)}e.equalsIgnoreCase=_;function u(K,se,he=K.length){for(let J=0;J<he;J++){const te=K.charCodeAt(J),ce=se.charCodeAt(J);if(te!==ce){if(h(te)&&h(ce)){const ve=Math.abs(te-ce);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(te).toLowerCase()!==String.fromCharCode(ce).toLowerCase())return!1}}return!0}function p(K,se){const he=se.length;return se.length>K.length?!1:u(K,se,he)}e.startsWithIgnoreCase=p;function R(K,se){let he,J=Math.min(K.length,se.length);for(he=0;he<J;he++)if(K.charCodeAt(he)!==se.charCodeAt(he))return he;return J}e.commonPrefixLength=R;function O(K,se){let he,J=Math.min(K.length,se.length);const te=K.length-1,ce=se.length-1;for(he=0;he<J;he++)if(K.charCodeAt(te-he)!==se.charCodeAt(ce-he))return he;return J}e.commonSuffixLength=O;function V(K){return 55296<=K&&K<=56319}e.isHighSurrogate=V;function re(K){return 56320<=K&&K<=57343}e.isLowSurrogate=re;function j(K,se){return(K-55296<<10)+(se-56320)+65536}e.computeCodePoint=j;function x(K,se,he){const J=K.charCodeAt(he);if(V(J)&&he+1<se){const te=K.charCodeAt(he+1);if(re(te))return j(J,te)}return J}e.getNextCodePoint=x;function W(K,se){const he=K.charCodeAt(se-1);if(re(he)&&se>1){const J=K.charCodeAt(se-2);if(V(J))return j(J,he)}return he}function U(K,se){const he=$e.getInstance(),J=se,te=K.length,ce=x(K,te,se);se+=ce>=65536?2:1;let ve=he.getGraphemeBreakType(ce);for(;se<te;){const ye=x(K,te,se),je=he.getGraphemeBreakType(ye);if(Ne(ve,je))break;se+=ye>=65536?2:1,ve=je}return se-J}e.nextCharLength=U;function M(K,se){const he=$e.getInstance(),J=se,te=W(K,se);se-=te>=65536?2:1;let ce=he.getGraphemeBreakType(te);for(;se>0;){const ve=W(K,se),ye=he.getGraphemeBreakType(ve);if(Ne(ye,ce))break;se-=ve>=65536?2:1,ce=ye}return J-se}e.prevCharLength=M;function F(K,se){const he=$e.getInstance(),J=K.length,te=se,ce=x(K,J,se),ve=he.getGraphemeBreakType(ce);se+=ce>=65536?2:1;let ye=ve;for(;se<J;){const He=x(K,J,se),We=he.getGraphemeBreakType(He);if(Ne(ye,We))break;se+=He>=65536?2:1,ye=We}const je=se;for(se=te,ye=ve;se>0;){const He=W(K,se),We=he.getGraphemeBreakType(He);if(Ne(We,ye))break;se-=He>=65536?2:1,ye=We}return[se,je]}function L(K,se){return se>0&&re(K.charCodeAt(se))?F(K,se-1):F(K,se)}e.getCharContainingOffset=L;function N(K){const se=K.length;let he=0,J=0;for(;J<se;){const ve=x(K,se,J);J+=ve>=65536?2:1,ve<128?he+=1:ve<2048?he+=2:ve<65536?he+=3:he+=4}const te=new Uint8Array(he);J=0;let ce=0;for(;J<se;){const ve=x(K,se,J);J+=ve>=65536?2:1,ve<128?te[ce++]=ve:ve<2048?(te[ce++]=192|(ve&1984)>>>6,te[ce++]=128|(ve&63)>>>0):ve<65536?(te[ce++]=224|(ve&61440)>>>12,te[ce++]=128|(ve&4032)>>>6,te[ce++]=128|(ve&63)>>>0):(te[ce++]=240|(ve&1835008)>>>18,te[ce++]=128|(ve&258048)>>>12,te[ce++]=128|(ve&4032)>>>6,te[ce++]=128|(ve&63)>>>0)}return te}e.encodeUTF8=N;function $(K){const se=K.byteLength,he=[];let J=0;for(;J<se;){const te=K[J];let ce;if(te>=240&&J+3<se?ce=(K[J++]&7)<<18>>>0|(K[J++]&63)<<12>>>0|(K[J++]&63)<<6>>>0|(K[J++]&63)<<0>>>0:te>=224&&J+2<se?ce=(K[J++]&15)<<12>>>0|(K[J++]&63)<<6>>>0|(K[J++]&63)<<0>>>0:te>=192&&J+1<se?ce=(K[J++]&31)<<6>>>0|(K[J++]&63)<<0>>>0:ce=K[J++],ce>=0&&ce<=55295||ce>=57344&&ce<=65535)he.push(String.fromCharCode(ce));else if(ce>=65536&&ce<=1114111){const ve=ce-65536,ye=55296+((ve&1047552)>>>10),je=56320+((ve&1023)>>>0);he.push(String.fromCharCode(ye)),he.push(String.fromCharCode(je))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=$;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(K){return q.test(K)}e.containsRTL=Q;const de=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function be(K){return de.test(K)}e.containsEmoji=be;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Ce(K){return Ae.test(K)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Le;function H(K){for(let se=0,he=K.length;se<he;se++)if(Y(K.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=H;function Y(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=Y;function ee(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=ee;function ae(K,se){if(K.length<se)return K;const he=/\b/g;let J=0;for(;he.test(K)&&!(K.length-he.lastIndex<se);)J=he.lastIndex,he.lastIndex+=1;return K.substring(J).replace(/^\s/,"")}e.lcut=ae;const me=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function we(K){return K&&(K=K.replace(me,""),K=K.replace(De,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Re(K){return Pe(K)?K.substr(1):K}e.stripUTF8BOM=Re;function Be(K,se){if(!K||!se||K.length<se.length)return!1;const he=se.length,J=K.toLowerCase();let te=0,ce=-1;for(;te<he;){const ve=J.indexOf(se[te],ce+1);if(ve<0)return!1;ce=ve,te++}return!0}e.fuzzyContains=Be;function Se(K,se=!1){return K?(se&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function qe(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=qe;function X(K,se=1){if(se===0)return"";let he=-1;do he=K.indexOf(`
`,he+1),se--;while(se>0&&he>=0);return he===-1?K:(K[he-1]==="\r"&&he--,K.substr(0,he))}e.getNLines=X;function ie(K){const se=90-65+1;return K=K%(2*se),K<se?String.fromCharCode(97+K):String.fromCharCode(65+K-se)}e.singleLetterHash=ie;function _e(K){return $e.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=_e;function Ne(K,se){return K===0?se!==5&&se!==7:K===2&&se===3?!1:K===4||K===2||K===3||se===4||se===2||se===3?!0:!(K===8&&(se===8||se===9||se===11||se===12)||(K===11||K===9)&&(se===9||se===10)||(K===12||K===10)&&se===10||se===5||se===13||se===7||K===1||K===13&&se===14||K===6&&se===6)}e.breakBetweenGraphemeBreakType=Ne;var ze;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Je()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const he=this._data,J=he.length/3;let te=1;for(;te<=J;)if(se<he[3*te])te=2*te;else if(se>he[3*te+1])te=2*te+1;else return he[3*te+2];return 0}}$e._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[23],pe([0,1,9,96]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let P,D;class k{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return T?new k(Buffer.allocUnsafe(h)):new k(new Uint8Array(h))}static wrap(h){return T&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new k(h)}static fromString(h,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&T?new k(Buffer.from(h)):A?(P||(P=new TextEncoder),new k(P.encode(h))):new k(b.encodeUTF8(h))}static concat(h,_){if(typeof _=="undefined"){_=0;for(let R=0,O=h.length;R<O;R++)_+=h[R].byteLength}const u=k.alloc(_);let p=0;for(let R=0,O=h.length;R<O;R++){const V=h[R];u.set(V,p),p+=V.byteLength}return u}toString(){return T?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(h,_){return new k(this.buffer.subarray(h,_))}set(h,_){h instanceof k?this.buffer.set(h.buffer,_):this.buffer.set(h,_)}readUInt32BE(h){return f(this.buffer,h)}writeUInt32BE(h,_){g(this.buffer,h,_)}readUInt32LE(h){return a(this.buffer,h)}writeUInt32LE(h,_){d(this.buffer,h,_)}readUInt8(h){return E(this.buffer,h)}writeUInt8(h,_){w(this.buffer,h,_)}}e.VSBuffer=k;function r(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}e.readUInt16LE=r;function C(c,h,_){c[_+0]=h&255,h=h>>>8,c[_+1]=h&255}e.writeUInt16LE=C;function f(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}e.readUInt32BE=f;function g(c,h,_){c[_+3]=h,h=h>>>8,c[_+2]=h,h=h>>>8,c[_+1]=h,h=h>>>8,c[_]=h}e.writeUInt32BE=g;function a(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}e.readUInt32LE=a;function d(c,h,_){c[_+0]=h&255,h=h>>>8,c[_+1]=h&255,h=h>>>8,c[_+2]=h&255,h=h>>>8,c[_+3]=h&255}e.writeUInt32LE=d;function E(c,h){return c[h]}e.readUInt8=E;function w(c,h,_){c[_]=h}e.writeUInt8=w;function S(c){return I.consumeReadable(c,h=>k.concat(h))}e.readableToBuffer=S;function m(c){return I.toReadable(c)}e.bufferToReadable=m;function l(c){return I.consumeStream(c,h=>k.concat(h))}e.streamToBuffer=l;async function v(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await l(c.stream)])}e.bufferedStreamToBuffer=v;function t(c){return I.toStream(c,h=>k.concat(h))}e.bufferToStream=t;function n(c){return I.transform(c,{data:h=>typeof h=="string"?k.fromString(h):k.wrap(h)},h=>k.concat(h))}e.streamToBufferReadableStream=n;function o(c){return I.newWriteableStream(h=>k.concat(h),c)}e.newWriteableBufferStream=o;function i(c,h){return I.prefixedReadable(c,h,_=>k.concat(_))}e.prefixedBufferReadable=i;function s(c,h){return I.prefixedStream(c,h,_=>k.concat(_))}e.prefixedBufferStream=s}),define(ge[74],pe([0,1,9]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(w){return T(w,0)}e.hash=I;function T(w,S){switch(typeof w){case"object":return w===null?A(349,S):Array.isArray(w)?D(w,S):k(w,S);case"string":return P(w,S);case"boolean":return y(w,S);case"number":return A(w,S);case"undefined":return A(937,S);default:return A(617,S)}}e.doHash=T;function A(w,S){return(S<<5)-S+w|0}function y(w,S){return A(w?433:863,S)}function P(w,S){S=A(149417,S);for(let m=0,l=w.length;m<l;m++)S=A(w.charCodeAt(m),S);return S}e.stringHash=P;function D(w,S){return S=A(104579,S),w.reduce((m,l)=>T(l,m),S)}function k(w,S){return S=A(181387,S),Object.keys(w).sort().reduce((m,l)=>(m=P(l,m),T(w[l],m)),S)}class r{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=T(S,this._value),this._value}}e.Hasher=r;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(w,S,m=32){const l=m-S,v=~((1<<l)-1);return(w<<S|(v&w)>>>l)>>>0}function g(w,S=0,m=w.byteLength,l=0){for(let v=0;v<m;v++)w[S+v]=l}function a(w,S,m="0"){for(;w.length<S;)w=m+w;return w}function d(w,S=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(m=>m.toString(16).padStart(2,"0")).join(""):a((w>>>0).toString(16),S/4)}e.toHexString=d;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const m=S.length;if(m!==0){const l=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,n,o;for(t!==0?(n=t,o=-1,t=0):(n=S.charCodeAt(0),o=0);;){let i=n;if(b.isHighSurrogate(n))if(o+1<m){const s=S.charCodeAt(o+1);b.isLowSurrogate(s)?(o++,i=b.computeCodePoint(n,s)):i=65533}else{t=n;break}else b.isLowSurrogate(n)&&(i=65533);if(v=this._push(l,v,i),o++,o<m)n=S.charCodeAt(o);else break}this._buffLen=v,this._leftoverHighSurrogate=t}}_push(S,m,l){return l<128?S[m++]=l:l<2048?(S[m++]=192|(l&1984)>>>6,S[m++]=128|(l&63)>>>0):l<65536?(S[m++]=224|(l&61440)>>>12,S[m++]=128|(l&4032)>>>6,S[m++]=128|(l&63)>>>0):(S[m++]=240|(l&1835008)>>>18,S[m++]=128|(l&258048)>>>12,S[m++]=128|(l&4032)>>>6,S[m++]=128|(l&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=E._bigBlock32,m=this._buffDV;for(let h=0;h<64;h+=4)S.setUint32(h,m.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)S.setUint32(h,f(S.getUint32(h-12,!1)^S.getUint32(h-32,!1)^S.getUint32(h-56,!1)^S.getUint32(h-64,!1),1),!1);let l=this._h0,v=this._h1,t=this._h2,n=this._h3,o=this._h4,i,s,c;for(let h=0;h<80;h++)h<20?(i=v&t|~v&n,s=1518500249):h<40?(i=v^t^n,s=1859775393):h<60?(i=v&t|v&n|t&n,s=2400959708):(i=v^t^n,s=3395469782),c=f(l,5)+i+o+s+S.getUint32(h*4,!1)&4294967295,o=n,n=t,t=f(v,30),v=l,l=c;this._h0=this._h0+l&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[57],pe([0,1,9]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(I||(I={})),function(T){const A="error",y="warning",P="warn",D="info",k="ignore";function r(f){return f?b.equalsIgnoreCase(A,f)?T.Error:b.equalsIgnoreCase(y,f)||b.equalsIgnoreCase(P,f)?T.Warning:b.equalsIgnoreCase(D,f)?T.Info:T.Ignore:T.Ignore}T.fromValue=r;function C(f){switch(f){case T.Error:return A;case T.Warning:return y;case T.Info:return D;default:return k}}T.toString=C}(I||(I={})),e.default=I}),define(ge[11],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(h){return Array.isArray(h)}e.isArray=b;function I(h){return typeof h=="string"}e.isString=I;function T(h){return Array.isArray(h)&&h.every(_=>I(_))}e.isStringArray=T;function A(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=A;function y(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=y;function P(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=P;function D(h){return h===!0||h===!1}e.isBoolean=D;function k(h){return typeof h=="undefined"}e.isUndefined=k;function r(h){return!C(h)}e.isDefined=r;function C(h){return k(h)||h===null}e.isUndefinedOrNull=C;function f(h,_){if(!h)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=f;function g(h){if(C(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=g;function a(...h){const _=[];for(let u=0;u<h.length;u++){const p=h[u];if(C(p))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);_.push(p)}return _}e.assertAllDefined=a;const d=Object.prototype.hasOwnProperty;function E(h){if(!A(h))return!1;for(let _ in h)if(d.call(h,_))return!1;return!0}e.isEmptyObject=E;function w(h){return typeof h=="function"}e.isFunction=w;function S(...h){return h.length>0&&h.every(w)}e.areFunctions=S;function m(h,_){const u=Math.min(h.length,_.length);for(let p=0;p<u;p++)l(h[p],_[p])}e.validateConstraints=m;function l(h,_){if(I(_)){if(typeof h!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(w(_)){try{if(h instanceof _)return}catch(u){}if(!C(h)&&h.constructor===_||_.length===1&&_.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function v(h){let _=[],u=Object.getPrototypeOf(h);for(;Object.prototype!==u;)_=_.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return _}e.getAllPropertyNames=v;function t(h){const _=[];for(const u of v(h))typeof h[u]=="function"&&_.push(u);return _}e.getAllMethodNames=t;function n(h,_){const u=R=>function(){const O=Array.prototype.slice.call(arguments,0);return _(R,O)};let p={};for(const R of h)p[R]=u(R);return p}e.createProxyObject=n;function o(h){return h===null?void 0:h}e.withNullAsUndefined=o;function i(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=i;function s(h){return class{constructor(){return new Proxy({},{get(_,u){if(_[u])return _[u];throw new Error(`Not Implemented: ${h}->${String(u)}`)}})}}}e.NotImplementedProxy=s;function c(h){throw new Error("Unreachable")}e.assertNever=c}),define(ge[29],pe([0,1,10,9,8,11]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function P(n){return n.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=P;function D(n,o=T.posix.sep){if(!n)return"";const i=n.length,s=n.charCodeAt(0);if(y(s)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let h=3;const _=h;for(;h<i&&!y(n.charCodeAt(h));h++);if(_!==h&&!y(n.charCodeAt(h+1))){for(h+=1;h<i;h++)if(y(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,o)}}return o}else if(E(s)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+o:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<i;c++)if(y(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=D;function k(n){if(!b.isWindows||!n||n.length<5)return!1;let o=n.charCodeAt(0);if(o!==92||(o=n.charCodeAt(1),o!==92))return!1;let i=2;const s=i;for(;i<n.length&&(o=n.charCodeAt(i),o!==92);i++);return!(s===i||(o=n.charCodeAt(i+1),isNaN(o)||o===92))}e.isUNC=k;const r=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(n,o=b.isWindows){const i=o?r:C;return!(!n||n.length===0||/^\s+$/.test(n)||(i.lastIndex=0,i.test(n))||o&&f.test(n)||n==="."||n===".."||o&&n[n.length-1]==="."||o&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=g;function a(n,o,i){const s=n===o;return!i||s?s:!n||!o?!1:(0,I.equalsIgnoreCase)(n,o)}e.isEqual=a;function d(n,o,i,s=T.sep){if(n===o)return!0;if(!n||!o||o.length>n.length)return!1;if(i){if(!(0,I.startsWithIgnoreCase)(n,o))return!1;if(o.length===n.length)return!0;let h=o.length;return o.charAt(o.length-1)===s&&h--,n.charAt(h)===s}return o.charAt(o.length-1)!==s&&(o+=s),n.indexOf(o)===0}e.isEqualOrParent=d;function E(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=E;function w(n,o){return b.isWindows&&n.endsWith(":")&&(n+=T.sep),(0,T.isAbsolute)(n)||(n=(0,T.join)(o,n)),n=(0,T.normalize)(n),b.isWindows?(n=(0,I.rtrim)(n,T.sep),n.endsWith(":")&&(n+=T.sep)):(n=(0,I.rtrim)(n,T.sep),n||(n=T.sep)),n}e.sanitizeFilePath=w;function S(n){const o=(0,T.normalize)(n);return b.isWindows?n.length>3?!1:m(o)&&(n.length===2||o.charCodeAt(2)===92):o===T.posix.sep}e.isRootOrDriveLetter=S;function m(n){return b.isWindows?E(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function l(n){return m(n)?n[0]:void 0}e.getDriveLetter=l;function v(n,o,i){return o.length>n.length?-1:n===o?0:(i&&(n=n.toLowerCase(),o=o.toLowerCase()),n.indexOf(o))}e.indexOfPath=v;function t(n){const o=n.split(":");let i,s,c;if(o.forEach(h=>{const _=Number(h);(0,A.isNumber)(_)?s===void 0?s=_:c===void 0&&(c=_):i=i?[i,h].join(":"):h}),!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:s!==void 0?s:void 0,column:c!==void 0?c:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[24],pe([0,1,11]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const E=Array.isArray(d)?[]:{};return Object.keys(d).forEach(w=>{d[w]&&typeof d[w]=="object"?E[w]=I(d[w]):E[w]=d[w]}),E}e.deepClone=I;function T(d){if(!d||typeof d!="object")return d;const E=[d];for(;E.length>0;){const w=E.shift();Object.freeze(w);for(const S in w)if(A.call(w,S)){const m=w[S];typeof m=="object"&&!Object.isFrozen(m)&&E.push(m)}}return d}e.deepFreeze=T;const A=Object.prototype.hasOwnProperty;function y(d,E){return P(d,E,new Set)}e.cloneAndChange=y;function P(d,E,w){if((0,b.isUndefinedOrNull)(d))return d;const S=E(d);if(typeof S!="undefined")return S;if((0,b.isArray)(d)){const m=[];for(const l of d)m.push(P(l,E,w));return m}if((0,b.isObject)(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const m={};for(let l in d)A.call(d,l)&&(m[l]=P(d[l],E,w));return w.delete(d),m}return d}function D(d,E,w=!0){return(0,b.isObject)(d)?((0,b.isObject)(E)&&Object.keys(E).forEach(S=>{S in d?w&&((0,b.isObject)(d[S])&&(0,b.isObject)(E[S])?D(d[S],E[S],w):d[S]=E[S]):d[S]=E[S]}),d):E}e.mixin=D;function k(d,E){if(d===E)return!0;if(d==null||E===null||E===void 0||typeof d!=typeof E||typeof d!="object"||Array.isArray(d)!==Array.isArray(E))return!1;let w,S;if(Array.isArray(d)){if(d.length!==E.length)return!1;for(w=0;w<d.length;w++)if(!k(d[w],E[w]))return!1}else{const m=[];for(S in d)m.push(S);m.sort();const l=[];for(S in E)l.push(S);if(l.sort(),!k(m,l))return!1;for(w=0;w<m.length;w++)if(!k(d[m[w]],E[m[w]]))return!1}return!0}e.equals=k;function r(d){const E=new Set;return JSON.stringify(d,(w,S)=>{if((0,b.isObject)(S)||Array.isArray(S)){if(E.has(S))return"[Circular]";E.add(S)}return S})}e.safeStringify=r;function C(d,E,w){const S=E(d);return typeof S=="undefined"?w:S}e.getOrDefault=C;function f(d,E){const w=Object.create(null);return!d||!E||Object.keys(E).forEach(m=>{const l=d[m],v=E[m];k(l,v)||(w[m]=v)}),w}e.distinct=f;function g(d,E){const w=E.toLowerCase(),S=Object.keys(d).find(m=>m.toLowerCase()===w);return S?d[S]:d[E]}e.getCaseInsensitive=g;function a(d,E){const w=Object.create(null);for(const S of Object.keys(d))E(S,d[S])&&(w[S]=d[S]);return w}e.filter=a}),define(ge[97],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function I(A){return A<0?0:A>255?255:A|0}e.toUint8=I;function T(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=T}),define(ge[2],pe([0,1,10,8]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function P(o,i){if(!o.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!A.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(o,i){return!o&&!i?"file":o}function k(o,i){switch(o){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const r="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(i,s,c,h,_,u=!1){typeof i=="object"?(this.scheme=i.scheme||r,this.authority=i.authority||r,this.path=i.path||r,this.query=i.query||r,this.fragment=i.fragment||r):(this.scheme=D(i,u),this.authority=s||r,this.path=k(this.scheme,c||r),this.query=h||r,this.fragment=_||r,P(this,u))}static isUri(i){return i instanceof g?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return m(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:c,path:h,query:_,fragment:u}=i;return s===void 0?s=this.scheme:s===null&&(s=r),c===void 0?c=this.authority:c===null&&(c=r),h===void 0?h=this.path:h===null&&(h=r),_===void 0?_=this.query:_===null&&(_=r),u===void 0?u=this.fragment:u===null&&(u=r),s===this.scheme&&c===this.authority&&h===this.path&&_===this.query&&u===this.fragment?this:new d(s,c,h,_,u)}static parse(i,s=!1){const c=f.exec(i);return c?new d(c[2]||r,n(c[4]||r),n(c[5]||r),n(c[7]||r),n(c[9]||r),s):new d(r,r,r,r,r)}static file(i){let s=r;if(b.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const c=i.indexOf(C,2);c===-1?(s=i.substring(2),i=C):(s=i.substring(2,c),i=i.substring(c)||C)}return new d("file",s,i,r,r)}static from(i){return new d(i.scheme,i.authority,i.path,i.query,i.fragment)}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return b.isWindows&&i.scheme==="file"?c=g.file(I.win32.join(m(i,!0),...s)).path:c=I.posix.join(i.path,...s),i.with({path:c})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof g)return i;{const s=new d(i);return s._formatted=i.external,s._fsPath=i._sep===a?i.fsPath:null,s}}else return i}}e.URI=g;const a=b.isWindows?1:void 0;class d extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=a),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(o,i){let s,c=-1;for(let h=0;h<o.length;h++){const _=o.charCodeAt(h);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||i&&_===47)c!==-1&&(s+=encodeURIComponent(o.substring(c,h)),c=-1),s!==void 0&&(s+=o.charAt(h));else{s===void 0&&(s=o.substr(0,h));const u=E[_];u!==void 0?(c!==-1&&(s+=encodeURIComponent(o.substring(c,h)),c=-1),s+=u):c===-1&&(c=h)}}return c!==-1&&(s+=encodeURIComponent(o.substring(c))),s!==void 0?s:o}function S(o){let i;for(let s=0;s<o.length;s++){const c=o.charCodeAt(s);c===35||c===63?(i===void 0&&(i=o.substr(0,s)),i+=E[c]):i!==void 0&&(i+=o[s])}return i!==void 0?i:o}function m(o,i){let s;return o.authority&&o.path.length>1&&o.scheme==="file"?s=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?i?s=o.path.substr(1):s=o.path[1].toLowerCase()+o.path.substr(2):s=o.path,b.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=m;function l(o,i){const s=i?S:w;let c="",{scheme:h,authority:_,path:u,query:p,fragment:R}=o;if(h&&(c+=h,c+=":"),(_||h==="file")&&(c+=C,c+=C),_){let O=_.indexOf("@");if(O!==-1){const V=_.substr(0,O);_=_.substr(O+1),O=V.indexOf(":"),O===-1?c+=s(V,!1):(c+=s(V.substr(0,O),!1),c+=":",c+=s(V.substr(O+1),!1)),c+="@"}_=_.toLowerCase(),O=_.indexOf(":"),O===-1?c+=s(_,!1):(c+=s(_.substr(0,O),!1),c+=_.substr(O))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const O=u.charCodeAt(1);O>=65&&O<=90&&(u=`/${String.fromCharCode(O+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const O=u.charCodeAt(0);O>=65&&O<=90&&(u=`${String.fromCharCode(O+32)}:${u.substr(2)}`)}c+=s(u,!0)}return p&&(c+="?",c+=s(p,!1)),R&&(c+="#",c+=i?R:w(R,!1)),c}function v(o){try{return decodeURIComponent(o)}catch(i){return o.length>3?o.substr(0,3)+v(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(t)?o.replace(t,i=>v(i)):o}});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(ge[22],pe([0,1,2,9]),function(G,e,b,I){"use strict";var T,A,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,n,o){let i=t.get(n);return i===void 0&&(i=o,t.set(n,i)),i}e.getOrSet=P;function D(t){const n=[];return t.forEach((o,i)=>{n.push(`${i} => ${o}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function k(t){const n=[];return t.forEach(o=>{n.push(o)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class r{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),i=this._value.charCodeAt(this._pos);return o-i}value(){return this._value[this._pos]}}e.StringIterator=r;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new a(n))}static forPaths(){return new E(new f)}static forStrings(){return new E(new r)}static forConfigKeys(){return new E(new C)}clear(){this._root=void 0}set(n,o){const i=this._iter.reset(n);let s;for(this._root||(this._root=new d,this._root.segment=i.value()),s=this._root;;){const h=i.cmp(s.segment);if(h>0)s.left||(s.left=new d,s.left.segment=i.value()),s=s.left;else if(h<0)s.right||(s.right=new d,s.right.segment=i.value()),s=s.right;else if(i.hasNext())i.next(),s.mid||(s.mid=new d,s.mid.segment=i.value()),s=s.mid;else break}const c=s.value;return s.value=o,s.key=n,c}get(n){var o;return(o=this._getNode(n))===null||o===void 0?void 0:o.value}_getNode(n){const o=this._iter.reset(n);let i=this._root;for(;i;){const s=o.cmp(i.segment);if(s>0)i=i.left;else if(s<0)i=i.right;else if(o.hasNext())o.next(),i=i.mid;else break}return i}has(n){const o=this._getNode(n);return!((o==null?void 0:o.value)===void 0&&(o==null?void 0:o.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const i=this._iter.reset(n),s=[];let c=this._root;for(;c;){const h=i.cmp(c.segment);if(h>0)s.push([1,c]),c=c.left;else if(h<0)s.push([-1,c]),c=c.right;else if(i.hasNext())i.next(),s.push([0,c]),c=c.mid;else{for(o?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;s.length>0&&c.isEmpty();){let[_,u]=s.pop();switch(_){case 1:u.left=void 0;break;case 0:u.mid=void 0;break;case-1:u.right=void 0;break}c=u}break}}}findSubstr(n){const o=this._iter.reset(n);let i=this._root,s;for(;i;){const c=o.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(o.hasNext())o.next(),s=i.value||s,i=i.mid;else break}return i&&i.value||s}findSuperstr(n){const o=this._iter.reset(n);let i=this._root;for(;i;){const s=o.cmp(i.segment);if(s>0)i=i.left;else if(s<0)i=i.right;else if(o.hasNext())o.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(n){for(const[o,i]of this)n(i,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class w{constructor(n,o){this[T]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=o!=null?o:w.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:w.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),o),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[i,s]of this.map)n(s,b.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield b.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[b.URI.parse(n[0]),n[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[b.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class m{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,o=0){const i=this._map.get(n);if(!!i)return o!==0&&this.touch(i,o),i.value}set(n,o,i=0){let s=this._map.get(n);if(s)s.value=o,i!==0&&this.touch(s,i);else{switch(s={key:n,value:o,next:void 0,previous:void 0},i){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,o){const i=this._state;let s=this._head;for(;s;){if(o?n.bind(o)(s.value,s.key,this):n(s.value,s.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,o=this._state;let i=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:i.key,done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return s}values(){const n=this,o=this._state;let i=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:i.value,done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return s}entries(){const n=this,o=this._state;let i=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:[i.key,i.value],done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return s}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let o=this._head,i=this.size;for(;o&&i>n;)this._map.delete(o.key),o=o.next,i--;this._head=o,this._size=i,o&&(o.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,i=n.previous;if(!o||!i)throw new Error("Invalid list");o.previous=i,i.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const i=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(i.previous=s,s.next=i),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const i=n.next,s=n.previous;n===this._head?(i.previous=void 0,this._head=i):(i.previous=s,s.next=i),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,i)=>{n.push([i,o])}),n}fromJSON(n){this.clear();for(const[o,i]of n)this.set(o,i)}}e.LinkedMap=m;class l extends m{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class v{constructor(n){y.set(this,void 0),tt(this,y,n,"f")}get size(){return Ue(this,y,"f").size}forEach(n,o){Ue(this,y,"f").forEach(n,o)}get(n){return Ue(this,y,"f").get(n)}has(n){return Ue(this,y,"f").has(n)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=v}),define(ge[98],pe([0,1,22,9]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...we){return function(Pe,Re){for(let Be=0,Se=we.length;Be<Se;Be++){const qe=we[Be](Pe,Re);if(qe)return qe}return null}}e.or=T,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(we,Pe,Re){if(!Re||Re.length<Pe.length)return null;let Be;return we?Be=I.startsWithIgnoreCase(Re,Pe):Be=Re.indexOf(Pe)===0,Be?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function y(we,Pe){const Re=Pe.toLowerCase().indexOf(we.toLowerCase());return Re===-1?null:[{start:Re,end:Re+we.length}]}e.matchesContiguousSubString=y;function P(we,Pe){return D(we.toLowerCase(),Pe.toLowerCase(),0,0)}e.matchesSubString=P;function D(we,Pe,Re,Be){if(Re===we.length)return[];if(Be===Pe.length)return null;if(we[Re]===Pe[Be]){let Se=null;return(Se=D(we,Pe,Re+1,Be+1))?w({start:Be,end:Be+1},Se):null}return D(we,Pe,Re,Be+1)}function k(we){return 97<=we&&we<=122}function r(we){return 65<=we&&we<=90}e.isUpper=r;function C(we){return 48<=we&&we<=57}function f(we){return we===32||we===9||we===10||we===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(we=>g.add(we.charCodeAt(0)));function a(we){return f(we)||g.has(we)}function d(we,Pe){return we===Pe||a(we)&&a(Pe)}function E(we){return k(we)||r(we)||C(we)}function w(we,Pe){return Pe.length===0?Pe=[we]:we.end===Pe[0].start?Pe[0].start=we.start:Pe.unshift(we),Pe}function S(we,Pe){for(let Re=Pe;Re<we.length;Re++){const Be=we.charCodeAt(Re);if(r(Be)||C(Be)||Re>0&&!E(we.charCodeAt(Re-1)))return Re}return we.length}function m(we,Pe,Re,Be){if(Re===we.length)return[];if(Be===Pe.length)return null;if(we[Re]!==Pe[Be].toLowerCase())return null;{let Se=null,qe=Be+1;for(Se=m(we,Pe,Re+1,Be+1);!Se&&(qe=S(Pe,qe))<Pe.length;)Se=m(we,Pe,Re+1,qe),qe++;return Se===null?null:w({start:Be,end:Be+1},Se)}}function l(we){let Pe=0,Re=0,Be=0,Se=0,qe=0;for(let ze=0;ze<we.length;ze++)qe=we.charCodeAt(ze),r(qe)&&Pe++,k(qe)&&Re++,E(qe)&&Be++,C(qe)&&Se++;const X=Pe/we.length,ie=Re/we.length,_e=Be/we.length,Ne=Se/we.length;return{upperPercent:X,lowerPercent:ie,alphaPercent:_e,numericPercent:Ne}}function v(we){const{upperPercent:Pe,lowerPercent:Re}=we;return Re===0&&Pe>.6}function t(we){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:Be,numericPercent:Se}=we;return Re>.2&&Pe<.8&&Be>.6&&Se<.2}function n(we){let Pe=0,Re=0,Be=0,Se=0;for(let qe=0;qe<we.length;qe++)Be=we.charCodeAt(qe),r(Be)&&Pe++,k(Be)&&Re++,f(Be)&&Se++;return(Pe===0||Re===0)&&Se===0?we.length<=30:Pe<=5}function o(we,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!n(we)||Pe.length>60)return null;const Re=l(Pe);if(!t(Re)){if(!v(Re))return null;Pe=Pe.toLowerCase()}let Be=null,Se=0;for(we=we.toLowerCase();Se<Pe.length&&(Be=m(we,Pe,0,Se))===null;)Se=S(Pe,Se+1);return Be}e.matchesCamelCase=o;function i(we,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let Be=null,Se=0;for(we=we.toLowerCase(),Pe=Pe.toLowerCase();Se<Pe.length&&(Be=s(we,Pe,0,Se,Re))===null;)Se=c(Pe,Se+1);return Be}e.matchesWords=i;function s(we,Pe,Re,Be,Se){if(Re===we.length)return[];if(Be===Pe.length)return null;if(d(we.charCodeAt(Re),Pe.charCodeAt(Be))){let qe=null,X=Be+1;if(qe=s(we,Pe,Re+1,Be+1,Se),!Se)for(;!qe&&(X=c(Pe,X))<Pe.length;)qe=s(we,Pe,Re+1,X,Se),X++;return qe===null?null:w({start:Be,end:Be+1},qe)}else return null}function c(we,Pe){for(let Re=Pe;Re<we.length;Re++)if(a(we.charCodeAt(Re))||Re>0&&a(we.charCodeAt(Re-1)))return Re;return we.length}const h=T(e.matchesPrefix,o,y),_=T(e.matchesPrefix,o,P),u=new b.LRUCache(1e4);function p(we,Pe,Re=!1){if(typeof we!="string"||typeof Pe!="string")return null;let Be=u.get(we);Be||(Be=new RegExp(I.convertSimple2RegExpPattern(we),"i"),u.set(we,Be));const Se=Be.exec(Pe);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Re?_(we,Pe):h(we,Pe)}e.matchesFuzzy=p;function R(we,Pe){const Re=H(we,we.toLowerCase(),0,Pe,Pe.toLowerCase(),0,!0);return Re?V(Re):null}e.matchesFuzzy2=R;function O(we,Pe,Re,Be,Se,qe){const X=Math.min(13,we.length);for(;Re<X;Re++){const ie=H(we,Pe,Re,Be,Se,qe,!1);if(ie)return ie}return[0,qe]}e.anyScore=O;function V(we){if(typeof we=="undefined")return[];const Pe=[],Re=we[1];for(let Be=we.length-1;Be>1;Be--){const Se=we[Be]+Re,qe=Pe[Pe.length-1];qe&&qe.end===Se?qe.end=Se+1:Pe.push({start:Se,end:Se+1})}return Pe}e.createMatches=V;const re=128;function j(){const we=[],Pe=[];for(let Re=0;Re<=re;Re++)Pe[Re]=0;for(let Re=0;Re<=re;Re++)we.push(Pe.slice(0));return we}function x(we){const Pe=[];for(let Re=0;Re<=we;Re++)Pe[Re]=0;return Pe}const W=x(2*re),U=x(2*re),M=j(),F=j(),L=j(),N=!1;function $(we,Pe,Re,Be,Se){function qe(ie,_e,Ne=" "){for(;ie.length<_e;)ie=Ne+ie;return ie}let X=` |   |${Be.split("").map(ie=>qe(ie,3)).join("|")}
`;for(let ie=0;ie<=Re;ie++)ie===0?X+=" |":X+=`${Pe[ie-1]}|`,X+=we[ie].slice(0,Se+1).map(_e=>qe(_e.toString(),3)).join("|")+`
`;return X}function q(we,Pe,Re,Be){we=we.substr(Pe),Re=Re.substr(Be),console.log($(F,we,we.length,Re,Re.length)),console.log($(L,we,we.length,Re,Re.length)),console.log($(M,we,we.length,Re,Re.length))}function Q(we,Pe){if(Pe<0||Pe>=we.length)return!1;const Re=we.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Re)}}function de(we,Pe){if(Pe<0||Pe>=we.length)return!1;switch(we.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function be(we,Pe,Re){return Pe[we]!==Re[we]}function Ae(we,Pe,Re,Be,Se,qe,X=!1){for(;Pe<Re&&Se<qe;)we[Pe]===Be[Se]&&(X&&(W[Pe]=Se),Pe+=1),Se+=1;return Pe===Re}e.isPatternInWord=Ae;var Ce;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Le;(function(we){we.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}we.isDefault=Pe})(Le=e.FuzzyScore||(e.FuzzyScore={}));function H(we,Pe,Re,Be,Se,qe,X){const ie=we.length>re?re:we.length,_e=Be.length>re?re:Be.length;if(!(Re>=ie||qe>=_e||ie-Re>_e-qe)&&!!Ae(Pe,Re,ie,Se,qe,_e,!0)){Y(ie,_e,Re,qe,Pe,Se);let Ne=1,ze=1,$e=Re,Je=qe;const K=[!1];for(Ne=1,$e=Re;$e<ie;Ne++,$e++){const ce=W[$e],ve=U[$e],ye=$e+1<ie?U[$e+1]:_e;for(ze=ce-qe+1,Je=ce;Je<ye;ze++,Je++){let je=Number.MIN_SAFE_INTEGER,He=!1;Je<=ve&&(je=ee(we,Pe,$e,Re,Be,Se,Je,_e,qe,M[Ne-1][ze-1]===0,K));let We=0;je!==Number.MAX_SAFE_INTEGER&&(He=!0,We=je+F[Ne-1][ze-1]);const Ge=Je>ce,nt=Ge?F[Ne][ze-1]+(M[Ne][ze-1]>0?-5:0):0,dt=Je>ce+1&&M[Ne][ze-1]>0,it=dt?F[Ne][ze-2]+(M[Ne][ze-2]>0?-5:0):0;if(dt&&(!Ge||it>=nt)&&(!He||it>=We))F[Ne][ze]=it,L[Ne][ze]=3,M[Ne][ze]=0;else if(Ge&&(!He||nt>=We))F[Ne][ze]=nt,L[Ne][ze]=2,M[Ne][ze]=0;else if(He)F[Ne][ze]=We,L[Ne][ze]=1,M[Ne][ze]=M[Ne-1][ze-1]+1;else throw new Error("not possible")}}if(N&&q(we,Re,Be,qe),!(!K[0]&&!X)){Ne--,ze--;const se=[F[Ne][ze],qe];let he=0,J=0;for(;Ne>=1;){let ce=ze;do{const ve=L[Ne][ce];if(ve===3)ce=ce-2;else if(ve===2)ce=ce-1;else break}while(ce>=1);he>1&&Pe[Re+Ne-1]===Se[qe+ze-1]&&!be(ce+qe-1,Be,Se)&&he+1>M[Ne][ce]&&(ce=ze),ce===ze?he++:he=1,J||(J=ce),Ne--,ze=ce-1,se.push(ze)}_e===ie&&(se[0]+=2);const te=J-ie;return se[0]-=te,se}}}e.fuzzyScore=H;function Y(we,Pe,Re,Be,Se,qe){let X=we-1,ie=Pe-1;for(;X>=Re&&ie>=Be;)Se[X]===qe[ie]&&(U[X]=ie,X--),ie--}function ee(we,Pe,Re,Be,Se,qe,X,ie,_e,Ne,ze){if(Pe[Re]!==qe[X])return Number.MIN_SAFE_INTEGER;let $e=1,Je=!1;return X===Re-Be?$e=we[Re]===Se[X]?7:5:be(X,Se,qe)&&(X===0||!be(X-1,Se,qe))?($e=we[Re]===Se[X]?7:5,Je=!0):Q(qe,X)&&(X===0||!Q(qe,X-1))?$e=5:(Q(qe,X-1)||de(qe,X-1))&&($e=5,Je=!0),$e>1&&Re===Be&&(ze[0]=!0),Je||(Je=be(X,Se,qe)||Q(qe,X-1)||de(qe,X-1)),Re===Be?X>_e&&($e-=Je?3:5):Ne?$e+=Je?2:0:$e+=Je?0:1,X+1===ie&&($e-=Je?3:5),$e}function ae(we,Pe,Re,Be,Se,qe,X){return De(we,Pe,Re,Be,Se,qe,!0,X)}e.fuzzyScoreGracefulAggressive=ae;function me(we,Pe,Re,Be,Se,qe,X){return De(we,Pe,Re,Be,Se,qe,!1,X)}e.fuzzyScoreGraceful=me;function De(we,Pe,Re,Be,Se,qe,X,ie){let _e=H(we,Pe,Re,Be,Se,qe,ie);if(_e&&!X)return _e;if(we.length>=3){const Ne=Math.min(7,we.length-1);for(let ze=Re+1;ze<Ne;ze++){const $e=Oe(we,ze);if($e){const Je=H($e,$e.toLowerCase(),Re,Be,Se,qe,ie);Je&&(Je[0]-=3,(!_e||Je[0]>_e[0])&&(_e=Je))}}}return _e}function Oe(we,Pe){if(!(Pe+1>=we.length)){const Re=we[Pe],Be=we[Pe+1];if(Re!==Be)return we.slice(0,Pe)+Be+Re+we.slice(Pe+2)}}}),define(ge[136],pe([0,1,43,98,9]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function P(d){return d.replace(y,(E,w)=>w?E:`\\${E}`)}e.escapeIcons=P;const D=new RegExp(`\\\\${A.source}`,"g");function k(d){return d.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=k;const r=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function C(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(r,(E,w,S,m)=>S?E:w||m||"")}e.stripIcons=C;function f(d){const E=d.indexOf(e.iconStartMarker);return E===-1?{text:d}:g(d,E)}e.parseLabelWithIcons=f;function g(d,E){const w=[];let S="";function m(c){if(c){S+=c;for(const h of c)w.push(t)}}let l=-1,v="",t=0,n,o,i=E;const s=d.length;for(m(d.substr(0,E));i<s;)n=d[i],o=d[i+1],n===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(l=i,m(v),v=e.iconStartMarker,i++):n===")"&&l!==-1?(t+=i-l+1,l=-1,v=""):l!==-1?/^[a-z0-9\-]$/i.test(n)?v+=n:(m(v),l=-1,v=""):m(n),i++;return m(v),{text:S,iconOffsets:w}}function a(d,E,w=!1){const{text:S,iconOffsets:m}=E;if(!m||m.length===0)return(0,I.matchesFuzzy)(d,S,w);const l=(0,T.ltrim)(S," "),v=S.length-l.length,t=(0,I.matchesFuzzy)(d,l,w);if(t)for(const n of t){const o=m[n.start+v]+v;n.start+=o,n.end+=o}return t}e.matchesFuzzyIconAware=a}),define(ge[99],pe([0,1,17,136,16]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(d="",E=!1){var w,S;if(this.value=d,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(w=E.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(S=E.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(d,E=0){return this.value+=C(this.supportThemeIcons?(0,I.escapeIcons)(d):d).replace(/([ \t]+)/g,(w,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,E){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function P(a){return D(a)?!a.value:Array.isArray(a)?a.every(P):!0}e.isEmptyMarkdownString=P;function D(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function k(a,d){return!a&&!d?!0:!a||!d?!1:Array.isArray(a)&&Array.isArray(d)?(0,b.equals)(a,d,r):D(a)&&D(d)?r(a,d):!1}e.markedStringsEquals=k;function r(a,d){return a===d?!0:!a||!d?!1:a.value===d.value&&a.isTrusted===d.isTrusted&&a.supportThemeIcons===d.supportThemeIcons}function C(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function f(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function g(a){const d=[],E=a.split("|").map(S=>S.trim());a=E[0];const w=E[1];if(w){const S=/height=(\d+)/.exec(w),m=/width=(\d+)/.exec(w),l=S?S[1]:"",v=m?m[1]:"",t=isFinite(parseInt(v)),n=isFinite(parseInt(l));t&&d.push(`width="${v}"`),n&&d.push(`height="${l}"`)}return{href:a,dimensions:d}}e.parseHrefAndDimensions=g}),define(ge[58],pe([0,1,23,9,2]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(k){return JSON.stringify(k,P)}e.stringify=A;function y(k){let r=JSON.parse(k);return r=D(r),r}e.parse=y;function P(k,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:(0,I.regExpFlags)(r)}:r}function D(k,r=0){if(!k||r>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return T.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof b.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=D(k[C],r+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=D(k[C],r+1))}return k}e.revive=D}),define(ge[12],pe([0,1,2,10]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(T=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,k,r){this._hosts[D]=k,this._ports[D]=r}setConnectionToken(D,k){this._connectionTokens[D]=k}rewrite(D){if(this._delegate)return this._delegate(D);const k=D.authority;let r=this._hosts[k];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const C=this._ports[k],f=this._connectionTokens[k];let g=`path=${encodeURIComponent(D.path)}`;return typeof f=="string"&&(g+=`&tkn=${encodeURIComponent(f)}`),b.URI.from({scheme:I.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${r}:${C}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new A;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,k,r){const C=this.toUri(D,k);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):I.isNative&&(r||I.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(D,k){const r=this.toUri(D,k);return r.scheme===T.vscodeFileResource?r.with({scheme:T.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(D,k){return b.URI.isUri(D)?D:b.URI.parse(k.toUrl(D))}}e.FileAccess=new y}),define(ge[75],pe([0,1,22]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const I=new b.LRUCache(1e4);function T(k){return D(k,"NFC",I)}e.normalizeNFC=T;const A=new b.LRUCache(1e4);function y(k){return D(k,"NFD",A)}e.normalizeNFD=y;const P=/[^\u0000-\u0080]/;function D(k,r,C){if(!e.canNormalize||!k)return k;const f=C.get(k);if(f)return f;let g;return P.test(k)?g=k.normalize(r):g=k,C.set(k,g),g}e.removeAccents=function(){if(e.canNormalize){const k=/[\u0300-\u036f]/g;return function(r){return y(r).replace(k,"")}}else return function(k){return k}}()}),define(ge[25],pe([0,1,29,8,2,9,12,10]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(g){return(0,T.uriToFsPath)(g,!0)}e.originalFSPath=D;class k{constructor(a){this._ignorePathCasing=a}compare(a,d,E=!1){return a===d?0:(0,A.compare)(this.getComparisonKey(a,E),this.getComparisonKey(d,E))}isEqual(a,d,E=!1){return a===d?!0:!a||!d?!1:this.getComparisonKey(a,E)===this.getComparisonKey(d,E)}getComparisonKey(a,d=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,d,E=!1){if(a.scheme===d.scheme){if(a.scheme===y.Schemas.file)return b.isEqualOrParent(D(a),D(d),this._ignorePathCasing(a))&&a.query===d.query&&(E||a.fragment===d.fragment);if((0,e.isEqualAuthority)(a.authority,d.authority))return b.isEqualOrParent(a.path,d.path,this._ignorePathCasing(a),"/")&&a.query===d.query&&(E||a.fragment===d.fragment)}return!1}joinPath(a,...d){return T.URI.joinPath(a,...d)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return I.posix.basename(a.path)}extname(a){return I.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let d;return a.scheme===y.Schemas.file?d=T.URI.file(I.dirname(D(a))).path:(d=I.posix.dirname(a.path),a.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),d="/")),a.with({path:d})}normalizePath(a){if(!a.path.length)return a;let d;return a.scheme===y.Schemas.file?d=T.URI.file(I.normalize(D(a))).path:d=I.posix.normalize(a.path),a.with({path:d})}relativePath(a,d){if(!(a.scheme!==d.scheme||!(0,e.isEqualAuthority)(a.authority,d.authority))){if(a.scheme===y.Schemas.file){const S=I.relative(D(a),D(d));return P.isWindows?b.toSlashes(S):S}let E=a.path||"/",w=d.path||"/";if(this._ignorePathCasing(a)){let S=0;for(const m=Math.min(E.length,w.length);S<m&&!(E.charCodeAt(S)!==w.charCodeAt(S)&&E.charAt(S).toLowerCase()!==w.charAt(S).toLowerCase());S++);E=w.substr(0,S)+E.substr(S)}return I.posix.relative(E,w)}}resolvePath(a,d){if(a.scheme===y.Schemas.file){const E=T.URI.file(I.resolve(D(a),d));return a.with({authority:E.authority,path:E.path})}return d.indexOf("/")===-1&&(d=b.toSlashes(d),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d)),a.with({path:I.posix.resolve(a.path,d)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,d){return a===d||(0,A.equalsIgnoreCase)(a,d)}hasTrailingPathSeparator(a,d=I.sep){if(a.scheme===y.Schemas.file){const E=D(a);return E.length>b.getRoot(E).length&&E[E.length-1]===d}else{const E=a.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,d=I.sep){return(0,e.hasTrailingPathSeparator)(a,d)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,d=I.sep){let E=!1;if(a.scheme===y.Schemas.file){const w=D(a);E=w!==void 0&&w.length===b.getRoot(w).length&&w[w.length-1]===d}else{d="/";const w=a.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(a,d)?a.with({path:a.path+"/"}):a}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(g=>g.scheme===y.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(g,a){const d=[];for(let E=0;E<g.length;E++){const w=a(g[E]);g.some((S,m)=>m===E?!1:(0,e.isEqualOrParent)(w,a(S)))||d.push(g[E])}return d}e.distinctParents=r;var C;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function a(d){const E=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(m=>{const[l,v]=m.split(":");l&&v&&E.set(l,v)});const S=d.path.substring(0,d.path.indexOf(";"));return S&&E.set(g.META_DATA_MIME,S),E}g.parseMetaData=a})(C=e.DataUri||(e.DataUri={}));function f(g,a,d){if(a){let E=g.path;return E&&E[0]!==I.posix.sep&&(E=I.posix.sep+E),g.with({scheme:d,authority:a,path:E})}return g.with({scheme:d})}e.toLocalResource=f}),define(ge[13],pe([0,1,21,16,3,6,56,25]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(F){return!!F&&typeof F.then=="function"}e.isThenable=D;function k(F){const L=new b.CancellationTokenSource,N=F(L.token),$=new Promise((q,Q)=>{L.token.onCancellationRequested(()=>{Q((0,I.canceled)())}),Promise.resolve(N).then(de=>{L.dispose(),q(de)},de=>{L.dispose(),Q(de)})});return new class{cancel(){L.cancel()}then(q,Q){return $.then(q,Q)}catch(q){return this.then(void 0,q)}finally(q){return $.finally(q)}}}e.createCancelablePromise=k;function r(F,L,N){return Promise.race([F,new Promise($=>L.onCancellationRequested(()=>$(N)))])}e.raceCancellation=r;async function C(F){let L=-1;const N=F.map((q,Q)=>q.then(de=>(L=Q,de))),$=await Promise.race(N);return F.forEach((q,Q)=>{Q!==L&&q.cancel()}),$}e.raceCancellablePromises=C;function f(F,L,N){let $;const q=setTimeout(()=>{$==null||$(void 0),N==null||N()},L);return Promise.race([F.finally(()=>clearTimeout(q)),new Promise(Q=>$=Q)])}e.raceTimeout=f;function g(F){return new Promise((L,N)=>{const $=F();D($)?$.then(L,N):L($)})}e.asPromise=g;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(N,N).then($)})}return new Promise((N,$)=>{this.queuedPromise.then(N,$)})}return this.activePromise=L(),new Promise((N,$)=>{this.activePromise.then(q=>{this.activePromise=null,N(q)},q=>{this.activePromise=null,$(q)})})}}e.Throttler=a;class d{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=d;class E{constructor(){this.promiseMap=new Map}queue(L,N){var $;const Q=(($=this.promiseMap.get(L))!==null&&$!==void 0?$:Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(L)===Q&&this.promiseMap.delete(L)});return this.promiseMap.set(L,Q),Q}}e.SequencerByKey=E;class w{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,N=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,q)=>{this.doResolve=$,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class S{constructor(L){this.delayer=new w(L),this.throttler=new a}trigger(L,N){return this.delayer.trigger(()=>this.throttler.queue(L),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class m{constructor(){this._isOpen=!1,this._promise=new Promise((L,N)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class l extends m{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function v(F,L){return L?new Promise((N,$)=>{const q=setTimeout(N,F);L.onCancellationRequested(()=>{clearTimeout(q),$((0,I.canceled)())})}):k(N=>v(F,N))}e.timeout=v;function t(F,L=0){const N=setTimeout(F,L);return(0,A.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=t;function n(F){return F.then(void 0,L=>{})}e.ignoreErrors=n;function o(F){const L=[];let N=0;const $=F.length;function q(){return N<$?F[N++]():null}function Q(de){de!=null&&L.push(de);const be=q();return be?be.then(Q):Promise.resolve(L)}return Promise.resolve(null).then(Q)}e.sequence=o;function i(F,L=$=>!!$,N=null){let $=0;const q=F.length,Q=()=>{if($>=q)return Promise.resolve(N);const de=F[$++];return Promise.resolve(de()).then(Ae=>L(Ae)?Promise.resolve(Ae):Q())};return Q()}e.first=i;function s(F,L=$=>!!$,N=null){if(F.length===0)return Promise.resolve(N);let $=F.length;const q=()=>{var Q,de;$=-1;for(const be of F)(de=(Q=be).cancel)===null||de===void 0||de.call(Q)};return new Promise((Q,de)=>{for(const be of F)be.then(Ae=>{--$>=0&&L(Ae)?(q(),Q(Ae)):$===0&&Q(N)}).catch(Ae=>{--$>=0&&(q(),de(Ae))})})}e.firstParallel=s;class c{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((N,$)=>{this.outstandingPromises.push({factory:L,c:N,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const N=L.factory();N.then(L.c,L.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class h extends c{constructor(){super(1)}}e.Queue=h;class _{constructor(){this.queues=new Map}queueFor(L,N=P.extUri){const $=N.getComparisonKey(L);let q=this.queues.get($);return q||(q=new h,T.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete($)}),this.queues.set($,q)),q}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=_;class u{constructor(L,N){this._token=-1,typeof L=="function"&&typeof N=="number"&&this.setIfNotSet(L,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},N)}setIfNotSet(L,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},N))}}e.TimeoutTimer=u;class p{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,N){this.cancel(),this._token=setInterval(()=>{L()},N)}}e.IntervalTimer=p;class R{constructor(L,N){this.timeoutToken=-1,this.runner=L,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class O extends R{constructor(L,N){super(L,N);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const F=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const N=setTimeout(()=>L(F));let $=!1;return{dispose(){$||($=!0,clearTimeout(N))}}}}else e.runWhenIdle=(F,L)=>{const N=requestIdleCallback(F,typeof L=="number"?{timeout:L}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(N))}}}}();class V{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=V;async function re(F,L,N){let $;for(let q=0;q<N;q++)try{return await F()}catch(Q){$=Q,await v(L)}throw $}e.retry=re;class j{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var L;(L=this._pending)===null||L===void 0||L.cancel()}setPending(L,N,$){return this._pending={taskId:L,cancel:()=>$==null?void 0:$(),promise:N},N.then(()=>this.donePending(L),()=>this.donePending(L)),N}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let N,$;const q=new Promise((Q,de)=>{N=Q,$=de});this._next={run:L,promise:q,promiseResolve:N,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=j;class x{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,N)=>{this.completeCallback=L,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(N=>{this.completeCallback(L),this.resolved=!0,N()})}error(L){return new Promise(N=>{this.errorCallback(L),this.rejected=!0,N()})}cancel(){new Promise(L=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=W;class U extends T.Emitter{async fireAsync(L,N,$){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,L]);for(;this._asyncDeliveryQueue.size>0&&!N.isCancellationRequested;){const[q,Q]=this._asyncDeliveryQueue.shift(),de=[],be=Object.assign(Object.assign({},Q),{waitUntil:Ae=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");$&&(Ae=$(Ae,typeof q=="function"?q:q[0])),de.push(Ae)}});try{typeof q=="function"?q.call(void 0,be):q[0].call(q[1],be)}catch(Ae){(0,I.onUnexpectedError)(Ae);continue}Object.freeze(de),await M.settled(de).catch(Ae=>(0,I.onUnexpectedError)(Ae))}}}}e.AsyncEmitter=U;var M;(function(F){async function L(Q){return typeof Promise.allSettled=="function"?N(Q):$(Q)}F.allSettled=L;async function N(Q){return Promise.allSettled(Q)}async function $(Q){return Promise.all(Q.map(de=>de.then(be=>({status:"fulfilled",value:be}),be=>({status:"rejected",reason:be}))))}async function q(Q){let de;const be=await Promise.all(Q.map(Ae=>Ae.then(Ce=>Ce,Ce=>{de||(de=Ce)})));if(typeof de!="undefined")throw de;return be}F.settled=q})(M=e.Promises||(e.Promises={}))}),define(ge[100],pe([0,1,8,13]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new I.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),A=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(u,p,R=!1){const O=u||"",V=p||"",re=T.value.collator.compare(O,V);return T.value.collatorIsNumeric&&re===0&&O!==V?O<V?-1:1:re}e.compareFileNames=P;function D(u,p){const R=A.value.collator;return u=u||"",p=p||"",v(R,u,p)}e.compareFileNamesDefault=D;function k(u,p){const R=A.value.collator;return u=u||"",p=p||"",i(u,p)||v(R,u,p)}e.compareFileNamesUpper=k;function r(u,p){const R=A.value.collator;return u=u||"",p=p||"",o(u,p)||v(R,u,p)}e.compareFileNamesLower=r;function C(u,p){return u=u||"",p=p||"",u===p?0:u<p?-1:1}e.compareFileNamesUnicode=C;function f(u,p,R=!1){R||(u=u&&u.toLowerCase(),p=p&&p.toLowerCase());const[O,V]=m(u),[re,j]=m(p);return O!==re?O<re?-1:1:V===j?0:V<j?-1:1}e.noIntlCompareFileNames=f;function g(u,p){const[R,O]=m(u),[V,re]=m(p);let j=T.value.collator.compare(O,re);if(j===0){if(T.value.collatorIsNumeric&&O!==re)return O<re?-1:1;if(j=T.value.collator.compare(R,V),T.value.collatorIsNumeric&&j===0&&R!==V)return R<V?-1:1}return j}e.compareFileExtensions=g;function a(u,p){u=u||"",p=p||"";const R=l(u),O=l(p),V=A.value.collator,re=y.value.collator;return v(re,R,O)||v(V,u,p)}e.compareFileExtensionsDefault=a;function d(u,p){u=u||"",p=p||"";const R=l(u),O=l(p),V=A.value.collator,re=y.value.collator;return v(re,R,O)||i(u,p)||v(V,u,p)}e.compareFileExtensionsUpper=d;function E(u,p){u=u||"",p=p||"";const R=l(u),O=l(p),V=A.value.collator,re=y.value.collator;return v(re,R,O)||o(u,p)||v(V,u,p)}e.compareFileExtensionsLower=E;function w(u,p){u=u||"",p=p||"";const R=l(u).toLowerCase(),O=l(p).toLowerCase();return R!==O?R<O?-1:1:u!==p?u<p?-1:1:0}e.compareFileExtensionsUnicode=w;const S=/^(.*?)(\.([^.]*))?$/;function m(u,p=!1){const R=u?S.exec(u):[];let O=[R&&R[1]||"",R&&R[3]||""];return p&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function l(u){const p=u?S.exec(u):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function v(u,p,R){let O=u.compare(p,R);return O!==0?O:p.length!==R.length?p.length<R.length?-1:1:0}function t(u){const p=u.charAt(0);return p.toLocaleUpperCase()!==p}function n(u){const p=u.charAt(0);return p.toLocaleLowerCase()!==p}function o(u,p){return t(u)&&n(p)?-1:n(u)&&t(p)?1:0}function i(u,p){return n(u)&&t(p)?-1:t(u)&&n(p)?1:0}function s(u,p,R=!1){return R||(u=u&&u.toLowerCase(),p=p&&p.toLowerCase()),u===p?0:u<p?-1:1}function c(u,p,R=!1){const O=u.split(b.sep),V=p.split(b.sep),re=O.length-1,j=V.length-1;let x,W;for(let U=0;;U++){if(x=re===U,W=j===U,x&&W)return P(O[U],V[U],R);if(x)return-1;if(W)return 1;const M=s(O[U],V[U],R);if(M!==0)return M}}e.comparePaths=c;function h(u,p,R){const O=u.toLowerCase(),V=p.toLowerCase(),re=_(u,p,R);if(re)return re;const j=O.endsWith(R),x=V.endsWith(R);if(j!==x)return j?-1:1;const W=P(O,V);return W!==0?W:O.localeCompare(V)}e.compareAnything=h;function _(u,p,R){const O=u.toLowerCase(),V=p.toLowerCase(),re=O.startsWith(R),j=V.startsWith(R);if(re!==j)return re?-1:1;if(re&&j){if(O.length<V.length)return-1;if(O.length>V.length)return 1}return 0}e.compareByPrefix=_}),define(ge[101],pe([0,1,100,98,8,10,9]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,D=[P,[]];function k(x,W,U,M){if(!x||!W)return D;const F=x.length,L=W.length;if(F<L)return D;const N=x.toLowerCase();return!M&&!N.includes(U)?D:r(W,U,L,x,N,F)}e.scoreFuzzy=k;function r(x,W,U,M,F,L){const N=[],$=[];for(let be=0;be<U;be++){const Ae=be*L,Ce=Ae-L,Le=be>0,H=x[be],Y=W[be];for(let ee=0;ee<L;ee++){const ae=ee>0,me=Ae+ee,De=me-1,Oe=Ce+ee-1,we=ae?N[De]:0,Pe=Le&&ae?N[Oe]:0,Re=Le&&ae?$[Oe]:0;let Be;!Pe&&Le?Be=0:Be=C(H,Y,M,F,ee,Re),Be&&Pe+Be>=we?($[me]=Re+1,N[me]=Pe+Be):($[me]=P,N[me]=we)}}const q=[];let Q=U-1,de=L-1;for(;Q>=0&&de>=0;){const be=Q*L+de;$[be]===P||(q.push(de),Q--),de--}return[N[U*L-1],q.reverse()]}function C(x,W,U,M,F,L){let N=0;if(!f(W,M[F]))return N;if(N+=1,L>0&&(N+=L*5),x===U[F]&&(N+=1),F===0)N+=8;else{const $=g(U.charCodeAt(F-1));$?N+=$:(0,I.isUpper)(U.charCodeAt(F))&&(N+=2)}return N}function f(x,W){return x===W?!0:x==="/"||x==="\\"?W==="/"||W==="\\":!1}function g(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function d(x,W,U=0,M=0){const F=W;return F.values&&F.values.length>1?E(x,F.values,U,M):w(x,W,U,M)}e.scoreFuzzy2=d;function E(x,W,U,M){let F=0;const L=[];for(const N of W){const[$,q]=w(x,N,U,M);if(typeof $!="number")return a;F+=$,L.push(...q)}return[F,c(L)]}function w(x,W,U,M){const F=(0,I.fuzzyScore)(W.original,W.originalLowercase,U,x,x.toLowerCase(),M,!0);return F?[F[0],(0,I.createMatches)(F)]:a}const S=Object.freeze({score:0}),m=1<<18,l=1<<17,v=1<<16;function t(x,W,U,M,F){if(!x||!W.normalized)return S;const L=M.getItemLabel(x);if(!L)return S;const N=M.getItemDescription(x);let $;N?$=`${L}${N}${W.normalized}${Array.isArray(W.values)?W.values.length:""}${U}`:$=`${L}${W.normalized}${Array.isArray(W.values)?W.values.length:""}${U}`;const q=F[$];if(q)return q;const Q=n(L,N,M.getItemPath(x),W,U);return F[$]=Q,Q}e.scoreItemFuzzy=t;function n(x,W,U,M,F){const L=!U||!M.containsPathSeparator;return U&&(A.isLinux?M.pathNormalized===U:(0,y.equalsIgnoreCase)(M.pathNormalized,U))?{score:m,labelMatch:[{start:0,end:x.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:M.values&&M.values.length>1?o(x,W,U,M.values,L,F):i(x,W,U,M,L,F)}function o(x,W,U,M,F,L){let N=0;const $=[],q=[];for(const Q of M){const{score:de,labelMatch:be,descriptionMatch:Ae}=i(x,W,U,Q,F,L);if(de===P)return S;N+=de,be&&$.push(...be),Ae&&q.push(...Ae)}return{score:N,labelMatch:c($),descriptionMatch:c(q)}}function i(x,W,U,M,F,L){if(F||!W){const[N,$]=k(x,M.normalized,M.normalizedLowercase,L);if(N){const q=(0,I.matchesPrefix)(M.normalized,x);let Q;return q?(Q=l,Q+=Math.round(M.normalized.length/x.length*100)):Q=v,{score:Q+N,labelMatch:q||s($)}}}if(W){let N=W;U&&(N=`${W}${T.sep}`);const $=N.length,q=`${N}${x}`,[Q,de]=k(q,M.normalized,M.normalizedLowercase,L);if(Q){const be=s(de),Ae=[],Ce=[];return be.forEach(Le=>{Le.start<$&&Le.end>$?(Ae.push({start:0,end:Le.end-$}),Ce.push({start:Le.start,end:$})):Le.start>=$?Ae.push({start:Le.start-$,end:Le.end-$}):Ce.push(Le)}),{score:Q,labelMatch:Ae,descriptionMatch:Ce}}}return S}function s(x){const W=[];if(!x)return W;let U;for(const M of x)U&&U.end===M?U.end+=1:(U={start:M,end:M+1},W.push(U));return W}function c(x){const W=x.sort((F,L)=>F.start-L.start),U=[];let M;for(const F of W)!M||!h(M,F)?(M=F,U.push(F)):(M.start=Math.min(M.start,F.start),M.end=Math.max(M.end,F.end));return U}function h(x,W){return!(x.end<W.start||W.end<x.start)}function _(x,W,U,M,F,L){const N=t(x,U,M,F,L),$=t(W,U,M,F,L),q=N.score,Q=$.score;if((q===m||Q===m)&&q!==Q)return q===m?-1:1;if(q>v||Q>v){if(q!==Q)return q>Q?-1:1;if(q<l&&Q<l){const Y=p(N.labelMatch,$.labelMatch);if(Y!==0)return Y}const Le=F.getItemLabel(x)||"",H=F.getItemLabel(W)||"";if(Le.length!==H.length)return Le.length-H.length}if(q!==Q)return q>Q?-1:1;const de=Array.isArray(N.labelMatch)&&N.labelMatch.length>0,be=Array.isArray($.labelMatch)&&$.labelMatch.length>0;if(de&&!be)return-1;if(be&&!de)return 1;const Ae=u(x,N,F),Ce=u(W,$,F);return Ae&&Ce&&Ae!==Ce?Ce>Ae?-1:1:R(x,W,U,F)}e.compareItemsByFuzzyScore=_;function u(x,W,U){let M=-1,F=-1;if(W.descriptionMatch&&W.descriptionMatch.length?M=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(M=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(F=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const L=U.getItemDescription(x);L&&(F+=L.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(F=W.descriptionMatch[W.descriptionMatch.length-1].end);return F-M}function p(x,W){if(!x&&!W||(!x||!x.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!x||!x.length)return 1;const U=x[0].start,F=x[x.length-1].end-U,L=W[0].start,$=W[W.length-1].end-L;return F===$?0:$<F?1:-1}function R(x,W,U,M){const F=M.getItemLabel(x)||"",L=M.getItemLabel(W)||"",N=M.getItemDescription(x),$=M.getItemDescription(W),q=F.length+(N?N.length:0),Q=L.length+($?$.length:0);if(q!==Q)return q-Q;const de=M.getItemPath(x),be=M.getItemPath(W);return de&&be&&de.length!==be.length?de.length-be.length:F!==L?(0,b.compareAnything)(F,L,U.normalized):N&&$&&N!==$?(0,b.compareAnything)(N,$,U.normalized):de&&be&&de!==be?(0,b.compareAnything)(de,be,U.normalized):0}const O=" ";function V(x){typeof x!="string"&&(x="");const W=x.toLowerCase(),{pathNormalized:U,normalized:M,normalizedLowercase:F}=re(x),L=U.indexOf(T.sep)>=0;let N;const $=x.split(O);if($.length>1)for(const q of $){const{pathNormalized:Q,normalized:de,normalizedLowercase:be}=re(q);de&&(N||(N=[]),N.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:Q,normalized:de,normalizedLowercase:be}))}return{original:x,originalLowercase:W,pathNormalized:U,normalized:M,normalizedLowercase:F,values:N,containsPathSeparator:L}}e.prepareQuery=V;function re(x){let W;A.isWindows?W=x.replace(/\//g,T.sep):W=x.replace(/\\/g,T.sep);const U=(0,y.stripWildcards)(W).replace(/\s/g,"");return{pathNormalized:W,normalized:U,normalizedLowercase:U.toLowerCase()}}function j(x){return Array.isArray(x)?V(x.map(W=>W.original).join(O)):V(x.original)}e.pieceToQuery=j}),define(ge[33],pe([0,1,9,29,8,22,13]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const D="**",k="/",r="[/\\\\]",C="[^/\\\\]",f=/\//g;function g(N){switch(N){case 0:return"";case 1:return`${C}*?`;default:return`(?:${r}|${C}+${r}|${r}${C}+)*?`}}function a(N,$){if(!N)return[];const q=[];let Q=!1,de=!1,be="";for(const Ae of N){switch(Ae){case $:if(!Q&&!de){q.push(be),be="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":de=!0;break;case"]":de=!1;break}be+=Ae}return be&&q.push(be),q}e.splitGlobAware=a;function d(N){if(!N)return"";let $="";const q=a(N,k);if(q.every(Q=>Q===D))$=".*";else{let Q=!1;q.forEach((de,be)=>{if(de===D){Q||($+=g(2),Q=!0);return}let Ae=!1,Ce="",Le=!1,H="";for(const Y of de){if(Y!=="}"&&Ae){Ce+=Y;continue}if(Le&&(Y!=="]"||!H)){let ee;Y==="-"?ee=Y:(Y==="^"||Y==="!")&&!H?ee="^":Y===k?ee="":ee=b.escapeRegExpCharacters(Y),H+=ee;continue}switch(Y){case"{":Ae=!0;continue;case"[":Le=!0;continue;case"}":$+=`(?:${a(Ce,",").map(me=>d(me)).join("|")})`,Ae=!1,Ce="";break;case"]":$+="["+H+"]",Le=!1,H="";break;case"?":$+=C;continue;case"*":$+=g(1);continue;default:$+=b.escapeRegExpCharacters(Y)}}be<q.length-1&&(q[be+1]!==D||be+2<q.length)&&($+=r),Q=!1})}return $}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},o=function(){return null};function i(N,$){if(!N)return o;let q;typeof N!="string"?q=N.pattern:q=N,q=q.trim();const Q=`${q}_${!!$.trimForExclusions}`;let de=t.get(Q);if(de)return s(de,N);let be;if(E.test(q)){const Ae=q.substr(4);de=function(Ce,Le){return typeof Ce=="string"&&Ce.endsWith(Ae)?q:null}}else(be=w.exec(c(q,$)))?de=h(be[1],q):($.trimForExclusions?m:S).test(q)?de=_(q,$):(be=l.exec(c(q,$)))?de=u(be[1].substr(1),q,!0):(be=v.exec(c(q,$)))?de=u(be[1],q,!1):de=p(q);return t.set(Q,de),s(de,N)}function s(N,$){return typeof $=="string"?N:function(q,Q){return I.isEqualOrParent(q,$.base)?N(T.relative($.base,q),Q):null}}function c(N,$){return $.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function h(N,$){const q=`/${N}`,Q=`\\${N}`,de=function(Ae,Ce){return typeof Ae!="string"?null:Ce?Ce===N?$:null:Ae===N||Ae.endsWith(q)||Ae.endsWith(Q)?$:null},be=[N];return de.basenames=be,de.patterns=[$],de.allBasenames=be,de}function _(N,$){const q=L(N.slice(1,-1).split(",").map(Ce=>i(Ce,$)).filter(Ce=>Ce!==o),N),Q=q.length;if(!Q)return o;if(Q===1)return q[0];const de=function(Ce,Le){for(let H=0,Y=q.length;H<Y;H++)if(q[H](Ce,Le))return N;return null},be=q.find(Ce=>!!Ce.allBasenames);be&&(de.allBasenames=be.allBasenames);const Ae=q.reduce((Ce,Le)=>Le.allPaths?Ce.concat(Le.allPaths):Ce,[]);return Ae.length&&(de.allPaths=Ae),de}function u(N,$,q){const Q=T.sep===T.posix.sep,de=Q?N:N.replace(f,T.sep),be=T.sep+de,Ae=T.posix.sep+N,Ce=q?function(Le,H){return typeof Le=="string"&&(Le===de||Le.endsWith(be)||!Q&&(Le===N||Le.endsWith(Ae)))?$:null}:function(Le,H){return typeof Le=="string"&&(Le===de||!Q&&Le===N)?$:null};return Ce.allPaths=[(q?"*/":"./")+N],Ce}function p(N){try{const $=new RegExp(`^${d(N)}$`);return function(q){return $.lastIndex=0,typeof q=="string"&&$.test(q)?N:null}}catch($){return o}}function R(N,$,q){return!N||typeof $!="string"?!1:O(N)($,void 0,q)}e.match=R;function O(N,$={}){if(!N)return n;if(typeof N=="string"||x(N)){const q=i(N,$);if(q===o)return n;const Q=function(de,be){return!!q(de,be)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return M(N,$)}e.parse=O;function V(N){if(!!N){let $;return q=>($||($=(N()||Promise.resolve([])).then(Q=>Q?j(Q):{})),$.then(Q=>!!Q[q]))}}e.hasSiblingPromiseFn=V;function re(N){if(!!N){let $;return q=>{if(!$){const Q=N();$=Q?j(Q):{}}return!!$[q]}}}e.hasSiblingFn=re;function j(N){const $={};for(const q of N)$[q]=!0;return $}function x(N){const $=N;return $&&typeof $.base=="string"&&typeof $.pattern=="string"}e.isRelativePattern=x;function W(N){return N.allBasenames||[]}e.getBasenameTerms=W;function U(N){return N.allPaths||[]}e.getPathTerms=U;function M(N,$){const q=L(Object.getOwnPropertyNames(N).map(Ce=>F(Ce,N[Ce],$)).filter(Ce=>Ce!==o)),Q=q.length;if(!Q)return o;if(!q.some(Ce=>!!Ce.requiresSiblings)){if(Q===1)return q[0];const Ce=function(Y,ee){for(let ae=0,me=q.length;ae<me;ae++){const De=q[ae](Y,ee);if(De)return De}return null},Le=q.find(Y=>!!Y.allBasenames);Le&&(Ce.allBasenames=Le.allBasenames);const H=q.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return H.length&&(Ce.allPaths=H),Ce}const de=function(Ce,Le,H){let Y;for(let ee=0,ae=q.length;ee<ae;ee++){const me=q[ee];me.requiresSiblings&&H&&(Le||(Le=T.basename(Ce)),Y||(Y=Le.substr(0,Le.length-T.extname(Ce).length)));const De=me(Ce,Le,Y,H);if(De)return De}return null},be=q.find(Ce=>!!Ce.allBasenames);be&&(de.allBasenames=be.allBasenames);const Ae=q.reduce((Ce,Le)=>Le.allPaths?Ce.concat(Le.allPaths):Ce,[]);return Ae.length&&(de.allPaths=Ae),de}function F(N,$,q){if($===!1)return o;const Q=i(N,q);if(Q===o)return o;if(typeof $=="boolean")return Q;if($){const de=$.when;if(typeof de=="string"){const be=(Ae,Ce,Le,H)=>{if(!H||!Q(Ae,Ce))return null;const Y=de.replace("$(basename)",Le),ee=H(Y);return(0,y.isThenable)(ee)?ee.then(ae=>ae?N:null):ee?N:null};return be.requiresSiblings=!0,be}}return Q}function L(N,$){const q=N.filter(Ce=>!!Ce.basenames);if(q.length<2)return N;const Q=q.reduce((Ce,Le)=>{const H=Le.basenames;return H?Ce.concat(H):Ce},[]);let de;if($){de=[];for(let Ce=0,Le=Q.length;Ce<Le;Ce++)de.push($)}else de=q.reduce((Ce,Le)=>{const H=Le.patterns;return H?Ce.concat(H):Ce},[]);const be=function(Ce,Le){if(typeof Ce!="string")return null;if(!Le){let Y;for(Y=Ce.length;Y>0;Y--){const ee=Ce.charCodeAt(Y-1);if(ee===47||ee===92)break}Le=Ce.substr(Y)}const H=Q.indexOf(Le);return H!==-1?de[H]:null};be.basenames=Q,be.patterns=de,be.allBasenames=Q;const Ae=N.filter(Ce=>!Ce.basenames);return Ae.push(be),Ae}}),define(ge[76],pe([0,1,2,8,9,12,10,25,29]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,s,c){if(typeof i=="string"&&(i=b.URI.file(i)),c){const _=c.getWorkspaceFolder(i);if(_){const u=c.getWorkspace().folders.length>1;let p;if((0,P.isEqual)(_.uri,i)?p="":p=(0,P.relativePath)(_.uri,i),u){const R=_.name?_.name:(0,P.basename)(_.uri);p=p?R+" \u2022 "+p:R}return p}}if(i.scheme!==A.Schemas.file&&i.scheme!==A.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(i.fsPath))return(0,I.normalize)(C(i.fsPath));let h=(0,I.normalize)(i.fsPath);return!y.isWindows&&(s==null?void 0:s.userHome)&&(h=g(h,s.userHome.fsPath)),h}e.getPathLabel=k;function r(i){if(!!i){typeof i=="string"&&(i=b.URI.file(i));const s=(0,P.basename)(i)||(i.scheme===A.Schemas.file?i.fsPath:i.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(s)?C(s):s}}e.getBaseLabel=r;function C(i){return(0,D.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let f=Object.create(null);function g(i,s){if(y.isWindows||!i||!s)return i;let c=f.original===s?f.normalized:void 0;return c||(c=`${(0,T.rtrim)(s,I.posix.sep)}${I.posix.sep}`,f={original:s,normalized:c}),(y.isLinux?i.startsWith(c):(0,T.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}e.tildify=g;function a(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=a;const d="\u2026",E="\\\\",w="~";function S(i,s=I.sep){const c=new Array(i.length);let h=!1;for(let _=0;_<i.length;_++){let u=i[_];if(u===""){c[_]=`.${s}`;continue}if(!u){c[_]=u;continue}h=!0;let p="";u.indexOf(E)===0?(p=u.substr(0,u.indexOf(E)+E.length),u=u.substr(u.indexOf(E)+E.length)):u.indexOf(s)===0?(p=u.substr(0,u.indexOf(s)+s.length),u=u.substr(u.indexOf(s)+s.length)):u.indexOf(w)===0&&(p=u.substr(0,u.indexOf(w)+w.length),u=u.substr(u.indexOf(w)+w.length));const R=u.split(s);for(let O=1;h&&O<=R.length;O++)for(let V=R.length-O;h&&V>=0;V--){h=!1;let re=R.slice(V,V+O).join(s);for(let j=0;!h&&j<i.length;j++)if(j!==_&&i[j]&&i[j].indexOf(re)>-1){const x=V+O===R.length,W=V>0&&i[j].indexOf(s)>-1?s+re:re,U=i[j].endsWith(W);h=!x||U}if(!h){let j="";(R[0].endsWith(":")||p!=="")&&(V===1&&(V=0,O++,re=R[0]+s+re),V>0&&(j=R[0]+s),j=p+j),V>0&&(j=j+d+s),j=j+re,V+O<R.length&&(j=j+s+d),c[_]=j}}h&&(c[_]=u)}return c}e.shorten=S;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function l(i,s=Object.create(null)){const c=[];let h=!1,_="";for(const u of i)if(u==="$"||h&&u==="{")_&&c.push({value:_,type:m.TEXT}),_="",h=!0;else if(u==="}"&&h){const p=s[_];if(typeof p=="string")p.length&&c.push({value:p,type:m.VARIABLE});else if(p){const R=c[c.length-1];(!R||R.type!==m.SEPARATOR)&&c.push({value:p.label,type:m.SEPARATOR})}_="",h=!1}else _+=u;return _&&!h&&c.push({value:_,type:m.TEXT}),c.filter((u,p)=>{if(u.type===m.SEPARATOR){const R=c[p-1],O=c[p+1];return[R,O].every(V=>V&&(V.type===m.VARIABLE||V.type===m.TEXT)&&V.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=l;function v(i,s){return y.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(i,s){return y.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):y.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(i){const s=i.indexOf("/")!==-1?I.posix:I.win32,c=s.basename(i),h=s.dirname(i);return c.length?{name:c,parentPath:h}:{name:h,parentPath:""}}e.splitName=o}),define(ge[102],pe([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(r){return r.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:I(b.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:I(b.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:b.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(r){return r}transformOutgoing(r){return r}transformOutgoingURI(r){return r}transformOutgoingScheme(r){return r}};function A(r,C,f){if(!r||f>200)return null;if(typeof r=="object"){if(r instanceof b.URI)return C.transformOutgoing(r);for(let g in r)if(Object.hasOwnProperty.call(r,g)){const a=A(r[g],C,f+1);a!==null&&(r[g]=a)}}return null}function y(r,C){const f=A(r,C,0);return f===null?r:f}e.transformOutgoingURIs=y;function P(r,C,f,g){if(!r||g>200)return null;if(typeof r=="object"){if(r.$mid===1)return f?b.URI.revive(C.transformIncoming(r)):C.transformIncoming(r);for(let a in r)if(Object.hasOwnProperty.call(r,a)){const d=P(r[a],C,f,g+1);d!==null&&(r[a]=d)}}return null}function D(r,C){const f=P(r,C,!1,0);return f===null?r:f}e.transformIncomingURIs=D;function k(r,C){const f=P(r,C,!0,0);return f===null?r:f}e.transformAndReviveIncomingURIs=k}),define(ge[30],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(D){return b.test(D)}e.isUUID=I;const T=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let k=0;k<D.length;k++)D[k]=Math.floor(Math.random()*256);return D};function P(){y(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,k="";return k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k}e.generateUuid=P}),define(ge[137],pe([0,1,103]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(A="utf8"){this.stringDecoder=new b.StringDecoder(A),this.remaining=null}write(A){const y=[],P=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(P.length<1)return y;let D=0,k,r=D;for(;r<P.length;)if(k=P.charCodeAt(r),k===13||k===10){if(y.push(P.substring(D,r)),r++,r<P.length){const C=k;k=P.charCodeAt(r),(C===13&&k===10||C===10&&k===13)&&r++}D=r}else r++;return this.remaining=D<P.length?P.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=I}),define(ge[26],pe([0,1,37,48,8,13,10,29,30,75,25,2]),function(G,e,b,I,T,A,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var f;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function g(W,U=f.UNLINK){if((0,P.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return U===f.UNLINK?d(W):a(W)}e.rimraf=g;async function a(W){try{const U=(0,T.join)((0,I.tmpdir)(),(0,D.generateUuid)());try{await b.promises.rename(W,U)}catch(M){return d(W)}d(U).catch(M=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function d(W){return b.promises.rmdir(W,{recursive:!0,maxRetries:3})}function E(W){if((0,P.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");b.rmdirSync(W,{recursive:!0})}e.rimrafSync=E;async function w(W,U){return l(await(U?S(W):b.promises.readdir(W)))}e.readdir=w;async function S(W){try{return await b.promises.readdir(W,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const U=[],M=await w(W);for(const F of M){let L=!1,N=!1,$=!1;try{const q=await b.promises.lstat((0,T.join)(W,F));L=q.isFile(),N=q.isDirectory(),$=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}U.push({name:F,isFile:()=>L,isDirectory:()=>N,isSymbolicLink:()=>$})}return U}function m(W){return l(b.readdirSync(W))}e.readdirSync=m;function l(W){return W.map(U=>typeof U=="string"?y.isMacintosh?(0,k.normalizeNFC)(U):U:(U.name=y.isMacintosh?(0,k.normalizeNFC)(U.name):U.name,U))}async function v(W){const U=await w(W),M=[];for(const F of U)await n.existsDirectory((0,T.join)(W,F))&&M.push(F);return M}e.readDirsInDir=v;function t(W,U=1e3){return new Promise(M=>{let F=!1;const L=setInterval(()=>{F||(F=!0,b.access(W,N=>{F=!1,N&&(clearInterval(L),M(void 0))}))},U)})}e.whenDeleted=t;var n;(function(W){async function U(L){let N;try{if(N=await b.promises.lstat(L),!N.isSymbolicLink())return{stat:N}}catch($){}try{return{stat:await b.promises.stat(L),symbolicLink:(N==null?void 0:N.isSymbolicLink())?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(y.isWindows&&$.code==="EACCES")try{return{stat:await b.promises.stat(await b.promises.readlink(L)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw q}throw $}}W.stat=U;async function M(L){try{const{stat:N,symbolicLink:$}=await W.stat(L);return N.isFile()&&($==null?void 0:$.dangling)!==!0}catch(N){}return!1}W.existsFile=M;async function F(L){try{const{stat:N,symbolicLink:$}=await W.stat(L);return N.isDirectory()&&($==null?void 0:$.dangling)!==!0}catch(N){}return!1}W.existsDirectory=F})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new A.ResourceQueue;function i(W,U,M){return o.queueFor(C.URI.file(W),r.extUriBiasedIgnorePathCase).queue(()=>{const F=_(M);return new Promise((L,N)=>c(W,U,F,$=>$?N($):L()))})}e.writeFile=i;let s=!0;function c(W,U,M,F){if(!s)return b.writeFile(W,U,{mode:M.mode,flag:M.flag},F);b.open(W,M.flag,M.mode,(L,N)=>{if(L)return F(L);b.writeFile(N,U,$=>{if($)return b.close(N,()=>F($));b.fdatasync(N,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),s=!1),b.close(N,Q=>F(Q))))})})}function h(W,U,M){const F=_(M);if(!s)return b.writeFileSync(W,U,{mode:F.mode,flag:F.flag});const L=b.openSync(W,F.flag,F.mode);try{b.writeFileSync(L,U);try{b.fdatasyncSync(L)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),s=!1}}finally{b.closeSync(L)}}e.writeFileSync=h;function _(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function u(W,U){if(W!==U){async function M(F){try{const L=await b.promises.lstat(F);if(L.isDirectory()||L.isSymbolicLink())return;const N=await b.promises.open(F,"a");try{await N.utimes(L.atime,new Date)}finally{await N.close()}}catch(L){}}try{await b.promises.rename(W,U),await M(U)}catch(F){if(W.toLowerCase()!==U.toLowerCase()&&F.code==="EXDEV"||W.endsWith("."))await p(W,U,{preserveSymlinks:!1}),await g(W,f.MOVE),await M(U);else throw F}}}e.move=u;async function p(W,U,M){return O(W,U,{root:{source:W,target:U},options:M,handledSourcePaths:new Set})}e.copy=p;const R=511;async function O(W,U,M){if(!M.handledSourcePaths.has(W)){M.handledSourcePaths.add(W);const{stat:F,symbolicLink:L}=await n.stat(W);if(L){if(M.options.preserveSymlinks)try{return await j(W,U,M)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(L.dangling)return}return F.isDirectory()?V(W,U,F.mode&R,M):re(W,U,F.mode&R)}}async function V(W,U,M,F){await b.promises.mkdir(U,{recursive:!0,mode:M});const L=await w(W);for(const N of L)await O((0,T.join)(W,N),(0,T.join)(U,N),F)}async function re(W,U,M){await b.promises.copyFile(W,U),await b.promises.chmod(U,M)}async function j(W,U,M){let F=await b.promises.readlink(W);(0,P.isEqualOrParent)(F,M.root.source,!y.isLinux)&&(F=(0,T.join)(M.root.target,F.substr(M.root.source.length+1))),await b.promises.symlink(F,U)}async function x(W){try{return await b.promises.access(W),!0}catch(U){return!1}}e.exists=x}),define(ge[104],pe([0,1,37,284,9,8,26]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(C){const f=(0,A.dirname)(C);if(C===f)return C;const g=((0,A.basename)(C)||C).toLowerCase();try{const d=(0,y.readdirSync)(f).filter(E=>E.toLowerCase()===g);if(d.length===1){const E=P(f);if(E)return(0,A.join)(E,d[0])}else if(d.length>1){const E=d.indexOf(g);if(E>=0){const w=P(f);if(w)return(0,A.join)(w,d[E])}}}catch(a){}return null}e.realcaseSync=P;async function D(C){try{return await(0,I.promisify)(b.realpath)(C)}catch(f){const g=r(C);return await b.promises.access(g,b.constants.R_OK),g}}e.realpath=D;function k(C){try{return b.realpathSync(C)}catch(f){const g=r(C);return b.accessSync(g,b.constants.R_OK),g}}e.realpathSync=k;function r(C){return(0,T.rtrim)((0,A.normalize)(C),A.sep)}});var Et=this&&this.__await||function(G){return this instanceof Et?(this.v=G,this):new Et(G)},Mn=this&&this.__asyncGenerator||function(G,e,b){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var I=b.apply(G,e||[]),T,A=[];return T={},y("next"),y("throw"),y("return"),T[Symbol.asyncIterator]=function(){return this},T;function y(f){I[f]&&(T[f]=function(g){return new Promise(function(a,d){A.push([f,g,a,d])>1||P(f,g)})})}function P(f,g){try{D(I[f](g))}catch(a){C(A[0][3],a)}}function D(f){f.value instanceof Et?Promise.resolve(f.value.v).then(k,r):C(A[0][2],f)}function k(f){P("next",f)}function r(f){P("throw",f)}function C(f,g){f(g),A.shift(),A.length&&P(A[0][0],A[0][1])}},mn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],b;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),b={},I("next"),I("throw"),I("return"),b[Symbol.asyncIterator]=function(){return this},b);function I(A){b[A]=G[A]&&function(y){return new Promise(function(P,D){y=G[A](y),T(P,D,y.done,y.value)})}}function T(A,y,P,D){Promise.resolve(D).then(function(k){A({value:k,done:P})},y)}};define(ge[105],pe([0,1,26,48,8]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,y=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var D;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(D||(D={}));let k;switch(process.arch){case"ia32":case"x32":k=1;break;case"arm":case"arm64":k=2;break;default:k=0;break}let r;process.env.PROCESSOR_ARCHITEW6432?r=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?r=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?r=1:r=0;class C{constructor(v,t,n){this.exePath=v,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:l=!1}={}){return l?k===0?process.env["ProgramFiles(x86)"]||null:r===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:l=!1,findPreview:v=!1}={}){const t=f({useAlternateBitness:l});if(!t)return null;const n=T.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(n))return null;let o=-1,i=null;for(const h of await b.readdir(n)){let _=-1;if(v){const p=h.indexOf("-");if(p<0)continue;const R=h.substring(0,p);if(!A.test(R)||h.substring(p+1)!=="preview")continue;_=parseInt(R,10)}else{if(!A.test(h))continue;_=parseInt(h,10)}if(!(_<=o)){const u=T.join(n,h,"pwsh.exe");!await b.SymlinkSupport.existsFile(u)||(i=u,o=_)}}if(!i)return null;const s=t.includes("x86")?" (x86)":"",c=v?" Preview":"";return new C(i,`PowerShell${c}${s}`,!0)}async function a({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const v=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(v))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=l?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:y,pwshMsixName:"PowerShell (Store)"};for(const o of await b.readdir(v))if(t.test(o)){const i=T.join(v,o,"pwsh.exe");return new C(i,n)}return null}function d(){const l=T.join(I.homedir(),".dotnet","tools","pwsh.exe");return new C(l,".NET Core PowerShell Global Tool")}function E(){const l=T.join(process.env.windir,k===1&&r!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(l,"Windows PowerShell",!0)}function w(){return Mn(this,arguments,function*(){let v=yield Et(g());v&&(yield yield Et(v)),v=yield Et(g({useAlternateBitness:!0})),v&&(yield yield Et(v)),v=yield Et(a()),v&&(yield yield Et(v)),v=d(),v&&(yield yield Et(v)),v=yield Et(g({findPreview:!0})),v&&(yield yield Et(v)),v=yield Et(a({findPreview:!0})),v&&(yield yield Et(v)),v=yield Et(g({useAlternateBitness:!0,findPreview:!0})),v&&(yield yield Et(v)),v=E(),v&&(yield yield Et(v))})}function S(){return Mn(this,arguments,function*(){var v,t;try{for(var n=mn(w()),o;o=yield Et(n.next()),!o.done;){const i=o.value;(yield Et(i.exists()))&&(yield yield Et(i))}}catch(i){v={error:i}}finally{try{o&&!o.done&&(t=n.return)&&(yield Et(t.call(n)))}finally{if(v)throw v.error}}})}e.enumeratePowerShellInstallations=S;async function m(){var l,v;try{for(var t=mn(S()),n;n=await t.next(),!n.done;)return n.value}catch(o){l={error:o}}finally{try{n&&!n.done&&(v=t.return)&&await v.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=m}),define(ge[106],pe([0,1,3,6,13,21,16,23,17,11,58,9]),function(G,e,b,I,T,A,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function g(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function d(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(E||(E={}));class w{constructor(L){this.buffer=L,this.pos=0}read(L){const N=this.buffer.slice(this.pos,this.pos+L);return this.pos+=N.byteLength,N}}class S{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(L){this.buffers.push(L)}}var m;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(m||(m={}));function l(F){const L=P.VSBuffer.alloc(4);return L.writeUInt32BE(F,0),L}function v(F){return F.read(4).readUInt32BE(0)}function t(F){const L=P.VSBuffer.alloc(1);return L.writeUInt8(F,0),L}const n={Undefined:t(m.Undefined),String:t(m.String),Buffer:t(m.Buffer),VSBuffer:t(m.VSBuffer),Array:t(m.Array),Object:t(m.Object)},o=typeof Buffer!="undefined";function i(F,L){if(typeof L=="undefined")F.write(n.Undefined);else if(typeof L=="string"){const N=P.VSBuffer.fromString(L);F.write(n.String),F.write(l(N.byteLength)),F.write(N)}else if(o&&Buffer.isBuffer(L)){const N=P.VSBuffer.wrap(L);F.write(n.Buffer),F.write(l(N.byteLength)),F.write(N)}else if(L instanceof P.VSBuffer)F.write(n.VSBuffer),F.write(l(L.byteLength)),F.write(L);else if(Array.isArray(L)){F.write(n.Array),F.write(l(L.length));for(const N of L)i(F,N)}else{const N=P.VSBuffer.fromString(JSON.stringify(L));F.write(n.Object),F.write(l(N.byteLength)),F.write(N)}}function s(F){switch(F.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return F.read(v(F)).toString();case m.Buffer:return F.read(v(F)).buffer;case m.VSBuffer:return F.read(v(F));case m.Array:{const N=v(F),$=[];for(let q=0;q<N;q++)$.push(s(F));return $}case m.Object:return JSON.parse(F.read(v(F)).toString())}}class c{constructor(L,N,$=null,q=1e3){this.protocol=L,this.ctx=N,this.logger=$,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(L,N){this.channels.set(L,N),setTimeout(()=>this.flushPendingRequests(L),0)}sendResponse(L){switch(L.type){case 200:{const N=this.send([L.type]);this.logger&&this.logger.logOutgoing(N,0,1,d(L.type));return}case 201:case 202:case 204:case 203:{const N=this.send([L.type,L.id],L.data);this.logger&&this.logger.logOutgoing(N,L.id,1,d(L.type),L.data);return}}}send(L,N=void 0){const $=new S;return i($,L),i($,N),this.sendBuffer($.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(N){return 0}}onRawMessage(L){const N=new w(L),$=s(N),q=s(N),Q=$[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(L.byteLength,$[1],1,`${g(Q)}: ${$[2]}.${$[3]}`,q),this.onPromise({type:Q,id:$[1],channelName:$[2],name:$[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(L.byteLength,$[1],1,`${g(Q)}: ${$[2]}.${$[3]}`,q),this.onEventListen({type:Q,id:$[1],channelName:$[2],name:$[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(L.byteLength,$[1],1,`${g(Q)}`),this.disposeActiveRequest({type:Q,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(L.byteLength,$[1],1,`${g(Q)}`),this.disposeActiveRequest({type:Q,id:$[1]})}}onPromise(L){const N=this.channels.get(L.channelName);if(!N){this.collectPendingRequest(L);return}const $=new A.CancellationTokenSource;let q;try{q=N.call(this.ctx,L.name,L.arg,$.token)}catch(be){q=Promise.reject(be)}const Q=L.id;q.then(be=>{this.sendResponse({id:Q,data:be,type:201}),this.activeRequests.delete(L.id)},be=>{be instanceof Error?this.sendResponse({id:Q,data:{message:be.message,name:be.name,stack:be.stack?be.stack.split?be.stack.split(`
`):be.stack:void 0},type:202}):this.sendResponse({id:Q,data:be,type:203}),this.activeRequests.delete(L.id)});const de=(0,I.toDisposable)(()=>$.cancel());this.activeRequests.set(L.id,de)}onEventListen(L){const N=this.channels.get(L.channelName);if(!N){this.collectPendingRequest(L);return}const $=L.id,Q=N.listen(this.ctx,L.name,L.arg)(de=>this.sendResponse({id:$,data:de,type:204}));this.activeRequests.set(L.id,Q)}disposeActiveRequest(L){const N=this.activeRequests.get(L.id);N&&(N.dispose(),this.activeRequests.delete(L.id))}collectPendingRequest(L){let N=this.pendingRequests.get(L.channelName);N||(N=[],this.pendingRequests.set(L.channelName,N));const $=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.sendResponse({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);N.push({request:L,timeoutTimer:$})}flushPendingRequests(L){const N=this.pendingRequests.get(L);if(N){for(const $ of N)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(L)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var h;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class _{constructor(L,N=null){this.protocol=L,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=N}getChannel(L){const N=this;return{call($,q,Q){return N.isDisposed?Promise.reject(y.canceled()):N.requestPromise(L,$,q,Q)},listen($,q){return N.isDisposed?Promise.reject(y.canceled()):N.requestEvent(L,$,q)}}}requestPromise(L,N,$,q=A.CancellationToken.None){const Q=this.lastRequestId++,be={id:Q,type:100,channelName:L,name:N,arg:$};if(q.isCancellationRequested)return Promise.reject(y.canceled());let Ae;return new Promise((Le,H)=>{if(q.isCancellationRequested)return H(y.canceled());const Y=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Q),Le(Oe.data);break;case 202:this.handlers.delete(Q);const we=new Error(Oe.data.message);we.stack=Oe.data.stack,we.name=Oe.data.name,H(we);break;case 203:this.handlers.delete(Q),H(Oe.data);break}};this.handlers.set(Q,De),this.sendRequest(be)};let ee=null;this.state===E.Idle?Y():(ee=(0,T.createCancelablePromise)(De=>this.whenInitialized()),ee.then(()=>{ee=null,Y()}));const ae=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:Q,type:101}),H(y.canceled())},me=q.onCancellationRequested(ae);Ae=(0,I.combinedDisposable)((0,I.toDisposable)(ae),me),this.activeRequests.add(Ae)}).finally(()=>{this.activeRequests.delete(Ae)})}requestEvent(L,N,$){const q=this.lastRequestId++,de={id:q,type:102,channelName:L,name:N,arg:$};let be=null;const Ae=new b.Emitter({onFirstListenerAdd:()=>{be=(0,T.createCancelablePromise)(Le=>this.whenInitialized()),be.then(()=>{be=null,this.activeRequests.add(Ae),this.sendRequest(de)})},onLastListenerRemove:()=>{be?(be.cancel(),be=null):(this.activeRequests.delete(Ae),this.sendRequest({id:q,type:103}))}}),Ce=Le=>Ae.fire(Le.data);return this.handlers.set(q,Ce),Ae.event}sendRequest(L){switch(L.type){case 100:case 102:{const N=this.send([L.type,L.id,L.channelName,L.name],L.arg);this.logger&&this.logger.logOutgoing(N,L.id,0,`${g(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const N=this.send([L.type,L.id]);this.logger&&this.logger.logOutgoing(N,L.id,0,g(L.type));return}}}send(L,N=void 0){const $=new S;return i($,L),i($,N),this.sendBuffer($.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(N){return 0}}onBuffer(L){const N=new w(L),$=s(N),q=s(N),Q=$[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(L.byteLength,0,0,d(Q)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(L.byteLength,$[1],0,d(Q),q),this.onResponse({type:$[0],id:$[1],data:q})}}onResponse(L){if(L.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const N=this.handlers.get(L.id);N&&N(L)}whenInitialized(){return this.state===E.Idle?Promise.resolve():b.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelClient=_;class u{constructor(L){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,L(({protocol:N,onDidClientDisconnect:$})=>{b.Event.once(N.onMessage)(Q=>{const de=new w(Q),be=s(de),Ae=new c(N,be),Ce=new _(N);this.channels.forEach((H,Y)=>Ae.registerChannel(Y,H));const Le={channelServer:Ae,channelClient:Ce,ctx:be};this._connections.add(Le),this._onDidAddConnection.fire(Le),$(()=>{Ae.dispose(),Ce.dispose(),this._connections.delete(Le),this._onDidRemoveConnection.fire(Le)})})})}get connections(){const L=[];return this._connections.forEach(N=>L.push(N)),L}getChannel(L,N){const $=this;return{call(q,Q,de){let be;if((0,k.isFunction)(N)){let Ce=(0,D.getRandomElement)($.connections.filter(N));be=Ce?Promise.resolve(Ce):b.Event.toPromise(b.Event.filter($.onDidAddConnection,N))}else be=N.routeCall($,q,Q);const Ae=be.then(Ce=>Ce.channelClient.getChannel(L));return R(Ae).call(q,Q,de)},listen(q,Q){if((0,k.isFunction)(N))return $.getMulticastEvent(L,N,q,Q);const de=N.routeEvent($,q,Q).then(be=>be.channelClient.getChannel(L));return R(de).listen(q,Q)}}}getMulticastEvent(L,N,$,q){const Q=this;let de=new I.DisposableStore;const be=new b.Emitter({onFirstListenerAdd:()=>{de=new I.DisposableStore;const Ae=new b.EventMultiplexer,Ce=new Map,Le=Y=>{const ae=Y.channelClient.getChannel(L).listen($,q),me=Ae.add(ae);Ce.set(Y,me)},H=Y=>{const ee=Ce.get(Y);!ee||(ee.dispose(),Ce.delete(Y))};Q.connections.filter(N).forEach(Le),b.Event.filter(Q.onDidAddConnection,N)(Le,void 0,de),Q.onDidRemoveConnection(H,void 0,de),Ae.event(be.fire,be,de),de.add(Ae)},onLastListenerRemove:()=>{de.dispose()}});return be.event}registerChannel(L,N){this.channels.set(L,N),this._connections.forEach($=>{$.channelServer.registerChannel(L,N)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=u;class p{constructor(L,N,$=null){const q=new S;i(q,N),L.send(q.buffer),this.channelClient=new _(L,$),this.channelServer=new c(L,N,$)}getChannel(L){return this.channelClient.getChannel(L)}registerChannel(L,N){this.channelServer.registerChannel(L,N)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=p;function R(F){return{call(L,N,$){return F.then(q=>q.call(L,N,$))},listen(L,N){const $=new b.Relay;return F.then(q=>$.input=q.listen(L,N)),$.event}}}e.getDelayedChannel=R;function O(F){let L=!1;return{call(N,$,q){return L?F.call(N,$,q):(0,T.timeout)(0).then(()=>L=!0).then(()=>F.call(N,$,q))},listen(N,$){if(L)return F.listen(N,$);const q=new b.Relay;return(0,T.timeout)(0).then(()=>L=!0).then(()=>q.input=F.listen(N,$)),q.event}}}e.getNextTickChannel=O;class V{constructor(L){this.fn=L}routeCall(L){return this.route(L)}routeEvent(L){return this.route(L)}async route(L){for(const N of L.connections)if(await Promise.resolve(this.fn(N.ctx)))return Promise.resolve(N);return await b.Event.toPromise(L.onDidAddConnection),await this.route(L)}}e.StaticRouter=V;var re;(function(F){function L(q,Q){const de=q,be=Q&&Q.disableMarshalling,Ae=new Map;for(const Ce in de)$(Ce)&&Ae.set(Ce,b.Event.buffer(de[Ce],!0));return new class{listen(Ce,Le){const H=Ae.get(Le);if(H)return H;throw new Error(`Event not found: ${Le}`)}call(Ce,Le,H){const Y=de[Le];if(typeof Y=="function"){if(!be&&Array.isArray(H))for(let ee=0;ee<H.length;ee++)H[ee]=(0,r.revive)(H[ee]);return Y.apply(de,H)}throw new Error(`Method not found: ${Le}`)}}}F.fromService=L;function N(q,Q){const de=Q&&Q.disableMarshalling;return new Proxy({},{get(be,Ae){var Ce;if(typeof Ae=="string")return((Ce=Q==null?void 0:Q.properties)===null||Ce===void 0?void 0:Ce.has(Ae))?Q.properties.get(Ae):$(Ae)?q.listen(Ae):async function(...Le){let H;Q&&!(0,k.isUndefinedOrNull)(Q.context)?H=[Q.context,...Le]:H=Le;const Y=await q.call(Ae,H);return de?Y:(0,r.revive)(Y)};throw new Error(`Property not found: ${String(Ae)}`)}})}F.toService=N;function $(q){return q[0]==="o"&&q[1]==="n"&&C.isUpperAsciiLetter(q.charCodeAt(2))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let L=F.toString();if(L!=="[object Object]")return L}return F}function W(F){return Array.isArray(F)?F.map(x):x(F)}function U(F,L,N,$,q,Q,de){de=W(de);const be=j[q],Ae=be[$%be.length];let Ce=[`%c[${F}]%c[${String(L).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String($).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(Q)?(Ce=Ce.concat(de),Ce.push(")")):Ce.push(de),console.log.apply(console,Ce)}e.logWithColors=U;class M{constructor(L,N){this._outgoingPrefix=L,this._incomingPrefix=N,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(L,N,$,q,Q){this._totalOutgoing+=L,U(this._outgoingPrefix,this._totalOutgoing,L,N,$,q,Q)}logIncoming(L,N,$,q,Q){this._totalIncoming+=L,U(this._incomingPrefix,this._totalIncoming,L,N,$,q,Q)}}e.IPCLogger=M}),define(ge[107],pe([0,1,3,106,6,23,10,36]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function k(){return D||(D=A.VSBuffer.alloc(0)),D}class r{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,i){if(o===0)return k();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const _=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=o),_}if(this._chunks[0].byteLength>o){const _=this._chunks[0].slice(0,o);return i&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),_}let s=A.VSBuffer.alloc(o),c=0,h=0;for(;o>0;){const _=this._chunks[h];if(_.byteLength>o){const u=_.slice(0,o);s.set(u,c),c+=o,i&&(this._chunks[h]=_.slice(o),this._totalLength-=o),o-=o}else s.set(_,c),c+=_.byteLength,i?(this._chunks.shift(),this._totalLength-=_.byteLength):h++,o-=_.byteLength}return s}}e.ChunkStream=r;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var f;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(o,i,s,c){this.type=o,this.id=i,this.ack=s,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends T.Disposable{constructor(o){super();this._onMessage=this._register(new b.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new r,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5);else{const s=this._state.messageType,c=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(s,c,h,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=A.VSBuffer.alloc(13);i.writeUInt8(o.type,0),i.writeUInt32BE(o.id,1),i.writeUInt32BE(o.ack,5),i.writeUInt32BE(o.data.byteLength,9),this._writeSoon(i,o.data)}}_bufferAdd(o,i){const s=this._totalLength===0;return this._data.push(o,i),this._totalLength+=o.byteLength+i.byteLength,s}_bufferTake(){const o=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,i){this._bufferAdd(o,i)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends T.Disposable{constructor(o){super();this._onMessage=new b.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new g(1,0,0,o))}}e.Protocol=E;class w extends I.IPCClient{constructor(o,i,s=null){super(o,i,s);this.protocol=o}static fromSocket(o,i){return new w(new E(o),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=w;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new b.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class m{constructor(o){this.data=o,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],i=0,s=this._first;for(;s;)o[i++]=s.data,s=s.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const i=new m(o);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class v{constructor(){this.lastRuns=[];const o=Date.now();for(let i=0;i<v._HISTORY_LENGTH;i++)this.lastRuns[i]=o-1e3*i;setInterval(()=>{for(let i=v._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return v._INSTANCE||(v._INSTANCE=new v),v._INSTANCE}load(){const o=Date.now(),i=(1+v._HISTORY_LENGTH)*1e3;let s=0;for(let c=0;c<v._HISTORY_LENGTH;c++)o-this.lastRuns[c]<=i&&s++;return 1-s/v._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}v._HISTORY_LENGTH=10,v._INSTANCE=null;class t{constructor(o,i=null){this._loadEstimator=v.getInstance(),this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),i&&this._socketReader.acceptChunk(i),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new g(5,0,0,k());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const i=new g(4,0,0,k());this._socketWriter.write(i),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,i){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let i=0,s=o.length;i<s;i++)this._socketWriter.write(o[i]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new g(6,0,0,k())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const i=this._outgoingUnackMsg.toArray();for(let s=0,c=i.length;s<c;s++)this._socketWriter.write(i[s]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new g(1,i,this._incomingAckId,o);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(o){const i=new g(2,0,0,o);this._socketWriter.write(i)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),i=Date.now()-o.writtenTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-i,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,k());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(ge[108],pe([0,1,97]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(P){let D=(0,b.toUint8)(P);this._defaultValue=D,this._asciiMap=I._createAsciiMap(D),this._map=new Map}static _createAsciiMap(P){let D=new Uint8Array(256);for(let k=0;k<256;k++)D[k]=P;return D}set(P,D){let k=(0,b.toUint8)(D);P>=0&&P<256?this._asciiMap[P]=k:this._map.set(P,k)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=I;var T;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(T||(T={}));class A{constructor(){this._actual=new I(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=A}),define(ge[138],pe([0,1,108]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends b.CharacterClassifier{constructor(P){super(0);for(let D=0,k=P.length;D<k;D++)this.set(P.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function A(y){let P={};return D=>(P.hasOwnProperty(D)||(P[D]=y(D)),P[D])}e.getMapForWordSeparators=A(y=>new T(y))}),define(ge[49],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(T,A){this.lineNumber=T,this.column=A}with(T=this.lineNumber,A=this.column){return T===this.lineNumber&&A===this.column?this:new b(T,A)}delta(T=0,A=0){return this.with(this.lineNumber+T,this.column+A)}equals(T){return b.equals(this,T)}static equals(T,A){return!T&&!A?!0:!!T&&!!A&&T.lineNumber===A.lineNumber&&T.column===A.column}isBefore(T){return b.isBefore(this,T)}static isBefore(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<A.column}isBeforeOrEqual(T){return b.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<=A.column}static compare(T,A){let y=T.lineNumber|0,P=A.lineNumber|0;if(y===P){let D=T.column|0,k=A.column|0;return D-k}return y-P}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new b(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=b}),define(ge[44],pe([0,1,49]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(A,y,P,D){A>P||A===P&&y>D?(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=A,this.endColumn=y):(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=P,this.endColumn=D)}isEmpty(){return I.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return I.containsPosition(this,A)}static containsPosition(A,y){return!(y.lineNumber<A.startLineNumber||y.lineNumber>A.endLineNumber||y.lineNumber===A.startLineNumber&&y.column<A.startColumn||y.lineNumber===A.endLineNumber&&y.column>A.endColumn)}containsRange(A){return I.containsRange(this,A)}static containsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>A.endColumn)}strictContainsRange(A){return I.strictContainsRange(this,A)}static strictContainsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<=A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>=A.endColumn)}plusRange(A){return I.plusRange(this,A)}static plusRange(A,y){let P,D,k,r;return y.startLineNumber<A.startLineNumber?(P=y.startLineNumber,D=y.startColumn):y.startLineNumber===A.startLineNumber?(P=y.startLineNumber,D=Math.min(y.startColumn,A.startColumn)):(P=A.startLineNumber,D=A.startColumn),y.endLineNumber>A.endLineNumber?(k=y.endLineNumber,r=y.endColumn):y.endLineNumber===A.endLineNumber?(k=y.endLineNumber,r=Math.max(y.endColumn,A.endColumn)):(k=A.endLineNumber,r=A.endColumn),new I(P,D,k,r)}intersectRanges(A){return I.intersectRanges(this,A)}static intersectRanges(A,y){let P=A.startLineNumber,D=A.startColumn,k=A.endLineNumber,r=A.endColumn,C=y.startLineNumber,f=y.startColumn,g=y.endLineNumber,a=y.endColumn;return P<C?(P=C,D=f):P===C&&(D=Math.max(D,f)),k>g?(k=g,r=a):k===g&&(r=Math.min(r,a)),P>k||P===k&&D>r?null:new I(P,D,k,r)}equalsRange(A){return I.equalsRange(this,A)}static equalsRange(A,y){return!!A&&!!y&&A.startLineNumber===y.startLineNumber&&A.startColumn===y.startColumn&&A.endLineNumber===y.endLineNumber&&A.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(A){return new b.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(A){return new b.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,y){return new I(this.startLineNumber,this.startColumn,A,y)}setStartPosition(A,y){return new I(A,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(A){return new I(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,y=A){return new I(A.lineNumber,A.column,y.lineNumber,y.column)}static lift(A){return A?new I(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn)}static areIntersecting(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,y){if(A&&y){const k=A.startLineNumber|0,r=y.startLineNumber|0;if(k===r){const C=A.startColumn|0,f=y.startColumn|0;if(C===f){const g=A.endLineNumber|0,a=y.endLineNumber|0;if(g===a){const d=A.endColumn|0,E=y.endColumn|0;return d-E}return g-a}return C-f}return k-r}return(A?1:0)-(y?1:0)}static compareRangesUsingEnds(A,y){return A.endLineNumber===y.endLineNumber?A.endColumn===y.endColumn?A.startLineNumber===y.startLineNumber?A.startColumn-y.startColumn:A.startLineNumber-y.startLineNumber:A.endColumn-y.endColumn:A.endLineNumber-y.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=I}),define(ge[139],pe([0,1,49,44]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class A extends I.Range{constructor(P,D,k,r){super(P,D,k,r);this.selectionStartLineNumber=P,this.selectionStartColumn=D,this.positionLineNumber=k,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return A.selectionsEqual(this,P)}static selectionsEqual(P,D){return P.selectionStartLineNumber===D.selectionStartLineNumber&&P.selectionStartColumn===D.selectionStartColumn&&P.positionLineNumber===D.positionLineNumber&&P.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,D){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,P,D):new A(P,D,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,D){return this.getDirection()===0?new A(P,D,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,P,D)}static fromPositions(P,D=P){return new A(P.lineNumber,P.column,D.lineNumber,D.column)}static liftSelection(P){return new A(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,D){if(P&&!D||!P&&D)return!1;if(!P&&!D)return!0;if(P.length!==D.length)return!1;for(let k=0,r=P.length;k<r;k++)if(!this.selectionsEqual(P[k],D[k]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,D,k,r,C){return C===0?new A(P,D,k,r):new A(k,r,P,D)}}e.Selection=A}),define(ge[109],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class D{constructor(a,d){this.range=a,this.matches=d}}e.FindMatch=D;var k;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var r;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(r=e.ModelConstants||(e.ModelConstants={}));class C{constructor(a,d,E,w,S,m){this.identifier=a,this.range=d,this.text=E,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=S,this._isTracked=m}}e.ValidAnnotatedEditOperation=C;class f{constructor(a,d,E){this.reverseEdits=a,this.changes=d,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=f}),define(ge[140],pe([0,1,9,138,49,44,109]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class D{constructor(m,l,v,t){this.searchString=m,this.isRegex=l,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let m;this.isRegex?m=k(this.searchString):m=this.searchString.indexOf(`
`)>=0;let l=null;try{l=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:m,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let v=!this.isRegex&&!m;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new r(l,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=D;function k(S){if(!S||S.length===0)return!1;for(let m=0,l=S.length;m<l;m++)if(S.charCodeAt(m)===92){if(m++,m>=l)break;const t=S.charCodeAt(m);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class r{constructor(m,l,v){this.regex=m,this.wordSeparators=l,this.simpleSearch=v}}e.SearchData=r;function C(S,m,l){if(!l)return new y.FindMatch(S,null);let v=[];for(let t=0,n=m.length;t<n;t++)v[t]=m[t];return new y.FindMatch(S,v)}e.createFindMatch=C;class f{constructor(m){let l=[],v=0;for(let t=0,n=m.length;t<n;t++)m.charCodeAt(t)===10&&(l[v++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(m){const l=this._lineFeedsOffsets;let v=0,t=l.length-1;if(t===-1||m<=l[0])return 0;for(;v<t;){const n=v+((t-v)/2>>0);l[n]>=m?t=n-1:l[n+1]>=m?(v=n,t=n):v=n+1}return v+1}}class g{static findMatches(m,l,v,t,n){const o=l.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(m,v,new w(o.wordSeparators,o.regex),t,n):this._doFindMatchesLineByLine(m,v,o,t,n):[]}static _getMultilineMatchRange(m,l,v,t,n,o){let i,s=0;t?(s=t.findLineFeedCountBeforeOffset(n),i=l+n+s):i=l+n;let c;if(t){let p=t.findLineFeedCountBeforeOffset(n+o.length)-s;c=i+o.length+p}else c=i+o.length;const h=m.getPositionAt(i),_=m.getPositionAt(c);return new A.Range(h.lineNumber,h.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(m,l,v,t,n){const o=m.getOffsetAt(l.getStartPosition()),i=m.getValueInRange(l,1),s=m.getEOL()===`\r
`?new f(i):null,c=[];let h=0,_;for(v.reset(0);_=v.next(i);)if(c[h++]=C(this._getMultilineMatchRange(m,o,i,s,_.index,_[0]),_,t),h>=n)return c;return c}static _doFindMatchesLineByLine(m,l,v,t,n){const o=[];let i=0;if(l.startLineNumber===l.endLineNumber){const c=m.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return i=this._findMatchesInLine(v,c,l.startLineNumber,l.startColumn-1,i,o,t,n),o}const s=m.getLineContent(l.startLineNumber).substring(l.startColumn-1);i=this._findMatchesInLine(v,s,l.startLineNumber,l.startColumn-1,i,o,t,n);for(let c=l.startLineNumber+1;c<l.endLineNumber&&i<n;c++)i=this._findMatchesInLine(v,m.getLineContent(c),c,0,i,o,t,n);if(i<n){const c=m.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);i=this._findMatchesInLine(v,c,l.endLineNumber,0,i,o,t,n)}return o}static _findMatchesInLine(m,l,v,t,n,o,i,s){const c=m.wordSeparators;if(!i&&m.simpleSearch){const u=m.simpleSearch,p=u.length,R=l.length;let O=-p;for(;(O=l.indexOf(u,O+p))!==-1;)if((!c||E(c,l,R,O,p))&&(o[n++]=new y.FindMatch(new A.Range(v,O+1+t,v,O+1+p+t),null),n>=s))return n;return n}const h=new w(m.wordSeparators,m.regex);let _;h.reset(0);do if(_=h.next(l),_&&(o[n++]=C(new A.Range(v,_.index+1+t,v,_.index+1+_[0].length+t),_,i),n>=s))return n;while(_);return n}static findNextMatch(m,l,v,t){const n=l.parseSearchRequest();if(!n)return null;const o=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(m,v,o,t):this._doFindNextMatchLineByLine(m,v,o,t)}static _doFindNextMatchMultiline(m,l,v,t){const n=new T.Position(l.lineNumber,1),o=m.getOffsetAt(n),i=m.getLineCount(),s=m.getValueInRange(new A.Range(n.lineNumber,n.column,i,m.getLineMaxColumn(i)),1),c=m.getEOL()===`\r
`?new f(s):null;v.reset(l.column-1);let h=v.next(s);return h?C(this._getMultilineMatchRange(m,o,s,c,h.index,h[0]),h,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(m,new T.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(m,l,v,t){const n=m.getLineCount(),o=l.lineNumber,i=m.getLineContent(o),s=this._findFirstMatchInLine(v,i,o,l.column,t);if(s)return s;for(let c=1;c<=n;c++){const h=(o+c-1)%n,_=m.getLineContent(h+1),u=this._findFirstMatchInLine(v,_,h+1,1,t);if(u)return u}return null}static _findFirstMatchInLine(m,l,v,t,n){m.reset(t-1);const o=m.next(l);return o?C(new A.Range(v,o.index+1,v,o.index+1+o[0].length),o,n):null}static findPreviousMatch(m,l,v,t){const n=l.parseSearchRequest();if(!n)return null;const o=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(m,v,o,t):this._doFindPreviousMatchLineByLine(m,v,o,t)}static _doFindPreviousMatchMultiline(m,l,v,t){const n=this._doFindMatchesMultiline(m,new A.Range(1,1,l.lineNumber,l.column),v,t,10*P);if(n.length>0)return n[n.length-1];const o=m.getLineCount();return l.lineNumber!==o||l.column!==m.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(m,new T.Position(o,m.getLineMaxColumn(o)),v,t):null}static _doFindPreviousMatchLineByLine(m,l,v,t){const n=m.getLineCount(),o=l.lineNumber,i=m.getLineContent(o).substring(0,l.column-1),s=this._findLastMatchInLine(v,i,o,t);if(s)return s;for(let c=1;c<=n;c++){const h=(n+o-c-1)%n,_=m.getLineContent(h+1),u=this._findLastMatchInLine(v,_,h+1,t);if(u)return u}return null}static _findLastMatchInLine(m,l,v,t){let n=null,o;for(m.reset(0);o=m.next(l);)n=C(new A.Range(v,o.index+1,v,o.index+1+o[0].length),o,t);return n}}e.TextModelSearch=g;function a(S,m,l,v,t){if(v===0)return!0;const n=m.charCodeAt(v-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const o=m.charCodeAt(v);if(S.get(o)!==0)return!0}return!1}function d(S,m,l,v,t){if(v+t===l)return!0;const n=m.charCodeAt(v+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const o=m.charCodeAt(v+t-1);if(S.get(o)!==0)return!0}return!1}function E(S,m,l,v,t){return a(S,m,l,v,t)&&d(S,m,l,v,t)}e.isValidMatch=E;class w{constructor(m,l){this._wordSeparators=m,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(m){this._searchRegex.lastIndex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(m){const l=m.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(v=this._searchRegex.exec(m),!v))return null;const t=v.index,n=v[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){b.getNextCodePoint(m,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,m,l,t,n))return v}while(v);return null}}e.Searcher=w}),define(ge[110],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(P=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)P.indexOf(k)>=0||(D+="\\"+k);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=b();function I(P){let D=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)D=P;else{let k="g";P.ignoreCase&&(k+="i"),P.multiline&&(k+="m"),P.unicode&&(k+="u"),D=new RegExp(P.source,k)}return D.lastIndex=0,D}e.ensureValidWordDefinition=I;const T={maxLen:1e3,windowSize:15,timeBudget:150};function A(P,D,k,r,C=T){if(k.length>C.maxLen){let E=P-C.maxLen/2;return E<0?E=0:r+=E,k=k.substring(E,P+C.maxLen/2),A(P,D,k,r,C)}const f=Date.now(),g=P-1-r;let a=-1,d=null;for(let E=1;!(Date.now()-f>=C.timeBudget);E++){const w=g-C.windowSize*E;D.lastIndex=Math.max(0,w);const S=y(D,k,g,a);if(!S&&d||(d=S,w<=0))break;a=w}if(d){let E={word:d[0],startColumn:r+1+d.index,endColumn:r+1+d.index+d[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=A;function y(P,D,k,r){let C;for(;C=P.exec(D);){const f=C.index||0;if(f<=k&&P.lastIndex>=k)return C;if(r>0&&f>r)return null}return null}}),define(ge[141],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class I{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let D=0,k=P.notIn.length;D<k;D++)switch(P.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=I;class T{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of P)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=T;function A(y,P,D){y.has(P)?y.get(P).push(D):y.set(P,[D])}}),define(ge[77],pe([0,1,33,8]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(A,y,P,D){if(Array.isArray(A)){let k=0;for(const r of A){const C=T(r,y,P,D);if(C===10)return C;C>k&&(k=C)}return k}else{if(typeof A=="string")return D?A==="*"?5:A===P?10:0:0;if(A){const{language:k,pattern:r,scheme:C,hasAccessToAllModels:f}=A;if(!D&&!f)return 0;let g=0;if(C)if(C===y.scheme)g=10;else if(C==="*")g=5;else return 0;if(k)if(k===P)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(r){let a;if(typeof r=="string"?a=r:a=Object.assign(Object.assign({},r),{base:(0,I.normalize)(r.base)}),a===y.fsPath||(0,b.match)(a,y.fsPath))g=10;else return 0}return g}else return 0}}e.score=T}),define(ge[142],pe([0,1,108]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class T{constructor(a,d,E){const w=new Uint8Array(a*d);for(let S=0,m=a*d;S<m;S++)w[S]=E;this._data=w,this.rows=a,this.cols=d}get(a,d){return this._data[a*this.cols+d]}set(a,d,E){this._data[a*this.cols+d]=E}}e.Uint8Matrix=T;class A{constructor(a){let d=0,E=0;for(let S=0,m=a.length;S<m;S++){let[l,v,t]=a[S];v>d&&(d=v),l>E&&(E=l),t>E&&(E=t)}d++,E++;let w=new T(E,d,0);for(let S=0,m=a.length;S<m;S++){let[l,v,t]=a[S];w.set(l,v,t)}this._states=w,this._maxCharCode=d}nextState(a,d){return d<0||d>=this._maxCharCode?0:this._states.get(a,d)}}e.StateMachine=A;let y=null;function P(){return y===null&&(y=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let k=null;function r(){if(k===null){k=new b.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<g.length;d++)k.set(g.charCodeAt(d),1);const a=".,;";for(let d=0;d<a.length;d++)k.set(a.charCodeAt(d),2)}return k}class C{static _createLink(a,d,E,w,S){let m=S-1;do{const l=d.charCodeAt(m);if(a.get(l)!==2)break;m--}while(m>w);if(w>0){const l=d.charCodeAt(w-1),v=d.charCodeAt(m);(l===40&&v===41||l===91&&v===93||l===123&&v===125)&&m--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:m+2},url:d.substring(w,m+1)}}static computeLinks(a,d=P()){const E=r();let w=[];for(let S=1,m=a.getLineCount();S<=m;S++){const l=a.getLineContent(S),v=l.length;let t=0,n=0,o=0,i=1,s=!1,c=!1,h=!1,_=!1;for(;t<v;){let u=!1;const p=l.charCodeAt(t);if(i===13){let R;switch(p){case 40:s=!0,R=0;break;case 41:R=s?0:1;break;case 91:h=!0,c=!0,R=0;break;case 93:h=!1,R=c?0:1;break;case 123:_=!0,R=0;break;case 125:R=_?0:1;break;case 39:R=o===34||o===96?0:1;break;case 34:R=o===39||o===96?0:1;break;case 96:R=o===39||o===34?0:1;break;case 42:R=o===42?1:0;break;case 124:R=o===124?1:0;break;case 32:R=h?0:1;break;default:R=E.get(p)}R===1&&(w.push(C._createLink(E,l,S,n,t)),u=!0)}else if(i===12){let R;p===91?(c=!0,R=0):R=E.get(p),R===1?u=!0:i=13}else i=d.nextState(i,p),i===0&&(u=!0);u&&(i=1,s=!1,c=!1,_=!1,n=t+1,o=p),t++}i===13&&w.push(C._createLink(E,l,S,n,v))}return w}}e.LinkComputer=C;function f(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:C.computeLinks(g)}e.computeLinks=f}),define(ge[143],pe([0,1,3,6]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,P){return this._map.set(y,P),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===P&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,P){let D=null,k=!1;return this._promises.set(y,P.then(r=>{this._promises.delete(y),!(k||!r)&&(D=this.register(y,r))})),(0,I.toDisposable)(()=>{k=!0,D&&D.dispose()})}getPromise(y){const P=this.get(y);if(P)return Promise.resolve(P);const D=this._promises.get(y);return D?D.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(ge[111],pe([0,1,23,10]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function A(C){for(let f=0,g=C.length;f<g;f+=4){const a=C[f+0],d=C[f+1],E=C[f+2],w=C[f+3];C[f+0]=w,C[f+1]=E,C[f+2]=d,C[f+3]=a}}function y(C){const f=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return I.isLittleEndian()||A(f),b.VSBuffer.wrap(f)}function P(C){const f=C.buffer;if(I.isLittleEndian()||A(f),f.byteOffset%4==0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const g=new Uint8Array(f.byteLength);return g.set(f),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function D(C){const f=new Uint32Array(k(C));let g=0;if(f[g++]=C.id,C.type==="full")f[g++]=1,f[g++]=C.data.length,f.set(C.data,g),g+=C.data.length;else{f[g++]=2,f[g++]=C.deltas.length;for(const a of C.deltas)f[g++]=a.start,f[g++]=a.deleteCount,a.data?(f[g++]=a.data.length,f.set(a.data,g),g+=a.data.length):f[g++]=0}return y(f)}e.encodeSemanticTokensDto=D;function k(C){let f=0;if(f+=1+1,C.type==="full")f+=1+C.data.length;else{f+=1,f+=(1+1+1)*C.deltas.length;for(const g of C.deltas)g.data&&(f+=g.data.length)}return f}function r(C){const f=P(C);let g=0;const a=f[g++];if(f[g++]===1){const S=f[g++],m=f.subarray(g,g+S);return g+=S,{id:a,type:"full",data:m}}const E=f[g++];let w=[];for(let S=0;S<E;S++){const m=f[g++],l=f[g++],v=f[g++];let t;v>0&&(t=f.subarray(g,g+v),g+=v),w[S]={start:m,deleteCount:l,data:t}}return{id:a,type:"delta",deltas:w}}e.decodeSemanticTokensDto=r}),define(ge[112],pe([0,1,97]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,P){this.index=y,this.remainder=P}}e.PrefixSumIndexOfResult=I;class T{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,P){y=(0,b.toUint32)(y);const D=this.values,k=this.prefixSum,r=P.length;return r===0?!1:(this.values=new Uint32Array(D.length+r),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+r),this.values.set(P,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,P){return y=(0,b.toUint32)(y),P=(0,b.toUint32)(P),this.values[y]===P?!1:(this.values[y]=P,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,P){y=(0,b.toUint32)(y),P=(0,b.toUint32)(P);const D=this.values,k=this.prefixSum;if(y>=D.length)return!1;let r=D.length-y;return P>=r&&(P=r),P===0?!1:(this.values=new Uint32Array(D.length-P),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+P),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,b.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),y>=this.values.length&&(y=this.values.length-1);for(let D=P;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let P=0,D=this.values.length-1,k=0,r=0,C=0;for(;P<=D;)if(k=P+(D-P)/2|0,r=this.prefixSum[k],C=r-this.values[k],y<C)D=k-1;else if(y>=r)P=k+1;else break;return new I(k,y-C)}}e.PrefixSumComputer=T}),define(ge[144],pe([0,1,9,49,112]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(P,D,k,r){this._uri=P,this._lines=D,this._eol=k,this._versionId=r,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const D=P.changes;for(const k of D)this._acceptDeleteRange(k.range),this._acceptInsertText(new I.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,D=this._lines.length,k=new Uint32Array(D);for(let r=0;r<D;r++)k[r]=this._lines[r].length+P;this._lineStarts=new T.PrefixSumComputer(k)}}_setLineText(P,D){this._lines[P]=D,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,D){if(D.length!==0){let k=(0,b.splitLines)(D);if(k.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}k[k.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]);let r=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this._lines.splice(P.lineNumber+C-1,0,k[C]),r[C-1]=k[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,r)}}}e.MirrorTextModel=A}),define(ge[145],pe([18,19]),function(G,e){return G.create("vs/base/common/date",e)}),define(ge[146],pe([0,1,145]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,T=I*60,A=T*24,y=A*7,P=A*30,D=A*365;function k(C,f){typeof C!="number"&&(C=C.getTime());const g=Math.round((new Date().getTime()-C)/1e3);if(g<-30)return(0,b.localize)(0,null,k(new Date().getTime()+g*1e3,!1));if(g<30)return(0,b.localize)(1,null);let a;return g<I?(a=g,f?a===1?(0,b.localize)(2,null,a):(0,b.localize)(3,null,a):a===1?(0,b.localize)(4,null,a):(0,b.localize)(5,null,a)):g<T?(a=Math.floor(g/I),f?a===1?(0,b.localize)(6,null,a):(0,b.localize)(7,null,a):a===1?(0,b.localize)(8,null,a):(0,b.localize)(9,null,a)):g<A?(a=Math.floor(g/T),f?a===1?(0,b.localize)(10,null,a):(0,b.localize)(11,null,a):a===1?(0,b.localize)(12,null,a):(0,b.localize)(13,null,a)):g<y?(a=Math.floor(g/A),f?a===1?(0,b.localize)(14,null,a):(0,b.localize)(15,null,a):a===1?(0,b.localize)(16,null,a):(0,b.localize)(17,null,a)):g<P?(a=Math.floor(g/y),f?a===1?(0,b.localize)(18,null,a):(0,b.localize)(19,null,a):a===1?(0,b.localize)(20,null,a):(0,b.localize)(21,null,a)):g<D?(a=Math.floor(g/P),f?a===1?(0,b.localize)(22,null,a):(0,b.localize)(23,null,a):a===1?(0,b.localize)(24,null,a):(0,b.localize)(25,null,a)):(a=Math.floor(g/D),f?a===1?(0,b.localize)(26,null,a):(0,b.localize)(27,null,a):a===1?(0,b.localize)(28,null,a):(0,b.localize)(29,null,a))}e.fromNow=k;function r(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(ge[147],pe([18,19]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ge[59],pe([0,1,147,11,17]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(k,r){return r&&(k.stack||k.stacktrace)?b.localize(0,null,P(k),y(k.stack)||y(k.stacktrace)):P(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?b.localize(1,null,k.message):k.message||b.localize(2,null)}function D(k=null,r=!1){if(!k)return b.localize(3,null);if(Array.isArray(k)){const C=T.coalesce(k),f=D(C[0],r);return C.length>1?b.localize(4,null,f,C.length):f}if(I.isString(k))return k;if(k.detail){const C=k.detail;if(C.error)return A(C.error,r);if(C.exception)return A(C.exception,r)}return k.stack?A(k,r):k.message?k.message:b.localize(5,null)}e.toErrorMessage=D}),define(ge[148],pe([18,19]),function(G,e){return G.create("vs/base/node/processes",e)}),define(ge[78],pe([0,1,8,37,26,38,148,36,11,24,29,10,137,12]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(v){switch(v){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(v,t){if(C.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const o=A.execFile("taskkill",["/T","/F","/PID",v.pid.toString()],n);return new Promise(i=>{o.once("error",s=>{i({success:!1,error:s})}),o.once("exit",(s,c)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?a(n.status):1})}else if(C.isLinux||C.isMacintosh)try{const n=g.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(o=>{A.execFile(n,[v.pid.toString()],{encoding:"utf8",shell:!0},(i,s,c)=>{o(i?{success:!1,error:i}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else v.kill("SIGKILL");return Promise.resolve({success:!0})}function E(v=P.env){return v.comspec||"cmd.exe"}e.getWindowsShell=E;class w{constructor(t,n,o,i){if(n!==void 0&&o!==void 0&&i!==void 0)this.cmd=t,this.args=n,this.shell=o,this.options=i;else{const s=t;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(P.env).forEach(c=>{s[c]=P.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(b.sep);return n!==-1&&(t=t.substring(n+1)),w.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&r.isUNC(this.options.cwd)||!this.options&&r.isUNC(P.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let o,i;const s=new Promise((c,h)=>{o=c,i=h});if(n){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=A.exec(c,this.options,(h,_,u)=>{this.childProcess=null;const p=h;p&&p.killed?i({killed:this.terminateRequested,stdout:_.toString(),stderr:u.toString()}):this.handleExec(o,t,h,_,u)})}else{let c=null;const h=_=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(_,o,t,i);const u={terminated:this.terminateRequested};D.isNumber(_)&&(u.cmdCode=_),o(u)};if(this.shell&&C.isWindows){const _=k.deepClone(this.options);_.windowsVerbatimArguments=!0,_.detached=!1;let u=!1,p=!1;const R=[];let O=this.ensureQuotes(this.cmd);R.push(O.value),u=O.quoted,this.args&&this.args.forEach(re=>{O=this.ensureQuotes(re),R.push(O.value),p=p&&O.quoted});const V=["/s","/c"];u?p?V.push('"'+R.join(" ")+'"'):R.length>1?V.push('"'+R[0]+'" '+R.slice(1).join(" ")):V.push('"'+R[0]+'"'):V.push(R.join(" ")),c=A.spawn(E(),V,_)}else this.cmd&&(c=A.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(D.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",_=>{this.childProcess=null,i({terminated:this.terminateRequested,error:_})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,o,t,i,!0)))}return s})}handleClose(t,n,o,i){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,d(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const n=A.spawn(E(),["/s","/c"]);n.on("error",o=>t(!0)),n.on("exit",o=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class S extends w{constructor(t,n,o,i){super(t,n,o,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,o,i,s){[i,s].forEach((c,h)=>{const _=new f.LineDecoder;_.write(c).forEach(R=>{n({line:R,source:h===0?0:1})});const p=_.end();p&&n({line:p,source:h===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,n,o,i,s){const c=new f.LineDecoder,h=new f.LineDecoder;t.stdout.on("data",_=>{c.write(_).forEach(p=>o({line:p,source:0}))}),t.stderr.on("data",_=>{h.write(_).forEach(p=>o({line:p,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(t,n,o,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&o({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&o({line:c,source:1})}}e.LineProcess=S;function m(v){let t=[],n=!1;const o=function(i){if(n){t.push(i);return}(!v.send(i,c=>{if(c&&console.error(c),n=!1,t.length>0){const h=t.slice(0);t=[],h.forEach(_=>o(_))}})||C.isWindows)&&(n=!0)};return{send:o}}e.createQueuedSender=m;var l;(function(v){async function t(n,o,i){if(b.isAbsolute(n))return n;if(o===void 0&&(o=P.cwd()),b.dirname(n)!=="."||(i===void 0&&D.isString(P.env.PATH)&&(i=P.env.PATH.split(b.delimiter)),i===void 0||i.length===0))return b.join(o,n);async function c(h){return await T.exists(h)?!(await I.promises.stat(h)).isDirectory():!1}for(let h of i){let _;if(b.isAbsolute(h)?_=b.join(h,n):_=b.join(o,h,n),await c(_))return _;let u=_+".com";if(await c(u)||(u=_+".exe",await c(u)))return u}return b.join(o,n)}v.findExecutable=t})(l=e.win32||(e.win32={}))}),define(ge[149],pe([0,1,48,10,105,78]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function y(g,a){return g===1?I.isWindows?C():A.getWindowsShell(a):k(g,a)}e.getSystemShell=y;function P(g,a){return g===1?I.isWindows?f(a):A.getWindowsShell(a):k(g,a)}e.getSystemShellSync=P;let D=null;function k(g,a){if(I.isLinux&&g===2||I.isMacintosh&&g===3)return"/bin/bash";if(!D){let d;if(I.isWindows)d="/bin/bash";else{if(d=a.SHELL,!d)try{d=(0,b.userInfo)().shell}catch(E){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}D=d}return D}let r=null;async function C(){return r||(r=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),r}function f(g){if(r)return r;const a=I.isWindows&&parseFloat((0,b.release)())>=10,d=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${g.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?E:A.getWindowsShell(g)}}),define(ge[150],pe([18,19]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(ge[151],pe([0,1,150,10,110]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=y;class P{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,_e){this._values[ie]=_e}}e.ValidatedEditorOptions=P;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class k{constructor(ie,_e,Ne,ze){this.id=ie,this.name=_e,this.defaultValue=Ne,this.schema=ze}compute(ie,_e,Ne){return Ne}}class r{constructor(ie,_e=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(ie){return this.defaultValue}}class C{constructor(ie,_e,Ne,ze){this.id=ie,this.name=_e,this.defaultValue=Ne,this.schema=ze}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,_e,Ne){return Ne}}function f(X,ie){return typeof X=="undefined"?ie:X==="false"?!1:Boolean(X)}e.boolean=f;class g extends C{constructor(ie,_e,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=Ne),super(ie,_e,Ne,ze)}validate(ie){return f(ie,this.defaultValue)}}class a extends C{constructor(ie,_e,Ne,ze,$e,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Ne,Je.minimum=ze,Je.maximum=$e),super(ie,_e,Ne,Je),this.minimum=ze,this.maximum=$e}static clampedInt(ie,_e,Ne,ze){if(typeof ie=="undefined")return _e;let $e=parseInt(ie,10);return isNaN($e)?_e:($e=Math.max(Ne,$e),$e=Math.min(ze,$e),$e|0)}validate(ie){return a.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class d extends C{constructor(ie,_e,Ne,ze,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ne),super(ie,_e,Ne,$e),this.validationFn=ze}static clamp(ie,_e,Ne){return ie<_e?_e:ie>Ne?Ne:ie}static float(ie,_e){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return _e;const Ne=parseFloat(ie);return isNaN(Ne)?_e:Ne}validate(ie){return this.validationFn(d.float(ie,this.defaultValue))}}class E extends C{static string(ie,_e){return typeof ie!="string"?_e:ie}constructor(ie,_e,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=Ne),super(ie,_e,Ne,ze)}validate(ie){return E.string(ie,this.defaultValue)}}function w(X,ie,_e){return typeof X!="string"||_e.indexOf(X)===-1?ie:X}e.stringSet=w;class S extends C{constructor(ie,_e,Ne,ze,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=ze,$e.default=Ne),super(ie,_e,Ne,$e),this._allowedValues=ze}validate(ie){return w(ie,this.defaultValue,this._allowedValues)}}class m extends k{constructor(ie,_e,Ne,ze,$e,Je,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=$e,K.default=ze),super(ie,_e,Ne,K),this._allowedValues=$e,this._convert=Je}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function l(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,_e,Ne){return Ne===0?ie.accessibilitySupport:Ne}}class t extends k{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertSpace:f(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function s(X){switch(X){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function c(X){switch(X){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class h extends r{constructor(){super(123,[62,31])}compute(ie,_e,Ne){const ze=["monaco-editor"];return _e.get(31)&&ze.push(_e.get(31)),ie.extraEditorClassName&&ze.push(ie.extraEditorClassName),_e.get(62)==="default"?ze.push("mouse-default"):_e.get(62)==="copy"&&ze.push("mouse-copy"),_e.get(97)&&ze.push("showUnused"),_e.get(121)&&ze.push("showDeprecated"),ze.join(" ")}}class _ extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ie,_e,Ne){return Ne&&ie.emptySelectionClipboard}}class u extends k{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:b.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:b.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{cursorMoveOnType:f(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:f(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":w(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(_e.loop,this.defaultValue.loop)}}}class p extends k{constructor(){super(41,"fontLigatures",p.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?p.OFF:ie==="true"?p.ON:ie:Boolean(ie)?p.ON:p.OFF}}e.EditorFontLigatures=p,p.OFF='"liga" off, "calt" off',p.ON='"liga" on, "calt" on';class R extends r{constructor(){super(40)}compute(ie,_e,Ne){return ie.fontInfo}}class O extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(ie){let _e=d.float(ie,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(_e,6,100)}compute(ie,_e,Ne){return ie.fontInfo.fontSize}}class V extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(a.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class re extends k{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Ne,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Ne,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Ne,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Ne,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Ne,description:b.localize(35,null)}})}validate(ie){var _e,Ne,ze,$e,Je;if(!ie||typeof ie!="object")return this.defaultValue;const K=ie;return{multiple:w(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=K.multipleDefinitions)!==null&&_e!==void 0?_e:w(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=K.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:w(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=K.multipleDeclarations)!==null&&ze!==void 0?ze:w(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=K.multipleImplementations)!==null&&$e!==void 0?$e:w(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Je=K.multipleReferences)!==null&&Je!==void 0?Je:w(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends k{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:b.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),delay:a.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:f(_e.sticky,this.defaultValue.sticky)}}}var x;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class W extends r{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ie,_e,Ne){return W.computeLayout(_e,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const _e=ie.height/ie.lineHeight,Ne=ie.scrollBeyondLastLine?_e-1:0,ze=(ie.viewLineCount+Ne)/(ie.pixelRatio*ie.height),$e=Math.floor(ie.viewLineCount/ze);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Ne,desiredRatio:ze,minimapLineCount:$e}}static _computeMinimapLayout(ie,_e){const Ne=ie.outerWidth,ze=ie.outerHeight,$e=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Je=_e.stableMinimapLayoutInput,K=Je&&ie.outerHeight===Je.outerHeight&&ie.lineHeight===Je.lineHeight&&ie.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Je.pixelRatio&&ie.scrollBeyondLastLine===Je.scrollBeyondLastLine&&ie.minimap.enabled===Je.minimap.enabled&&ie.minimap.side===Je.minimap.side&&ie.minimap.size===Je.minimap.size&&ie.minimap.showSlider===Je.minimap.showSlider&&ie.minimap.renderCharacters===Je.minimap.renderCharacters&&ie.minimap.maxColumn===Je.minimap.maxColumn&&ie.minimap.scale===Je.minimap.scale&&ie.verticalScrollbarWidth===Je.verticalScrollbarWidth&&ie.isViewportWrapping===Je.isViewportWrapping,se=ie.lineHeight,he=ie.typicalHalfwidthCharacterWidth,J=ie.scrollBeyondLastLine,te=ie.minimap.renderCharacters;let ce=$e>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const ve=ie.minimap.maxColumn,ye=ie.minimap.size,je=ie.minimap.side,He=ie.verticalScrollbarWidth,We=ie.viewLineCount,Ge=ie.remainingWidth,nt=ie.isViewportWrapping,dt=te?2:3;let it=Math.floor($e*ze);const Ye=it/$e;let mt=!1,wt=!1,Ee=dt*ce,fe=ce/$e,le=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Xe,desiredRatio:ot,minimapLineCount:ft}=W.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:J,height:ze,lineHeight:se,pixelRatio:$e});if(We/ft>1)mt=!0,wt=!0,ce=1,Ee=1,fe=ce/$e;else{let St=!1,vt=ce+1;if(ye==="fit"){const Pt=Math.ceil((We+Xe)*Ee);nt&&K&&Ge<=_e.stableFitRemainingWidth?(St=!0,vt=_e.stableFitMaxMinimapScale):(St=Pt>it,nt&&St?(_e.stableMinimapLayoutInput=ie,_e.stableFitRemainingWidth=Ge):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(ye==="fill"||St){mt=!0;const Pt=ce;Ee=Math.min(se*$e,Math.max(1,Math.floor(1/ot))),ce=Math.min(vt,Math.max(1,Math.floor(Ee/dt))),ce>Pt&&(le=Math.min(2,ce/Pt)),fe=ce/$e/le,it=Math.ceil(Math.max(ht,We+Xe)*Ee),nt&&St&&(_e.stableFitMaxMinimapScale=ce)}}}const Z=Math.floor(ve*fe),Fe=Math.min(Z,Math.max(0,Math.floor((Ge-He-2)*fe/(he+fe)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor($e*Fe);const Qe=Te/$e;Te=Math.floor(Te*le);const Ze=te?1:2,ct=je==="left"?0:Ne-Fe-He;return{renderMinimap:Ze,minimapLeft:ct,minimapWidth:Fe,minimapHeightIsEditorHeight:mt,minimapIsSampling:wt,minimapScale:ce,minimapLineHeight:Ee,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:it,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:Ye}}static computeLayout(ie,_e){const Ne=_e.outerWidth|0,ze=_e.outerHeight|0,$e=_e.lineHeight|0,Je=_e.lineNumbersDigitCount|0,K=_e.typicalHalfwidthCharacterWidth,se=_e.maxDigitWidth,he=_e.pixelRatio,J=_e.viewLineCount,te=ie.get(118),ce=te==="inherit"?ie.get(117):te,ve=ce==="inherit"?ie.get(113):ce,ye=ie.get(116),je=ie.get(2),He=_e.isDominatedByLongLines,We=ie.get(46),Ge=ie.get(56).renderType!==0,nt=ie.get(57),dt=ie.get(91),it=ie.get(61),Ye=ie.get(89),mt=Ye.verticalScrollbarSize,wt=Ye.verticalHasArrows,Ee=Ye.arrowSize,fe=Ye.horizontalScrollbarSize,le=ie.get(54),Z=ie.get(35);let Fe;if(typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)){const _t=parseFloat(le.substr(0,le.length-2));Fe=a.clampedInt(_t*K,0,0,1e3)}else Fe=a.clampedInt(le,0,0,1e3);Z&&(Fe+=16);let Te=0;if(Ge){const _t=Math.max(Je,nt);Te=Math.round(_t*se)}let Qe=0;We&&(Qe=$e);let Ze=0,ct=Ze+Qe,ht=ct+Te,Xe=ht+Fe;const ot=Ne-Qe-Te-Fe;let ft=!1,at=!1,St=-1;je!==2&&(ce==="inherit"&&He?(ft=!0,at=!0):ve==="on"||ve==="bounded"?at=!0:ve==="wordWrapColumn"&&(St=ye));const vt=W._computeMinimapLayout({outerWidth:Ne,outerHeight:ze,lineHeight:$e,typicalHalfwidthCharacterWidth:K,pixelRatio:he,scrollBeyondLastLine:dt,minimap:it,verticalScrollbarWidth:mt,viewLineCount:J,remainingWidth:ot,isViewportWrapping:at},_e.memory||new D);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ze+=vt.minimapWidth,ct+=vt.minimapWidth,ht+=vt.minimapWidth,Xe+=vt.minimapWidth);const Pt=ot-vt.minimapWidth,Tt=Math.max(1,Math.floor((Pt-mt-2)/K)),Rt=wt?Ee:0;return at&&(St=Math.max(1,Tt),ve==="bounded"&&(St=Math.min(St,ye))),{width:Ne,height:ze,glyphMarginLeft:Ze,glyphMarginWidth:Qe,lineNumbersLeft:ct,lineNumbersWidth:Te,decorationsLeft:ht,decorationsWidth:Fe,contentLeft:Xe,contentWidth:Pt,minimap:vt,viewportColumn:Tt,isWordWrapMinified:ft,isViewportWrapping:at,wrappingColumn:St,verticalScrollbarWidth:mt,horizontalScrollbarHeight:fe,overviewRuler:{top:Rt,width:mt,height:ze-2*Rt,right:0}}}}e.EditorLayoutInfoComputer=W;class U extends k{constructor(){const ie={enabled:!0};super(53,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:b.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:f(ie.enabled,this.defaultValue.enabled)}}}class M extends k{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:b.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,description:b.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,description:b.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class F extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(ie,_e,Ne){return ie.fontInfo.lineHeight}}class L extends k{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:ie.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:b.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),size:w(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(_e.side,this.defaultValue.side,["right","left"]),showSlider:w(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(_e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(_e.scale,1,1,3),maxColumn:a.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function N(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class $ extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{top:a.clampedInt(_e.top,0,0,1e3),bottom:a.clampedInt(_e.bottom,0,0,1e3)}}}class q extends k{constructor(){const ie={enabled:!0,cycle:!1};super(72,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:b.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),cycle:f(_e.cycle,this.defaultValue.cycle)}}}class Q extends r{constructor(){super(124)}compute(ie,_e,Ne){return ie.pixelRatio}}class de extends k{constructor(){const ie={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:b.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:b.localize(59,null)},other:{type:"boolean",default:ie.other,description:b.localize(60,null)}}}],default:ie,description:b.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const _e=ie,Ne={other:f(_e.other,this.defaultValue.other),comments:f(_e.comments,this.defaultValue.comments),strings:f(_e.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var be;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ae extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(ie){let _e=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(_e=4,Ne=ie):ie==="interval"?_e=3:ie==="relative"?_e=2:ie==="on"?_e=1:_e=0),{renderType:_e,renderFn:Ne}}}function Ce(X){const ie=X.get(84);return ie==="editable"?X.get(77):ie!=="on"}e.filterValidationDecorations=Ce;class Le extends k{constructor(){const ie=[],_e={type:"number",description:b.localize(67,null)};super(88,"rulers",ie,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:ie,description:b.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let _e=[];for(let Ne of ie)if(typeof Ne=="number")_e.push({column:a.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const ze=Ne;_e.push({column:a.clampedInt(ze.column,0,0,1e4),color:ze.color})}return _e.sort((Ne,ze)=>Ne.column-ze.column),_e}return this.defaultValue}}function H(X,ie){if(typeof X!="string")return ie;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie,Ne=a.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=a.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:H(_e.vertical,this.defaultValue.vertical),horizontal:H(_e.horizontal,this.defaultValue.horizontal),useShadows:f(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:a.clampedInt(_e.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:a.clampedInt(_e.verticalSliderSize,ze,0,1e3),scrollByPage:f(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends k{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:ie.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertMode:w(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:f(_e.showIcons,this.defaultValue.showIcons),showStatusBar:f(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:f(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(_e.showMethods,this.defaultValue.showMethods),showFunctions:f(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:f(_e.showConstructors,this.defaultValue.showConstructors),showFields:f(_e.showFields,this.defaultValue.showFields),showVariables:f(_e.showVariables,this.defaultValue.showVariables),showClasses:f(_e.showClasses,this.defaultValue.showClasses),showStructs:f(_e.showStructs,this.defaultValue.showStructs),showInterfaces:f(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:f(_e.showModules,this.defaultValue.showModules),showProperties:f(_e.showProperties,this.defaultValue.showProperties),showEvents:f(_e.showEvents,this.defaultValue.showEvents),showOperators:f(_e.showOperators,this.defaultValue.showOperators),showUnits:f(_e.showUnits,this.defaultValue.showUnits),showValues:f(_e.showValues,this.defaultValue.showValues),showConstants:f(_e.showConstants,this.defaultValue.showConstants),showEnums:f(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:f(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(_e.showKeywords,this.defaultValue.showKeywords),showWords:f(_e.showWords,this.defaultValue.showWords),showColors:f(_e.showColors,this.defaultValue.showColors),showFiles:f(_e.showFiles,this.defaultValue.showFiles),showReferences:f(_e.showReferences,this.defaultValue.showReferences),showFolders:f(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:f(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(_e.showSnippets,this.defaultValue.showSnippets),showUsers:f(_e.showUsers,this.defaultValue.showUsers),showIssues:f(_e.showIssues,this.defaultValue.showIssues)}}}class ae extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends r{constructor(){super(125,[77])}compute(ie,_e,Ne){return _e.get(77)?!0:ie.tabFocusMode}}var De;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Oe(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class we extends r{constructor(){super(127,[126])}compute(ie,_e,Ne){const ze=_e.get(126);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const Pe="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Re:I.isLinux?Be:Pe,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(X){return e.editorOptionsRegistry[X.id]=X,X}var qe;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.letterSpacing=52]="letterSpacing",X[X.lightbulb=53]="lightbulb",X[X.lineDecorationsWidth=54]="lineDecorationsWidth",X[X.lineHeight=55]="lineHeight",X[X.lineNumbers=56]="lineNumbers",X[X.lineNumbersMinChars=57]="lineNumbersMinChars",X[X.linkedEditing=58]="linkedEditing",X[X.links=59]="links",X[X.matchBrackets=60]="matchBrackets",X[X.minimap=61]="minimap",X[X.mouseStyle=62]="mouseStyle",X[X.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=64]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",X[X.multiCursorModifier=66]="multiCursorModifier",X[X.multiCursorPaste=67]="multiCursorPaste",X[X.occurrencesHighlight=68]="occurrencesHighlight",X[X.overviewRulerBorder=69]="overviewRulerBorder",X[X.overviewRulerLanes=70]="overviewRulerLanes",X[X.padding=71]="padding",X[X.parameterHints=72]="parameterHints",X[X.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",X[X.quickSuggestions=75]="quickSuggestions",X[X.quickSuggestionsDelay=76]="quickSuggestionsDelay",X[X.readOnly=77]="readOnly",X[X.renameOnType=78]="renameOnType",X[X.renderControlCharacters=79]="renderControlCharacters",X[X.renderIndentGuides=80]="renderIndentGuides",X[X.renderFinalNewline=81]="renderFinalNewline",X[X.renderLineHighlight=82]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=84]="renderValidationDecorations",X[X.renderWhitespace=85]="renderWhitespace",X[X.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",X[X.roundedSelection=87]="roundedSelection",X[X.rulers=88]="rulers",X[X.scrollbar=89]="scrollbar",X[X.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=91]="scrollBeyondLastLine",X[X.scrollPredominantAxis=92]="scrollPredominantAxis",X[X.selectionClipboard=93]="selectionClipboard",X[X.selectionHighlight=94]="selectionHighlight",X[X.selectOnLineNumbers=95]="selectOnLineNumbers",X[X.showFoldingControls=96]="showFoldingControls",X[X.showUnused=97]="showUnused",X[X.snippetSuggestions=98]="snippetSuggestions",X[X.smartSelect=99]="smartSelect",X[X.smoothScrolling=100]="smoothScrolling",X[X.stickyTabStops=101]="stickyTabStops",X[X.stopRenderingLineAfter=102]="stopRenderingLineAfter",X[X.suggest=103]="suggest",X[X.suggestFontSize=104]="suggestFontSize",X[X.suggestLineHeight=105]="suggestLineHeight",X[X.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",X[X.suggestSelection=107]="suggestSelection",X[X.tabCompletion=108]="tabCompletion",X[X.tabIndex=109]="tabIndex",X[X.unusualLineTerminators=110]="unusualLineTerminators",X[X.useTabStops=111]="useTabStops",X[X.wordSeparators=112]="wordSeparators",X[X.wordWrap=113]="wordWrap",X[X.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=116]="wordWrapColumn",X[X.wordWrapOverride1=117]="wordWrapOverride1",X[X.wordWrapOverride2=118]="wordWrapOverride2",X[X.wrappingIndent=119]="wrappingIndent",X[X.wrappingStrategy=120]="wrappingStrategy",X[X.showDeprecated=121]="showDeprecated",X[X.inlayHints=122]="inlayHints",X[X.editorClassName=123]="editorClassName",X[X.pixelRatio=124]="pixelRatio",X[X.tabFocusMode=125]="tabFocusMode",X[X.layoutInfo=126]="layoutInfo",X[X.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:Se(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:Se(new v),accessibilityPageSize:Se(new a(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:Se(new E(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:Se(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingDelete:Se(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingOvertype:Se(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(121,null),""],description:b.localize(122,null)})),autoClosingQuotes:Se(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(123,null),b.localize(124,null),""],description:b.localize(125,null)})),autoIndent:Se(new m(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null)],description:b.localize(131,null)})),automaticLayout:Se(new g(10,"automaticLayout",!1)),autoSurround:Se(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null),""],description:b.localize(135,null)})),stickyTabStops:Se(new g(101,"stickyTabStops",!1,{description:b.localize(136,null)})),codeLens:Se(new g(12,"codeLens",!0,{description:b.localize(137,null)})),codeLensFontFamily:Se(new E(13,"codeLensFontFamily","",{description:b.localize(138,null)})),codeLensFontSize:Se(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(139,null)})),colorDecorators:Se(new g(15,"colorDecorators",!0,{description:b.localize(140,null)})),columnSelection:Se(new g(16,"columnSelection",!1,{description:b.localize(141,null)})),comments:Se(new t),contextmenu:Se(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new g(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(142,null)})),cursorBlinking:Se(new m(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:b.localize(143,null)})),cursorSmoothCaretAnimation:Se(new g(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(144,null)})),cursorStyle:Se(new m(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:b.localize(145,null)})),cursorSurroundingLines:Se(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(146,null)})),cursorSurroundingLinesStyle:Se(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(147,null),b.localize(148,null)],description:b.localize(149,null)})),cursorWidth:Se(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(150,null)})),disableLayerHinting:Se(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new g(28,"domReadOnly",!1)),dragAndDrop:Se(new g(29,"dragAndDrop",!0,{description:b.localize(151,null)})),emptySelectionClipboard:Se(new _),extraEditorClassName:Se(new E(31,"extraEditorClassName","")),fastScrollSensitivity:Se(new d(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:b.localize(152,null)})),find:Se(new u),fixedOverflowWidgets:Se(new g(34,"fixedOverflowWidgets",!1)),folding:Se(new g(35,"folding",!0,{description:b.localize(153,null)})),foldingStrategy:Se(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(154,null),b.localize(155,null)],description:b.localize(156,null)})),foldingHighlight:Se(new g(37,"foldingHighlight",!0,{description:b.localize(157,null)})),unfoldOnClickAfterEndOfLine:Se(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(158,null)})),fontFamily:Se(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(159,null)})),fontInfo:Se(new R),fontLigatures2:Se(new p),fontSize:Se(new O),fontWeight:Se(new V),formatOnPaste:Se(new g(44,"formatOnPaste",!1,{description:b.localize(160,null)})),formatOnType:Se(new g(45,"formatOnType",!1,{description:b.localize(161,null)})),glyphMargin:Se(new g(46,"glyphMargin",!0,{description:b.localize(162,null)})),gotoLocation:Se(new re),hideCursorInOverviewRuler:Se(new g(48,"hideCursorInOverviewRuler",!1,{description:b.localize(163,null)})),highlightActiveIndentGuide:Se(new g(49,"highlightActiveIndentGuide",!0,{description:b.localize(164,null)})),hover:Se(new j),inDiffEditor:Se(new g(51,"inDiffEditor",!1)),letterSpacing:Se(new d(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:b.localize(165,null)})),lightbulb:Se(new U),lineDecorationsWidth:Se(new C(54,"lineDecorationsWidth",10)),lineHeight:Se(new F),lineNumbers:Se(new Ae),lineNumbersMinChars:Se(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new g(58,"linkedEditing",!1,{description:b.localize(166,null)})),links:Se(new g(59,"links",!0,{description:b.localize(167,null)})),matchBrackets:Se(new S(60,"matchBrackets","always",["always","near","never"],{description:b.localize(168,null)})),minimap:Se(new L),mouseStyle:Se(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new d(63,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:b.localize(169,null)})),mouseWheelZoom:Se(new g(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(170,null)})),multiCursorMergeOverlapping:Se(new g(65,"multiCursorMergeOverlapping",!0,{description:b.localize(171,null)})),multiCursorModifier:Se(new m(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],N,{markdownEnumDescriptions:[b.localize(172,null),b.localize(173,null)],markdownDescription:b.localize(174,null)})),multiCursorPaste:Se(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(175,null),b.localize(176,null)],markdownDescription:b.localize(177,null)})),occurrencesHighlight:Se(new g(68,"occurrencesHighlight",!0,{description:b.localize(178,null)})),overviewRulerBorder:Se(new g(69,"overviewRulerBorder",!0,{description:b.localize(179,null)})),overviewRulerLanes:Se(new a(70,"overviewRulerLanes",3,0,3)),padding:Se(new $),parameterHints:Se(new q),peekWidgetDefaultFocus:Se(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(180,null),b.localize(181,null)],description:b.localize(182,null)})),definitionLinkOpensInPeek:Se(new g(74,"definitionLinkOpensInPeek",!1,{description:b.localize(183,null)})),quickSuggestions:Se(new de),quickSuggestionsDelay:Se(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(184,null)})),readOnly:Se(new g(77,"readOnly",!1)),renameOnType:Se(new g(78,"renameOnType",!1,{description:b.localize(185,null),markdownDeprecationMessage:b.localize(186,null)})),renderControlCharacters:Se(new g(79,"renderControlCharacters",!1,{description:b.localize(187,null)})),renderIndentGuides:Se(new g(80,"renderIndentGuides",!0,{description:b.localize(188,null)})),renderFinalNewline:Se(new g(81,"renderFinalNewline",!0,{description:b.localize(189,null)})),renderLineHighlight:Se(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(190,null)],description:b.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Se(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(192,null)})),renderValidationDecorations:Se(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(193,null),b.localize(194,null),b.localize(195,null),""],description:b.localize(196,null)})),revealHorizontalRightPadding:Se(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new g(87,"roundedSelection",!0,{description:b.localize(197,null)})),rulers:Se(new Le),scrollbar:Se(new Y),scrollBeyondLastColumn:Se(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(198,null)})),scrollBeyondLastLine:Se(new g(91,"scrollBeyondLastLine",!0,{description:b.localize(199,null)})),scrollPredominantAxis:Se(new g(92,"scrollPredominantAxis",!0,{description:b.localize(200,null)})),selectionClipboard:Se(new g(93,"selectionClipboard",!0,{description:b.localize(201,null),included:I.isLinux})),selectionHighlight:Se(new g(94,"selectionHighlight",!0,{description:b.localize(202,null)})),selectOnLineNumbers:Se(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:Se(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(203,null),b.localize(204,null)],description:b.localize(205,null)})),showUnused:Se(new g(97,"showUnused",!0,{description:b.localize(206,null)})),showDeprecated:Se(new g(121,"showDeprecated",!0,{description:b.localize(207,null)})),inlayHints:Se(new M),snippetSuggestions:Se(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(208,null),b.localize(209,null),b.localize(210,null),b.localize(211,null)],description:b.localize(212,null)})),smartSelect:Se(new ae),smoothScrolling:Se(new g(100,"smoothScrolling",!1,{description:b.localize(213,null)})),stopRenderingLineAfter:Se(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ee),suggestFontSize:Se(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestLineHeight:Se(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestOnTriggerCharacters:Se(new g(106,"suggestOnTriggerCharacters",!0,{description:b.localize(216,null)})),suggestSelection:Se(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),tabCompletion:Se(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null)],description:b.localize(224,null)})),tabIndex:Se(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(225,null),b.localize(226,null),b.localize(227,null)],description:b.localize(228,null)})),useTabStops:Se(new g(111,"useTabStops",!0,{description:b.localize(229,null)})),wordSeparators:Se(new E(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:b.localize(230,null)})),wordWrap:Se(new S(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),wordWrapBreakAfterCharacters:Se(new E(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new E(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new a(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(236,null)})),wordWrapOverride1:Se(new S(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new S(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new m(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[b.localize(237,null),b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),wrappingStrategy:Se(new S(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(242,null),b.localize(243,null)],description:b.localize(244,null)})),editorClassName:Se(new h),pixelRatio:Se(new Q),tabFocusMode:Se(new me),layoutInfo:Se(new W),wrappingInfo:Se(new we)}}),define(ge[152],pe([18,19]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[153],pe([18,19]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[154],pe([18,19]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[155],pe([18,19]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[156],pe([18,19]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ge[157],pe([18,19]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(ge[158],pe([18,19]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[159],pe([18,19]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[160],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[161],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[162],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[163],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[164],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[165],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[166],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[167],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[168],pe([18,19]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[169],pe([18,19]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(ge[170],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[171],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[172],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[173],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[174],pe([18,19]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[175],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var T;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[176],pe([0,1,154]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(C){return C=C.trim(),C==="*"||I.test(C)}e.isValidVersionStr=T;function A(C){if(!T(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=C.match(I);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function y(C){if(!C)return null;let f=C.majorBase,g=C.majorMustEqual,a=C.minorBase,d=C.minorMustEqual,E=C.patchBase,w=C.patchMustEqual;return C.hasCaret&&(f===0||(d=!1),w=!1),{majorBase:f,majorMustEqual:g,minorBase:a,minorMustEqual:d,patchBase:E,patchMustEqual:w,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=y;function P(C,f){let g;typeof C=="string"?g=y(A(C)):g=C;let a;if(typeof f=="string"?a=y(A(f)):a=f,!g||!a)return!1;let d=g.majorBase,E=g.minorBase,w=g.patchBase,S=a.majorBase,m=a.minorBase,l=a.patchBase,v=a.majorMustEqual,t=a.minorMustEqual,n=a.patchMustEqual;return a.isMinimum?d>S?!0:d<S?!1:E>m?!0:E<m?!1:w>=l:(d===1&&S===0&&(!v||!t||!n)&&(S=1,m=0,l=0,v=!0,t=!1,n=!1),d<S?!1:d>S?!v:E<m?!1:E>m?!t:w<l?!1:w>l?!n:!0)}e.isValidVersion=P;function D(C,f,g){return f.isBuiltin||typeof f.main=="undefined"?!0:r(C,f.engines.vscode,g)}e.isValidExtensionVersion=D;function k(C,f){return C==="*"||r(f,C)}e.isEngineValid=k;function r(C,f,g=[]){let a=y(A(f));if(!a)return g.push(b.localize(0,null,f)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return g.push(b.localize(1,null,f)),!1}else if(!a.majorMustEqual)return g.push(b.localize(2,null,f)),!1;return P(C,a)?!0:(g.push(b.localize(3,null,C,f)),!1)}e.isVersionValid=r}),define(ge[113],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(A,y=[],P=!1){this.ctor=A,this.staticArguments=y,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=b;const I=(T,...A)=>new b(T,A);e.createSyncDescriptor=I}),define(ge[79],pe([0,1,113]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function T(y,P,D){P instanceof b.SyncDescriptor||(P=new b.SyncDescriptor(P,[],D)),I.push([y,P])}e.registerSingleton=T;function A(){return I}e.getSingletonServiceDescriptors=A}),define(ge[177],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=b;class I{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let y of this._nodes.values())y.outgoing.size===0&&A.push(y);return A}insertEdge(A,y){const P=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(y);P.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(A),P)}removeNode(A){const y=this._hashFn(A);this._nodes.delete(y);for(let P of this._nodes.values())P.outgoing.delete(y),P.incoming.delete(y)}lookupOrInsertNode(A){const y=this._hashFn(A);let P=this._nodes.get(y);return P||(P=new b(A),this._nodes.set(y,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[y,P]of this._nodes)A.push(`${y}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,y]of this._nodes){const P=new Set([A]),D=this._findCycle(y,P);if(D)return D}}_findCycle(A,y){for(let[P,D]of A.outgoing){if(y.has(P))return[...y,P].join(" -> ");y.add(P);const k=this._findCycle(D,y);if(k)return k;y.delete(P)}}}e.Graph=I}),define(ge[4],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function D(k){return k[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=D})(b=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function I(P,D,k,r){D[b.DI_TARGET]===D?D[b.DI_DEPENDENCIES].push({id:P,index:k,optional:r}):(D[b.DI_DEPENDENCIES]=[{id:P,index:k,optional:r}],D[b.DI_TARGET]=D)}function T(P){if(b.serviceIds.has(P))return b.serviceIds.get(P);const D=function(k,r,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(D,k,C,!1)};return D.toString=()=>P,b.serviceIds.set(P,D),D}e.createDecorator=T;function A(P){return P}e.refineServiceDecorator=A;function y(P){return function(D,k,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(P,D,r,!0)}}e.optional=y}),define(ge[178],pe([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function I(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(ge[179],pe([0,1,3,74,6,22,73,77,178]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(f){return typeof f=="string"?!1:Array.isArray(f)?f.every(k):!!f.exclusive}class r{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(g,a){let d={selector:g,provider:a,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(d){let E=this._entries.indexOf(d);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const a=[];for(let d of this._entries)d._score>0&&a.push(d.provider);return a}ordered(g){const a=[];return this._orderedForEach(g,d=>a.push(d.provider)),a}orderedGroups(g){const a=[];let d,E;return this._orderedForEach(g,w=>{d&&E===w._score?d.push(w.provider):(E=w._score,d=[w.provider],a.push(d))}),a}_orderedForEach(g,a){if(!!g){this._updateScores(g);for(const d of this._entries)d._score>0&&a(d)}}_updateScores(g){let a={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let d of this._entries)if(d._score=(0,P.score)(d.selector,g.uri,g.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(g)),k(d.selector)&&d._score>0){for(let E of this._entries)E._score=0;d._score=1e3;break}this._entries.sort(r._compareByScoreAndTime)}}static _compareByScoreAndTime(g,a){return g._score<a._score?1:g._score>a._score?-1:g._time<a._time?1:g._time>a._time?-1:0}}e.LanguageFeatureRegistry=r;class C{constructor(g,a,d=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=a,this.max=d,this._cache=new A.LRUCache(50,.7)}_key(g){return g.id+(0,I.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const a=this._key(g),d=this._cache.get(a);return this._clamp(d==null?void 0:d.value)}update(g,a){const d=this._key(g);let E=this._cache.get(d);return E||(E=new y.MovingAverage,this._cache.set(d,E)),E.update(a),this.get(g)}}e.LanguageFeatureRequestDelays=C}),define(ge[80],pe([0,1,2,44,179,143,43]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class D{constructor(p,R){this.language=p,this.id=R}}e.LanguageIdentifier=D;var k;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var r;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(r=e.ColorId||(e.ColorId={}));var C;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var f;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(f=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(p){return(p&255)>>>0}static getTokenType(p){return(p&1792)>>>8}static getFontStyle(p){return(p&14336)>>>11}static getForeground(p){return(p&8372224)>>>14}static getBackground(p){return(p&4286578688)>>>23}static getClassNameFromMetadata(p){let R=this.getForeground(p),O="mtk"+R,V=this.getFontStyle(p);return V&1&&(O+=" mtki"),V&2&&(O+=" mtkb"),V&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(p,R){const O=this.getForeground(p),V=this.getFontStyle(p);let re=`color: ${R[O]};`;return V&1&&(re+="font-style: italic;"),V&2&&(re+="font-weight: bold;"),V&4&&(re+="text-decoration: underline;"),re}}e.TokenMetadata=g;var a;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(p){const R=u[p];let O=R&&y.iconRegistry.get(R);return O||(console.info("No codicon found for CompletionItemKind "+p),O=y.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(p,R){let O=u[p];return typeof O=="undefined"&&!R&&(O=9),O}}();var d;(function(u){u[u.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(S=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(u){return u&&b.URI.isUri(u.uri)&&I.Range.isIRange(u.range)&&(I.Range.isIRange(u.originSelectionRange)||I.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=v;var t;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(u){u[u.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var o;(function(u){const p=new Map;p.set("file",0),p.set("module",1),p.set("namespace",2),p.set("package",3),p.set("class",4),p.set("method",5),p.set("property",6),p.set("field",7),p.set("constructor",8),p.set("enum",9),p.set("interface",10),p.set("function",11),p.set("variable",12),p.set("constant",13),p.set("string",14),p.set("number",15),p.set("boolean",16),p.set("array",17),p.set("object",18),p.set("key",19),p.set("null",20),p.set("enum-member",21),p.set("struct",22),p.set("event",23),p.set("operator",24),p.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function O(j){return p.get(j)}u.fromString=O;function V(j){return R.get(j)}u.toString=V;function re(j,x){const W=R.get(j);let U=W&&y.iconRegistry.get("symbol-"+W);return U||(console.info("No codicon found for SymbolKind "+j),U=y.Codicon.symbolProperty),`${x?"inline":"block"} ${U.classNames}`}u.toCssClassName=re})(o=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(p){this.value=p}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var s;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var h;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(h=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var _;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[180],pe([0,1,6,11,4,3,56,54]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,k){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:D,handler:k})}if(D.description){const a=[];for(let E of D.description.args)a.push(E.constraint);const d=D.handler;D.handler=function(E,...w){return(0,I.validateConstraints)(w,a),d(E,...w)}}const{id:r}=D;let C=this._commands.get(r);C||(C=new y.LinkedList,this._commands.set(r,C));let f=C.unshift(D),g=(0,b.toDisposable)(()=>{f();const a=this._commands.get(r);(a==null?void 0:a.isEmpty())&&this._commands.delete(r)});return this._onDidRegisterCommand.fire(r),g}registerCommandAlias(D,k){return e.CommandsRegistry.registerCommand(D,(r,...C)=>r.get(e.ICommandService).executeCommand(k,...C))}getCommand(D){const k=this._commands.get(D);if(!(!k||k.isEmpty()))return P.Iterable.first(k)}getCommands(){const D=new Map;for(const k of this._commands.keys()){const r=this.getCommand(k);r&&D.set(k,r)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(ge[81],pe([0,1,9,4,10]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=T.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",T.isMacintosh),y.set("isLinux",T.isLinux),y.set("isWindows",T.isWindows),y.set("isWeb",T.isWeb),y.set("isMacNative",T.isMacintosh&&!T.isWeb),y.set("isEdge",A.indexOf("Edg/")>=0),y.set("isFirefox",A.indexOf("Firefox")>=0),y.set("isChrome",A.indexOf("Chrome")>=0),y.set("isSafari",A.indexOf("Safari")>=0),y.set("isIPad",A.indexOf("iPad")>=0);const P=Object.prototype.hasOwnProperty;var D;(function(u){u[u.False=0]="False",u[u.True=1]="True",u[u.Defined=2]="Defined",u[u.Not=3]="Not",u[u.Equals=4]="Equals",u[u.NotEquals=5]="NotEquals",u[u.And=6]="And",u[u.Regex=7]="Regex",u[u.NotRegex=8]="NotRegex",u[u.Or=9]="Or",u[u.In=10]="In",u[u.NotIn=11]="NotIn",u[u.Greater=12]="Greater",u[u.GreaterEquals=13]="GreaterEquals",u[u.Smaller=14]="Smaller",u[u.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(p){return g.create(p)}static equals(p,R){return a.create(p,R)}static notEquals(p,R){return w.create(p,R)}static regex(p,R){return n.create(p,R)}static in(p,R){return d.create(p,R)}static not(p){return S.create(p)}static and(...p){return i.create(p)}static or(...p){return s.create(p)}static greater(p,R){return m.create(p,R)}static less(p,R){return v.create(p,R)}static deserialize(p,R=!1){if(!!p)return this._deserializeOrExpression(p,R)}static _deserializeOrExpression(p,R){let O=p.split("||");return s.create(O.map(V=>this._deserializeAndExpression(V,R)))}static _deserializeAndExpression(p,R){let O=p.split("&&");return i.create(O.map(V=>this._deserializeOne(V,R)))}static _deserializeOne(p,R){if(p=p.trim(),p.indexOf("!=")>=0){let O=p.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],R))}if(p.indexOf("==")>=0){let O=p.split("==");return a.create(O[0].trim(),this._deserializeValue(O[1],R))}if(p.indexOf("=~")>=0){let O=p.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],R))}if(p.indexOf(" in ")>=0){let O=p.split(" in ");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const O=p.split(">=");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const O=p.split(">");return m.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const O=p.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const O=p.split("<");return v.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(p)?S.create(p.substr(1).trim()):g.create(p)}static _deserializeValue(p,R){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let O=/^'([^']*)'$/.exec(p);return O?O[1].trim():p}static _deserializeRegexValue(p,R){if((0,b.isFalsyOrWhitespace)(p)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=p.indexOf("/"),V=p.lastIndexOf("/");if(O===V||O<0){if(R)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let re=p.slice(O+1,V),j=p[V+1]==="i"?"i":"";try{return new RegExp(re,j)}catch(x){if(R)throw new Error(`bad regexp-value '${p}', parse error: ${x}`);return console.warn(`bad regexp-value '${p}', parse error: ${x}`),null}}}e.ContextKeyExpr=k;function r(u,p){return u.cmp(p)}class C{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class g{constructor(p){this.key=p,this.type=2}static create(p){const R=y.get(p);return typeof R=="boolean"?R?f.INSTANCE:C.INSTANCE:new g(p)}cmp(p){return p.type!==this.type?this.type-p.type:h(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=g;class a{constructor(p,R){this.key=p,this.value=R,this.type=4}static create(p,R){if(typeof R=="boolean")return R?g.create(p):S.create(p);const O=y.get(p);return typeof O=="boolean"?R===(O?"true":"false")?f.INSTANCE:C.INSTANCE:new a(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class d{constructor(p,R){this.key=p,this.valueKey=R,this.type=10}static create(p,R){return new d(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}evaluate(p){const R=p.getValue(this.valueKey),O=p.getValue(this.key);return Array.isArray(R)?R.indexOf(O)>=0:typeof O=="string"&&typeof R=="object"&&R!==null?P.call(R,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=d;class E{constructor(p){this._actual=p,this.type=11}static create(p){return new E(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new E(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class w{constructor(p,R){this.key=p,this.value=R,this.type=5}static create(p,R){if(typeof R=="boolean")return R?S.create(p):g.create(p);const O=y.get(p);return typeof O=="boolean"?R===(O?"true":"false")?C.INSTANCE:f.INSTANCE:new w(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class S{constructor(p){this.key=p,this.type=3}static create(p){const R=y.get(p);return typeof R=="boolean"?R?C.INSTANCE:f.INSTANCE:new S(p)}cmp(p){return p.type!==this.type?this.type-p.type:h(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=S;class m{constructor(p,R){this.key=p,this.value=R,this.type=12}static create(p,R){return new m(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=m;class l{constructor(p,R){this.key=p,this.value=R,this.type=13}static create(p,R){return new l(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class v{constructor(p,R){this.key=p,this.value=R,this.type=14}static create(p,R){return new v(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(p,R){this.key=p,this.value=R,this.type=15}static create(p,R){return new t(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(p,R){this.key=p,this.regexp=R,this.type=7}static create(p,R){return new n(p,R)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const R=this.regexp?this.regexp.source:"",O=p.regexp?p.regexp.source:"";return R<O?-1:R>O?1:0}equals(p){if(p.type===this.type){const R=this.regexp?this.regexp.source:"",O=p.regexp?p.regexp.source:"";return this.key===p.key&&R===O}return!1}evaluate(p){let R=p.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=n;class o{constructor(p){this._actual=p,this.type=8}static create(p){return new o(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new o(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class i{constructor(p){this.expr=p,this.type=6}static create(p){return i._normalizeArr(p)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let R=0,O=this.expr.length;R<O;R++){const V=r(this.expr[R],p.expr[R]);if(V!==0)return V}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].equals(p.expr[R]))return!1;return!0}return!1}evaluate(p){for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].evaluate(p))return!1;return!0}static _normalizeArr(p){const R=[];let O=!1;for(const V of p)if(!!V){if(V.type===1){O=!0;continue}if(V.type===0)return C.INSTANCE;if(V.type===6){R.push(...V.expr);continue}R.push(V)}if(R.length===0&&O)return f.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(r);R.length>1;){const V=R[R.length-1];if(V.type!==9)break;R.pop();const re=R.pop(),j=s.create(V.expr.map(x=>i.create([x,re])));j&&(R.push(j),R.sort(r))}return R.length===1?R[0]:new i(R)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let R of this.expr)p.push(...R.keys());return p}map(p){return new i(this.expr.map(R=>R.map(p)))}negate(){let p=[];for(let R of this.expr)p.push(R.negate());return s.create(p)}}e.ContextKeyAndExpr=i;class s{constructor(p){this.expr=p,this.type=9}static create(p){const R=s._normalizeArr(p);if(R.length!==0)return R.length===1?R[0]:new s(R)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let R=0,O=this.expr.length;R<O;R++){const V=r(this.expr[R],p.expr[R]);if(V!==0)return V}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].equals(p.expr[R]))return!1;return!0}return!1}evaluate(p){for(let R=0,O=this.expr.length;R<O;R++)if(this.expr[R].evaluate(p))return!0;return!1}static _normalizeArr(p){let R=[],O=!1;if(p){for(let V=0,re=p.length;V<re;V++){const j=p[V];if(!!j){if(j.type===0){O=!0;continue}if(j.type===1)return[f.INSTANCE];if(j.type===9){R=R.concat(j.expr);continue}R.push(j)}}if(R.length===0&&O)return[C.INSTANCE];R.sort(r)}return R}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let R of this.expr)p.push(...R.keys());return p}map(p){return new s(this.expr.map(R=>R.map(p)))}negate(){let p=[];for(let O of this.expr)p.push(O.negate());const R=O=>O.type===9?O.expr:[O];for(;p.length>1;){const O=p.shift(),V=p.shift(),re=[];for(const j of R(O))for(const x of R(V))re.push(k.and(j,x));p.unshift(k.or(...re))}return p[0]}}e.ContextKeyOrExpr=s;class c extends g{constructor(p,R,O){super(p);this._defaultValue=R,typeof O=="object"?c._info.push(Object.assign(Object.assign({},O),{key:p})):O!==!0&&c._info.push({key:p,description:O,type:R!=null?typeof R:void 0})}static all(){return c._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(p){return k.equals(this.key,p)}notEqualsTo(p){return k.notEquals(this.key,p)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(u,p){return u<p?-1:u>p?1:0}function _(u,p,R,O){return u<R?-1:u>R?1:p<O?-1:p>O?1:0}}),define(ge[181],pe([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[182],pe([0,1,153,4,12]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=A;var y;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var P;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var D;(function(C){C.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var k;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(k=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(f,g){super(f);this.code=g}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ge[27],pe([0,1,9,4]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,C){if(typeof r=="undefined"||r===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof r=="string"||typeof C=="string"){let f=typeof r=="string"?r:r.value,g=typeof C=="string"?C:C.value;return b.equalsIgnoreCase(f,g)}return r._lower===C._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.ExtensionIdentifier=y;function P(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function D(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[183],pe([0,1,9,27]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(g,a){return g.uuid&&a.uuid?g.uuid===a.uuid:g.id===a.id?!0:(0,b.compareIgnoreCase)(g.id,a.id)===0}e.areSameExtensions=T;class A{constructor(a,d){this.version=d,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof A?T(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=A;function y(g,a){return`${g}.${a}`}e.getExtensionId=y;function P(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function D(g,a){return P(y(g,a))}e.getGalleryExtensionId=D;function k(g,a){const d=[],E=w=>{for(const S of d)if(S.some(m=>T(a(m),a(w))))return S;return null};for(const w of g){const S=E(w);S?S.push(w):d.push([w])}return d}e.groupByExtension=k;function r(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function C(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function f(g){const a=new Set;for(const d of g)d.malicious&&a.add(d.id.id);return a}e.getMaliciousExtensionsSet=f}),define(ge[184],pe([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,b.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,b.createDecorator)("externalTerminal")}),define(ge[45],pe([0,1,156,8,2,4,9,11,22]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function k(j){return j.create===!0}e.isFileOpenForWriteOptions=k;var r;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var C;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=f;function g(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=g;function a(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function d(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=d;var E;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(x,W){super(x);this.code=W}}e.FileSystemProviderError=w;function S(j,x){const W=new w(j.toString(),x);return l(W,x),W}e.createFileSystemProviderError=S;function m(j){return j||S((0,b.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=m;function l(j,x){return j.name=x?`${x} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=l;function v(j){if(!j)return E.Unknown;if(j instanceof w)return j.code;const x=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!x)return E.Unknown;switch(x[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=v;function t(j){if(j instanceof h)return j.fileOperationResult;switch(v(j)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class o{constructor(x,W,U){this.resource=x,this.operation=W,this.target=U}isOperation(x){return this.operation===x}}e.FileOperationEvent=o;var i;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class s{constructor(x,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const U of x)switch(U.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(U.resource,U);break}}contains(x,...W){return this.doContains(x,{includeChildren:!1},...W)}affects(x,...W){return this.doContains(x,{includeChildren:!0},...W)}doContains(x,W,...U){var M,F,L,N,$,q;if(!x)return!1;const Q=U.length>0;return!!((!Q||U.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(x))||W.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(x)))||(!Q||U.includes(0))&&(((L=this.updated)===null||L===void 0?void 0:L.get(x))||W.includeChildren&&((N=this.updated)===null||N===void 0?void 0:N.findSuperstr(x)))||(!Q||U.includes(2))&&((($=this.deleted)===null||$===void 0?void 0:$.findSubstr(x))||W.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const W=[],U=x===1?this.added:x===0?this.updated:this.deleted;if(U)for(const[,M]of U)W.push(M);return W}filter(x){return new s(this.changes.filter(W=>x(W)),this.ignorePathCasing)}}e.FileChangesEvent=s;function c(j,x,W){return!j||!x||j===x||x.length>j.length?!1:(x.charAt(x.length-1)!==I.sep&&(x+=I.sep),W?(0,y.startsWithIgnoreCase)(j,x):j.indexOf(x)===0)}e.isParent=c;class h extends Error{constructor(x,W,U){super(x);this.fileOperationResult=W,this.options=U}static isFileOperationError(x){return x instanceof Error&&!(0,P.isUndefinedOrNull)(x.fileOperationResult)}}e.FileOperationError=h;var _;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var u;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(u=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function p(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=p;async function R(j,x){if(!x.canHandleResource(T.URI.from({scheme:j.scheme})))return new Promise(W=>{const U=x.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===j.scheme&&M.added&&(U.dispose(),W())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(x){return(0,P.isNumber)(x)||(x=0),x<O.KB?(0,b.localize)(1,null,x.toFixed(0)):x<O.MB?(0,b.localize)(2,null,(x/O.KB).toFixed(2)):x<O.GB?(0,b.localize)(3,null,(x/O.MB).toFixed(2)):x<O.TB?(0,b.localize)(4,null,(x/O.GB).toFixed(2)):(0,b.localize)(5,null,(x/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var V;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function re(j){return{maxFileSize:j===0?300*O.MB:16*O.GB,maxHeapSize:j===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=re}),define(ge[82],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...T){this._entries=new Map;for(let[A,y]of T)this.set(A,y)}set(T,A){const y=this._entries.get(T);return this._entries.set(T,A),y}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=b}),define(ge[185],pe([0,1,16,177,113,4,82,13]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class k extends Error{constructor(a){var d;super("cyclic dependency between services");this.message=(d=a.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class r{constructor(a=new y.ServiceCollection,d=!1,E){this._activeInstantiations=new Set,this._services=a,this._strict=d,this._parent=E,this._services.set(A.IInstantiationService,this)}createChild(a){return new r(a,this._strict,this)}invokeFunction(a,...d){let E=f.traceInvocation(a),w=!1;try{return a({get:(m,l)=>{if(w)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(m,E);if(!v&&l!==A.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return v}},...d)}finally{w=!0,E.stop()}}createInstance(a,...d){let E,w;return a instanceof T.SyncDescriptor?(E=f.traceCreation(a.ctor),w=this._createInstance(a.ctor,a.staticArguments.concat(d),E)):(E=f.traceCreation(a),w=this._createInstance(a,d,E)),E.stop(),w}_createInstance(a,d=[],E){let w=A._util.getServiceDependencies(a).sort((l,v)=>l.index-v.index),S=[];for(const l of w){let v=this._getOrCreateServiceInstance(l.id,E);if(!v&&this._strict&&!l.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${l.id}.`);S.push(v)}let m=w.length>0?w[0].index:d.length;if(d.length!==m){console.warn(`[createInstance] First service dependency of ${a.name} at position ${m+1} conflicts with ${d.length} static arguments`);let l=m-d.length;l>0?d=d.concat(new Array(l)):d=d.slice(0,m)}return new a(...[...d,...S])}_setServiceInstance(a,d){if(this._services.get(a)instanceof T.SyncDescriptor)this._services.set(a,d);else if(this._parent)this._parent._setServiceInstance(a,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let d=this._services.get(a);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):d}_getOrCreateServiceInstance(a,d){let E=this._getServiceInstanceOrDescriptor(a);return E instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,E,d.branch(a,!0)):(d.branch(a,!1),E)}_safeCreateAndCacheServiceInstance(a,d,E){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,d,E)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,d,E){const w=new I.Graph(l=>l.id.toString());let S=0;const m=[{id:a,desc:d,_trace:E}];for(;m.length;){const l=m.pop();if(w.lookupOrInsertNode(l),S++>1e3)throw new k(w);for(let v of A._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${a} depends on ${v.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const n={id:v.id,desc:t,_trace:l._trace.branch(v.id,!0)};w.insertEdge(l,n),m.push(n)}}}for(;;){const l=w.roots();if(l.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:v}of l){if(this._getServiceInstanceOrDescriptor(v.id)instanceof T.SyncDescriptor){const n=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,n)}w.removeNode(v)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,d,E=[],w,S){if(this._services.get(a)instanceof T.SyncDescriptor)return this._createServiceInstance(d,E,w,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,d,E,w,S);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(a,d=[],E,w){if(E){const S=new P.IdleValue(()=>this._createInstance(a,d,w));return new Proxy(Object.create(null),{get(m,l){if(l in m)return m[l];let v=S.value,t=v[l];return typeof t!="function"||(t=t.bind(v),m[l]=t),t},set(m,l,v){return S.value[l]=v,!0}})}else return this._createInstance(a,d,w)}}e.InstantiationService=r;var C;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(C||(C={}));class f{constructor(a,d){this.type=a,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new f(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(a){return D?new f(0,a.name):f._None}branch(a,d){let E=new f(2,a.toString());return this._dep.push([a,d,E]),E}stop(){let a=Date.now()-this._start;f._totals+=a;let d=!1;function E(S,m){let l=[],v=new Array(S+1).join("	");for(const[t,n,o]of m._dep)if(n&&o){d=!0,l.push(`${v}CREATES -> ${t}`);let i=E(S+1,o);i&&l.push(i)}else l.push(`${v}uses -> ${t}`);return l.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(a>2||d)&&console.log(w.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ge[14],pe([0,1,4,6,10,3,59]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function P(){return new Date().toISOString()}var D;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class k extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class r extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(D.Error,this.format(o))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let o=0;o<t.length;o++){let i=t[o];if(typeof i=="object")try{i=JSON.stringify(i)}catch(s){}n+=(o>0?" ":"")+i}return n}}e.AbstractMessageLogger=r;class C extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class f extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=f;class g extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class a extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class d extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=d;class E extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(o))}))}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function S(v){if(v.verbose)return D.Trace;if(typeof v.logLevel=="string"){const t=m(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function m(v){switch(v){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=m;function l(v){switch(v){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=l}),define(ge[114],pe([0,1,14,45]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(D,k,r,C){try{const f=await new Promise((g,a)=>{G(["spdlog"],g,a)});return f.setAsyncMode(8192,500),f.createRotatingLoggerAsync(D,k,r,C)}catch(f){console.error(f)}return null}function A(D,k,r,C){return G.__$__nodeRequire("spdlog").createRotatingLogger(D,k,r,C)}e.createRotatingLogger=A;function y(D,k,r){switch(k){case b.LogLevel.Trace:D.trace(r);break;case b.LogLevel.Debug:D.debug(r);break;case b.LogLevel.Info:D.info(r);break;case b.LogLevel.Warning:D.warn(r);break;case b.LogLevel.Error:D.error(r);break;case b.LogLevel.Critical:D.critical(r);break;default:throw new Error("Invalid log level")}}class P extends b.AbstractMessageLogger{constructor(k,r,C,f){super();this.name=k,this.filepath=r,this.rotating=C,this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const k=this.rotating?6:1,r=30/k*I.ByteSize.MB;return T(this.name,this.filepath,r,k).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:f,message:g}of this.buffer)y(this._logger,f,g);this.buffer=[]}})}log(k,r){this._logger?y(this._logger,k,r):this.getLevel()<=k&&this.buffer.push({level:k,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(ge[115],pe([0,1,4,157,57]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function k(a,d){return d-a}D.compare=k;const r=Object.create(null);r[D.Error]=(0,I.localize)(0,null),r[D.Warning]=(0,I.localize)(1,null),r[D.Info]=(0,I.localize)(2,null);function C(a){return r[a]||""}D.toString=C;function f(a){switch(a){case T.default.Error:return D.Error;case T.default.Warning:return D.Warning;case T.default.Info:return D.Info;case T.default.Ignore:return D.Hint}}D.fromSeverity=f;function g(a){switch(a){case D.Error:return T.default.Error;case D.Warning:return T.default.Warning;case D.Info:return T.default.Info;case D.Hint:return T.default.Ignore}}D.toSeverity=g}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(D){const k="";function r(f){return C(f,!0)}D.makeKey=r;function C(f,g){let a=[k];return f.source?a.push(f.source.replace("\xA6","\\\xA6")):a.push(k),f.code?typeof f.code=="string"?a.push(f.code.replace("\xA6","\\\xA6")):a.push(f.code.value.replace("\xA6","\\\xA6")):a.push(k),f.severity!==void 0&&f.severity!==null?a.push(y.toString(f.severity)):a.push(k),f.message&&g?a.push(f.message.replace("\xA6","\\\xA6")):a.push(k),f.startLineNumber!==void 0&&f.startLineNumber!==null?a.push(f.startLineNumber.toString()):a.push(k),f.startColumn!==void 0&&f.startColumn!==null?a.push(f.startColumn.toString()):a.push(k),f.endLineNumber!==void 0&&f.endLineNumber!==null?a.push(f.endLineNumber.toString()):a.push(k),f.endColumn!==void 0&&f.endColumn!==null?a.push(f.endColumn.toString()):a.push(k),a.push(k),a.join("\xA6")}D.makeKeyOptionalMessage=C})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(ge[186],pe([0,1,57,4,3]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new D,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(r){}updateMessage(r){}updateActions(r){}close(){}}e.NoOpNotification=P;class D{infinite(){}done(){}total(r){}worked(r){}}e.NoOpProgress=D}),define(ge[187],pe([0,1,12,10,36,25]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof I.globals.vscode!="undefined"){const P=I.globals.vscode.context.configuration();if(P)y=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const P=(0,A.dirname)(b.FileAccess.asFileUri("",G));y=G.__$__nodeRequire((0,A.joinPath)(P,"product.json").fsPath);const D=G.__$__nodeRequire((0,A.joinPath)(P,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.57.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var Ve=this&&this.__decorate||function(G,e,b,I){var T=arguments.length,A=T<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,b):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,b,I);else for(var P=G.length-1;P>=0;P--)(y=G[P])&&(A=(T<3?y(A):T>3?y(e,b,A):y(e,b))||A);return T>3&&A&&Object.defineProperty(e,b,A),A},xe=this&&this.__param||function(G,e){return function(b,I){e(b,I,G)}};define(ge[116],pe([0,1,4,21,6,13]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var y;(function(r){r[r.Explorer=1]="Explorer",r[r.Scm=3]="Scm",r[r.Extensions=5]="Extensions",r[r.Window=10]="Window",r[r.Notification=15]="Notification",r[r.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let D=class extends T.Disposable{constructor(C,f){super();this.deferred=new A.DeferredPromise,f.withProgress(C,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};D=Ve([xe(1,e.IProgressService)],D),e.UnmanagedProgress=D;class k extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const f=++this.currentOperationId,g=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{f===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:f,token:g.token,stop:()=>this.doStop(f),isCurrent:()=>this.currentOperationId===f}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(ge[40],pe([0,1,11,52]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(y,P){I.ok(b.isString(y)),I.ok(b.isObject(P)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,P)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new T}),define(ge[117],pe([0,1,40,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,k){this.schemasById[T(D)]=k,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new A;b.Registry.add(e.Extensions.JSONContribution,y)}),define(ge[83],pe([0,1,152,3,40,11,117]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=T.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,S=!0){this.registerConfigurations([w],S)}registerConfigurations(w,S=!0){const m=[];w.forEach(l=>{m.push(...this.validateAndRegisterProperties(l,S,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(w){const S=[],m=l=>{if(l.properties)for(const v in l.properties)S.push(v),delete this.configurationProperties[v],this.removeFromSchema(v,l.properties[v]);l.allOf&&l.allOf.forEach(v=>m(v))};for(const l of w){m(l);const v=this.configurationContributors.indexOf(l);v!==-1&&this.configurationContributors.splice(v,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(w){const S=[],m=[];for(const l of w)for(const v in l)if(S.push(v),e.OVERRIDE_PROPERTY_PATTERN.test(v)){this.defaultValues[v]=Object.assign(Object.assign({},this.defaultValues[v]||{}),l[v]);const t={type:"object",default:this.defaultValues[v],description:b.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId};m.push(C(v)),this.configurationProperties[v]=t,this.defaultLanguageConfigurationOverridesNode.properties[v]=t}else{this.defaultValues[v]=l[v];const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(w){const S=[];for(const m of w)for(const l in m)if(S.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const v=this.configurationProperties[l];v&&(this.updatePropertyDefaultValue(l,v),this.updateSchema(l,v))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const S of w)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,S=!0,m,l=3){var v;l=A.isUndefinedOrNull(w.scope)?l:w.scope;let t=[],n=w.properties;if(n)for(let i in n){if(S&&a(i)){delete n[i];continue}const s=n[i];if(this.updatePropertyDefaultValue(i,s),e.OVERRIDE_PROPERTY_PATTERN.test(i)?s.scope=void 0:(s.scope=A.isUndefinedOrNull(s.scope)?l:s.scope,s.restricted=A.isUndefinedOrNull(s.restricted)?!!((v=m==null?void 0:m.restrictedConfigurations)===null||v===void 0?void 0:v.includes(i)):s.restricted),n[i].hasOwnProperty("included")&&!n[i].included){this.excludedConfigurationProperties[i]=n[i],delete n[i];continue}else this.configurationProperties[i]=n[i];!n[i].deprecationMessage&&n[i].markdownDeprecationMessage&&(n[i].deprecationMessage=n[i].markdownDeprecationMessage),t.push(i)}let o=w.allOf;if(o)for(let i of o)t.push(...this.validateAndRegisterProperties(i,S,m,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const S=m=>{let l=m.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let v=m.allOf;v&&v.forEach(S)};S(w)}updateSchema(w,S){switch(e.allSettings.properties[w]=S,S.scope){case 1:e.applicationSettings.properties[w]=S;break;case 2:e.machineSettings.properties[w]=S;break;case 6:e.machineOverridableSettings.properties[w]=S;break;case 3:e.windowSettings.properties[w]=S;break;case 4:e.resourceSettings.properties[w]=S;break;case 5:e.resourceSettings.properties[w]=S,this.resourceLanguageSettingsSchema.properties[w]=S;break}}removeFromSchema(w,S){switch(delete e.allSettings.properties[w],S.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const S=`[${w}]`,m={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,m),e.allSettings.properties[S]=m,e.applicationSettings.properties[S]=m,e.machineSettings.properties[S]=m,e.machineOverridableSettings.properties[S]=m,e.windowSettings.properties[S]=m,e.resourceSettings.properties[S]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,S){let m=this.defaultValues[w];A.isUndefined(m)&&(m=S.default),A.isUndefined(m)&&(m=f(S.type)),S.default=m}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function C(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=C;function f(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const g=new k;T.Registry.add(e.Extensions.Configuration,g);function a(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?b.localize(5,null,E):g.getConfigurationProperties()[E]!==void 0?b.localize(6,null,E):null:b.localize(4,null)}e.validateProperty=a;function d(){const E=[],w=g.getConfigurationProperties();for(const S of Object.keys(w))E.push([S,w[S].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=d}),define(ge[84],pe([0,1,24,11,2,40,4,83]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof T.URI)}e.isConfigurationOverrides=D;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function C(n,o){const i=o?n?o.keys.filter(R=>n.keys.indexOf(R)===-1):[...o.keys]:[],s=n?o?n.keys.filter(R=>o.keys.indexOf(R)===-1):[...n.keys]:[],c=[];if(o&&n){for(const R of n.keys)if(o.keys.indexOf(R)!==-1){const O=w(n.contents,R),V=w(o.contents,R);b.equals(O,V)||c.push(R)}}const h=[],_=R=>{const O={};for(const V of R)for(const re of V.identifiers)O[v(re)]=V;return O},u=o?_(o.overrides):{},p=n?_(n.overrides):{};if(Object.keys(u).length)for(const R of i){const O=u[R];O&&h.push([(0,P.overrideIdentifierFromKey)(R),O.keys])}if(Object.keys(p).length)for(const R of s){const O=p[R];O&&h.push([(0,P.overrideIdentifierFromKey)(R),O.keys])}if(Object.keys(u).length&&Object.keys(p).length)for(const R of c){const O=p[R],V=u[R];if(O&&V){const re=C({contents:O.contents,keys:O.keys,overrides:[]},{contents:V.contents,keys:V.keys,overrides:[]});h.push([(0,P.overrideIdentifierFromKey)(R),[...re.added,...re.removed,...re.updated]])}}return{added:i,removed:s,updated:c,overrides:h}}e.compare=C;function f(n,o){const i=[];for(const s of Object.keys(n))if(P.OVERRIDE_PROPERTY_PATTERN.test(s)){const c={};for(const h in n[s])c[h]=n[s][h];i.push({identifiers:[(0,P.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(c),contents:g(c,o)})}return i}e.toOverrides=f;function g(n,o){const i=Object.create(null);for(let s in n)a(i,s,n[s],o);return i}e.toValuesTree=g;function a(n,o,i,s){const c=o.split("."),h=c.pop();let _=n;for(let u=0;u<c.length;u++){let p=c[u],R=_[p];switch(typeof R){case"undefined":R=_[p]=Object.create(null);break;case"object":break;default:s(`Ignoring ${o} as ${c.slice(0,u+1).join(".")} is ${JSON.stringify(R)}`);return}_=R}if(typeof _=="object"&&_!==null)try{_[h]=i}catch(u){s(`Ignoring ${o} as ${c.join(".")} is ${JSON.stringify(_)}`)}else s(`Ignoring ${o} as ${c.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=a;function d(n,o){const i=o.split(".");E(n,i)}e.removeFromValueTree=d;function E(n,o){const i=o.shift();if(o.length===0){delete n[i];return}if(Object.keys(n).indexOf(i)!==-1){const s=n[i];typeof s=="object"&&!Array.isArray(s)&&(E(s,o),Object.keys(s).length===0&&delete n[i])}}function w(n,o,i){function s(_,u){let p=_;for(const R of u){if(typeof p!="object"||p===null)return;p=p[R]}return p}const c=o.split("."),h=s(n,c);return typeof h=="undefined"?i:h}e.getConfigurationValue=w;function S(n,o,i){Object.keys(o).forEach(s=>{s!=="__proto__"&&(s in n?I.isObject(n[s])&&I.isObject(o[s])?S(n[s],o[s],i):i&&(n[s]=o[s]):n[s]=o[s])})}e.merge=S;function m(){const n=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=m;function l(){const n=Object.create(null),o=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let i in o){let s=o[i].default;a(n,i,s,c=>console.error(`Conflict in default settings: ${c}`))}return n}e.getDefaultValues=l;function v(n){return`[${n}]`}e.keyFromOverrideIdentifier=v;function t(n,o,i){const s=n.inspect(o),c=n.inspect(i);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:s.defaultValue}e.getMigratedSettingValue=t}),define(ge[188],pe([0,1,55,22,17,11,24,2,83,84,40,6,3]),function(G,e,b,I,T,A,y,P,D,k,r,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},n=[],o=[]){this._contents=t,this._keys=n,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const o=this.getContentsForOverrideIdentifer(n);return o?t?(0,k.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const i of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[i],c=n[i];c&&(typeof s=="object"&&typeof c=="object"?(s=y.deepClone(s),this.mergeContents(s,c)):s=c),o[i]=s}return new g(o,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),o=y.deepClone(this.overrides),i=[...this.keys];for(const s of t){this.mergeContents(n,s.contents);for(const c of s.overrides){const[h]=o.filter(_=>T.equals(_.identifiers,c.identifiers));h?this.mergeContents(h.contents,c.contents):o.push(y.deepClone(c))}for(const c of s.keys)i.indexOf(c)===-1&&i.push(c)}return new g(n,i,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const o of Object.keys(n)){if(o in t&&A.isObject(t[o])&&A.isObject(n[o])){this.mergeContents(t[o],n[o]);continue}t[o]=y.deepClone(n[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let o=0;o<n;o++)t.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=g;class a extends g{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),o=[];for(const i of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(i)&&o.push({identifiers:[(0,D.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,k.toValuesTree)(t[i],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,n,o)}}e.DefaultConfigurationModel=a;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:o,keys:i,overrides:s,restricted:c}=this.doParseRaw(t,n);this._configurationModel=new g(o,i,s),this._restrictedConfigurations=c||[]}doParseContent(t){let n={},o=null,i=[],s=[],c=[];function h(u){Array.isArray(i)?i.push(u):o&&(i[o]=u)}let _={onObjectBegin:()=>{let u={};h(u),s.push(i),i=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{let u=[];h(u),s.push(i),i=u,o=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:h,onError:(u,p,R)=>{c.push({error:u,offset:p,length:R})}};if(t)try{b.visit(t,_),n=i[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return n}doParseRaw(t,n){const o=r.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,o,!0,n);t=i.raw;const s=(0,k.toValuesTree)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),c=Object.keys(t),h=(0,k.toOverrides)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:s,keys:c,overrides:h,restricted:i.restricted}}filter(t,n,o,i){if(!(i==null?void 0:i.scopes)&&!(i==null?void 0:i.skipRestricted))return{raw:t,restricted:[]};const s={},c=[];for(let h in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(h)&&o){const _=this.filter(t[h],n,!1,i);s[h]=_.raw,c.push(..._.restricted)}else{const _=n[h],u=_?typeof _.scope!="undefined"?_.scope:3:void 0;(_==null?void 0:_.restricted)&&c.push(h),(u===void 0||i.scopes===void 0||i.scopes.includes(u))&&(i.skipRestricted&&(_==null?void 0:_.restricted)||(s[h]=t[h]))}return{raw:s,restricted:c}}}e.ConfigurationModelParser=d;class E extends C.Disposable{constructor(t,n,o,i){super();this.userSettingsResource=t,this.scopes=n,this.fileService=i,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(f.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class w{constructor(t,n,o=new g,i=new g,s=new I.ResourceMap,c=new g,h=new I.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=i,this._folderConfigurations=s,this._memoryConfiguration=c,this._memoryConfigurationByResource=h,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(t)}updateValue(t,n,o={}){let i;o.resource?(i=this._memoryConfigurationByResource.get(o.resource),i||(i=new g,this._memoryConfigurationByResource.set(o.resource,i))):i=this._memoryConfiguration,n===void 0?i.removeValue(t):i.setValue(t,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,o){const i=this.getConsolidateConfigurationModel(n,o),s=this.getFolderConfigurationModelForResource(n.resource,o),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,h=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),u=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),p=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,V=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(t):c.getValue(t),re=i.getValue(t),j=T.distinct(T.flatten(i.overrides.map(x=>x.identifiers))).filter(x=>i.getOverrideValue(t,x)!==void 0);return{defaultValue:h,userValue:_,userLocalValue:u,userRemoteValue:p,workspaceValue:R,workspaceFolderValue:O,memoryValue:V,value:re,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:u!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:V!==void 0?{value:c.getValue(t),override:n.overrideIdentifier?c.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const o=n.filter(i=>D.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const s=(0,D.overrideIdentifierFromKey)(i),c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),h=t.getKeysForOverrideIdentifier(s),_=[...h.filter(u=>c.indexOf(u)===-1),...c.filter(u=>h.indexOf(u)===-1),...c.filter(u=>!y.equals(this._defaultConfiguration.override(s).getValue(u),t.override(s).getValue(u)))];return[s,_]});return this.updateDefaultConfiguration(t),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:o,removed:i,overrides:s}=(0,k.compare)(this.localUserConfiguration,t),c=[...n,...o,...i];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:o,removed:i,overrides:s}=(0,k.compare)(this.remoteUserConfiguration,t);let c=[...n,...o,...i];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:o,removed:i,overrides:s}=(0,k.compare)(this.workspaceConfiguration,t);let c=[...n,...o,...i];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(t,n){const o=this.folderConfigurations.get(t),{added:i,updated:s,removed:c,overrides:h}=(0,k.compare)(o,n);let _=[...i,...s,...c];return(_.length||!o)&&this.updateFolderConfiguration(t,n),{keys:_,overrides:h}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:i,removed:s,overrides:c}=(0,k.compare)(n,void 0);return{keys:[...o,...i,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let o=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const i=n.getFolder(t);i&&(o=this.getFolderConsolidatedConfiguration(i.uri)||o);const s=this._memoryConfigurationByResource.get(t);s&&(o=o.merge(s))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(n=o.merge(i),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=o}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const o=n.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:o,overrides:i,keys:s}=this._folderConfigurations.get(n);return t.push([n,{contents:o,overrides:i,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((c,h)=>(c.set(P.URI.revive(h[0]),this.parseConfigurationModel(h[1])),c),new I.ResourceMap);return new w(n,o,new g,i,s,new g,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function S(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,n=new Map;for(const i of v)i.keys.forEach(s=>t.add(s)),i.overrides.forEach(([s,c])=>{const h=(0,I.getOrSet)(n,s,new Set);c.forEach(_=>h.add(_))});const o=[];return n.forEach((i,s)=>o.push([s,[...i.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=S;class m{constructor(t,n,o,i){this.change=t,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=i,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(h=>s.add(h)),t.overrides.forEach(([,h])=>h.forEach(_=>s.add(_))),this.affectedKeys=[...s.values()];const c=new g;this.affectedKeys.forEach(h=>c.setValue(h,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,s=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let o=(0,k.toValuesTree)({[n]:!0},()=>{}),i;for(;typeof o=="object"&&(i=Object.keys(o)[0]);){if(t=t[i],!t)return!1;o=o[i]}return!0}}e.ConfigurationChangeEvent=m;class l extends m{constructor(t,n,o,i){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=o,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=l}),define(ge[189],pe([0,1,38,8,78,155,26,10,184,84,4,12,95]),function(G,e,b,I,T,A,y,P,D,k,r,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const g=A.localize(0,null);class a{async getDefaultTerminalForPlatforms(){const t=await w.getDefaultTerminalLinuxReady();return{windows:d.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let d=class jt extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,T.getWindowsShell(),t)}spawnTerminal(t,n,o,i){const s=n.terminal.external,c=(s==null?void 0:s.windowsExec)||jt.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const h=I.basename(c).toLowerCase();if(h==="cmder"||h==="cmder.exe")return t.spawn(c,i?[i]:void 0),Promise.resolve(void 0);const _=["/c","start","/wait"];return c.indexOf(" ")>=0&&_.push('""'),_.push(c),(h==="wt"||h==="wt.exe")&&_.push("-d ."),new Promise((u,p)=>{const R=S(process),O=t.spawn(o,_,{cwd:i,env:R});O.on("error",p),O.on("exit",()=>u())})}runInTerminal(t,n,o,i,s){const c=s.windowsExec||jt.getDefaultTerminalWindows();return new Promise((h,_)=>{const u=`"${n} - ${g}"`,p=`""${o.join('" "')}" & pause"`,R=["/c","start",u,"/wait",c,"/c",p],O=Object.assign({},S(process),i);Object.keys(O).filter(j=>O[j]===null).forEach(j=>delete O[j]);const V={cwd:n,env:O,windowsVerbatimArguments:!0};b.spawn(jt.CMD,R,V).on("error",j=>{_(m(j))}),h(void 0)})}static getDefaultTerminalWindows(){if(!jt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");jt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return jt._DEFAULT_TERMINAL_WINDOWS}};d.CMD="cmd.exe",d=Ve([xe(0,(0,r.optional)(k.IConfigurationService))],d),e.WindowsExternalTerminalService=d;let E=class Nn extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,o,i,s){const c=s.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((h,_)=>{if(c===D.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const u=c===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,G).fsPath,"-t",t||g,"-w",n];for(let re of o)R.push("-a"),R.push(re);if(i)for(let re in i){const j=i[re];j===null?(R.push("-u"),R.push(re)):(R.push("-e"),R.push(`${re}=${j}`))}let O="";const V=b.spawn(Nn.OSASCRIPT,R);V.on("error",re=>{_(m(re))}),V.stderr.on("data",re=>{O+=re.toString()}),V.on("exit",re=>{if(re===0)h(void 0);else if(O){const j=O.split(`
`,1);_(new Error(j[0]))}else _(new Error(A.localize(1,null,u,re)))})}else _(new Error(A.localize(2,null,c)))})}spawnTerminal(t,n,o){const i=n.terminal.external,s=(i==null?void 0:i.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((c,h)=>{const _=["-a",s];o&&_.push(o);const u=t.spawn("/usr/bin/open",_);u.on("error",h),u.on("exit",()=>c())})}};E.OSASCRIPT="/usr/bin/osascript",E=Ve([xe(0,(0,r.optional)(k.IConfigurationService))],E),e.MacExternalTerminalService=E;let w=class qt extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,o,i,s){const c=s.linuxExec?Promise.resolve(s.linuxExec):qt.getDefaultTerminalLinuxReady();return new Promise((h,_)=>{let u=[];c.then(p=>{p.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const R=`${l(o)}; echo; read -p "${qt.WAIT_MESSAGE}" -n1;`;u.push(`''${R}''`);const O=Object.assign({},process.env,i);Object.keys(O).filter(x=>O[x]===null).forEach(x=>delete O[x]);const V={cwd:n,env:O};let re="";const j=b.spawn(p,u,V);j.on("error",x=>{_(m(x))}),j.stderr.on("data",x=>{re+=x.toString()}),j.on("exit",x=>{if(x===0)h(void 0);else if(re){const W=re.split(`
`,1);_(new Error(W[0]))}else _(new Error(A.localize(4,null,p,x)))})})})}static async getDefaultTerminalLinuxReady(){return qt._DEFAULT_TERMINAL_LINUX_READY||(qt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{P.isLinux?await y.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),qt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,o){const i=n.terminal.external,s=(i==null?void 0:i.linuxExec)?Promise.resolve(i.linuxExec):qt.getDefaultTerminalLinuxReady();return new Promise((c,h)=>{s.then(_=>{const u=S(process),p=t.spawn(_,[],{cwd:o,env:u});p.on("error",h),p.on("exit",()=>c())})})}};w.WAIT_MESSAGE=A.localize(3,null),w=Ve([xe(0,(0,r.optional)(k.IConfigurationService))],w),e.LinuxExternalTerminalService=w;function S(v){const t=v.env;return(0,f.sanitizeProcessEnvironment)(t),t}function m(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(A.localize(5,null,v.path)):v}function l(v){let t="";for(let n of v)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(ge[85],pe([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var T;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(P,D=T.Unknown,k){super(P);this._message=P,this._code=D,this._detail=k,this.isHandled=D===T.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(P){return P instanceof A&&P._code===T.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof A&&P._code===T.NoResolverFound}static isHandled(P){return P instanceof A&&P.isHandled}}e.RemoteAuthorityResolverError=A}),define(ge[118],pe([0,1,12]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(D){return D.scheme===b.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=I;function T(D){if(!!D){const k=D.indexOf("+");return k<0?D:D.substr(0,k)}}e.getRemoteName=T;function A(D){return D.scheme!==b.Schemas.file&&D.scheme!==b.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(k=>A(k.uri))?D.folders[0].uri:void 0;if(D.configuration&&A(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function P(D){var k;return(k=y(D))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=P}),define(ge[190],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class b{vsda(){return new Promise((T,A)=>G(["vsda"],T,A))}async sign(T){try{const A=await this.vsda(),y=new A.signer;if(y)return y.sign(T)}catch(A){}return T}}e.SignService=b}),define(ge[191],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,A,y=5){let P;return P=A(D=>{const k=typeof D=="string"?D:D.data;let r=this._terminalBufferMap.get(T);if(r){r.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(T),y);r={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(T),P.dispose()}},this._terminalBufferMap.set(T,r)}),P}stopBuffering(T){const A=this._terminalBufferMap.get(T);A&&A.dispose()}flushBuffer(T){const A=this._terminalBufferMap.get(T);A&&(this._terminalBufferMap.delete(T),this._callback(T,A.data.join("")))}}e.TerminalDataBufferer=b}),define(ge[192],pe([0,1,48,8,36,26,11,24,10]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function k(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=k;async function r(C,f,g,a=T.env,d=A.exists){if(I.isAbsolute(C))return await d(C)?C:void 0;if(f===void 0&&(f=T.cwd()),I.dirname(C)!=="."){const m=I.join(f,C);return await d(m)?m:void 0}const w=(0,P.getCaseInsensitive)(a,"PATH");if(g===void 0&&(0,y.isString)(w)&&(g=w.split(I.delimiter)),g===void 0||g.length===0){const m=I.join(f,C);return await d(m)?m:void 0}for(let m of g){let l;if(I.isAbsolute(m)?l=I.join(m,C):l=I.join(f,m,C),await d(l))return l;if(D.isWindows){let v=l+".com";if(await d(v)||(v=l+".exe",await d(v)))return v}}const S=I.join(f,C);return await d(S)?S:void 0}e.findExecutable=r}),define(ge[193],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(ge[194],pe([0,1,4,6,40,3,193,43]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var D;(function(E){function w(S){return S&&typeof S=="object"&&typeof S.id=="string"}E.isThemeColor=w})(D=e.ThemeColor||(e.ThemeColor={}));function k(E){return{id:E}}e.themeColorFromId=k;var r;(function(E){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}E.isThemeIcon=w;const S=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function m(t){const n=S.exec(t);if(!!n){let[,o]=n;return{id:o}}}E.fromString=m;function l(t,n){let o=t.id;const i=o.lastIndexOf("~");return i!==-1&&(o=o.substring(0,i)),n&&(o=`${o}~${n}`),{id:o}}E.modify=l;function v(t,n){var o,i;return t.id===n.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((i=n.color)===null||i===void 0?void 0:i.id)}E.isEqual=v,E.asClassNameArray=P.CSSIcon.asClassNameArray,E.asClassName=P.CSSIcon.asClassName,E.asCSSSelector=P.CSSIcon.asCSSSelector})(r=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function C(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,I.toDisposable)(()=>{const S=this.themingParticipants.indexOf(w);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new f;T.Registry.add(e.Extensions.ThemingContribution,g);function a(E){return g.onColorThemeChange(E)}e.registerThemingParticipant=a;class d extends I.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,S){let m=this.theme.getColor(w);return m&&S&&(m=S(m,this.theme)),m?m.toString():null}}e.Themable=d}),define(ge[195],pe([0,1,40,194,3,158,117,13,43]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,S,m,l){const v=this.iconsById[w];if(v){if(m&&!v.description){v.description=m,this.iconSchema.properties[w].markdownDescription=`${m} $(${w})`;const o=this.iconReferenceSchema.enum.indexOf(w);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=m),this._onDidChange.fire()}return v}let t={id:w,description:m,defaults:S,deprecationMessage:l};this.iconsById[w]=t;let n={$ref:"#/definitions/icons"};return l&&(n.deprecationMessage=l),m&&(n.markdownDescription=`${m}: $(${w})`),this.iconSchema.properties[w]=n,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(m||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const S=this.iconReferenceSchema.enum.indexOf(w);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,S){const m=this.iconFontsById[w];if(m)return m;let l={id:w,definition:S};return this.iconFontsById[w]=l,this._onDidChange.fire(),l}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(v,t)=>v.id.localeCompare(t.id),S=v=>{for(;I.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of l.filter(t=>!!t.description).sort(w))m.push(`|<i class="${S(v)}"></i>|${v.id}|${I.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const v of l.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(w))m.push(`|<i class="${S(v)}"></i>|${v.id}|`);return m.join(`
`)}}const r=new k;b.Registry.add(e.Extensions.IconContribution,r);function C(E,w,S,m){return r.registerIcon(E,w,S,m)}e.registerIcon=C;function f(){return r}e.getIconRegistry=f;function g(){for(const E of D.iconRegistry.all)r.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>r.registerIcon(E.id,E.definition,E.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let a=b.Registry.as(y.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,r.getIconSchema());const d=new P.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);r.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=C("widget-close",D.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",D.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",D.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=I.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(ge[60],pe([0,1,2,25,4,22]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var y;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function P(f){const g=f;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=P;function D(f){const g=f;return!!(g&&typeof g=="object"&&b.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=D;class k{constructor(g,a,d,E){this._id=g,this._configuration=d,this._ignorePathCasing=E,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class r{constructor(g,a){this.raw=a,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,I.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function C(f){return new r({uri:f,index:0,name:(0,I.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=C}),define(ge[119],pe([0,1,4,159,60,2,10,8,25,134,55,12,76,29,118]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(W){return(typeof W=="string"?(0,P.extname)(W):(0,D.extname)(W))===d}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function w(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function S(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=S;function m(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=m;function l(W){const U=W;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=l;function v(W){if(W.configuration)return{id:W.id,configPath:W.configuration};if(W.folders.length===1)return{id:W.id,uri:W.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(W){const U=W;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function n(W){const U=W;if(U==null?void 0:U.uri)return{id:U.id,uri:A.URI.revive(U.uri)};const M=W;if(M==null?void 0:M.configPath)return{id:M.id,configPath:A.URI.revive(M.configPath)};if(W==null?void 0:W.id)return{id:W.id}}e.reviveIdentifier=n;function o(W,U){return D.extUriBiasedIgnorePathCase.isEqualOrParent(W,U.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function i(W){return s(W)||c(W)}e.isStoredWorkspaceFolder=i;function s(W){const U=W;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=s;function c(W){const U=W;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=c;function h(W,U,M,F,L=!y.isWindows,N){if(W.scheme!==F.scheme)return{name:M,uri:W.toString(!0)};let $=U?void 0:N.relativePath(F,W);if($!==void 0)$.length===0?$=".":y.isWindows&&W.scheme===C.Schemas.file&&!L&&($=$.replace(/\//g,"\\"));else if(W.scheme===C.Schemas.file)$=W.fsPath,y.isWindows&&($=(0,f.normalizeDriveLetter)($),L&&($=(0,g.toSlashes)($)));else{if(!N.isEqualAuthority(W.authority,F.authority))return{name:M,uri:W.toString(!0)};$=W.path}return{name:M,path:$}}e.getStoredWorkspaceFolder=h;function _(W,U,M){let F=[],L=new Set;const N=M.dirname(U);for(let $ of W){let q;if(s($))$.path&&(q=M.resolvePath(N,$.path));else if(c($))try{q=A.URI.parse($.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(Q){console.warn(Q)}if(q){let Q=M.getComparisonKey(q);if(!L.has(Q)){L.add(Q);const de=$.name||M.basenameOrAuthority(q);F.push(new T.WorkspaceFolder({uri:q,name:de,index:F.length},$))}}}return F}e.toWorkspaceFolders=_;function u(W,U,M,F,L){let N=p(U,W);const $=L.dirname(U),q=L.dirname(F),Q=[],de=R(N.folders);for(const Le of N.folders){const H=s(Le)?L.resolvePath($,Le.path):A.URI.parse(Le.uri);let Y;M?Y=!1:Y=!s(Le)||(0,P.isAbsolute)(Le.path),Q.push(h(H,Y,Le.name,q,de,L))}const be={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Ae=k.setProperty(W,["folders"],Q,be);let Ce=k.applyEdits(W,Ae);return N.remoteAuthority===(0,a.getRemoteAuthority)(F)&&(Ce=k.applyEdits(Ce,k.removeProperty(Ce,["remoteAuthority"],be))),Ce}e.rewriteWorkspaceFileForNewLocation=u;function p(W,U){let M=r.parse(U);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(F=>i(F));else throw new Error(`${W} looks like an invalid workspace file.`);return M}function R(W){return y.isWindows?W.some(U=>s(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function O(W){return W.workspace&&typeof W.workspace=="object"&&typeof W.workspace.id=="string"&&typeof W.workspace.configPath=="string"}function V(W){return typeof W.folderUri=="string"}function re(W){return typeof W.fileUri=="string"}function j(W,U){const M={workspaces:[],files:[]};if(W){const F=function(N,$){for(let q=0;q<N.length;q++)try{$(N[q],q)}catch(Q){U.warn(`Error restoring recent entry ${JSON.stringify(N[q])}: ${Q.toString()}. Skip entry.`)}},L=W;if(Array.isArray(L.entries))F(L.entries,N=>{const $=N.label,q=N.remoteAuthority;O(N)?M.workspaces.push({label:$,remoteAuthority:q,workspace:{id:N.workspace.id,configPath:A.URI.parse(N.workspace.configPath)}}):V(N)?M.workspaces.push({label:$,remoteAuthority:q,folderUri:A.URI.parse(N.folderUri)}):re(N)&&M.files.push({label:$,remoteAuthority:q,fileUri:A.URI.parse(N.fileUri)})});else{const N=W;Array.isArray(N.workspaces3)&&F(N.workspaces3,($,q)=>{const Q=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[q]||void 0;typeof $=="object"&&typeof $.id=="string"&&typeof $.configURIPath=="string"?M.workspaces.push({label:Q,workspace:{id:$.id,configPath:A.URI.parse($.configURIPath)}}):typeof $=="string"&&M.workspaces.push({label:Q,folderUri:A.URI.parse($)})}),Array.isArray(N.files2)&&F(N.files2,($,q)=>{const Q=Array.isArray(N.fileLabels)&&N.fileLabels[q]||void 0;typeof $=="string"&&M.files.push({label:Q,fileUri:A.URI.parse($)})})}}return M}e.restoreRecentlyOpened=j;function x(W){const U={entries:[]};for(const M of W.workspaces)S(M)?U.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):U.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of W.files)U.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return U}e.toStoreData=x}),define(ge[86],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const A=this._idPool++;return this._data.set(A,T),this.logDebugInfo(),A}get(T,A){return this._data.has(T)?this._data.get(T)[A]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(ge[196],pe([0,1,2,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(P=>({name:P.name,group:P.group,resource:b.URI.revive(P.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(ge[61],pe([0,1,12,4]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,P){P===null?this._providerInfo.delete(y):this._providerInfo.set(y,P)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ge[28],pe([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(ge[197],pe([0,1,13]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,P,D){this._deferredPromises=new Map,this._id=y,this._shared=P,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new b.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const r of k.values())r.complete()}catch(r){for(const C of k.values())C.error(r)}})()},0)}get whenReady(){return this._init}get(y,P){let D=this._value[y];return typeof D=="undefined"&&(D=P),D}update(y,P){this._value[y]=P;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const k=new b.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class T extends I{constructor(y,P){super(y.identifier.value,!0,P);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=T}),define(ge[15],pe([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class I{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(ge[198],pe([0,1,27,3]),function(G,e,b,I){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,D){T.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(P.identifier),tt(this,T,D,"f"),Ue(this,T,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(P){return Ue(this,T,"f").get(this._id,P)}store(P,D){return Ue(this,T,"f").store(this._id,P,D)}delete(P){return Ue(this,T,"f").delete(this._id,P)}}e.ExtensionSecrets=A,T=new WeakMap}),define(ge[120],pe([0,1,4,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(ge[87],pe([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const T=new WeakMap,A=y=>{let P=T.get(y);return P||(P={children:new Map,bus:new b.Emitter},T.set(y,P)),P};e.getPrivateApiFor=A}),define(ge[50],pe([0,1,4,3,15]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(P){function D(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public}}P.fromApiTunnel=D;function k(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.public}}P.fromServiceTunnel=k})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,k){return{dispose:()=>{}}}async $providePortAttributes(D,k,r,C,f){return[]}async $forwardPort(D,k){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=Ve([xe(0,T.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)},Jt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(ge[7],pe([0,1,17,16,99,22,9,11,2,30,45,85,87]),function(G,e,b,I,T,A,y,P,D,k,r,C,f){"use strict";var g,a,d,E,w,S,m,l,v,t,n,o,i,s,c,h;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(z){function B(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(B,z),Object.setPrototypeOf(B.prototype,z.prototype),B}let u=d=class{constructor(B){g.set(this,void 0),tt(this,g,B,"f")}static from(...B){let oe=B;return new d(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof Ue(this,g,"f")=="function"&&(Ue(this,g,"f").call(this),tt(this,g,void 0,"f"))}};g=new WeakMap,u=d=Ve([_],u),e.Disposable=u;let p=E=class{constructor(B,oe){if(B<0)throw(0,I.illegalArgument)("line must be non-negative");if(oe<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=B,this._character=oe}static Min(...B){if(B.length===0)throw new TypeError;let oe=B[0];for(let ke=1;ke<B.length;ke++){const Ke=B[ke];Ke.isBefore(oe)&&(oe=Ke)}return oe}static Max(...B){if(B.length===0)throw new TypeError;let oe=B[0];for(let ke=1;ke<B.length;ke++){const Ke=B[ke];Ke.isAfter(oe)&&(oe=Ke)}return oe}static isPosition(B){if(!B)return!1;if(B instanceof E)return!0;let{line:oe,character:ke}=B;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,oe=0){if(B===null||oe===null)throw(0,I.illegalArgument)();let ke;return typeof B=="undefined"?ke=0:typeof B=="number"?ke=B:(ke=typeof B.lineDelta=="number"?B.lineDelta:0,oe=typeof B.characterDelta=="number"?B.characterDelta:0),ke===0&&oe===0?this:new E(this.line+ke,this.character+oe)}with(B,oe=this.character){if(B===null||oe===null)throw(0,I.illegalArgument)();let ke;return typeof B=="undefined"?ke=this.line:typeof B=="number"?ke=B:(ke=typeof B.line=="number"?B.line:this.line,oe=typeof B.character=="number"?B.character:this.character),ke===this.line&&oe===this.character?this:new E(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};p=E=Ve([_],p),e.Position=p;let R=w=class{constructor(B,oe,ke,Ke){let et,st;if(typeof B=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"?(et=new p(B,oe),st=new p(ke,Ke)):B instanceof p&&oe instanceof p&&(et=B,st=oe),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(B){return B instanceof w?!0:B?p.isPosition(B.start)&&p.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof w?this.contains(B._start)&&this.contains(B._end):B instanceof p?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const oe=p.Max(B.start,this._start),ke=p.Min(B.end,this._end);if(!oe.isAfter(ke))return new w(oe,ke)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const oe=p.Min(B.start,this._start),ke=p.Max(B.end,this.end);return new w(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,oe=this.end){if(B===null||oe===null)throw(0,I.illegalArgument)();let ke;return B?p.isPosition(B)?ke=B:(ke=B.start||this.start,oe=B.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new w(ke,oe)}toJSON(){return[this.start,this.end]}};R=w=Ve([_],R),e.Range=R;let O=S=class extends R{constructor(B,oe,ke,Ke){let et,st;if(typeof B=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"?(et=new p(B,oe),st=new p(ke,Ke)):B instanceof p&&oe instanceof p&&(et=B,st=oe),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(B){return B instanceof S?!0:B?R.isRange(B)&&p.isPosition(B.anchor)&&p.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=S=Ve([_],O),e.Selection=O;class V{constructor(B,oe,ke){if(typeof B!="string"||B.length===0)throw(0,I.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,I.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,I.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=V;class re extends Error{constructor(B,oe=C.RemoteAuthorityResolverErrorCode.Unknown,ke){super(B);this._message=B,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,re.prototype)}static NotAvailable(B,oe){return new re(B,C.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(B){return new re(B,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=re;var j;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var x;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=m=class{constructor(B,oe){this._range=B,this._newText=oe}static isTextEdit(B){return B instanceof m?!0:B?R.isRange(B)&&typeof B.newText=="string":!1}static replace(B,oe){return new m(B,oe)}static insert(B,oe){return m.replace(new R(B,B),oe)}static delete(B){return m.replace(B,"")}static setEndOfLine(B){const oe=new m(new R(new p(0,0),new p(0,0)),"");return oe.newEol=B,oe}get range(){return this._range}set range(B){if(B&&!R.isRange(B))throw(0,I.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,I.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,I.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=m=Ve([_],W),e.TextEdit=W;var U;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellOutput=4]="CellOutput",z[z.CellReplace=5]="CellReplace",z[z.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,oe,ke,Ke){this._edits.push({_type:1,from:B,to:oe,options:ke,metadata:Ke})}createFile(B,oe,ke){this._edits.push({_type:1,from:void 0,to:B,options:oe,metadata:ke})}deleteFile(B,oe,ke){this._edits.push({_type:1,from:B,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata(B,oe,ke){this._edits.push({_type:3,metadata:ke,uri:B,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(B,oe,ke,Ke,et){let st,ut,yt=[],kt;if($t.isNotebookRange(oe)&&Mt.isNotebookCellDataArray(ke)&&!Mt.isNotebookCellDataArray(Ke)?(st=oe.start,ut=oe.end,yt=ke,kt=Ke):typeof oe=="number"&&typeof ke=="number"&&Mt.isNotebookCellDataArray(Ke)&&(st=oe,ut=ke,yt=Ke,kt=et),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||yt.length>0)&&this._edits.push({_type:5,uri:B,index:st,count:ut-st,cells:yt,metadata:kt})}replaceNotebookCellMetadata(B,oe,ke,Ke){this._edits.push({_type:3,metadata:Ke,uri:B,edit:{editType:8,index:oe,metadata:ke}})}replace(B,oe,ke,Ke){this._edits.push({_type:2,uri:B,edit:new W(oe,ke),metadata:Ke})}insert(B,oe,ke,Ke){this.replace(B,new R(oe,oe),ke,Ke)}delete(B,oe,ke){this.replace(B,oe,"",ke)}has(B){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===B.toString())}set(B,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:B,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ke=this._edits[ke];Ke._type===2&&Ke.uri.toString()===B.toString()&&(this._edits[ke]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(B){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===B.toString()&&oe.push(ke.edit);return oe}entries(){const B=new A.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=B.get(oe.uri);ke||(ke=[oe.uri,[]],B.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=Ve([_],M),e.WorkspaceEdit=M;let F=l=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof l?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=l._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,oe=this._tabstop++){if(typeof B=="function"){const ke=new l;ke._tabstop=this._tabstop,B(ke),this._tabstop=ke._tabstop,B=ke.value}else B=l._escape(B);return this.value+="${",this.value+=oe,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,oe=this._tabstop++){const ke=B.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(B,oe){if(typeof oe=="function"){const ke=new l;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};F=l=Ve([_],F),e.SnippetString=F;var L;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(L=e.DiagnosticTag||(e.DiagnosticTag={}));var N;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(N=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let $=v=class{constructor(B,oe){if(this.uri=B,oe)if(oe instanceof R)this.range=oe;else if(oe instanceof p)this.range=new R(oe,oe);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof v?!0:B?R.isRange(B.range)&&D.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};$=v=Ve([_],$),e.Location=$;let q=class{constructor(B,oe){this.location=B,this.message=oe}static is(B){return B?typeof B.message=="string"&&B.location&&R.isRange(B.location.range)&&D.URI.isUri(B.location.uri):!1}static isEqual(B,oe){return B===oe?!0:!B||!oe?!1:B.message===oe.message&&B.location.range.isEqual(oe.location.range)&&B.location.uri.toString()===oe.location.uri.toString()}};q=Ve([_],q),e.DiagnosticRelatedInformation=q;let Q=class{constructor(B,oe,ke=N.Error){if(!R.isRange(B))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=B,this.message=oe,this.severity=ke}toJSON(){return{severity:N[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,oe){return B===oe?!0:!B||!oe?!1:B.message===oe.message&&B.severity===oe.severity&&B.code===oe.code&&B.severity===oe.severity&&B.source===oe.source&&B.range.isEqual(oe.range)&&(0,b.equals)(B.tags,oe.tags)&&(0,b.equals)(B.relatedInformation,oe.relatedInformation,q.isEqual)}};Q=Ve([_],Q),e.Diagnostic=Q;let de=class{constructor(B,oe){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:(0,T.isMarkdownString)(B)?this.contents=[B]:this.contents=[B],this.range=oe}};de=Ve([_],de),e.Hover=de;var be;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor(B,oe=be.Text){this.range=B,this.kind=oe}toJSON(){return{range:this.range,kind:be[this.kind]}}};Ae=Ve([_],Ae),e.DocumentHighlight=Ae;var Ce;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Ce=e.SymbolKind||(e.SymbolKind={}));var Le;(function(z){z[z.Deprecated=1]="Deprecated"})(Le=e.SymbolTag||(e.SymbolTag={}));let H=t=class{constructor(B,oe,ke,Ke,et){this.name=B,this.kind=oe,this.containerName=et,typeof ke=="string"&&(this.containerName=ke),Ke instanceof $?this.location=Ke:ke instanceof R&&(this.location=new $(Ke,ke)),t.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ce[this.kind],location:this.location,containerName:this.containerName}}};H=t=Ve([_],H),e.SymbolInformation=H;let Y=n=class{constructor(B,oe,ke,Ke,et){this.name=B,this.detail=oe,this.kind=ke,this.range=Ke,this.selectionRange=et,this.children=[],n.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(n.validate)}};Y=n=Ve([_],Y),e.DocumentSymbol=Y;var ee;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(B,oe){this.title=B,this.kind=oe}};ae=Ve([_],ae),e.CodeAction=ae;let me=o=class{constructor(B){this.value=B}append(B){return new o(this.value?this.value+o.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+o.sep)}};me.sep=".",me=o=Ve([_],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let De=class{constructor(B,oe){if(this.range=B,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=Ve([_],De),e.SelectionRange=De;class Oe{constructor(B,oe,ke,Ke,et,st){this.kind=B,this.name=oe,this.detail=ke,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=Oe;class we{constructor(B,oe){this.fromRanges=oe,this.from=B}}e.CallHierarchyIncomingCall=we;class Pe{constructor(B,oe){this.fromRanges=oe,this.to=B}}e.CallHierarchyOutgoingCall=Pe;let Re=class{constructor(B,oe){this.range=B,this.command=oe}get isResolved(){return!!this.command}};Re=Ve([_],Re),e.CodeLens=Re;let Be=i=class{constructor(B,oe=!1){a.set(this,void 0),tt(this,a,new T.MarkdownString(B,{supportThemeIcons:oe}),"f")}static isMarkdownString(B){return B instanceof i?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return Ue(this,a,"f").value}set value(B){Ue(this,a,"f").value=B}get isTrusted(){return Ue(this,a,"f").isTrusted}set isTrusted(B){Ue(this,a,"f").isTrusted=B}get supportThemeIcons(){return Ue(this,a,"f").supportThemeIcons}appendText(B){return Ue(this,a,"f").appendText(B),this}appendMarkdown(B){return Ue(this,a,"f").appendMarkdown(B),this}appendCodeblock(B,oe){return Ue(this,a,"f").appendCodeblock(oe!=null?oe:"",B),this}};a=new WeakMap,Be=i=Ve([_],Be),e.MarkdownString=Be;let Se=class{constructor(B,oe){this.label=B,this.documentation=oe}};Se=Ve([_],Se),e.ParameterInformation=Se;let qe=class{constructor(B,oe){this.label=B,this.documentation=oe,this.parameters=[]}};qe=Ve([_],qe),e.SignatureInformation=qe;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=Ve([_],X),e.SignatureHelp=X;var ie;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(ie=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _e;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(_e=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(B,oe,ke){this.text=B,this.position=oe,this.kind=ke}};Ne=Ve([_],Ne),e.InlayHint=Ne;var ze;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Je;(function(z){z[z.Deprecated=1]="Deprecated"})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));let K=class{constructor(B,oe){this.label=B,this.kind=oe}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};K=Ve([_],K),e.CompletionItem=K;let se=class{constructor(B=[],oe=!1){this.items=B,this.isIncomplete=oe}};se=Ve([_],se),e.CompletionList=se;var he;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var J;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(J=e.StatusBarAlignment||(e.StatusBarAlignment={}));var te;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ce;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var je;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(je=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function B(oe){switch(oe){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=B}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let He=class{constructor(B,oe){if(oe&&!D.URI.isUri(oe))throw(0,I.illegalArgument)("target");if(!R.isRange(B)||B.isEmpty)throw(0,I.illegalArgument)("range");this.range=B,this.target=oe}};He=Ve([_],He),e.DocumentLink=He;let We=class{constructor(B,oe,ke,Ke){this.red=B,this.green=oe,this.blue=ke,this.alpha=Ke}};We=Ve([_],We),e.Color=We;let Ge=class{constructor(B,oe){if(oe&&!(oe instanceof We))throw(0,I.illegalArgument)("color");if(!R.isRange(B)||B.isEmpty)throw(0,I.illegalArgument)("range");this.range=B,this.color=oe}};Ge=Ve([_],Ge),e.ColorInformation=Ge;let nt=class{constructor(B){if(!B||typeof B!="string")throw(0,I.illegalArgument)("label");this.label=B}};nt=Ve([_],nt),e.ColorPresentation=nt;var dt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var it;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ye;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Ye=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let wt=s=class{constructor(B,oe){if(typeof B!="string"||typeof oe!="string")throw(0,I.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};wt.Clean=new s("clean","Clean"),wt.Build=new s("build","Build"),wt.Rebuild=new s("rebuild","Rebuild"),wt.Test=new s("test","Test"),wt=s=Ve([_],wt),e.TaskGroup=wt;function Ee(z){let B="";for(let oe=0;oe<z.length;oe++)B+=z[oe].replace(/,/g,",,")+",";return B}let fe=class{constructor(B,oe,ke){if(typeof B!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=B,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,I.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)B.push(oe);return Ee(B)}};fe=Ve([_],fe),e.ProcessExecution=fe;let le=class{constructor(B,oe,ke){if(this._args=[],Array.isArray(oe)){if(!B)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,I.illegalArgument)("command");this._command=B,this._args=oe,this._options=ke}else{if(typeof B!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=B,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,I.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)B.push(typeof oe=="string"?oe:oe.value);return Ee(B)}};le=Ve([_],le),e.ShellExecution=le;var Z;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Z=e.ShellQuoting||(e.ShellQuoting={}));var Fe;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Fe=e.TaskScope||(e.TaskScope={}));class Te{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=Te;let Qe=c=class{constructor(B,oe,ke,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=B;let ut;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Ke,ut=et,this.__deprecated=!0):oe===Fe.Global||oe===Fe.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Ke,this.execution=et,ut=st):(this.target=oe,this._name=this.name=ke,this._source=this.source=Ke,this.execution=et,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof fe?this._definition={type:c.ProcessType,id:this._execution.computeId()}:this._execution instanceof le?this._definition={type:c.ShellType,id:this._execution.computeId()}:this._execution instanceof Te?this._definition={type:c.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:c.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const oe=this._definition.type;(c.EmptyType===oe||c.ProcessType===oe||c.ShellType===oe||c.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=c=Ve([_],Qe),e.Task=Qe;var Ze;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Ze=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(B,oe=ht.None){this.collapsibleState=oe,D.URI.isUri(B)?this.resourceUri=B:this.label=B}};ct=Ve([_],ct),e.TreeItem=ct;var ht;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Xe=class{constructor(B,oe){this.id=B,this.color=oe}};Xe=Ve([_],Xe),e.ThemeIcon=Xe,Xe.File=new Xe("file"),Xe.Folder=new Xe("folder");let ot=class{constructor(B){this.id=B}};ot=Ve([_],ot),e.ThemeColor=ot;var ft;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(B,oe){if(typeof B!="string"&&(!B||!D.URI.isUri(B)&&!D.URI.isUri(B.uri)))throw(0,I.illegalArgument)("base");if(typeof oe!="string")throw(0,I.illegalArgument)("pattern");typeof B=="string"?(this.baseFolder=D.URI.file(B),this.base=B):D.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=oe}};at=Ve([_],at),e.RelativePattern=at;let St=class{constructor(B,oe,ke,Ke){this.enabled=typeof B=="boolean"?B:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};St=Ve([_],St),e.Breakpoint=St;let vt=class extends St{constructor(B,oe,ke,Ke,et){super(oe,ke,Ke,et);if(B===null)throw(0,I.illegalArgument)("location");this.location=B}};vt=Ve([_],vt),e.SourceBreakpoint=vt;let Pt=class extends St{constructor(B,oe,ke,Ke,et){super(oe,ke,Ke,et);this.functionName=B}};Pt=Ve([_],Pt),e.FunctionBreakpoint=Pt;let Tt=class extends St{constructor(B,oe,ke,Ke,et,st,ut){super(Ke,et,st,ut);if(!oe)throw(0,I.illegalArgument)("dataId");this.label=B,this.dataId=oe,this.canPersist=ke}};Tt=Ve([_],Tt),e.DataBreakpoint=Tt;let Rt=class{constructor(B,oe,ke){this.command=B,this.args=oe||[],this.options=ke}};Rt=Ve([_],Rt),e.DebugAdapterExecutable=Rt;let _t=class{constructor(B,oe){this.port=B,this.host=oe}};_t=Ve([_],_t),e.DebugAdapterServer=_t;let Zt=class{constructor(B){this.path=B}};Zt=Ve([_],Zt),e.DebugAdapterNamedPipeServer=Zt;let en=class{constructor(B){this.implementation=B}};en=Ve([_],en),e.DebugAdapterInlineImplementation=en;let gt=class{constructor(B,oe){this.range=B,this.expression=oe}};gt=Ve([_],gt),e.EvaluatableExpression=gt;let tn=class{constructor(B,oe){this.range=B,this.text=oe}};tn=Ve([_],tn),e.InlineValueText=tn;let Dt=class{constructor(B,oe,ke=!0){this.range=B,this.variableName=oe,this.caseSensitiveLookup=ke}};Dt=Ve([_],Dt),e.InlineValueVariableLookup=Dt;let Gt=class{constructor(B,oe){this.range=B,this.expression=oe}};Gt=Ve([_],Gt),e.InlineValueEvaluatableExpression=Gt;let nn=class{constructor(B,oe){this.frameId=B,this.stoppedLocation=oe}};nn=Ve([_],nn),e.InlineValueContext=nn;var Qt;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Qt=e.FileChangeType||(e.FileChangeType={}));let lt=h=class extends Error{constructor(B,oe=r.FileSystemProviderErrorCode.Unknown,ke){var Ke;super(D.URI.isUri(B)?B.toString(!0):B);this.code=(Ke=ke==null?void 0:ke.name)!==null&&Ke!==void 0?Ke:"Unknown",(0,r.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(B){return new h(B,r.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(B){return new h(B,r.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(B){return new h(B,r.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(B){return new h(B,r.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(B){return new h(B,r.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(B){return new h(B,r.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};lt=h=Ve([_],lt),e.FileSystemError=lt;let rn=class{constructor(B,oe,ke){this.start=B,this.end=oe,this.kind=ke}};rn=Ve([_],rn),e.FoldingRange=rn;var Lt;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Lt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wt;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Wt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var gn;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(gn=e.CommentMode||(e.CommentMode={}));class Dn{constructor(B,oe=[]){this.tokenTypes=B,this.tokenModifiers=oe}}e.SemanticTokensLegend=Dn;function pn(z){return typeof z=="undefined"||(0,P.isStringArray)(z)}class sn{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let oe=0,ke=B.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set(B.tokenTypes[oe],oe);for(let oe=0,ke=B.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set(B.tokenModifiers[oe],oe)}}push(B,oe,ke,Ke,et){if(typeof B=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(B,oe,ke,Ke,et);if(R.isRange(B)&&typeof oe=="string"&&pn(ke))return this._push(B,oe,ke);throw(0,I.illegalArgument)()}_push(B,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ke=B.start.line,et=B.start.character,st=B.end.character-B.start.character,ut=this._tokenTypeStrToInt.get(oe);let yt=0;if(ke)for(const kt of ke){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(kt);yt|=1<<It>>>0}this._pushEncoded(Ke,et,st,ut,yt)}_pushEncoded(B,oe,ke,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let kt=0,It=0;for(let At=0;At<yt;At++){let Ot=this._data[5*At],hn=this._data[5*At+1];Ot===0?(Ot=kt,hn+=It):Ot+=kt,this._data[5*At]=Ot,this._data[5*At+1]=hn,kt=Ot,It=hn}}let st=B,ut=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=B,this._prevChar=oe}static _sortAndDeltaEncode(B){let oe=[];const ke=B.length/5|0;for(let ut=0;ut<ke;ut++)oe[ut]=ut;oe.sort((ut,yt)=>{const kt=B[5*ut],It=B[5*yt];if(kt===It){const At=B[5*ut+1],Ot=B[5*yt+1];return At-Ot}return kt-It});const Ke=new Uint32Array(B.length);let et=0,st=0;for(let ut=0;ut<ke;ut++){const yt=5*oe[ut],kt=B[yt+0],It=B[yt+1],At=B[yt+2],Ot=B[yt+3],hn=B[yt+4],On=kt-et,Wn=On===0?It-st:It,fn=5*ut;Ke[fn+0]=On,Ke[fn+1]=Wn,Ke[fn+2]=At,Ke[fn+3]=Ot,Ke[fn+4]=hn,et=kt,st=It}return Ke}build(B){return this._dataIsSortedAndDeltaEncoded?new Xt(new Uint32Array(this._data),B):new Xt(sn._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=sn;class Xt{constructor(B,oe){this.resultId=oe,this.data=B}}e.SemanticTokens=Xt;class Ut{constructor(B,oe,ke){this.start=B,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=Ut;class Cn{constructor(B,oe){this.resultId=oe,this.edits=B}}e.SemanticTokensEdits=Cn;var on;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(on=e.DebugConsoleMode||(e.DebugConsoleMode={}));var an;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(an=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Yt=class{constructor(){}};Yt.Back={iconPath:new Xe("arrow-left")},Yt=Ve([_],Yt),e.QuickInputButtons=Yt;var kn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(kn=e.ExtensionKind||(e.ExtensionKind={}));class Ft{constructor(B,oe,ke){this.badge=B,this.tooltip=oe,this.color=ke}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ft;let ln=class{constructor(B){this.kind=B}};ln=Ve([_],ln),e.ColorTheme=ln;var Pn;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(Pn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(B,oe){if(B<0)throw(0,I.illegalArgument)("start must be positive");if(oe<0)throw(0,I.illegalArgument)("end must be positive");B<=oe?(this._start=B,this._end=oe):(this._start=oe,this._end=B)}static isNotebookRange(B){return B instanceof $t?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let oe=this._start,ke=this._end;return B.start!==void 0&&(oe=B.start),B.end!==void 0&&(ke=B.end),oe===this._start&&ke===this._end?this:new $t(oe,ke)}}e.NotebookRange=$t;class cn{constructor(B,oe){typeof B=="object"?Object.assign(this,B):(this.inputCollapsed=B,this.outputCollapsed=oe)}with(B){let{inputCollapsed:oe,outputCollapsed:ke}=B,Ke=Jt(B,["inputCollapsed","outputCollapsed"]);return oe===void 0?oe=this.inputCollapsed:oe===null&&(oe=void 0),ke===void 0?ke=this.outputCollapsed:ke===null&&(ke=void 0),oe===this.inputCollapsed&&ke===this.outputCollapsed&&Object.keys(Ke).length===0?this:new cn(Object.assign({inputCollapsed:oe,outputCollapsed:ke},Ke))}}e.NotebookCellMetadata=cn;class xt{constructor(B={}){Object.assign(this,B)}with(B){return new xt(B)}}e.NotebookDocumentMetadata=xt;class Mt{constructor(B,oe,ke,Ke,et,st){this.kind=B,this.source=oe,this.language=ke,this.outputs=Ke!=null?Ke:[],this.metadata=et,this.latestExecutionSummary=st}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(oe=>Mt.isNotebookCellData(oe))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Mt;class vn{constructor(B,oe){this.cells=B,this.metadata=oe!=null?oe:new xt}}e.NotebookData=vn;class Ht{constructor(B,oe,ke){if(this.mime=B,this.value=oe,this.metadata=ke,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(B){return B instanceof Ht}}e.NotebookCellOutputItem=Ht;class Me{constructor(B,oe,ke){this.outputs=B,typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,k.generateUuid)(),this.metadata=oe!=null?oe:ke)}}e.NotebookCellOutput=Me;var un;(function(z){z[z.Markdown=1]="Markdown",z[z.Code=2]="Code"})(un=e.NotebookCellKind||(e.NotebookCellKind={}));var dn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(dn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class An{constructor(B,oe,ke,Ke,et,st){this.text=B,this.alignment=oe,this.command=ke,this.tooltip=Ke,this.priority=et,this.accessibilityInformation=st}}e.NotebookCellStatusBarItem=An;var wn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(wn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class bn{constructor(B,oe=[]){this.uri=B,this.provides=typeof oe=="string"?[oe]:oe}}e.NotebookKernelPreload=bn;let zt=class{constructor(B,oe){this.label=B,this.timestamp=oe}};zt=Ve([_],zt),e.TimelineItem=zt;var Tn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class _n{constructor(B,oe){this.ranges=B,this.wordPattern=oe}}e.LinkedEditingRanges=_n;var Fn;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var En;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(En=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Sn;(function(z){z[z.Pending=0]="Pending",z[z.Resolved=1]="Resolved"})(Sn=e.TestItemStatus||(e.TestItemStatus={}));const Bt=(z,B,oe,ke)=>{let Ke=oe;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){ke(Ke,et)||(Ke=et,z.bus.fire([3,B,et]))}}},Vt=(z,B)=>z===B,ne=(z,B)=>z===B?!0:!z||!B?!1:z.isEqual(B);class ue{constructor(B,oe,ke,Ke){this.label=oe,this.data=Ke;const et=(0,f.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:B,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new A.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:Bt(et,"range",void 0,ne),description:Bt(et,"description",void 0,Vt),runnable:Bt(et,"runnable",!0,Vt),debuggable:Bt(et,"debuggable",!1,Vt),status:Bt(et,"status",Sn.Resolved,Vt),error:Bt(et,"error",void 0,Vt)})}invalidate(){(0,f.getPrivateApiFor)(this).bus.fire([2])}dispose(){const B=(0,f.getPrivateApiFor)(this);B.parent&&(0,f.getPrivateApiFor)(B.parent).children.delete(this.id),B.bus.fire([1])}addChild(B){if(!(B instanceof ue))throw new Error("Test child must be created through vscode.test.createTestItem()");const oe=(0,f.getPrivateApiFor)(this);if(oe.children.has(B.id))throw new Error(`Attempted to insert a duplicate test item ID ${B.id}`);oe.children.set(B.id,B),oe.bus.fire([0,B])}}e.TestItemImpl=ue;class Ie{constructor(B){this.message=B,this.severity=En.Error}static diff(B,oe,ke){const Ke=new Ie(B);return Ke.expectedOutput=oe,Ke.actualOutput=ke,Ke}}e.TestMessage=Ie;var rt;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(rt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bt;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ct;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore"})(Ct=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[121],pe([0,1,52,12,9,144,110,7,17]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function r(a,d){d?k.set(a,d):k.delete(a)}e.setWordDefinitionFor=r;function C(a){return k.get(a)}e.getWordDefinitionFor=C;class f extends A.MirrorTextModel{constructor(d,E,w,S,m,l,v,t){super(E,w,S,m);this._proxy=d,this._languageId=l,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,D.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===I.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(E){return E?d._getTextInRange(E):d.getText()},get eol(){return d._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(E){return d._lineAt(E)},offsetAt(E){return d._offsetAt(E)},positionAt(E){return d._positionAt(E)},validateRange(E){return d._validateRange(E)},validatePosition(E){return d._validatePosition(E)},getWordRangeAtPosition(E,w){return d._getWordRangeAtPosition(E,w)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,b.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,b.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const E=this._validateRange(d);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const w=this._eol,S=E.start.line,m=E.end.line,l=[];l.push(this._lines[S].substring(E.start.character));for(let v=S+1;v<m;v++)l.push(this._lines[v]);return l.push(this._lines[m].substring(0,E.end.character)),l.join(w)}_lineAt(d){let E;if(d instanceof P.Position?E=d.line:typeof d=="number"&&(E=d),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new g(E,this._lines[E],E===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(d),w=this._lines[E.index].length;return new P.Position(E.index,Math.min(E.remainder,w))}_validateRange(d){if(!(d instanceof P.Range))throw new Error("Invalid argument");const E=this._validatePosition(d.start),w=this._validatePosition(d.end);return E===d.start&&w===d.end?d:new P.Range(E.line,E.character,w.line,w.character)}_validatePosition(d){if(!(d instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:E,character:w}=d,S=!1;if(E<0)E=0,w=0,S=!0;else if(E>=this._lines.length)E=this._lines.length-1,w=this._lines[E].length,S=!0;else{const m=this._lines[E].length;w<0?(w=0,S=!0):w>m&&(w=m,S=!0)}return S?new P.Position(E,w):d}_getWordRangeAtPosition(d,E){const w=this._validatePosition(d);if(!E)E=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const S=(0,y.getWordAtText)(w.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[w.line],0);if(S)return new P.Range(w.line,S.startColumn-1,w.line,S.endColumn-1)}}e.ExtHostDocumentData=f;class g{constructor(d,E,w){this._line=d,this._text=E,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ge[199],pe([0,1,7,3,112,6,77,22,2,30]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class r{constructor(f,g,a,d){this._notebook=a,this._selector=d,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(w=>{const S=this._cellUris.get(w.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(f.onDidChangeNotebookCells(w=>E(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const f=[],g=[];for(const a of this._notebook.getCells())a.kind===b.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),f.push(a.document.getText().length+1),g.push(a.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(f)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(f){var g,a;if(!f){let m="";for(const l of this._cells)m+=l.document.getText()+`
`;return m=m.slice(0,-1),m}if(f.isEmpty)return"";const d=this.locationAt(f.start),E=this.locationAt(f.end),w=this._cells[(g=this._cellUris.get(d.uri))!==null&&g!==void 0?g:-1],S=this._cells[(a=this._cellUris.get(E.uri))!==null&&a!==void 0?a:-1];if(!w||!S)return"";if(w===S)return w.document.getText(new b.Range(d.range.start,E.range.end));{const m=w.document.getText(new b.Range(d.range.start,new b.Position(w.document.lineCount,0))),l=S.document.getText(new b.Range(new b.Position(0,0),E.range.end));return m+`
`+l}}offsetAt(f){const g=this._cellLines.getIndexOf(f.line),a=this._cellLengths.getAccumulatedValue(g.index-1),d=this._cells[g.index].document.offsetAt(f.with(g.remainder));return a+d}positionAt(f){if(typeof f=="number"){const a=this._cellLengths.getIndexOf(f),d=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(d)}const g=this._cellUris.get(f.uri);if(g!==void 0){const a=this._cellLines.getAccumulatedValue(g-1);return new b.Position(a+f.range.start.line,f.range.start.character)}return new b.Position(0,0)}locationAt(f){b.Range.isRange(f)||(f=new b.Range(f,f));const g=this._cellLines.getIndexOf(f.start.line);let a=g;f.isEmpty||(a=this._cellLines.getIndexOf(f.end.line));const d=new b.Position(g.remainder,f.start.character),E=new b.Position(a.remainder,f.end.character),w=new b.Range(d,E),S=this._cells[g.index];return new b.Location(S.document.uri,S.document.validateRange(w))}contains(f){return this._cellUris.has(f)}validateRange(f){const g=this.validatePosition(f.start),a=this.validatePosition(f.end);return f.with(g,a)}validatePosition(f){const g=this._cellLines.getIndexOf(f.line),a=new b.Position(g.remainder,f.character),d=this._cells[g.index].document.validatePosition(a),E=this._cellLines.getAccumulatedValue(g.index-1);return new b.Position(E+d.line,d.character)}}e.ExtHostNotebookConcatDocument=r}),define(ge[200],pe([0,1,7,15,3]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let D=P==="light"?b.ColorThemeKind.Light:P==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ve([xe(0,I.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ge[62],pe([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class I{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(ge[201],pe([0,1,23]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(D){let k=this.buffers.indexOf(D);return k<0&&(k=this.buffers.length,this.buffers.push(D)),k}}function T(P,D){if(D.serializeBuffersForPostMessage){const k=new I,r=(g,a)=>{if(a instanceof ArrayBuffer){const d=k.add(a);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(a)){const d=A(a);if(d){const E=k.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:d,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},C=JSON.stringify(P,r),f=k.buffers.map(g=>{const a=new Uint8Array(g);return b.VSBuffer.wrap(a)});return{message:C,buffers:f}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=T;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(P,D){const k=D.map(f=>{const g=new ArrayBuffer(f.byteLength);return new Uint8Array(g).set(f.buffer),g}),r=D.length?(f,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const a=g,{index:d}=a,E=k[d];if(a.view)switch(a.view.type){case 1:return new Int8Array(E,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return g}:void 0;return{message:JSON.parse(P,r),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(ge[88],pe([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(A,y,P){const D=A.webviewResourceRoot.replace("{{resource}}",P.scheme+T(P)).replace("{{uuid}}",y);return b.URI.parse(D)}e.asWebviewUri=I;function T(A){return A.toString().replace(/^\S+?:/,"")}}),define(ge[202],pe([0,1,3,6,88,30]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,k,r){this._proxy=D,this._editors=k,this._initData=r,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const C=k.getVisibleTextEditors();for(const f of this._insets.values())C.indexOf(f.editor)<0&&f.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,k,r,C,f){let g;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===D){g=l;break}if(!g)throw new Error("not a visible editor");const a=this,d=this._handlePool++,E=new b.Emitter,w=new b.Emitter,S=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,T.asWebviewUri)(a._initData,this._uuid,l)}get cspSource(){return a._initData.webviewCspSource}set options(l){this._options=l,a._proxy.$setOptions(d,l)}get options(){return this._options}set html(l){this._html=l,a._proxy.$setHtml(d,l)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(l){return a._proxy.$postMessage(d,l)}},m=new class{constructor(){this.editor=D,this.line=k,this.height=r,this.webview=S,this.onDidDispose=w.event}dispose(){a._insets.has(d)&&(a._insets.delete(d),a._proxy.$disposeEditorInset(d),w.fire(),w.dispose(),E.dispose())}};return this._proxy.$createEditorInset(d,g.id,g.value.document.uri,k+1,r,C||{},f.identifier,f.extensionLocation),this._insets.set(d,{editor:D,inset:m,onDidReceiveMessage:E}),m}$onDidDispose(D){const k=this._insets.get(D);k&&k.inset.dispose()}$onDidReceiveMessage(D,k){const r=this._insets.get(D);r&&r.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(ge[203],pe([0,1,3,81,169,4,6,22,40,17,53,24,43,195]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",f.Codicon.window,(0,T.localize)(0,null));var a;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var d;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(s){switch(s){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function w(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=w;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(c,h,_){var u;const p=this.get(c.id);if(p)return p;const R=c;return R.openCommandActionDescriptor=(_==null?void 0:_.donotRegisterOpenCommand)?void 0:(u=R.openCommandActionDescriptor)!==null&&u!==void 0?u:{id:R.id},(0,P.getOrSet)(this.viewContainers,h,[]).push(R),(_==null?void 0:_.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:h}),R}deregisterViewContainer(c){for(const h of this.viewContainers.keys()){const _=this.viewContainers.get(h),u=_==null?void 0:_.indexOf(c);if(u!==-1){_==null||_.splice(u,1),_.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(_=>(_==null?void 0:_.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===c)}}D.Registry.add(a.ViewContainersRegistry,new S);var m;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(m=e.ViewContentGroups||(e.ViewContentGroups={}));function l(s,c){var h,_,u,p;const R=(h=s.group)!==null&&h!==void 0?h:m.More,O=(_=c.group)!==null&&_!==void 0?_:m.More;return R!==O?R.localeCompare(O):((u=s.order)!==null&&u!==void 0?u:5)-((p=c.order)!==null&&p!==void 0?p:5)}class v extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new r.SetMap}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:_})=>this.addViews(h,_)),this._onViewsRegistered.fire(c)}deregisterViews(c,h){const _=this.removeViews(c,h);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:h})}moveViews(c,h){for(const _ of this._views.keys())if(_!==h){const u=this.removeViews(c,_);u.length&&(this.addViews(u,h),this._onDidChangeContainer.fire({views:u,from:_,to:h}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const h of this._viewContainers){const _=(this._views.get(h)||[]).filter(u=>u.id===c)[0];if(_)return _}return null}getViewContainer(c){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(u=>u.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this._viewWelcomeContents.add(c,h),this._onDidChangeViewWelcomeContent.fire(c),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,h),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,h){const _=new Map;for(const[u,p]of h)this._viewWelcomeContents.add(c,p),_.set(u,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,p),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),_}getViewWelcomeContent(c){const h=[];return this._viewWelcomeContents.forEach(c,_=>h.push(_)),h.sort(l)}addViews(c,h){let _=this._views.get(h);_||(_=[],this._views.set(h,_),this._viewContainers.push(h));for(const u of c){if(this.getView(u.id)!==null)throw new Error((0,T.localize)(1,null,u.id));_.push(u)}}removeViews(c,h){const _=this._views.get(h);if(!_)return[];const u=[],p=[];for(const R of _)c.includes(R)?u.push(R):p.push(R);return u.length&&(p.length?this._views.set(h,p):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),u}}D.Registry.add(a.ViewsRegistry,new v),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,h){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,c),this._hasResolve=!!h,this.resolve=async _=>{var u,p;if(h&&!this.resolved){const R=await h(_);R&&(this.tooltip=(u=this.tooltip)!==null&&u!==void 0?u:R.tooltip,this.command=(p=this.command)!==null&&p!==void 0?p:R.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i}),define(ge[204],pe([0,1,2,180,119,14,181,203]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(d){return(E,...w)=>d(E.get(I.ICommandService),...w)}class k{static execute(E,w){const S={forceReuseWindow:w&&w.reuseWindow,remoteAuthority:w&&w.remoteAuthority};return E.executeCommand("_files.newWindow",S)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:k.ID,handler:D(k.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(d,E){return d.get(T.IWorkspacesService).removeRecentlyOpened([E])});class r{static execute(E,w){return typeof w=="string"?w=w.match(/^[^:/?#]+:\/\//)?b.URI.parse(w):b.URI.file(w):w=b.URI.revive(w),E.executeCommand("_workbench.removeFromRecentlyOpened",w)}}e.RemoveFromRecentlyOpenedAPICommand=r,r.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(r.ID,D(r.execute));class C{static execute(E,w){const S=typeof w=="string"?{extensionId:w}:w;return E.executeCommand("workbench.action.openIssueReporter",S)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(d,E){const w=d.get(T.IWorkspacesService);let S;const m=E.uri,l=E.label,v=E.remoteAuthority;return E.type==="workspace"?S={workspace:await w.getWorkspaceIdentifier(m),label:l,remoteAuthority:v}:E.type==="folder"?S={folderUri:m,label:l,remoteAuthority:v}:S={fileUri:m,label:l,remoteAuthority:v},w.addRecentlyOpened([S])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(d){return d.get(T.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(d,E){const w=d.get(A.ILogService),S=d.get(y.IEnvironmentService);S.isExtensionDevelopment&&!!S.extensionTestsLocationURI&&w.setLevel(E)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(d){return d.get(A.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(d,E){const w=d.get(P.IViewDescriptorService),S=w.getViewContainerById(E.destinationId);if(!!S){for(const m of E.viewIds){const l=w.getViewDescriptorById(m);(l==null?void 0:l.canMoveView)&&w.moveViewsToContainer([l],S,P.ViewVisibilityState.Default)}await d.get(P.IViewsService).openViewContainer(S.id,!0)}});class f{static execute(E,w){return!Array.isArray(w==null?void 0:w.viewIds)||typeof(w==null?void 0:w.destinationId)!="string"?Promise.reject("Invalid arguments"):E.executeCommand("_workbench.action.moveViews",w)}}e.MoveViewsAPICommand=f,f.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:f.ID,handler:D(f.execute),description:{description:"Move Views",args:[]}});class g{static execute(E,w){return E.executeCommand("_workbench.open",w)}}g.ID="vscode.open",I.CommandsRegistry.registerCommand(g.ID,D(g.execute));class a{static execute(E,w,S,m,l){return E.executeCommand("_workbench.diff",[w,S,m])}}a.ID="vscode.diff",I.CommandsRegistry.registerCommand(a.ID,D(a.execute))}),define(ge[122],pe([0,1,3,13,170]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,D,k,r){const C={command:P};if(D&&Object.keys(D).length>0&&(C.arguments=D),this.internalSend("request",C),typeof r=="number"){const f=setTimeout(()=>{clearTimeout(f);const g=this.pendingRequests.get(C.seq);if(g){this.pendingRequests.delete(C.seq);const a={type:"response",seq:0,request_seq:C.seq,success:!1,command:P,message:(0,T.localize)(0,null,r,P)};g(a)}},r)}return k&&this.pendingRequests.set(C.seq,k),C.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,D){return P.type!=="event"||D.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,I.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const D=P,k=this.pendingRequests.get(D.request_seq);k&&(this.pendingRequests.delete(D.request_seq),k(D));break}}}internalSend(P,D){D.type=P,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((D,k)=>P.set(k,D)),await(0,I.timeout)(500),P.forEach((D,k)=>{D({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ge[205],pe([0,1,9,2,8,24,12]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function D(n,o,i){return n.replace(P,function(s,c){return o&&c.length>0&&c[0]!=="_"?s:i&&i.hasOwnProperty(c)?i[c]:s})}e.formatPII=D;function k(n){const o={};for(const i of Object.keys(n))i.startsWith("!")||(o[i]=n[i]);return o}e.filterExceptionsFromTelemetry=k;function r(n){return n.configuration.request==="attach"&&!C(n)}e.isSessionAttach=r;function C(n){let o=n.configuration.type;if(!!o)return o==="vslsShare"&&(o=n.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(o,"extensionhost")||(0,b.equalsIgnoreCase)(o,"pwa-extensionhost")?n:n.parentSession?C(n.parentSession):void 0}e.getExtensionHostDebugSession=C;function f(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=f;function g(n,o,i){let s,c=0,h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=h.exec(n);){let u=_.index+1,p=u+_[0].length;if(u<=o&&p>=i){s=_[0],c=u;break}}if(s){let u=/\w+/g,p=null;for(;(p=u.exec(s))&&!(p.index+1+c+p[0].length>=i););p&&(s=s.substring(0,u.lastIndex))}return s?{start:c,end:c+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(n){return!!(n&&n.match(a))}e.isUri=d;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(d(n.path))return I.URI.parse(n.path);if((0,T.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const o=I.URI.revive(n.path);if(o)return o.scheme===y.Schemas.file?o.fsPath:o.toString()}return n.path}function S(n,o){const i=o?E:w,s=(0,A.deepClone)(n);return l(s,(c,h)=>{c&&h&&(h.path=i(h))}),s}e.convertToDAPaths=S;function m(n,o){const i=o?E:w,s=(0,A.deepClone)(n);return l(s,(c,h)=>{!c&&h&&(h.path=i(h))}),s}e.convertToVSCPaths=m;function l(n,o){switch(n.type){case"event":const i=n;switch(i.event){case"output":o(!1,i.body.source);break;case"loadedSource":o(!1,i.body.source);break;case"breakpoint":o(!1,i.body.breakpoint.source);break;default:break}break;case"request":const s=n;switch(s.command){case"setBreakpoints":o(!0,s.arguments.source);break;case"breakpointLocations":o(!0,s.arguments.source);break;case"source":o(!0,s.arguments.source);break;case"gotoTargets":o(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(h=>o(!1,h));break;default:break}break;case"response":const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(h=>o(!1,h.source));break;case"loadedSources":c.body.sources.forEach(h=>o(!1,h));break;case"scopes":c.body.scopes.forEach(h=>o(!1,h.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(h=>o(!1,h.source));break;case"setBreakpoints":c.body.breakpoints.forEach(h=>o(!1,h.source));break;default:break}break}}function v(n){return n.filter(o=>{var i;return!((i=o.presentation)===null||i===void 0?void 0:i.hidden)}).sort((o,i)=>o.presentation?i.presentation?o.presentation.group?i.presentation.group?o.presentation.group!==i.presentation.group?o.presentation.group.localeCompare(i.presentation.group):t(o.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(o.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=v;function t(n,o){return typeof n!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:n-o}}),define(ge[206],pe([0,1,26,38,171,123,8,9,24,10,182,122]),function(G,e,b,I,T,A,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class f extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,m){this.outputStream=m,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",l=>this.handleData(l))}sendMessage(S){if(this.outputStream){const m=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${f.TWO_CRLF}${m}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const m=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+m))}continue}}else{const m=this.rawData.indexOf(f.TWO_CRLF);if(m!==-1){const v=this.rawData.toString("utf8",0,m).split(f.HEADER_LINESEPARATOR);for(const t of v){const n=t.split(f.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(m+f.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=f,f.TWO_CRLF=`\r
\r
`,f.HEADER_LINESEPARATOR=/\r?\n/,f.HEADER_FIELDSEPARATOR=/: */;class g extends f{startSession(){return new Promise((S,m)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.socket.on("error",v=>{l?this._onError.fire(v):m(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class a extends g{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=a;class d extends g{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=d;class E extends f{constructor(S,m,l){super();this.adapterExecutable=S,this.debugType=m,this.outputService=l}async startSession(){const S=this.adapterExecutable.command,m=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(S)if(y.isAbsolute(S)){if(!await(0,b.exists)(S))throw new Error(T.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(T.localize(1,null,this.debugType));let v=process.env;if(l.env&&Object.keys(l.env).length>0&&(v=D.mixin(D.deepClone(process.env),l.env)),S==="node")if(Array.isArray(m)&&m.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:v,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(o.cwd=l.cwd);const i=I.fork(m[0],m.slice(1),o);if(!i.pid)throw new Error(T.localize(2,null,m[0]));this.serverProcess=i}else throw new Error(T.localize(3,null));else{const n={env:v};l.cwd&&(n.cwd=l.cwd),this.serverProcess=I.spawn(S,m,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,o)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const i=t.getChannel(r.ExtensionsChannelId);i&&i.append(n(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((S,m)=>{const l=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,n){if(v)return m(v)});l.on("exit",S),l.on("error",m)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,m){if(!!S){const l=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?l.runtime=y.join(m,S.runtime):l.runtime=S.runtime),S.runtimeArgs&&(l.runtimeArgs=S.runtimeArgs),S.program&&(y.isAbsolute(S.program)?l.program=S.program:l.program=y.join(m,S.program)),S.args&&(l.args=S.args);const v=S;return v.win&&(l.win=E.extract(v.win,m)),v.winx86&&(l.winx86=E.extract(v.winx86,m)),v.windows&&(l.windows=E.extract(v.windows,m)),v.osx&&(l.osx=E.extract(v.osx,m)),v.linux&&(l.linux=E.extract(v.linux,m)),l}}static platformAdapterExecutable(S,m){let l=Object.create(null);m=m.toLowerCase();for(const s of S)if(s.contributes){const c=s.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&P.equalsIgnoreCase(h.type,m)).forEach(h=>{const _=E.extract(h,s.extensionLocation.fsPath);l=D.mixin(l,_,s.isBuiltin)})}let v;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=l.winx86||l.win||l.windows:k.isWindows?v=l.win||l.windows:k.isMacintosh?v=l.osx:k.isLinux&&(v=l.linux),v=v||l;let t=v.program||l.program;const n=v.args||l.args;let o=v.runtime||l.runtime;const i=v.runtimeArgs||l.runtimeArgs;if(o)return{type:"executable",command:o,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(ge[207],pe([0,1,38,10,29,189]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function y(f,g){return new Promise((a,d)=>{let E="";const w=b.spawn(f,g);w.pid&&w.stdout.on("data",S=>{E+=S.toString()}),w.on("error",S=>{d(S)}),w.on("close",S=>{a(E)})})}let P;function D(f,g){if(!P)if(I.isWindows)P=new A.WindowsExternalTerminalService(void 0);else if(I.isMacintosh)P=new A.MacExternalTerminalService(void 0);else if(I.isLinux)P=new A.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=g.getConfiguration("terminal");return P.runInTerminal(f.title,f.cwd,f.args,f.env||{},a.external||{})}e.runInExternalTerminal=D;function k(f){return f?I.isWindows?y("wmic",["process","get","ParentProcessId"]).then(g=>g.split(`\r
`).some(d=>parseInt(d)===f),g=>!0):y("/usr/bin/pgrep",["-lP",String(f)]).then(g=>{const a=g.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},g=>!0):Promise.resolve(!0)}e.hasChildProcesses=k;var r;(function(f){f[f.cmd=0]="cmd",f[f.powershell=1]="powershell",f[f.bash=2]="bash"})(r||(r={}));function C(f,g,a,d){f=f.trim().toLowerCase();let E;f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0?E=1:f.indexOf("cmd.exe")>=0?E=0:f.indexOf("bash")>=0?E=2:I.isWindows?E=0:E=2;let w,S=" ";switch(E){case 1:if(w=l=>(l=l.replace(/\'/g,"''"),l.length>0&&l.charAt(l.length-1)==="\\"?`'${l}\\'`:`'${l}'`),a){const l=(0,T.getDriveLetter)(a);l&&(S+=`${l}:; `),S+=`cd ${w(a)}; `}if(d)for(let l in d){const v=d[l];v===null?S+=`Remove-Item env:${l}; `:S+=`\${env:${l}}='${v}'; `}if(g.length>0){const l=w(g.shift());S+=l[0]==="'"?`& ${l} `:`${l} `;for(let v of g)S+=`${w(v)} `}break;case 0:if(w=l=>(l=l.replace(/\"/g,'""'),l.indexOf(" ")>=0||l.indexOf('"')>=0||l.length===0?`"${l}"`:l),a){const l=(0,T.getDriveLetter)(a);l&&(S+=`${l}: && `),S+=`cd ${w(a)} && `}if(d){S+='cmd /C "';for(let l in d){let v=d[l];v===null?S+=`set "${l}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),S+=`set "${l}=${v}" && `)}}for(let l of g)S+=`${w(l)} `;d&&(S+='"');break;case 2:w=l=>(l=l.replace(/(["'\\\$])/g,"\\$1"),l.indexOf(" ")>=0||l.indexOf(";")>=0||l.length===0?`"${l}"`:l);const m=l=>/[^\w@%\/+=,.:^-]/.test(l)?`'${l.replace(/'/g,"'\\''")}'`:l;if(a&&(S+=`cd ${w(a)} ; `),d){S+="/usr/bin/env";for(let l in d){const v=d[l];v===null?S+=` -u ${m(l)}`:S+=` ${m(`${l}=${v}`)}`}S+=" "}for(let l of g)S+=`${w(l)} `;break}return S}e.prepareCommand=C}),define(ge[89],pe([0,1,33,12,8,10,81]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(u){u[u.Running=1]="Running",u[u.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(u){u[u.Idle=1]="Idle",u[u.Pending=2]="Pending",u[u.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var r;(function(u){u[u.WithHardKernelDependency=0]="WithHardKernelDependency",u[u.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",u[u.Pure=2]="Pure",u[u.Never=3]="Never"})(r=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(u){u[u.ModelChange=1]="ModelChange",u[u.Move=2]="Move",u[u.CellClearOutput=3]="CellClearOutput",u[u.CellsClearOutput=4]="CellsClearOutput",u[u.ChangeLanguage=5]="ChangeLanguage",u[u.Initialize=6]="Initialize",u[u.ChangeCellMetadata=7]="ChangeCellMetadata",u[u.Output=8]="Output",u[u.OutputItem=9]="OutputItem",u[u.ChangeCellContent=10]="ChangeCellContent",u[u.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",u[u.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var f;(function(u){u[u.Handle=0]="Handle",u[u.Index=1]="Index"})(f=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(u){u[u.Replace=1]="Replace",u[u.Output=2]="Output",u[u.Metadata=3]="Metadata",u[u.CellLanguage=4]="CellLanguage",u[u.DocumentMetadata=5]="DocumentMetadata",u[u.Move=6]="Move",u[u.OutputItems=7]="OutputItems",u[u.PartialMetadata=8]="PartialMetadata"})(g=e.CellEditType||(e.CellEditType={}));function a(u){const p=d.parse(u);return p?p.notebook.toString():u.toString()}e.getCellUndoRedoComparisonKey=a;var d;(function(u){u.scheme=I.Schemas.vscodeNotebookCell;const p=/^ch(\d{7,})/;function R(x,W){return x.with({scheme:u.scheme,fragment:`ch${W.toString().padStart(7,"0")}${x.scheme!==I.Schemas.file?x.scheme:""}`})}u.generate=R;function O(x){if(x.scheme===u.scheme){const W=p.exec(x.fragment);if(!!W)return{handle:Number(W[1]),notebook:x.with({scheme:x.fragment.substr(W[0].length)||I.Schemas.file,fragment:null})}}}u.parse=O;function V(x){if(x.scheme===I.Schemas.vscodeNotebookCellMetadata){const W=p.exec(x.fragment);if(!!W)return{handle:Number(W[1]),notebook:x.with({scheme:x.fragment.substr(W[0].length)||I.Schemas.file,fragment:null})}}}u.parseCellMetadataUri=V;function re(x,W,U){return x.with({scheme:U,fragment:`ch${W.toString().padStart(7,"0")}${x.scheme!==I.Schemas.file?x.scheme:""}`})}u.generateCellUri=re;function j(x,W){if(x.scheme===W){const U=p.exec(x.fragment);if(!!U)return{handle:Number(U[1]),notebook:x.with({scheme:x.fragment.substr(U[0].length)||I.Schemas.file,fragment:null})}}}u.parseCellUri=j})(d=e.CellUri||(e.CellUri={}));const E=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(u){var p,R;return(R=(p=E.get(u))===null||p===void 0?void 0:p.alwaysSecure)!==null&&R!==void 0?R:!1}e.mimeTypeIsAlwaysSecure=w;function S(u){var p,R;return(R=(p=E.get(u))===null||p===void 0?void 0:p.supportedByCore)!==null&&R!==void 0?R:!1}e.mimeTypeSupportedByCore=S;function m(u){var p,R;return(R=(p=E.get(u))===null||p===void 0?void 0:p.mergeable)!==null&&R!==void 0?R:!1}e.mimeTypeIsMergeable=m;function l(u,p){return A.isWindows&&(u=u.replace(/\//g,"\\"),p=p.replace(/\//g,"\\")),b.match(u,p)}function v(u,p,R){let O=0;for(let V=0;V<p.length;V++){if(l(p[V],u))return O;O++}for(let V=0;V<R.length;V++){if(l(R[V],u))return O;O++}return O}function t(u,p,R){return u.sort((O,V)=>v(O,p,R)-v(V,p,R))}e.sortMimeTypes=t;function n(u,p,R,O=(V,re)=>V===re){const V=[];function re(W,U,M){if(!(U===0&&M.length===0)){const F=V[V.length-1];F&&F.start+F.deleteCount===W?(F.deleteCount+=U,F.toInsert.push(...M)):V.push({start:W,deleteCount:U,toInsert:M})}}let j=0,x=0;for(;;){if(j===u.length){re(j,0,p.slice(x));break}if(x===p.length){re(j,u.length-j,[]);break}const W=u[j],U=p[x];if(O(W,U)){j+=1,x+=1;continue}R(U)?(re(j,1,[]),j+=1):(re(j,0,[U]),x+=1)}return V}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(u){u.default="default",u.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(u){const p=u;return!!((typeof p.include=="string"||b.isRelativePattern(p.include))&&(typeof p.exclude=="string"||b.isRelativePattern(p.exclude)))}e.isDocumentExcludePattern=i;function s(u,p,R){if(Array.isArray(u.viewType)&&u.viewType.indexOf(p)>=0||u.viewType===p)return!0;if(u.filenamePattern){let O=i(u.filenamePattern)?u.filenamePattern.include:u.filenamePattern,V=i(u.filenamePattern)?u.filenamePattern.exclude:void 0;if(b.match(O,(0,T.basename)(R.fsPath).toLowerCase()))return!(V&&b.match(V,(0,T.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class c{constructor(p){this.textModel=p}getElements(){const p=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)p[R]=this.textModel.cells[R].getHashValue();return p}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var h;(function(u){u[u.Left=1]="Left",u[u.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class _{static create(p){return`${_._prefix}/${p}`}static parse(p){if(p.startsWith(_._prefix))return p.substr(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_,_._prefix="notebook/"}),define(ge[208],pe([0,1,173,4,81]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[209],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=b;function I(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=I}),define(ge[210],pe([0,1,8,95,10]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function A(l,v){if(!!v)if(T.isWindows)for(const t in v){let n=t;for(const i in l)if(t.toLowerCase()===i.toLowerCase()){n=i;break}const o=v[t];o!==void 0&&y(l,n,o)}else Object.keys(v).forEach(t=>{const n=v[t];n!==void 0&&y(l,t,n)})}e.mergeEnvironments=A;function y(l,v,t){typeof t=="string"?l[v]=t:delete l[v]}function P(l,v,t,n){l.TERM_PROGRAM="vscode",v&&(l.TERM_PROGRAM_VERSION=v),r(l,n)&&(l.LANG=C(t)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function D(l,v){if(!!v)for(const t of Object.keys(v)){const n=v[t];n&&(l[t]=n)}}function k(l,v){return Object.keys(v).forEach(t=>{const n=v[t];if(typeof n=="string")try{v[t]=l(n)}catch(o){v[t]=n}}),v}function r(l,v){if(v==="on")return!0;if(v==="auto"){const t=l.LANG;return!t||t.search(/\.UTF\-8$/)===-1&&t.search(/\.utf8$/)===-1&&t.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=r;function C(l){const v=l?l.split("-"):[],t=v.length;if(t===0)return"en_US.UTF-8";if(t===1){const n={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};v[0]in n&&v.push(n[v[0]])}else v[1]=v[1].toUpperCase();return v.join("_")+".UTF-8"}e.getLangEnvVariable=C;function f(l,v,t,n,o,i){if(l.cwd){const c=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,h=g(c,t);return a(h||c)}let s;return!l.ignoreConfigurationCwd&&o&&(t&&(o=g(o,t,i)),o&&(b.isAbsolute(o)?s=o:n&&(s=b.join(n.fsPath,o)))),s||(s=n?n.fsPath:v||""),a(s)}e.getCwd=f;function g(l,v,t){if(v)try{return v(l)}catch(n){t==null||t.error("Could not resolve terminal cwd",n);return}return l}function a(l){return T.OS===1&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function d(l,v,t){if(!!t)return n=>t.resolveWithEnvironment(v,l,n)}e.createVariableResolver=d;function E(l,v,t,n,o,i,s,c=T.platform){let h;s&&(h=S(l,"automationShell",c)),h||(h=S(l,"shell",c));let _=h||v;if(c===3&&!t&&n){const u=b.join(n,"Sysnative").replace(/\//g,"\\").toLowerCase();_&&_.toLowerCase().indexOf(u)===0&&(_=b.join(n,"System32",_.substr(u.length+1)))}if(_&&c===3&&(_=_.replace(/\//g,"\\")),o)try{_=o(_)}catch(u){i.error("Could not resolve shell",u)}return _}e.getDefaultShell=E;function w(l,v,t,n,o=T.platform){if(v&&S(l,"automationShell",o))return[];const i=o===3?"windows":o===1?"osx":"linux";let s=l(`terminal.integrated.shellArgs.${i}`);if(!s)return[];if(typeof s=="string"&&o===3)return t?t(s):s;if(t){const c=[];for(const h of s)try{c.push(t(h))}catch(_){n.error(`Could not resolve terminal.integrated.shellArgs.${i}`,_),c.push(h)}s=c}return s}e.getDefaultShellArgs=w;function S(l,v,t=T.platform){return l(`terminal.integrated.${v}.${t===3?"windows":t===1?"osx":"linux"}`)}function m(l,v,t,n,o,i){const s={};if(l.strictEnv)D(s,l.env);else{D(s,i);const c=Object.assign({},v);t&&(c&&k(t,c),l.env&&k(t,l.env)),(0,I.sanitizeProcessEnvironment)(s,"VSCODE_IPC_HOOK_CLI"),A(s,c),A(s,l.env),P(s,n,T.locale,o)}return s}e.createTerminalEnvironment=m});var mn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],b;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),b={},I("next"),I("throw"),I("return"),b[Symbol.asyncIterator]=function(){return this},b);function I(A){b[A]=G[A]&&function(y){return new Promise(function(P,D){y=G[A](y),T(P,D,y.done,y.value)})}}function T(A,y,P,D){Promise.resolve(D).then(function(k){A({value:k,done:P})},y)}};define(ge[211],pe([0,1,37,8,105,192,38,26,43,10]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let r;function C(l,v,t,n,o,i,s){return t=t||{existsFile:P.SymlinkSupport.existsFile,readFile:b.promises.readFile},k.isWindows?f(l,t,n,v("terminal.integrated.useWslProfiles")||!0,v("terminal.integrated.profiles.windows"),o,i):w(t,n,l,v(k.isMacintosh?"terminal.integrated.profiles.osx":"terminal.integrated.profiles.linux"),s,o,i)}e.detectAvailableProfiles=C;async function f(l,v,t,n,o,i,s){const c=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),h=`${process.env.windir}\\${c?"Sysnative":"System32"}`;let _=!1;(0,A.getWindowsBuildNumber)()>=16299&&(_=!0),await a();const u=new Map;l||(u.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),u.set("Windows PowerShell",{path:`${h}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),u.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),u.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),u.set("Command Prompt",{path:`${h}\\cmd.exe`,icon:D.Codicon.terminalCmd.id,isAutoDetected:!0})),S(o,u);const p=await g(u.entries(),v,t,i,s);if(!l||l&&n)try{const R=await E(`${h}\\${_?"wsl.exe":"bash.exe"}`,n);R&&p.push(...R)}catch(R){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return p}async function g(l,v,t,n,o){const i=[];for(const[s,c]of l)if(c!==null){let h,_,u;if("source"in c){const O=r==null?void 0:r.get(c.source);if(!O)continue;h=O.paths,_=c.args||O.args,u=c.icon||O.icon}else h=Array.isArray(c.path)?c.path:[c.path],_=k.isWindows||Array.isArray(c.args)?c.args:void 0,u=c.icon;const p=h.slice();for(let O=0;O<p.length;O++)p[O]=await(n==null?void 0:n.resolveAsync(o,p[O]))||p[O];const R=await m(s,p,v,_,c.env,c.overrideName,c.isAutoDetected,t);R?(R.isAutoDetected=c.isAutoDetected,R.icon=u,i.push(R)):t==null||t.trace("profile not validated",s,h)}return i}async function a(){r||(r=new Map,r.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),r.set("PowerShell",{profileName:"PowerShell",paths:await d(),icon:"terminal-powershell"}))}async function d(){var l,v;const t=[];try{for(var n=mn((0,T.enumeratePowerShellInstallations)()),o;o=await n.next(),!o.done;){const i=o.value;t.push(i.exePath)}}catch(i){l={error:i}}finally{try{o&&!o.done&&(v=n.return)&&await v.call(n)}finally{if(l)throw l.error}}return t}async function E(l,v){const t=[];if(v){const n=await new Promise((o,i)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le"},(s,c)=>{if(s)return i("Problem occurred when getting wsl distros");o(c)})});if(n){const o=new RegExp(/[\r?\n]/),i=n.split(o).filter(s=>s.trim().length>0&&s!=="");for(const s of i)if(s!==""&&!s.startsWith("docker-desktop")){const c={profileName:`${s} (WSL)`,path:l,args:["-d",`${s}`]};s.includes("Ubuntu")?c.icon="terminal-ubuntu":s.includes("Debian")?c.icon="terminal-debian":c.icon="terminal-linux",t.push(c)}return t}}return[]}async function w(l,v,t,n,o,i,s){const c=new Map;if(!t){const h=await l.readFile("/etc/shells","utf8"),_=o||h.split(`
`).filter(p=>p.trim().indexOf("#")!==0&&p.trim().length>0),u=new Map;for(const p of _){let R=(0,I.basename)(p),O=u.get(R)||0;O++,O>1&&(R=`${R} (${O})`),u.set(R,O),c.set(R,{path:p,isAutoDetected:!0})}}return S(n,c),await g(c.entries(),l,v,i,s)}function S(l,v){if(!!l)for(const[t,n]of Object.entries(l))n===null||!("path"in n)&&!("source"in n)?v.delete(t):v.set(t,n)}async function m(l,v,t,n,o,i,s,c){if(v.length===0)return Promise.resolve(void 0);const h=v.shift();if(h==="")return m(l,v,t,n,o,i,s);const _={profileName:l,path:h,args:n,env:o,overrideName:i,isAutoDetected:s};if((0,I.basename)(h)===h){const p=process.env.PATH?process.env.PATH.split(I.delimiter):void 0;return await(0,A.findExecutable)(h,void 0,p,void 0,t.existsFile)?_:m(l,v,t,n)}return await t.existsFile((0,I.normalize)(h))?_:m(l,v,t,n,o,i,s)}}),define(ge[124],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(D,k)=>{k.expand!==void 0&&(D.expand=k.expand),k.item!==void 0&&(D.item=D.item?Object.assign(D.item,k.item):k.item)};e.applyTestItemUpdate=I;var T;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(D,k)=>`${D}:${k.toString()}`;e.getTestSubscriptionKey=A;class y{add(k){}update(k){}remove(k,r){}complete(){}}e.IncrementalChangeCollector=y;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const r=this.createChangeCollector();for(const C of k)switch(C[0]){case 0:{const f=C[1];if(f.parent){if(this.items.has(f.parent)){const g=this.items.get(f.parent);g.children.add(f.item.extId);const a=this.createItem(f,g);this.items.set(f.item.extId,a),r.add(a)}}else{this.roots.add(f.item.extId);const g=this.createItem(f);this.items.set(f.item.extId,g),r.add(g)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=C[1],g=this.items.get(f.extId);if(!g)break;f.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,f),r.update(g);break}case 2:{const f=this.items.get(C[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f.item.extId);const g=[[C[1]]];for(;g.length;)for(const a of g.pop()){const d=this.items.get(a);d&&(g.push(d.children),this.items.delete(a),r.remove(d,d!==f),d.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}r.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=P}),define(ge[212],pe([0,1,8,36,11,24,10,76,174]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(C,f,g){this._contributedVariables=new Map,this._context=C,this._labelService=f,g&&(this._envVariablesPromise=g.then(a=>this.prepareEnv(a)))}prepareEnv(C){if(y.isWindows){const f=Object.create(null);return Object.keys(C).forEach(g=>{f[g.toLowerCase()]=C[g]}),f}return C}resolveWithEnvironment(C,f,g){return this.recursiveResolve(this.prepareEnv(C),f?f.uri:void 0,g)}async resolveAsync(C,f){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,f)}async resolveAnyBase(C,f,g,a){const d=A.deepClone(f);return y.isWindows&&d.windows?Object.keys(d.windows).forEach(E=>d[E]=d.windows[E]):y.isMacintosh&&d.osx?Object.keys(d.osx).forEach(E=>d[E]=d.osx[E]):y.isLinux&&d.linux&&Object.keys(d.linux).forEach(E=>d[E]=d.linux[E]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,d,g,a)}async resolveAnyAsync(C,f,g){return this.resolveAnyBase(C,f,g)}async resolveAnyMap(C,f,g){const a=new Map;return{newConfig:await this.resolveAnyBase(C,f,g,a),resolvedVariables:a}}resolveWithInteractionReplace(C,f,g,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,f,g,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,f){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,f)}recursiveResolve(C,f,g,a,d){if(T.isString(g))return this.resolveString(C,f,g,a,d);if(T.isArray(g))return g.map(E=>this.recursiveResolve(C,f,E,a,d));if(T.isObject(g)){let E=Object.create(null);return Object.keys(g).forEach(w=>{const S=this.resolveString(C,f,w,a,d);E[S]=this.recursiveResolve(C,f,g[w],a,d)}),E}return g}resolveString(C,f,g,a,d){return g.replace(k.VARIABLE_REGEXP,(w,S)=>{if(S.includes(k.VARIABLE_LHS))return w;let m=this.evaluateSingleVariable(C,w,S,f,a);return d&&d.set(S,m),m})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,f,g,a,d){let E;const w=g.split(":");w.length>1&&(g=w[0],E=w[1]);const S=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,D.localize)(0,null,f))},m=()=>{const v=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,f,b.basename(v)))},l=()=>{if(E){const v=this._context.getFolderUri(E);if(v)return v;throw new Error((0,D.localize)(2,null,f,E))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,f)):new Error((0,D.localize)(4,null,f))};switch(g){case"env":if(E){if(C){const v=C[y.isWindows?E.toLowerCase():E];if(T.isString(v))return v}return""}throw new Error((0,D.localize)(5,null,f));case"config":if(E){const v=this._context.getConfigurationValue(a,E);if(T.isUndefinedOrNull(v))throw new Error((0,D.localize)(6,null,f,E));if(T.isObject(v))throw new Error((0,D.localize)(7,null,f,E));return v}throw new Error((0,D.localize)(8,null,f));case"command":return this.resolveFromMap(f,E,d,"command");case"input":return this.resolveFromMap(f,E,d,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return a||E?(0,P.normalizeDriveLetter)(this.fsPath(l())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(l()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,D.localize)(9,null,f));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,f));case"file":return S();case"fileWorkspaceFolder":return m();case"relativeFile":return a||E?b.relative(this.fsPath(l()),S()):S();case"relativeFileDirname":const n=b.dirname(S());if(a||E){const c=b.relative(this.fsPath(l()),n);return c.length===0?".":c}return n;case"fileDirname":return b.dirname(S());case"fileExtname":return b.extname(S());case"fileBasename":return b.basename(S());case"fileBasenameNoExtension":const o=b.basename(S());return o.slice(0,o.length-b.extname(o).length);case"fileDirnameBasename":return b.basename(b.dirname(S()));case"execPath":const i=this._context.getExecPath();return i||f;case"execInstallFolder":const s=this._context.getAppRoot();return s||f;case"pathSeparator":return b.sep;default:try{const c=E?`${g}:${E}`:g;return this.resolveFromMap(f,c,d,void 0)}catch(c){return f}}}}resolveFromMap(C,f,g,a){if(f&&g){const d=a===void 0?g[f]:g[a+":"+f];if(typeof d=="string")return d;throw new Error((0,D.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[213],pe([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var I;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var y;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(f){f[f.GROUP_ACTIVE=0]="GROUP_ACTIVE",f[f.GROUP_INDEX=1]="GROUP_INDEX",f[f.EDITOR_OPEN=2]="EDITOR_OPEN",f[f.EDITOR_CLOSE=3]="EDITOR_CLOSE",f[f.EDITOR_MOVE=4]="EDITOR_MOVE",f[f.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",f[f.EDITOR_LABEL=6]="EDITOR_LABEL",f[f.EDITOR_PIN=7]="EDITOR_PIN",f[f.EDITOR_STICKY=8]="EDITOR_STICKY",f[f.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function C(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ge[214],pe([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,17,99,285,58,24,11,2,44,80,175,115,89,214,7]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(Ee){function fe(Z){const{selectionStartLineNumber:Fe,selectionStartColumn:Te,positionLineNumber:Qe,positionColumn:Ze}=Z,ct=new d.Position(Fe-1,Te-1),ht=new d.Position(Qe-1,Ze-1);return new d.Selection(ct,ht)}Ee.to=fe;function le(Z){const{anchor:Fe,active:Te}=Z;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}Ee.from=le})(E=e.Selection||(e.Selection={}));var w;(function(Ee){function fe(Z){if(!!Z){const{start:Fe,end:Te}=Z;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}Ee.from=fe;function le(Z){if(!!Z){const{startLineNumber:Fe,startColumn:Te,endLineNumber:Qe,endColumn:Ze}=Z;return new d.Range(Fe-1,Te-1,Qe-1,Ze-1)}}Ee.to=le})(w=e.Range||(e.Range={}));var S;(function(Ee){function fe(le){switch(le){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}Ee.to=fe})(S=e.TokenType||(e.TokenType={}));var m;(function(Ee){function fe(Z){return new d.Position(Z.lineNumber-1,Z.column-1)}Ee.to=fe;function le(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Ee.from=le})(m=e.Position||(e.Position={}));var l;(function(Ee){function fe(Z){switch(Z){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}Ee.from=fe;function le(Z){switch(Z){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}Ee.to=le})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(Ee){function fe(Z){let Fe;return Z.code&&((0,P.isString)(Z.code)||(0,P.isNumber)(Z.code)?Fe=String(Z.code):Fe={value:String(Z.code.value),target:Z.code.target}),Object.assign(Object.assign({},w.from(Z.range)),{message:Z.message,source:Z.source,code:Fe,severity:n.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(t.from),tags:Array.isArray(Z.tags)?(0,b.coalesce)(Z.tags.map(l.from)):void 0})}Ee.from=fe;function le(Z){var Fe;const Te=new d.Diagnostic(w.to(Z),Z.message,n.to(Z.severity));return Te.source=Z.source,Te.code=(0,P.isString)(Z.code)?Z.code:(Fe=Z.code)===null||Fe===void 0?void 0:Fe.value,Te.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(t.to),Te.tags=Z.tags&&(0,b.coalesce)(Z.tags.map(l.to)),Te}Ee.to=le})(v=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function fe(Z){return Object.assign(Object.assign({},w.from(Z.location.range)),{message:Z.message,resource:Z.location.uri})}Ee.from=fe;function le(Z){return new d.DiagnosticRelatedInformation(new d.Location(Z.resource,w.to(Z)),Z.message)}Ee.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(Ee){function fe(Z){switch(Z){case d.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Ee.from=fe;function le(Z){switch(Z){case f.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}Ee.to=le})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(Ee){function fe(Z){return typeof Z=="number"&&Z>=d.ViewColumn.One?Z-1:Z===d.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}Ee.from=fe;function le(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=le})(o=e.ViewColumn||(e.ViewColumn={}));function i(Ee){return typeof Ee.range!="undefined"}function s(Ee){return Ee.length===0?!0:!!i(Ee[0])}e.isDecorationOptionsArr=s;var c;(function(Ee){function fe(Ze){return Ze.map(Ee.from)}Ee.fromMany=fe;function le(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function Z(Ze){let ct;if(le(Ze)){const{language:ft,value:at}=Ze;ct={value:"```"+ft+`
`+at+"\n```\n"}}else d.MarkdownString.isMarkdownString(Ze)?ct={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ct={value:Ze}:ct={value:""};const ht=Object.create(null);ct.uris=ht;const Xe=ft=>{try{let at=D.URI.parse(ft,!0);at=at.with({query:Fe(at.query,ht)}),ht[ft]=at}catch(at){}return""},ot=new T.Renderer;return ot.link=Xe,ot.image=ft=>Xe(I.parseHrefAndDimensions(ft).href),T(ct.value,{renderer:ot}),ct}Ee.from=Z;function Fe(Ze,ct){if(!Ze)return Ze;let ht;try{ht=(0,A.parse)(Ze)}catch(ot){}if(!ht)return Ze;let Xe=!1;return ht=(0,y.cloneAndChange)(ht,ot=>{if(D.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=ot,Xe=!0,ft}else return}),Xe?JSON.stringify(ht):Ze}function Te(Ze){const ct=new d.MarkdownString(Ze.value,Ze.supportThemeIcons);return ct.isTrusted=Ze.isTrusted,ct}Ee.to=Te;function Qe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:Ee.from(Ze)}Ee.fromStrict=Qe})(c=e.MarkdownString||(e.MarkdownString={}));function h(Ee){return s(Ee)?Ee.map(fe=>({range:w.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?c.fromMany(fe.hoverMessage):fe.hoverMessage?c.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):Ee.map(fe=>({range:w.from(fe)}))}e.fromRangeOrRangeWithMessage=h;function _(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?D.URI.file(Ee):Ee}e.pathOrURIToURI=_;var u;(function(Ee){function fe(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?_(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}Ee.from=fe})(u=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var p;(function(Ee){function fe(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?_(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?u.from(le.before):void 0,after:le.after?u.from(le.after):void 0}}Ee.from=fe})(p=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(Ee){function fe(le){if(typeof le=="undefined")return le;switch(le){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=fe})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(Ee){function fe(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?R.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?p.from(le.light):void 0,dark:le.dark?p.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?_(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?u.from(le.before):void 0,after:le.after?u.from(le.after):void 0}}Ee.from=fe})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Ee){function fe(Z){return{text:Z.newText,eol:Z.newEol&&ie.from(Z.newEol),range:w.from(Z.range)}}Ee.from=fe;function le(Z){const Fe=new d.TextEdit(w.to(Z.range),Z.text);return Fe.newEol=typeof Z.eol=="undefined"?void 0:ie.to(Z.eol),Fe}Ee.to=le})(V=e.TextEdit||(e.TextEdit={}));var re;(function(Ee){function fe(Z,Fe,Te){var Qe,Ze,ct;const ht={edits:[]};if(Z instanceof d.WorkspaceEdit)for(let Xe of Z._allEntries())if(Xe._type===1)ht.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const ot=Fe==null?void 0:Fe.getDocument(Xe.uri);ht.edits.push({_type:2,resource:Xe.uri,edit:V.from(Xe.edit),modelVersionId:ot==null?void 0:ot.version,metadata:Xe.metadata})}else Xe._type===3?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:(Qe=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Qe===void 0?void 0:Qe.apiNotebook.version}):Xe._type===4?(Xe.newOutputs&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:2,index:Xe.index,append:Xe.append,outputs:Xe.newOutputs.map(je.from)}}),Xe.newMetadata&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:8,index:Xe.index,metadata:Xe.newMetadata}})):Xe._type===5?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:(Ze=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(ve.from)}}):Xe._type===6&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:7,outputId:Xe.outputId,items:((ct=Xe.newOutputItems)===null||ct===void 0?void 0:ct.map(ye.from))||[],append:Xe.append}});return ht}Ee.from=fe;function le(Z){const Fe=new d.WorkspaceEdit;for(const Te of Z.edits)Te.edit?Fe.replace(D.URI.revive(Te.resource),w.to(Te.edit.range),Te.edit.text):Fe.renameFile(D.URI.revive(Te.oldUri),D.URI.revive(Te.newUri),Te.options);return Fe}Ee.to=le})(re=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(Ee){const fe=Object.create(null);fe[d.SymbolKind.File]=0,fe[d.SymbolKind.Module]=1,fe[d.SymbolKind.Namespace]=2,fe[d.SymbolKind.Package]=3,fe[d.SymbolKind.Class]=4,fe[d.SymbolKind.Method]=5,fe[d.SymbolKind.Property]=6,fe[d.SymbolKind.Field]=7,fe[d.SymbolKind.Constructor]=8,fe[d.SymbolKind.Enum]=9,fe[d.SymbolKind.Interface]=10,fe[d.SymbolKind.Function]=11,fe[d.SymbolKind.Variable]=12,fe[d.SymbolKind.Constant]=13,fe[d.SymbolKind.String]=14,fe[d.SymbolKind.Number]=15,fe[d.SymbolKind.Boolean]=16,fe[d.SymbolKind.Array]=17,fe[d.SymbolKind.Object]=18,fe[d.SymbolKind.Key]=19,fe[d.SymbolKind.Null]=20,fe[d.SymbolKind.EnumMember]=21,fe[d.SymbolKind.Struct]=22,fe[d.SymbolKind.Event]=23,fe[d.SymbolKind.Operator]=24,fe[d.SymbolKind.TypeParameter]=25;function le(Fe){return typeof fe[Fe]=="number"?fe[Fe]:6}Ee.from=le;function Z(Fe){for(const Te in fe)if(fe[Te]===Fe)return Number(Te);return d.SymbolKind.Property}Ee.to=Z})(j=e.SymbolKind||(e.SymbolKind={}));var x;(function(Ee){function fe(Z){switch(Z){case d.SymbolTag.Deprecated:return 1}}Ee.from=fe;function le(Z){switch(Z){case 1:return d.SymbolTag.Deprecated}}Ee.to=le})(x=e.SymbolTag||(e.SymbolTag={}));var W;(function(Ee){function fe(Z){return{name:Z.name,kind:j.from(Z.kind),tags:Z.tags&&Z.tags.map(x.from),containerName:Z.containerName,location:N.from(Z.location)}}Ee.from=fe;function le(Z){const Fe=new d.SymbolInformation(Z.name,j.to(Z.kind),Z.containerName,N.to(Z.location));return Fe.tags=Z.tags&&Z.tags.map(x.to),Fe}Ee.to=le})(W=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(Ee){function fe(Z){var Fe,Te;const Qe={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:w.from(Z.range),selectionRange:w.from(Z.selectionRange),kind:j.from(Z.kind),tags:(Te=(Fe=Z.tags)===null||Fe===void 0?void 0:Fe.map(x.from))!==null&&Te!==void 0?Te:[]};return Z.children&&(Qe.children=Z.children.map(fe)),Qe}Ee.from=fe;function le(Z){const Fe=new d.DocumentSymbol(Z.name,Z.detail,j.to(Z.kind),w.to(Z.range),w.to(Z.selectionRange));return(0,b.isNonEmptyArray)(Z.tags)&&(Fe.tags=Z.tags.map(x.to)),Z.children&&(Fe.children=Z.children.map(le)),Fe}Ee.to=le})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(Ee){function fe(le){const Z=new d.CallHierarchyItem(j.to(le.kind),le.name,le.detail||"",D.URI.revive(le.uri),w.to(le.range),w.to(le.selectionRange));return Z._sessionId=le._sessionId,Z._itemId=le._itemId,Z}Ee.to=fe})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var F;(function(Ee){function fe(le){return new d.CallHierarchyIncomingCall(M.to(le.from),le.fromRanges.map(Z=>w.to(Z)))}Ee.to=fe})(F=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(Ee){function fe(le){return new d.CallHierarchyOutgoingCall(M.to(le.to),le.fromRanges.map(Z=>w.to(Z)))}Ee.to=fe})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var N;(function(Ee){function fe(Z){return{range:Z.range&&w.from(Z.range),uri:Z.uri}}Ee.from=fe;function le(Z){return new d.Location(D.URI.revive(Z.uri),w.to(Z.range))}Ee.to=le})(N=e.location||(e.location={}));var $;(function(Ee){function fe(Z){const Fe=Z,Te=Z;return{originSelectionRange:Fe.originSelectionRange?w.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Te.uri,range:w.from(Fe.targetRange?Fe.targetRange:Te.range),targetSelectionRange:Fe.targetSelectionRange?w.from(Fe.targetSelectionRange):void 0}}Ee.from=fe;function le(Z){return{targetUri:D.URI.revive(Z.uri),targetRange:w.to(Z.range),targetSelectionRange:Z.targetSelectionRange?w.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?w.to(Z.originSelectionRange):void 0}}Ee.to=le})($=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(Ee){function fe(Z){return{range:w.from(Z.range),contents:c.fromMany(Z.contents)}}Ee.from=fe;function le(Z){return new d.Hover(Z.contents.map(c.to),w.to(Z.range))}Ee.to=le})(q=e.Hover||(e.Hover={}));var Q;(function(Ee){function fe(Z){return{range:w.from(Z.range),expression:Z.expression}}Ee.from=fe;function le(Z){return new d.EvaluatableExpression(w.to(Z.range),Z.expression)}Ee.to=le})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var de;(function(Ee){function fe(Z){if(Z instanceof d.InlineValueText)return{type:"text",range:w.from(Z.range),text:Z.text};if(Z instanceof d.InlineValueVariableLookup)return{type:"variable",range:w.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=fe;function le(Z){switch(Z.type){case"text":return{range:w.to(Z.range),text:Z.text};case"variable":return{range:w.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:w.to(Z.range),expression:Z.expression}}}Ee.to=le})(de=e.InlineValue||(e.InlineValue={}));var be;(function(Ee){function fe(Z){return{frameId:Z.frameId,stoppedLocation:w.from(Z.stoppedLocation)}}Ee.from=fe;function le(Z){return new d.InlineValueContext(Z.frameId,w.to(Z.stoppedLocation))}Ee.to=le})(be=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(Ee){function fe(Z){return{range:w.from(Z.range),kind:Z.kind}}Ee.from=fe;function le(Z){return new d.DocumentHighlight(w.to(Z.range),Z.kind)}Ee.to=le})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(Ee){function fe(le){switch(le){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}Ee.to=fe})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(Ee){function fe(le){return{triggerKind:Ce.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}Ee.to=fe})(Le=e.CompletionContext||(e.CompletionContext={}));var H;(function(Ee){function fe(Z){switch(Z){case d.CompletionItemTag.Deprecated:return 1}}Ee.from=fe;function le(Z){switch(Z){case 1:return d.CompletionItemTag.Deprecated}}Ee.to=le})(H=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(Ee){const fe=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function le(Te){var Qe;return(Qe=fe.get(Te))!==null&&Qe!==void 0?Qe:9}Ee.from=le;const Z=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Fe(Te){var Qe;return(Qe=Z.get(Te))!==null&&Qe!==void 0?Qe:d.CompletionItemKind.Property}Ee.to=Fe})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(Ee){function fe(le,Z){var Fe;const Te=new d.CompletionItem(typeof le.label=="string"?le.label:le.label.name);return typeof le.label!="string"&&(Te.label2=le.label),Te.insertText=le.insertText,Te.kind=Y.to(le.kind),Te.tags=(Fe=le.tags)===null||Fe===void 0?void 0:Fe.map(H.to),Te.detail=le.detail,Te.documentation=I.isMarkdownString(le.documentation)?c.to(le.documentation):le.documentation,Te.sortText=le.sortText,Te.filterText=le.filterText,Te.preselect=le.preselect,Te.commitCharacters=le.commitCharacters,k.Range.isIRange(le.range)?Te.range=w.to(le.range):typeof le.range=="object"&&(Te.range={inserting:w.to(le.range.insert),replacing:w.to(le.range.replace)}),Te.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Te.insertText=new d.SnippetString(le.insertText):(Te.insertText=le.insertText,Te.textEdit=Te.range instanceof d.Range?new d.TextEdit(Te.range,Te.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Te.additionalTextEdits=le.additionalTextEdits.map(Qe=>V.to(Qe))),Te.command=Z&&le.command?Z.fromInternal(le.command):void 0,Te}Ee.to=fe})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(Ee){function fe(Z){return{label:Z.label,documentation:Z.documentation?c.fromStrict(Z.documentation):void 0}}Ee.from=fe;function le(Z){return{label:Z.label,documentation:I.isMarkdownString(Z.documentation)?c.to(Z.documentation):Z.documentation}}Ee.to=le})(ae=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(Ee){function fe(Z){return{label:Z.label,documentation:Z.documentation?c.fromStrict(Z.documentation):void 0,parameters:Array.isArray(Z.parameters)?Z.parameters.map(ae.from):[],activeParameter:Z.activeParameter}}Ee.from=fe;function le(Z){return{label:Z.label,documentation:I.isMarkdownString(Z.documentation)?c.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(ae.to):[],activeParameter:Z.activeParameter}}Ee.to=le})(me=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(Ee){function fe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(me.from):[]}}Ee.from=fe;function le(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(me.to):[]}}Ee.to=le})(De=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(Ee){function fe(Z){var Fe;return{text:Z.text,position:m.from(Z.position),kind:we.from((Fe=Z.kind)!==null&&Fe!==void 0?Fe:d.InlayHintKind.Other),whitespaceBefore:Z.whitespaceBefore,whitespaceAfter:Z.whitespaceAfter}}Ee.from=fe;function le(Z){const Fe=new d.InlayHint(Z.text,m.to(Z.position),we.to(Z.kind));return Fe.whitespaceAfter=Z.whitespaceAfter,Fe.whitespaceBefore=Z.whitespaceBefore,Fe}Ee.to=le})(Oe=e.InlayHint||(e.InlayHint={}));var we;(function(Ee){function fe(Z){return Z}Ee.from=fe;function le(Z){return Z}Ee.to=le})(we=e.InlayHintKind||(e.InlayHintKind={}));var Pe;(function(Ee){function fe(Z){return{range:w.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Ee.from=fe;function le(Z){let Fe;if(Z.url)try{Fe=typeof Z.url=="string"?D.URI.parse(Z.url,!0):D.URI.revive(Z.url)}catch(Te){}return new d.DocumentLink(w.to(Z.range),Fe)}Ee.to=le})(Pe=e.DocumentLink||(e.DocumentLink={}));var Re;(function(Ee){function fe(Z){const Fe=new d.ColorPresentation(Z.label);return Z.textEdit&&(Fe.textEdit=V.to(Z.textEdit)),Z.additionalTextEdits&&(Fe.additionalTextEdits=Z.additionalTextEdits.map(Te=>V.to(Te))),Fe}Ee.to=fe;function le(Z){return{label:Z.label,textEdit:Z.textEdit?V.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Fe=>V.from(Fe)):void 0}}Ee.from=le})(Re=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(Ee){function fe(Z){return new d.Color(Z[0],Z[1],Z[2],Z[3])}Ee.to=fe;function le(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Ee.from=le})(Be=e.Color||(e.Color={}));var Se;(function(Ee){function fe(Z){return{range:w.from(Z.range)}}Ee.from=fe;function le(Z){return new d.SelectionRange(w.to(Z.range))}Ee.to=le})(Se=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Ee){function fe(le){switch(le){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}Ee.to=fe})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(Ee){function fe(Z){switch(Z){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=fe;function le(Z){switch(Z){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}Ee.to=le})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(Ee){function fe(Z){if(Z===d.EndOfLine.CRLF)return 1;if(Z===d.EndOfLine.LF)return 0}Ee.from=fe;function le(Z){if(Z===1)return d.EndOfLine.CRLF;if(Z===0)return d.EndOfLine.LF}Ee.to=le})(ie=e.EndOfLine||(e.EndOfLine={}));var _e;(function(Ee){function fe(le){if(typeof le=="object")return le.viewId;switch(le){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=fe})(_e=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(Ee){function fe(le){const Z={start:le.start+1,end:le.end+1};return le.kind&&(Z.kind=ze.from(le.kind)),Z}Ee.from=fe})(Ne=e.FoldingRange||(e.FoldingRange={}));var ze;(function(Ee){function fe(le){if(le)switch(le){case d.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}Ee.from=fe})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(Ee){function fe(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?w.from(le.selection):void 0,override:typeof le.override=="boolean"?C.EditorOverride.DISABLED:void 0}}Ee.from=fe})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Je;(function(Ee){function fe(Z){return Z instanceof d.RelativePattern||typeof Z=="string"?Z:le(Z)?new d.RelativePattern(Z.base,Z.pattern):Z}Ee.from=fe;function le(Z){const Fe=Z;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Je=e.GlobPattern||(e.GlobPattern={}));var K;(function(Ee){function fe(le){if(le){if(Array.isArray(le))return le.map(fe);if(typeof le=="string")return le;{const Z=le;return{language:Z.language,scheme:Z.scheme,pattern:typeof Z.pattern=="undefined"?void 0:Je.from(Z.pattern),exclusive:Z.exclusive}}}else return}Ee.from=fe})(K=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(Ee){function fe(Z){return{start:Z.start,end:Z.end}}Ee.from=fe;function le(Z){return new d.NotebookRange(Z.start,Z.end)}Ee.to=le})(se=e.NotebookRange||(e.NotebookRange={}));var he;(function(Ee){function fe(le){return new d.NotebookCellMetadata().with(Object.assign(Object.assign({},le),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}Ee.to=fe})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var J;(function(Ee){function fe(Z){return Z}Ee.from=fe;function le(Z){return new d.NotebookDocumentMetadata().with(Z)}Ee.to=le})(J=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var te;(function(Ee){function fe(Z){return{startTime:Z.runStartTime,endTime:Z.runEndTime,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Ee.to=fe;function le(Z){return{lastRunSuccess:Z.success,runStartTime:Z.startTime,runEndTime:Z.endTime,executionOrder:Z.executionOrder}}Ee.from=le})(te=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ce;(function(Ee){function fe(Z){switch(Z){case d.NotebookCellKind.Markdown:return g.CellKind.Markdown;case d.NotebookCellKind.Code:default:return g.CellKind.Code}}Ee.from=fe;function le(Z){switch(Z){case g.CellKind.Markdown:return d.NotebookCellKind.Markdown;case g.CellKind.Code:default:return d.NotebookCellKind.Code}}Ee.to=le})(ce=e.NotebookCellKind||(e.NotebookCellKind={}));var ve;(function(Ee){function fe(Z){var Fe;return{cellKind:ce.from(Z.kind),language:Z.language,source:Z.source,metadata:Object.assign(Object.assign({},Z.metadata),te.from((Fe=Z.latestExecutionSummary)!==null&&Fe!==void 0?Fe:{})),outputs:Z.outputs?Z.outputs.map(je.from):[]}}Ee.from=fe;function le(Z){return new d.NotebookCellData(ce.to(Z.cellKind),Z.source,Z.language,Z.outputs?Z.outputs.map(je.to):void 0,Z.metadata?he.to(Z.metadata):void 0)}Ee.to=le})(ve=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(Ee){function fe(Z){return{mime:Z.mime,value:Z.value,metadata:Z.metadata}}Ee.from=fe;function le(Z){return new d.NotebookCellOutputItem(Z.mime,Z.value,Z.metadata)}Ee.to=le})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var je;(function(Ee){function fe(Z){return{outputId:Z.id,outputs:Z.outputs.map(ye.from),metadata:Z.metadata}}Ee.from=fe;function le(Z){const Fe=Z.outputs.map(ye.to);return new d.NotebookCellOutput(Fe,Z.outputId,Z.metadata)}Ee.to=le})(je=e.NotebookCellOutput||(e.NotebookCellOutput={}));var He;(function(Ee){function fe(Te){if(Te!=null){if(Te instanceof d.RelativePattern||typeof Te=="string")return Te;if(Fe(Te))return new d.RelativePattern(Te.base,Te.pattern);if(Z(Te))return{include:Je.from(Te.include)||void 0,exclude:Je.from(Te.exclude)||void 0}}}Ee.from=fe;function le(Te){return typeof Te=="string"?Te:Fe(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}Ee.to=le;function Z(Te){const Qe=Te,Ze=Je.from(Qe.include);if(!(Ze&&Ze instanceof d.RelativePattern||typeof Ze=="string"))return!1;const ct=Je.from(Qe.exclude);return!!(ct&&ct instanceof d.RelativePattern||typeof ct=="string")}function Fe(Te){const Qe=Te;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(He=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var We;(function(Ee){function fe(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?u.from(le.top):void 0}}Ee.from=fe})(We=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(Ee){function fe(le,Z,Fe){const Te=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(Te,Fe),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}Ee.from=fe})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(Ee){function fe(le){var Z,Fe;return{transientOutputs:(Z=le==null?void 0:le.transientOutputs)!==null&&Z!==void 0?Z:!1,transientCellMetadata:Object.assign(Object.assign({},le==null?void 0:le.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Fe=le==null?void 0:le.transientDocumentMetadata)!==null&&Fe!==void 0?Fe:{}}}Ee.from=fe})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(Ee){function fe(Z){var Fe;return{uri:Z.uri,provides:typeof Z.provides=="string"?[Z.provides]:(Fe=Z.provides)!==null&&Fe!==void 0?Fe:[]}}Ee.from=fe;function le(Z){return new d.NotebookKernelPreload(D.URI.revive(Z.uri),Z.provides)}Ee.to=le})(dt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var it;(function(Ee){function fe(Z){return{message:c.fromStrict(Z.message)||"",severity:Z.severity,expectedOutput:Z.expectedOutput,actualOutput:Z.actualOutput,location:Z.location?N.from(Z.location):void 0}}Ee.from=fe;function le(Z){const Fe=new d.TestMessage(typeof Z.message=="string"?Z.message:c.to(Z.message));return Fe.severity=Z.severity,Fe.actualOutput=Z.actualOutput,Fe.expectedOutput=Z.expectedOutput,Fe}Ee.to=le})(it=e.TestMessage||(e.TestMessage={}));var Ye;(function(Ee){function fe(Te){var Qe,Ze;return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range)||null,debuggable:(Qe=Te.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Te.description||null,runnable:(Ze=Te.runnable)!==null&&Ze!==void 0?Ze:!0,error:Te.error&&c.fromStrict(Te.error)||null}}Ee.from=fe;function le(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=le;function Z(Te){return{id:Te.extId,label:Te.label,uri:D.URI.revive(Te.uri),range:w.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:d.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}Ee.toPlain=Z;function Fe(Te){const Qe=new d.TestItemImpl(Te.extId,Te.label,D.URI.revive(Te.uri),void 0);return Qe.range=w.to(Te.range||void 0),Qe.debuggable=Te.debuggable,Qe.description=Te.description||void 0,Qe.runnable=Te.runnable,Qe}Ee.to=Fe})(Ye=e.TestItem||(e.TestItem={}));var mt;(function(Ee){const fe=(Z,Fe)=>Object.assign(Object.assign({},Ye.toPlain(Z.item)),{taskStates:Z.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(it.to)})),children:Z.children.map(Te=>Fe.get(Te)).filter(P.isDefined).map(Te=>fe(Te,Fe))});function le(Z){const Fe=[],Te=new Map;for(const Qe of Z.items)Te.set(Qe.item.extId,Qe),Qe.direct&&Fe.push(Qe);return{completedAt:Z.completedAt,results:Fe.map(Qe=>fe(Qe,Te))}}Ee.to=le})(mt=e.TestResults||(e.TestResults={}));var wt;(function(Ee){function fe(le){switch(le){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}Ee.to=fe})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[215],pe([0,1,2,16,7,20,56]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(k,r,C,f={timeout:1500,errors:3}){this._logService=k,this._documents=r,this._mainThreadBulkEdits=C,this._thresholds=f,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(r,C,f)=>{const a={dispose:this._callbacks.push([r,C,k])};return Array.isArray(f)&&f.push(a),a}}async $participateInSave(k,r){const C=b.URI.revive(k);let f=!1;const g=setTimeout(()=>f=!0,this._thresholds.timeout),a=[];try{for(let d of[...this._callbacks]){if(f)break;const E=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(d,{document:E,reason:A.TextDocumentSaveReason.to(r)});a.push(w)}}finally{clearTimeout(g)}return a}_deliverEventAsyncAndBlameBadListeners([k,r,C],f){const g=this._badListeners.get(k);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,k,r,f).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const d=this._badListeners.get(k);this._badListeners.set(k,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,r,C,f){const g=[],a=Date.now(),{document:d,reason:E}=f,{version:w}=d,S=Object.freeze({document:d,reason:E,waitUntil(m){if(Object.isFrozen(g))throw(0,I.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(m))}});try{r.apply(C,[S])}catch(m){return Promise.reject(m)}return Object.freeze(g),new Promise((m,l)=>{const v=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(v),m(t)}).catch(t=>{clearTimeout(v),l(t)})}).then(m=>{const l={edits:[]};for(const v of m)if(Array.isArray(v)&&v.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:n,range:o}of v)l.edits.push({_type:2,resource:d.uri,edit:{range:o&&A.Range.from(o),text:t,eol:n&&A.EndOfLine.from(n)}});if(l.edits.length!==0)return w===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ge[216],pe([0,1,3,13,33,2,20,7]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(C,f,g,a,d){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,g&&(this._config+=1),a&&(this._config+=2),d&&(this._config+=4);const E=(0,T.parse)(f),w=C(S=>{if(!g)for(let m of S.created){const l=A.URI.revive(m);E(l.fsPath)&&this._onDidCreate.fire(l)}if(!a)for(let m of S.changed){const l=A.URI.revive(m);E(l.fsPath)&&this._onDidChange.fire(l)}if(!d)for(let m of S.deleted){const l=A.URI.revive(m);E(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(C,f,g){this._logService=f,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,f,g,a){return new D(this._onFileSystemEvent.event,C,f,g,a)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,f){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:f.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:f.map(g=>A.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:f.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,f){return(g,a,d)=>{const E=function(S){g.call(a,S)};return E.extension=C,f.event(E,void 0,d)}}async $onWillRunFileOperation(C,f,g,a){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:f.map(d=>({oldUri:A.URI.revive(d.source),newUri:A.URI.revive(d.target)}))},g,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:f.map(d=>A.URI.revive(d.target))},g,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:f.map(d=>A.URI.revive(d.target))},g,a)}}async _fireWillEvent(C,f,g,a){const d=new Set,E=[];if(await C.fireAsync(f,a,async(S,m)=>{var l;const v=Date.now(),t=await Promise.resolve(S);t instanceof P.WorkspaceEdit&&(E.push(t),d.add((l=m.extension.displayName)!==null&&l!==void 0?l:m.extension.identifier.value)),Date.now()-v>g&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),!a.isCancellationRequested&&E.length!==0){const w={edits:[]};for(let S of E){let{edits:m}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(m)}return{edit:w,extensionNames:Array.from(d)}}}}e.ExtHostFileSystemEventService=k}),define(ge[217],pe([0,1,12,24,2,20,7,89]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(f,g,a,d){this.start=f,this.deletedCount=g,this.deletedItems=a,this.items=d}static asApiEvents(f){return f.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(a=>a.apiCell)}))}}class k{constructor(f,g,a){var d;this._notebook=f,this._extHostDocument=g,this._cellData=a,this.handle=a.handle,this.uri=T.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(d=a.metadata)!==null&&d!==void 0?d:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(f,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:f}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const f=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return f._notebook.getCellIndex(f)},notebook:f._notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return f._outputs.slice(0)},get metadata(){return f._metadata},get latestExecutionSummary(){return f._previousResult}})}return this._cell}setOutputs(f){this._outputs=f.map(A.NotebookCellOutput.to)}setOutputItems(f,g,a){const d=a.map(A.NotebookCellOutputItem.to),E=this._outputs.find(w=>w.id===f);E&&(g||(E.outputs.length=0),E.outputs.push(...d))}setMetadata(f){this._internalMetadata=f,this._metadata=A.NotebookCellMetadata.to(f),this._previousResult=A.NotebookCellPreviousExecutionResult.to(f)}}e.ExtHostCell=k;class r{constructor(f,g,a,d,E,w,S){this._proxy=f,this._textDocumentsAndEditors=g,this._textDocuments=a,this._emitter=d,this._viewType=E,this._metadata=w,this.uri=S,this.handle=r._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const f=this;this._notebook={get uri(){return f.uri},get version(){return f._versionId},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===b.Schemas.untitled},get isClosed(){return f._disposed},get metadata(){return f._metadata},get cellCount(){return f._cells.length},cellAt(g){return g=f._validateIndex(g),f._cells[g].apiCell},getCells(g){return(g?f._getCells(g):f._cells).map(d=>d.apiCell)},save(){return f._save()}}}return this._notebook}updateBackup(f){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){f.metadata&&(this._metadata=this._metadata.with(f.metadata))}acceptModelChanged(f,g){this._versionId=f.versionId,this._isDirty=g;for(const a of f.rawEvents)a.kind===P.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===P.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===P.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(a.index,a.metadata)}_validateIndex(f){return f=f|0,f<0?0:f>=this._cells.length?this._cells.length-1:f}_validateRange(f){let g=f.start|0,a=f.end|0;return g<0&&(g=0),a>this._cells.length&&(a=this._cells.length),f.with({start:g,end:a})}_getCells(f){f=this._validateRange(f);const g=[];for(let a=f.start;a<f.end;a++)g.push(this._cells[a]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(f,g){if(!this._disposed){const a=[],d=[],E=[];f.reverse().forEach(w=>{const m=w[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return g||d.push(k.asModelAddData(this.apiNotebook,t)),n}),l=new D(w[0],w[1],[],m),v=this._cells.splice(w[0],w[1],...m);for(let t of v)E.push(t.uri),l.deletedItems.push(t.apiCell);a.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:E}),g||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}}_moveCell(f,g){const a=this._cells.splice(f,1);this._cells.splice(g,0,...a);const d=[new D(f,1,a.map(E=>E.apiCell),[]),new D(g,0,[],a)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(d)}))}_setCellOutputs(f,g){const a=this._cells[f];a.setOutputs(g),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(f,g,a,d){const E=this._cells[f];E.setOutputItems(g,a,d),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(f,g){const a=this._cells[f];a.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(a.uri,g)}_changeCellMetadata(f,g){var a;const d=this._cells[f],E=d.internalMetadata,w=d.apiCell.metadata;d.setMetadata(g);const S=d.apiCell.metadata;if((0,I.equals)(w,S)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:d.apiCell})),E.runState!==g.runState){const m=(a=g.runState)!==null&&a!==void 0?a:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.apiNotebook,cell:d.apiCell,executionState:m}))}}getCellFromIndex(f){return this._cells[f]}getCell(f){return this._cells.find(g=>g.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}}e.ExtHostNotebookDocument=r,r._handlePool=0}),define(ge[218],pe([0,1,7,20]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(P){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=P}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(P){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:P})}replaceCellMetadata(P,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:P,metadata:D})}replaceCells(P,D,k){this._throwIfFinalized(),!(P===D&&k.length===0)&&this._collectedEdits.push({editType:1,index:P,count:D-P,cells:k.map(I.NotebookCellData.from)})}}class A{constructor(P,D,k,r,C,f){this.id=P,this._proxy=D,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=r,this._viewColumn=f}get apiEditor(){if(!this._editor){const P=this;this._editor={get document(){return P.notebookData.apiNotebook},get selections(){return P._selections},get visibleRanges(){return P._visibleRanges},revealRange(D,k){P._proxy.$tryRevealRange(P.id,I.NotebookRange.from(D),k!=null?k:b.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn},edit(D){const k=new T(this.document.version);return D(k),P._applyEdit(k.finalize())},setDecorations(D,k){return P.setDecorations(D,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_acceptViewColumn(P){this._viewColumn=P}_applyEdit(P){if(P.cellEdits.length===0)return Promise.resolve(!0);const D=[];let k=-1;for(let r=0;r<P.cellEdits.length;r++){if(k<0){D.push(P.cellEdits[r]),k++;continue}const f=D[k],g=P.cellEdits[r];if(f.editType===1&&g.editType===1&&f.index===g.index){f.cells.push(...P.cellEdits[r].cells),f.count+=P.cellEdits[r].count;continue}D.push(P.cellEdits[r]),k++}return this._proxy.$tryApplyEdits(this.id,P.documentVersionId,D)}setDecorations(P,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(P.key)))return D.isEmpty?this._hasDecorationsForKey.delete(P.key):this._hasDecorationsForKey.add(P.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(D),P.key)}}e.ExtHostNotebookEditor=A}),define(ge[219],pe([0,1,20,116,163,21,70]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,f,g){const a=this._handles++,{title:d,location:E,cancellable:w}=f,S={label:(0,T.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(a,{location:b.ProgressLocation.from(E),title:d,source:S,cancellable:w},C),this._withProgress(a,g,!!w)}_withProgress(C,f,g){let a;g&&(a=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,a));const d=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),a&&a.dispose()};let E;try{E=f(new k(this._proxy,C),g&&a?a.token:A.CancellationToken.None)}catch(w){throw d(C),w}return E.then(w=>d(C),w=>d(C)),E}$acceptProgressCanceled(C){const f=this._mapHandleToCancellationSource.get(C);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=P;function D(r,C){return r.message=C.message,typeof C.increment=="number"&&(typeof r.increment=="number"?r.increment+=C.increment:r.increment=C.increment),r}class k extends I.Progress{constructor(C,f){super(g=>this.throttledReport(g));this._proxy=C,this._handle=f}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}Ve([(0,y.throttle)(100,(r,C)=>D(r,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(ge[125],pe([0,1,52,16,72,20,7]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(f,g){const a=P._Keys.nextId();f.$registerTextEditorDecorationType(a,A.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:a,dispose(){f.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=P,P._Keys=new T.IdGenerator("TextEditorDecorationType");class D{constructor(f,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=f,this._documentVersionId=f.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(f,g){this._throwIfFinalized();let a=null;if(f instanceof y.Position)a=new y.Range(f,f);else if(f instanceof y.Range)a=f;else throw new Error("Unrecognized location");this._pushEdit(a,g,!1)}insert(f,g){this._throwIfFinalized(),this._pushEdit(new y.Range(f,f),g,!0)}delete(f){this._throwIfFinalized();let g=null;if(f instanceof y.Range)g=f;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(f,g,a){const d=this._document.validateRange(f);this._collectedEdits.push({range:d,text:g,forceMoveMarkers:a})}setEndOfLine(f){if(this._throwIfFinalized(),f!==y.EndOfLine.LF&&f!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=f}}e.TextEditorEdit=D;class k{constructor(f,g,a,d){this._proxy=f,this._id=g,this._accept(a),this._logService=d;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(w){E._setTabSize(w)},get insertSpaces(){return E._insertSpaces},set insertSpaces(w){E._setInsertSpaces(w)},get cursorStyle(){return E._cursorStyle},set cursorStyle(w){E._setCursorStyle(w)},get lineNumbers(){return E._lineNumbers},set lineNumbers(w){E._setLineNumbers(w)}}}_accept(f){this._tabSize=f.tabSize,this._insertSpaces=f.insertSpaces,this._cursorStyle=f.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(f.lineNumbers)}_validateTabSize(f){if(f==="auto")return"auto";if(typeof f=="number"){const g=Math.floor(f);return g>0?g:null}if(typeof f=="string"){const g=parseInt(f,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(f){const g=this._validateTabSize(f);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}_setInsertSpaces(f){const g=this._validateInsertSpaces(f);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(f){this._cursorStyle!==f&&(this._cursorStyle=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:f})))}_setLineNumbers(f){this._lineNumbers!==f&&(this._lineNumbers=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(f)})))}assign(f){const g={};let a=!1;if(typeof f.tabSize!="undefined"){const d=this._validateTabSize(f.tabSize);d==="auto"?(a=!0,g.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,a=!0,g.tabSize=d)}if(typeof f.insertSpaces!="undefined"){const d=this._validateInsertSpaces(f.insertSpaces);d==="auto"?(a=!0,g.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,a=!0,g.insertSpaces=d)}typeof f.cursorStyle!="undefined"&&this._cursorStyle!==f.cursorStyle&&(this._cursorStyle=f.cursorStyle,a=!0,g.cursorStyle=f.cursorStyle),typeof f.lineNumbers!="undefined"&&this._lineNumbers!==f.lineNumbers&&(this._lineNumbers=f.lineNumbers,a=!0,g.lineNumbers=A.TextEditorLineNumbersStyle.from(f.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(f){f.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=k;class r{constructor(f,g,a,d,E,w,S,m){this.id=f,this._proxy=g,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new k(this._proxy,this.id,w,a),this._visibleRanges=S,this._viewColumn=m;const l=this;this.value=Object.freeze({get document(){return d.getValue()},set document(v){throw(0,I.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(v){if(!(v instanceof y.Selection))throw(0,I.illegalArgument)("selection");l._selections=[v],l._trySetSelection()},get selections(){return l._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof y.Selection)))throw(0,I.illegalArgument)("selections");l._selections=v,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(v){throw(0,I.readonly)("visibleRanges")},get options(){return l._options.value},set options(v){l._disposed||l._options.assign(v)},get viewColumn(){return l._viewColumn},set viewColumn(v){throw(0,I.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(d.getValue(),t);return v(n),l._applyEdit(n)},insertSnippet(v,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=l._selections.map(i=>A.Range.from(i));else if(t instanceof y.Position){const{lineNumber:i,column:s}=A.Position.from(t);o=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(t instanceof y.Range)o=[A.Range.from(t)];else{o=[];for(const i of t)if(i instanceof y.Range)o.push(A.Range.from(i));else{const{lineNumber:s,column:c}=A.Position.from(i);o.push({startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c})}}return g.$tryInsertSnippet(f,v.value,o,n)},setDecorations(v,t){const n=t.length===0;n&&!l._hasDecorationsForKey.has(v.key)||(n?l._hasDecorationsForKey.delete(v.key):l._hasDecorationsForKey.add(v.key),l._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return g.$trySetDecorations(f,v.key,A.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let i=0,s=t.length;i<s;i++){const c=t[i];o[4*i]=c.start.line+1,o[4*i+1]=c.start.character+1,o[4*i+2]=c.end.line+1,o[4*i+3]=c.end.character+1}return g.$trySetDecorationsFast(f,v.key,o)}}))},revealRange(v,t){l._runOnProxy(()=>g.$tryRevealRange(f,A.Range.from(v),t||y.TextEditorRevealType.Default))},show(v){g.$tryShowEditor(f,A.ViewColumn.from(v))},hide(){g.$tryHideEditor(f)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(f){(0,b.ok)(!this._disposed),this._options._accept(f)}_acceptVisibleRanges(f){(0,b.ok)(!this._disposed),this._visibleRanges=f}_acceptViewColumn(f){(0,b.ok)(!this._disposed),this._viewColumn=f}_acceptSelections(f){(0,b.ok)(!this._disposed),this._selections=f}async _trySetSelection(){const f=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,f)),this.value}_applyEdit(f){const g=f.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const a=g.edits.map(E=>E.range);a.sort((E,w)=>E.end.line===w.end.line?E.end.character===w.end.character?E.start.line===w.start.line?E.start.character-w.start.character:E.start.line-w.start.line:E.end.character-w.end.character:E.end.line-w.end.line);for(let E=0,w=a.length-1;E<w;E++){const S=a[E].end;if(a[E+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=g.edits.map(E=>({range:A.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,d,{setEndOfLine:typeof g.setEndOfLine=="number"?A.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(f){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=r}),define(ge[220],pe([0,1,166,25,2,3,6,13,7,11,17,20,21]),function(G,e,b,I,T,A,y,P,D,k,r,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(E,w){if((0,k.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let S;return Array.isArray(E.highlights)&&(S=E.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),S=S.length?S:void 0),{label:E.label,highlights:S}}}class a{constructor(w,S,m){this._proxy=w,this.commands=S,this.logService=m,this.treeViews=new Map;function l(v){return v&&v.$treeViewId&&v.$treeItemHandle}S.registerArgumentProcessor({processArgument:v=>l(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(t=>l(t)?this.convertArgument(t):t):v})}registerTreeDataProvider(w,S,m){const l=this.createTreeView(w,{treeDataProvider:S},m);return{dispose:()=>l.dispose()}}createTreeView(w,S,m){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,canDragAndDrop:!!S.canDragAndDrop}),v=this.createExtHostTreeView(w,S,m);return{get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get message(){return v.message},set message(t){v.message=t},get title(){return v.title},set title(t){v.title=t},get description(){return v.description},set description(t){v.description=t},reveal:(t,n)=>v.reveal(t,n),dispose:async()=>{await l,this.treeViews.delete(w),v.dispose()}}}$getChildren(w,S){const m=this.treeViews.get(w);return m?m.getChildren(S):Promise.reject(new Error((0,b.localize)(0,null,w)))}$setParent(w,S,m){const l=this.treeViews.get(w);return l?l.setParent(S,m):Promise.reject(new Error((0,b.localize)(1,null,w)))}async $hasResolve(w){const S=this.treeViews.get(w);if(!S)throw new Error((0,b.localize)(2,null,w));return S.hasResolve}$resolve(w,S,m){const l=this.treeViews.get(w);if(!l)throw new Error((0,b.localize)(3,null,w));return l.resolveTreeItem(S,m)}$setExpanded(w,S,m){const l=this.treeViews.get(w);if(!l)throw new Error((0,b.localize)(4,null,w));l.setExpanded(S,m)}$setSelection(w,S){const m=this.treeViews.get(w);if(!m)throw new Error((0,b.localize)(5,null,w));m.setSelection(S)}$setVisible(w,S){const m=this.treeViews.get(w);if(!m)throw new Error((0,b.localize)(6,null,w));m.setVisible(S)}createExtHostTreeView(w,S,m){const l=new d(w,S,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(w,l),l}convertArgument(w){const S=this.treeViews.get(w.$treeViewId);return S?S.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=a;class d extends y.Disposable{constructor(w,S,m,l,v,t){super();if(this.viewId=w,this.proxy=m,this.commands=l,this.logService=v,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,t.contributes&&t.contributes.views)for(const i in t.contributes.views)for(const s of t.contributes.views[i])s.id===w&&(this._title=s.name);this.dataProvider=S.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let n,o;this._register(A.Event.debounce(this._onDidChangeData.event,(i,s)=>(i||(i={message:!1,elements:[]}),s.element!==!1&&(n||(n=new Promise(c=>o=c),this.refreshPromise=this.refreshPromise.then(()=>n)),i.elements.push(s.element)),s.message&&(i.message=!0),i),200,!0)(({message:i,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=o;return n=null,this.refresh(s).then(()=>c())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,k.isUndefinedOrNull)(w))}getChildren(w){const S=w?this.getExtensionElement(w):void 0;if(w&&!S)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const m=this.getChildrenNodes(w);return(m?Promise.resolve(m):this.fetchChildrenNodes(S)).then(l=>l.map(v=>v.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,S){S=S||{select:!0,focus:!1};const m=(0,k.isUndefinedOrNull)(S.select)?!0:S.select,l=(0,k.isUndefinedOrNull)(S.focus)?!1:S.focus,v=(0,k.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(o=>o.item)},{select:m,focus:l,expand:v})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:l,expand:v})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,S){const m=this.getExtensionElement(w);m&&(S?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(w){(0,r.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}setParent(w,S){const m=w.map(v=>this.getExtensionElement(v)).filter(v=>!(0,k.isUndefinedOrNull)(v)),l=this.getExtensionElement(S);return this.dataProvider.setParent&&m&&l?(0,P.asPromise)(()=>this.dataProvider.setParent(m,l)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,S){var m;if(!!this.dataProvider.resolveTreeItem){const l=this.elements.get(w);if(l){const v=this.nodes.get(l);if(v){const t=(m=await this.dataProvider.resolveTreeItem(v.extensionItem,l,S))!==null&&m!==void 0?m:v.extensionItem;return v.item.tooltip=this.getTooltip(t.tooltip),v.item.command=this.getCommand(v.disposableStore,t.command),v.item}}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(S=>S?this.resolveUnknownParentChain(S).then(m=>this.resolveTreeNode(S,m[m.length-1]).then(l=>(m.push(l),m))):Promise.resolve([]))}resolveParent(w){const S=this.nodes.get(w);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,S){const m=this.nodes.get(w);return m?Promise.resolve(m):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(l=>this.createHandle(w,l,S,!0)).then(l=>this.getChildren(S?S.item.handle:void 0).then(()=>{const v=this.getExtensionElement(l);if(v){const t=this.nodes.get(v);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(w){if(w){let S;if(typeof w=="string"){const m=this.getExtensionElement(w);S=m?this.nodes.get(m):void 0}else S=w;return S&&S.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const S=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=w?this.nodes.get(w):void 0,l=await this.dataProvider.getChildren(w);if(S.token.isCancellationRequested)return[];const v=await Promise.all((0,r.coalesce)(l||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,m):null}));return S.token.isCancellationRequested?[]:(0,r.coalesce)(v)}finally{S.dispose()}}refresh(w){if(w.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(w);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const S=new Set,m=w.map(v=>this.nodes.get(v));for(const v of m)if(v&&!S.has(v.item.handle)){let t=v;for(;t&&t.parent&&m.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(v.item.handle)}const l=[];return S.forEach(v=>{const t=this.elements.get(v);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&l.push(v)}}),l}refreshHandles(w){const S={};return Promise.all(w.map(m=>this.refreshNode(m).then(l=>{l&&(S[m]=l.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(w){const S=this.getExtensionElement(w);if(S){const m=this.nodes.get(S);if(m)return this.clearChildren(S),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(l=>{if(l){const v=this.createTreeNode(S,l,m.parent);return this.updateNodeCache(S,v,m,m.parent),m.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,S,m){const l=this.createTreeNode(w,S,m);if(S.id&&this.elements.has(l.item.handle))throw new Error((0,b.localize)(7,null,S.id));return this.addNodeToCache(w,l),this.addNodeToParentCache(l,m),l}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?C.MarkdownString.from(w):w}getCommand(w,S){return S?this.commands.toInternal(S,w):void 0}createTreeNode(w,S,m){const l=new y.DisposableStore,v=this.createHandle(w,S,m),t=this.getLightIconPath(S);return{item:{handle:v,parentHandle:m?m.item.handle:void 0,label:g(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(l,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:(0,k.isUndefinedOrNull)(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:m,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:S,label:m,resourceUri:l},v,t){if(S)return`${d.ID_HANDLE_PREFIX}/${S}`;const n=g(m,this.extension),o=v?v.item.handle:d.LABEL_HANDLE_PREFIX;let i=n?n.label:l?(0,I.basename)(l):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const s=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,c=this.getChildrenNodes(v)||[];let h,_=0;do{if(h=`${o}/${_}:${i}`,t||!this.elements.has(h)||s===h)break;_++}while(_<=c.length);return h}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||T.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return T.URI.isUri(w)?w:T.URI.file(w)}addNodeToCache(w,S){this.elements.set(S.item.handle,w),this.nodes.set(w,S)}updateNodeCache(w,S,m,l){this.elements.delete(S.item.handle),this.nodes.delete(w),S.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(w,S);const v=this.getChildrenNodes(l)||[],t=v.filter(n=>n.item.handle===m.item.handle)[0];t&&v.splice(v.indexOf(t),1,S)}addNodeToParentCache(w,S){S?(S.children||(S.children=[]),S.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const S=this.nodes.get(w);if(S){if(S.children)for(const m of S.children){const l=this.elements.get(m.item.handle);l&&this.clear(l)}S.children=void 0}}else this.clearAll()}clear(w){const S=this.nodes.get(w);if(S){if(S.children)for(const m of S.children){const l=this.elements.get(m.item.handle);l&&this.clear(l)}this.nodes.delete(w),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(ge[221],pe([0,1,17,13,21,11,87,20,7,124]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class r{constructor(){this.testIdsToInternal=new Map}getTestById(E,w){if(w!==void 0){const S=this.testIdsToInternal.get(w),m=S==null?void 0:S.get(E);if(m)return[S,m]}return(0,b.mapFind)(this.testIdsToInternal.values(),S=>{const m=S.get(E);return m&&[S,m]})}createForHierarchy(E=()=>{}){return new a(this.createIdMap(f++),E)}createIdMap(E){const w=new g(E);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=r;var C;(function(d){d[d.Disconnected=0]="Disconnected",d[d.IsChild=1]="IsChild",d[d.IsParent=2]="IsParent",d[d.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));let f=0;class g{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const w=this.map.get(E);return w?(this.map.delete(E),this._roots.delete(w),!0):!1}get(E){return this.map.get(E)}comparePositions(E,w){const S=typeof E=="string"?this.map.get(E):E,m=typeof w=="string"?this.map.get(w):w;if(!S||!m)return 0;if(S===m)return 3;for(let l=this.map.get(m.parent);l;l=this.map.get(l.parent))if(l===S)return 1;for(let l=this.map.get(S.parent);l;l=this.map.get(l.parent))if(l===m)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class a{constructor(E,w){this.testIdToInternal=E,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,w){this.addItem(E,w,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const w=this.diff[this.diff.length-1];if(w&&E[0]===1){if(w[0]===1&&w[1].extId===E[1].extId){(0,k.applyTestItemUpdate)(w[1],E[1]);return}if(w[0]===0&&w[1].item.extId===E[1].extId){(0,k.applyTestItemUpdate)(w[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,w){var S;const m=this.testIdToInternal.object.get(E);if(!!m){if((m.expandLevels===void 0||w>m.expandLevels)&&(m.expandLevels=w),m.expand===1){const l=this.refreshChildren(m);return l.isSettled?this.expandChildren(m,w-1):l.p.then(()=>this.expandChildren(m,w-1))}else if(m.expand===3)return((S=m.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?m.initialExpand.p.then(()=>this.expandChildren(m,w-1)):this.expandChildren(m,w-1)}}dispose(){var E;for(const w of this.testItemToInternal.values())(E=w.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,w){const S=E==null?void 0:E.actual.id;switch(w[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(E);break;case 0:this.addItem(w[1],E.src.controller,E);break;case 3:const[m,l,v]=w;switch(l){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:S,item:{range:P.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:P.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[l]:v!=null?v:null}}]);break}break;default:(0,A.assertNever)(w[0])}}addItem(E,w,S){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const m=S?S.item.extId:null,l=E.resolveHandler?1:0,v=S?S.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:E,parent:m,item:P.TestItem.from(E),expandLevels:v?v-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:m,src:t,expand:l,item:n.item}]);const o=(0,y.getPrivateApiFor)(E);o.parent=S==null?void 0:S.actual,o.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const i of o.children.values())this.testItemToInternal.has(i)||this.addItem(i,w,n)}updateExpandability(E){var w;let S;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?S=E.discoverCts?2:1:((w=E.initialExpand)===null||w===void 0||w.complete(),S=3):S=0,S!==E.expand&&(E.expand=S,this.pushDiff([1,{extId:E.actual.id,expand:S}]),S===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,w){if(!(w<0)){const S=[...E.actual.children.values()].map(m=>this.expand(m.id,w)).filter(I.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const w=new I.DeferredPromise;return w.complete(),w}return E.expand=2,E.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new I.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var w;this.pushDiff([2,E.actual.id]);const S=[E];for(;S.length;){const m=S.pop();if(!!m){(w=m.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(m.item.extId),this.testItemToInternal.delete(m.actual);for(const l of m.actual.children.values())S.push(this.testIdToInternal.object.get(l.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=a}),define(ge[222],pe([0,1,27,3,8]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=A;class y{constructor(r){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(r.identifier))){console.error("Extension `"+r.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(r.identifier),r),this._extensionsArr.push(r),Array.isArray(r.activationEvents))for(let C of r.activationEvents)C==="onUri"&&(C=`onUri:${b.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(r)}}keepOnly(r){const C=new Set;r.forEach(f=>C.add(b.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>C.has(b.ExtensionIdentifier.toKey(f.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(r,C){r.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(r));const f=y._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(f.map(g=>g.identifier)),C.length>0){const g=new Set;C.forEach(a=>g.add(b.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!g.has(b.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(f)}static _findLoopingExtensions(r){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,w){this.addNode(E),this.addNode(w),this._arcs.has(E)?this._arcs.get(E).push(w):this._arcs.set(E,[w])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,w){const S=C.getArcs(E);for(let m=0;m<S.length;m++)if(!w.has(S[m]))return!1;return!0}getNodes(){return this._nodesArr}};let f=new Map;for(let E of r){const w=b.ExtensionIdentifier.toKey(E.identifier);if(f.set(w,E),E.extensionDependencies)for(let S of E.extensionDependencies){const m=b.ExtensionIdentifier.toKey(S);C.addArc(w,m)}}let g=new Set;C.getNodes().filter(E=>C.getArcs(E).length===0).forEach(E=>g.add(E));let a=C.getNodes().filter(E=>!g.has(E)),d;do{d=!1;for(let E=0;E<a.length;E++){const w=a[E];C.hasOnlyGoodArcs(w,g)&&(a.splice(E,1),E--,g.add(w),d=!0)}}while(d);return a.map(E=>f.get(E))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(r))}getExtensionDescriptionsForActivationEvent(r){const C=this._activationMap.get(r);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(r){const C=this._extensionsMap.get(b.ExtensionIdentifier.toKey(r));return C||void 0}}e.ExtensionDescriptionRegistry=y;var P;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(P||(P={}));function D(k,r){const C=k.isBuiltin?0:k.isUnderDevelopment?2:1,f=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(C!==f)return C-f;const g=T.posix.basename(k.extensionLocation.path),a=T.posix.basename(r.extensionLocation.path);return g<a?-1:g>a?1:0}}),define(ge[223],pe([0,1,23]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function A(P){const D=b.VSBuffer.alloc(1);switch(P){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function y(P,D){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(ge[41],pe([0,1,3,2,4,27,183]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class P{constructor(S){this.dependency=S}}e.MissingExtensionDependency=P;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(S,m,l,v){this.codeLoadingTime=S,this.activateCallTime=m,this.activateResolvedTime=l,this.activationReason=v}}e.ActivationTimes=k;class r{constructor(S,m){this.description=S,this.value=m}}e.ExtensionPointContribution=r,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function f(w){w.enableProposedApi||g(w)}e.checkProposedApiEnabled=f;function g(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=g;function a(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=a;function d(w){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=d;class E{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,m){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,m,l,v,t){}_onDidActivateExtensionError(S,m){}_onExtensionRuntimeError(S,m){}_onExtensionHostExit(S){}}e.NullExtensionService=E}),define(ge[224],pe([0,1,27,41,14]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class y{constructor(a,d,E,w){this.startup=a,this.codeLoadingTime=d,this.activateCallTime=E,this.activateResolvedTime=w}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class P{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,d){return a===-1||d===-1?-1:d-a}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class D{constructor(a,d,E,w,S,m){this.activationFailed=a,this.activationFailedError=d,this.activationTimes=E,this.module=w,this.exports=S,this.subscriptions=m}}e.ActivatedExtension=D;class k extends D{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class r extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=r;class C extends D{constructor(a){super(!0,a,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=C;let f=class{constructor(a,d,E,w,S){this._logService=S,this._registry=a,this._resolvedExtensionsSet=new Set,d.forEach(m=>this._resolvedExtensionsSet.add(b.ExtensionIdentifier.toKey(m))),this._hostExtensionsMap=new Map,E.forEach(m=>this._hostExtensionsMap.set(b.ExtensionIdentifier.toKey(m),m)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const d=b.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(d)}getActivatedExtension(a){const d=b.ExtensionIdentifier.toKey(a),E=this._activatedExtensions.get(d);if(!E)throw new Error("Extension `"+a.value+"` is not known or not activated");return E}activateByEvent(a,d){if(this._alreadyActivatedEvents[a])return A;const E=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(E.map(w=>({id:w.identifier,reason:{startup:d,extensionId:w.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,d){const E=this._registry.getExtensionDescription(a);if(!E)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:E.identifier,reason:d}])}_handleActivateRequest(a,d,E){if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(a.id))){d[b.ExtensionIdentifier.toKey(a.id)]=a;return}const w=this._registry.getExtensionDescription(a.id);if(!w){const l=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,l,new I.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(a.id),new C(l));return}const S=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let m=!0;for(let l=0,v=S.length;l<v;l++){const t=S[l];if(!this._resolvedExtensionsSet.has(b.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(b.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const c=w.displayName||w.identifier.value,h=this._registry.getExtensionDescription(t),_=h&&h.displayName||t,u=new Error(`Cannot activate the '${c}' extension because its dependency '${_}' failed to activate`);u.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,u,null),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(w.identifier),new C(u));return}if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(t))){m=!1,d[b.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(b.ExtensionIdentifier.toKey(t)),reason:a.reason};continue}const o=this._registry.getExtensionDescription(t);if(o){m=!1,d[b.ExtensionIdentifier.toKey(t)]={id:o.identifier,reason:a.reason};continue}const i=w.displayName||w.identifier.value,s=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,s,new I.MissingExtensionDependency(t)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(w.identifier),new C(s));return}}}m?d[b.ExtensionIdentifier.toKey(w.identifier)]=a:E.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(S=>!this._activatedExtensions.has(b.ExtensionIdentifier.toKey(S.id))),a.length===0))return Promise.resolve(void 0);const d=Object.create(null),E=[];for(let S=0,m=a.length;S<m;S++)this._handleActivateRequest(a[S],d,E);for(let S=0,m=E.length;S<m;S++){const l=b.ExtensionIdentifier.toKey(E[S].id);d[l]&&delete d[l]}const w=Object.keys(d).map(S=>d[S]);return E.length===0?Promise.all(w.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(w).then(S=>this._activateExtensions(E))}_activateExtension(a,d){const E=b.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const w=this._activatingExtensions.get(E);if(w)return w;const S=this._host.actualActivateExtension(a,d).then(void 0,m=>{const l=new Error;return m&&m.name&&(l.name=m.name),m&&m.message?l.message=`Activating extension '${a.value}' failed: ${m.message}.`:l.message=`Activating extension '${a.value}' failed: ${m}.`,m&&m.stack&&(l.stack=m.stack),this._host.onExtensionActivationError(a,l,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(m),new C(m)}).then(m=>{this._activatedExtensions.set(E,m),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,S),S}};f=Ve([xe(4,T.ILogService)],f),e.ExtensionsActivator=f}),define(ge[225],pe([0,1,14,41,28,12,114]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends b.LogService{constructor(k){if(k.logFile.scheme!==A.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(I.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};P=Ve([xe(0,T.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(ge[226],pe([0,1,16]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,y)=>{this._actualOk=A,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,b.onUnexpectedError)(A))}then(A,y){return this._ensureActual().then(A,y)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=I}),define(ge[126],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(D,k){this.isMain=D,this.sid=k,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const I=[];function T(P){const D=new b(!0,P);return I[D.nid]=D,D}e.createMainContextProxyIdentifier=T;function A(P){const D=new b(!1,P);return I[D.nid]=D,D}e.createExtHostContextProxyIdentifier=A;function y(P){return I[P].sid}e.getStringIdentifierForProxy=y}),define(ge[5],pe([0,1,2,126,58]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(k=e.CellKind||(e.CellKind={}));var r;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(r=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var f;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(f=e.CandidatePortSource||(e.CandidatePortSource={}));var g;(function(l){l.name="$ident";function v(n,o){return Object.defineProperty(n,l.name,{value:o,enumerable:!0}),n}l.mixin=v;function t(n){return n[l.name]}l.of=t})(g=e.ObjectIdentifier||(e.ObjectIdentifier={}));class a{static mixin(v){return v._id=a._n++,v}}e.IdObject=a,a._n=0;var d;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(l){if(l&&l.edits)for(const v of l.edits)typeof v.resource=="object"?v.resource=b.URI.revive(v.resource):(v.newUri=b.URI.revive(v.newUri),v.oldUri=b.URI.revive(v.oldUri)),v.metadata&&v.metadata.iconPath&&(v.metadata=(0,T.revive)(v.metadata));return l}e.reviveWorkspaceEditDto=S;var m;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[90],pe([0,1,5,3,4]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,D){return this._proxy.$getPassword(P,D)}store(P,D,k){return this._proxy.$setPassword(P,D,k)}delete(P,D){return this._proxy.$deletePassword(P,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(ge[63],pe([0,1,4,14,5,15]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(T.MainContext.MainThreadTelemetry)}report(D,k,r){const C=this.getUsageKey(D,k);this._reportedUsages.has(C)||(this._reportedUsages.add(C),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${r}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:D}))}getUsageKey(D,k){return`${D}-${k.identifier.value}`}};y=Ve([xe(0,A.IExtHostRpcService),xe(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(P,D,k){}})}),define(ge[227],pe([0,1,3,5,7,27]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,k,r,C={}){const f=A.ExtensionIdentifier.toKey(D.identifier),g=this._inFlightRequests.get(f)||[],a=r.sort().join(" ");let d=g.find(E=>E.scopes===a);if(d)return d.result;{const E=this._getSession(D,f,k,r,C);d={scopes:a,result:E},g.push(d),this._inFlightRequests.set(f,g);try{await E}finally{const w=g.findIndex(S=>S.scopes===a);w>-1&&(g.splice(w),this._inFlightRequests.set(f,g))}return E}}async _getSession(D,k,r,C,f={}){await this._proxy.$ensureProvider(r);const g=D.displayName||D.name;return this._proxy.$getSession(r,C,k,g,f)}async removeSession(D,k){const r=this._authenticationProviders.get(D);return r?r.provider.removeSession(k):this._proxy.$removeSession(D,k)}registerAuthenticationProvider(D,k,r,C){var f;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:k,provider:r,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:k});const g=r.onDidChangeSessions(a=>{var d,E,w;this._proxy.$sendDidChangeSessions(D,{added:(d=a.added)!==null&&d!==void 0?d:[],changed:(E=a.changed)!==null&&E!==void 0?E:[],removed:(w=a.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,k,(f=C==null?void 0:C.supportsMultipleAccounts)!==null&&f!==void 0?f:!1),new T.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(d=>d.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,k){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,k){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,k){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,k){return this._onDidChangeSessions.fire({provider:{id:D,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,k){return D.forEach(r=>{this._providers.some(C=>C.id===r.id)||this._providers.push(r)}),k.forEach(r=>{const C=this._providers.findIndex(f=>f.id===r.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ge[228],pe([0,1,5,15,20]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,D){this._extHostDocumentsAndEditors=D,this._proxy=P.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const D=T.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=Ve([xe(0,I.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ge[229],pe([0,1,5]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(A){const y=A.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(P){return y.$writeText(P)}})}}e.ExtHostClipboard=I}),define(ge[51],pe([0,1,11,7,20,24,5,17,14,58,44,49,2,6,4,15]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,o=>{const i=this._apiCommands.get(o);return(i==null?void 0:i.result)===m.Void?i:void 0},n),this._argumentProcessors=[{processArgument(o){return(0,k.revive)(o)}},{processArgument(o){return(0,A.cloneAndChange)(o,function(i){if(r.Range.isIRange(i))return T.Range.to(i);if(C.Position.isIPosition(i))return T.Position.to(i);if(r.Range.isIRange(i.range)&&f.URI.isUri(i.uri))return T.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...o)=>{const i=t.args.map((c,h)=>{if(!c.validate(o[h]))throw new Error(`Invalid argument '${c.name}' when running '${t.id}', received: ${o[h]}`);return c.convert(o[h])}),s=await this.executeCommand(t.internalId,...i);return t.result.convert(s,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,o,i,s){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:o,thisArg:i,description:s}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,o){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const i=(0,A.cloneAndChange)(n,function(s){if(s instanceof I.Position)return T.Position.from(s);if(s instanceof I.Range)return T.Range.from(s);if(s instanceof I.Location)return T.location.from(s);if(I.NotebookRange.isNotebookRange(s))return T.NotebookRange.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(t,i,o);return(0,k.revive)(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw s}}}async _executeContributedCommand(t,n){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:i,thisArg:s,description:c}=o;if(c)for(let h=0;h<c.args.length;h++)try{(0,b.validateConstraint)(n[h],c.args[h].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${c.args[h].name}' - ${c.args[h].description}`)}try{return await i.apply(s,n)}catch(h){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...n);_&&(t=_.command)}throw this._logService.error(h,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(o=>this._argumentProcessors.reduce((i,s)=>s.processArgument(i),o)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(o=>o[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,o]of this._commands){let{description:i}=o;i&&(t[n]=i)}return Promise.resolve(t)}};E=Ve([xe(0,d.IExtHostRpcService),xe(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class w{constructor(t,n,o){this._commands=t,this._lookupApiCommand=n,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const i=this._lookupApiCommand(t.command);if(i)o.id=i.internalId,o.arguments=i.args.map((s,c)=>s.convert(t.arguments&&t.arguments[c]));else if((0,P.isNonEmptyArray)(t.arguments)){const s=++this._cachIdPool;this._cache.set(s,t),n.add((0,g.toDisposable)(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),o.$ident=s,o.id=this.delegatingCommandId,o.arguments=[s],this._logService.trace("CommandsConverter#CREATE",t.command,s)}return o}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class S{constructor(t,n,o,i){this.name=t,this.description=n,this.validate=o,this.convert=i}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",v=>f.URI.isUri(v),v=>v),S.Position=new S("position","A position in a text document",v=>I.Position.isPosition(v),T.Position.from),S.Range=new S("range","A range in a text document",v=>I.Range.isRange(v),T.Range.from),S.Selection=new S("selection","A selection in a text document",v=>I.Selection.isSelection(v),T.Selection.from),S.Number=new S("number","",v=>typeof v=="number",v=>v),S.String=new S("string","",v=>typeof v=="string",v=>v),S.CallHierarchyItem=new S("item","A call hierarchy item",v=>v instanceof I.CallHierarchyItem,T.CallHierarchyItem.to);class m{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=m,m.Void=new m("no result",v=>v);class l{constructor(t,n,o,i,s){this.id=t,this.internalId=n,this.description=o,this.args=i,this.result=s}}e.ApiCommand=l}),define(ge[230],pe([0,1,6,20,7,80,51,204,17,111]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const r=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",f(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,d)=>{if(!(0,D.isFalsyOrEmpty)(a)){class E extends T.SymbolInformation{static to(S){const m=new E(S.name,I.SymbolKind.to(S.kind),S.containerName||"",new T.Location(d[0],I.Range.to(S.range)));return m.detail=S.detail,m.range=m.location.range,m.selectionRange=I.Range.to(S.selectionRange),m.children=S.children?S.children.map(E.to):[],m}}return a.map(E.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",f(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",f(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(d=>T.Position.isPosition(d)),a=>a.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(d=>{let E;for(const w of d.reverse())E=new T.SelectionRange(I.Range.to(w),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const d=[];if(Array.isArray(a))for(let E of a)d.push(...E[1].map(I.WorkspaceSymbol.to));return d})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return I.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new T.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const d=(0,k.decodeSemanticTokensDto)(a);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new T.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const d=(0,k.decodeSemanticTokensDto)(a);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,d,E)=>{if(!a)return new T.CompletionList([]);const w=a.suggestions.map(S=>I.CompletionItem.to(S,E));return new T.CompletionList(w,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return I.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,d,E)=>f(w=>new T.CodeLens(I.Range.to(w.range),w.command&&E.fromInternal(w.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>T.Range.isRange(a),a=>T.Selection.isSelection(a)?I.Selection.from(a):I.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,d,E)=>f(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(w.command)}else{const S=new T.CodeAction(w.title,w.kind?new T.CodeActionKind(w.kind):void 0);return w.edit&&(S.edit=I.WorkspaceEdit.to(w.edit)),w.command&&(S.command=E.fromInternal(w.command)),S.isPreferred=w.isPreferred,S}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(d=>new T.ColorInformation(I.Range.to(d.range),I.Color.to(d.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof T.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:I.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(I.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",f(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(d=>I.NotebookExclusiveDocumentPattern.to(d))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class C{constructor(d){this._disposables=new b.DisposableStore,this._commands=d}static register(d){return r.forEach(d.registerApiCommand,d),new C(d).registerCommands()}registerCommands(){const d=E=>(...w)=>E(this._commands,...w);this._register(P.RemoveFromRecentlyOpenedAPICommand.ID,d(P.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]}),this._register(P.OpenIssueReporter.ID,d(P.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:E=>typeof E=="string"||typeof E=="object"&&typeof E.extensionId=="string"}]})}_register(d,E,w){const S=this._commands.registerCommand(!1,d,E,this,w);this._disposables.add(S)}}e.ExtHostApiCommands=C;function f(a){return d=>{if(Array.isArray(d))return d.map(a)}}function g(a){if(!!Array.isArray(a)){const d=[];for(const E of a)A.isLocationLink(E)?d.push(I.DefinitionLink.to(E)):d.push(I.location.to(E));return d}}}),define(ge[231],pe([0,1,13,70,3,6,2,80,27,20,7,5]),function(G,e,b,I,T,A,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class f{constructor(l,v,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=l.getProxy(C.MainContext.MainThreadComments),v.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const o=this._commentControllers.get(n.handle);return o||n}else if(n&&n.$mid===7){const o=this._commentControllers.get(n.commentControlHandle);if(!o)return n;const i=o.getCommentThread(n.commentThreadHandle);return i||n}else if(n&&n.$mid===8){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const i=o.getCommentThread(n.thread.commentThreadHandle);return i?{thread:i,text:n.text}:n}else if(n&&n.$mid===9){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const i=o.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let s=n.commentUniqueId,c=i.getCommentByUniqueId(s);return c||n}else if(n&&n.$mid===10){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const i=o.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let s=n.text,c=n.commentUniqueId,h=i.getCommentByUniqueId(c);return h?(h.body=s,h):n}return n}})}createCommentController(l,v,t){const n=f.handlePool++,o=new a(l,n,this._proxy,v,t);this._commentControllers.set(o.handle,o);const i=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(l.identifier))||[];return i.push(o),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(l.identifier),i),o}$createCommentThreadTemplate(l,v,t){const n=this._commentControllers.get(l);!n||n.$createCommentThreadTemplate(v,t)}async $updateCommentThreadTemplate(l,v,t){const n=this._commentControllers.get(l);!n||n.$updateCommentThreadTemplate(v,t)}$deleteCommentThread(l,v){const t=this._commentControllers.get(l);t&&t.$deleteCommentThread(v)}$provideCommentingRanges(l,v,t){const n=this._commentControllers.get(l);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(y.URI.revive(v));return(0,b.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(o,t)).then(i=>i?i.map(s=>k.Range.from(s)):void 0)}$toggleReaction(l,v,t,n,o){const i=this._commentControllers.get(l);return!i||!i.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const s=i.getCommentThread(v);if(s){const c=s.getCommentByUniqueId(n.uniqueIdInThread);if(i!==void 0&&c&&i.reactionHandler)return i.reactionHandler(c,w(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=f,f.handlePool=0;class g{constructor(l,v,t,n,o,i,s){this._proxy=l,this._commentController=v,this._id=t,this._uri=n,this._range=o,this._comments=i,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${v.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=i}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const l=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),v={};l("range")&&(v.range=k.Range.from(this._range)),l("label")&&(v.label=this.label),l("contextValue")&&(v.contextValue=this.contextValue),l("comments")&&(v.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),l("collapsibleState")&&(v.collapseState=S(this._collapseState)),l("canReply")&&(v.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,v)}}getCommentByUniqueId(l){for(let v of this._commentsMap){let t=v[0],n=v[1];if(l===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,Ve([(0,I.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class a{constructor(l,v,t,n,o){this._extension=l,this._handle=v,this._proxy=t,this._id=n,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(l,v,t,n){if(typeof l=="string"){const o=new g(this._proxy,this,l,v,t,n,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new g(this._proxy,this,void 0,l,v,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(l,v){const t=new g(this._proxy,this,void 0,y.URI.revive(l),k.Range.to(v),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(l,v){let t=this._threads.get(l);t&&(t.range=k.Range.to(v))}$deleteCommentThread(l){let v=this._threads.get(l);v&&v.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(m,l,v,t){let n=t.get(v);n||(n=++m.commentHandle,t.set(v,n));const o=v.author&&v.author.iconPath?v.author.iconPath.toString():void 0;return{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(v.body),userName:v.author.name,userIconPath:o,label:v.label,commentReactions:v.reactions?v.reactions.map(i=>E(i)):void 0}}function E(m){return{label:m.label,iconPath:m.iconPath?k.pathOrURIToURI(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted}}function w(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?y.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1}}function S(m){if(m!==void 0)switch(m){case r.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case r.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(ge[127],pe([0,1,2,5,7,4,15,14,17,9,8]),function(G,e,b,I,T,A,y,P,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class yn{constructor(g,a){this._logService=a,this._provider=new Map,this._proxy=g.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,a){const d=yn._handlePool++;this._provider.set(d,{provider:g,extensionId:a}),this._proxy.$registerDecorationProvider(d,a.value);const E=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(d,null);return}let S=(0,D.asArray)(w);if(S.length<=yn._maxEventSize){this._proxy.$onDidChange(d,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,S.length);const m=S.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),l=(0,D.groupBy)(m,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let v=[];e:for(let t of l){let n;for(let o of t){let i=(0,r.dirname)(o.uri.path);if(n!==i&&(n=i,v.push(o.uri)>=yn._maxEventSize))break e}}this._proxy.$onDidChange(d,v)});return new T.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(g,a,d){if(!this._provider.has(g))return Object.create(null);const E=Object.create(null),{provider:w,extensionId:S}=this._provider.get(g);return await Promise.all(a.map(async m=>{try{const{uri:l,id:v}=m,t=await Promise.resolve(w.provideFileDecoration(b.URI.revive(l),d));if(!t)return;try{T.FileDecoration.validate(t),E[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(l){this._logService.error(l)}})),E}};C._handlePool=0,C._maxEventSize=250,C=Ve([xe(0,y.IExtHostRpcService),xe(1,P.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(ge[232],pe([0,1,161,115,2,5,7,20,3,14,22]),function(G,e,b,I,T,A,y,P,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(a,d,E,w,S){this._name=a,this._owner=d,this._maxDiagnosticsPerFile=E,this._proxy=w,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new r.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,d){if(!a){this.clear();return}this._checkDisposed();let E=[];if(T.URI.isUri(a)){if(!d){this.delete(a);return}this._data.set(a,d.slice()),E=[a]}else if(Array.isArray(a)){E=[];let S;a=[...a].sort(C._compareIndexedTuplesByUri);for(const m of a){const[l,v]=m;if((!S||l.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=l,E.push(l),this._data.set(l,[])),v){const t=this._data.get(l);t&&t.push(...v)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const w=[];for(let S of E){let m=[];const l=this._data.get(S);if(l)if(l.length>this._maxDiagnosticsPerFile){m=[];const v=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of l)if(n.severity===v[t]&&m.push(P.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;m.push({severity:I.MarkerSeverity.Info,message:(0,b.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:m[m.length-1].startLineNumber,startColumn:m[m.length-1].startColumn,endLineNumber:m[m.length-1].endLineNumber,endColumn:m[m.length-1].endColumn})}else m=l.map(v=>P.Diagnostic.from(v));w.push([S,m])}this._proxy.$changeMany(this._owner,w)}}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,d){this._checkDisposed();for(let E of this._data.keys())a.apply(d,[E,this.get(E),this])}get(a){this._checkDisposed();const d=this._data.get(a);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,d){return a[0].toString()<d[0].toString()?-1:a[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=C;let f=class Kt{constructor(a,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,Kt._debouncer,50),Kt._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(a,d){return a?a.concat(d):d}static _mapper(a){const d=[],E=new Set;for(const w of a)typeof w=="string"?E.has(w)||(E.add(w),d.push(T.URI.parse(w))):E.has(w.toString())||(E.add(w.toString()),d.push(w));return Object.freeze(d),{uris:d}}createDiagnosticCollection(a,d){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:S,_logService:m}=this,l=new class{$changeMany(n,o){w.$changeMany(n,o),m.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,n,o.length===0?"CLEARING":o)}$clear(n){w.$clear(n),m.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,n)}dispose(){w.dispose()}};let v;if(!d)d="_generated_diagnostic_collection_name_#"+Kt._idPool++,v=d;else if(!E.has(d))v=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do v=d+Kt._idPool++;while(E.has(v))}return new class extends C{constructor(){super(d,v,Kt._maxDiagnosticsPerFile,l,S);E.set(v,this)}dispose(){super.dispose(),E.delete(v)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const d=new Map,E=[];for(const w of this._collections.values())w.forEach((S,m)=>{let l=d.get(S.toString());typeof l=="undefined"&&(l=E.length,d.set(S.toString(),l),E.push([S,[]])),E[l][1]=E[l][1].concat(...m)});return E}}_getDiagnostics(a){let d=[];for(let E of this._collections.values())E.has(a)&&(d=d.concat(E.get(a)));return d}$acceptMarkersChange(a){if(!this._mirrorCollection){const d="_generated_mirror",E=new C(d,d,Kt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,E),this._mirrorCollection=E}for(const[d,E]of a)this._mirrorCollection.set(T.URI.revive(d),E.map(P.Diagnostic.to))}};f._idPool=0,f._maxDiagnosticsPerFile=1e3,f=Ve([xe(1,k.ILogService)],f),e.ExtHostDiagnostics=f}),define(ge[233],pe([0,1,2,5]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(P=>P?P.map(D=>b.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(P=>P?b.URI.revive(P):void 0)}}e.ExtHostDialogs=T}),define(ge[234],pe([0,1,16,2,7,5,12,21,9]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(C,f,g){this._documentsAndEditors=f,this._logService=g,this._documentContentProviders=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,f){if(Object.keys(y.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const g=k._handlePool++;this._documentContentProviders.set(g,f),this._proxy.$registerTextContentProvider(g,C);let a;return typeof f.onDidChange=="function"&&(a=f.onDidChange(d=>{if(d.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(g,d).then(E=>{if(!(!E&&typeof E!="string")){const w=this._documentsAndEditors.getDocument(d);if(!!w){const S=(0,D.splitLines)(E);if(!w.equalLines(S))return this._proxy.$onVirtualDocumentChange(d,E)}}},b.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(C,f){const g=this._documentContentProviders.get(C);return g?Promise.resolve(g.provideTextDocumentContent(I.URI.revive(f),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(ge[235],pe([0,1,3,6,2,5,121,20,11,24]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class r{constructor(f,g){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const d of a)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const d of a)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!!f){const g=this._documentsAndEditors.getDocument(f);if(g)return g}}getDocument(f){const g=this.getDocumentData(f);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${f}'`);return g.document}ensureDocumentData(f){const g=this._documentsAndEditors.getDocument(f);if(g)return Promise.resolve(g);let a=this._documentLoader.get(f.toString());return a||(a=this._proxy.$tryOpenDocument(f).then(d=>{this._documentLoader.delete(f.toString());const E=T.URI.revive(d);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},d=>(this._documentLoader.delete(f.toString()),Promise.reject(d))),this._documentLoader.set(f.toString(),a)),a}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(g=>T.URI.revive(g))}$acceptModelModeChanged(f,g){const a=T.URI.revive(f),d=this._documentsAndEditors.getDocument(a);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(g),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(f){const g=T.URI.revive(f),a=this._documentsAndEditors.getDocument(g);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(f,g){const a=T.URI.revive(f),d=this._documentsAndEditors.getDocument(a);if(!d)throw new Error("unknown document");d._acceptIsDirty(g),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(f,g,a){const d=T.URI.revive(f),E=this._documentsAndEditors.getDocument(d);if(!E)throw new Error("unknown document");E._acceptIsDirty(a),E.onEvents(g),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:E.document,contentChanges:g.changes.map(w=>({range:P.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(f,g){(0,y.setWordDefinitionFor)(f,g)}}e.ExtHostDocuments=r}),define(ge[39],pe([0,1,52,3,6,2,4,5,121,15,125,20,14,22,12,54,135]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(l,v){this._extHostRpc=l,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const v=[],t=[],n=[];if(l.removedDocuments)for(const o of l.removedDocuments){const i=A.URI.revive(o),s=this._documents.get(i);(s==null?void 0:s.unref())&&(this._documents.delete(i),v.push(s.value))}if(l.addedDocuments)for(const o of l.addedDocuments){const i=A.URI.revive(o.uri);let s=this._documents.get(i);if(s&&i.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${i} already exists!'`);s||(s=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(i,s),t.push(s.value)),s.ref()}if(l.removedEditors)for(const o of l.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&n.push(i)}if(l.addedEditors)for(const o of l.addedEditors){const i=A.URI.revive(o.documentUri);b.ok(this._documents.has(i),`document '${i}' does not exist`),b.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const s=this._documents.get(i).value,c=new r.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>s.document),o.selections.map(C.Selection.to),o.options,o.visibleRanges.map(h=>C.Range.to(h)),typeof o.editorPosition=="number"?C.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,c)}l.newActiveEditor!==void 0&&(b.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,T.dispose)(v),(0,T.dispose)(n),l.removedDocuments&&this._onDidRemoveDocuments.fire(v),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){var v;return(v=this._documents.get(l))===null||v===void 0?void 0:v.value}allDocuments(){return d.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!!this._activeEditorId){const v=this._editors.get(this._activeEditorId);return l?v:v==null?void 0:v.value}}allEditors(){return[...this._editors.values()]}};S=Ve([xe(0,k.IExtHostRpcService),xe(1,f.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[236],pe([0,1,2,5,6,7,20,142,9,23]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class r{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const a=this._schemes.indexOf(g);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),a=[];let d,E,w=14,S=14;for(const m of g){let l=d?(0,D.commonPrefixLength)(d,m):0;for(l===0?E=1:E=S;l<m.length;l++)l+1===m.length?(w=S,S=9):S+=1,a.push([E,m.toUpperCase().charCodeAt(l),S]),a.push([E,m.toLowerCase().charCodeAt(l),S]),E=S;d=m,S=w}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new P.StateMachine(a)}}provideDocumentLinks(g){this._initStateMachine();const a=[],d=P.LinkComputer.computeLinks({getLineContent(E){return g.lineAt(E-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const E of d){const w=y.DocumentLink.to(E);w.target&&a.push(w)}return a}}class C{constructor(g,a){this._extHostLanguageFeatures=a,this._linkProvider=new r,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,a,d,E={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(w,d);let S=2;E.isCaseSensitive&&(S+=1024),E.isReadonly&&(S+=2048),typeof d.copy=="function"&&(S+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(w,a,S).catch(l=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${a}`),console.error(l)});const m=d.onDidChangeFile(l=>{const v=[];for(const t of l){let{uri:n,type:o}=t;if(n.scheme===a){let i;switch(o){case A.FileChangeType.Changed:i=0;break;case A.FileChangeType.Created:i=1;break;case A.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:n,type:i})}}this._proxy.$onFileSystemChange(w,v)});return(0,T.toDisposable)(()=>{m.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(g){const{type:a,ctime:d,mtime:E,size:w}=g;return{type:a,ctime:d,mtime:E,size:w}}$stat(g,a){return Promise.resolve(this._getFsProvider(g).stat(b.URI.revive(a))).then(C._asIStat)}$readdir(g,a){return Promise.resolve(this._getFsProvider(g).readDirectory(b.URI.revive(a)))}$readFile(g,a){return Promise.resolve(this._getFsProvider(g).readFile(b.URI.revive(a))).then(d=>k.VSBuffer.wrap(d))}$writeFile(g,a,d,E){return Promise.resolve(this._getFsProvider(g).writeFile(b.URI.revive(a),d.buffer,E))}$delete(g,a,d){return Promise.resolve(this._getFsProvider(g).delete(b.URI.revive(a),d))}$rename(g,a,d,E){return Promise.resolve(this._getFsProvider(g).rename(b.URI.revive(a),b.URI.revive(d),E))}$copy(g,a,d,E){const w=this._getFsProvider(g);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(b.URI.revive(a),b.URI.revive(d),E))}$mkdir(g,a){return Promise.resolve(this._getFsProvider(g).createDirectory(b.URI.revive(a)))}$watch(g,a,d,E){const w=this._getFsProvider(g).watch(b.URI.revive(d),E);this._watches.set(a,w)}$unwatch(g,a){const d=this._watches.get(a);d&&(d.dispose(),this._watches.delete(a))}$open(g,a,d){const E=this._getFsProvider(g);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(b.URI.revive(a),d))}$close(g,a){const d=this._getFsProvider(g);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(a))}$read(g,a,d,E){const w=this._getFsProvider(g);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const S=k.VSBuffer.alloc(E);return Promise.resolve(w.read(a,d,S.buffer,0,E)).then(m=>S.slice(0,m))}$write(g,a,d,E){const w=this._getFsProvider(g);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(a,d,E.buffer,0,E.byteLength))}_getFsProvider(g){const a=this._fsProvider.get(g);if(!a){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return a}}e.ExtHostFileSystem=C}),define(ge[91],pe([0,1,5,45,7,23,4,15,61]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Nt{constructor(C,f){const g=C.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return g.$stat(a).catch(Nt._handleError)},readDirectory(a){return g.$readdir(a).catch(Nt._handleError)},createDirectory(a){return g.$mkdir(a).catch(Nt._handleError)},async readFile(a){return g.$readFile(a).then(d=>d.buffer).catch(Nt._handleError)},writeFile(a,d){return g.$writeFile(a,A.VSBuffer.wrap(d)).catch(Nt._handleError)},delete(a,d){return g.$delete(a,Object.assign({recursive:!1,useTrash:!1},d)).catch(Nt._handleError)},rename(a,d,E){return g.$rename(a,d,Object.assign({overwrite:!1},E)).catch(Nt._handleError)},copy(a,d,E){return g.$copy(a,d,Object.assign({overwrite:!1},E)).catch(Nt._handleError)},isWritableFileSystem(a){const d=f.getCapabilities(a);if(typeof d=="number")return!(d&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case I.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case I.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case I.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case I.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};k=Ve([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[237],pe([0,1,6,5]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,y),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=T}),define(ge[238],pe([0,1,2,24,20,7,13,5,9,44,17,11,139,6,111,72,86,47,16]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor(H,Y){this._documents=H,this._provider=Y}provideDocumentSymbols(H,Y){const ee=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,Y)).then(ae=>{if(!(0,r.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(T.DocumentSymbol.from):m._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(H){var Y;H=H.slice(0).sort((me,De)=>{let Oe=me.location.range.start.compareTo(De.location.range.start);return Oe===0&&(Oe=De.location.range.end.compareTo(me.location.range.end)),Oe});const ee=[],ae=[];for(const me of H){const De={name:me.name||"!!MISSING: name!!",kind:T.SymbolKind.from(me.kind),tags:((Y=me.tags)===null||Y===void 0?void 0:Y.map(T.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:T.Range.from(me.location.range),selectionRange:T.Range.from(me.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),ee.push(De);break}const Oe=ae[ae.length-1];if(k.Range.containsRange(Oe.range,De.range)&&!k.Range.equalsRange(Oe.range,De.range)){Oe.children&&Oe.children.push(De),ae.push(De);break}ae.pop()}}return ee}}class l{constructor(H,Y,ee){this._documents=H,this._commands=Y,this._provider=ee,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,Y){const ee=this._documents.getDocument(H),ae=await this._provider.provideCodeLenses(ee,Y);if(!(!ae||Y.isCancellationRequested)){const me=this._cache.add(ae),De=new g.DisposableStore;this._disposables.set(me,De);const Oe={cacheId:me,lenses:[]};for(let we=0;we<ae.length;we++)Oe.lenses.push({cacheId:[me,we],range:T.Range.from(ae[we].range),command:this._commands.toInternal(ae[we].command,De)});return Oe}}async resolveCodeLens(H,Y){var ee;const ae=H.cacheId&&this._cache.get(...H.cacheId);if(!!ae){let me;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?me=ae:me=await this._provider.resolveCodeLens(ae,Y),me||(me=ae),!Y.isCancellationRequested){const De=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!De)return H.command=this._commands.toInternal((ee=me.command)!==null&&ee!==void 0?ee:l._badCmd,De),H}}}releaseCodeLenses(H){var Y;(Y=this._disposables.get(H))===null||Y===void 0||Y.dispose(),this._disposables.delete(H),this._cache.delete(H)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(Le){return Array.isArray(Le)?Le.map(T.DefinitionLink.from):Le?[T.DefinitionLink.from(Le)]:[]}class t{constructor(H,Y){this._documents=H,this._provider=Y}provideDefinition(H,Y,ee){const ae=this._documents.getDocument(H),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDefinition(ae,me,ee)).then(v)}}class n{constructor(H,Y){this._documents=H,this._provider=Y}provideDeclaration(H,Y,ee){const ae=this._documents.getDocument(H),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDeclaration(ae,me,ee)).then(v)}}class o{constructor(H,Y){this._documents=H,this._provider=Y}provideImplementation(H,Y,ee){const ae=this._documents.getDocument(H),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideImplementation(ae,me,ee)).then(v)}}class i{constructor(H,Y){this._documents=H,this._provider=Y}provideTypeDefinition(H,Y,ee){const ae=this._documents.getDocument(H),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(ae,me,ee)).then(v)}}class s{constructor(H,Y){this._documents=H,this._provider=Y}provideHover(H,Y,ee){const ae=this._documents.getDocument(H),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideHover(ae,me,ee)).then(De=>{if(!(!De||(0,r.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(me)),De.range||(De.range=new A.Range(me,me)),T.Hover.from(De)})}}class c{constructor(H,Y){this._documents=H,this._provider=Y}provideEvaluatableExpression(H,Y,ee){const ae=this._documents.getDocument(H),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,me,ee)).then(De=>{if(De)return T.EvaluatableExpression.from(De)})}}class h{constructor(H,Y){this._documents=H,this._provider=Y}provideInlineValues(H,Y,ee,ae){const me=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideInlineValues(me,T.Range.to(Y),T.InlineValueContext.to(ee),ae)).then(De=>{if(Array.isArray(De))return De.map(Oe=>T.InlineValue.from(Oe))})}}class _{constructor(H,Y){this._documents=H,this._provider=Y}provideDocumentHighlights(H,Y,ee){const ae=this._documents.getDocument(H),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(ae,me,ee)).then(De=>{if(Array.isArray(De))return De.map(T.DocumentHighlight.from)})}}class u{constructor(H,Y){this._documents=H,this._provider=Y}provideLinkedEditingRanges(H,Y,ee){const ae=this._documents.getDocument(H),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,me,ee)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,r.coalesce)(De.ranges.map(T.Range.from)),wordPattern:De.wordPattern}})}}class p{constructor(H,Y){this._documents=H,this._provider=Y}provideReferences(H,Y,ee,ae){const me=this._documents.getDocument(H),De=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideReferences(me,De,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.location.from)})}}class R{constructor(H,Y,ee,ae,me,De,Oe){this._documents=H,this._commands=Y,this._diagnostics=ee,this._provider=ae,this._logService=me,this._extension=De,this._apiDeprecation=Oe,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(H,Y,ee,ae){const me=this._documents.getDocument(H),De=f.Selection.isISelection(Y)?T.Selection.to(Y):T.Range.to(Y),Oe=[];for(const Pe of this._diagnostics.getDiagnostics(H))if(De.intersection(Pe.range)&&Oe.push(Pe)>R._maxCodeActionsPerFile)break;const we={diagnostics:Oe,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:T.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(me,De,we,ae)).then(Pe=>{var Re;if(!(!(0,r.isNonEmptyArray)(Pe)||ae.isCancellationRequested)){const Be=this._cache.add(Pe),Se=new g.DisposableStore;this._disposables.set(Be,Se);const qe=[];for(let X=0;X<Pe.length;X++){const ie=Pe[X];!ie||(R._isCommand(ie)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:ie.title,command:this._commands.toInternal(ie,Se)})):(we.only&&(ie.kind?we.only.contains(ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Be,X],title:ie.title,command:ie.command&&this._commands.toInternal(ie.command,Se),diagnostics:ie.diagnostics&&ie.diagnostics.map(T.Diagnostic.from),edit:ie.edit&&T.WorkspaceEdit.from(ie.edit),kind:ie.kind&&ie.kind.value,isPreferred:ie.isPreferred,disabled:(Re=ie.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:Be,actions:qe}}})}async resolveCodeAction(H,Y){var ee;const[ae,me]=H,De=this._cache.get(ae,me);if(!(!De||R._isCommand(De))&&!!this._provider.resolveCodeAction){const Oe=(ee=await this._provider.resolveCodeAction(De,Y))!==null&&ee!==void 0?ee:De;return(Oe==null?void 0:Oe.edit)?T.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(H){var Y;(Y=this._disposables.get(H))===null||Y===void 0||Y.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}R._maxCodeActionsPerFile=1e3;class O{constructor(H,Y){this._documents=H,this._provider=Y}provideDocumentFormattingEdits(H,Y,ee){const ae=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,Y,ee)).then(me=>{if(Array.isArray(me))return me.map(T.TextEdit.from)})}}class V{constructor(H,Y){this._documents=H,this._provider=Y}provideDocumentRangeFormattingEdits(H,Y,ee,ae){const me=this._documents.getDocument(H),De=T.Range.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,De,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.TextEdit.from)})}}class re{constructor(H,Y){this._documents=H,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(H,Y,ee,ae,me){const De=this._documents.getDocument(H),Oe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Oe,ee,ae,me)).then(we=>{if(Array.isArray(we))return we.map(T.TextEdit.from)})}}class j{constructor(H,Y){this._provider=H,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(H,Y){const ee=P.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(H,Y)).then(ae=>{if((0,r.isNonEmptyArray)(ae)){for(const me of ae)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const De=P.IdObject.mixin(T.WorkspaceSymbol.from(me));this._symbolCache.set(De._id,me),ee.symbols.push(De)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(H,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const ee=this._symbolCache.get(H._id);if(ee){const ae=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,Y));return ae&&(0,I.mixin)(H,T.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(H){const Y=this._resultCache.get(H);if(Y){for(let[ee,ae]=Y;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(H)}}}class x{constructor(H,Y,ee){this._documents=H,this._provider=Y,this._logService=ee}static supportsResolving(H){return typeof H.prepareRename=="function"}provideRenameEdits(H,Y,ee,ae){const me=this._documents.getDocument(H),De=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(me,De,ee,ae)).then(Oe=>{if(!!Oe)return T.WorkspaceEdit.from(Oe)},Oe=>{const we=x._asMessage(Oe);return we?{rejectReason:we,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(H,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(H),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.prepareRename(ae,me,ee)).then(De=>{let Oe,we;if(A.Range.isRange(De)?(Oe=De,we=ae.getText(De)):(0,C.isObject)(De)&&(Oe=De.range,we=De.placeholder),!!Oe){if(Oe.start.line>me.line||Oe.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Oe),text:we}}},De=>{const Oe=x._asMessage(De);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class W{constructor(H,Y){this.resultId=H,this.tokens=Y}}class U{constructor(H,Y){this._documents=H,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(H,Y,ee){const ae=this._documents.getDocument(H),me=Y!==0?this._previousResults.get(Y):null;return(0,y.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,me.resultId,ee):this._provider.provideDocumentSemanticTokens(ae,ee)).then(De=>(me&&this._previousResults.delete(Y),De?(De=U._fixProvidedSemanticTokens(De),this._send(U._convertToEdits(me,De),De)):null))}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return U._isSemanticTokens(H)?U._isCorrectSemanticTokens(H)?H:new A.SemanticTokens(new Uint32Array(H.data),H.resultId):U._isSemanticTokensEdits(H)?U._isCorrectSemanticTokensEdits(H)?H:new A.SemanticTokensEdits(H.edits.map(Y=>new A.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const Y of H.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,Y){if(!U._isSemanticTokens(Y)||!H||!H.tokens)return Y;const ee=H.tokens,ae=ee.length,me=Y.data,De=me.length;let Oe=0;const we=Math.min(ae,De);for(;Oe<we&&ee[Oe]===me[Oe];)Oe++;if(Oe===ae&&Oe===De)return new A.SemanticTokensEdits([],Y.resultId);let Pe=0;const Re=we-Oe;for(;Pe<Re&&ee[ae-Pe-1]===me[De-Pe-1];)Pe++;return new A.SemanticTokensEdits([{start:Oe,deleteCount:ae-Oe-Pe,data:me.subarray(Oe,De-Pe)}],Y.resultId)}_send(H,Y){if(U._isSemanticTokens(H)){const ee=this._nextResultId++;return this._previousResults.set(ee,new W(H.resultId,H.data)),(0,a.encodeSemanticTokensDto)({id:ee,type:"full",data:H.data})}if(U._isSemanticTokensEdits(H)){const ee=this._nextResultId++;return U._isSemanticTokens(Y)?this._previousResults.set(ee,new W(Y.resultId,Y.data)):this._previousResults.set(ee,new W(H.resultId)),(0,a.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(H.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class M{constructor(H,Y){this._documents=H,this._provider=Y}provideDocumentRangeSemanticTokens(H,Y,ee){const ae=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,T.Range.to(Y),ee)).then(me=>me?this._send(me):null)}_send(H){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=M;class F{constructor(H,Y,ee,ae,me){this._documents=H,this._commands=Y,this._provider=ee,this._apiDeprecation=ae,this._extension=me,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,Y,ee,ae){const me=this._documents.getDocument(H),De=T.Position.to(Y),Oe=me.getWordRangeAtPosition(De)||new A.Range(De,De),we=Oe.with({end:De}),Pe=new w.StopWatch(!0),Re=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(me,De,ae,T.CompletionContext.to(ee)));if(!!Re&&!ae.isCancellationRequested){const Be=Array.isArray(Re)?new A.CompletionList(Re):Re,Se=F.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),qe=new g.DisposableStore;this._disposables.set(Se,qe);const X=[],ie={x:Se,b:X,a:{replace:T.Range.from(Oe),insert:T.Range.from(we)},c:Be.isIncomplete||void 0,d:Pe.elapsed()};for(let _e=0;_e<Be.items.length;_e++){const Ne=Be.items[_e],ze=this._convertCompletionItem(Ne,[Se,_e],we,Oe);X.push(ze)}return ie}}async resolveCompletionItem(H,Y){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...H);if(!!ee){const ae=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,Y));if(!!ae)return this._convertCompletionItem(ae,H)}}}releaseCompletionItems(H){var Y;(Y=this._disposables.get(H))===null||Y===void 0||Y.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,Y,ee,ae){var me;const De=this._disposables.get(Y[0]);if(!De)throw Error("DisposableStore is missing...");const Oe={x:Y,a:(me=H.label)!==null&&me!==void 0?me:"",o:H.label2,b:H.kind!==void 0?T.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(T.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(H.command,De)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=H.textEdit.newText):typeof H.insertText=="string"?Oe.h=H.insertText:H.insertText instanceof A.SnippetString&&(Oe.h=H.insertText.value,Oe.i|=4);let we;return H.textEdit?we=H.textEdit.range:H.range&&(we=H.range),A.Range.isRange(we)?Oe.j=T.Range.from(we):we&&(!(ee==null?void 0:ee.isEqual(we.inserting))||!(ae==null?void 0:ae.isEqual(we.replacing)))&&(Oe.j={insert:T.Range.from(we.inserting),replace:T.Range.from(we.replacing)}),Oe}}class L{constructor(H,Y){this._documents=H,this._provider=Y,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(H,Y,ee,ae){const me=this._documents.getDocument(H),De=T.Position.to(Y),Oe=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(me,De,ae,Oe)).then(we=>{if(we){const Pe=this._cache.add([we]);return Object.assign(Object.assign({},T.SignatureHelp.from(we)),{id:Pe})}})}reviveContext(H){let Y;if(H.activeSignatureHelp){const ee=T.SignatureHelp.to(H.activeSignatureHelp),ae=this._cache.get(H.activeSignatureHelp.id,0);ae?(Y=ae,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return Object.assign(Object.assign({},H),{activeSignatureHelp:Y})}releaseSignatureHelp(H){this._cache.delete(H)}}class N{constructor(H,Y){this._documents=H,this._provider=Y}provideInlayHints(H,Y,ee){const ae=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideInlayHints(ae,T.Range.to(Y),ee)).then(me=>me?{hints:me.map(T.InlayHint.from)}:void 0)}}class ${constructor(H,Y){this._documents=H,this._provider=Y,this._cache=new E.Cache("DocumentLink")}provideLinks(H,Y){const ee=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,Y)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(T.DocumentLink.from)};{const me=this._cache.add(ae),De={links:[],id:me};for(let Oe=0;Oe<ae.length;Oe++){const we=T.DocumentLink.from(ae[Oe]);we.cacheId=[me,Oe],De.links.push(we)}return De}}})}resolveLink(H,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...H);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,Y)).then(ae=>ae&&T.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(H){this._cache.delete(H)}}class q{constructor(H,Y){this._documents=H,this._provider=Y}provideColors(H,Y){const ee=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,Y)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:T.Color.from(De.color),range:T.Range.from(De.range)})):[])}provideColorPresentations(H,Y,ee){const ae=this._documents.getDocument(H),me=T.Range.to(Y.range),De=T.Color.to(Y.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:me},ee)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(T.ColorPresentation.from)})}}class Q{constructor(H,Y){this._documents=H,this._provider=Y}provideFoldingRanges(H,Y,ee){const ae=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(ae,Y,ee)).then(me=>{if(!!Array.isArray(me))return me.map(T.FoldingRange.from)})}}class de{constructor(H,Y,ee){this._documents=H,this._provider=Y,this._logService=ee}provideSelectionRanges(H,Y,ee){const ae=this._documents.getDocument(H),me=Y.map(T.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(ae,me,ee)).then(De=>{if(!(0,r.isNonEmptyArray)(De))return[];if(De.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let we=0;we<me.length;we++){const Pe=[];Oe.push(Pe);let Re=me[we],Be=De[we];for(;;){if(!Be.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(T.SelectionRange.from(Be)),!Be.parent)break;Re=Be.range,Be=Be.parent}}return Oe})}}class be{constructor(H,Y){this._documents=H,this._provider=Y,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(H,Y,ee){const ae=this._documents.getDocument(H),me=T.Position.to(Y),De=await this._provider.prepareCallHierarchy(ae,me,ee);if(!!De){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(De)?De.map(we=>this._cacheAndConvertItem(Oe,we)):[this._cacheAndConvertItem(Oe,De)]}}async provideCallsTo(H,Y,ee){const ae=this._itemFromCache(H,Y);if(!ae)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!me)return me.map(De=>({from:this._cacheAndConvertItem(H,De.from),fromRanges:De.fromRanges.map(Oe=>T.Range.from(Oe))}))}async provideCallsFrom(H,Y,ee){const ae=this._itemFromCache(H,Y);if(!ae)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!me)return me.map(De=>({to:this._cacheAndConvertItem(H,De.to),fromRanges:De.fromRanges.map(Oe=>T.Range.from(Oe))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,Y){var ee;const ae=this._cache.get(H),me={_sessionId:H,_itemId:ae.size.toString(36),name:Y.name,detail:Y.detail,kind:T.SymbolKind.from(Y.kind),uri:Y.uri,range:T.Range.from(Y.range),selectionRange:T.Range.from(Y.selectionRange),tags:(ee=Y.tags)===null||ee===void 0?void 0:ee.map(T.SymbolTag.from)};return ae.set(me._itemId,Y),me}_itemFromCache(H,Y){const ee=this._cache.get(H);return ee==null?void 0:ee.get(Y)}}class Ae{constructor(H,Y){this.adapter=H,this.extension=Y}}class Ce{constructor(H,Y,ee,ae,me,De,Oe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=H.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=me,this._logService=De,this._apiDeprecation=Oe}_transformDocumentSelector(H){return(0,r.coalesce)((0,r.asArray)(H).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(H){if(typeof H=="string")return{$serialized:!0,language:H};if(H)return{$serialized:!0,language:H.language,scheme:this._transformScheme(H.scheme),pattern:typeof H.pattern=="undefined"?void 0:T.GlobPattern.from(H.pattern),exclusive:H.exclusive}}_transformScheme(H){return this._uriTransformer&&typeof H=="string"?this._uriTransformer.transformOutgoingScheme(H):H}_createDisposable(H){return new A.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Ce._handlePool++}_withAdapter(H,Y,ee,ae,me=!1){const De=this._adapter.get(H);if(!De)return Promise.resolve(ae);if(De.adapter instanceof Y){let Oe;De.extension&&(Oe=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${Y.name}'`));const we=ee(De.adapter,De.extension),Pe=De.extension;return Pe&&Promise.resolve(we).then(()=>this._logService.trace(`[${Pe.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Re=>{me&&Re instanceof S.CancellationError||(this._logService.error(`[${Pe.identifier.value}] provider FAILED`),this._logService.error(Re))}),we}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Ae(H,Y)),ee}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,Y,ee,ae){const me=this._addNewAdapter(new m(this._documents,ee),H),De=ae&&ae.label||Ce._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(Y),De),this._createDisposable(me)}$provideDocumentSymbols(H,Y,ee){return this._withAdapter(H,m,ae=>ae.provideDocumentSymbols(b.URI.revive(Y),ee),void 0)}registerCodeLensProvider(H,Y,ee){const ae=this._nextHandle(),me=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new l(this._documents,this._commands.converter,ee),H)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Y),me);let De=this._createDisposable(ae);if(me!==void 0){const Oe=ee.onDidChangeCodeLenses(we=>this._proxy.$emitCodeLensEvent(me));De=A.Disposable.from(De,Oe)}return De}$provideCodeLenses(H,Y,ee){return this._withAdapter(H,l,ae=>ae.provideCodeLenses(b.URI.revive(Y),ee),void 0)}$resolveCodeLens(H,Y,ee){return this._withAdapter(H,l,ae=>ae.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(H,Y){this._withAdapter(H,l,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(H,Y,ee){const ae=this._addNewAdapter(new t(this._documents,ee),H);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDefinition(H,Y,ee,ae){return this._withAdapter(H,t,me=>me.provideDefinition(b.URI.revive(Y),ee,ae),[])}registerDeclarationProvider(H,Y,ee){const ae=this._addNewAdapter(new n(this._documents,ee),H);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDeclaration(H,Y,ee,ae){return this._withAdapter(H,n,me=>me.provideDeclaration(b.URI.revive(Y),ee,ae),[])}registerImplementationProvider(H,Y,ee){const ae=this._addNewAdapter(new o(this._documents,ee),H);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideImplementation(H,Y,ee,ae){return this._withAdapter(H,o,me=>me.provideImplementation(b.URI.revive(Y),ee,ae),[])}registerTypeDefinitionProvider(H,Y,ee){const ae=this._addNewAdapter(new i(this._documents,ee),H);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideTypeDefinition(H,Y,ee,ae){return this._withAdapter(H,i,me=>me.provideTypeDefinition(b.URI.revive(Y),ee,ae),[])}registerHoverProvider(H,Y,ee,ae){const me=this._addNewAdapter(new s(this._documents,ee),H);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(Y)),this._createDisposable(me)}$provideHover(H,Y,ee,ae){return this._withAdapter(H,s,me=>me.provideHover(b.URI.revive(Y),ee,ae),void 0)}registerEvaluatableExpressionProvider(H,Y,ee,ae){const me=this._addNewAdapter(new c(this._documents,ee),H);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(Y)),this._createDisposable(me)}$provideEvaluatableExpression(H,Y,ee,ae){return this._withAdapter(H,c,me=>me.provideEvaluatableExpression(b.URI.revive(Y),ee,ae),void 0)}registerInlineValuesProvider(H,Y,ee,ae){const me=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new h(this._documents,ee),H);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(Y),me);let Oe=this._createDisposable(De);if(me!==void 0){const we=ee.onDidChangeInlineValues(Pe=>this._proxy.$emitInlineValuesEvent(me));Oe=A.Disposable.from(Oe,we)}return Oe}$provideInlineValues(H,Y,ee,ae,me){return this._withAdapter(H,h,De=>De.provideInlineValues(b.URI.revive(Y),ee,ae,me),void 0)}registerDocumentHighlightProvider(H,Y,ee){const ae=this._addNewAdapter(new _(this._documents,ee),H);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentHighlights(H,Y,ee,ae){return this._withAdapter(H,_,me=>me.provideDocumentHighlights(b.URI.revive(Y),ee,ae),void 0)}registerLinkedEditingRangeProvider(H,Y,ee){const ae=this._addNewAdapter(new u(this._documents,ee),H);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideLinkedEditingRanges(H,Y,ee,ae){return this._withAdapter(H,u,async me=>{const De=await me.provideLinkedEditingRanges(b.URI.revive(Y),ee,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Ce._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(H,Y,ee){const ae=this._addNewAdapter(new p(this._documents,ee),H);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideReferences(H,Y,ee,ae,me){return this._withAdapter(H,p,De=>De.provideReferences(b.URI.revive(Y),ee,ae,me),void 0)}registerCodeActionProvider(H,Y,ee,ae){var me,De;const Oe=new g.DisposableStore,we=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(Y),{providedKinds:(me=ae==null?void 0:ae.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Pe=>Pe.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(Pe=>({kind:Pe.kind.value,command:this._commands.converter.toInternal(Pe.command,Oe)}))},Ce._extLabel(H),Boolean(ee.resolveCodeAction)),Oe.add(this._createDisposable(we)),Oe}$provideCodeActions(H,Y,ee,ae,me){return this._withAdapter(H,R,De=>De.provideCodeActions(b.URI.revive(Y),ee,ae,me),void 0)}$resolveCodeAction(H,Y,ee){return this._withAdapter(H,R,ae=>ae.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(H,Y){this._withAdapter(H,R,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(H,Y,ee){const ae=this._addNewAdapter(new O(this._documents,ee),H);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Y),H.identifier,H.displayName||H.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(H,Y,ee,ae){return this._withAdapter(H,O,me=>me.provideDocumentFormattingEdits(b.URI.revive(Y),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(H,Y,ee){const ae=this._addNewAdapter(new V(this._documents,ee),H);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Y),H.identifier,H.displayName||H.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(H,Y,ee,ae,me){return this._withAdapter(H,V,De=>De.provideDocumentRangeFormattingEdits(b.URI.revive(Y),ee,ae,me),void 0)}registerOnTypeFormattingEditProvider(H,Y,ee,ae){const me=this._addNewAdapter(new re(this._documents,ee),H);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(Y),ae,H.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(H,Y,ee,ae,me,De){return this._withAdapter(H,re,Oe=>Oe.provideOnTypeFormattingEdits(b.URI.revive(Y),ee,ae,me,De),void 0)}registerWorkspaceSymbolProvider(H,Y){const ee=this._addNewAdapter(new j(Y,this._logService),H);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(H,Y,ee){return this._withAdapter(H,j,ae=>ae.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(H,Y,ee){return this._withAdapter(H,j,ae=>ae.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(H,Y){this._withAdapter(H,j,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(H,Y,ee){const ae=this._addNewAdapter(new x(this._documents,ee,this._logService),H);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Y),x.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(H,Y,ee,ae,me){return this._withAdapter(H,x,De=>De.provideRenameEdits(b.URI.revive(Y),ee,ae,me),void 0)}$resolveRenameLocation(H,Y,ee,ae){return this._withAdapter(H,x,me=>me.resolveRenameLocation(b.URI.revive(Y),ee,ae),void 0)}registerDocumentSemanticTokensProvider(H,Y,ee,ae){const me=this._nextHandle(),De=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new Ae(new U(this._documents,ee),H)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(Y),ae,De);let Oe=this._createDisposable(me);if(De){const we=ee.onDidChangeSemanticTokens(Pe=>this._proxy.$emitDocumentSemanticTokensEvent(De));Oe=A.Disposable.from(Oe,we)}return Oe}$provideDocumentSemanticTokens(H,Y,ee,ae){return this._withAdapter(H,U,me=>me.provideDocumentSemanticTokens(b.URI.revive(Y),ee,ae),null,!0)}$releaseDocumentSemanticTokens(H,Y){this._withAdapter(H,U,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(H,Y,ee,ae){const me=this._addNewAdapter(new M(this._documents,ee),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(Y),ae),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(H,Y,ee,ae){return this._withAdapter(H,M,me=>me.provideDocumentRangeSemanticTokens(b.URI.revive(Y),ee,ae),null,!0)}registerCompletionItemProvider(H,Y,ee,ae){const me=this._addNewAdapter(new F(this._documents,this._commands.converter,ee,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(Y),ae,F.supportsResolving(ee),`${H.identifier.value}(${ae.join("")})`),this._createDisposable(me)}$provideCompletionItems(H,Y,ee,ae,me){return this._withAdapter(H,F,De=>De.provideCompletionItems(b.URI.revive(Y),ee,ae,me),void 0)}$resolveCompletionItem(H,Y,ee){return this._withAdapter(H,F,ae=>ae.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(H,Y){this._withAdapter(H,F,ee=>ee.releaseCompletionItems(Y),void 0)}registerSignatureHelpProvider(H,Y,ee,ae){const me=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new L(this._documents,ee),H);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(Y),me),this._createDisposable(De)}$provideSignatureHelp(H,Y,ee,ae,me){return this._withAdapter(H,L,De=>De.provideSignatureHelp(b.URI.revive(Y),ee,ae,me),void 0)}$releaseSignatureHelp(H,Y){this._withAdapter(H,L,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(H,Y,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new N(this._documents,ee),H);this._proxy.$registerInlayHintsProvider(me,this._transformDocumentSelector(Y),ae);let De=this._createDisposable(me);if(ae!==void 0){const Oe=ee.onDidChangeInlayHints(we=>this._proxy.$emitInlayHintsEvent(ae));De=A.Disposable.from(De,Oe)}return De}$provideInlayHints(H,Y,ee,ae){return this._withAdapter(H,N,me=>me.provideInlayHints(b.URI.revive(Y),ee,ae),void 0)}registerDocumentLinkProvider(H,Y,ee){const ae=this._addNewAdapter(new $(this._documents,ee),H);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(H,Y,ee){return this._withAdapter(H,$,ae=>ae.provideLinks(b.URI.revive(Y),ee),void 0)}$resolveDocumentLink(H,Y,ee){return this._withAdapter(H,$,ae=>ae.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(H,Y){this._withAdapter(H,$,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(H,Y,ee){const ae=this._addNewAdapter(new q(this._documents,ee),H);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentColors(H,Y,ee){return this._withAdapter(H,q,ae=>ae.provideColors(b.URI.revive(Y),ee),[])}$provideColorPresentations(H,Y,ee,ae){return this._withAdapter(H,q,me=>me.provideColorPresentations(b.URI.revive(Y),ee,ae),void 0)}registerFoldingRangeProvider(H,Y,ee){const ae=this._nextHandle(),me=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new Q(this._documents,ee),H)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Y),me);let De=this._createDisposable(ae);if(me!==void 0){const Oe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));De=A.Disposable.from(De,Oe)}return De}$provideFoldingRanges(H,Y,ee,ae){return this._withAdapter(H,Q,me=>me.provideFoldingRanges(b.URI.revive(Y),ee,ae),void 0)}registerSelectionRangeProvider(H,Y,ee){const ae=this._addNewAdapter(new de(this._documents,ee,this._logService),H);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideSelectionRanges(H,Y,ee,ae){return this._withAdapter(H,de,me=>me.provideSelectionRanges(b.URI.revive(Y),ee,ae),[])}registerCallHierarchyProvider(H,Y,ee){const ae=this._addNewAdapter(new be(this._documents,ee),H);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareCallHierarchy(H,Y,ee,ae){return this._withAdapter(H,be,me=>Promise.resolve(me.prepareSession(b.URI.revive(Y),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(H,Y,ee,ae){return this._withAdapter(H,be,me=>me.provideCallsTo(Y,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(H,Y,ee,ae){return this._withAdapter(H,be,me=>me.provideCallsFrom(Y,ee,ae),void 0)}$releaseCallHierarchy(H,Y){this._withAdapter(H,be,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,D.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Ce._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Ce._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Ce._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Ce._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Ce._serializeRegExp(H.beforeText),afterText:H.afterText?Ce._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Ce._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Ce._serializeOnEnterRule)}setLanguageConfiguration(H,Y,ee){let{wordPattern:ae}=ee;if(ae&&(0,D.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Y,ae):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const me=this._nextHandle(),De={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Ce._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Ce._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Ce._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,Y,De),this._createDisposable(me)}$setWordDefinitions(H){for(const Y of H)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Ce,Ce._handlePool=0}),define(ge[239],pe([0,1,5,20,7]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(P,D){this._proxy=P.getProxy(b.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,D){await this._proxy.$changeLanguage(P,D);const k=this._documents.getDocumentData(P);if(!k)throw new Error(`document '${P.toString}' NOT found`);return k.document}async tokenAtPosition(P,D){var k;const r=P.version,C=I.Position.from(D),f=await this._proxy.$tokensAtPosition(P.uri,C),g={type:T.StandardTokenType.Other,range:(k=P.getWordRangeAtPosition(D))!==null&&k!==void 0?k:new T.Range(D.line,D.character,D.line,D.character)};if(!f)return g;const a={range:I.Range.to(f.range),type:I.TokenType.to(f.type)};return!a.range.contains(D)||r!==P.version?g:a}}e.ExtHostLanguages=A}),define(ge[240],pe([0,1,5,14,41]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let y=class{constructor(D,k){this._logService=k,this._proxy=D.getProxy(b.MainContext.MainThreadMessageService)}showMessage(D,k,r,C,f){const g={extension:D};let a;typeof C=="string"||A(C)?a=[C,...f]:(g.modal=C&&C.modal,g.useCustom=C&&C.useCustom,a=f),g.useCustom&&(0,T.checkProposedApiEnabled)(D);const d=[];for(let E=0;E<a.length;E++){const w=a[E];if(typeof w=="string")d.push({title:w,handle:E,isCloseAffordance:!1});else if(typeof w=="object"){let{title:S,isCloseAffordance:m}=w;d.push({title:S,isCloseAffordance:!!m,handle:E})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(k,r,g,d).then(E=>{if(typeof E=="number")return a[E]})}};y=Ve([xe(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(ge[241],pe([0,1,13,23,21,3,74,72,6,22,9,11,2,86,5,20,7,89,217,218]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class l{constructor(s,c){const h=l._Keys.nextId();s.$registerNotebookEditorDecorationType(h,d.NotebookDecorationRenderOptions.from(c)),this.value={key:h,dispose(){s.$removeNotebookEditorDecorationType(h)}}}}e.NotebookEditorDecorationType=l,l._Keys=new P.IdGenerator("NotebookEditorDecorationType");class v{constructor(s,c,h,_,u,p){this._textDocumentsAndEditors=h,this._textDocuments=_,this.logService=u,this._extensionStoragePaths=p,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new A.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new A.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new A.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new A.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new A.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new A.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new A.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new A.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new A.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new A.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new k.ResourceMap,this._statusBarCache=new g.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(a.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(a.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(a.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:R=>{var O;if(R&&R.$mid===12){const V=(O=R.notebookEditor)===null||O===void 0?void 0:O.notebookUri,re=R.cell.handle,j=this._documents.get(V),x=j==null?void 0:j.getCell(re);if(x)return x.apiCell}return R}})}get activeNotebookEditor(){var s;return(s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){return this._editors.get(s)}getIdByEditor(s){for(const[c,h]of this._editors)if(h.apiEditor===s)return c}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(s){return this._documents.get(s)}_getNotebookDocument(s){const c=this._documents.get(s);if(!c)throw new Error(`NO notebook document for '${s}'`);return c}_getProviderData(s){const c=this._notebookContentProviders.get(s);if(!c)throw new Error(`NO provider for '${s}'`);return c}registerNotebookContentProvider(s,c,h,_,u){if((0,r.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:s,provider:h});let p;return h.onDidChangeNotebookContentOptions&&(p=h.onDidChangeNotebookContentOptions(()=>{const R=d.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(c,R)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},c,d.NotebookDocumentContentOptions.from(_),v._convertNotebookRegistrationData(s,u)),new E.Disposable(()=>{p==null||p.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(s,c){if(!!c){const h=c.filenamePattern.map(_=>d.NotebookExclusiveDocumentPattern.from(_)).filter(_=>_!==void 0);if(c.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{providerDisplayName:s.displayName||s.name,displayName:c.displayName,filenamePattern:h,exclusive:c.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(s,c,h){const _=v._notebookStatusBarItemProviderHandlePool++,u=typeof h.onDidChangeCellStatusBarItems=="function"?v._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(_,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(_,u,c);let p;return u!==void 0&&(p=h.onDidChangeCellStatusBarItems(R=>this._notebookProxy.$emitCellStatusBarEvent(u))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(_),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(_,u),p&&p.dispose()})}createNotebookEditorDecorationType(s){return new l(this._notebookEditorsProxy,s).value}async openNotebookDocument(s){const c=this._documents.get(s);if(c)return c.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenDocument(s),_=this._documents.get(f.URI.revive(h));return(0,C.assertIsDefined)(_==null?void 0:_.apiNotebook)}async showNotebookDocument(s,c){var h;f.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let _;typeof c=="object"?_={position:d.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(d.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:_={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.viewType,_),p=u&&((h=this._editors.get(u))===null||h===void 0?void 0:h.apiEditor);if(p)return p;throw u?new Error(`Could NOT open editor for "${s.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.toString()}".`)}async $provideNotebookCellStatusBarItems(s,c,h,_){var u;const p=this._notebookStatusBarItemProviders.get(s),R=f.URI.revive(c),O=this._documents.get(R);if(!(!O||!p)){const V=O.getCellFromIndex(h);if(!!V){const re=await p.provideCellStatusBarItems(V.apiCell,_);if(!!re){const j=new D.DisposableStore,x=this._statusBarCache.add([j]),W=(u=re&&re.map(U=>d.NotebookStatusBarItem.from(U,this._commandsConverter,j)))!==null&&u!==void 0?u:void 0;return{cacheId:x,items:W}}}}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,c,h,_,u){if((0,r.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const p=this._handlePool++;return this._notebookSerializer.set(p,h),this._notebookProxy.$registerNotebookSerializer(p,{id:s.identifier,location:s.extensionLocation},c,d.NotebookDocumentContentOptions.from(_),v._convertNotebookRegistrationData(s,u)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(p)})}async $dataToNotebook(s,c,h){const _=this._notebookSerializer.get(s);if(!_)throw new Error("NO serializer found");const u=await _.deserializeNotebook(c.buffer,h);return{metadata:d.NotebookDocumentMetadata.from(u.metadata),cells:u.cells.map(d.NotebookCellData.from)}}async $notebookToData(s,c,h){const _=this._notebookSerializer.get(s);if(!_)throw new Error("NO serializer found");const u=await _.serializeNotebook({metadata:d.NotebookDocumentMetadata.to(c.metadata),cells:c.cells.map(d.NotebookCellData.to)},h);return I.VSBuffer.wrap(u)}cancelOneNotebookCellExecution(s){const c=this._activeExecutions.get(s.uri);c==null||c.cancel()}async $openNotebook(s,c,h,_,u){const{provider:p}=this._getProviderData(s),R=await p.openNotebook(f.URI.revive(c),{backupId:h,untitledDocumentData:_==null?void 0:_.buffer},u);return{metadata:d.NotebookDocumentMetadata.from(R.metadata),cells:R.cells.map(d.NotebookCellData.from)}}async $saveNotebook(s,c,h){const _=this._getNotebookDocument(f.URI.revive(c)),{provider:u}=this._getProviderData(s);return await u.saveNotebook(_.apiNotebook,h),!0}async $saveNotebookAs(s,c,h,_){const u=this._getNotebookDocument(f.URI.revive(c)),{provider:p}=this._getProviderData(s);return await p.saveNotebookAs(f.URI.revive(h),u.apiNotebook,_),!0}async $backupNotebook(s,c,h){var _;const u=this._getNotebookDocument(f.URI.revive(c)),p=this._getProviderData(s),R=(_=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&_!==void 0?_:this._extensionStoragePaths.globalValue(p.extension),O=String((0,y.hash)([u.uri.toString(),this._backupIdPool++])),V=f.URI.joinPath(R,O),re=await p.provider.backupNotebook(u.apiNotebook,{destination:V},h);return u.updateBackup(re),re.id}$acceptModelChanged(s,c,h){this._getNotebookDocument(f.URI.revive(s)).acceptModelChanged(c,h)}$acceptDirtyStateChanged(s,c){const h=this._getNotebookDocument(f.URI.revive(s));h.acceptModelChanged({rawEvents:[],versionId:h.apiNotebook.version},c)}$acceptModelSaved(s){const c=this._getNotebookDocument(f.URI.revive(s));this._onDidSaveNotebookDocument.fire(c.apiNotebook)}$acceptEditorPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",s,c);const h=this._editors.get(s);if(!h)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);c.visibleRanges&&h._acceptVisibleRanges(c.visibleRanges.ranges.map(d.NotebookRange.to)),c.selections&&h._acceptSelections(c.selections.selections.map(d.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(s){for(const c in s){const h=this._editors.get(c);if(!h)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);h._acceptViewColumn(d.ViewColumn.to(s[c]))}}$acceptDocumentPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",s.path,c);const h=this._getNotebookDocument(f.URI.revive(s));h.acceptDocumentPropertiesChanged(c),c.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:h.apiNotebook})}_createExtHostEditor(s,c,h){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const _=new m.ExtHostNotebookEditor(c,this._notebookEditorsProxy,s,h.visibleRanges.map(d.NotebookRange.to),h.selections.map(d.NotebookRange.to),typeof h.viewColumn=="number"?d.ViewColumn.to(h.viewColumn):void 0);this._editors.set(c,_)}$acceptDocumentAndEditorsDelta(s){var c,h,_;if(s.removedDocuments)for(const p of s.removedDocuments){const R=f.URI.revive(p),O=this._documents.get(R);O&&(O.dispose(),this._documents.delete(R),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:O.apiNotebook.getCells().map(V=>V.document.uri)}),this._onDidCloseNotebookDocument.fire(O.apiNotebook));for(const V of this._editors.values())V.notebookData.uri.toString()===R.toString()&&this._editors.delete(V.id)}if(s.addedDocuments){const p=[];for(const R of s.addedDocuments){const O=f.URI.revive(R.uri),V=R.viewType;if(this._documents.has(O))throw new Error(`adding EXISTING notebook ${O} `);const re=this,j=new S.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(x){re._onDidChangeNotebookCells.fire(x)},emitCellOutputsChange(x){re._onDidChangeCellOutputs.fire(x)},emitCellMetadataChange(x){re._onDidChangeCellMetadata.fire(x)},emitCellExecutionStateChange(x){re._onDidChangeCellExecutionState.fire(x)}},V,R.metadata?d.NotebookDocumentMetadata.to(R.metadata):new E.NotebookDocumentMetadata,O);j.acceptModelChanged({versionId:R.versionId,rawEvents:[{kind:w.NotebookCellsChangeType.Initialize,changes:[[0,0,R.cells]]}]},!1),p.push(...R.cells.map(x=>S.ExtHostCell.asModelAddData(j.apiNotebook,x))),(c=this._documents.get(O))===null||c===void 0||c.dispose(),this._documents.set(O,j),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(j.apiNotebook)}}if(s.addedEditors)for(const p of s.addedEditors){if(this._editors.has(p.id))return;const R=f.URI.revive(p.documentUri),O=this._documents.get(R);O&&this._createExtHostEditor(O,p.id,p)}const u=[];if(s.removedEditors)for(const p of s.removedEditors){const R=this._editors.get(p);R&&(this._editors.delete(p),((h=this._activeNotebookEditor)===null||h===void 0?void 0:h.id)===R.id&&(this._activeNotebookEditor=void 0),u.push(R))}if(s.visibleEditors){this._visibleNotebookEditors=s.visibleEditors.map(R=>this._editors.get(R)).filter(R=>!!R);const p=new Set;this._visibleNotebookEditors.forEach(R=>p.add(R.id));for(const R of this._editors.values()){const O=p.has(R.id);R._acceptVisibility(O)}this._visibleNotebookEditors=[...this._editors.values()].map(R=>R).filter(R=>R.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.newActiveEditor===null?this._activeNotebookEditor=void 0:s.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.newActiveEditor)),s.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((_=this._activeNotebookEditor)===null||_===void 0?void 0:_.apiEditor)}createNotebookCellExecution(s,c,h){const _=this.lookupNotebookDocument(s);if(!_)throw new Error(`Invalid uri: ${s} `);const u=_.getCellFromIndex(c);if(!u)throw new Error(`Invalid cell index: ${s}, ${c} `);if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const p=new n(s,_,u,this._notebookDocumentsProxy);this._activeExecutions.set(u.uri,p);const R=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),R.dispose(),this._activeExecutions.delete(u.uri))});return p.asApiObject()}}e.ExtHostNotebookController=v,v._notebookStatusBarItemProviderHandlePool=0;var t;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(t||(t={}));class n extends D.Disposable{constructor(s,c,h,_){super();this._uri=s,this._document=c,this._cell=h,this._proxy=_,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new T.CancellationTokenSource),this._collector=new o(10,u=>this.applyEdits(u)),this._executionOrder=h.internalMetadata.executionOrder,this.mixinMetadata({runState:E.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(s){await this._collector.addItem(s)}async applyEdits(s){return this._proxy.$applyEdits(this._uri,s,!1)}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(s){const c={editType:8,handle:this._cell.handle,metadata:s};this.applyEdits([c])}cellIndexToHandle(s){const c=typeof s=="number"?this._document.getCellFromIndex(s):this._cell;if(!!c)return c.handle}asApiObject(){const s=this;return Object.freeze({get document(){return s._document.apiNotebook},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(c){s._executionOrder=c,s.mixinMetadata({executionOrder:c})},start(c){var h;if(s._state===t.Resolved||s._state===t.Started)throw new Error("Cannot call start again");s._state=t.Started,s._onDidChangeState.fire(),s.mixinMetadata({runState:E.NotebookCellExecutionState.Executing,runStartTime:(h=c==null?void 0:c.startTime)!==null&&h!==void 0?h:null})},end(c){var h,_;if(s._state===t.Resolved)throw new Error("Cannot call resolve twice");s._state=t.Resolved,s._onDidChangeState.fire(),s.mixinMetadata({runState:E.NotebookCellExecutionState.Idle,lastRunSuccess:(h=c==null?void 0:c.success)!==null&&h!==void 0?h:null,runEndTime:(_=c==null?void 0:c.endTime)!==null&&_!==void 0?_:null})},clearOutput(c){return s.verifyStateForOutput(),this.replaceOutput([],c)},async appendOutput(c,h){s.verifyStateForOutput();const _=s.cellIndexToHandle(h);if(typeof _=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:_,append:!0,outputs:c.map(d.NotebookCellOutput.from)})},async replaceOutput(c,h){s.verifyStateForOutput();const _=s.cellIndexToHandle(h);if(typeof _=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:_,outputs:c.map(d.NotebookCellOutput.from)})},async appendOutputItems(c,h){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,append:!0,items:c.map(d.NotebookCellOutputItem.from),outputId:h})},async replaceOutputItems(c,h){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,items:c.map(d.NotebookCellOutputItem.from),outputId:h})},token:s._tokenSource.token})}}class o{constructor(s,c){this.delay=s,this.callback=c,this.batch=[]}addItem(s){return this.batch.push(s),this.waitPromise||(this.waitPromise=(0,b.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const c=this.batch;return this.batch=[],this.callback(c)})),this.waitPromise}}}),define(ge[242],pe([0,1,3,6,5,27,2,20,88,22]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class r{constructor(f,g,a){this._initData=g,this._extHostNotebook=a,this._kernelData=new Map,this._handlePool=0,this._proxy=f.getProxy(T.MainContext.MainThreadNotebookKernels)}createNotebookController(f,g,a,d,E,w){for(let R of this._kernelData.values())if(R.controller.id===g&&A.ExtensionIdentifier.equals(f.identifier,R.extensionId))throw new Error(`notebook controller with id '${g}' ALREADY exist`);const S=this._handlePool++,m=this,l=()=>console.warn(`NO execute handler from notebook controller '${i.id}' of extension: '${f.identifier}'`);let v=!1;const t=new I.DisposableStore,n=new b.Emitter,o=new b.Emitter,i={id:`${f.identifier.value}/${g}`,viewType:a,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:d||f.identifier.value,preloads:w?w.map(P.NotebookKernelPreload.from):[]};let s=E!=null?E:l,c;this._proxy.$addKernel(S,i).catch(R=>{console.log(R),v=!0});let h=0;const _=()=>{if(!v){const R=++h;Promise.resolve().then(()=>{R===h&&this._proxy.$updateKernel(S,i)})}},u=new k.ResourceMap,p={get id(){return g},get viewType(){return i.viewType},onDidChangeNotebookAssociation:n.event,get label(){return i.label},set label(R){var O;i.label=(O=R!=null?R:f.displayName)!==null&&O!==void 0?O:f.name,_()},get detail(){var R;return(R=i.detail)!==null&&R!==void 0?R:""},set detail(R){i.detail=R,_()},get description(){var R;return(R=i.description)!==null&&R!==void 0?R:""},set description(R){i.description=R,_()},get supportedLanguages(){return i.supportedLanguages},set supportedLanguages(R){i.supportedLanguages=R,_()},get hasExecutionOrder(){var R;return(R=i.hasExecutionOrder)!==null&&R!==void 0?R:!1},set hasExecutionOrder(R){i.hasExecutionOrder=R,_()},get preloads(){return i.preloads?i.preloads.map(P.NotebookKernelPreload.to):[]},get executeHandler(){return s},set executeHandler(R){s=R!=null?R:l},get interruptHandler(){return c},set interruptHandler(R){c=R,i.supportsInterrupt=Boolean(R),_()},createNotebookCellExecutionTask(R){if(v)throw new Error("notebook controller is DISPOSED");if(!u.has(R.notebook.uri))throw new Error(`notebook controller is NOT associated to notebook: ${R.notebook.uri.toString()}`);return m._extHostNotebook.createNotebookCellExecution(R.notebook.uri,R.index,i.id)},dispose:()=>{v||(v=!0,this._kernelData.delete(S),t.dispose(),n.dispose(),o.dispose(),this._proxy.$removeKernel(S))},onDidReceiveMessage:o.event,postMessage(R,O){return m._proxy.$postMessage(S,O&&m._extHostNotebook.getIdByEditor(O),R)},asWebviewUri(R){return(0,D.asWebviewUri)(m._initData.environment,String(S),R)},updateNotebookAffinity(R,O){m._proxy.$updateNotebookPriority(S,R.uri,O)}};return this._kernelData.set(S,{extensionId:f.identifier,controller:p,onDidReceiveMessage:o,onDidChangeSelection:n,associatedNotebooks:u}),p}$acceptSelection(f,g,a){const d=this._kernelData.get(f);if(d){const E=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(g));a?d.associatedNotebooks.set(E.uri,!0):d.associatedNotebooks.delete(E.uri),d.onDidChangeSelection.fire({selected:a,notebook:E.apiNotebook})}}async $executeCells(f,g,a){const d=this._kernelData.get(f);if(!!d){const E=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(g));if(!E)throw new Error("MISSING notebook");const w=[];for(let S of a){const m=E.getCell(S);m&&w.push(m.apiCell)}try{await d.controller.executeHandler.call(d.controller,w,E.apiNotebook,d.controller)}catch(S){console.error(S)}}}async $cancelCells(f,g,a){const d=this._kernelData.get(f);if(!!d){const E=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(g));if(!E)throw new Error("MISSING notebook");d.controller.interruptHandler&&await d.controller.interruptHandler.call(d.controller,E.apiNotebook);for(let w of a){const S=E.getCell(w);S&&this._extHostNotebook.cancelOneNotebookCellExecution(S)}}}$acceptKernelMessageFromRenderer(f,g,a){const d=this._kernelData.get(f);if(!!d){const E=this._extHostNotebook.getEditorById(g);if(!E)throw new Error(`send message for UNKNOWN editor: ${g}`);d.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:a}))}}}e.ExtHostNotebookKernels=r}),define(ge[64],pe([0,1,5,3,6,23,4,15]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends T.Disposable{constructor(a,d,E,w){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=w,this._id=w.$register(this.name,d,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?A.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(d=>this._proxy.$clear(d,a))}show(a,d){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof a=="boolean"?a:d)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class k extends D{constructor(a,d){super(a,!1,void 0,d)}append(a){super.append(a),this._id.then(d=>this._proxy.$append(d,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class r extends D{constructor(a,d,E){super(a,!0,d,E)}append(a){throw new Error("Not supported")}}class C{constructor(a,d){this.name=a,this._channel=d}append(a){this._channel.then(d=>d.append(a))}appendLine(a){this._channel.then(d=>d.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,d){this._channel.then(E=>E.show(a,d))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=C;let f=class{constructor(a){this._proxy=a.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new k(a,this._proxy)}createOutputChannelFromLogFile(a,d){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new r(a,d,this._proxy)}};f=Ve([xe(0,P.IExtHostRpcService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ge[243],pe([0,1,13,21,3,6,5,2,7,16,17,57]),function(G,e,b,I,T,A,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(g,a,d){const E=g.getProxy(y.MainContext.MainThreadQuickOpen);class w{constructor(i,s){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=s}showQuickPick(i,s,c,h=I.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(i),u=++this._instances,p=E.$show(u,{title:c==null?void 0:c.title,placeHolder:c==null?void 0:c.placeHolder,matchOnDescription:c==null?void 0:c.matchOnDescription,matchOnDetail:c==null?void 0:c.matchOnDetail,ignoreFocusLost:c==null?void 0:c.ignoreFocusOut,canPickMany:c==null?void 0:c.canPickMany},h),R={},O=p.then(()=>R);return Promise.race([O,_]).then(V=>{if(V!==R)return _.then(re=>{const j=[];for(let x=0;x<re.length;x++){const W=re[x];let U,M,F,L,N;typeof W=="string"?U=W:(U=W.label,M=W.description,F=W.detail,L=W.picked,N=W.alwaysShow),j.push({label:U,description:M,handle:x,detail:F,picked:L,alwaysShow:N})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{c.onDidSelectItem(re[x])}),E.$setItems(u,j),p.then(x=>{if(typeof x=="number")return re[x];if(Array.isArray(x))return x.map(W=>re[W])})})}).then(void 0,V=>{if(!(0,k.isPromiseCanceledError)(V))return E.$setError(u,V),Promise.reject(V)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,s=I.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,E.$input(i,typeof this._validateInput=="function",s).then(void 0,c=>{if(!(0,k.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(i){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,s=I.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!!c){const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(_=>_.uri.toString()===c.uri.toString())}}createQuickPick(i,s){const c=new t(i,s,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(i){const s=new n(i,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(i,s){const c=this._sessions.get(i);c&&c._fireDidChangeValue(s)}$onDidAccept(i){const s=this._sessions.get(i);s&&s._fireDidAccept()}$onDidChangeActive(i,s){const c=this._sessions.get(i);c instanceof t&&c._fireDidChangeActive(s)}$onDidChangeSelection(i,s){const c=this._sessions.get(i);c instanceof t&&c._fireDidChangeSelection(s)}$onDidTriggerButton(i,s){const c=this._sessions.get(i);c&&c._fireDidTriggerButton(s)}$onDidHide(i){const s=this._sessions.get(i);s&&s._fireDidHide()}}class S{constructor(i,s){this._extensionId=i,this._onDidDispose=s,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((s,c)=>{const h=s===D.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(h,s)}),this.update({buttons:i.map((s,c)=>({iconPath:m(s.iconPath),tooltip:s.tooltip,handle:s===D.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const s=this._handlesToButtons.get(i);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(i){if(!this._disposed){for(const s of Object.keys(i)){const c=i[s];this._pendingUpdate[s]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function m(o){if(o instanceof D.ThemeIcon)return{id:o.id};const i=v(o),s=l(o);return{dark:typeof i=="string"?P.URI.file(i):i,light:typeof s=="string"?P.URI.file(s):s}}function l(o){return typeof o=="object"&&"light"in o?o.light:o}function v(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends S{constructor(i,s,c){super(i,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((s,c)=>{this._handlesToItems.set(c,s),this._itemsToHandles.set(s,c)}),this.update({items:i.map((s,c)=>({label:s.label,description:s.description,handle:c,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(i){const s=(0,r.coalesce)(i.map(c=>this._handlesToItems.get(c)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(i){const s=(0,r.coalesce)(i.map(c=>this._handlesToItems.get(c)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}}class n extends S{constructor(i,s){super(i,s);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?C.default.Error:C.default.Ignore})}}return new w(a,d)}e.createExtHostQuickOpen=f}),define(ge[244],pe([0,1,2,3,70,6,13,5,17,100,14,27,41]),function(G,e,b,I,T,A,y,P,D,k,r,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(i){if(i)return typeof i.iconPath=="string"?b.URI.file(i.iconPath):i.iconPath}function a(i,s){if(!i.iconPath&&!s.iconPath)return 0;if(i.iconPath){if(!s.iconPath)return 1}else return-1;const c=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath,h=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath;return(0,k.comparePaths)(c,h)}function d(i,s){let c=0;if(i.strikeThrough!==s.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==s.faded)return i.faded?1:-1;if(i.tooltip!==s.tooltip)return(i.tooltip||"").localeCompare(s.tooltip||"");if(c=a(i,s),c!==0)return c;if(i.light&&s.light)c=a(i.light,s.light);else{if(i.light)return 1;if(s.light)return-1}if(c!==0)return c;if(i.dark&&s.dark)c=a(i.dark,s.dark);else{if(i.dark)return 1;if(s.dark)return-1}return c}function E(i,s){if(i.command!==s.command)return i.command<s.command?-1:1;if(i.title!==s.title)return i.title<s.title?-1:1;if(i.tooltip!==s.tooltip){if(i.tooltip!==void 0&&s.tooltip!==void 0)return i.tooltip<s.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(i.arguments===s.arguments)return 0;if(i.arguments)if(s.arguments){if(i.arguments.length!==s.arguments.length)return i.arguments.length-s.arguments.length}else return 1;else return-1;for(let c=0;c<i.arguments.length;c++){const h=i.arguments[c],_=s.arguments[c];if(h!==_)return h<_?-1:1}return 0}function w(i,s){let c=(0,k.comparePaths)(i.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(c!==0)return c;if(i.command&&s.command)c=E(i.command,s.command);else{if(i.command)return 1;if(s.command)return-1}if(c!==0)return c;if(i.decorations&&s.decorations)c=d(i.decorations,s.decorations);else{if(i.decorations)return 1;if(s.decorations)return-1}return c}function S(i,s){for(let c=0;c<i.length;c++)if(i[c]!==s[c])return!1;return!0}function m(i,s){return i.command===s.command&&i.title===s.title&&i.tooltip===s.tooltip&&(i.arguments&&s.arguments?S(i.arguments,s.arguments):i.arguments===s.arguments)}function l(i,s){return(0,D.equals)(i,s,m)}class v{constructor(s,c,h){this._extension=s,this._proxy=c,this._sourceControlHandle=h,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(s){if((0,f.checkProposedApiEnabled)(this._extension),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}focus(){(0,f.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(s,c){(0,f.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,s,c)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=v;class t{constructor(s,c,h,_,u){this._proxy=s,this._commands=c,this._sourceControlHandle=h,this._id=_,this._label=u,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,c){const h=this._resourceStatesCommandsMap.get(s);return h?(0,y.asPromise)(()=>this._commands.executeCommand(h.command,...h.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var s;const c=[...this._resourceStates].sort(w),_=(0,D.sortedDiff)(this._resourceSnapshot,c,w).map(R=>{const O=R.toInsert.map(V=>{const re=this._resourceHandlePool++;this._resourceStatesMap.set(re,V);const j=V.resourceUri,x=g(V.decorations),W=V.decorations&&g(V.decorations.light)||x,U=V.decorations&&g(V.decorations.dark)||x,M=[];let F;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const de=new A.DisposableStore;F=this._commands.converter.toInternal(V.command,de),this._resourceStatesDisposablesMap.set(re,de)}else this._resourceStatesCommandsMap.set(re,V.command);W&&M.push(W),U&&U.toString()!==(W==null?void 0:W.toString())&&M.push(U);const L=V.decorations&&V.decorations.tooltip||"",N=V.decorations&&!!V.decorations.strikeThrough,$=V.decorations&&!!V.decorations.faded,q=V.contextValue||"";return{rawResource:[re,j,M,L,N,$,q,F],handle:re}});return{start:R.start,deleteCount:R.deleteCount,toInsert:O}}),u=_.map(({start:R,deleteCount:O,toInsert:V})=>[R,O,V.map(re=>re.rawResource)]),p=_.reverse();for(const{start:R,deleteCount:O,toInsert:V}of p){const re=V.map(x=>x.handle),j=this._handlesSnapshot.splice(R,O,...re);for(const x of j)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),(s=this._resourceStatesDisposablesMap.get(x))===null||s===void 0||s.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=c,u}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(s,c,h,_,u,p){this._proxy=c,this._commands=h,this._id=_,this._label=u,this._rootUri=p,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new v(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,u,p)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=s;const c=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(!(this._statusBarCommands&&s&&l(this._statusBarCommands,s))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=s;const c=(s||[]).map(h=>this._commands.converter.toInternal(h,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(s,c){const h=new t(this._proxy,this._commands,this.handle,s,c),_=I.Event.once(h.onDidDispose)(()=>this.createdResourceGroups.delete(h));return this.createdResourceGroups.set(h,_),this.eventuallyAddResourceGroups(),h}eventuallyAddResourceGroups(){const s=[],c=[];for(const[h,_]of this.createdResourceGroups){_.dispose();const u=h.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(h),this.eventuallyUpdateResourceStates()});I.Event.once(h.onDidDispose)(()=>{this.updatedResourceGroups.delete(h),u.dispose(),this._groups.delete(h.handle),this._proxy.$unregisterGroup(this.handle,h.handle)}),s.push([h.handle,h.id,h.label,h.features]);const p=h._takeResourceStateSnapshot();p.length>0&&c.push([h.handle,p]),this._groups.set(h.handle,h)}this._proxy.$registerGroups(this.handle,s,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(c=>{const h=c._takeResourceStateSnapshot();h.length!==0&&s.push([c.handle,h])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,T.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,T.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let o=class Un{constructor(s,c,h){this._commands=c,this.logService=h,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=s.getProxy(P.MainContext.MainThreadSCM),this._telemetry=s.getProxy(P.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const u=this._sourceControls.get(_.sourceControlHandle);if(!u)return _;const p=u.getResourceGroup(_.groupHandle);return p?p.getResourceState(_.handle):_}else if(_&&_.$mid===4){const u=this._sourceControls.get(_.sourceControlHandle);return u?u.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const u=this._sourceControls.get(_.handle);return u||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,c,h,_){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,c,h,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const u=Un._handlePool++,p=new n(s,this._proxy,this._commands,c,h,_);this._sourceControls.set(u,p);const R=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(s.identifier))||[];return R.push(p),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(s.identifier),R),p}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const c=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(s.identifier)),h=c&&c[c.length-1];return h&&h.inputBox}$provideOriginalResource(s,c,h){const _=b.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,_.toString());const u=this._sourceControls.get(s);return!u||!u.quickDiffProvider||!u.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>u.quickDiffProvider.provideOriginalResource(_,h)).then(p=>p||null)}$onInputBoxValueChange(s,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const h=this._sourceControls.get(s);return h&&h.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(s,c,h,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,c,h);const u=this._sourceControls.get(s);if(!u)return Promise.resolve(void 0);const p=u.getResourceGroup(c);return p?p.$executeResourceCommand(h,_):Promise.resolve(void 0)}$validateInput(s,c,h){this.logService.trace("ExtHostSCM#$validateInput",s);const _=this._sourceControls.get(s);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>_.inputBox.validateInput(c,h)).then(u=>u?Promise.resolve([u.message,u.type]):Promise.resolve(void 0))}$setSelectedSourceControl(s){var c,h;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&((c=this._sourceControls.get(s))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((h=this._sourceControls.get(this._selectedSourceControlHandle))===null||h===void 0||h.setSelectionState(!1)),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};o._handlePool=0,o=Ve([xe(2,r.ILogService)],o),e.ExtHostSCM=o});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(ge[245],pe([0,1,7,5,164,6]),function(G,e,b,I,T,A){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(f,g,a,d,E=b.StatusBarAlignment.Left,w,S){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,y,f,"f"),tt(this,P,g,"f"),this._id=D.ID_GEN++,this._statusId=a,this._statusName=d,this._alignment=E,this._priority=w,this._accessibilityInformation=S}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!D.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ue(this,P,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ue(this,P,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let g=this._color;this._backgroundColor&&(g=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(f=this._command)===null||f===void 0?void 0:f.internal,g,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,P=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(f){this._messages=[],this._item=f.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const g={message:f};return this._messages.unshift(g),this._update(),new b.Disposable(()=>{const a=this._messages.indexOf(g);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class r{constructor(f,g){this._proxy=f.getProxy(I.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(f,g,a,d,E){return new D(this._proxy,this._commands,f,g,a,d,E)}setStatusBarMessage(f,g){const a=this._statusMessage.setMessage(f);let d;return typeof g=="number"?d=setTimeout(()=>a.dispose(),g):typeof g!="undefined"&&g.then(()=>a.dispose(),()=>a.dispose()),new b.Disposable(()=>{a.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=r}),define(ge[92],pe([0,1,5,3,4]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,D){this._proxy.$registerExtensionStorageKeysToSync(P,D)}getValue(P,D,k){return this._proxy.$getValue(P,D).then(r=>r||k)}setValue(P,D,k){return this._proxy.$setValue(P,D,k)}$acceptValue(P,D,k){this._onDidChangeStorage.fire({shared:P,key:D,value:k})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ge[93],pe([0,1,4,28,14,91,2]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let P=class{constructor(k,r,C){var f;this._logService=r,this._extHostFileSystem=C,this._workspace=(f=k.workspace)!==null&&f!==void 0?f:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const r=this._workspace.id,C=y.URI.joinPath(this._environment.workspaceStorageHome,r);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(f){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),C}catch(f){this._logService.error("[ExtHostStorage]",f);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};P=Ve([xe(0,I.IExtHostInitDataService),xe(1,T.ILogService),xe(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ge[34],pe([0,1,3,5,4,2,15,6,7,165,16,209,21,30,191]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class d{constructor(t,n,o,i){this._proxy=t,this._id=n,this._creationOptions=o,this._name=i,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const s=this;this.value={get name(){return s._name||""},get processId(){return s._pidPromise},get creationOptions(){return s._creationOptions},get exitStatus(){return s._exitStatus},sendText(c,h=!0){s._checkDisposed(),s._proxy.$sendText(s._id,c,h)},show(c){s._checkDisposed(),s._proxy.$show(s._id,c)},hide(){s._checkDisposed(),s._proxy.$hide(s._id)},dispose(){s._disposed||(s._disposed=!0,s._proxy.$dispose(s._id))},get dimensions(){if(!(s._cols===void 0||s._rows===void 0))return{columns:s._cols,rows:s._rows}}}}async create(t,n,o,i,s,c,h,_,u,p,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:o,env:i,icon:s,initialText:c,waitOnExit:h,strictEnv:_,hideFromUser:u,isFeatureTerminal:p,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=d;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let w=1,S=class extends P.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,i]of this._terminalProcesses)i.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new d(this._proxy,(0,g.generateUuid)(),t,t.name),o=new E(t.pty);return n.createExtensionTerminal().then(i=>{const s=this._setupExtHostProcessListeners(i,o);this._terminalProcessDisposables[i]=s}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const i=new E(n),s=this._setupExtHostProcessListeners(t,i);this._terminalProcessDisposables[t]=s}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:n})}async $acceptTerminalDimensions(t,n,o){const i=this._getTerminalById(t);i&&i.setDimensions(n,o)&&this._onDidChangeTerminalDimensions.fire({terminal:i.value,dimensions:i.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,o){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,o)}async $acceptTerminalTitleChange(t,n){const o=this._getTerminalById(t);o&&(o.name=n)}async $acceptTerminalClosed(t,n){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const i=this._terminals.splice(o,1)[0];i.setExitCode(n),this._onDidCloseTerminal.fire(i.value)}}$acceptTerminalOpened(t,n,o,i){if(n){const h=this._getTerminalObjectIndexById(this._terminals,n);if(h!==null){this._terminals[h]._id=t,this._onDidOpenTerminal.fire(this.terminals[h]),this._terminals[h].isOpen=!0;return}}const s={name:i.name,shellPath:i.executable,shellArgs:i.args,cwd:typeof i.cwd=="string"?i.cwd:A.URI.revive(i.cwd),env:i.env,hideFromUser:i.hideFromUser},c=new d(this._proxy,t,s,o);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(t,n){const o=this._getTerminalById(t);o&&o._setProcessId(n)}async $startExtensionTerminal(t,n){const o=this._getTerminalById(t);if(!o)return{message:(0,k.localize)(0,null,t)};o.isOpen||await new Promise(s=>{const c=this.onDidOpenTerminal(async h=>{h===o.value&&(c.dispose(),s())})});const i=this._terminalProcesses.get(t);i?i.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const o=new P.DisposableStore;o.add(n.onProcessReady(s=>this._proxy.$sendProcessReady(t,s.pid,s.cwd))),o.add(n.onProcessTitleChanged(s=>this._proxy.$sendProcessTitle(t,s))),this._bufferer.startBuffering(t,n.onProcessData),o.add(n.onProcessExit(s=>this._onProcessExit(t,s))),n.onProcessOverrideDimensions&&o.add(n.onProcessOverrideDimensions(s=>this._proxy.$sendOverrideDimensions(t,s))),this._terminalProcesses.set(t,n);const i=this._extensionTerminalAwaitingStart[t];return i&&n instanceof E&&(n.startSendingEvents(i.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(n)}$acceptProcessResize(t,n,o){var i;try{(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,o)}catch(s){if(s.code!=="EPIPE"&&s.code!=="ERR_IPC_CHANNEL_CLOSED")throw s}}$acceptProcessShutdown(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const i=this._terminalLinkCancellationSource.get(t);i&&i.dispose(!0);const s=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,s);const c=[],h={terminal:o.value,line:n},_=[];for(const R of this._linkProviders)_.push(new Promise(async O=>{s.token.onCancellationRequested(()=>O({provider:R,links:[]}));const V=await R.provideTerminalLinks(h,s.token)||[];s.token.isCancellationRequested||O({provider:R,links:V})}));const u=await Promise.all(_);if(s.token.isCancellationRequested)return[];const p=new Map;for(const R of u)R&&R.links.length>0&&c.push(...R.links.map(O=>{const V={id:w++,startIndex:O.startIndex,length:O.length,label:O.tooltip};return p.set(V.id,{provider:R.provider,link:O}),V}));return this._terminalLinkCache.set(t,p),c}$activateLink(t,n){var o;const i=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(n);!i||i.provider.handleTerminalLink(i.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const o=this._getTerminalObjectIndexById(t,n);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,n){let o=null;return t.some((i,s)=>i._id===n?(o=s,!0):!1),o}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new m,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const o=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const o=n[0],i=new m(n[1]);this._setEnvironmentVariableCollection(o,i)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};S=Ve([xe(1,y.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class m{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const o=this.map.get(t);(!o||o.value!==n.value||o.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((o,i)=>t.call(n,i,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=m;let l=class extends S{constructor(t){super(!1,t)}createTerminal(t,n,o){throw new r.NotSupportedError}createTerminalFromOptions(t){throw new r.NotSupportedError}getDefaultShell(t,n){throw new r.NotSupportedError}getDefaultShellArgs(t,n){throw new r.NotSupportedError}async getDefaultShellAndArgs(t){throw new r.NotSupportedError}$getAvailableProfiles(t){throw new r.NotSupportedError}};l=Ve([xe(0,y.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l}),define(ge[246],pe([0,1,3,17,5,125,20,7]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(r,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=r.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(f=>this._onDidChangeVisibleTextEditors.fire(f)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(f=>this._onDidChangeActiveTextEditor.fire(f))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(r){const C=this._extHostDocumentsAndEditors.allEditors();return r?C:C.map(f=>f.value)}async showTextDocument(r,C,f){let g;typeof C=="number"?g={position:y.ViewColumn.from(C),preserveFocus:f}:typeof C=="object"?g={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?y.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:g={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(r.uri,g),d=a&&this._extHostDocumentsAndEditors.getEditor(a);if(d)return d.value;throw a?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}createTextEditorDecorationType(r){return new A.TextEditorDecorationType(this._proxy,r).value}$acceptEditorPropertiesChanged(r,C){const f=this._extHostDocumentsAndEditors.getEditor(r);if(!f)throw new Error("unknown text editor");if(C.options&&f._acceptOptions(C.options),C.selections){const g=C.selections.selections.map(y.Selection.to);f._acceptSelections(g)}if(C.visibleRanges){const g=I.coalesce(C.visibleRanges.map(y.Range.to));f._acceptVisibleRanges(g)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:f.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const g=P.TextEditorSelectionChangeKind.fromValue(C.selections.source),a=C.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:f.value,selections:a,kind:g})}if(C.visibleRanges){const g=I.coalesce(C.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:f.value,visibleRanges:g})}}$acceptEditorPositionData(r){for(const C in r){const f=this._extHostDocumentsAndEditors.getEditor(C);if(!f)throw new Error("Unknown text editor");const g=y.ViewColumn.to(r[C]);f.value.viewColumn!==g&&(f._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:f.value,viewColumn:g}))}}getDiffInformation(r){return Promise.resolve(this._proxy.$getDiffInformation(r))}}e.ExtHostEditors=D});var Jt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(ge[247],pe([0,1,2,4,5,6,7]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class P{constructor(r,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=r.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:f=>{var g,a;if(f&&f.$mid===11){const d=f.uri===void 0?void 0:b.URI.revive(f.uri);return(a=(g=this._itemsBySourceAndUriMap.get(f.source))===null||g===void 0?void 0:g.get(D(d)))===null||a===void 0?void 0:a.get(f.handle)}return f}})}async $getTimeline(r,C,f,g,a){const d=this._providers.get(r);return d==null?void 0:d.provideTimeline(b.URI.revive(C),f,g,a)}registerTimelineProvider(r,C,f,g){const a=new A.DisposableStore,d=this.convertTimelineItem(C.id,g,a).bind(this);let E;C.onDidChange&&(E=C.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:C.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:r,onDidChange:void 0,async provideTimeline(S,m,l,v){var t;(v==null?void 0:v.resetCache)&&(a.clear(),(t=w.get(C.id))===null||t===void 0||t.clear());const n=await C.provideTimeline(S,m,l);if(n!=null){const o=d(S,v);return Object.assign(Object.assign({},n),{source:C.id,items:n.items.map(o)})}},dispose(){var S;for(const m of w.values())(S=m.get(C.id))===null||S===void 0||S.clear();E==null||E.dispose(),a.dispose()}}))}convertTimelineItem(r,C,f){return(g,a)=>{let d;if(a==null?void 0:a.cacheResults){let E=this._itemsBySourceAndUriMap.get(r);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(r,E));const w=D(g);d=E.get(w),d===void 0&&(d=new Map,E.set(w,d))}return E=>{var w,S;const{iconPath:m}=E,l=Jt(E,["iconPath"]),v=`${r}|${(w=E.id)!==null&&w!==void 0?w:E.timestamp}`;d==null||d.set(v,E);let t,n,o;return E.iconPath&&(m instanceof y.ThemeIcon?o={id:m.id}:b.URI.isUri(m)?(t=m,n=m):{light:t,dark:n}=m),Object.assign(Object.assign({},l),{id:(S=l.id)!==null&&S!==void 0?S:void 0,handle:v,source:r,command:E.command?C.toInternal(E.command,f):void 0,icon:t,iconDark:n,themeIcon:o,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(r){if(this._providers.get(r.id))throw new Error(`Timeline Provider ${r.id} already exists.`);return this._proxy.$registerTimelineProvider({id:r.id,label:r.label,scheme:r.scheme}),this._providers.set(r.id,r),(0,A.toDisposable)(()=>{var f;for(const g of this._itemsBySourceAndUriMap.values())(f=g.get(r.id))===null||f===void 0||f.clear();this._providers.delete(r.id),this._proxy.$unregisterTimelineProvider(r.id),r.dispose()})}}e.ExtHostTimeline=P;function D(k){return k==null?void 0:k.toString()}}),define(ge[248],pe([0,1,6,12,2,5]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,k,r,C){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const f=C.schemes.find(g=>!y.supportedSchemes.has(g));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,r),this._proxy.$registerUriOpener(k,C.schemes,D,C.label),(0,b.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(D,k,r){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener with id: ${D}`);const f=T.URI.revive(k);return C.canOpenExternalUri(f,r)}async $openUri(D,k,r){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener id: '${D}'`);return C.openExternalUri(T.URI.revive(k.resolvedUri),{sourceUri:T.URI.revive(k.sourceUri)},r)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(ge[249],pe([0,1,5,2,6,16,27]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(k,r){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const C=P.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(C,r),this._proxy.$registerUriHandler(C,k),(0,T.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(k,r){const C=this.handlers.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(I.URI.revive(r))}catch(f){(0,A.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(k){return I.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=P,P.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(ge[65],pe([0,1,3,2,176,201,88,5]),function(G,e,b,I,T,A,y,P){"use strict";var D,k,r,C,f,g,a,d,E,w,S,m;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(h,_,u,p,R,O,V){D.set(this,void 0),k.set(this,void 0),r.set(this,void 0),C.set(this,void 0),f.set(this,void 0),g.set(this,void 0),a.set(this,""),d.set(this,void 0),E.set(this,!1),w.set(this,!1),S.set(this,!1),this._onMessageEmitter=new b.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,m.set(this,new b.Emitter),this._onDidDispose=Ue(this,m,"f").event,tt(this,D,h,"f"),tt(this,k,_,"f"),tt(this,d,u,"f"),tt(this,C,p,"f"),tt(this,f,R,"f"),tt(this,g,O,"f"),tt(this,S,v(O),"f"),tt(this,r,V,"f")}dispose(){tt(this,E,!0,"f"),Ue(this,m,"f").fire(),Ue(this,m,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return tt(this,w,!0,"f"),(0,y.asWebviewUri)(Ue(this,C,"f"),Ue(this,D,"f"),h)}get cspSource(){return Ue(this,C,"f").webviewCspSource.replace("{{uuid}}",Ue(this,D,"f"))}get html(){return this.assertNotDisposed(),Ue(this,a,"f")}set html(h){this.assertNotDisposed(),Ue(this,a,"f")!==h&&(tt(this,a,h,"f"),!Ue(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(tt(this,w,!0,"f"),Ue(this,r,"f").report("Webview vscode-resource: uris",Ue(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,k,"f").$setHtml(Ue(this,D,"f"),h))}get options(){return this.assertNotDisposed(),Ue(this,d,"f")}set options(h){this.assertNotDisposed(),Ue(this,k,"f").$setOptions(Ue(this,D,"f"),o(Ue(this,g,"f"),Ue(this,f,"f"),h)),tt(this,d,h,"f")}async postMessage(h){if(Ue(this,E,"f"))return!1;const _=(0,A.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Ue(this,S,"f")});return Ue(this,k,"f").$postMessage(Ue(this,D,"f"),_.message,..._.buffers)}assertNotDisposed(){if(Ue(this,E,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=l,D=new WeakMap,k=new WeakMap,r=new WeakMap,C=new WeakMap,f=new WeakMap,g=new WeakMap,a=new WeakMap,d=new WeakMap,E=new WeakMap,w=new WeakMap,S=new WeakMap,m=new WeakMap;function v(c){try{const h=(0,T.normalizeVersion)((0,T.parseVersion)(c.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch(h){return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(h,_,u,p,R){this.initData=_,this.workspace=u,this._logService=p,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=h.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(h,_,...u){const p=this.getWebview(h);if(p){const{message:R}=(0,A.deserializeWebviewMessage)(_,u);p._onMessageEmitter.fire(R)}}$onMissingCsp(h,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,_,u){const p=new l(h,this._webviewProxy,i(_),this.initData,this.workspace,u,this._deprecationService);return this._webviews.set(h,p),p._onDidDispose(()=>{this._webviews.delete(h)}),p}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=t;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function o(c,h,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||s(c,h)}}e.serializeWebviewOptions=o;function i(c){var h;return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,portMapping:c.portMapping,localResourceRoots:(h=c.localResourceRoots)===null||h===void 0?void 0:h.map(_=>I.URI.from(_))}}e.reviveOptions=i;function s(c,h){return[...((h==null?void 0:h.getWorkspaceFolders())||[]).map(_=>_.uri),c.extensionLocation]}}),define(ge[250],pe([0,1,21,74,6,12,25,2,20,65,86,5,7]),function(G,e,b,I,T,A,y,P,D,k,r,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new r.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class a{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,o){const i=this.key(t,n.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const s=new g(n,o);return this._documents.set(i,s),s}delete(t,n){const o=this.key(t,n.uri);this._documents.delete(o)}key(t,n){return`${t}@@@${n}`}}var d;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(d||(d={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,o){return this.add(0,t,n,o)}addCustomProvider(t,n,o){return this.add(1,t,n,o)}get(t){return this._providers.get(t)}add(t,n,o,i){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:o,provider:i}),new f.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,o,i,s){this._extHostDocuments=n,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=s,this._editorProviders=new E,this._documents=new a,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,o,i){const s=new T.DisposableStore;return S(o)?(s.add(this._editorProviders.addTextProvider(n,t,o)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(n,t,o)),this.supportEditing(o)&&s.add(o.onDidChangeCustomDocument(c=>{const h=this.getCustomDocumentEntry(n,c.document.uri);if(m(c)){const _=h.addEdit(c);this._proxy.$onDidEdit(c.document.uri,n,_,c.label)}else this._proxy.$onContentChange(c.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),f.Disposable.from(s,new f.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,o,i,s){var c;const h=this._editorProviders.get(n);if(!h)throw new Error(`No provider found for '${n}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${n}'`);const _=P.URI.revive(t),u=await h.provider.openCustomDocument(_,{backupId:o,untitledDocumentData:i==null?void 0:i.buffer},s);let p;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(p=(c=this._extensionStoragePaths.workspaceValue(h.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(n,u,p),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,n){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const i=P.URI.revive(t),{document:s}=this.getCustomDocumentEntry(n,i);this._documents.delete(n,s),s.dispose()}async $resolveWebviewEditor(t,n,o,i,s,c){const h=this._editorProviders.get(o);if(!h)throw new Error(`No provider found for '${o}'`);const _=D.ViewColumn.to(s),u=this._extHostWebview.createNewWebview(n,i.webviewOptions,h.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(n,o,i.title,_,i.panelOptions,u),R=P.URI.revive(t);switch(h.type){case 1:{const{document:O}=this.getCustomDocumentEntry(o,R);return h.provider.resolveCustomEditor(O,p,c)}case 0:{const O=this._extHostDocuments.getDocument(R);return h.provider.resolveCustomTextEditor(O,p,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,o){this.getCustomDocumentEntry(n,t).disposeEdits(o)}async $onMoveCustomEditor(t,n,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const c=P.URI.revive(n),h=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(h,s,b.CancellationToken.None)}async $undo(t,n,o,i){return this.getCustomDocumentEntry(n,t).undo(o,i)}async $redo(t,n,o,i){return this.getCustomDocumentEntry(n,t).redo(o,i)}async $revert(t,n,o){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(t,n,o){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(t,n,o,i){const s=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(s.document,P.URI.revive(o),i)}async $backup(t,n,o){const i=this.getCustomDocumentEntry(n,t),c=await this.getCustomEditorProvider(n).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(c),c.id}getCustomDocumentEntry(t,n){const o=this._documents.get(t,P.URI.revive(n));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const n=this._editorProviders.get(t),o=n==null?void 0:n.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function S(v){return typeof v.resolveCustomTextEditor=="function"}function m(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function l(v){const t=v.scheme===A.Schemas.file||v.scheme===A.Schemas.untitled?v.fsPath:v.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(ge[251],pe([0,1,3,6,2,30,20,65,5,7]),function(G,e,b,I,T,A,y,P,D,k){"use strict";var r,C,f,g,a,d,E,w,S,m,l,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(c,h,_,u,p,R,O){super();r.set(this,void 0),C.set(this,void 0),f.set(this,void 0),g.set(this,void 0),a.set(this,void 0),d.set(this,void 0),E.set(this,void 0),w.set(this,void 0),S.set(this,!0),m.set(this,!0),l.set(this,!1),v.set(this,this._register(new b.Emitter)),this.onDidDispose=Ue(this,v,"f").event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,tt(this,r,c,"f"),tt(this,C,h,"f"),tt(this,f,_,"f"),tt(this,a,R,"f"),tt(this,w,p,"f"),tt(this,d,u,"f"),tt(this,g,O,"f")}dispose(){Ue(this,l,"f")||(tt(this,l,!0,"f"),Ue(this,v,"f").fire(),Ue(this,C,"f").$disposeWebview(Ue(this,r,"f")),Ue(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,g,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,f,"f")}get title(){return this.assertNotDisposed(),Ue(this,d,"f")}set title(c){this.assertNotDisposed(),Ue(this,d,"f")!==c&&(tt(this,d,c,"f"),Ue(this,C,"f").$setTitle(Ue(this,r,"f"),c))}get iconPath(){return this.assertNotDisposed(),Ue(this,E,"f")}set iconPath(c){this.assertNotDisposed(),Ue(this,E,"f")!==c&&(tt(this,E,c,"f"),Ue(this,C,"f").$setIconPath(Ue(this,r,"f"),T.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Ue(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,w,"f")=="number"&&Ue(this,w,"f")<0))return Ue(this,w,"f")}get active(){return this.assertNotDisposed(),Ue(this,m,"f")}get visible(){return this.assertNotDisposed(),Ue(this,S,"f")}_updateViewState(c){Ue(this,l,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(tt(this,m,c.active,"f"),tt(this,S,c.visible,"f"),tt(this,w,c.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(c,h){this.assertNotDisposed(),Ue(this,C,"f").$reveal(Ue(this,r,"f"),{viewColumn:c?y.ViewColumn.from(c):void 0,preserveFocus:!!h})}assertNotDisposed(){if(Ue(this,l,"f"))throw new Error("Webview is disposed")}}r=new WeakMap,C=new WeakMap,f=new WeakMap,g=new WeakMap,a=new WeakMap,d=new WeakMap,E=new WeakMap,w=new WeakMap,S=new WeakMap,m=new WeakMap,l=new WeakMap,v=new WeakMap,t=new WeakMap;class o{constructor(c,h,_){this.webviews=h,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(c,h,_,u,p={}){const R=typeof u=="object"?u.viewColumn:u,O={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof u=="object"&&!!u.preserveFocus},V=(0,P.shouldSerializeBuffersForPostMessage)(c),re=o.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(c),re,h,{title:_,panelOptions:i(p),webviewOptions:(0,P.serializeWebviewOptions)(c,this.workspace,p),serializeBuffersForPostMessage:V},O);const j=this.webviews.createNewWebview(re,p,c);return this.createNewWebviewPanel(re,h,_,R,p,j)}$onDidChangeWebviewPanelViewStates(c){const h=Object.keys(c);h.sort((_,u)=>{const p=c[_],R=c[u];return p.active?1:R.active?-1:+p.visible-+R.visible});for(const _ of h){const u=this.getWebviewPanel(_);if(!!u){const p=c[_];u._updateViewState({active:p.active,visible:p.visible,viewColumn:y.ViewColumn.to(p.position)})}}}async $onDidDisposeWebviewPanel(c){const h=this.getWebviewPanel(c);h==null||h.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,h,_){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:_,extension:c}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(c)}),new k.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(c,h,_,u){const p=this._serializers.get(h);if(!p)throw new Error(`No serializer found for '${h}'`);const{serializer:R,extension:O}=p,V=this.webviews.createNewWebview(c,_.webviewOptions,O),re=this.createNewWebviewPanel(c,h,_.title,u,_.panelOptions,V);await R.deserializeWebviewPanel(re,_.state)}createNewWebviewPanel(c,h,_,u,p,R){const O=new n(c,this._proxy,h,_,u,p,R);return this._webviewPanels.set(c,O),O}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=o;function i(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(ge[252],pe([0,1,3,6,65,5,7]),function(G,e,b,I,T,A,y){"use strict";var P,D,k,r,C,f,g,a,d,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends I.Disposable{constructor(l,v,t,n,o,i){super();P.set(this,void 0),D.set(this,void 0),k.set(this,void 0),r.set(this,void 0),C.set(this,!1),f.set(this,void 0),g.set(this,void 0),a.set(this,void 0),d.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=Ue(this,d,"f").event,E.set(this,this._register(new b.Emitter)),this.onDidDispose=Ue(this,E,"f").event,tt(this,k,t,"f"),tt(this,g,n,"f"),tt(this,P,l,"f"),tt(this,D,v,"f"),tt(this,r,o,"f"),tt(this,f,i,"f")}dispose(){Ue(this,C,"f")||(tt(this,C,!0,"f"),Ue(this,E,"f").fire(),Ue(this,r,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(l){this.assertNotDisposed(),Ue(this,g,"f")!==l&&(tt(this,g,l,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,P,"f"),l))}get description(){return this.assertNotDisposed(),Ue(this,a,"f")}set description(l){this.assertNotDisposed(),Ue(this,a,"f")!==l&&(tt(this,a,l,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,P,"f"),l))}get visible(){return Ue(this,f,"f")}get webview(){return Ue(this,r,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(l){l===Ue(this,f,"f")||Ue(this,C,"f")||(tt(this,f,l,"f"),Ue(this,d,"f").fire())}show(l){this.assertNotDisposed(),Ue(this,D,"f").$show(Ue(this,P,"f"),!!l)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,D=new WeakMap,k=new WeakMap,r=new WeakMap,C=new WeakMap,f=new WeakMap,g=new WeakMap,a=new WeakMap,d=new WeakMap,E=new WeakMap;class S{constructor(l,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,v,t,n){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(l),v,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(l,v,t,n,o){const i=this._viewProviders.get(v);if(!i)throw new Error(`No view provider found for '${v}'`);const{provider:s,extension:c}=i,h=this._extHostWebview.createNewWebview(l,{},c),_=new w(l,this._proxy,v,t,h,!0);this._webviewViews.set(l,_),await s.resolveWebviewView(_,{state:n},o)}async $onDidChangeWebviewViewVisibility(l,v){this.getWebviewView(l)._setVisible(v)}async $disposeWebviewView(l){const v=this.getWebviewView(l);this._webviewViews.delete(l),v.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const v=this._webviewViews.get(l);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=S}),define(ge[128],pe([0,1,3,5,2,12,9,4,15]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class xn{constructor(C){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=C.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,f){let g;if(typeof C=="string"){g=C;try{C=T.URI.parse(C)}catch(a){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,y.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,g,f)}async asExternalUri(C,f){if((0,y.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const g=await this._proxy.$asExternalUri(C,f);return T.URI.from(g)}};k.InitialState={focused:!0},k=Ve([xe(0,D.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ge[253],pe([0,1,8,48,30,51,6,5,2,15]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let r=class extends y.Disposable{constructor(f,g){super();const a=f.getProxy(P.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async d=>{const E=D.URI.file((0,b.join)((0,I.tmpdir)(),(0,T.generateUuid)()));return await a.$download(d,E),E})}};r=Ve([xe(0,k.IExtHostRpcService),xe(1,A.IExtHostCommands)],r),e.ExtHostDownloadService=r}),define(ge[254],pe([0,1,2,8,146,26,37,64,28,15,6,14,114,45]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class a{constructor(S,m){this.file=m,this.appender=(0,f.createRotatingLogger)(S,m,30*g.ByteSize.MB,1),this.appender.clearFormatters()}append(S){this.appender.critical(S)}flush(){this.appender.flush()}}class d extends P.AbstractExtHostOutputChannel{constructor(S,m,l){super(S,!1,b.URI.file(m.file),l);this._appender=m}append(S){super.append(S),this._appender.append(S),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(S,m){this._appender.flush(),super.show(S,m)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=d;let E=class extends P.ExtHostOutputService{constructor(S,m,l){super(S);this.logService=m,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new r.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(S){if(S){const m=this._channels.get(S);m&&(this._visibleChannelDisposable.value=m.onDidAppend(()=>m.update()))}}createOutputChannel(S){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const m=this._doCreateOutChannel(S);return m.then(l=>l._id.then(v=>this._channels.set(v,l))),new P.LazyOutputChannel(S,m)}async _doCreateOutChannel(S){try{const m=(0,I.join)(this._logsLocation.fsPath,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await A.SymlinkSupport.existsDirectory(m)||await y.promises.mkdir(m,{recursive:!0});const v=`${this._namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=b.URI.file((0,I.join)(m,`${v}.log`)),n=new a(v,t.fsPath);return new d(S,n,this._proxy)}catch(m){return this.logService.error(m),new P.ExtHostPushOutputChannel(S,this._proxy)}}};E=Ve([xe(0,k.IExtHostRpcService),xe(1,C.ILogService),xe(2,D.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(ge[255],pe([0,1,5,15,6,28,2,38,25,37,26,7,10,50,3,73,14]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(h,_,u){this.remoteAddress=h,this.localAddress=_,this._dispose=u,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function S(c){const h=c.trim().split(`
`),_=[];return h.forEach(p=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(p);R&&R.length>=3&&_.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),_.reduce((p,R)=>(p[R.socket]=R,p),{})}e.getSockets=S;function m(...c){const h=[].concat(...c.map(v));return[...new Map(h.filter(_=>_.st==="0A").map(_=>{const u=_.local_address.split(":");return{socket:parseInt(_.inode,10),ip:l(u[0]),port:parseInt(u[1],16)}}).map(_=>[_.ip+":"+_.port,_])).values()]}e.loadListeningPorts=m;function l(c){let h="";if(c.length===8)for(let _=c.length-2;_>=0;_-=2)h+=parseInt(c.substr(_,2),16),_!==0&&(h+=".");else for(let _=c.length-4;_>=0;_-=4)h+=parseInt(c.substr(_,4),16).toString(16),_!==0&&(h+=":");return h}e.parseIpAddress=l;function v(c){const h=c.trim().split(`
`),_=h.shift().trim().split(/\s+/).filter(p=>p!=="rx_queue"&&p!=="tm->when");return h.map(p=>p.trim().split(/\s+/).reduce((R,O,V)=>(R[_[V]||V]=O,R),{}))}e.loadConnectionTable=v;function t(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function n(c){const h=c.trim().split(`
`),_=[];return h.forEach(u=>{const p=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(u);p&&p.length>=4&&_.push({pid:parseInt(p[1],10),ppid:parseInt(p[2]),cmd:p[3]})}),_}e.getRootProcesses=n;async function o(c,h,_){const u=_.reduce((R,O)=>(R[O.pid]=O,R),{}),p=[];return c.forEach(({socket:R,ip:O,port:V})=>{var re;const j=h[R]?h[R].pid:void 0,x=j?(re=u[j])===null||re===void 0?void 0:re.cmd:void 0;j&&x&&!t(x)&&p.push({host:O,port:V,detail:x,pid:j})}),p}e.findPorts=o;function i(c,h,_){const u=new Map,p=n(h);for(const R of c){const O=_.get(R.port);if(O){u.set(R.port,O);continue}const V=p.find(re=>re.cmd.includes(`${R.port}`));if(V){let re=V,j;do j=p.find(x=>x.ppid===re.pid),j&&(re=j);while(j);u.set(R.port,{host:R.ip,port:R.port,pid:re.pid,detail:re.cmd,ppid:re.ppid})}else u.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return u}e.tryFindRootPorts=i;let s=class extends T.Disposable{constructor(h,_,u){super();this.logService=u,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new a.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(b.MainContext.MainThreadTunnelService),f.isLinux&&_.remote.isRemote&&_.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,_){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${_.remoteAddress.host}:${_.remoteAddress.port}.`);const u=await this._proxy.$openTunnel(_,h.displayName);if(u){const p=new w(u.remoteAddress,u.localAddress,()=>this._proxy.$closeTunnel(u.remoteAddress));return this._register(p),p}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,_){const u=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(u,{selector:h,provider:_}),this._proxy.$registerPortsAttributesProvider(h,u),new C.Disposable(()=>{this._portAttributesProviders.delete(u),this._proxy.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(h,_,u,p,R){const O=[];for(const re of h){const j=this._portAttributesProviders.get(re);if(!j)return[];O.push(...await Promise.all(_.map(async x=>j.provider.providePortAttributes(x,u,p,R))))}const V=O.filter(re=>!!re);return V.length>0?V.map(re=>({autoForwardAction:re.autoForwardAction,port:re.port})):[]}async $registerCandidateFinder(h){if(!(h&&this._candidateFindingEnabled)){this._candidateFindingEnabled=h;let _=new d.MovingAverage,u;for(;this._candidateFindingEnabled;){const p=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(V=>V.port).join(", ")}`);const O=new Date().getTime()-p;_.update(O),(!u||JSON.stringify(u)!==JSON.stringify(R))&&(u=R,await this._proxy.$onFoundNewCandidates(u)),await new Promise(V=>setTimeout(()=>V(),this.calculateDelay(_.value)))}}}async setTunnelExtensionFunctions(h){var _;return h?(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory&&(this._forwardPortProvider=h.tunnelFactory,this._proxy.$setTunnelProvider((_=h.tunnelFeatures)!==null&&_!==void 0?_:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,_){if(this._extensionTunnels.has(h.host)){const u=this._extensionTunnels.get(h.host);u.has(h.port)&&(_&&u.get(h.port).disposeListener.dispose(),await u.get(h.port).tunnel.dispose(),u.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,_){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this._forwardPortProvider(h,_);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const p=await u;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const R=this._register(p.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(p.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:p,disposeListener:R}),g.TunnelDto.fromApiTunnel(p)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(u){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const _=await Promise.all(h.map(p=>{var R;return this._showCandidatePort(p.host,p.port,(R=p.detail)!==null&&R!==void 0?R:"")})),u=h.filter((p,R)=>_[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(p=>p.port).join(", ")} to ${u.map(p=>p.port).join(", ")}`),u}async findCandidatePorts(){let h="",_="";try{h=await k.promises.readFile("/proc/net/tcp","utf8"),_=await k.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const u=m(h,_),p=await new Promise(U=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,F,L)=>{U(F)})}),R=S(p),O=await r.readdir("/proc"),V=[];for(let U of O)try{const M=Number(U),F=D.joinPath(y.URI.file("/proc"),U);if((await k.promises.stat(F.fsPath)).isDirectory()&&!isNaN(M)){const N=await k.promises.readlink(D.joinPath(F,"cwd").fsPath),$=await k.promises.readFile(D.joinPath(F,"cmdline").fsPath,"utf8");V.push({pid:M,cwd:N,cmd:$})}}catch(M){}const re=[],j=u.filter(U=>{const M=R[U.socket];return M||re.push(U),M}),x=o(j,R,V);let W;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${re.length}`),re.length>0){const U=await new Promise(M=>{(0,P.exec)("ps -F -A -l | grep root",(F,L,N)=>{M(L)})});this._foundRootPorts=i(re,U,this._foundRootPorts),W=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${W.join(", ")}`)}return x.then(U=>W?U.concat(W):U)}};s=Ve([xe(0,I.IExtHostRpcService),xe(1,A.IExtHostInitDataService),xe(2,E.ILogService)],s),e.ExtHostTunnelService=s}),define(ge[256],pe([0,1,13,21,16,3,6,102,226,126,23]),function(G,e,b,I,T,A,y,P,D,k,r){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function f(i,s){try{return JSON.stringify(i,s)}catch(c){return"null"}}function g(i,s){return JSON.stringify(i,s)}function a(i){return i?(s,c)=>c&&c.$mid===1?i.transformOutgoing(c):c:null}var d;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},S=Symbol.for("rpcProtocol"),m=Symbol.for("rpcProxy");class l extends y.Disposable{constructor(s,c=null,h=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=c,this._uriTransformer=h,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,u=k.ProxyIdentifier.count;_<u;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?(0,P.transformIncomingURIs)(s,this._uriTransformer):s}getProxy(s){const{nid:c,sid:h}=s;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,h)),this._proxies[c]}_createProxy(s,c){let h={get:(_,u)=>(typeof u=="string"&&!_[u]&&u.charCodeAt(0)===36&&(_[u]=(...p)=>this._remoteCall(s,u,p)),u===m?c:_[u])};return new Proxy(Object.create(null),h)}set(s,c){return this._locals[s.nid]=c,c}assertRegistered(s){for(let c=0,h=s.length;c<h;c++){const _=s[c];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(s){if(!this._isDisposed){const c=s.byteLength,h=v.read(s,0),_=h.readUInt8(),u=h.readUInt32();switch(_){case 1:case 2:{let{rpcId:p,method:R,args:O}=t.deserializeRequestJSONArgs(h);this._uriTransformer&&(O=(0,P.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(c,u,p,R,O,_===2);break}case 3:case 4:{let{rpcId:p,method:R,args:O}=t.deserializeRequestMixedArgs(h);this._uriTransformer&&(O=(0,P.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(c,u,p,R,O,_===4);break}case 5:{this._logger&&this._logger.logIncoming(c,u,0,"ack"),this._onDidReceiveAcknowledge(u);break}case 6:{this._receiveCancel(c,u);break}case 7:{this._receiveReply(c,u,void 0);break}case 9:{let p=t.deserializeReplyOKJSON(h);this._uriTransformer&&(p=(0,P.transformIncomingURIs)(p,this._uriTransformer)),this._receiveReply(c,u,p);break}case 8:{let p=t.deserializeReplyOKVSBuffer(h);this._receiveReply(c,u,p);break}case 10:{let p=t.deserializeReplyErrError(h);this._uriTransformer&&(p=(0,P.transformIncomingURIs)(p,this._uriTransformer)),this._receiveReplyErr(c,u,p);break}case 11:{this._receiveReplyErr(c,u,void 0);break}default:console.error("received unexpected message"),console.error(s)}}}_receiveRequest(s,c,h,_,u,p){this._logger&&this._logger.logIncoming(s,c,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(h)}.${_}(`,u);const R=String(c);let O,V;if(p){const j=new I.CancellationTokenSource;u.push(j.token),O=this._invokeHandler(h,_,u),V=()=>j.cancel()}else O=this._invokeHandler(h,_,u),V=w;this._cancelInvokedHandlers[R]=V;const re=t.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(re.byteLength,c,1,"ack"),this._protocol.send(re),O.then(j=>{delete this._cancelInvokedHandlers[R];const x=t.serializeReplyOK(c,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,c,1,"reply:",j),this._protocol.send(x)},j=>{delete this._cancelInvokedHandlers[R];const x=t.serializeReplyErr(c,j);this._logger&&this._logger.logOutgoing(x.byteLength,c,1,"replyErr:",j),this._protocol.send(x)})}_receiveCancel(s,c){this._logger&&this._logger.logIncoming(s,c,1,"receiveCancel");const h=String(c);this._cancelInvokedHandlers[h]&&this._cancelInvokedHandlers[h]()}_receiveReply(s,c,h){this._logger&&this._logger.logIncoming(s,c,0,"receiveReply:",h);const _=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const u=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],u.resolveOk(h)}}_receiveReplyErr(s,c,h){this._logger&&this._logger.logIncoming(s,c,0,"receiveReplyErr:",h);const _=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const u=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let p;h&&(h.$isError?(p=new Error,p.name=h.name,p.message=h.message,p.stack=h.stack):p=h),u.resolveErr(p)}}_invokeHandler(s,c,h){try{return Promise.resolve(this._doInvokeHandler(s,c,h))}catch(_){return Promise.reject(_)}}_doInvokeHandler(s,c,h){const _=this._locals[s];if(!_)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(s));let u=_[c];if(typeof u!="function")throw new Error("Unknown method "+c+" on actor "+(0,k.getStringIdentifierForProxy)(s));return u.apply(_,h)}_remoteCall(s,c,h){if(this._isDisposed)return Promise.reject(T.canceled());let _=null;if(h.length>0&&I.CancellationToken.isCancellationToken(h[h.length-1])&&(_=h.pop()),_&&_.isCancellationRequested)return Promise.reject(T.canceled());const u=t.serializeRequestArguments(h,this._uriReplacer),p=++this._lastMessageId,R=String(p),O=new D.LazyPromise;_&&_.onCancellationRequested(()=>{const re=t.serializeCancel(p);this._logger&&this._logger.logOutgoing(re.byteLength,p,0,"cancel"),this._protocol.send(t.serializeCancel(p))}),this._pendingRPCReplies[R]=O,this._onWillSendRequest(p);const V=t.serializeRequest(p,s,c,u,!!_);return this._logger&&this._logger.logOutgoing(V.byteLength,p,0,`request: ${(0,k.getStringIdentifierForProxy)(s)}.${c}(`,h),this._protocol.send(V),O}}e.RPCProtocol=l,C=S,l.UNRESPONSIVE_TIME=3*1e3;class v{constructor(s,c){this._buff=s,this._offset=c}static alloc(s,c,h){let _=new v(r.VSBuffer.alloc(h+1+4),0);return _.writeUInt8(s),_.writeUInt32(c),_}static read(s,c){return new v(s,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const h=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,h}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,h}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,c}static sizeMixedArray(s,c){let h=0;h+=1;for(let _=0,u=s.length;_<u;_++){const p=s[_],R=c[_];switch(h+=1,R){case 1:h+=this.sizeLongString(p);break;case 2:h+=this.sizeVSBuffer(p);break;case 3:break}}return h}writeMixedArray(s,c){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let h=0,_=s.length;h<_;h++){const u=s[h];switch(c[h]){case 1:this.writeUInt8(1),this.writeLongString(u);break;case 2:this.writeUInt8(2),this.writeVSBuffer(u);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(s);for(let h=0;h<s;h++)switch(this.readUInt8()){case 1:c[h]=this.readLongString();break;case 2:c[h]=this.readVSBuffer();break;case 3:c[h]=void 0;break}return c}}class t{static _arrayContainsBufferOrUndefined(s){for(let c=0,h=s.length;c<h;c++)if(s[c]instanceof r.VSBuffer||typeof s[c]=="undefined")return!0;return!1}static serializeRequestArguments(s,c){if(this._arrayContainsBufferOrUndefined(s)){let h=[],_=[];for(let u=0,p=s.length;u<p;u++){const R=s[u];R instanceof r.VSBuffer?(h[u]=R,_[u]=2):typeof R=="undefined"?(h[u]=r.VSBuffer.alloc(0),_[u]=3):(h[u]=r.VSBuffer.fromString(g(R,c)),_[u]=1)}return{type:"mixed",args:h,argsType:_}}return{type:"simple",args:g(s,c)}}static serializeRequest(s,c,h,_,u){return _.type==="mixed"?this._requestMixedArgs(s,c,h,_.args,_.argsType,u):this._requestJSONArgs(s,c,h,_.args,u)}static _requestJSONArgs(s,c,h,_,u){const p=r.VSBuffer.fromString(h),R=r.VSBuffer.fromString(_);let O=0;O+=v.sizeUInt8(),O+=v.sizeShortString(p),O+=v.sizeLongString(R);let V=v.alloc(u?2:1,s,O);return V.writeUInt8(c),V.writeShortString(p),V.writeLongString(R),V.buffer}static deserializeRequestJSONArgs(s){const c=s.readUInt8(),h=s.readShortString(),_=s.readLongString();return{rpcId:c,method:h,args:JSON.parse(_)}}static _requestMixedArgs(s,c,h,_,u,p){const R=r.VSBuffer.fromString(h);let O=0;O+=v.sizeUInt8(),O+=v.sizeShortString(R),O+=v.sizeMixedArray(_,u);let V=v.alloc(p?4:3,s,O);return V.writeUInt8(c),V.writeShortString(R),V.writeMixedArray(_,u),V.buffer}static deserializeRequestMixedArgs(s){const c=s.readUInt8(),h=s.readShortString(),_=s.readMixedArray(),u=new Array(_.length);for(let p=0,R=_.length;p<R;p++){const O=_[p];typeof O=="string"?u[p]=JSON.parse(O):u[p]=O}return{rpcId:c,method:h,args:u}}static serializeAcknowledged(s){return v.alloc(5,s,0).buffer}static serializeCancel(s){return v.alloc(6,s,0).buffer}static serializeReplyOK(s,c,h){return typeof c=="undefined"?this._serializeReplyOKEmpty(s):c instanceof r.VSBuffer?this._serializeReplyOKVSBuffer(s,c):this._serializeReplyOKJSON(s,f(c,h))}static _serializeReplyOKEmpty(s){return v.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,c){let h=0;h+=v.sizeVSBuffer(c);let _=v.alloc(8,s,h);return _.writeVSBuffer(c),_.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,c){const h=r.VSBuffer.fromString(c);let _=0;_+=v.sizeLongString(h);let u=v.alloc(9,s,_);return u.writeLongString(h),u.buffer}static deserializeReplyOKJSON(s){const c=s.readLongString();return JSON.parse(c)}static serializeReplyErr(s,c){return c?this._serializeReplyErrEror(s,c):this._serializeReplyErrEmpty(s)}static _serializeReplyErrEror(s,c){const h=r.VSBuffer.fromString(f(T.transformErrorForSerialization(c),null));let _=0;_+=v.sizeLongString(h);let u=v.alloc(10,s,_);return u.writeLongString(h),u.buffer}static deserializeReplyErrError(s){const c=s.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(s){return v.alloc(11,s,0).buffer}}var n;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var o;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(o||(o={}))}),define(ge[257],pe([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(ge[258],pe([0,1,12,8,10,2,4,257]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(r,C){this.localUserHome=r,this.remoteAgentService=C,this.resolveOS=(async()=>{const f=await this.remoteAgentService.getEnvironment();return(f==null?void 0:f.os)||T.OS})(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(f==null?void 0:f.userHome)||r})()}async userHome(r){return(r==null?void 0:r.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(r=>r===1?I.win32:I.posix)}async fileURI(r){let C="";if(await this.resolveOS===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const g=r.indexOf("/",2);g===-1?(C=r.substring(2),r="/"):(C=r.substring(2,g),r=r.substring(g)||"/")}return A.URI.from({scheme:b.Schemas.file,authority:C,path:r,query:"",fragment:""})}};D=Ve([xe(1,P.IRemoteAgentService)],D),e.AbstractPathService=D}),define(ge[66],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class b{constructor(y,P){this.line=y,this.character=P}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,P){return new b(0,0)}with(y){return new b(0,0)}}e.Position=b;class I{constructor(y,P,D,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(y,P),this.end=new b(D,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var T;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(T=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,17,33,24,29,9,4,8,16,66]),function(G,e,b,I,T,A,y,P,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return r.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",f=" characters skipped \u27EB",g=(C.length+f.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var a;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function E(M){return!!M.preview}e.resultIsMatch=E;function w(M){return!!M.resource}e.isFileMatch=w;function S(M){return!!M.message}e.isProgressMessage=S;var m;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(m=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class l{constructor(F){this.resource=F,this.results=[]}}e.FileMatch=l;class v{constructor(F,L,N){this.ranges=L;const $=Array.isArray(L)?L:[L];if(N&&N.matchLines===1&&t($)){F=(0,y.getNLines)(F,N.matchLines);let q="",Q=0,de=0;const be=Math.floor(N.charsPerLine/5),Ae=[];for(const Ce of $){const Le=Math.max(Ce.startColumn-be,0),H=Ce.startColumn+N.charsPerLine;if(Le>de+be+g){const Y=C+(Le-de)+f;q+=Y+F.slice(Le,H),Q+=Le-(de+Y.length)}else q+=F.slice(de,H);Ae.push(new o(0,Ce.startColumn-Q,Ce.endColumn-Q)),de=H}this.preview={text:q,matches:Array.isArray(this.ranges)?Ae:Ae[0]}}else{const q=Array.isArray(L)?L[0].startLineNumber:L.startLineNumber;this.preview={text:F,matches:(0,b.mapArrayOrNot)(L,Q=>new n(Q.startLineNumber-q,Q.startColumn,Q.endLineNumber-q,Q.endColumn))}}}}e.TextSearchMatch=v;function t(M){const F=M[0].startLineNumber;for(const L of M)if(L.startLineNumber!==F||L.endLineNumber!==F)return!1;return!0}class n{constructor(F,L,N,$){this.startLineNumber=F,this.startColumn=L,this.endLineNumber=N,this.endColumn=$}}e.SearchRange=n;class o extends n{constructor(F,L,N){super(F,L,F,N)}}e.OneLineRange=o;var i;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function s(M,F=!0){const L=M&&M.files&&M.files.exclude,N=F&&M&&M.search&&M.search.exclude;if(!(!L&&!N)){if(!L||!N)return L||N;let $=Object.create(null);return $=T.mixin($,T.deepClone(L)),$=T.mixin($,T.deepClone(N),!0),$}}e.getExcludes=s;function c(M,F){return M.excludePattern&&I.match(M.excludePattern,F)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&I.match(M.includePattern,F)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(L=>{const N=L.folder.fsPath;if(A.isEqualOrParent(F,N)){const $=D.relative(N,F);return!L.includePattern||!!I.match(L.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var h;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(F,L){super(F);this.code=L}}e.SearchError=_;function u(M){const F=M.message;if((0,k.isPromiseCanceledError)(M))return new _(F,h.canceled);try{const L=JSON.parse(F);return new _(L.message,L.code)}catch(L){return new _(F,h.other)}}e.deserializeSearchError=u;function p(M){const F={message:M.message,code:M.code};return new Error(JSON.stringify(F))}e.serializeSearchError=p;function R(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=R;function O(M){return M.type==="success"}e.isSerializedSearchSuccess=O;function V(M){return!!M.path}e.isSerializedFileMatch=V;function re(M,F){const L=M.searchPath?M.searchPath:M.relativePath;return(0,y.fuzzyContains)(L,F)}e.isFilePatternMatch=re;class j{constructor(F){this.path=F,this.results=[]}addMatch(F){this.results.push(F)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=j;function x(M,F){const L=Object.assign(Object.assign({},M||{}),F||{});return Object.keys(L).filter(N=>{const $=L[N];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=x;class W{constructor(F,L){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},F.excludePattern||{}),L.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let N=F.includePattern;L.includePattern&&(N?N=Object.assign(Object.assign({},N),L.includePattern):N=L.includePattern),N&&(this._parsedIncludeExpression=I.parse(N))}includedInQuerySync(F,L,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(F,L,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(F,L,N))}includedInQuery(F,L,N){return Promise.resolve(this._parsedExcludeExpression(F,L,N)).then(q=>!!q).then(q=>q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(F,L,N)).then(Q=>!!Q):Promise.resolve(!0)).then(q=>q)}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=W;function U(M){for(const F in M)if(typeof M[F]!="boolean")return!0;return!1}}),define(ge[32],pe([0,1,17,13,21,3,22,12,73,25,9,11,2,167,4,14,186,60,61,28,15,7,31,5]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S,m,l,v,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(R,O,V){return new k.ExtUri(re=>h(re,V)).isEqual(R,O)}function i(R,O,V){return o(R.uri,O.uri,V)?0:(0,r.compare)(R.uri.toString(),O.uri.toString())}function s(R,O,V){return R.index!==O.index?R.index<O.index?-1:1:o(R.uri,O.uri,V)?(0,r.compare)(R.name,O.name):(0,r.compare)(R.uri.toString(),O.uri.toString())}function c(R,O,V,re){const j=R.slice(0).sort((W,U)=>V(W,U,re)),x=O.slice(0).sort((W,U)=>V(W,U,re));return(0,b.delta)(j,x,(W,U)=>V(W,U,re))}function h(R,O){const V=O.getCapabilities(R.scheme);return!(V&&V&1024)}class _ extends w.Workspace{constructor(O,V,re,j,x,W){super(O,re.map(U=>new w.WorkspaceFolder(U)),j,W);this._name=V,this._isUntitled=x,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(W),re.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(O,V,re,j){if(!O)return{workspace:null,added:[],removed:[]};const{id:x,name:W,folders:U,configuration:M,isUntitled:F}=O,L=[],N=V;V?U.forEach((de,be)=>{const Ae=f.URI.revive(de.uri),Ce=_._findFolder(re||V,Ae,j);Ce?(Ce.name=de.name,Ce.index=de.index,L.push(Ce)):L.push({uri:Ae,name:de.name,index:be})}):L.push(...U.map(({uri:de,name:be,index:Ae})=>({uri:f.URI.revive(de),name:be,index:Ae}))),L.sort((de,be)=>de.index<be.index?-1:1);const $=new _(x,W,L,M?f.URI.revive(M):null,!!F,de=>h(de,j)),{added:q,removed:Q}=c(N?N.workspaceFolders:[],$.workspaceFolders,i,j);return{workspace:$,added:q,removed:Q}}static _findFolder(O,V,re){for(let j=0;j<O.folders.length;j++){const x=O.workspaceFolders[j];if(o(x.uri,V,re))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,V){return V&&this._structure.get(O)&&(O=(0,k.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let u=class{constructor(O,V,re,j){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=j,this._extHostFileSystemInfo=re,this._requestIdProvider=new D.Counter,this._barrier=new I.Barrier,this._proxy=O.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(n.MainContext.MainThreadMessageService);const x=V.workspace;this._confirmedWorkspace=x?new _(x.id,x.name,[],x.configuration?f.URI.revive(x.configuration):null,!!x.isUntitled,W=>h(W,re)):void 0}$initializeWorkspace(O,V){this._trusted=V,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?f.URI.from({scheme:P.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,V,re,...j){const x=[];if(Array.isArray(j)&&j.forEach(L=>{f.URI.isUri(L.uri)&&!x.some(N=>o(N.uri,L.uri,this._extHostFileSystemInfo))&&x.push({uri:L.uri,name:L.name||(0,k.basenameOrAuthority)(L.uri)})}),this._unconfirmedWorkspace||[V,re].some(L=>typeof L!="number"||L<0)||re===0&&x.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(V+re>W.length)return!1;const U=W.slice(0);U.splice(V,re,...x.map(L=>({uri:L.uri,name:L.name||(0,k.basenameOrAuthority)(L.uri),index:void 0})));for(let L=0;L<U.length;L++){const N=U[L];if(U.some(($,q)=>q!==L&&o(N.uri,$.uri,this._extHostFileSystemInfo)))return!1}U.forEach((L,N)=>L.index=N);const{added:M,removed:F}=c(W,U,s,this._extHostFileSystemInfo);if(M.length===0&&F.length===0)return!1;if(this._proxy){const L=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(L,V,re,x).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,g.localize)(0,null,L,N.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(O,V){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,V)}async getWorkspaceFolder2(O,V){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,V)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!!this._actualWorkspace){const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}}getRelativePath(O,V){let re,j="";if(typeof O=="string"?(re=f.URI.file(O),j=O):typeof O!="undefined"&&(re=O,j=O.fsPath),!re)return j;const x=this.getWorkspaceFolder(re,!0);if(!x)return j;typeof V=="undefined"&&this._actualWorkspace&&(V=this._actualWorkspace.folders.length>1);let W=(0,k.relativePath)(x.uri,re);return V&&x.name&&(W=`${x.name}/${W}`),W}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:V,added:re,removed:j}=_.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=V||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:re,removed:j}))}findFiles(O,V,re,j,x=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let W;if(V===null?W=!1:V&&(typeof V=="string"?W=V:W=V.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:M}=p(O);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(M),(0,C.withUndefinedAsNull)(W),(0,C.withUndefinedAsNull)(re),x).then(F=>Array.isArray(F)?F.map(L=>f.URI.revive(L)):[])}async findTextInFiles(O,V,re,j,x=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),U=typeof V.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:M,folder:F}=p(V.include),L=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,N={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:U,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:M,excludePattern:L},$=!1;if(this._activeSearchCallbacks[W]=q=>{if(!$){const Q=f.URI.revive(q.resource);q.results.forEach(de=>{(0,t.resultIsMatch)(de)?re({uri:Q,preview:{text:de.preview.text,matches:(0,b.mapArrayOrNot)(de.preview.matches,be=>new v.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,b.mapArrayOrNot)(de.ranges,be=>new v.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):re({uri:Q,text:de.text,lineNumber:de.lineNumber})})}},x.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(O,(0,C.withUndefinedAsNull)(F),N,W,x);return delete this._activeSearchCallbacks[W],q||{}}catch(q){throw delete this._activeSearchCallbacks[W],q}}$handleTextSearchResult(O,V){this._activeSearchCallbacks[V]&&this._activeSearchCallbacks[V](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=Ve([xe(0,l.IExtHostRpcService),xe(1,m.IExtHostInitDataService),xe(2,S.IExtHostFileSystemInfo),xe(3,d.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function p(R){let O,V;return R&&(typeof R=="string"?O=R:(O=R.pattern,V=R.baseFolder||f.URI.file(R.base))),{includePattern:O,folder:V}}}),define(ge[35],pe([0,1,24,3,32,5,7,188,83,11,13,4,15,14,2]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(n,o){if(o){const i=o.split(".");let s=n;for(let c=0;s&&c<i.length;c++)s=s[i[c]];return s}}function E(n){return n instanceof a.URI}function w(n){return n&&n.uri instanceof a.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function m(n){return n&&n.uri instanceof a.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function l(n){if(E(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(m(n))return{resource:n.uri};if(n===null)return{resource:null}}let v=class{constructor(o,i,s){this._proxy=o.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=s,this._barrier=new r.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(o,i))}};v=Ve([xe(0,f.IExtHostRpcService),xe(1,T.IExtHostWorkspace),xe(2,g.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(o,i,s,c){this._onDidChangeConfiguration=new I.Emitter,this._proxy=o,this._logService=c,this._extHostWorkspace=i,this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,s))}getConfiguration(o,i,s){const c=l(i)||{},h=this._toReadonlyValue(o?d(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,c,s==null?void 0:s.identifier);function _(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(p){return typeof d(h,p)!="undefined"},get:(p,R)=>{this._validateConfigurationAccess(o?`${o}.${p}`:p,c,s==null?void 0:s.identifier);let O=d(h,p);if(typeof O=="undefined")O=R;else{let V;const re=(j,x)=>{let W;const U=()=>{V=V||(0,b.deepClone)(h),W=W||d(V,x)};return(0,k.isObject)(j)?new Proxy(j,{get:(M,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return U(),()=>W;if(V)return W=W||d(V,x),W[F];const L=M[F];return typeof F=="string"?re(L,`${x}.${F}`):L},set:(M,F,L)=>(U(),W&&(W[F]=L),!0),deleteProperty:(M,F)=>(U(),W&&delete W[F],!0),defineProperty:(M,F,L)=>(U(),W&&Object.defineProperty(W,F,L),!0)}):j};O=re(O,p)}return O},update:(p,R,O,V)=>{p=o?`${o}.${p}`:p;const re=_(O);return R!==void 0?this._proxy.$updateConfigurationOption(re,p,R,c,V):this._proxy.$removeConfigurationOption(re,p,c,V)},inspect:p=>{var R,O,V,re,j,x,W,U;p=o?`${o}.${p}`:p;const M=(0,b.deepClone)(this._configuration.inspect(p,c,this._extHostWorkspace.workspace));if(M)return{key:p,defaultValue:(R=M.default)===null||R===void 0?void 0:R.value,globalValue:(O=M.user)===null||O===void 0?void 0:O.value,workspaceValue:(V=M.workspace)===null||V===void 0?void 0:V.value,workspaceFolderValue:(re=M.workspaceFolder)===null||re===void 0?void 0:re.value,defaultLanguageValue:(j=M.default)===null||j===void 0?void 0:j.override,globalLanguageValue:(x=M.user)===null||x===void 0?void 0:x.override,workspaceLanguageValue:(W=M.workspace)===null||W===void 0?void 0:W.override,workspaceFolderLanguageValue:(U=M.workspaceFolder)===null||U===void 0?void 0:U.override,languageIds:M.overrideIdentifiers}}};return typeof h=="object"&&(0,b.mixin)(u,h,!1),Object.freeze(u)}_toReadonlyValue(o){const i=s=>(0,k.isObject)(s)?new Proxy(s,{get:(c,h)=>i(c[h]),set:(c,h,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(c,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(c,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(o)}_validateConfigurationAccess(o,i,s){const c=D.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),h=s?`[${s.value}] `:"";if(c===4){typeof(i==null?void 0:i.resource)=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(i==null?void 0:i.resource)&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const s=new P.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,h)=>s.affectsConfiguration(c,l(h))})}_toMap(o){return o.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(ge[67],pe([0,1,2,13,3,5,7,32,39,35,21,34,15,28,4,12,10,14,63,208,16]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S,m,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(j){function x(U){if(U!=null)return U}j.from=x;function W(U){if(U!=null)return U}j.to=W})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(j){function x(U){if(U!=null)return U}j.from=x;function W(U){if(U!=null)return U}j.to=W})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(j){function x(U){if(U!=null)return U}j.from=x;function W(U){if(U!=null)return U}j.to=W})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(j){function x(M){if(M){const F=M;return F&&!!F.process}else return!1}j.is=x;function W(M){if(M!=null){const F={process:M.process,args:M.args};return M.options&&(F.options=o.from(M.options)),F}}j.from=W;function U(M){if(M!=null)return new y.ProcessExecution(M.process,M.args,M.options)}j.to=U})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(j){function x(U){if(U!=null)return U}j.from=x;function W(U){if(U!=null)return U}j.to=W})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(j){function x(M){if(M){const F=M;return F&&(!!F.commandLine||!!F.command)}else return!1}j.is=x;function W(M){if(M!=null){const F={};return M.commandLine!==void 0?F.commandLine=M.commandLine:(F.command=M.command,F.args=M.args),M.options&&(F.options=s.from(M.options)),F}}j.from=W;function U(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new y.ShellExecution(M.commandLine,M.options):new y.ShellExecution(M.command,M.args?M.args:[],M.options)}j.to=U})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(j){function x(M){if(M){let F=M;return F&&F.customExecution==="customExecution"}else return!1}j.is=x;function W(M){return{customExecution:"customExecution"}}j.from=W;function U(M,F){return F.get(M)}j.to=U})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(j){function x(W,U){let M;return W.scope!==void 0&&typeof W.scope!="number"?M=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?M=U.workspaceFile:M=m.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:M}}j.from=x})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(j){function x(M,F){if(M==null)return[];const L=[];for(let N of M){const $=W(N,F);$&&L.push($)}return L}j.fromMany=x;function W(M,F){if(M!=null){let L;M.execution instanceof y.ProcessExecution?L=i.from(M.execution):M.execution instanceof y.ShellExecution?L=c.from(M.execution):M.execution&&M.execution instanceof y.CustomExecution&&(L=h.from(M.execution));const N=t.from(M.definition);let $;if(M.scope?typeof M.scope=="number"?$=M.scope:$=M.scope.uri:$=y.TaskScope.Workspace,!(!N||!$)){const q=M.group?M.group.id:void 0;return{_id:M._id,definition:N,name:M.name,source:{extensionId:F.identifier.value,label:M.source,scope:$},execution:L,isBackground:M.isBackground,group:q,presentationOptions:n.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}}}j.from=W;async function U(M,F,L){if(M!=null){let N;i.is(M.execution)?N=i.to(M.execution):c.is(M.execution)?N=c.to(M.execution):h.is(M.execution)&&(N=h.to(M._id,L));const $=t.to(M.definition);let q;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?q=M.source.scope:q=await F.resolveWorkspaceFolder(b.URI.revive(M.source.scope)):q=y.TaskScope.Workspace),!(!$||!q)){const Q=new y.Task($,q,M.name,M.source.label,N,M.problemMatchers);return M.isBackground!==void 0&&(Q.isBackground=M.isBackground),M.group!==void 0&&(Q.group=y.TaskGroup.from(M.group)),M.presentationOptions&&(Q.presentationOptions=n.to(M.presentationOptions)),M._id&&(Q._id=M._id),M.detail&&(Q.detail=M.detail),Q}}}j.to=U})(u=e.TaskDTO||(e.TaskDTO={}));var p;(function(j){function x(U){return U}j.from=x;function W(U){if(!!U)return Object.assign(Object.create(null),U)}j.to=W})(p=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(x,W,U){this._id=W,this._task=U,v.set(this,void 0),tt(this,v,x,"f")}get task(){return this._task}terminate(){Ue(this,v,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}v=new WeakMap;var O;(function(j){function x(W){return{id:W._id,task:void 0}}j.from=x})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let V=class{constructor(x,W,U,M,F,L,N,$){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=x.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=M,this._configurationService=F,this._terminalService=L,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=N,this._deprecationService=$,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,W,U){if(!U)return new y.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:W,provider:U,extension:x}),this._proxy.$registerTaskProvider(M,W),new y.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(x,W){this._proxy.$registerTaskSystem(x,W)}fetchTasks(x){return this._proxy.$fetchTasks(p.from(x)).then(async W=>{const U=[];for(let M of W){const F=await u.to(M,this._workspaceProvider,this._providedCustomExecutions2);F&&U.push(F)}return U})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(W=>x.push(W)),x}terminateTask(x){if(!(x instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,W,U){const M=this._providedCustomExecutions2.get(x.id);if(M){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,M),this._terminalService.attachPtyToTerminal(W,await M.callback(U))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const W=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const W=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:W,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const W=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:x.exitCode})}$provideTasks(x,W){const U=this._handlers.get(x);if(!U)return Promise.reject(new Error("no handler found"));const M=[],F=(0,I.asPromise)(()=>U.provider.provideTasks(r.CancellationToken.None)).then(L=>this.provideTasksInternal(W,M,U,L));return new Promise(L=>{F.then(N=>{Promise.all(M).then(()=>{L(N)})})})}async $resolveTask(x,W){const U=this._handlers.get(x);if(!U)return Promise.reject(new Error("no handler found"));if(W.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${U.type}].`);const M=await u.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const F=await U.provider.resolveTask(M,r.CancellationToken.None);if(!!F){this.checkDeprecation(F,U);const L=u.from(F,U.extension);if(!L)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(L.execution)&&await this.addCustomExecution(L,F,!0),await this.resolveTaskInternal(L)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,W,U){const M=await this._proxy.$createTaskId(x);!U&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,W.execution)}async getTaskExecution(x,W){if(typeof x=="string"){const F=this._taskExecutionPromises.get(x);if(!F)throw new Error("Unexpected: The specified task is missing an execution");return F}let U=this._taskExecutionPromises.get(x.id);if(U)return U;const M=new Promise(async(F,L)=>{const N=W||await u.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);N?F(new R(this,x.id,N)):L("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,M),M.then(F=>(this._taskExecutions.set(x.id,F),F),F=>Promise.reject(F))}checkDeprecation(x,W){x._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let U=this._notProvidedCustomExecutions.values(),M=U.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=U.next()}};V=Ve([xe(0,f.IExtHostRpcService),xe(1,g.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,D.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,w.ILogService),xe(7,S.IExtHostApiDeprecationService)],V),e.ExtHostTaskBase=V;let re=class extends V{constructor(x,W,U,M,F,L,N,$){super(x,W,U,M,F,L,N,$);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(x,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const U=u.from(W,x);if(U===void 0)throw new Error("Task is not valid");if(h.is(U.execution))await this.addCustomExecution(U,W,!1);else throw new l.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),W);return this._proxy.$executeTask(U).catch(F=>{throw new Error(F)}),M}provideTasksInternal(x,W,U,M){const F=[];if(M)for(let L of M){this.checkDeprecation(L,U),(!L.definition||!x[L.definition.type])&&this._logService.warn(`The task [${L.source}, ${L.name}] uses an undefined task type. The task will be ignored in the future.`);const N=u.from(L,U.extension);N&&h.is(N.execution)?(F.push(N),W.push(this.addCustomExecution(N,L,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:F,extension:U.extension}}async resolveTaskInternal(x){if(h.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,W){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,W,U){}};re=Ve([xe(0,f.IExtHostRpcService),xe(1,g.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,D.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,w.ILogService),xe(7,S.IExtHostApiDeprecationService)],re),e.WorkerExtHostTask=re,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)},Jt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(ge[259],pe([0,1,17,13,23,21,3,71,54,6,24,11,2,30,5,39,15,87,20,7,32,221,124]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S,m,l,v,t){"use strict";var n,o,i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=(U,M)=>`${U}:${M.toString()}`;let h=class{constructor(M,F,L){this.documents=F,this.workspace=L,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new v.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new _(this.proxy),this.workspaceObservers=new x(this.proxy),this.textDocumentObservers=new W(this.proxy,F)}registerTestController(M,F){const L=(0,g.generateUuid)();this.controllers.set(L,{instance:F,extensionId:M}),this.proxy.$registerTestController(L);const N=[...this.testControllers.keys()];return setTimeout(()=>{var $;for(const q of N)($=this.testControllers.get(q))===null||$===void 0||$.subscribeFn(L,F)},0),new m.Disposable(()=>{this.controllers.delete(L),this.proxy.$unregisterTestController(L)})}createTextDocumentTestObserver(M){return this.textDocumentObservers.checkout(M.uri)}createWorkspaceTestObserver(M){return this.workspaceObservers.checkout(M.uri)}async runTests(M,F=A.CancellationToken.None){const L=N=>N.map(this.getInternalTestForReference,this).filter(C.isDefined).map($=>({src:$.src,testId:$.item.extId}));await this.proxy.$runTests({exclude:M.exclude?L(M.exclude).map(N=>N.testId):void 0,tests:L(M.tests),debug:M.debug},F)}createTestRun(M,F,L,N=!0){return this.runQueue.createTestRun(M,F,L,N)}$publishTestResults(M){this.results=Object.freeze(M.map(F=>(0,r.deepFreeze)(S.TestResults.to(F))).concat(this.results).sort((F,L)=>L.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(M,F){const L=f.URI.revive(F),N=c(M,L);if(!this.testControllers.has(N)){const $=new A.CancellationTokenSource;let q;if(M===1){let Ce=this.documents.getDocument(L);if(!Ce){const Le=new k.DisposableStore;Ce=await new Promise(H=>{Le.add((0,I.disposableTimeout)(()=>H(void 0),5e3)),Le.add(this.documents.onDidAddDocuments(Y=>{const ee=Y.find(ae=>ae.document.uri.toString()===L.toString());ee&&H(ee)}))}).finally(()=>Le.dispose())}if(Ce){const Le=await this.workspace.getWorkspaceFolder2(L,!1);q=H=>H.createDocumentTestRoot?H.createDocumentTestRoot(Ce.document,$.token):(0,e.createDefaultDocumentTestRoot)(H,Ce.document,Le,$.token)}}else{const Ce=await this.workspace.getWorkspaceFolder2(L,!1);Ce&&(q=Le=>Le.createWorkspaceTestRoot(Ce,$.token))}if(!!q){const Q=async(Ce,Le)=>{try{const H=await q(Le);H&&be.addRoot(H,Ce)}catch(H){console.error(H)}},de=new k.DisposableStore,be=de.add(this.ownedTests.createForHierarchy(Ce=>this.proxy.$publishDiff(M,F,Ce)));de.add((0,k.toDisposable)(()=>$.dispose(!0)));const Ae=[];for(const[Ce,Le]of this.controllers)Ae.push(Q(Ce,Le.instance));Promise.all(Ae).then(()=>be.pushDiff([3,-1])),this.testControllers.set(N,{store:de,collection:be,subscribeFn:Q})}}}async $expandTest(M,F){const L=(0,b.mapFind)(this.testControllers.values(),N=>N.collection.treeId===M.src.tree?N:void 0);await(L==null?void 0:L.collection.expand(M.testId,F<0?Infinity:F)),this.flushCollectionDiffs()}$unsubscribeFromTests(M,F){var L;const N=f.URI.revive(F),$=c(M,N);(L=this.testControllers.get($))===null||L===void 0||L.store.dispose(),this.testControllers.delete($)}$acceptDiff(M,F,L){M===1?this.textDocumentObservers.acceptDiff(f.URI.revive(F),L):this.workspaceObservers.acceptDiff(f.URI.revive(F),L)}async $runTestsForProvider(M,F){const L=this.controllers.get(M.tests[0].src.controller);if(!!L){const N=M.tests.map(({testId:Q,src:de})=>this.ownedTests.getTestById(Q,de==null?void 0:de.tree)).filter(C.isDefined).map(([Q,de])=>de),$=M.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(C.isDefined).filter(([Q,de])=>N.some(be=>Q.comparePositions(be,de)===1));if(!!N.length){const q={tests:N.map(Q=>O.unwrap(Q.actual)),exclude:$.map(([,Q])=>O.unwrap(Q.actual)),debug:M.debug};await this.runQueue.enqueueRun({dto:u.fromInternal(M),token:F,extensionId:L.extensionId,req:q,doRun:()=>L.instance.runTests(q,F)})}}}$lookupTest(M){const F=this.ownedTests.getTestById(M.testId);if(!F)return Promise.resolve(void 0);const L=F[1],{actual:N,discoverCts:$,expandLevels:q}=L,Q=Jt(L,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:M}of this.testControllers.values())M.flushDiff()}getInternalTestForReference(M){var F,L;return(L=(F=this.workspaceObservers.getMirroredTestDataByReference(M))!==null&&F!==void 0?F:(0,b.mapFind)(this.testControllers.values(),N=>N.collection.getTestByReference(M)))!==null&&L!==void 0?L:this.textDocumentObservers.getMirroredTestDataByReference(M)}};h=Ve([xe(0,E.IExtHostRpcService),xe(1,d.IExtHostDocumentsAndEditors),xe(2,l.IExtHostWorkspace)],h),e.ExtHostTesting=h;class _{constructor(M){this.proxy=M,this.state=new Map}enqueueRun(M){let F=this.state.get(M.extensionId);F||(F={queue:[],current:void 0},this.state.set(M.extensionId,F));const L=new I.DeferredPromise,N=()=>{const $=[],q=new Set;F.current={publicReq:M.req,factory:Q=>{const de=new p(Q,M.dto,q,this.proxy);return $.push(de),M.token.onCancellationRequested(()=>de.end()),de}},this.invokeRunner(M.extensionId,M.dto.id,M.doRun,$).finally(()=>L.complete())};return F.queue.push(N),F.queue.length===1&&N(),L.p}createTestRun(M,F,L,N){var $,q;const Q=this.state.get(M);if((Q==null?void 0:Q.current.publicReq)===F)return Q.current.factory(L);const de=u.fromPublic(F),be=new p(L,de,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:F.debug,exclude:(q=($=F.exclude)===null||$===void 0?void 0:$.map(Ae=>Ae.id))!==null&&q!==void 0?q:[],id:de.id,tests:F.tests.map(Ae=>Ae.id),persist:N}),be.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(de.id)),be}invokeRunner(M,F,L,N){try{const $=L();return(0,I.isThenable)($)?$.then(()=>this.handleInvokeResult(M,F,N,void 0)).catch(q=>this.handleInvokeResult(M,F,N,q)):this.handleInvokeResult(M,F,N,void 0)}catch($){return this.handleInvokeResult(M,F,N,$)}}async handleInvokeResult(M,F,L,N){const $=this.state.get(M);!$||($.queue.shift(),$.queue.length>0?$.queue[0]():this.state.delete(M),await Promise.all(L.map(q=>q.onEnd.wait())))}}class u{constructor(M,F,L){this.id=M,this.include=F,this.exclude=L}static fromPublic(M){var F,L;return new u((0,g.generateUuid)(),new Set(M.tests.map(N=>N.id)),new Set((L=(F=M.exclude)===null||F===void 0?void 0:F.map(N=>N.id))!==null&&L!==void 0?L:D.Iterable.empty()))}static fromInternal(M){return new u(M.runId,new Set(M.tests.map(F=>F.testId)),new Set(M.excludeExtIds))}isIncluded(M){for(let F=M;F;F=F.parent){if(this.include.has(F.id))return!0;if(this.exclude.has(F.id))return!1}return!0}}class p{constructor(M,F,L,N){this.name=M,n.set(this,void 0),o.set(this,void 0),i.set(this,(0,g.generateUuid)()),s.set(this,void 0),this.onEnd=new I.Barrier,tt(this,n,N,"f"),tt(this,o,F,"f"),tt(this,s,L,"f"),N.$startedTestRunTask(F.id,{id:Ue(this,i,"f"),name:M,running:!0})}setState(M,F,L){Ue(this,o,"f").isIncluded(M)&&(this.ensureTestIsKnown(M),Ue(this,n,"f").$updateTestStateInRun(Ue(this,o,"f").id,Ue(this,i,"f"),M.id,F,L))}appendMessage(M,F){Ue(this,o,"f").isIncluded(M)&&(this.ensureTestIsKnown(M),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,o,"f").id,Ue(this,i,"f"),M.id,S.TestMessage.from(F)))}appendOutput(M){Ue(this,n,"f").$appendOutputToRun(Ue(this,o,"f").id,Ue(this,i,"f"),T.VSBuffer.fromString(M))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,o,"f").id,Ue(this,i,"f")),this.onEnd.open()}ensureTestIsKnown(M){const F=Ue(this,s,"f");if(!F.has(M.id)){const L=[];for(;L.unshift(S.TestItem.from(M)),!(F.has(M.id)||(F.add(M.id),!M.parent));)M=M.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,o,"f").id,L)}}}n=new WeakMap,o=new WeakMap,i=new WeakMap,s=new WeakMap;const R=async(U,M,F,L)=>{if(!!F){const N=await U.createWorkspaceTestRoot(F,L);if(!!N){L.onCancellationRequested(()=>{O.removeFilter(M)});const $=O.getWrapperForTestItem(N,M);return $.refreshMatch(),$}}};e.createDefaultDocumentTestRoot=R;class O extends m.TestItemImpl{constructor(M,F,L){super(M.id,M.label,M.uri,void 0);if(this.actual=M,this.filterDocument=F,this.actualParent=L,!(M instanceof m.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${M.id} did not`);this.debuggable=M.debuggable,this.runnable=M.runnable,this.description=M.description,this.error=M.error,this.status=M.status,this.range=M.range,this.resolveHandler=M.resolveHandler;const N=(0,w.getPrivateApiFor)(this);(0,w.getPrivateApiFor)(M).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const Q=O.getWrapperForTestItem(q[1],this.filterDocument,this);(0,w.getPrivateApiFor)(Q).parent=M,Q.refreshMatch();break;default:N.bus.fire(q)}})}static removeFilter(M){this.wrapperMap.delete(M)}static getWrapperForTestItem(M,F,L){let N=this.wrapperMap.get(F);if(N==null?void 0:N.has(M))return N.get(M);N||(N=new WeakMap,this.wrapperMap.set(F,N));const $=new O(M,F,L);return N.set(M,$),$}static unwrap(M){return M instanceof O?M.actual:M}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var M,F;const L=this._cachedMatchesFilter;for(const $ of this.actual.children.values()){const q=O.getWrapperForTestItem($,this.filterDocument,this);q.hasNodeMatchingFilter?this.children.has(q.id)||this.addChild(q):q.dispose()}const N=this.children.size>0||((M=this.actual.uri)===null||M===void 0?void 0:M.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=N,N!==L&&((F=this.actualParent)===null||F===void 0||F.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,w.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,w.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class V extends t.IncrementalChangeCollector{constructor(M){super();this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(M){this.added.add(M)}update(M){Object.assign(M.revived,S.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}if(this.updated.delete(M),M.parent&&this.alreadyRemoved.has(M.parent)){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:F,removed:L}=this;return{get added(){return[...M].map(N=>N.revived)},get updated(){return[...F].map(N=>N.revived)},get removed(){return[...L].map(N=>N.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class re extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(M){let F=[];for(const L of M){const N=this.items.get(L);N&&F.push(N.revived)}return F}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,F){return Object.assign(Object.assign({},M),{revived:S.TestItem.toPlain(M.item),depth:F?F.depth+1:0,children:new Set})}createChangeCollector(){return new V(this.changeEmitter)}}e.MirroredTestCollection=re;class j{constructor(){this.resources=new Map}checkout(M){var F,L;const N=M.toString(),$=(F=this.resources.get(N))!==null&&F!==void 0?F:this.createObserverData(M);return(L=$.pendingDeletion)===null||L===void 0||L.dispose(),$.observers++,{onDidChangeTest:$.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return $.tests.rootTestItems},dispose:(0,P.once)(()=>{--$.observers||($.pendingDeletion=this.eventuallyDispose(M))})}}getMirroredTestDataByReference(M){for(const{tests:F}of this.resources.values()){const L=F.getMirroredTestDataByReference(M);if(L)return L}}eventuallyDispose(M){return(0,I.disposableTimeout)(()=>this.unlisten(M),10*1e3)}createObserverData(M){const F=new re,L=this.listen(M,$=>F.apply($)),N={observers:0,tests:F,listener:L};return this.resources.set(M.toString(),N),N}unlisten(M){var F;const L=M.toString(),N=this.resources.get(L);N&&(N.observers=-1,(F=N.pendingDeletion)===null||F===void 0||F.dispose(),N.listener.dispose(),this.resources.delete(L))}}class x extends j{constructor(M){super();this.proxy=M,this.diffListeners=new Map}acceptDiff(M,F){var L;(L=this.diffListeners.get(M.toString()))===null||L===void 0||L(F)}listen(M,F){this.proxy.$subscribeToDiffs(0,M);const L=M.toString();return this.diffListeners.set(L,F),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,M),this.diffListeners.delete(L)})}}class W extends j{constructor(M,F){super();this.proxy=M,this.documents=F,this.diffListeners=new Map}acceptDiff(M,F){var L;(L=this.diffListeners.get(M.toString()))===null||L===void 0||L(F)}listen(M,F){if(!this.documents.getDocument(M))return new m.Disposable(()=>{});const N=M.toString();return this.diffListeners.set(N,F),this.proxy.$subscribeToDiffs(1,M),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,M),this.diffListeners.delete(N)})}}}),define(ge[260],pe([0,1,17,53,33,76,22,12,8,25,9,11,2,140,172,84,60,213,258,31]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(_,u,p,R){this.configurationService=_,this.workspaceContextService=u,this.editorGroupsService=p,this.pathService=R}text(_,u,p={}){_=this.getContentPattern(_,p);const R=this.configurationService.getValue(),O=u&&u.some(re=>!this.configurationService.getValue({resource:re}).search.useRipgrep),V=this.commonQuery(u==null?void 0:u.map(E.toWorkspaceFolder),p);return Object.assign(Object.assign({},V),{type:2,contentPattern:_,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:R.search.usePCRE2||O||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles})}getContentPattern(_,u){const p=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},_),{wordSeparators:p.editor.wordSeparators});return this.isCaseSensitive(_,u)&&(R.isCaseSensitive=!0),this.isMultiline(_)&&(R.isMultiline=!0),R}file(_,u={}){const p=this.commonQuery(_,u);return Object.assign(Object.assign({},p),{type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey})}handleIncludeExclude(_,u){return _?(_=Array.isArray(_)?_.map(i):i(_),u?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],u={}){const p=this.handleIncludeExclude(u.includePattern,u.expandPatterns),R=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),O=_.length>1,V=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,u,R)):_.map(x=>this.getFolderQueryForRoot(x,u,R,O))).filter(x=>!!x),re={_reason:u._reason,folderQueries:V,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:R.pattern,includePattern:p.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const W=b.coalesce(b.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(F=>F.resource)))).filter(M=>(0,m.pathIncludedInQuery)(re,M.fsPath)),U=this.commonQueryFromFileList(W);return Object.assign(Object.assign({},re),U)}const j=u.extraFileResources&&u.extraFileResources.filter(x=>(0,m.pathIncludedInQuery)(re,x.fsPath));return re.extraFileResources=j&&j.length?j:void 0,re}commonQueryFromFileList(_){const u=[],p=new y.ResourceMap,R={};let O=!1;return _.forEach(V=>{var re,j;if(V.scheme!==P.Schemas.walkThrough)if((0,k.isAbsolutePath)(V)){const W=(j=(re=this.workspaceContextService.getWorkspaceFolder(V))===null||re===void 0?void 0:re.uri)!==null&&j!==void 0?j:V.with({path:D.dirname(V.fsPath)});let U=p.get(W);U||(O=!0,U={folder:W,includePattern:{}},u.push(U),p.set(W,U));const M=D.relative(W.fsPath,V.fsPath);(0,C.assertIsDefined)(U.includePattern)[M.replace(/\\/g,"/")]=!0}else V.fsPath&&(O=!0,R[V.fsPath]=!0)}),{folderQueries:u,includePattern:R,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(_,u){if(u.isSmartCase){if(_.isRegExp){if(r.containsUppercaseCharacter(_.pattern,!0))return!0}else if(r.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,g.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const u=U=>D.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),R=(Array.isArray(_)?_:n(_)).map(U=>{const M=this.pathService.resolvedUserHome;return M?(0,A.untildify)(U,M.scheme===P.Schemas.file?M.fsPath:M.path):U}),O=I.groupBy(R,U=>u(U)?"searchPaths":"exprSegments"),V=(O.exprSegments||[]).map(U=>r.rtrim(U,"/")).map(U=>r.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),o(U))),re={},j=this.expandSearchPathPatterns(O.searchPaths||[]);j&&j.length&&(re.searchPaths=j);const x=b.flatten(V),W=t(...x);return W&&(re.pattern=W),re}getExcludesForFolder(_,u){return u.disregardExcludeSettings?void 0:(0,m.getExcludes)(_,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const u=b.flatten(_.map(R=>{let{pathPortion:O,globPortion:V}=v(R);V&&(V=s(V));const re=this.expandOneSearchPath(O);return b.flatten(re.map(j=>this.resolveOneSearchPathPattern(j,V)))})),p=new Map;return u.forEach(R=>{const O=R.searchPath.toString(),V=p.get(O);V?R.pattern&&(V.pattern=V.pattern||{},V.pattern[R.pattern]=!0):p.set(O,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(_){if(D.isAbsolute(_)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==P.Schemas.file?[{searchPath:u[0].uri.with({path:_})}]:[{searchPath:f.URI.file(D.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=i(_),_.startsWith("../")||_===".."){const R=D.posix.resolve(u.path,_);return[{searchPath:u.with({path:R})}]}const p=s(_);return[{searchPath:u,pattern:p}]}else{if(_==="./"||_===".\\")return[];{const u=_.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(O=>{const V=u.match(new RegExp(`^${O.name}(?:/(.*))?`));return V?{match:V,folder:O}:null}).filter(C.isDefined);if(R.length)return R.map(O=>{const V=O.match[1];return{searchPath:O.folder.uri,pattern:V&&s(V)}});{const O=_.match(/\.[\/\\](.+)[\/\\]?/),V=O?O[1]:_,re=a.localize(0,null,V);throw new Error(re)}}}}resolveOneSearchPathPattern(_,u){const p=_.pattern&&u?`${_.pattern}/${u}`:_.pattern||u,R=[{searchPath:_.searchPath,pattern:p}];return p&&!p.endsWith("**")&&R.push({searchPath:_.searchPath,pattern:p+"/**"}),R}getFolderQueryForSearchPath(_,u,p){const R=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(_.searchPath),u,p,!1);return R?Object.assign(Object.assign({},R),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,u,p,R){let O;const V=f.URI.isUri(_)?_:_.uri;if(p.searchPaths){const U=p.searchPaths.filter(M=>(0,k.isEqual)(M.searchPath,V))[0];if(U&&!U.pattern)return null;U&&(O=U.pattern)}const re=this.configurationService.getValue({resource:V}),j=this.getExcludesForFolder(re,u),x=Object.assign(Object.assign({},j||{}),O||{}),W=f.URI.isUri(_)?(0,k.basename)(_):_.name;return{folder:V,folderName:R?W:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:re.files&&re.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!re.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!re.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!re.search.followSymlinks}}};l=Ve([xe(0,d.IConfigurationService),xe(1,E.IWorkspaceContextService),xe(2,w.IEditorGroupsService),xe(3,S.IPathService)],l),e.QueryBuilder=l;function v(h){const _=h.match(/[\*\{\}\(\)\[\]\?]/);if(_){const u=_.index,p=h.substr(0,u).match(/[/|\\][^/\\]*$/);if(p){let R=h.substr(0,p.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:h.substr((p.index||0)+1)}}}return{pathPortion:h}}function t(...h){return h.length?h.reduce((_,u)=>(_[u]=!0,_),Object.create(null)):void 0}function n(h){return T.splitGlobAware(h,",").map(_=>_.trim()).filter(_=>!!_.length)}function o(h){return[`**/${h}/**`,`**/${h}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function i(h){return h.replace(/\\/g,"/")}function s(h){return i(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(h,_){h=b.distinct(h,R=>R.toString());const u=[],p=_.getWorkspace();return h&&h.forEach(R=>{let O;if(_.getWorkbenchState()===2)O=(0,k.relativePath)(p.folders[0].uri,R),O&&O!=="."&&(O="./"+O);else{const V=_.getWorkspaceFolder(R);if(V){const re=V.name;if(p.folders.filter(x=>x.name===re).length===1){const x=(0,k.relativePath)(V.uri,R);x===""?O=`./${V.name}`:O=`./${V.name}/${x}`}else O=R.fsPath}}O&&u.push(O)}),u}e.resolveResourcesForSearchIncludes=c}),define(ge[261],pe([0,1,25,2,21,16,4,260,31,60]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const r=7e3;function C(d,E){const w=E.activationEvents;if(!w)return Promise.resolve(void 0);const S=[],m=[];for(const i of w)if(/^workspaceContains:/.test(i)){const s=i.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||d.forceUsingSearch?m.push(s):S.push(s)}if(S.length===0&&m.length===0)return Promise.resolve(void 0);let l;const v=new Promise((i,s)=>{l=i}),t=i=>l({activationEvent:i}),n=Promise.all(S.map(i=>f(d,i,t))).then(()=>{}),o=g(d,E.identifier,m,t);return Promise.all([n,o]).then(()=>{l(void 0)}),v}e.checkActivateWorkspaceContainsExtension=C;async function f(d,E,w){for(const S of d.folders)if(await d.exists(b.joinPath(I.URI.revive(S),E))){w(`workspaceContains:${E}`);return}}async function g(d,E,w,S){if(w.length===0)return Promise.resolve(void 0);const m=new T.CancellationTokenSource,l=d.checkExists(d.folders,w,m.token),v=setTimeout(async()=>{m.cancel(),S(`workspaceContainsTimeout:${w.join(",")}`)},r);let t=!1;try{t=await l}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}m.dispose(),clearTimeout(v),t&&S(`workspaceContains:${w.join(",")}`)}function a(d,E,w,S){const m=d.get(y.IInstantiationService),l=d.get(D.ISearchService),t=m.createInstance(P.QueryBuilder).file(E.map(n=>(0,k.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return l.fileSearch(t,S).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=a});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(ge[42],pe([0,1,162,8,68,25,13,6,22,2,14,5,35,224,92,32,41,222,16,27,23,197,7,85,4,28,93,15,82,50,34,3,261,90,198]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S,m,l,v,t,n,o,i,s,c,h,_,u,p,R,O,V){"use strict";var re,j,x;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let W=class Bn extends P.Disposable{constructor(L,N,$,q,Q,de,be,Ae,Ce,Le){super();this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=N,this._extHostContext=$,this._initData=be,this._extHostWorkspace=q,this._extHostConfiguration=Q,this._logService=de,this._extHostTunnelService=Ce,this._extHostTerminalService=Le,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Ae,this._instaService=L.createChild(new h.ServiceCollection([a.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const H=new Set;this._initData.hostExtensions.forEach(Y=>H.add(m.ExtensionIdentifier.toKey(Y))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Y,ee,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Y,S.transformErrorForSerialization(ee),ae)},actualActivateExtension:async(Y,ee)=>{if(H.has(m.ExtensionIdentifier.toKey(Y)))return await this._mainThreadExtensionsProxy.$activateExtension(Y,ee),new g.HostExtension;const ae=this._registry.getExtensionDescription(Y);return this._activateExtension(ae,ee)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(L){S.onUnexpectedError(L)}}async deactivateAll(){let L=[];try{L=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(N){}await Promise.all(L)}isActivated(L){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(L):!1}_activateByEvent(L,N){return this._activator.activateByEvent(L,N)}_activateById(L,N){return this._activator.activateById(L,N)}activateByIdWithErrors(L,N){return this._activateById(L,N).then(()=>{const $=this._activator.getActivatedExtension(L);if($.activationFailed)return Promise.reject($.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(L=>this._registry)}getExtensionExports(L){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(L).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const L=D.TernarySearchTree.forPaths(),N=this._registry.getAllExtensionDescriptions().map($=>{if(!!this._getEntryPoint($))return this._hostUtils.realpath($.extensionLocation.fsPath).then(q=>L.set(k.URI.file(q).fsPath,$))});this._extensionPathIndex=Promise.all(N).then(()=>L)}return this._extensionPathIndex}_deactivate(L){let N=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(L))return N;const $=this._activator.getActivatedExtension(L);if(!$)return N;try{typeof $.module.deactivate=="function"&&(N=Promise.resolve($.module.deactivate()).then(void 0,q=>Promise.resolve(void 0)))}catch(q){}try{(0,P.dispose)($.subscriptions)}catch(q){}return N}async _activateExtension(L,N){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier),this._doActivateExtension(L,N).then($=>{const q=$.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(L.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,N),this._logExtensionActivationTimes(L,N,"success",q),$},$=>{throw this._logExtensionActivationTimes(L,N,"failure"),$})}_logExtensionActivationTimes(L,N,$,q){const Q=U(L,N);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Q),q||{}),{outcome:$}))}_doActivateExtension(L,N){const $=U(L,N);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",$);const q=this._getEntryPoint(L);if(!q)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${L.identifier.value} ${JSON.stringify(N)}`),this._logService.flush();const Q=new g.ExtensionActivationTimesBuilder(N.startup);return Promise.all([this._loadCommonJSModule(L.identifier,(0,A.joinPath)(L.extensionLocation,q),Q),this._loadExtensionContext(L)]).then(de=>(T.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),Bn._callActivate(this._logService,L.identifier,de[0],de[1],Q))).then(de=>(T.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),de))}_loadExtensionContext(L){const N=new v.ExtensionGlobalMemento(L,this._storage),$=new v.ExtensionMemento(L.identifier.value,!1,this._storage),q=new V.ExtensionSecrets(L,this._secretState),Q=L.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([N.whenReady,$.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Ae;return Object.freeze({globalState:N,workspaceState:$,secrets:q,subscriptions:[],get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Ce){return I.join(L.extensionLocation.fsPath,Ce)},get storagePath(){var Ce;return(Ce=be._storagePath.workspaceValue(L))===null||Ce===void 0?void 0:Ce.fsPath},get globalStoragePath(){return be._storagePath.globalValue(L).fsPath},get logPath(){return I.join(be._initData.logsLocation.fsPath,L.identifier.value)},get logUri(){return k.URI.joinPath(be._initData.logsLocation,L.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(L)},get globalStorageUri(){return be._storagePath.globalValue(L)},get extensionMode(){return Q},get extension(){return Ae===void 0&&(Ae=new M(be,L.identifier,L,de)),Ae},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(L),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(L)}})})}static _callActivate(L,N,$,q,Q){return $=$||{activate:void 0,deactivate:void 0},this._callActivateOptional(L,N,$,q,Q).then(de=>new g.ActivatedExtension(!1,null,Q.build(),$,de,q.subscriptions))}static _callActivateOptional(L,N,$,q,Q){if(typeof $.activate=="function")try{Q.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${N.value}`);const de=typeof global=="object"?global:self,be=$.activate.apply(de,[q]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(be).then(Ae=>(Q.activateResolveStop(),Ae))}catch(de){return Promise.reject(de)}else return Promise.resolve($)}_activateOneStartupFinished(L,N){this._activateById(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:N}).then(void 0,$=>{this._logService.error($)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const L of this._registry.getAllExtensionDescriptions())if(L.activationEvents)for(const N of L.activationEvents)N==="onStartupFinished"&&this._activateOneStartupFinished(L,N)}_handleEagerExtensions(){const L=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const N=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],$=this._handleWorkspaceContainsEagerExtensions(N),q=Promise.all([L,$]).then(()=>{});return Promise.race([q,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(L){return L.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(N=>this._handleWorkspaceContainsEagerExtension(L,N))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(L,N){if(!this.isActivated(N.identifier)){const $=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:L.map(de=>de.uri),forceUsingSearch:$,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,be,Ae)=>this._mainThreadWorkspaceProxy.$checkExists(de,be,Ae)},Q=await(0,R.checkActivateWorkspaceContainsExtension)(q,N);if(!!Q)return this._activateById(N.identifier,{startup:!0,extensionId:N.identifier,activationEvent:Q.activationEvent}).then(void 0,de=>this._logService.error(de))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(L){throw console.error(L),L}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:N}=this._initData.environment;if(!L||!N)throw new Error(b.localize(0,null));const $=await this._loadCommonJSModule(null,N,new g.ExtensionActivationTimesBuilder(!1));if(!$||typeof $.run!="function")throw new Error(b.localize(1,null,N.toString()));return new Promise((q,Q)=>{const de=(Ce,Le)=>{Ce?Q(Ce):q(typeof Le=="number"&&Le>0?1:0)},be=(0,A.originalFSPath)(N),Ae=$.run(be,de);Ae&&Ae.then&&Ae.then(()=>{q(0)}).catch(Ce=>{Q(Ce.toString())})})}async $extensionTestsExit(L){this._logService.info(`extension host terminating: test runner requested exit with code ${L}`),this._logService.info(`exiting with code ${L}`),this._logService.flush(),this._hostUtils.exit(L)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(L,N){return this._resolvers[L]=N,(0,P.toDisposable)(()=>{delete this._resolvers[L]})}async $resolveAuthority(L,N){const $=L.indexOf("+");if($===-1)throw new Error("Not an authority that can be resolved!");const q=L.substr(0,$);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1);const Q=this._resolvers[q];if(!Q)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(Q)),T.mark(`code/extHost/willResolveAuthority/${q}`);const de=await Q.resolve(L,{resolveAttempt:N});T.mark(`code/extHost/didResolveAuthorityOK/${q}`);const be={authority:L,host:de.host,port:de.port,connectionToken:de.connectionToken},Ae={extensionHostEnv:de.extensionHostEnv,trust:de.trust};return{type:"ok",value:{authority:be,options:Ae,tunnelInformation:{environmentTunnels:de.environmentTunnels}}}}catch(de){if(T.mark(`code/extHost/didResolveAuthorityError/${q}`),de instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:de._code,message:de._message,detail:de._detail}};throw de}}$startExtensionHost(L){return this._registry.keepOnly(L),this._startExtensionHost()}$activateByEvent(L,N){return N===1?this._activateByEvent(L,!1):this._readyToRunExtensions.wait().then($=>this._activateByEvent(L,!1))}async $activate(L,N){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(L)?(await this._activateById(L,N),!0):!1}async $deltaExtensions(L,N){L.forEach(q=>q.extensionLocation=k.URI.revive(q.extensionLocation));const $=await this.getExtensionPathIndex();return await Promise.all(N.map(async q=>{const Q=this._registry.getExtensionDescription(q);if(!!Q){const de=await this._hostUtils.realpath(Q.extensionLocation.fsPath);$.delete(k.URI.file(de).fsPath)}})),await Promise.all(L.map(async q=>{const Q=await this._hostUtils.realpath(q.extensionLocation.fsPath);$.set(k.URI.file(Q).fsPath,q)})),this._registry.deltaExtensions(L,N),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){let N=l.VSBuffer.alloc(L),$=Math.random()%256;for(let q=0;q<L;q++)N.writeUInt8($,q);return N}async $updateRemoteConnectionData(L){this._remoteConnectionData=L,this._onDidChangeRemoteConnectionData.fire()}};W=Ve([xe(0,o.IInstantiationService),xe(1,e.IHostUtils),xe(2,c.IExtHostRpcService),xe(3,d.IExtHostWorkspace),xe(4,f.IExtHostConfiguration),xe(5,r.ILogService),xe(6,i.IExtHostInitDataService),xe(7,s.IExtensionStoragePaths),xe(8,_.IExtHostTunnelService),xe(9,u.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function U(F,L){return{id:F.identifier.value,name:F.name,extensionVersion:F.version,publisherDisplayName:F.publisher,activationEvents:F.activationEvents?F.activationEvents.join(","):null,isBuiltin:F.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class M{constructor(L,N,$,q){re.set(this,void 0),j.set(this,void 0),x.set(this,void 0),tt(this,re,L,"f"),tt(this,j,N,"f"),tt(this,x,$.identifier,"f"),this.id=$.identifier.value,this.extensionUri=$.extensionLocation,this.extensionPath=I.normalize((0,A.originalFSPath)($.extensionLocation)),this.packageJSON=$,this.extensionKind=q}get isActive(){return Ue(this,re,"f").isActivated(Ue(this,x,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,re,"f").getExtensionExports(Ue(this,x,"f"))}activate(){return Ue(this,re,"f").activateByIdWithErrors(Ue(this,x,"f"),{startup:!1,extensionId:Ue(this,j,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,re=new WeakMap,j=new WeakMap,x=new WeakMap}),define(ge[46],pe([0,1,8,2,3,13,5,7,122,32,42,39,212,35,205,15,4,11,36]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let m=class{constructor(c,h,_,u,p){this._workspaceService=h,this._extensionService=_,this._editorsService=u,this._configurationService=p,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=c.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new v(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(O=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,h){const _=c;if(typeof _.sourceReference=="number"&&_.sourceReference>0){let u=`debug:${encodeURIComponent(_.path||"")}`,p="?";return h&&(u+=`${p}session=${encodeURIComponent(h.id)}`,p="&"),u+=`${p}ref=${_.sourceReference}`,I.URI.parse(u)}else{if(_.path)return I.URI.file(_.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const h=[];for(const _ of c.getAllExtensionDescriptions())if(_.contributes){const u=_.contributes.debuggers;if(u&&u.length>0)for(const p of u)(0,a.isDebuggerMainContribution)(p)&&h.push(p.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(h=>c.push(h)),c}addBreakpoints(c){this.startBreakpoints();const h=c.filter(p=>{const R=p.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,p),!0)});this.fireBreakpointChanges(h,[],[]);const _=[],u=new Map;for(const p of h)if(p instanceof P.SourceBreakpoint){let R=u.get(p.location.uri.toString());R||(R={type:"sourceMulti",uri:p.location.uri,lines:[]},u.set(p.location.uri.toString(),R),_.push(R)),R.lines.push({id:p.id,enabled:p.enabled,condition:p.condition,hitCondition:p.hitCondition,logMessage:p.logMessage,line:p.location.range.start.line,character:p.location.range.start.character})}else p instanceof P.FunctionBreakpoint&&_.push({type:"function",id:p.id,enabled:p.enabled,hitCondition:p.hitCondition,logMessage:p.logMessage,condition:p.condition,functionName:p.functionName});return this._debugServiceProxy.$registerBreakpoints(_)}removeBreakpoints(c){this.startBreakpoints();const h=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],h,[]);const _=h.filter(R=>R instanceof P.SourceBreakpoint).map(R=>R.id),u=h.filter(R=>R instanceof P.FunctionBreakpoint).map(R=>R.id),p=h.filter(R=>R instanceof P.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(_,u,p)}startDebugging(c,h,_){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,h,{parentSessionID:_.parentSession?_.parentSession.id:void 0,repl:_.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:_.noDebug,compact:_.compact})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,h,_){if(!h)return new P.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:u,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,_,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,u),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(p=>p.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(c,h,_){if(!_)return new P.Disposable(()=>{});if(!this.definesDebugType(c,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:u,factory:_}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,u),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(p=>p.factory!==_),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(c,h){if(!h)return new P.Disposable(()=>{});const _=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:_,factory:h}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==h)})}async $runInTerminal(c,h){return Promise.resolve(void 0)}async $substituteVariables(c,h){if(!this._variableResolver){const[p,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(p||[],this._editorsService,R)}let _;const u=await this.getFolder(c);return u&&(_={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(_,h)}createDebugAdapter(c,h){if(c.type==="implementation")return new o(c.implementation)}createSignService(){}async $startDASession(c,h){const _=this,u=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const R=this.convertToDto(p),O=this.createDebugAdapter(R,u);if(!O)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const V=O;return this._debugAdapters.set(c,V),this.getDebugAdapterTrackers(u).then(re=>(re&&this._debugAdaptersTrackers.set(c,re),V.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const x=j,W={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(x.arguments.value);W.body={signature:U},V.sendResponse(W)}else throw new Error("no signer")}catch(U){W.success=!1,W.message=U.message,V.sendResponse(W)}}else re&&re.onDidSendMessage&&re.onDidSendMessage(j),j=(0,a.convertToVSCPaths)(j,!0),_._debugServiceProxy.$acceptDAMessage(c,j)}),V.onError(j=>{re&&re.onError&&re.onError(j),this._debugServiceProxy.$acceptDAError(c,j.name,j.message,j.stack)}),V.onExit(j=>{re&&re.onExit&&re.onExit((0,w.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,w.withNullAsUndefined)(j),void 0)}),re&&re.onWillStartSession&&re.onWillStartSession(),V.startSession()))})}$sendDAMessage(c,h){h=(0,a.convertToDAPaths)(h,!1);const _=this._debugAdaptersTrackers.get(c);_&&_.onWillReceiveMessage&&_.onWillReceiveMessage(h);const u=this._debugAdapters.get(c);u&&u.sendMessage(h)}$stopDASession(c){const h=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),h&&h.onWillStopSession&&h.onWillStopSession();const _=this._debugAdapters.get(c);return this._debugAdapters.delete(c),_?_.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const h=[],_=[],u=[];if(c.added)for(const p of c.added){const R=p.id;if(R&&!this._breakpoints.has(R)){let O;if(p.type==="function")O=new P.FunctionBreakpoint(p.functionName,p.enabled,p.condition,p.hitCondition,p.logMessage);else if(p.type==="data")O=new P.DataBreakpoint(p.label,p.dataId,p.canPersist,p.enabled,p.hitCondition,p.condition,p.logMessage);else{const V=I.URI.revive(p.uri);O=new P.SourceBreakpoint(new P.Location(V,new P.Position(p.line,p.character)),p.enabled,p.condition,p.hitCondition,p.logMessage)}O._id=R,this._breakpoints.set(R,O),h.push(O)}}if(c.removed)for(const p of c.removed){const R=this._breakpoints.get(p);R&&(this._breakpoints.delete(p),_.push(R))}if(c.changed){for(const p of c.changed)if(p.id){const R=this._breakpoints.get(p.id);if(R){if(R instanceof P.FunctionBreakpoint&&p.type==="function"){const O=R;O.enabled=p.enabled,O.condition=p.condition,O.hitCondition=p.hitCondition,O.logMessage=p.logMessage,O.functionName=p.functionName}else if(R instanceof P.SourceBreakpoint&&p.type==="source"){const O=R;O.enabled=p.enabled,O.condition=p.condition,O.hitCondition=p.hitCondition,O.logMessage=p.logMessage,O.location=new P.Location(I.URI.revive(p.uri),new P.Position(p.line,p.character))}u.push(R)}}}this.fireBreakpointChanges(h,_,u)}$provideDebugConfigurations(c,h,_){return(0,A.asPromise)(async()=>{const u=this.getConfigProviderByHandle(c);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const p=await this.getFolder(h);return u.provideDebugConfigurations(p,_)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(c,h,_,u){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(c);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(h);return p.resolveDebugConfiguration(R,_,u)})}$resolveDebugConfigurationWithSubstitutedVariables(c,h,_,u){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(c);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(h);return p.resolveDebugConfigurationWithSubstitutedVariables(R,_,u)})}async $provideDebugAdapter(c,h){const _=this.getAdapterDescriptorFactoryByHandle(c);if(!_)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(h);return this.getAdapterDescriptor(_,u).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(p)})}async $acceptDebugSessionStarted(c){const h=await this.getSession(c);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(c){const h=await this.getSession(c);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,h){const _=await this.getSession(c);_&&_._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(c,h){const u={session:await this.getSession(c),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const h=this._adapterFactories.filter(_=>_.type===c);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(c){const h=this._adapterFactories.filter(_=>_.handle===c);if(h.length>0)return h[0].factory}getConfigProviderByHandle(c){const h=this._configProviders.filter(_=>_.handle===c);if(h.length>0)return h[0].provider}definesDebugType(c,h){if(c.contributes){const _=c.contributes.debuggers;if(_&&_.length>0){for(const u of _)if(u.label&&u.type&&u.type===h)return!0}}return!1}getDebugAdapterTrackers(c){const _=c.configuration.type,u=this._trackerFactories.filter(p=>p.type===_||p.type==="*").map(p=>(0,A.asPromise)(()=>p.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(u).then(p=>{const R=p.filter(O=>!!O);if(R.length>0)return new n(R)}),new Promise((p,R)=>{const O=setTimeout(()=>{clearTimeout(O),R(new Error("timeout"))},1e3)})]).catch(p=>{})}async getAdapterDescriptor(c,h){const _=h.configuration.debugServer;if(typeof _=="number")return Promise.resolve(new P.DebugAdapterServer(_));if(c){const p=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,p))).then(R=>{if(R)return R})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,u))}daExecutableFromPackage(c,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,h,_){(c.length>0||h.length>0||_.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:h,changed:_}))}async getSession(c){if(c)if(typeof c=="string"){const h=this._debugSessions.get(c);if(h)return h}else{let h=this._debugSessions.get(c.id);if(!h){const _=await this.getFolder(c.folderUri);h=new l(this._debugServiceProxy,c.id,c.type,c.name,_,c.configuration),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(c){if(c){const h=I.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};m=Ve([xe(0,d.IExtHostRpcService),xe(1,k.IExtHostWorkspace),xe(2,r.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,g.IExtHostConfiguration)],m),e.ExtHostDebugServiceBase=m;class l{constructor(c,h,_,u,p,R){this._debugServiceProxy=c,this._id=h,this._type=_,this._name=u,this._workspaceFolder=p,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,h)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=l;class v{constructor(c){this.value=Object.freeze({append(h){c.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=v;class t extends f.AbstractVariableResolverService{constructor(c,h,_,u){super({getFolderUri:p=>{const R=c.filter(O=>O.name===p);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(p,R)=>_.getConfiguration(void 0,p).get(R),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(h){const p=h.activeEditor();if(p)return b.normalize(p.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(h&&u){const p=h.activeEditor();if(p){const R=u.getWorkspaceFolder(p.document.uri);if(R)return b.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(h){const p=h.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(h){const p=h.activeEditor();if(p)return String(p.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=t;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(h=>h.onError?h.onError(c):void 0)}onExit(c,h){this.trackers.forEach(_=>_.onExit?_.onExit(c,h):void 0)}}class o extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends m{constructor(c,h,_,u,p){super(c,h,_,u,p)}createVariableResolver(c,h,_){return new t(c,h,_)}};i=Ve([xe(0,d.IExtHostRpcService),xe(1,k.IExtHostWorkspace),xe(2,r.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,g.IExtHostConfiguration)],i),e.WorkerExtHostDebugService=i}),define(ge[262],pe([0,1,68,2,5,35,41,27,15,28,4,42,36,14]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(m,l,v,t,n,o,i){this._apiFactory=m,this._extensionRegistry=l,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=o,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,l,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,l,this._initData.environment.appUriScheme))}register(m){if(Array.isArray(m.nodeModuleName))for(let l of m.nodeModuleName)this._factories.set(l,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(l=>m.alternativeModuleName(l))}};a=Ve([xe(2,r.IInstantiationService),xe(3,A.IExtHostConfiguration),xe(4,C.IExtHostExtensionService),xe(5,k.IExtHostInitDataService),xe(6,g.ILogService)],a),e.RequireInterceptor=a;class d{constructor(m,l,v,t,n){this._apiFactory=m,this._extensionPaths=l,this._extensionRegistry=v,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,l){const v=this._extensionPaths.findSubstr(l.fsPath);if(v){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,o)=>t+=`	${o} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(m,l){this.nodeModuleName="keytar";const{environment:v}=l,t=m.getProxy(T.MainContext.MainThreadKeytar);if(v.appRoot){let n=v.appRoot.fsPath;f.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,o)=>t.$getPassword(n,o),setPassword:(n,o,i)=>t.$setPassword(n,o,i),deletePassword:(n,o)=>t.$deletePassword(n,o),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(m,l){return this._impl}alternativeModuleName(m){const l=m.length;if(!(l<=7||!this.alternativeNames)){const v=l-7;if((m.charAt(v)==="/"||m.charAt(v)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}}};E=Ve([xe(0,D.IExtHostRpcService),xe(1,k.IExtHostInitDataService)],E);let w=class{constructor(m,l,v){this._extensionPaths=m,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(T.MainContext.MainThreadTelemetry);const t=v.getProxy(T.MainContext.MainThreadWindow);this._impl=(n,o)=>{const i=I.URI.parse(n);return o?this.callOriginal(n,o):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,n,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,n,{}):this.callOriginal(n,o)}}load(m,l,v){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(m),this._impl}callOriginal(m,l){return this.sendNoForwardTelemetry(),this._original(m,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([xe(2,D.IExtHostRpcService)],w)}),define(ge[263],pe([0,1,168,10,7,206,32,42,39,35,34,15,46,190,13,207]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let E=class extends f.ExtHostDebugServiceBase{constructor(m,l,v,t,n,o){super(m,l,v,t,n);this._terminalService=o,this._integratedTerminalInstances=new w}createDebugAdapter(m,l){switch(m.type){case"server":return new A.SocketDebugAdapter(m);case"pipeServer":return new A.NamedPipeDebugAdapter(m);case"executable":return new A.ExecutableDebugAdapter(m,l.type)}return super.createDebugAdapter(m,l)}daExecutableFromPackage(m,l){const v=A.ExecutableDebugAdapter.platformAdapterExecutable(l.getAllExtensionDescriptions(),m.type);if(v)return new T.DebugAdapterExecutable(v.command,v.args,v.options)}createSignService(){return new g.SignService}async $runInTerminal(m,l){if(m.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(p=>{this._integratedTerminalInstances.onTerminalClosed(p)}));const v=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,v),n=this._terminalService.getDefaultShellArgs(!0,v),o=JSON.stringify({shell:t,shellArgs:n});let i=await this._integratedTerminalInstances.checkout(o),s,c=!1;if(i)s=m.cwd;else{const p={shellPath:t,shellArgs:n,cwd:m.cwd,name:m.title||b.localize(0,null)};c=!0,i=this._terminalService.createTerminalFromOptions(p,!0),this._integratedTerminalInstances.insert(i,o)}i.show(!0);const h=await i.processId;c?await new Promise(p=>setTimeout(p,1e3)):v.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?i.sendText("cls"):t.indexOf("bash")>=0?i.sendText("clear"):I.isWindows?i.sendText("cls"):i.sendText("clear"));const _=(0,d.prepareCommand)(t,m.args,s,m.env);i.sendText(_);const u=this.onDidTerminateDebugSession(p=>{p.id===l&&(this._integratedTerminalInstances.free(i),u.dispose())});return h}else if(m.kind==="external")return(0,d.runInExternalTerminal)(m,await this._configurationService.getConfigProvider());return super.$runInTerminal(m,l)}createVariableResolver(m,l,v){return new f.ExtHostVariableResolverService(m,l,v,this._workspaceService)}};E=Ve([xe(0,C.IExtHostRpcService),xe(1,y.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,D.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,r.IExtHostTerminalService)],E),e.ExtHostDebugService=E;class w{constructor(){this._terminalInstances=new Map}async checkout(m){const v=[...this._terminalInstances.entries()].map(([t,n])=>(0,a.createCancelablePromise)(async o=>{if(n.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await t.processId))return null;const i=Date.now();return n.lastUsedAt+w.minUseDelay>i||o.isCancellationRequested||n.config!==m?null:(n.lastUsedAt=i,t)}));return await(0,a.firstParallel)(v,t=>!!t)}insert(m,l){this._terminalInstances.set(m,{lastUsedAt:Date.now(),config:l})}free(m){const l=this._terminalInstances.get(m);l&&(l.lastUsedAt=-1)}onTerminalClosed(m){this._terminalInstances.delete(m)}}w.minUseDelay=1e3}),define(ge[264],pe([0,1,8,2,78,32,46,39,35,34,15,28,67,12,14,63]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let E=class extends f.ExtHostTaskBase{constructor(S,m,l,v,t,n,o,i){super(S,m,l,v,t,n,o,i);this.workspaceService=l,m.remote.isRemote&&m.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:m.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(S,m){const l=m;if(!m.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const v=f.TaskHandleDTO.from(l,this.workspaceService),t=await this._proxy.$getTaskExecution(v);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(t,m);return this._proxy.$executeTask(v).catch(()=>{}),n}else{const v=f.TaskDTO.from(m,S);if(v===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(v.execution)&&await this.addCustomExecution(v,m,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(v),m);return this._proxy.$executeTask(v).catch(()=>{}),t}}provideTasksInternal(S,m,l,v){const t=[];if(v)for(let n of v){this.checkDeprecation(n,l),(!n.definition||!S[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const o=f.TaskDTO.from(n,l.extension);o&&(t.push(o),f.CustomExecutionDTO.is(o.execution)&&m.push(this.addCustomExecution(o,n,!0)))}return{tasks:t,extension:l.extension}}async resolveTaskInternal(S){return S}async getVariableResolver(S){if(this._variableResolver===void 0){const m=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(S,this._editorService,m,this.workspaceService)}return this._variableResolver}async $resolveVariables(S,m){const l=I.URI.revive(S),v={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(l),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const o=await this.getVariableResolver(n),i={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let s of m.variables)v.variables[s]=await o.resolveAsync(i,s);if(m.process!==void 0){let s;if(m.process.path!==void 0){s=m.process.path.split(b.delimiter);for(let c=0;c<s.length;c++)s[c]=await o.resolveAsync(i,s[c])}v.process=await T.win32.findExecutable(await o.resolveAsync(i,m.process.name),m.process.cwd!==void 0?await o.resolveAsync(i,m.process.cwd):void 0,s)}return v}$getDefaultShellAndArgs(){return this._terminalService.getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(S,m,l){return T.win32.findExecutable(S,m,l)}};E=Ve([xe(0,r.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,A.IExtHostWorkspace),xe(3,P.IExtHostDocumentsAndEditors),xe(4,D.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,a.ILogService),xe(7,d.IExtHostApiDeprecationService)],E),e.ExtHostTask=E}),define(ge[265],pe([0,1,10,11,30,149,14,35,46,39,15,34,32,210,211]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let d=class extends C.BaseExtHostTerminalService{constructor(w,S,m,l,v){super(!0,w);this._extHostConfiguration=S,this._extHostWorkspace=m,this._extHostDocumentsAndEditors=l,this._logService=v,(0,A.getSystemShell)(b.OS,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(w,S,m){const l=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),{name:w,shellPath:S,shellArgs:m},w);return this._terminals.push(l),l.create(S,m),l.value}createTerminalFromOptions(w,S){const m=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),w,w.name);return this._terminals.push(m),m.create((0,I.withNullAsUndefined)(w.shellPath),(0,I.withNullAsUndefined)(w.shellArgs),(0,I.withNullAsUndefined)(w.cwd),(0,I.withNullAsUndefined)(w.env),(0,I.withNullAsUndefined)(w.icon),(0,I.withNullAsUndefined)(w.message),void 0,(0,I.withNullAsUndefined)(w.strictEnv),(0,I.withNullAsUndefined)(w.hideFromUser),(0,I.withNullAsUndefined)(S),!0),m.value}getDefaultShell(w,S){var m;return g.getDefaultShell(this._buildSafeConfigProvider(S),(m=this._defaultShell)!==null&&m!==void 0?m:(0,A.getSystemShellSync)(b.OS,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,g.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService,w)}getDefaultShellArgs(w,S){return g.getDefaultShellArgs(this._buildSafeConfigProvider(S),w,g.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService)}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const w=this._extHostDocumentsAndEditors.activeEditor();w&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(w.document.uri))}async _updateVariableResolver(){const w=await this._extHostConfiguration.getConfigProvider(),S=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new D.ExtHostVariableResolverService(S||[],this._extHostDocumentsAndEditors,w),this._variableResolver}async $getAvailableProfiles(w){const S=this._buildSafeConfigProvider(await this._extHostConfiguration.getConfigProvider());return(0,a.detectAvailableProfiles)(w,S,void 0,this._logService,await this._variableResolverPromise,this._lastActiveWorkspace)}async getDefaultShellAndArgs(w){const S=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(w,S),args:this.getDefaultShellArgs(w,S)}}_buildSafeConfigProvider(w){const S=w.getConfiguration();return m=>{if(S.get("terminal.integrated.allowWorkspaceConfiguration"))return S.get(m);const v=S.inspect(m);return(v==null?void 0:v.globalValue)||(v==null?void 0:v.defaultValue)}}};d=Ve([xe(0,r.IExtHostRpcService),xe(1,P.IExtHostConfiguration),xe(2,f.IExtHostWorkspace),xe(3,k.IExtHostDocumentsAndEditors),xe(4,y.ILogService)],d),e.ExtHostTerminalService=d}),define(ge[266],pe([0,1,13,16,68,6,2,5,256,14,79,82,28,185,15,62,42,34]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(l,v,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new D.RPCProtocol(l,null,n);v=S._transform(v,o);const i=new C.ServiceCollection(...(0,r.getSingletonServiceDescriptors)());i.set(f.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},v)),i.set(a.IExtHostRpcService,new a.ExtHostRpcService(o)),i.set(d.IURITransformerService,new d.URITransformerService(n)),i.set(E.IHostUtils,t);const s=new g.InstantiationService(i,!0),c=s.invokeFunction(p=>p.get(w.IExtHostTerminalService));this._disposables.add(c),this._logService=s.invokeFunction(p=>p.get(k.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=s.invokeFunction(p=>p.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(p=>{Error.prepareStackTrace=(R,O)=>{let V="",re,j;for(const x of O)V+=`
	at ${x.toString()}`,j=x.getFileName(),!re&&j&&(re=p.findSubstr(j));return h.set(R,re),`${R.name||"Error"}: ${R.message||""}${V}`}});const _=o.getProxy(P.MainContext.MainThreadExtensionService),u=o.getProxy(P.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(p=>{const R=I.transformErrorForSerialization(p),O=h.get(p);O?_.$onExtensionRuntimeError(O.identifier,R):u.$onUnexpectedError(R)})}terminate(l){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(l,v){l.extensions.forEach(n=>n.extensionLocation=y.URI.revive(v.transformIncomingURIs(n.extensionLocation))),l.environment.appRoot=y.URI.revive(v.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(v.transformIncomingURIs(n)))),l.environment.extensionTestsLocationURI=y.URI.revive(v.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=y.URI.revive(v.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=y.URI.revive(v.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=y.URI.revive(v.transformIncomingURIs(l.logsLocation)),l.logFile=y.URI.revive(v.transformIncomingURIs(l.logFile)),l.workspace=v.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=S}),define(ge[267],pe([0,1,8,21,59,33,25,47,31]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(f,g,a){this.config=f,this.provider=g,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&A.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&A.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const g=this.config.folderQueries||[];return new Promise((a,d)=>{const E=w=>{this.resultCount++,f(w)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const S=w.toString(),m=b.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,m)||this.matchFile(E,{base:w,basename:m})}),Promise.all(g.map(w=>this.searchInFolder(w,E))).then(w=>{a({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{d(new Error((0,T.toErrorMessage)(w)))})})}async searchInFolder(f,g){const a=new I.CancellationTokenSource,d=this.getSearchOptionsForFolder(f),E=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,f),S=!w.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(a),m=P.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,a.token),v=m.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(n=>{const o=b.posix.relative(f.folder.path,n.path);if(S){const i=b.basename(n.path);this.matchFile(g,{base:f.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(E,f.folder,o,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,w,g),{providerTime:v,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(f){const g=(0,D.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:a,includes:g,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},g,a,d){if(a===this.filePattern){const w=b.basename(this.filePattern);this.matchFile(d,{base:g,relativePath:this.filePattern,basename:w})}function E(w){const S=b.basename(w),m=b.dirname(w);let l=f[m];l||(l=f[m]=[],E(m)),l.push({base:g,relativePath:w,basename:S})}E(a)}matchDirectoryTree({rootEntries:f,pathToEntries:g},a,d){const E=this,w=this.filePattern;function S(m){const l=A.hasSiblingFn(()=>m.map(v=>v.basename));for(let v=0,t=m.length;v<t;v++){const n=m[v],{relativePath:o,basename:i}=n;if(!!a.includedInQuerySync(o,i,w!==i?l:void 0)){const s=g[o];if(s)S(s);else{if(o===w)continue;E.matchFile(d,n)}if(E.isLimitHit)break}}}S(f)}matchFile(f,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(g))}}class r{constructor(){this.sessions=new Map}fileSearch(f,g,a,d){const E=this.getSessionTokenSource(f.cacheKey),w=new k(f,g,E&&E.token);let S=0;const m=l=>{S+=l.length,a(l.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(w,r.BATCH_SIZE,m,d).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:l.stats}}))}clearCache(f){const g=this.getSessionTokenSource(f);g&&g.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new I.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:y.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,g,a,d){d.onCancellationRequested(()=>{f.cancel()});const E=S=>{S&&(w.push(S),g>0&&w.length>=g&&(a(w),w=[]))};let w=[];return f.search(E).then(S=>(w.length&&a(w),S),S=>(w.length&&a(w),Promise.reject(S)))}}e.FileSearchManager=r,r.BATCH_SIZE=512}),define(ge[129],pe([0,1,8,17,21,59,25,33,2,31,12,11]),function(G,e,b,I,T,A,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class f{constructor(m,l,v){this.query=m,this.provider=l,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(m,l){const v=this.query.folderQueries||[],t=new T.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((n,o)=>{this.collector=new a(m);let i=!1;const s=(c,h)=>{if(!i&&!this.isLimitHit){const _=this.resultSize(c);E(c)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const u=this.resultSize(c);this.resultCount+=u,(u>0||!E(c))&&this.collector.add(c,h)}};Promise.all(v.map((c,h)=>this.searchInFolder(c,_=>s(_,h),t.token))).then(c=>{t.dispose(),this.collector.flush();const h=c.some(_=>!!_&&!!_.limitHit);n({limitHit:this.isLimitHit||h,messages:(0,I.flatten)(c.map(_=>(_==null?void 0:_.message)?(0,C.isArray)(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},c=>{t.dispose();const h=(0,A.toErrorMessage)(c);o(new Error(h))})})}resultSize(m){return E(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,l){const v=Array.isArray(m.ranges)?m.ranges:[m.ranges],t=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:v.slice(0,l),preview:{matches:t.slice(0,l),text:m.preview.text},uri:m.uri}}async searchInFolder(m,l,v){const t=new k.QueryGlobTester(this.query,m),n=[],o={report:c=>{if(!!this.validateProviderResult(c)){const h=m.folder.scheme===r.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(c.uri))):void 0,_=y.relativePath(m.folder,c.uri);_&&n.push(t.includedInQuery(_,b.basename(_),h).then(u=>{u&&l(c)}))}}},i=this.getSearchOptionsForFolder(m),s=await this.provider.provideTextSearchResults(g(this.query.contentPattern),i,o,v);return await Promise.all(n),s}validateProviderResult(m){if(E(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const l=(0,k.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),v=(0,k.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),t={folder:D.URI.from(m.folder),excludes:v,includes:l,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=f;function g(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class a{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,l=>this.sendItems(l))}add(m,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!y.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(d(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=a;function d(S){return E(S)?{preview:{matches:(0,I.mapArrayOrNot)(S.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:S.preview.text},ranges:(0,I.mapArrayOrNot)(S.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function E(S){return!!S.preview}e.extensionResultIsMatch=E;class w{constructor(m,l){this.maxBatchSize=m,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,l){!m||this.addItemToBatch(m,l)}addItems(m,l){!m||this.addItemsToBatch(m,l)}addItemToBatch(m,l){this.batch.push(m),this.batchSize+=l,this.onUpdate()}addItemsToBatch(m,l){this.batch=this.batch.concat(m),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(ge[69],pe([0,1,6,5,4,267,15,62,14,2,129]),function(G,e,b,I,T,A,y,P,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(d,E,w){this.extHostRpc=d,this._uriTransformer=E,this._logService=w,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,E){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const w=this._handlePool++;return this._textSearchProvider.set(w,E),this._proxy.$registerTextSearchProvider(w,this._transformScheme(d)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(d,E){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const w=this._handlePool++;return this._fileSearchProvider.set(w,E),this._proxy.$registerFileSearchProvider(w,this._transformScheme(d)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(d,E,w,S){const m=f(w),l=this._fileSearchProvider.get(d);if(l)return this._fileSearchManager.fileSearch(m,l,v=>{this._proxy.$handleFileMatch(d,E,v.map(t=>t.resource))},S);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,E,w,S){const m=this._textSearchProvider.get(d);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const l=f(w);return this.createTextSearchManager(l,m).search(t=>this._proxy.$handleTextMatch(d,E,t),S)}createTextSearchManager(d,E){return new r.TextSearchManager(d,E,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=Ve([xe(0,y.IExtHostRpcService),xe(1,P.IURITransformerService),xe(2,D.ILogService)],C),e.ExtHostSearch=C;function f(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(g),extraFileResources:a.extraFileResources&&a.extraFileResources.map(d=>k.URI.revive(d))})}e.reviveQuery=f;function g(a){return Object.assign(Object.assign({},a),{folder:k.URI.revive(a.folder)})}}),define(ge[268],pe([0,1,160,21,16,3,57,2,151,109,141,77,45,5,230,229,51,231,35,232,233,234,215,235,39,42,236,216,238,239,240,64,219,243,244,245,92,34,246,220,20,7,249,65,128,32,41,53,202,237,118,127,67,46,69,14,62,15,28,241,200,50,63,227,247,199,93,91,252,250,251,228,61,259,248,90,196,120,242,85,66]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S,m,l,v,t,n,o,i,s,c,h,_,u,p,R,O,V,re,j,x,W,U,M,F,L,N,$,q,Q,de,be,Ae,Ce,Le,H,Y,ee,ae,me,De,Oe,we,Pe,Re,Be,Se,qe,X,ie,_e,Ne,ze,$e,Je,K,se,he,J,te,ce,ve,ye,je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function He(We){const Ge=We.get(Oe.IExtHostInitDataService),nt=We.get(K.IExtHostFileSystemInfo),dt=We.get(_e.IExtHostConsumerFileSystem),it=We.get(i.IExtHostExtensionService),Ye=We.get(q.IExtHostWorkspace),mt=We.get(ce.IExtHostTelemetry),wt=We.get(S.IExtHostConfiguration),Ee=We.get(me.IURITransformerService),fe=We.get(De.IExtHostRpcService),le=We.get(j.IExtHostStorage),Z=We.get(ie.IExtensionStoragePaths),Fe=We.get(ae.ILogService),Te=We.get(Re.IExtHostTunnelService),Qe=We.get(Be.IExtHostApiDeprecationService),Ze=We.get($.IExtHostWindow),ct=We.get(J.IExtHostSecretState);fe.set(g.ExtHostContext.ExtHostFileSystemInfo,nt),fe.set(g.ExtHostContext.ExtHostLogService,Fe),fe.set(g.ExtHostContext.ExtHostWorkspace,Ye),fe.set(g.ExtHostContext.ExtHostConfiguration,wt),fe.set(g.ExtHostContext.ExtHostExtensionService,it),fe.set(g.ExtHostContext.ExtHostStorage,le),fe.set(g.ExtHostContext.ExtHostTunnelService,Te),fe.set(g.ExtHostContext.ExtHostWindow,Ze),fe.set(g.ExtHostContext.ExtHostSecretState,ct),fe.set(g.ExtHostContext.ExtHostTelemetry,mt);const ht=fe.set(g.ExtHostContext.ExtHostDecorations,We.get(Le.IExtHostDecorations)),Xe=fe.set(g.ExtHostContext.ExtHostDocumentsAndEditors,We.get(o.IExtHostDocumentsAndEditors)),ot=fe.set(g.ExtHostContext.ExtHostCommands,We.get(E.IExtHostCommands)),ft=fe.set(g.ExtHostContext.ExtHostTerminalService,We.get(x.IExtHostTerminalService)),at=fe.set(g.ExtHostContext.ExtHostDebugService,We.get(Y.IExtHostDebugService)),St=fe.set(g.ExtHostContext.ExtHostSearch,We.get(ee.IExtHostSearch)),vt=fe.set(g.ExtHostContext.ExtHostTask,We.get(H.IExtHostTask)),Pt=fe.set(g.ExtHostContext.ExtHostOutputService,We.get(p.IExtHostOutputService)),Tt=fe.set(g.ExtHostContext.ExtHostEditorTabs,new te.ExtHostEditorTabs),Rt=fe.set(g.ExtHostContext.ExtHostUrls,new L.ExtHostUrls(fe)),_t=fe.set(g.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(fe,Xe)),Zt=fe.set(g.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(fe,Xe,Fe)),en=fe.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Fe,_t,fe.getProxy(g.MainContext.MainThreadBulkEdits))),gt=fe.set(g.ExtHostContext.ExtHostNotebook,new we.ExtHostNotebookController(fe,ot,Xe,_t,Fe,Z)),tn=fe.set(g.ExtHostContext.ExtHostNotebookKernels,new ve.ExtHostNotebookKernels(fe,Ge,gt)),Dt=fe.set(g.ExtHostContext.ExtHostEditors,new W.ExtHostEditors(fe,Xe)),Gt=fe.set(g.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(fe.getProxy(g.MainContext.MainThreadTreeViews),ot,Fe)),nn=fe.set(g.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(fe.getProxy(g.MainContext.MainThreadEditorInsets),Dt,Ge.environment)),Qt=fe.set(g.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(fe,Fe)),lt=fe.set(g.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(fe,Ee,_t,ot,Qt,Fe,Qe)),rn=fe.set(g.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(fe,lt)),Lt=fe.set(g.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(fe,Fe,Xe)),Wt=fe.set(g.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(fe,Ye,ot)),gn=fe.set(g.ExtHostContext.ExtHostSCM,new V.ExtHostSCM(fe,ot,Fe)),Dn=fe.set(g.ExtHostContext.ExtHostComments,new w.ExtHostComments(fe,ot,_t)),pn=fe.set(g.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(fe.getProxy(g.MainContext.MainThreadProgress))),sn=fe.set(g.ExtHostContext.ExtHosLabelService,new Ae.ExtHostLabelService(fe)),Xt=fe.set(g.ExtHostContext.ExtHostTheming,new Pe.ExtHostTheming(fe)),Ut=fe.set(g.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(fe)),Cn=fe.set(g.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(fe,ot)),on=fe.set(g.ExtHostContext.ExtHostWebviews,new N.ExtHostWebviews(fe,Ge.environment,Ye,Fe,Qe)),an=fe.set(g.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(fe,on,Ye)),Yt=fe.set(g.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(fe,_t,Z,on,an)),kn=fe.set(g.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(fe,on)),Ft=fe.set(g.ExtHostContext.ExtHostTesting,new se.ExtHostTesting(fe,Xe,Ye)),ln=fe.set(g.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(fe)),Pn=(0,de.values)(g.ExtHostContext);fe.assertRegistered(Pn);const $t=new Je.ExtHostBulkEdits(fe,Xe),cn=new d.ExtHostClipboard(fe),xt=new u.ExtHostMessageService(fe,Fe),Mt=new l.ExtHostDialogs(fe),vn=new re.ExtHostStatusBar(fe,ot.converter),Ht=new _.ExtHostLanguages(fe,_t);return a.ExtHostApiCommands.register(ot),function(Me,un,dn){const pt=function(){let ne=!Me.isUnderDevelopment;function ue(Ie){ne||(Fe.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ie(rt){if(Array.isArray(rt))rt.forEach(Ie);else if(typeof rt=="string")ue(rt);else{const bt=rt;typeof bt.scheme=="undefined"&&ue(rt),!Me.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Me)}return rt}}(),In={getSession(ne,ue,Ie){return Ut.getSession(Me,ne,ue,Ie)},get onDidChangeSessions(){return Ut.onDidChangeSessions},registerAuthenticationProvider(ne,ue,Ie,rt){return Ut.registerAuthenticationProvider(ne,ue,Ie,rt)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Me),Ut.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Me),Ut.providers},logout(ne,ue){return(0,Q.checkProposedApiEnabled)(Me),Ut.removeSession(ne,ue)}},An={registerCommand(ne,ue,Ie){return ot.registerCommand(!0,ne,ue,Ie)},registerTextEditorCommand(ne,ue,Ie){return ot.registerCommand(!0,ne,(...rt)=>{const bt=Dt.getActiveTextEditor();if(!bt){Fe.warn("Cannot execute "+ne+" because there is no active text editor.");return}return bt.edit(Ct=>{ue.apply(Ie,[bt,Ct,...rt])}).then(Ct=>{Ct||Fe.warn("Edits from command "+ne+" were not applied.")},Ct=>{Fe.warn("An error occurred while running command "+ne,Ct)})})},registerDiffInformationCommand:(ne,ue,Ie)=>((0,Q.checkProposedApiEnabled)(Me),ot.registerCommand(!0,ne,async(...rt)=>{const bt=Xe.activeEditor(!0);if(!bt){Fe.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(bt.id);ue.apply(Ie,[Ct,...rt])})),executeCommand(ne,...ue){return ot.executeCommand(ne,...ue)},getCommands(ne=!1){return ot.getCommands(ne)}},wn={get machineId(){return Ge.telemetryInfo.machineId},get sessionId(){return Ge.telemetryInfo.sessionId},get language(){return Ge.environment.appLanguage},get appName(){return Ge.environment.appName},get appRoot(){var ne,ue;return(ue=(ne=Ge.environment.appRoot)===null||ne===void 0?void 0:ne.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ge.environment.appUriScheme},get clipboard(){return cn.value},get shell(){return ft.getDefaultShell(!1,dn)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(Ge.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,ue){return Ze.openUri(ne,{allowTunneling:!!Ge.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(ne){return ne.scheme===Ge.environment.appUriScheme?Rt.createAppUri(ne):Ze.asExternalUri(ne,{allowTunneling:!!Ge.remote.authority})},get remoteName(){return(0,Ce.getRemoteName)(Ge.remote.authority)},get uiKind(){return Ge.uiKind}};Ge.environment.extensionTestsLocationURI||Object.freeze(wn);const bn=Ge.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,zt={registerTestController(ne){return(0,Q.checkProposedApiEnabled)(Me),Ft.registerTestController(Me.identifier.value,ne)},createDocumentTestObserver(ne){return(0,Q.checkProposedApiEnabled)(Me),Ft.createTextDocumentTestObserver(ne)},createWorkspaceTestObserver(ne){return(0,Q.checkProposedApiEnabled)(Me),Ft.createWorkspaceTestObserver(ne)},runTests(ne){return(0,Q.checkProposedApiEnabled)(Me),Ft.runTests(ne)},createTestItem(ne,ue){return new F.TestItemImpl(ne.id,ne.label,ne.uri,ue)},createTestRun(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),Ft.createTestRun(Me.identifier.value,ne,ue,Ie)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Me),Ft.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Me),Ft.results}};zt.createTestRunTask=zt.createTestRun;const Tn={getExtension(ne){const ue=un.getExtensionDescription(ne);if(ue)return new i.Extension(it,Me.identifier,ue,bn)},get all(){return un.getAllExtensionDescriptions().map(ne=>new i.Extension(it,Me.identifier,ne,bn))},get onDidChange(){return un.onDidChange}},Rn={createDiagnosticCollection(ne){return Qt.createDiagnosticCollection(Me.identifier,ne)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:ne=>Qt.getDiagnostics(ne),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(ne,ue){return Ht.changeLanguage(ne.uri,ue)},match(ne,ue){return(0,C.score)(M.LanguageSelector.from(ne),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(ne,ue,Ie){return lt.registerCodeActionProvider(Me,pt(ne),ue,Ie)},registerCodeLensProvider(ne,ue){return lt.registerCodeLensProvider(Me,pt(ne),ue)},registerDefinitionProvider(ne,ue){return lt.registerDefinitionProvider(Me,pt(ne),ue)},registerDeclarationProvider(ne,ue){return lt.registerDeclarationProvider(Me,pt(ne),ue)},registerImplementationProvider(ne,ue){return lt.registerImplementationProvider(Me,pt(ne),ue)},registerTypeDefinitionProvider(ne,ue){return lt.registerTypeDefinitionProvider(Me,pt(ne),ue)},registerHoverProvider(ne,ue){return lt.registerHoverProvider(Me,pt(ne),ue,Me.identifier)},registerEvaluatableExpressionProvider(ne,ue){return lt.registerEvaluatableExpressionProvider(Me,pt(ne),ue,Me.identifier)},registerInlineValuesProvider(ne,ue){return lt.registerInlineValuesProvider(Me,pt(ne),ue,Me.identifier)},registerDocumentHighlightProvider(ne,ue){return lt.registerDocumentHighlightProvider(Me,pt(ne),ue)},registerLinkedEditingRangeProvider(ne,ue){return lt.registerLinkedEditingRangeProvider(Me,pt(ne),ue)},registerReferenceProvider(ne,ue){return lt.registerReferenceProvider(Me,pt(ne),ue)},registerRenameProvider(ne,ue){return lt.registerRenameProvider(Me,pt(ne),ue)},registerDocumentSymbolProvider(ne,ue,Ie){return lt.registerDocumentSymbolProvider(Me,pt(ne),ue,Ie)},registerWorkspaceSymbolProvider(ne){return lt.registerWorkspaceSymbolProvider(Me,ne)},registerDocumentFormattingEditProvider(ne,ue){return lt.registerDocumentFormattingEditProvider(Me,pt(ne),ue)},registerDocumentRangeFormattingEditProvider(ne,ue){return lt.registerDocumentRangeFormattingEditProvider(Me,pt(ne),ue)},registerOnTypeFormattingEditProvider(ne,ue,Ie,...rt){return lt.registerOnTypeFormattingEditProvider(Me,pt(ne),ue,[Ie].concat(rt))},registerDocumentSemanticTokensProvider(ne,ue,Ie){return lt.registerDocumentSemanticTokensProvider(Me,pt(ne),ue,Ie)},registerDocumentRangeSemanticTokensProvider(ne,ue,Ie){return lt.registerDocumentRangeSemanticTokensProvider(Me,pt(ne),ue,Ie)},registerSignatureHelpProvider(ne,ue,Ie,...rt){return typeof Ie=="object"?lt.registerSignatureHelpProvider(Me,pt(ne),ue,Ie):lt.registerSignatureHelpProvider(Me,pt(ne),ue,typeof Ie=="undefined"?[]:[Ie,...rt])},registerCompletionItemProvider(ne,ue,...Ie){return lt.registerCompletionItemProvider(Me,pt(ne),ue,Ie)},registerDocumentLinkProvider(ne,ue){return lt.registerDocumentLinkProvider(Me,pt(ne),ue)},registerColorProvider(ne,ue){return lt.registerColorProvider(Me,pt(ne),ue)},registerFoldingRangeProvider(ne,ue){return lt.registerFoldingRangeProvider(Me,pt(ne),ue)},registerSelectionRangeProvider(ne,ue){return lt.registerSelectionRangeProvider(Me,ne,ue)},registerCallHierarchyProvider(ne,ue){return lt.registerCallHierarchyProvider(Me,ne,ue)},setLanguageConfiguration:(ne,ue)=>lt.setLanguageConfiguration(Me,ne,ue),getTokenInformationAtPosition(ne,ue){return(0,Q.checkProposedApiEnabled)(Me),Ht.tokenAtPosition(ne,ue)},registerInlayHintsProvider(ne,ue){return(0,Q.checkProposedApiEnabled)(Me),lt.registerInlayHintsProvider(Me,ne,ue)}},Ln={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(ne,ue,Ie){const rt=await(P.URI.isUri(ne)?Promise.resolve(_n.openTextDocument(ne)):Promise.resolve(ne));return Dt.showTextDocument(rt,ue,Ie)},createTextEditorDecorationType(ne){return Dt.createTextEditorDecorationType(ne)},onDidChangeActiveTextEditor(ne,ue,Ie){return Dt.onDidChangeActiveTextEditor(ne,ue,Ie)},onDidChangeVisibleTextEditors(ne,ue,Ie){return Dt.onDidChangeVisibleTextEditors(ne,ue,Ie)},onDidChangeTextEditorSelection(ne,ue,Ie){return Dt.onDidChangeTextEditorSelection(ne,ue,Ie)},onDidChangeTextEditorOptions(ne,ue,Ie){return Dt.onDidChangeTextEditorOptions(ne,ue,Ie)},onDidChangeTextEditorVisibleRanges(ne,ue,Ie){return Dt.onDidChangeTextEditorVisibleRanges(ne,ue,Ie)},onDidChangeTextEditorViewColumn(ne,ue,Ie){return Dt.onDidChangeTextEditorViewColumn(ne,ue,Ie)},onDidCloseTerminal(ne,ue,Ie){return ft.onDidCloseTerminal(ne,ue,Ie)},onDidOpenTerminal(ne,ue,Ie){return ft.onDidOpenTerminal(ne,ue,Ie)},onDidChangeActiveTerminal(ne,ue,Ie){return ft.onDidChangeActiveTerminal(ne,ue,Ie)},onDidChangeTerminalDimensions(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),ft.onDidChangeTerminalDimensions(ne,ue,Ie)},onDidWriteTerminalData(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),ft.onDidWriteTerminalData(ne,ue,Ie)},get state(){return Ze.state},onDidChangeWindowState(ne,ue,Ie){return Ze.onDidChangeWindowState(ne,ue,Ie)},showInformationMessage(ne,...ue){return xt.showMessage(Me,y.default.Info,ne,ue[0],ue.slice(1))},showWarningMessage(ne,...ue){return xt.showMessage(Me,y.default.Warning,ne,ue[0],ue.slice(1))},showErrorMessage(ne,...ue){return xt.showMessage(Me,y.default.Error,ne,ue[0],ue.slice(1))},showQuickPick(ne,ue,Ie){return Wt.showQuickPick(ne,!!Me.enableProposedApi,ue,Ie)},showWorkspaceFolderPick(ne){return Wt.showWorkspaceFolderPick(ne)},showInputBox(ne,ue){return Wt.showInput(ne,ue)},showOpenDialog(ne){return Mt.showOpenDialog(ne)},showSaveDialog(ne){return Mt.showSaveDialog(ne)},createStatusBarItem(ne,ue){let Ie,rt,bt,Ct;return ne&&typeof ne!="number"?(Ie=ne.id,rt=ne.name,bt=ne.alignment,ue=ne.priority,Ct=ne.accessibilityInformation):(Ie=Me.identifier.value,rt=b.localize(0,null,Me.displayName||Me.name),bt=ne),vn.createStatusBarEntry(Ie,rt,bt,ue,Ct)},setStatusBarMessage(ne,ue){return vn.setStatusBarMessage(ne,ue)},withScmProgress(ne){return Qe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),pn.withProgress(Me,{location:F.ProgressLocation.SourceControl},(ue,Ie)=>ne({report(rt){}}))},withProgress(ne,ue){return pn.withProgress(Me,ne,ue)},createOutputChannel(ne){return Pt.createOutputChannel(ne)},createWebviewPanel(ne,ue,Ie,rt){return an.createWebviewPanel(Me,ne,ue,Ie,rt)},createWebviewTextEditorInset(ne,ue,Ie,rt){return(0,Q.checkProposedApiEnabled)(Me),nn.createWebviewEditorInset(ne,ue,Ie,rt,Me)},createTerminal(ne,ue,Ie){return typeof ne=="object"?"pty"in ne?ft.createExtensionTerminal(ne):(ne.icon&&(0,Q.checkProposedApiEnabled)(Me),ft.createTerminalFromOptions(ne)):ft.createTerminal(ne,ue,Ie)},registerTerminalLinkProvider(ne){return ft.registerLinkProvider(ne)},registerTreeDataProvider(ne,ue){return Gt.registerTreeDataProvider(ne,ue,Me)},createTreeView(ne,ue){return Gt.createTreeView(ne,ue,Me)},registerWebviewPanelSerializer:(ne,ue)=>an.registerWebviewPanelSerializer(Me,ne,ue),registerCustomEditorProvider:(ne,ue,Ie={})=>Yt.registerCustomEditorProvider(Me,ne,ue,Ie),registerFileDecorationProvider(ne){return ht.registerFileDecorationProvider(ne,Me.identifier)},registerUriHandler(ne){return Rt.registerUriHandler(Me.identifier,ne)},createQuickPick(){return Wt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Wt.createInputBox(Me.identifier)},get activeColorTheme(){return Xt.activeColorTheme},onDidChangeActiveColorTheme(ne,ue,Ie){return Xt.onDidChangeActiveColorTheme(ne,ue,Ie)},registerWebviewViewProvider(ne,ue,Ie){return kn.registerWebviewViewProvider(Me,ne,ue,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Me),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeActiveNotebookEditor(ne,ue,Ie)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Me),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorSelection(ne,ue,Ie)},onDidChangeNotebookEditorVisibleRanges(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorVisibleRanges(ne,ue,Ie)},showNotebookDocument(ne,ue){return(0,Q.checkProposedApiEnabled)(Me),gt.showNotebookDocument(ne,ue)},registerExternalUriOpener(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),ln.registerExternalUriOpener(Me.identifier,ne,ue,Ie)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Me),Tt.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Me),Tt.onDidChangeTabs}},_n={get rootPath(){return Qe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ye.getPath()},set rootPath(ne){throw T.readonly()},getWorkspaceFolder(ne){return Ye.getWorkspaceFolder(ne)},get workspaceFolders(){return Ye.getWorkspaceFolders()},get name(){return Ye.name},set name(ne){throw T.readonly()},get workspaceFile(){return Ye.workspaceFile},set workspaceFile(ne){throw T.readonly()},updateWorkspaceFolders:(ne,ue,...Ie)=>Ye.updateWorkspaceFolders(Me,ne,ue||0,...Ie),onDidChangeWorkspaceFolders:function(ne,ue,Ie){return Ye.onDidChangeWorkspace(ne,ue,Ie)},asRelativePath:(ne,ue)=>Ye.getRelativePath(ne,ue),findFiles:(ne,ue,Ie,rt)=>Ye.findFiles(M.GlobPattern.from(ne),M.GlobPattern.from(ue),Ie,Me.identifier,rt),findTextInFiles:(ne,ue,Ie,rt)=>{let bt,Ct;return typeof ue=="object"?(bt=ue,Ct=Ie):(bt={},Ct=ue,rt=Ie),Ye.findTextInFiles(ne,bt||{},Ct,Me.identifier,rt)},saveAll:ne=>Ye.saveAll(ne),applyEdit(ne){return $t.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,ue,Ie,rt)=>Lt.createFileSystemWatcher(M.GlobPattern.from(ne),ue,Ie,rt),get textDocuments(){return _t.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw T.readonly()},openTextDocument(ne){let ue;const Ie=ne;if(typeof ne=="string")ue=Promise.resolve(P.URI.file(ne));else if(P.URI.isUri(ne))ue=Promise.resolve(ne);else if(!Ie||typeof Ie=="object")ue=_t.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>_t.ensureDocumentData(rt).then(bt=>bt.document))},onDidOpenTextDocument:(ne,ue,Ie)=>_t.onDidAddDocument(ne,ue,Ie),onDidCloseTextDocument:(ne,ue,Ie)=>_t.onDidRemoveDocument(ne,ue,Ie),onDidChangeTextDocument:(ne,ue,Ie)=>_t.onDidChangeDocument(ne,ue,Ie),onDidSaveTextDocument:(ne,ue,Ie)=>_t.onDidSaveDocument(ne,ue,Ie),onWillSaveTextDocument:(ne,ue,Ie)=>en.getOnWillSaveTextDocumentEvent(Me)(ne,ue,Ie),onDidChangeConfiguration:(ne,ue,Ie)=>dn.onDidChangeConfiguration(ne,ue,Ie),getConfiguration(ne,ue){return ue=arguments.length===1?void 0:ue,dn.getConfiguration(ne,ue,Me)},registerTextDocumentContentProvider(ne,ue){return Zt.registerTextDocumentContentProvider(ne,ue)},registerTaskProvider:(ne,ue)=>(Qe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Me,ne,ue)),registerFileSystemProvider(ne,ue,Ie){return rn.registerFileSystemProvider(Me.identifier,ne,ue,Ie)},get fs(){return dt.value},registerFileSearchProvider:(ne,ue)=>((0,Q.checkProposedApiEnabled)(Me),St.registerFileSearchProvider(ne,ue)),registerTextSearchProvider:(ne,ue)=>((0,Q.checkProposedApiEnabled)(Me),St.registerTextSearchProvider(ne,ue)),registerRemoteAuthorityResolver:(ne,ue)=>((0,Q.checkProposedApiEnabled)(Me),it.registerRemoteAuthorityResolver(ne,ue)),registerResourceLabelFormatter:ne=>((0,Q.checkProposedApiEnabled)(Me),sn.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,ue,Ie)=>Lt.onDidCreateFile(ne,ue,Ie),onDidDeleteFiles:(ne,ue,Ie)=>Lt.onDidDeleteFile(ne,ue,Ie),onDidRenameFiles:(ne,ue,Ie)=>Lt.onDidRenameFile(ne,ue,Ie),onWillCreateFiles:(ne,ue,Ie)=>Lt.getOnWillCreateFileEvent(Me)(ne,ue,Ie),onWillDeleteFiles:(ne,ue,Ie)=>Lt.getOnWillDeleteFileEvent(Me)(ne,ue,Ie),onWillRenameFiles:(ne,ue,Ie)=>Lt.getOnWillRenameFileEvent(Me)(ne,ue,Ie),openTunnel:ne=>((0,Q.checkProposedApiEnabled)(Me),Te.openTunnel(Me,ne).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Me),Te.getTunnels()},onDidChangeTunnels:(ne,ue,Ie)=>((0,Q.checkProposedApiEnabled)(Me),Te.onDidChangeTunnels(ne,ue,Ie)),registerPortAttributesProvider:(ne,ue)=>((0,Q.checkProposedApiEnabled)(Me),Te.registerPortsAttributesProvider(ne,ue)),registerTimelineProvider:(ne,ue)=>((0,Q.checkProposedApiEnabled)(Me),Cn.registerTimelineProvider(ne,ue,Me.identifier,ot.converter)),get isTrusted(){return Ye.trusted},requestWorkspaceTrust:ne=>((0,Q.checkProposedApiEnabled)(Me),Ye.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,ue,Ie)=>Ye.onDidGrantWorkspaceTrust(ne,ue,Ie)},Fn={get inputBox(){return Qe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),gn.getLastInputBox(Me)},createSourceControl(ne,ue,Ie){return gn.createSourceControl(Me,ne,ue,Ie)}},En={createCommentController(ne,ue){return Dn.createCommentController(Me,ne,ue)}},Sn={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(ne,ue,Ie){return at.onDidStartDebugSession(ne,ue,Ie)},onDidTerminateDebugSession(ne,ue,Ie){return at.onDidTerminateDebugSession(ne,ue,Ie)},onDidChangeActiveDebugSession(ne,ue,Ie){return at.onDidChangeActiveDebugSession(ne,ue,Ie)},onDidReceiveDebugSessionCustomEvent(ne,ue,Ie){return at.onDidReceiveDebugSessionCustomEvent(ne,ue,Ie)},onDidChangeBreakpoints(ne,ue,Ie){return at.onDidChangeBreakpoints(ne,ue,Ie)},registerDebugConfigurationProvider(ne,ue,Ie){return at.registerDebugConfigurationProvider(ne,ue,Ie||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,ue){return at.registerDebugAdapterDescriptorFactory(Me,ne,ue)},registerDebugAdapterTrackerFactory(ne,ue){return at.registerDebugAdapterTrackerFactory(ne,ue)},startDebugging(ne,ue,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?at.startDebugging(ne,ue,{parentSession:Ie}):at.startDebugging(ne,ue,Ie||{})},stopDebugging(ne){return at.stopDebugging(ne)},addBreakpoints(ne){return at.addBreakpoints(ne)},removeBreakpoints(ne){return at.removeBreakpoints(ne)},asDebugSourceUri(ne,ue){return at.asDebugSourceUri(ne,ue)}},Bt={registerTaskProvider:(ne,ue)=>vt.registerTaskProvider(Me,ne,ue),fetchTasks:ne=>vt.fetchTasks(ne),executeTask:ne=>vt.executeTask(Me,ne),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ne,ue,Ie)=>vt.onDidStartTask(ne,ue,Ie),onDidEndTask:(ne,ue,Ie)=>vt.onDidEndTask(ne,ue,Ie),onDidStartTaskProcess:(ne,ue,Ie)=>vt.onDidStartTaskProcess(ne,ue,Ie),onDidEndTaskProcess:(ne,ue,Ie)=>vt.onDidEndTaskProcess(ne,ue,Ie)},Vt={openNotebookDocument:ne=>((0,Q.checkProposedApiEnabled)(Me),gt.openNotebookDocument(ne)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Me),gt.notebookDocuments.map(ne=>ne.apiNotebook)},registerNotebookSerializer(ne,ue,Ie,rt){return(0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookSerializer(Me,ne,ue,Ie,Me.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(ne,ue,Ie,rt)=>((0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookContentProvider(Me,ne,ue,Ie,Me.enableProposedApi?rt:void 0)),registerNotebookCellStatusBarItemProvider:(ne,ue)=>((0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookCellStatusBarItemProvider(Me,ne,ue)),createNotebookEditorDecorationType(ne){return(0,Q.checkProposedApiEnabled)(Me),gt.createNotebookEditorDecorationType(ne)},onDidChangeNotebookDocumentMetadata(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookDocumentMetadata(ne,ue,Ie)},onDidChangeNotebookCells(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCells(ne,ue,Ie)},onDidChangeCellExecutionState(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCellExecutionState(ne,ue,Ie)},onDidChangeCellOutputs(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeCellOutputs(ne,ue,Ie)},onDidChangeCellMetadata(ne,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeCellMetadata(ne,ue,Ie)},createConcatTextDocument(ne,ue){return(0,Q.checkProposedApiEnabled)(Me),new X.ExtHostNotebookConcatDocument(gt,_t,ne,ue)},createNotebookController(ne,ue,Ie,rt,bt){return(0,Q.checkProposedApiEnabled)(Me),tn.createNotebookController(Me,ne,ue,Ie,rt,bt)}};return{version:Ge.version,authentication:In,commands:An,comments:En,debug:Sn,env:wn,extensions:Tn,languages:Rn,notebook:Vt,scm:Fn,tasks:Bt,test:zt,window:Ln,workspace:_n,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:f.FileType,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,Hover:F.Hover,IndentAction:r.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,UIKind:g.UIKind,Uri:P.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,RemoteTrustOption:ye.RemoteTrustOption,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookDocumentMetadata:F.NotebookDocumentMetadata,NotebookCellMetadata:F.NotebookCellMetadata,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookKernelPreload:F.NotebookKernelPreload,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,LinkedEditingRanges:F.LinkedEditingRanges,TestItemStatus:F.TestItemStatus,TestResultState:F.TestResultState,TestMessage:F.TestMessage,TextSearchCompleteMessageType:je.TextSearchCompleteMessageType,TestMessageSeverity:F.TestMessageSeverity,WorkspaceTrustState:F.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=He}),define(ge[269],pe([0,1,79,64,32,127,35,51,39,34,67,46,69,93,92,50,63,128,91,61,90,120]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,b.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,b.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,b.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,b.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,b.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,b.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,b.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo),(0,b.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,b.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch),(0,b.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,b.registerSingleton)(r.IExtHostTask,r.WorkerExtHostTask),(0,b.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,b.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,b.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,b.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,b.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,b.registerSingleton)(v.IExtHostTelemetry,v.ExtHostTelemetry)}),define(ge[94],pe([0,1,17,14,31,66]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=y;function P(C,f,g,a){const d=(0,b.mapArrayOrNot)(g,D),E=new T.TextSearchMatch(f,d,a),w=E.preview.matches;return{ranges:(0,b.mapArrayOrNot)(d,k),uri:C,preview:{text:E.preview.text,matches:(0,b.mapArrayOrNot)(w,k)}}}e.createTextSearchResult=P;function D(C){return new T.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new A.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let r=class{constructor(f,g){this.prefix=f,this.logService=g}appendLine(f){this.logService.debug(`${this.prefix}#search`,f)}};r=Ve([xe(1,I.ILogService)],r),e.OutputChannel=r}),define(ge[270],pe([0,1,96,23]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,y=512,P=512*8,D=512*128;class k{constructor(n){this.iconvLiteDecoder=n}static async create(n){let o;if(n!==e.UTF8)o=(await new Promise((s,c)=>{G(["iconv-lite-umd"],s,c)})).getDecoder(g(n));else{const i=new TextDecoder;o={write(s){return i.decode(s,{stream:!0})},end(){return i.decode()}}}return new k(o)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function r(t,n){var o;const i=((o=n.minBytesRequiredForDetection)!==null&&o!==void 0?o:n.guessEncoding)?P:y;return new Promise((s,c)=>{const h=(0,b.newWriteableStream)(O=>O.join("")),_=[];let u=0,p;const R=async()=>{try{const O=await v({buffer:I.VSBuffer.concat(_),bytesRead:u},n.guessEncoding);O.encoding=await n.overwriteEncoding(O.encoding),p=await k.create(O.encoding);const V=p.write(I.VSBuffer.concat(_).buffer);h.write(V),_.length=0,u=0,s({stream:h,detected:O})}catch(O){c(O)}};(0,b.listenStream)(t,{onData:async O=>{p?h.write(p.write(O.buffer)):(_.push(O),u+=O.byteLength,u>=i&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:O=>h.error(O),onEnd:async()=>{p||await R(),h.end(p==null?void 0:p.end())}})})}e.toDecodeStream=r;async function C(t,n,o){const s=(await new Promise((_,u)=>{G(["iconv-lite-umd"],_,u)})).getEncoder(g(n),o);let c=!1,h=!1;return{read(){if(h)return null;const _=t.read();if(typeof _!="string"){if(h=!0,!c&&(o==null?void 0:o.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return I.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=s.end();return u&&u.length>0?(c=!0,I.VSBuffer.wrap(u)):null}return c=!0,I.VSBuffer.wrap(s.write(_))}}}e.toEncodeReadable=C;async function f(t){return(await new Promise((o,i)=>{G(["iconv-lite-umd"],o,i)})).encodingExists(g(t))}e.encodingExists=f;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function a(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),i=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const s=t.readUInt8(2);return o===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const d=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((h,_)=>{G(["jschardet"],h,_)}),o=t.slice(0,D),i=m(o.buffer),s=n.detect(i);if(!s||!s.encoding)return null;const c=s.encoding.toLowerCase();return 0<=d.indexOf(c)?null:S(s.encoding)}const w={ibm866:"cp866",big5:"cp950"};function S(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function m(t){let n="";for(let o=0;o<t.length;o++)n+=String.fromCharCode(t[o]);return n}function l(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=l;function v({buffer:t,bytesRead:n},o){let i=a(t,n),s=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let c=!0,h=!0,_=!1;for(let u=0;u<n&&u<A;u++){const p=u%2==1,R=t.readUInt8(u)===0;if(R&&(_=!0),c&&(p&&!R||!p&&R)&&(c=!1),h&&(p&&R||!p&&!R)&&(h=!1),R&&!c&&!h)break}_&&(c?i=e.UTF16le:h?i=e.UTF16be:s=!0)}return o&&!s&&!i&&t?E(t.slice(0,n)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:s,encoding:i}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[130],pe([0,1,270,26,129]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends T.TextSearchManager{constructor(P,D,k=I){super(P,D,{readdir:r=>k.readdir(r.fsPath),toCanonicalName:r=>(0,b.toCanonicalName)(r)})}}e.NativeTextSearchManager=A}),define(ge[271],pe([0,1,272,286,287,2,288]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(C,f,g,a,d,E){const w=E.environment.useHostProxy,S=typeof w=="boolean"?w:!E.remote.isRemote,m=(0,y.createProxyResolver)({resolveProxy:v=>C.resolveProxy(v),getHttpProxySetting:()=>f.getConfiguration("http").get("proxy"),log:(v,t,...n)=>{switch(v){case y.LogLevel.Trace:a.trace(t,...n);break;case y.LogLevel.Debug:a.debug(t,...n);break;case y.LogLevel.Info:a.info(t,...n);break;case y.LogLevel.Warning:a.warn(t,...n);break;case y.LogLevel.Error:a.error(t,...n);break;case y.LogLevel.Critical:a.critical(t,...n);break;case y.LogLevel.Off:break;default:o(v,t,n);break}function o(i,s,...c){a.error("Unknown log level",i),a.error(s,...c)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:v=>{d.$publicLog2("resolveProxy",v)},useHostProxy:S,env:process.env}),l=D(f,m);return r(g,l)}e.connectProxyResolver=P;function D(C,f){const g={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(d=>{g.config=C.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(d=>{a.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"off"},a,!0)),on:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"on"},a,!0)),override:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"override"},a,!0)),onRequest:Object.assign({},b,(0,y.createHttpPatch)(b,f,g,a,!0)),default:Object.assign(b,(0,y.createHttpPatch)(b,f,g,a,!1))},https:{off:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"off"},a,!0)),on:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"on"},a,!0)),override:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"override"},a,!0)),onRequest:Object.assign({},I,(0,y.createHttpPatch)(I,f,g,a,!0)),default:Object.assign(I,(0,y.createHttpPatch)(I,f,g,a,!1))},tls:Object.assign(T,(0,y.createTlsPatch)(T))}}const k=new Map;function r(C,f){return C.getExtensionPathIndex().then(g=>{const a=G.__$__nodeRequire("module"),d=a._load;a._load=function(w,S,m){if(w==="tls")return f.tls;if(w!=="http"&&w!=="https")return d.apply(this,arguments);const l=f[w],v=g.findSubstr(A.URI.file(S.filename).fsPath);let t=k.get(v);if(t||k.set(v,t={}),!t[w]){let n=l.default;v&&v.enableProposedApi&&(n=l[v.proxySupport]||l.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(ge[273],pe([0,1,38,8,75,29,10,9,94,274]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const r=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(m,l,v,t){const n=f(m,l,v,t),o=l.folder.fsPath;return{cmd:b.spawn(r,n.args,{cwd:o}),rgDiskPath:r,siblingClauses:n.siblingClauses,rgArgs:n,cwd:o}}e.spawnRipgrepCmd=C;function f(m,l,v,t){const n=["--files","--hidden","--case-sensitive"];a([l],v,!1).forEach(i=>{const s=(0,D.anchorGlob)(i);if(n.push("-g",s),y.isMacintosh){const c=(0,T.normalizeNFD)(s);c!==s&&n.push("-g",c)}});const o=g([l],t,void 0,!1);return o.globArgs.forEach(i=>{const s=`!${(0,D.anchorGlob)(i)}`;if(n.push("-g",s),y.isMacintosh){const c=(0,T.normalizeNFD)(s);c!==s&&n.push("-g",c)}}),l.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),l.ignoreSymlinks||n.push("--follow"),m.exists&&n.push("--quiet"),n.push("--no-config"),l.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:o.siblingClauses}}function g(m,l,v,t=!0){const n=[];let o={};return m.forEach(i=>{const s=Object.assign({},i.excludePattern||{},l||{}),c=d(s,t?i.folder.fsPath:void 0,v);n.push(...c.globArgs),c.siblingClauses&&(o=Object.assign(o,c.siblingClauses))}),{globArgs:n,siblingClauses:o}}e.foldersToRgExcludeGlobs=g;function a(m,l,v=!0){const t=[];return m.forEach(n=>{const o=Object.assign({},l||{},n.includePattern||{}),i=d(o,v?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=a;function d(m,l,v){const t=[],n={};return Object.keys(m).forEach(o=>{if(!(v&&v.has(o))&&!!o){const i=m[o];o=w(l?E(l,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),t.push(S(o))):i&&i.when&&(n[o]=i)}}),{globArgs:t,siblingClauses:n}}function E(m,l){return I.isAbsolute(l)?l:I.join(m,l)}e.getAbsoluteGlob=E;function w(m){return m=P.rtrim(m,"\\"),P.rtrim(m,"/")}function S(m){return A.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=S}),define(ge[275],pe([0,1,38,37,8,103,17,59,33,75,29,10,47,9,11,26,31,273,101]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(o=>o())});class l{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,S.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(s=>{const c=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),h=s.folder.fsPath;i.folderQueries.map(_=>_.folder.fsPath).filter(_=>_!==h).forEach(_=>{(0,r.isEqualOrParent)(_,h)&&(c[T.relative(h,_)]=!0)}),this.folderExcludePatterns.set(h,new t(c,h))})}cancel(){this.isCanceled=!0}walk(i,s,c,h,_){if(this.fileWalkSW=f.StopWatch.create(!1),this.isCanceled)return _(null,this.isLimitHit);s.forEach(u=>{const p=T.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,p)||this.matchFile(c,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=f.StopWatch.create(!1),this.parallel(i,(u,p)=>{this.call(this.cmdTraversal,this,u,c,h,R=>{if(R){const O=(0,P.toErrorMessage)(R);console.error(O),this.errors.push(O),p(R,void 0)}else p(null,void 0)})},(u,p)=>{this.fileWalkSW.stop();const R=u?y.coalesce(u)[0]:null;_(R,this.isLimitHit)})}parallel(i,s,c){const h=new Array(i.length),_=new Array(i.length);let u=!1,p=0;if(i.length===0)return c(null,[]);i.forEach((R,O)=>{s(R,(V,re)=>{if(V?(u=!0,h[O]=null,_[O]=V):(h[O]=re,_[O]=null),++p===i.length)return c(u?_:null,h)})})}call(i,s,...c){try{i.apply(s,c)}catch(h){c[c.length-1](h)}}cmdTraversal(i,s,c,h){const _=i.folder.fsPath,u=C.isMacintosh;let p;const R=()=>p&&p.kill();m.add(R);let O=M=>{m.delete(R),O=()=>{},h(M)},V="";const re=this.initDirectoryTree();let j;const x=(0,w.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);p=x.cmd,j=!Object.keys(x.siblingClauses).length;const W=x.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let U=`${x.rgDiskPath} ${W}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),c({message:U}),this.cmdResultCount=0,this.collectStdout(p,"utf8",c,(M,F,L)=>{if(M){O(M);return}if(this.isLimitHit){O();return}const $=(V+(u?k.normalizeNFC(F||""):F)).split(`
`);if(L){const q=$.length;$[q-1]=$[q-1].trim(),$[q-1]||$.pop()}else V=$.pop()||"";if($.length&&$[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=$.length,j){for(const q of $)if(this.matchFile(s,{base:_,relativePath:q,searchPath:this.getSearchPath(i,q)}),this.isLimitHit){R();break}(L||this.isLimitHit)&&O();return}this.addDirectoryEntries(i,re,_,$,s),L&&(this.matchDirectoryTree(re,_,s),O())})}spawnFindCmd(i){const s=this.folderExcludePatterns.get(i.folder.fsPath),c=s.getBasenameTerms(),h=s.getPathTerms(),_=["-L","."];if(c.length||h.length){_.push("-not","(","(");for(const u of c)_.push("-name",u),_.push("-o");for(const u of h)_.push("-path",u),_.push("-o");_.pop(),_.push(")","-prune",")")}return _.push("-type","f"),b.spawn("find",_,{cwd:i.folder.fsPath})}readStdout(i,s,c){let h="";this.collectStdout(i,s,()=>{},(_,u,p)=>{if(_){c(_);return}h+=u,p&&c(null,h)})}collectStdout(i,s,c,h){let _=(R,O,V)=>{(R||V)&&(_=()=>{},this.cmdSW&&this.cmdSW.stop()),h(R,O,V)},u=!1;i.stdout?(this.forwardData(i.stdout,s,_),i.stdout.once("data",()=>u=!0)):c({message:"stdout is null"});let p;i.stderr?p=this.collectData(i.stderr):c({message:"stderr is null"}),i.on("error",R=>{_(R)}),i.on("close",R=>{let O;!u&&(O=this.decodeData(p,s))&&n(O)?_(new Error(`command failed with error code ${R}: ${this.decodeData(p,s)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),_(null,"",!0))})}forwardData(i,s,c){const h=new A.StringDecoder(s);return i.on("data",_=>{c(null,h.write(_))}),h}collectData(i){const s=[];return i.on("data",c=>{s.push(c)}),s}decodeData(i,s){const c=new A.StringDecoder(s);return i.map(h=>c.write(h)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:s},c,h,_){h.indexOf(this.filePattern)!==-1&&this.matchFile(_,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const u=p=>{const R=T.basename(p),O=T.dirname(p);let V=s[O];V||(V=s[O]=[],u(O)),V.push({base:c,relativePath:p,basename:R,searchPath:this.getSearchPath(i,p)})};h.forEach(u)}matchDirectoryTree({rootEntries:i,pathToEntries:s},c,h){const _=this,u=this.folderExcludePatterns.get(c),p=this.filePattern;function R(O){_.directoriesWalked++;const V=D.hasSiblingFn(()=>O.map(re=>re.basename));for(let re=0,j=O.length;re<j;re++){const x=O[re],{relativePath:W,basename:U}=x;if(!u.test(W,U,p!==U?V:void 0)){const M=s[W];if(M)R(M);else{if(_.filesWalked++,W===p)continue;_.matchFile(h,x)}if(_.isLimitHit)break}}}R(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,s,c,h,_){const u=i.folder,p=D.hasSiblingFn(()=>c);this.parallel(c,(R,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const V=s?[s,R].join(T.sep):R;if(this.folderExcludePatterns.get(i.folder.fsPath).test(V,R,this.config.filePattern!==R?p:void 0))return O(null);const re=[u.fsPath,V].join(T.sep);I.lstat(re,(j,x)=>{if(j||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(re,x,(W,U)=>W||this.isCanceled||this.isLimitHit?O(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(re,x,(M,F)=>M||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?O(null):(this.walkedPaths[F]=!0,(0,d.readdir)(re).then(L=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(i,V,L,h,N=>O(N||null))},L=>{O(null)})))):(this.filesWalked++,V===this.filePattern||this.maxFilesize&&a.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(h,{base:u.fsPath,relativePath:V,searchPath:this.getSearchPath(i,V)}),O(null,void 0)))})},R=>{const O=R&&y.coalesce(R);return _(O&&O.length>0?O[0]:void 0)})}matchFile(i,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,T.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(s))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,s,c){return s.isSymbolicLink()?I.stat(i,c):c(null,s)}realPathIfNeeded(i,s,c){return s.isSymbolicLink()?I.realpath(i,(h,_)=>h?c(h):c(null,_)):c(null,i)}getSearchPath(i,s){return i.folderName?T.join(i.folderName,s):s}}e.FileWalker=l;class v{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new l(i)}search(i,s,c){this.walker.walk(this.folderQueries,this.extraFiles,i,s,(h,_)=>{c(h,{limitHit:_,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(i,s){this.expression=i,this.root=s,this.init(i)}init(i){let s,c;Object.keys(i).filter(h=>i[h]).forEach(h=>{T.isAbsolute(h)?(s=s||D.getEmptyExpression(),s[h]=i[h]):(c=c||D.getEmptyExpression(),c[h]=i[h])}),this.absoluteParsedExpr=s&&D.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=c&&D.parse(c,{trimForExclusions:!0})}test(i,s,c){return this.relativeParsedExpr&&this.relativeParsedExpr(i,s,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,i),s,c)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function n(o){const i=o.trim().split(`
`),s=i[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return g.uppercaseFirstLetter(i[i.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=n}),define(ge[131],pe([0,1,38,289,103,17,53,33,8,9,2,31,66,290,274,94]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(u){this.outputChannel=u}provideTextSearchResults(u,p,R,O){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify(Object.assign(Object.assign({},p),{folder:p.folder.toString()}))}`),new Promise((V,re)=>{O.onCancellationRequested(()=>N());const j=n(u,p),x=p.folder.fsPath,W=j.map(be=>be.match(/^-/)?be:`'${be}'`).join(" ");this.outputChannel.appendLine(`${E} ${W}
 - cwd: ${x}`);let U=b.spawn(E,j,{cwd:x});U.on("error",be=>{console.error(be),this.outputChannel.appendLine("Error: "+(be&&be.message)),re((0,C.serializeSearchError)(new C.SearchError(be&&be.message,C.SearchErrorCode.rgProcessError)))});let M=!1;const F=new l(p.maxResults,x,p.previewOptions);F.on("result",be=>{M=!0,q="",R.report(be)});let L=!1;const N=()=>{L=!0,U&&U.kill(),F&&F.cancel()};let $=!1;F.on("hitLimit",()=>{$=!0,N()});let q="";U.stdout.on("data",be=>{F.handleData(be),M||(q+=be)});let Q=!1;U.stdout.once("data",()=>Q=!0);let de="";U.stderr.on("data",be=>{const Ae=be.toString();this.outputChannel.appendLine(Ae),de+=Ae}),U.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),L)V({limitHit:$});else{F.flush(),U=null;let be;de&&!Q&&(be=S(de))?re((0,C.serializeSearchError)(new C.SearchError(be.message,be.code))):V({limitHit:$})}})})}}e.RipgrepTextSearchEngine=w;function S(_){const u=_.split(`
`),p=u[0].trim();if(u.some(O=>O.startsWith("regex parse error")))return new C.SearchError(m(u),C.SearchErrorCode.regexParseError);const R=p.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new C.SearchError(p.charAt(0).toUpperCase()+p.substr(1),C.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new C.SearchError(p.charAt(0).toUpperCase()+p.substr(1),C.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(p,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function m(_){const u=["Regex parse error"],p=_.filter(R=>R.startsWith("PCRE2:"));if(p.length>=1){const R=p[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const O=R.split(":")[1];u.push(":"+O)}}return u.join("")}e.buildRegexParseError=m;class l extends I.EventEmitter{constructor(u,p,R){super();this.maxResults=u,this.rootFolder=p,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,p){return super.on(u,p),this}handleData(u){if(!this.isDone){const p=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(p)}}handleDecodedData(u){let p=u.indexOf(`
`);const R=this.remainder+u;if(p>=0)p+=this.remainder.length;else{this.remainder=R;return}let O=0;for(;p>=0;)this.handleLine(R.substring(O,p).trim()),O=p+1,p=R.indexOf(`
`,O);this.remainder=R.substring(O)}handleLine(u){if(!(this.isDone||!u)){let p;try{p=JSON.parse(u)}catch(R){throw new Error(`malformed line from rg: ${u}`)}if(p.type==="match"){const R=v(p.data.path),O=r.URI.file(D.join(this.rootFolder,R)),V=this.createTextSearchMatch(p.data,O);this.onResult(V),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const R=v(p.data.path),O=r.URI.file(D.join(this.rootFolder,R));this.createTextSearchContext(p.data,O).forEach(re=>this.onResult(re))}}}createTextSearchMatch(u,p){const R=u.line_number-1;let O=!1,V=v(u.lines);R===0&&(0,k.startsWithUTF8BOM)(V)&&(O=!0,V=(0,k.stripUTF8BOM)(V));const re=Buffer.from(V);let j=0,x=0,W=R;u.submatches.length===0&&u.submatches.push(V.length?{start:0,end:1,match:{text:V[0]}}:{start:0,end:0,match:{text:""}});const U=(0,A.coalesce)(u.submatches.map((M,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let L=v(M.match);R===0&&F===0&&O&&(L=(0,k.stripUTF8BOM)(L),M.start=M.start<=3?0:M.start-3,M.end=M.end<=3?0:M.end-3);const N=re.slice(j,M.start).toString().length,$=x+N,q=t(L),Q=W,de=q.numLines+Q,be=q.numLines>0?q.lastLineLength:q.lastLineLength+$;return j=M.end,x=be,W=de,new f.Range(Q,$,de,be)}));return(0,d.createTextSearchResult)(p,V,U,this.previewOptions)}createTextSearchContext(u,p){const R=v(u.lines),O=u.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((V,re)=>({text:V,uri:p,lineNumber:O+re}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=l;function v(_){return _.bytes?Buffer.from(_.bytes,"base64").toString():_.text}function t(_){const u=/\n/g;let p=0,R=-1,O;for(;O=u.exec(_);)p++,R=O.index;const V=R>=0?_.length-R-1:_.length;return{numLines:p,lastLineLength:V}}function n(_,u){const p=["--hidden"];p.push(_.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:O}=(0,y.groupBy)(u.includes,re=>re.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const re=new Set;O.forEach(j=>{re.add(j)}),p.push("-g","!*"),re.forEach(j=>{o(j).map(d.anchorGlob).forEach(x=>{p.push("-g",x)})})}R&&R.length&&R.forEach(re=>{p.push("-g",re)}),u.excludes.map(d.anchorGlob).forEach(re=>p.push("-g",`!${re}`)),u.maxFileSize&&p.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?p.push("--no-ignore-parent"):p.push("--no-ignore"),u.followSymlinks&&p.push("--follow"),u.encoding&&u.encoding!=="utf8"&&p.push("--encoding",u.encoding),_.pattern==="--"&&(_.isRegExp=!0,_.pattern="\\-\\-"),_.isMultiline&&!_.isRegExp&&(_.pattern=(0,k.escapeRegExpCharacters)(_.pattern),_.isRegExp=!0),u.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),_.isRegExp&&(_.pattern=i(_.pattern),p.push("--auto-hybrid-regex"));let V;if(_.isWordMatch){const j=(0,k.createRegExp)(_.pattern,!!_.isRegExp,{wholeWord:_.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",j)}else if(_.isRegExp){let re=c(_.pattern);re=h(re),p.push("--regexp",re)}else V=_.pattern,p.push("--fixed-strings");return p.push("--no-config"),u.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),_.isMultiline&&p.push("--multiline"),u.beforeContext&&p.push("--before-context",u.beforeContext+""),u.afterContext&&p.push("--after-context",u.afterContext+""),p.push("--"),V&&p.push(V),p.push("."),p}function o(_){const u=(0,P.splitGlobAware)(_,"/");return u.map((p,R)=>u.slice(0,R+1).join("/"))}e.spreadGlobComponents=o;function i(_){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;_.match(u);)_=_.replace(u,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;_.match(p);)_=_.replace(p,"$1\\x{$2}");return _}e.unicodeEscapesToPCRE2=i;const s=_=>_.type==="Assertion"&&_.kind==="lookbehind";function c(_){let u;try{u=new g.RegExpParser().parsePattern(_)}catch(j){return _}let p="",R=0;const O=(j,x,W)=>{p+=_.slice(R,j)+W,R=x},V=[];return new g.RegExpVisitor({onCharacterEnter(j){if(j.raw==="\\n"){const x=V[0];if(!x)O(j.start,j.end,"\\r?\\n");else if(!V.some(s))if(x.type==="CharacterClass")if(x.negate){const W=_.slice(x.start+2,j.start)+_.slice(j.end,x.end-1);O(x.start,x.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=_.slice(x.start+1,j.start)+_.slice(j.end,x.end-1);O(x.start,x.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else x.type==="Quantifier"&&O(j.start,j.end,"(?:\\r?\\n)")}},onQuantifierEnter(j){V.unshift(j)},onQuantifierLeave(){V.shift()},onCharacterClassRangeEnter(j){V.unshift(j)},onCharacterClassRangeLeave(){V.shift()},onCharacterClassEnter(j){V.unshift(j)},onCharacterClassLeave(){V.shift()},onAssertionEnter(j){s(j)&&V.push(j)},onAssertionLeave(j){V[0]===j&&V.shift()}}).visit(u),p+=_.slice(R),p}e.fixRegexNewline=c;function h(_){return _.replace(/\n/g,"\\r?\\n")}e.fixNewline=h}),define(ge[276],pe([0,1,21,131,116,12]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,r,C,f){const g=new I.RipgrepTextSearchEngine(this.outputChannel);if(r.folder.scheme===A.Schemas.userData){const a=Object.assign(Object.assign({},r),{folder:r.folder.with({scheme:A.Schemas.file})}),d=new T.Progress(E=>C.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:r.folder.scheme})})));return this.withToken(f,E=>g.provideTextSearchResults(k,a,d,E))}else return this.withToken(f,a=>g.provideTextSearchResults(k,r,C,a))}async withToken(k,r){const C=P(k);this.inProgress.add(C);const f=await r(C.token);return this.inProgress.delete(C),f}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=y;function P(D){const k=new b.CancellationTokenSource;return D.onCancellationRequested(()=>k.cancel()),k}}),define(ge[277],pe([0,1,26,131,130]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(D){this.query=D}search(D,k,r){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(g){r({message:g})}},f=new T.NativeTextSearchManager(this.query,new I.RipgrepTextSearchEngine(C),b);return new Promise((g,a)=>f.search(d=>{k(d.map(y))},D).then(d=>g({limitHit:d.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=A;function y(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((D,k)=>{if(k.ranges){const r=k;return D+(Array.isArray(r.ranges)?r.ranges.length:1)}else return D+1},0)}}}),define(ge[278],pe([0,1,37,291,17,13,16,3,101,8,47,2,45,31,275,277]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,I.gracefulify(b);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const o=m(t),i=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(s=>this.doFileSearchWithEngine(a.Engine,o,c=>i.fire(c),s)),n.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}textSearch(t){let n;const o=m(t),i=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(s=>this.ripgrepTextSearch(o,c=>i.fire(c),s)),n.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}ripgrepTextSearch(t,n,o){return t.maxFileSize=(0,f.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new d.TextSearchEngineAdapter(t).search(o,n,n)}doFileSearch(t,n,o){return this.doFileSearchWithEngine(a.Engine,t,n,o)}doFileSearchWithEngine(t,n,o,i,s=E.BATCH_SIZE){let c=0;const h=u=>{Array.isArray(u)?(c+=u.length,o(u.map(p=>this.rawMatchToSearchItem(p)))):u.relativePath?(c++,o(this.rawMatchToSearchItem(u))):o(u)};if(n.sortByScore){let u=this.trySortedSearchFromCache(n,h,i);if(!u){const p=n.maxResults?Object.assign({},n,{maxResults:null}):n,R=new t(p);u=this.doSortedSearch(R,n,o,h,i)}return new Promise((p,R)=>{u.then(([O,V])=>{const re=V.map(j=>this.rawMatchToSearchItem(j));this.sendProgress(re,o,s),p(O)},R)})}const _=new t(n);return this.doSearch(_,h,s,i).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:"searchProcess",fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,k.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,o,i,s){const c=new P.Emitter;let h=(0,A.createCancelablePromise)(u=>{let p=[];const R=O=>{Array.isArray(O)?p=O:(i(O),c.fire(O))};return this.doSearch(t,R,-1,u).then(O=>[O,p])}),_;if(n.cacheKey){_=this.getOrCreateCache(n.cacheKey);const u={promise:h,event:c.event,resolved:!1};_.resultsToSearchCache[n.filePattern||""]=u,h.then(()=>{u.resolved=!0},p=>{delete _.resultsToSearchCache[n.filePattern||""]}),h=this.preventCancellation(h)}return h.then(([u,p])=>{const R=_?_.scorerCache:Object.create(null),O=(typeof n.maxResults!="number"||n.maxResults>0)&&r.StopWatch.create(!1);return this.sortResults(n,p,R,s).then(V=>{const re=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:re,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:V.length},messages:u.messages,limitHit:u.limitHit||typeof n.maxResults=="number"&&p.length>n.maxResults},V]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,o){const i=t.cacheKey&&this.caches[t.cacheKey];if(!!i){const s=this.getResultsFromCache(i,t.filePattern||"",n,o);if(s)return s.then(([c,h,_])=>{const u=r.StopWatch.create(!1);return this.sortResults(t,h,i.scorerCache,o).then(p=>{const R=u.elapsed(),O={fromCache:!0,detailStats:_,type:"searchProcess",resultCount:h.length,sortingTime:R};return[{type:"success",limitHit:c.limitHit||typeof t.maxResults=="number"&&h.length>t.maxResults,stats:O},p]})})}}sortResults(t,n,o,i){const s=(0,D.prepareQuery)(t.filePattern||""),c=(_,u)=>(0,D.compareItemsByFuzzyScore)(_,u,s,!0,S,o),h=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return T.topAsync(n,c,h,1e4,i)}sendProgress(t,n,o){if(o&&o>0)for(let i=0;i<t.length;i+=o)n(t.slice(i,i+o));else n(t)}getResultsFromCache(t,n,o,i){const s=r.StopWatch.create(!1),c=n.indexOf(k.sep)>=0;let h;for(const R in t.resultsToSearchCache)if(n.startsWith(R)){if(c&&R.indexOf(k.sep)<0&&R!=="")continue;const O=t.resultsToSearchCache[R];h={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!h)return null;const _=s.elapsed(),u=r.StopWatch.create(!1),p=h.event(o);return i&&i.onCancellationRequested(()=>{p.dispose()}),h.promise.then(([R,O])=>{if(i&&i.isCancellationRequested)throw(0,y.canceled)();const V=[],re=(0,D.prepareQuery)(n).normalizedLowercase;for(const j of O)!(0,g.isFilePatternMatch)(j,re)||V.push(j);return[R,V,{cacheWasResolved:h.resolved,cacheLookupTime:_,cacheFilterTime:u.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,n,o,i){return new Promise((s,c)=>{let h=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(_=>{_&&(o?(h.push(_),o>0&&h.length>=o&&(n(h),h=[])):n(_))},_=>{n(_)},(_,u)=>{h.length&&n(h),_?c(_):s(u)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,o){return t.then(n,o)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(v){return(0,k.basename)(v.relativePath)}getItemDescription(v){return(0,k.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function m(v){return Object.assign(Object.assign({},v),{folderQueries:v.folderQueries&&v.folderQueries.map(l),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>C.URI.revive(t))})}function l(v){return Object.assign(Object.assign({},v),{folder:C.URI.revive(v.folder)})}}),define(ge[279],pe([0,1,6,2,26,14,31,278,276,94,15,62,28,69,12,130]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends g.ExtHostSearch{constructor(S,m,l,v){super(S,l,v);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new k.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),m.remote.isRemote&&m.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const S=new k.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(a.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(S,m){const l=this._handlePool++;return this._internalFileSearchProvider=m,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(S)),(0,b.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(S,m,l,v){const t=(0,g.reviveQuery)(l);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,m,t,v):super.$provideFileSearchResults(S,m,l,v)}doInternalFileSearch(S,m,l,v){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(S,m,n.map(o=>I.URI.file(o.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,t,v)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,m){return new d.NativeTextSearchManager(S,m)}};E=Ve([xe(0,r.IExtHostRpcService),xe(1,f.IExtHostInitDataService),xe(2,C.IURITransformerService),xe(3,A.ILogService)],E),e.NativeExtHostSearch=E}),define(ge[132],pe([0,1,292,123,293,3,106,8,48,30,6,23,107,16,10]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(h){this.socket=h,this._errorListener=_=>{if(_){if(_.code==="EPIPE")return;(0,g.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(h){const _=u=>h(C.VSBuffer.wrap(u));return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(h){return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,g.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,g.onUnexpectedError)(_)}}end(){this.socket.end()}drain(){return new Promise((h,_)=>{if(this.socket.bufferSize===0){h();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),h()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=d;var E;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var w;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(w||(w={}));class S extends r.Disposable{constructor(h,_,u,p){super();this._onDidZlibFlush=this._register(new A.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new A.Emitter),this._onClose=this._register(new A.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=_,this._recordInflateBytes=p,_?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,g.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,g.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let _=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.length-4),this._isEnded||this._write(C.VSBuffer.wrap(_),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,_){let u=2;h.byteLength<126?u+=0:h.byteLength<2**16?u+=2:u+=8;const p=C.VSBuffer.alloc(u);if(_?p.writeUInt8(194,0):p.writeUInt8(130,0),h.byteLength<126)p.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){p.writeUInt8(126,1);let R=1;p.writeUInt8(h.byteLength>>>8&255,++R),p.writeUInt8(h.byteLength>>>0&255,++R)}else{p.writeUInt8(127,1);let R=1;p.writeUInt8(0,++R),p.writeUInt8(0,++R),p.writeUInt8(0,++R),p.writeUInt8(0,++R),p.writeUInt8(h.byteLength>>>24&255,++R),p.writeUInt8(h.byteLength>>>16&255,++R),p.writeUInt8(h.byteLength>>>8&255,++R),p.writeUInt8(h.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=p.byteLength+h.byteLength,this.socket.write(C.VSBuffer.concat([p,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),p=(_.readUInt8(0)&128)>>>7,R=_.readUInt8(1),O=(R&128)>>>7,V=R&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=p,this._state.mask=0}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),u=_.readUInt8(1),p=(u&128)>>>7;let R=u&127,O=1;R===126?R=_.readUInt8(++O)*2**8+_.readUInt8(++O):R===127&&(R=_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*2**24+_.readUInt8(++O)*2**16+_.readUInt8(++O)*2**8+_.readUInt8(++O));let V=0;p&&(V=_.readUInt8(++O)*2**24+_.readUInt8(++O)*2**16+_.readUInt8(++O)*2**8+_.readUInt8(++O)),this._state.state=3,this._state.readLen=R,this._state.mask=V}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);m(_,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(_.buffer)),this._zlibInflate.write(_.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(C.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=_.byteLength,this._onData.fire(_))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await A.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=S;function m(c,h){if(h!==0){let _=c.byteLength>>>2;for(let re=0;re<_;re++){const j=c.readUInt32BE(re*4);c.writeUInt32BE(j^h,re*4)}let u=_*4,p=c.byteLength-u;const R=h>>>24&255,O=h>>>16&255,V=h>>>8&255;p>=1&&c.writeUInt8(c.readUInt8(u)^R,u),p>=2&&c.writeUInt8(c.readUInt8(u+1)^O,u+1),p>=3&&c.writeUInt8(c.readUInt8(u+2)^V,u+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function v(){const c=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let h;return e.XDG_RUNTIME_DIR?h=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):h=(0,P.join)((0,D.tmpdir)(),`vscode-ipc-${c}.sock`),n(h),h}e.createRandomIPCHandle=v;function t(c,h,_){const u=(0,b.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${_}-${h}-sock`;let p;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?p=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${_}-${h}.sock`):p=(0,P.join)(c,`${_}-${h}.sock`),n(p),p}e.createStaticIPCHandle=t;function n(c){const h=l[a.platform];typeof h=="number"&&c.length>=h&&console.warn(`WARNING: IPC handle "${c}" is longer than ${h} chars, try a shorter --user-data-dir`)}class o extends y.IPCServer{constructor(h){super(o.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const _=A.Event.fromNodeEventEmitter(h,"connection");return A.Event.map(_,u=>({protocol:new f.Protocol(new d(u)),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function i(c){return new Promise((h,_)=>{const u=(0,I.createServer)();u.on("error",_),u.listen(c,()=>{u.removeListener("error",_),h(new o(u))})})}e.serve=i;function s(c,h){return new Promise((_,u)=>{const p=(0,I.createConnection)(c,()=>{p.removeListener("error",u),_(f.Client.fromSocket(new d(p),h))});p.once("error",u)})}e.connect=s}),define(ge[280],pe([0,1,132,272,37,51,2,119,14]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(f,g,a){this._commands=f,this.logService=g,this._ipcHandlePath=a,this._server=I.createServer((d,E)=>this.onRequest(d,E)),this.setup().catch(d=>(g.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",f=>this.logService.error(f))}catch(f){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(f,g){const a=[];f.setEncoding("utf8"),f.on("data",d=>a.push(d)),f.on("end",()=>{const d=JSON.parse(a.join(""));switch(d.type){case"open":this.open(d,g);break;case"openExternal":this.openExternal(d,g);break;case"status":this.getStatus(d,g);break;case"extensionManagement":this.manageExtensions(d,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${d.type}`,E=>{E&&this.logService.error(E)}),g.end();break}})}open(f,g){let{fileURIs:a,folderURIs:d,forceNewWindow:E,diffMode:w,addMode:S,forceReuseWindow:m,gotoLineMode:l,waitMarkerFilePath:v}=f;const t=[];if(Array.isArray(d))for(const n of d)try{t.push({folderUri:y.URI.parse(n)})}catch(o){}if(Array.isArray(a))for(const n of a)try{(0,P.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(o){}if(t.length){const n=v?y.URI.file(v):void 0,i={forceNewWindow:E,diffMode:w,addMode:S,gotoLineMode:l,forceReuseWindow:m,preferNewWindow:!m&&!n&&!S,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}g.writeHead(200),g.end()}async openExternal(f,g){for(const a of f.uris){const d=y.URI.parse(a),E=d.scheme==="file"?d:a;await this._commands.executeCommand("_remoteCLI.openExternal",E)}g.writeHead(200),g.end()}async manageExtensions(f,g){try{const a=w=>w==null?void 0:w.map(S=>/\.vsix$/i.test(S)?y.URI.parse(S):S),d={list:f.list,install:a(f.install),uninstall:a(f.uninstall),force:f.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);g.writeHead(200),g.write(E)}catch(a){g.writeHead(500),g.write(String(a),d=>{d&&this.logService.error(d)})}g.end()}async getStatus(f,g){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");g.writeHead(200),g.write(a),g.end()}catch(a){g.writeHead(500),g.write(String(a),d=>{d&&this.logService.error(d)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let r=class extends k{constructor(f,g){super(f,g,(0,b.createRandomIPCHandle)())}};r=Ve([xe(0,A.IExtHostCommands),xe(1,D.ILogService)],r),e.CLIServer=r}),define(ge[281],pe([0,1,68,268,262,5,271,42,253,2,12,7,280,104]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends T.RequireInterceptor{_installInterceptor(){const w=this,S=G.__$__nodeRequire("module"),m=S._load;S._load=function(v,t,n){for(let o of w._alternatives){let i=o(v);if(i){v=i;break}}return w._factories.has(v)?w._factories.get(v).load(v,k.URI.file((0,g.realpathSync)(t.filename)),o=>m.apply(this,[o,t,n])):m.apply(this,arguments)}}}class d extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(f.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,w,this._registry).install(),b.mark("code/extHost/didInitAPI");const m=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,m,this,this._logService,this._mainThreadTelemetryProxy,this._initData),b.mark("code/extHost/didInitProxyResolver");const l=process.send,v=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?l.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,S,m){if(S.scheme!==r.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let l=null;m.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{w&&b.mark(`code/extHost/willLoadExtensionCode/${w.value}`),l=G.__$__nodeRequire(S.fsPath)}catch(v){return Promise.reject(v)}finally{w&&b.mark(`code/extHost/didLoadExtensionCode/${w.value}`),m.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const S in w){const m=w[S];m===null?delete process.env[S]:process.env[S]=m}}}e.ExtHostExtensionService=d}),define(ge[282],pe([0,1,79,254,265,264,263,279,281,225,255,46,42,64,69,67,34,50,14]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(f.IExtHostExtensionService,D.ExtHostExtensionService),(0,b.registerSingleton)(S.ILogService,k.ExtHostLogService),(0,b.registerSingleton)(C.IExtHostDebugService,y.ExtHostDebugService),(0,b.registerSingleton)(g.IExtHostOutputService,I.ExtHostOutputService2),(0,b.registerSingleton)(a.IExtHostSearch,P.NativeExtHostSearch),(0,b.registerSingleton)(d.IExtHostTask,A.ExtHostTask),(0,b.registerSingleton)(E.IExtHostTerminalService,T.ExtHostTerminalService),(0,b.registerSingleton)(w.IExtHostTunnelService,r.ExtHostTunnelService)}),define(ge[283],pe([0,1,123,294,68,16,107,132,187,223,266,23,102,26,104,13,269,282]),function(G,e,b,I,T,A,y,P,D,k,r,C,f,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let i=0;i<process.execArgv.length;i++)process.execArgv[i]==="--inspect-port=0"&&(process.execArgv.splice(i,1),i--)}();const E=I(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const o=G.__$__nodeRequire("module"),i=o._load;o._load=function(s){if(s==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return i.apply(this,arguments)}})();const w=process.exit.bind(process);function S(o){process.exit=function(i){if(o)w(i);else{const s=new Error("An extension called process.exit() and this was prevented.");console.warn(s.stack)}},process.crash=function(){const i=new Error("An extension called process.crash() and this was prevented.");console.warn(i.stack)}}let m=function(o){w()};function l(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((o,i)=>{let s=null,c=setTimeout(()=>{m("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,_=3e5,u=new d.RunOnceScheduler(()=>m("renderer disconnected for too long (1)"),h),p=new d.RunOnceScheduler(()=>m("renderer disconnected for too long (2)"),_);process.on("message",(O,V)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const re=C.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let j;if(O.skipWebSocketFrames)j=new P.NodeSocket(V);else{const x=C.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));j=new P.WebSocketNodeSocket(new P.NodeSocket(V),O.permessageDeflate,x,!1)}s?(u.cancel(),p.cancel(),s.beginAcceptReconnection(j,re),s.endAcceptReconnection()):(clearTimeout(c),s=new y.PersistentProtocol(j,re),s.onDidDispose(()=>m("renderer disconnected")),o(s),s.onSocketClose(()=>{u.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(p.isScheduled())return;u.isScheduled()&&p.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const o=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((i,s)=>{const c=b.createConnection(o,()=>{c.removeListener("error",s),i(new y.PersistentProtocol(new P.NodeSocket(c)))});c.once("error",s)})}}async function v(){const o=await l();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(i=>{(0,k.isMessageOfType)(i,2)?(this._terminating=!0,m("received terminate message from renderer")):this._onMessage.fire(i)})}send(i){this._terminating||o.send(i)}drain(){return o.drain()}}}function t(o){return new Promise(i=>{const s=o.onMessage(c=>{s.dispose();const h=JSON.parse(c.toString()),_=h.commit,u=D.default.commit;_&&u&&_!==u&&w(55);const p=[];process.on("unhandledRejection",(V,re)=>{p.push(re),setTimeout(()=>{const j=p.indexOf(re);j>=0&&re.catch(x=>{p.splice(j,1),console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),(0,A.onUnexpectedError)(V)})},1e3)}),process.on("rejectionHandled",V=>{const re=p.indexOf(V);re>=0&&p.splice(re,1)}),process.on("uncaughtException",function(V){(0,A.onUnexpectedError)(V)});let R=0;setInterval(function(){try{process.kill(h.parentPid,0),R=0}catch(V){V&&V.code==="EPERM"?(R++,R>=3&&m(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):m(`parent process ${h.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let O;try{O=G.__$__nodeRequire("native-watchdog"),O.start(h.parentPid)}catch(V){(0,A.onUnexpectedError)(V)}o.send((0,k.createMessageOfType)(0)),i({protocol:o,initData:h})});o.send((0,k.createMessageOfType)(1))})}async function n(){T.mark("code/extHost/willConnectToRenderer");const o=await v();T.mark("code/extHost/didConnectToRenderer");const i=await t(o);T.mark("code/extHost/didWaitForInitData");const{initData:s}=i;S(!!s.environment.extensionTestsLocationURI),s.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const c=new class{exit(p){w(p)}exists(p){return(0,g.exists)(p)}realpath(p){return(0,a.realpath)(p)}};let h=null;if(s.remote.authority&&E.uriTransformerPath)try{const p=G.__$__nodeRequire(E.uriTransformerPath)(s.remote.authority);h=new f.URITransformer(p)}catch(u){console.error(u)}const _=new r.ExtensionHostMain(i.protocol,s,c,h);m=u=>_.terminate(u)}e.startExtensionHostProcess=n}),define(ge[295],pe([0,1,283]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.startExtensionHostProcess)().catch(I=>console.log(I))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6bee0f2f3fea9df1ad45344f09b2a139c93b384f/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
